%------------------------------------------------------------------------------
% File     : VBT00044^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Succ 00602_038696
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0070_VEBT_Succ_00602_038696 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9556 (2817 unt; 591 typ;   0 def)
%            Number of atoms       : 28761 (9279 equ;   0 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 170275 (2106   ~; 305   |;2202   &;152283   @)
%                                         (   0 <=>;13379  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   11 (  10 usr)
%            Number of type conns  : 3532 (3532   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  584 ( 581 usr;  17 con; 0-8 aty)
%            Number of variables   : 27925 (2842   ^23865   !; 741   ?;27925   :)
%                                         ( 477  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-18 00:59:01.574
%------------------------------------------------------------------------------
% Could-be-implicit typings (16)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (575)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot1__space,type,
    topological_t1_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Odist__norm,type,
    real_V6936659425649961206t_norm: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num__rel,type,
    bit_un5425074673868309765um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num__rel,type,
    bit_un3595099601533988841um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: num > int ).

thf(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: num > int ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Complex_Orcis,type,
    rcis: real > real > complex ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__vector__derivative,type,
    has_ve8173657378732805170vative: 
      !>[B: $tType] : ( ( real > B ) > B > ( filter @ real ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B > $o ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Ointrel,type,
    intrel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opcr__int,type,
    pcr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > A > ( option @ B ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Oint__decode,type,
    nat_int_decode: nat > int ).

thf(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: ( list @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: ( list @ nat ) > ( list @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: ( product_prod @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum_Orec__num,type,
    rec_num: 
      !>[A: $tType] : ( A > ( num > A > A ) > ( num > A > A ) > num > A ) ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Power_Opower_Opower,type,
    power2: 
      !>[A: $tType] : ( A > ( A > A > A ) > A > nat > A ) ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Opcr__rat,type,
    pcr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Opositive,type,
    positive: rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oratrel,type,
    ratrel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Real_OReal,type,
    real2: ( nat > rat ) > real ).

thf(sy_c_Real_Ocauchy,type,
    cauchy: ( nat > rat ) > $o ).

thf(sy_c_Real_Ocr__real,type,
    cr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opcr__real,type,
    pcr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opositive,type,
    positive2: real > $o ).

thf(sy_c_Real_Orealrel,type,
    realrel: ( nat > rat ) > ( nat > rat ) > $o ).

thf(sy_c_Real_Orep__real,type,
    rep_real: real > nat > rat ).

thf(sy_c_Real_Ovanishes,type,
    vanishes: ( nat > rat ) > $o ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( ( filter @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : ( filter @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_VEBT__Insert_Ovebt__insert,type,
    vEBT_vebt_insert: vEBT_VEBT > nat > vEBT_VEBT ).

thf(sy_c_VEBT__Insert_Ovebt__insert__rel,type,
    vEBT_vebt_insert_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Obit__concat,type,
    vEBT_VEBT_bit_concat: nat > nat > nat > nat ).

thf(sy_c_VEBT__Member_OVEBT__internal_OminNull,type,
    vEBT_VEBT_minNull: vEBT_VEBT > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Oset__vebt_H,type,
    vEBT_VEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Member_Ovebt__member,type,
    vEBT_vebt_member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Member_Ovebt__member__rel,type,
    vEBT_vebt_member_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Oadd,type,
    vEBT_VEBT_add: ( option @ nat ) > ( option @ nat ) > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Ogreater,type,
    vEBT_VEBT_greater: ( option @ nat ) > ( option @ nat ) > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Oless,type,
    vEBT_VEBT_less: ( option @ nat ) > ( option @ nat ) > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Olesseq,type,
    vEBT_VEBT_lesseq: ( option @ nat ) > ( option @ nat ) > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Omax__in__set,type,
    vEBT_VEBT_max_in_set: ( set @ nat ) > nat > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Omin__in__set,type,
    vEBT_VEBT_min_in_set: ( set @ nat ) > nat > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Omul,type,
    vEBT_VEBT_mul: ( option @ nat ) > ( option @ nat ) > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Ooption__shift,type,
    vEBT_V2048590022279873568_shift: 
      !>[A: $tType] : ( ( A > A > A ) > ( option @ A ) > ( option @ A ) > ( option @ A ) ) ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Opower,type,
    vEBT_VEBT_power: ( option @ nat ) > ( option @ nat ) > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_Ovebt__maxt,type,
    vEBT_vebt_maxt: vEBT_VEBT > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_Ovebt__maxt__rel,type,
    vEBT_vebt_maxt_rel: vEBT_VEBT > vEBT_VEBT > $o ).

thf(sy_c_VEBT__MinMax_Ovebt__mint,type,
    vEBT_vebt_mint: vEBT_VEBT > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_Ovebt__mint__rel,type,
    vEBT_vebt_mint_rel: vEBT_VEBT > vEBT_VEBT > $o ).

thf(sy_c_VEBT__Succ_Ois__succ__in__set,type,
    vEBT_is_succ_in_set: ( set @ nat ) > nat > nat > $o ).

thf(sy_c_VEBT__Succ_Ovebt__succ,type,
    vEBT_vebt_succ: vEBT_VEBT > nat > ( option @ nat ) ).

thf(sy_c_VEBT__Succ_Ovebt__succ__rel,type,
    vEBT_vebt_succ_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_deg____,type,
    deg: nat ).

thf(sy_v_m____,type,
    m: nat ).

thf(sy_v_ma____,type,
    ma: nat ).

thf(sy_v_maxl____,type,
    maxl: nat ).

thf(sy_v_mi____,type,
    mi: nat ).

thf(sy_v_na____,type,
    na: nat ).

thf(sy_v_succy____,type,
    succy: nat ).

thf(sy_v_summary____,type,
    summary: vEBT_VEBT ).

thf(sy_v_treeList____,type,
    treeList: list @ vEBT_VEBT ).

thf(sy_v_xa____,type,
    xa: nat ).

thf(sy_v_z____,type,
    z: nat ).

% Relevant facts (8182)
thf(fact_0_min__in__set__def,axiom,
    ( vEBT_VEBT_min_in_set
    = ( ^ [Xs: set @ nat,X: nat] :
          ( ( member @ nat @ X @ Xs )
          & ! [Y: nat] :
              ( ( member @ nat @ Y @ Xs )
             => ( ord_less_eq @ nat @ X @ Y ) ) ) ) ) ).

% min_in_set_def
thf(fact_1_max__in__set__def,axiom,
    ( vEBT_VEBT_max_in_set
    = ( ^ [Xs: set @ nat,X: nat] :
          ( ( member @ nat @ X @ Xs )
          & ! [Y: nat] :
              ( ( member @ nat @ Y @ Xs )
             => ( ord_less_eq @ nat @ Y @ X ) ) ) ) ) ).

% max_in_set_def
thf(fact_2__092_060open_062succy_A_092_060le_062_Alow_Az_A_Ideg_Adiv_A2_J_092_060close_062,axiom,
    ord_less_eq @ nat @ succy @ ( vEBT_VEBT_low @ z @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% \<open>succy \<le> low z (deg div 2)\<close>
thf(fact_3_True,axiom,
    ( ( vEBT_VEBT_high @ z @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
    = ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% True
thf(fact_4__092_060open_0622_A_092_060le_062_Adeg_092_060close_062,axiom,
    ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ).

% \<open>2 \<le> deg\<close>
thf(fact_5_pow__sum,axiom,
    ! [A2: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_6_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X: nat,N: nat] : ( divide_divide @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% high_def
thf(fact_7_bit__concat__def,axiom,
    ( vEBT_VEBT_bit_concat
    = ( ^ [H: nat,L: nat,D2: nat] : ( plus_plus @ nat @ ( times_times @ nat @ H @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ D2 ) ) @ L ) ) ) ).

% bit_concat_def
thf(fact_8_bit__split__inv,axiom,
    ! [X2: nat,D3: nat] :
      ( ( vEBT_VEBT_bit_concat @ ( vEBT_VEBT_high @ X2 @ D3 ) @ ( vEBT_VEBT_low @ X2 @ D3 ) @ D3 )
      = X2 ) ).

% bit_split_inv
thf(fact_9__092_060open_062high_Ax_A_Ideg_Adiv_A2_J_A_092_060le_062_Ahigh_Az_A_Ideg_Adiv_A2_J_092_060close_062,axiom,
    ord_less_eq @ nat @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ z @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% \<open>high x (deg div 2) \<le> high z (deg div 2)\<close>
thf(fact_10__092_060open_062x_A_060_Az_092_060close_062,axiom,
    ord_less @ nat @ xa @ z ).

% \<open>x < z\<close>
thf(fact_11__C17_C,axiom,
    ( xa
    = ( plus_plus @ nat @ ( times_times @ nat @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% "17"
thf(fact_12__C10_C,axiom,
    ( ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
    & ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = succy ) ) ).

% "10"
thf(fact_13_add__self__div__2,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M ) ).

% add_self_div_2
thf(fact_14__C19_C,axiom,
    ord_less @ nat @ xa @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) ).

% "19"
thf(fact_15_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_16_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_17_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) @ Y2 ) @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_18_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_19_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_20_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) @ Y2 ) ) ) ) ).

% power2_sum
thf(fact_21_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ).

% div_exp_eq
thf(fact_22__C18_C,axiom,
    ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) @ xa )
    = ( minus_minus @ nat @ ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) @ ( times_times @ nat @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% "18"
thf(fact_23_high__inv,axiom,
    ! [X2: nat,N2: nat,Y2: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ X2 ) @ N2 )
        = Y2 ) ) ).

% high_inv
thf(fact_24__092_060open_062deg_Adiv_A2_A_061_An_092_060close_062,axiom,
    ( ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = na ) ).

% \<open>deg div 2 = n\<close>
thf(fact_25_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N2 ) )
          = ( M = N2 ) ) ) ).

% numeral_eq_iff
thf(fact_26_power__minus__is__div,axiom,
    ! [B2: nat,A2: nat] :
      ( ( ord_less_eq @ nat @ B2 @ A2 )
     => ( ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ A2 @ B2 ) )
        = ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% power_minus_is_div
thf(fact_27_high__bound__aux,axiom,
    ! [Ma: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_28_False,axiom,
    ~ ( ord_less @ nat @ xa @ mi ) ).

% False
thf(fact_29_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less_eq @ num @ M @ N2 ) ) ) ).

% numeral_le_iff
thf(fact_30_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ num @ M @ N2 ) ) ) ).

% numeral_less_iff
thf(fact_31_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_32_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ).

% numeral_times_numeral
thf(fact_33_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z ) ) ) ).

% add_numeral_left
thf(fact_34_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N2 ) ) ) ) ).

% numeral_plus_numeral
thf(fact_35_low__inv,axiom,
    ! [X2: nat,N2: nat,Y2: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ X2 ) @ N2 )
        = X2 ) ) ).

% low_inv
thf(fact_36_num__double,axiom,
    ! [N2: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N2 )
      = ( bit0 @ N2 ) ) ).

% num_double
thf(fact_37_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N2: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% power_mult_numeral
thf(fact_38__C5_Ohyps_C_I6_J,axiom,
    ( deg
    = ( plus_plus @ nat @ na @ m ) ) ).

% "5.hyps"(6)
thf(fact_39_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_40_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_41_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N2: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N2 ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N2 ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_42_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N2: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N2 ) ) ) ) ) ).

% power_add_numeral
thf(fact_43_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_44_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) ).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( collect @ A
        @ ^ [X: A] : ( member @ A @ X @ A3 ) )
      = A3 ) ).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_47_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ! [X3: A] :
          ( ( F2 @ X3 )
          = ( G @ X3 ) )
     => ( F2 = G ) ) ).

% ext
thf(fact_48_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_49__C5_Ohyps_C_I10_J,axiom,
    ord_less @ nat @ ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "5.hyps"(10)
thf(fact_50_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D3: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D3 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_51_add__One__commute,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ N2 )
      = ( plus_plus @ num @ N2 @ one2 ) ) ).

% add_One_commute
thf(fact_52_le__num__One__iff,axiom,
    ! [X2: num] :
      ( ( ord_less_eq @ num @ X2 @ one2 )
      = ( X2 = one2 ) ) ).

% le_num_One_iff
thf(fact_53_four__x__squared,axiom,
    ! [X2: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_54_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,K: num,L2: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L2 ) )
          = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L2 ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_55_less__mult__imp__div__less,axiom,
    ! [M: nat,I: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I @ N2 ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N2 ) @ I ) ) ).

% less_mult_imp_div_less
thf(fact_56_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y2 @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_57_less__exp,axiom,
    ! [N2: nat] : ( ord_less @ nat @ N2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% less_exp
thf(fact_58_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_59_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N2 ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N2 ) ) ) ) ).

% diff_le_diff_pow
thf(fact_60_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) @ Y2 ) ) ) ) ).

% power2_diff
thf(fact_61_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X2: A,Y2: A,N2: nat] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( times_times @ A @ Y2 @ X2 ) )
         => ( ( times_times @ A @ ( power_power @ A @ X2 @ N2 ) @ Y2 )
            = ( times_times @ A @ Y2 @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_62_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ).

% power_mult_distrib
thf(fact_63_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_commutes
thf(fact_64_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N2 )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ).

% power_divide
thf(fact_65_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M @ N2 ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M ) @ N2 ) ) ) ).

% power_mult
thf(fact_66_div__le__dividend,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N2 ) @ M ) ).

% div_le_dividend
thf(fact_67_div__le__mono,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N2 @ K ) ) ) ).

% div_le_mono
thf(fact_68_div__mult2__eq,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( divide_divide @ nat @ M @ ( times_times @ nat @ N2 @ Q2 ) )
      = ( divide_divide @ nat @ ( divide_divide @ nat @ M @ N2 ) @ Q2 ) ) ).

% div_mult2_eq
thf(fact_69_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_70_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_71_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_Bit0
thf(fact_72_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_73_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_add
thf(fact_74_times__div__less__eq__dividend,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ ( divide_divide @ nat @ M @ N2 ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_75_div__times__less__eq__dividend,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N2 ) @ N2 ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_76_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% numeral_Bit0_div_2
thf(fact_77_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_78_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2_right
thf(fact_79_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2
thf(fact_80_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_81_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X2: A] :
          ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X2 @ X2 ) @ X2 ) @ X2 ) ) ) ).

% power4_eq_xxxx
thf(fact_82_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_83_power2__nat__le__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% power2_nat_le_imp_le
thf(fact_84_power2__nat__le__eq__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% power2_nat_le_eq_le
thf(fact_85_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_86__092_060open_062high_Ax_An_A_060_A2_A_094_Am_A_092_060and_062_Alow_Ax_An_A_060_A2_A_094_An_092_060close_062,axiom,
    ( ( ord_less @ nat @ ( vEBT_VEBT_high @ xa @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
    & ( ord_less @ nat @ ( vEBT_VEBT_low @ xa @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) ) ).

% \<open>high x n < 2 ^ m \<and> low x n < 2 ^ n\<close>
thf(fact_87__092_060open_0620_A_060_A2_A_094_A_Ideg_Adiv_A2_J_A_K_Ahigh_Ax_A_Ideg_Adiv_A2_J_A_L_Asuccy_A_N_Ax_092_060close_062,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) @ xa ) ).

% \<open>0 < 2 ^ (deg div 2) * high x (deg div 2) + succy - x\<close>
thf(fact_88_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ) ).

% Nat.diff_diff_right
thf(fact_89_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_90_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_91_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_92_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_93_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ord_less @ A @ X2 @ ( divide_divide @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_94_diff__diff__left,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J ) @ K )
      = ( minus_minus @ nat @ I @ ( plus_plus @ nat @ J @ K ) ) ) ).

% diff_diff_left
thf(fact_95_diff__diff__cancel,axiom,
    ! [I: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I @ N2 )
     => ( ( minus_minus @ nat @ N2 @ ( minus_minus @ nat @ N2 @ I ) )
        = I ) ) ).

% diff_diff_cancel
thf(fact_96_nat__less__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N2 ) ) ) ) ).

% nat_less_add_iff2
thf(fact_97_nat__less__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N2 ) ) ) ).

% nat_less_add_iff1
thf(fact_98__C5_Ohyps_C_I9_J,axiom,
    ord_less_eq @ nat @ mi @ ma ).

% "5.hyps"(9)
thf(fact_99_semiring__norm_I87_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N2 ) )
      = ( M = N2 ) ) ).

% semiring_norm(87)
thf(fact_100__092_060open_062mi_A_092_060le_062_Ax_092_060close_062,axiom,
    ord_less_eq @ nat @ mi @ xa ).

% \<open>mi \<le> x\<close>
thf(fact_101_real__divide__square__eq,axiom,
    ! [R: real,A2: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ R ) )
      = ( divide_divide @ real @ A2 @ R ) ) ).

% real_divide_square_eq
thf(fact_102_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_103_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_104_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_105_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_106_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_107_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_108_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_109_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_110_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_111_semiring__norm_I85_J,axiom,
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) ).

% semiring_norm(85)
thf(fact_112_semiring__norm_I83_J,axiom,
    ! [N2: num] :
      ( one2
     != ( bit0 @ N2 ) ) ).

% semiring_norm(83)
thf(fact_113_less__nat__zero__code,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_114_neq0__conv,axiom,
    ! [N2: nat] :
      ( ( ( N2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% neq0_conv
thf(fact_115_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_116_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_117_le0,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N2 ) ).

% le0
thf(fact_118_add__is__0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_119_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_120_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% nat_add_left_cancel_less
thf(fact_121_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_122_diff__0__eq__0,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_123_mult__is__0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_124_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_125_mult__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N2 ) )
      = ( ( M = N2 )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_126_mult__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N2 @ K ) )
      = ( ( M = N2 )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_127_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% nat_add_left_cancel_le
thf(fact_128_semiring__norm_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N2 ) ) ) ).

% semiring_norm(6)
thf(fact_129_semiring__norm_I13_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N2 ) ) ) ) ).

% semiring_norm(13)
thf(fact_130_semiring__norm_I12_J,axiom,
    ! [N2: num] :
      ( ( times_times @ num @ one2 @ N2 )
      = N2 ) ).

% semiring_norm(12)
thf(fact_131_semiring__norm_I11_J,axiom,
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) ).

% semiring_norm(11)
thf(fact_132_semiring__norm_I78_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(78)
thf(fact_133_semiring__norm_I71_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(71)
thf(fact_134_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_135_semiring__norm_I68_J,axiom,
    ! [N2: num] : ( ord_less_eq @ num @ one2 @ N2 ) ).

% semiring_norm(68)
thf(fact_136_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_137_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_138_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_139_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_140_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_141_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_142_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_143_add__gr__0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% add_gr_0
thf(fact_144_zero__less__diff,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% zero_less_diff
thf(fact_145_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N2 ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_146_nat__0__less__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% nat_0_less_mult_iff
thf(fact_147_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N2 ) ) ) ).

% mult_less_cancel2
thf(fact_148_div__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( divide_divide @ nat @ M @ N2 )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_149_diff__is__0__eq_H,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( minus_minus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_150_diff__is__0__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( minus_minus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% diff_is_0_eq
thf(fact_151_nat__zero__less__power__iff,axiom,
    ! [X2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X2 @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_152_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
          = ( divide_divide @ nat @ M @ N2 ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_153_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_154_semiring__norm_I76_J,axiom,
    ! [N2: num] : ( ord_less @ num @ one2 @ ( bit0 @ N2 ) ) ).

% semiring_norm(76)
thf(fact_155_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_156__C5_Ohyps_C_I5_J,axiom,
    ( m
    = ( suc @ na ) ) ).

% "5.hyps"(5)
thf(fact_157_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_158_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_159_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_160_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_161_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_162_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_163_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( power_power @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% power_eq_0_iff
thf(fact_164_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% mult_le_cancel2
thf(fact_165_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_166_div__mult__self__is__m,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N2 ) @ N2 )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_167_div__mult__self1__is__m,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N2 @ M ) @ N2 )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_168__C12_C,axiom,
    ( ( ord_less_eq @ nat @ mi @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) )
    & ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) @ ma ) ) ).

% "12"
thf(fact_169_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_170_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_171_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_172_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X2 = Y2 ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_173_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_174_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_175_complete__real,axiom,
    ! [S: set @ real] :
      ( ? [X4: real] : ( member @ real @ X4 @ S )
     => ( ? [Z2: real] :
          ! [X3: real] :
            ( ( member @ real @ X3 @ S )
           => ( ord_less_eq @ real @ X3 @ Z2 ) )
       => ? [Y3: real] :
            ( ! [X4: real] :
                ( ( member @ real @ X4 @ S )
               => ( ord_less_eq @ real @ X4 @ Y3 ) )
            & ! [Z2: real] :
                ( ! [X3: real] :
                    ( ( member @ real @ X3 @ S )
                   => ( ord_less_eq @ real @ X3 @ Z2 ) )
               => ( ord_less_eq @ real @ Y3 @ Z2 ) ) ) ) ) ).

% complete_real
thf(fact_176_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X: real,Y: real] :
          ( ( ord_less @ real @ X @ Y )
          | ( X = Y ) ) ) ) ).

% less_eq_real_def
thf(fact_177_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
                & ( ord_less @ A @ E @ D1 )
                & ( ord_less @ A @ E @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_178_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_179_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_180_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_181_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_182_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_183_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: A > nat,P: A > $o,X2: A] :
      ( ! [X3: A] :
          ( ( ( V2 @ X3 )
            = ( zero_zero @ nat ) )
         => ( P @ X3 ) )
     => ( ! [X3: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V2 @ X3 ) )
           => ( ~ ( P @ X3 )
             => ? [Y4: A] :
                  ( ( ord_less @ nat @ ( V2 @ Y4 ) @ ( V2 @ X3 ) )
                  & ~ ( P @ Y4 ) ) ) )
       => ( P @ X2 ) ) ) ).

% infinite_descent0_measure
thf(fact_184_infinite__descent0,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M2: nat] :
                  ( ( ord_less @ nat @ M2 @ N3 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N2 ) ) ) ).

% infinite_descent0
thf(fact_185_gr__implies__not0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( N2
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_186_less__zeroE,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_187_not__less0,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_188_not__gr0,axiom,
    ! [N2: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_189_gr0I,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% gr0I
thf(fact_190_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_191_less__eq__nat_Osimps_I1_J,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N2 ) ).

% less_eq_nat.simps(1)
thf(fact_192_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_193_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_194_le__0__eq,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( zero_zero @ nat ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_195_plus__nat_Oadd__0,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N2 )
      = N2 ) ).

% plus_nat.add_0
thf(fact_196_add__eq__self__zero,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M @ N2 )
        = M )
     => ( N2
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_197_diffs0__imp__equal,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( minus_minus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N2 @ M )
          = ( zero_zero @ nat ) )
       => ( M = N2 ) ) ) ).

% diffs0_imp_equal
thf(fact_198_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_199_mult__0,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_200_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N2 ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N2 ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_201_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_202_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_203_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_204_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_neq_numeral
thf(fact_205_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N2: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_206_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_207_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_208_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_209_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_210_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_211_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_212_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_213_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_214_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_215_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_216_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_217_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_218_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_219_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_220_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_221_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_222_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_223_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_224_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_225_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_226_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_227_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_228_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_229_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_230_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_231_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_232_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_233_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_234_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_235_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_236_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_237_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_238_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_239_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_240_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_241_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_242_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X2 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y2 @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_243_ex__least__nat__le,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N2 )
            & ! [I2: nat] :
                ( ( ord_less @ nat @ I2 @ K2 )
               => ~ ( P @ I2 ) )
            & ( P @ K2 ) ) ) ) ).

% ex_least_nat_le
thf(fact_244_less__imp__add__positive,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ? [K2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K2 )
          & ( ( plus_plus @ nat @ I @ K2 )
            = J ) ) ) ).

% less_imp_add_positive
thf(fact_245_diff__less,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N2 ) @ M ) ) ) ).

% diff_less
thf(fact_246_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( ord_less @ nat @ M @ N2 ) ) ) ).

% nat_mult_less_cancel1
thf(fact_247_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N2 ) )
        = ( M = N2 ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_248_mult__less__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) ) ).

% mult_less_mono2
thf(fact_249_mult__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_250_diff__add__0,axiom,
    ! [N2: nat,M: nat] :
      ( ( minus_minus @ nat @ N2 @ ( plus_plus @ nat @ N2 @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_251_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N2 )
                  = ( power_power @ A @ B2 @ N2 ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_252_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N2 )
            = ( power_power @ A @ B2 @ N2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_253_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_254_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_255_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_256_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_257_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_258_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_259_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_260_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_261_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_262_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_263_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_264_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_265_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_266_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_267_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_268_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_269_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X2: A,Y2: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_270_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_le_numeral
thf(fact_271_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_272_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_273_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_less_numeral
thf(fact_274_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono
thf(fact_275_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_le_power
thf(fact_276_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_less_power
thf(fact_277_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% nat_mult_le_cancel1
thf(fact_278_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D2: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D2 ) )
                & ~ ( P @ D2 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_279_nat__diff__split,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D2: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D2 ) )
           => ( P @ D2 ) ) ) ) ).

% nat_diff_split
thf(fact_280_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( divide_divide @ nat @ M @ N2 ) ) ) ).

% nat_mult_div_cancel1
thf(fact_281_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( divide_divide @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_282_nat__power__less__imp__less,axiom,
    ! [I: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N2 ) )
       => ( ord_less @ nat @ M @ N2 ) ) ) ).

% nat_power_less_imp_less
thf(fact_283_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ B @ ( F2 @ Y4 ) @ ( F2 @ X3 ) )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_284_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ B @ ( F2 @ Y4 ) @ ( F2 @ X3 ) )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct
thf(fact_285_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ~ ( ord_less @ A @ X2 @ Y2 )
           => ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_286_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) @ ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_287_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_288_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) )
          = ( ( X2
             != ( zero_zero @ A ) )
            | ( Y2
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_289_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_290_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_291_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V2: A > nat,X2: A] :
      ( ! [X3: A] :
          ( ~ ( P @ X3 )
         => ? [Y4: A] :
              ( ( ord_less @ nat @ ( V2 @ Y4 ) @ ( V2 @ X3 ) )
              & ~ ( P @ Y4 ) ) )
     => ( P @ X2 ) ) ).

% infinite_descent_measure
thf(fact_292_linorder__neqE__nat,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( X2 != Y2 )
     => ( ~ ( ord_less @ nat @ X2 @ Y2 )
       => ( ord_less @ nat @ Y2 @ X2 ) ) ) ).

% linorder_neqE_nat
thf(fact_293_infinite__descent,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N2 ) ) ).

% infinite_descent
thf(fact_294_nat__less__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) ).

% nat_less_induct
thf(fact_295_less__irrefl__nat,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) ).

% less_irrefl_nat
thf(fact_296_less__not__refl3,axiom,
    ! [S2: nat,T2: nat] :
      ( ( ord_less @ nat @ S2 @ T2 )
     => ( S2 != T2 ) ) ).

% less_not_refl3
thf(fact_297_less__not__refl2,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( M != N2 ) ) ).

% less_not_refl2
thf(fact_298_less__not__refl,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) ).

% less_not_refl
thf(fact_299_nat__neq__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( M != N2 ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( ord_less @ nat @ N2 @ M ) ) ) ).

% nat_neq_iff
thf(fact_300_le__refl,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ N2 ) ).

% le_refl
thf(fact_301_le__trans,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I @ K ) ) ) ).

% le_trans
thf(fact_302_eq__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( M = N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% eq_imp_le
thf(fact_303_le__antisym,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ M )
       => ( M = N2 ) ) ) ).

% le_antisym
thf(fact_304_nat__le__linear,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
      | ( ord_less_eq @ nat @ N2 @ M ) ) ).

% nat_le_linear
thf(fact_305_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ? [X3: nat] :
            ( ( P @ X3 )
            & ! [Y4: nat] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ nat @ Y4 @ X3 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_306_diff__commute,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I @ K ) @ J ) ) ).

% diff_commute
thf(fact_307_div__le__mono2,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N2 ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_308_div__greater__zero__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N2 ) )
      = ( ( ord_less_eq @ nat @ N2 @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% div_greater_zero_iff
thf(fact_309_div__less__iff__less__mult,axiom,
    ! [Q2: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q2 ) @ N2 )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N2 @ Q2 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_310_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_311_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_312_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_313_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_314_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N2 ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_diff
thf(fact_315_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N2 @ Q2 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q2 ) @ N2 ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_316_split__div,axiom,
    ! [P: nat > $o,M: nat,N2: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N2
           != ( zero_zero @ nat ) )
         => ! [I3: nat,J2: nat] :
              ( ( ord_less @ nat @ J2 @ N2 )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ I3 ) @ J2 ) )
               => ( P @ I3 ) ) ) ) ) ) ).

% split_div
thf(fact_317_dividend__less__div__times,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N2 ) @ N2 ) ) ) ) ).

% dividend_less_div_times
thf(fact_318_dividend__less__times__div,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ N2 @ ( divide_divide @ nat @ M @ N2 ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_319_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_320_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_321_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_322_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_323_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_324_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
             => ( X2 = Y2 ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_325_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% power2_le_imp_le
thf(fact_326_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_327_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_328_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_329_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_330_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% power2_less_imp_less
thf(fact_331_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_332_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_333_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_334_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X2
             != ( zero_zero @ A ) )
            | ( Y2
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_335_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% zero_le_even_power'
thf(fact_336_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_337_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_338_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_339_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_340_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_341_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,E2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_342_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_343_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_344_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A2 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% left_diff_distrib'
thf(fact_345_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_346_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D3: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D3 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D3 ) ) ) ) ).

% add_diff_add
thf(fact_347_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M3 @ N )
          & ( M3 != N ) ) ) ) ).

% nat_less_le
thf(fact_348_less__imp__le__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% less_imp_le_nat
thf(fact_349_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( ( ord_less @ nat @ M3 @ N )
          | ( M3 = N ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_350_less__or__eq__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( ord_less @ nat @ M @ N2 )
        | ( M = N2 ) )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% less_or_eq_imp_le
thf(fact_351_le__neq__implies__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( M != N2 )
       => ( ord_less @ nat @ M @ N2 ) ) ) ).

% le_neq_implies_less
thf(fact_352_less__mono__imp__le__mono,axiom,
    ! [F2: nat > nat,I: nat,J: nat] :
      ( ! [I4: nat,J3: nat] :
          ( ( ord_less @ nat @ I4 @ J3 )
         => ( ord_less @ nat @ ( F2 @ I4 ) @ ( F2 @ J3 ) ) )
     => ( ( ord_less_eq @ nat @ I @ J )
       => ( ord_less_eq @ nat @ ( F2 @ I ) @ ( F2 @ J ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_353_add__lessD1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ K )
     => ( ord_less @ nat @ I @ K ) ) ).

% add_lessD1
thf(fact_354_add__less__mono,axiom,
    ! [I: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ K @ L2 )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L2 ) ) ) ) ).

% add_less_mono
thf(fact_355_not__add__less1,axiom,
    ! [I: nat,J: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ I ) ).

% not_add_less1
thf(fact_356_not__add__less2,axiom,
    ! [J: nat,I: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J @ I ) @ I ) ).

% not_add_less2
thf(fact_357_add__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_less_mono1
thf(fact_358_trans__less__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_less_add1
thf(fact_359_trans__less__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_less_add2
thf(fact_360_less__add__eq__less,axiom,
    ! [K: nat,L2: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ L2 )
     => ( ( ( plus_plus @ nat @ M @ L2 )
          = ( plus_plus @ nat @ K @ N2 ) )
       => ( ord_less @ nat @ M @ N2 ) ) ) ).

% less_add_eq_less
thf(fact_361_add__leE,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N2 )
     => ~ ( ( ord_less_eq @ nat @ M @ N2 )
         => ~ ( ord_less_eq @ nat @ K @ N2 ) ) ) ).

% add_leE
thf(fact_362_le__add1,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ N2 @ ( plus_plus @ nat @ N2 @ M ) ) ).

% le_add1
thf(fact_363_le__add2,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ N2 @ ( plus_plus @ nat @ M @ N2 ) ) ).

% le_add2
thf(fact_364_add__leD1,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% add_leD1
thf(fact_365_add__leD2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N2 )
     => ( ord_less_eq @ nat @ K @ N2 ) ) ).

% add_leD2
thf(fact_366_le__Suc__ex,axiom,
    ! [K: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ K @ L2 )
     => ? [N3: nat] :
          ( L2
          = ( plus_plus @ nat @ K @ N3 ) ) ) ).

% le_Suc_ex
thf(fact_367_add__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L2 )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L2 ) ) ) ) ).

% add_le_mono
thf(fact_368_add__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_le_mono1
thf(fact_369_trans__le__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_le_add1
thf(fact_370_trans__le__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_le_add2
thf(fact_371_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N: nat] :
        ? [K3: nat] :
          ( N
          = ( plus_plus @ nat @ M3 @ K3 ) ) ) ) ).

% nat_le_iff_add
thf(fact_372_less__imp__diff__less,axiom,
    ! [J: nat,K: nat,N2: nat] :
      ( ( ord_less @ nat @ J @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J @ N2 ) @ K ) ) ).

% less_imp_diff_less
thf(fact_373_diff__less__mono2,axiom,
    ! [M: nat,N2: nat,L2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( ord_less @ nat @ M @ L2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L2 @ N2 ) @ ( minus_minus @ nat @ L2 @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_374_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N2 @ K ) )
          = ( M = N2 ) ) ) ) ).

% eq_diff_iff
thf(fact_375_le__diff__iff,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ).

% le_diff_iff
thf(fact_376_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_377_diff__le__mono,axiom,
    ! [M: nat,N2: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L2 ) @ ( minus_minus @ nat @ N2 @ L2 ) ) ) ).

% diff_le_mono
thf(fact_378_diff__le__self,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N2 ) @ M ) ).

% diff_le_self
thf(fact_379_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_380_diff__le__mono2,axiom,
    ! [M: nat,N2: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L2 @ N2 ) @ ( minus_minus @ nat @ L2 @ M ) ) ) ).

% diff_le_mono2
thf(fact_381_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_382_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_383_mult__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L2 )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ L2 ) ) ) ) ).

% mult_le_mono
thf(fact_384_mult__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) ).

% mult_le_mono1
thf(fact_385_mult__le__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) ).

% mult_le_mono2
thf(fact_386_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( minus_minus @ nat @ M @ N2 ) ) ).

% Nat.diff_cancel
thf(fact_387_diff__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) )
      = ( minus_minus @ nat @ M @ N2 ) ) ).

% diff_cancel2
thf(fact_388_diff__add__inverse,axiom,
    ! [N2: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ M ) @ N2 )
      = M ) ).

% diff_add_inverse
thf(fact_389_diff__add__inverse2,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ N2 )
      = M ) ).

% diff_add_inverse2
thf(fact_390_add__mult__distrib,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N2 ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) ) ) ).

% add_mult_distrib
thf(fact_391_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% add_mult_distrib2
thf(fact_392_left__add__mult__distrib,axiom,
    ! [I: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I @ J ) @ U ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_393_diff__mult__distrib,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N2 ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) ) ) ).

% diff_mult_distrib
thf(fact_394_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% diff_mult_distrib2
thf(fact_395_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X2: A,Y2: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X2 @ Y2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_396_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N2 )
         => ( ord_less_eq @ A @ I @ ( minus_minus @ A @ N2 @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_397_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N2: A,J: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N2 )
         => ( ( ord_less_eq @ A @ N2 @ ( plus_plus @ A @ J @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N2 )
             => ( ( ord_less_eq @ A @ N2 @ ( plus_plus @ A @ J @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N2 @ K ) @ J ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_398_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_399_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 )
            = D3 ) ) ) ).

% eq_add_iff1
thf(fact_400_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D3 ) ) ) ) ).

% eq_add_iff2
thf(fact_401_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X2: A,Y2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) )
          = ( times_times @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( minus_minus @ A @ X2 @ Y2 ) ) ) ) ).

% square_diff_square_factored
thf(fact_402_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X2: A,Y2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X2 @ Y2 ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X2 @ ( minus_minus @ A @ Y2 @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X2 @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_403_mono__nat__linear__lb,axiom,
    ! [F2: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N3: nat] :
          ( ( ord_less @ nat @ M4 @ N3 )
         => ( ord_less @ nat @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F2 @ M ) @ K ) @ ( F2 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_404_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_405_less__diff__iff,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( ord_less @ nat @ M @ N2 ) ) ) ) ).

% less_diff_iff
thf(fact_406_add__diff__inverse__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ~ ( ord_less @ nat @ M @ N2 )
     => ( ( plus_plus @ nat @ N2 @ ( minus_minus @ nat @ M @ N2 ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_407_less__diff__conv,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ).

% less_diff_conv
thf(fact_408_le__diff__conv,axiom,
    ! [J: nat,K: nat,I: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
      = ( ord_less_eq @ nat @ J @ ( plus_plus @ nat @ I @ K ) ) ) ).

% le_diff_conv
thf(fact_409_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less_eq @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ) ).

% Nat.le_diff_conv2
thf(fact_410_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J ) @ K )
        = ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_411_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_412_Nat_Ole__imp__diff__is__add,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ( minus_minus @ nat @ J @ I )
          = K )
        = ( J
          = ( plus_plus @ nat @ K @ I ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_413_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D3 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_414_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D3 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_415_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D3 ) ) ) ).

% less_add_iff1
thf(fact_416_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D3 ) ) ) ) ).

% less_add_iff2
thf(fact_417_less__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
        = ( ord_less @ nat @ J @ ( plus_plus @ nat @ I @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_418_nat__eq__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M )
          = N2 ) ) ) ).

% nat_eq_add_iff1
thf(fact_419_nat__eq__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N2 ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_420_nat__le__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N2 ) ) ) ).

% nat_le_add_iff1
thf(fact_421_nat__le__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N2 ) ) ) ) ).

% nat_le_add_iff2
thf(fact_422_nat__diff__add__eq1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N2 ) ) ) ).

% nat_diff_add_eq1
thf(fact_423_nat__diff__add__eq2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N2 ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_424_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X2 ) ) ).

% field_sum_of_halves
thf(fact_425__C07_C,axiom,
    ( ( ord_less @ nat @ succy @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
    & ( ord_less @ nat @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
    & ( ( suc @ ( plus_plus @ nat @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
      = deg ) ) ).

% "07"
thf(fact_426_real__average__minus__second,axiom,
    ! [B2: real,A2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_427_real__average__minus__first,axiom,
    ! [A2: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_428_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X2: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X2 @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_429_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X2: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_430_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_431_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_432_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_433_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_434_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_435_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_436_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_437_even__odd__cases,axiom,
    ! [X2: nat] :
      ( ! [N3: nat] :
          ( X2
         != ( plus_plus @ nat @ N3 @ N3 ) )
     => ~ ! [N3: nat] :
            ( X2
           != ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) ) ) ).

% even_odd_cases
thf(fact_438_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_439_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_440_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_441_nat_Oinject,axiom,
    ! [X22: nat,Y22: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% nat.inject
thf(fact_442_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ord_less_eq @ A @ N2 @ ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_443_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_444_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_445_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_446_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_447_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X2 @ Y2 ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_448_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( plus_plus @ A @ X2 @ Y2 )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_449_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_450_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_451_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_452_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_453_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_454_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_455_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_456_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_457_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_458_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_0_right
thf(fact_459_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_460_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_zero
thf(fact_461_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_462_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_463_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_464_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_465_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_466_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_467_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_468_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_469_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_470_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_471_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_472_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_473_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_474_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_475_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_476_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_477_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_478_lessI,axiom,
    ! [N2: nat] : ( ord_less @ nat @ N2 @ ( suc @ N2 ) ) ).

% lessI
thf(fact_479_Suc__mono,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) ) ).

% Suc_mono
thf(fact_480_Suc__less__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_less_eq
thf(fact_481_Suc__le__mono,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N2 @ M ) ) ).

% Suc_le_mono
thf(fact_482_add__Suc__right,axiom,
    ! [M: nat,N2: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N2 ) )
      = ( suc @ ( plus_plus @ nat @ M @ N2 ) ) ) ).

% add_Suc_right
thf(fact_483_diff__Suc__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ M @ N2 ) ) ).

% diff_Suc_Suc
thf(fact_484_Suc__diff__diff,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N2 ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N2 ) @ K ) ) ).

% Suc_diff_diff
thf(fact_485_not__real__square__gt__zero,axiom,
    ! [X2: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X2 @ X2 ) ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_486_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_487_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_488_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_489_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_490_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_491_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_492_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_493_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_494_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_495_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_496_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_497_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_498_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_499_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N2 ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_500_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_501_zero__less__Suc,axiom,
    ! [N2: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) ).

% zero_less_Suc
thf(fact_502_less__Suc0,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_503_one__eq__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N2 ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_504_mult__eq__1__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ N2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_505_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_506_mult__Suc__right,axiom,
    ! [M: nat,N2: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N2 ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N2 ) ) ) ).

% mult_Suc_right
thf(fact_507_power__Suc__0,axiom,
    ! [N2: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_508_nat__power__eq__Suc__0__iff,axiom,
    ! [X2: nat,M: nat] :
      ( ( ( power_power @ nat @ X2 @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_509_Suc__pred,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N2 ) ) ).

% Suc_pred
thf(fact_510_one__le__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N2 ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) ) ) ).

% one_le_mult_iff
thf(fact_511_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J @ K ) ) @ I )
        = ( minus_minus @ nat @ ( suc @ J ) @ ( plus_plus @ nat @ K @ I ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_512_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I @ ( suc @ ( minus_minus @ nat @ J @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ ( suc @ J ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_513_Suc__numeral,axiom,
    ! [N2: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N2 ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N2 @ one2 ) ) ) ).

% Suc_numeral
thf(fact_514_add__2__eq__Suc_H,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N2 ) ) ) ).

% add_2_eq_Suc'
thf(fact_515_add__2__eq__Suc,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
      = ( suc @ ( suc @ N2 ) ) ) ).

% add_2_eq_Suc
thf(fact_516_div2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_517_n__not__Suc__n,axiom,
    ! [N2: nat] :
      ( N2
     != ( suc @ N2 ) ) ).

% n_not_Suc_n
thf(fact_518_Suc__inject,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y2 ) )
     => ( X2 = Y2 ) ) ).

% Suc_inject
thf(fact_519_realpow__pos__nth2,axiom,
    ! [A2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R2: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
          & ( ( power_power @ real @ R2 @ ( suc @ N2 ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_520_vebt__buildup_Ocases,axiom,
    ! [X2: nat] :
      ( ( X2
       != ( zero_zero @ nat ) )
     => ( ( X2
         != ( suc @ ( zero_zero @ nat ) ) )
       => ~ ! [Va: nat] :
              ( X2
             != ( suc @ ( suc @ Va ) ) ) ) ) ).

% vebt_buildup.cases
thf(fact_521_nat_Odistinct_I1_J,axiom,
    ! [X22: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X22 ) ) ).

% nat.distinct(1)
thf(fact_522_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat3: nat] :
      ( ( suc @ Nat3 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_523_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_524_nat_OdiscI,axiom,
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_525_old_Onat_Oexhaust,axiom,
    ! [Y2: nat] :
      ( ( Y2
       != ( zero_zero @ nat ) )
     => ~ ! [Nat4: nat] :
            ( Y2
           != ( suc @ Nat4 ) ) ) ).

% old.nat.exhaust
thf(fact_526_nat__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( P @ ( suc @ N3 ) ) )
       => ( P @ N2 ) ) ) ).

% nat_induct
thf(fact_527_diff__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N2: nat] :
      ( ! [X3: nat] : ( P @ X3 @ ( zero_zero @ nat ) )
     => ( ! [Y3: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y3 ) )
       => ( ! [X3: nat,Y3: nat] :
              ( ( P @ X3 @ Y3 )
             => ( P @ ( suc @ X3 ) @ ( suc @ Y3 ) ) )
         => ( P @ M @ N2 ) ) ) ) ).

% diff_induct
thf(fact_528_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_529_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_530_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_531_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_532_not0__implies__Suc,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ? [M4: nat] :
          ( N2
          = ( suc @ M4 ) ) ) ).

% not0_implies_Suc
thf(fact_533_Nat_OlessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ I @ K )
     => ( ( K
         != ( suc @ I ) )
       => ~ ! [J3: nat] :
              ( ( ord_less @ nat @ I @ J3 )
             => ( K
               != ( suc @ J3 ) ) ) ) ) ).

% Nat.lessE
thf(fact_534_Suc__lessD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N2 )
     => ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_lessD
thf(fact_535_Suc__lessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ K )
     => ~ ! [J3: nat] :
            ( ( ord_less @ nat @ I @ J3 )
           => ( K
             != ( suc @ J3 ) ) ) ) ).

% Suc_lessE
thf(fact_536_Suc__lessI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( ( suc @ M )
         != N2 )
       => ( ord_less @ nat @ ( suc @ M ) @ N2 ) ) ) ).

% Suc_lessI
thf(fact_537_less__SucE,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
     => ( ~ ( ord_less @ nat @ M @ N2 )
       => ( M = N2 ) ) ) ).

% less_SucE
thf(fact_538_less__SucI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less @ nat @ M @ ( suc @ N2 ) ) ) ).

% less_SucI
thf(fact_539_Ex__less__Suc,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N2 ) )
            & ( P @ I3 ) ) )
      = ( ( P @ N2 )
        | ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N2 )
            & ( P @ I3 ) ) ) ) ).

% Ex_less_Suc
thf(fact_540_less__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( M = N2 ) ) ) ).

% less_Suc_eq
thf(fact_541_not__less__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N2 ) )
      = ( ord_less @ nat @ N2 @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_542_All__less__Suc,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N2 ) )
           => ( P @ I3 ) ) )
      = ( ( P @ N2 )
        & ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N2 )
           => ( P @ I3 ) ) ) ) ).

% All_less_Suc
thf(fact_543_Suc__less__eq2,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N2 ) @ M )
      = ( ? [M5: nat] :
            ( ( M
              = ( suc @ M5 ) )
            & ( ord_less @ nat @ N2 @ M5 ) ) ) ) ).

% Suc_less_eq2
thf(fact_544_less__antisym,axiom,
    ! [N2: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
       => ( M = N2 ) ) ) ).

% less_antisym
thf(fact_545_Suc__less__SucD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
     => ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_less_SucD
thf(fact_546_less__trans__Suc,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ J @ K )
       => ( ord_less @ nat @ ( suc @ I ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_547_less__Suc__induct,axiom,
    ! [I: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I @ J )
     => ( ! [I4: nat] : ( P @ I4 @ ( suc @ I4 ) )
       => ( ! [I4: nat,J3: nat,K2: nat] :
              ( ( ord_less @ nat @ I4 @ J3 )
             => ( ( ord_less @ nat @ J3 @ K2 )
               => ( ( P @ I4 @ J3 )
                 => ( ( P @ J3 @ K2 )
                   => ( P @ I4 @ K2 ) ) ) ) )
         => ( P @ I @ J ) ) ) ) ).

% less_Suc_induct
thf(fact_548_strict__inc__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I @ J )
     => ( ! [I4: nat] :
            ( ( J
              = ( suc @ I4 ) )
           => ( P @ I4 ) )
       => ( ! [I4: nat] :
              ( ( ord_less @ nat @ I4 @ J )
             => ( ( P @ ( suc @ I4 ) )
               => ( P @ I4 ) ) )
         => ( P @ I ) ) ) ) ).

% strict_inc_induct
thf(fact_549_not__less__less__Suc__eq,axiom,
    ! [N2: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
        = ( N2 = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_550_transitive__stepwise__le,axiom,
    ! [M: nat,N2: nat,R3: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ! [X3: nat] : ( R3 @ X3 @ X3 )
       => ( ! [X3: nat,Y3: nat,Z3: nat] :
              ( ( R3 @ X3 @ Y3 )
             => ( ( R3 @ Y3 @ Z3 )
               => ( R3 @ X3 @ Z3 ) ) )
         => ( ! [N3: nat] : ( R3 @ N3 @ ( suc @ N3 ) )
           => ( R3 @ M @ N2 ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_551_nat__induct__at__least,axiom,
    ! [M: nat,N2: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( P @ M )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct_at_least
thf(fact_552_full__nat__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) ).

% full_nat_induct
thf(fact_553_not__less__eq__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N2 ) )
      = ( ord_less_eq @ nat @ ( suc @ N2 ) @ M ) ) ).

% not_less_eq_eq
thf(fact_554_Suc__n__not__le__n,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N2 ) @ N2 ) ).

% Suc_n_not_le_n
thf(fact_555_le__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
      = ( ( ord_less_eq @ nat @ M @ N2 )
        | ( M
          = ( suc @ N2 ) ) ) ) ).

% le_Suc_eq
thf(fact_556_Suc__le__D,axiom,
    ! [N2: nat,M6: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ M6 )
     => ? [M4: nat] :
          ( M6
          = ( suc @ M4 ) ) ) ).

% Suc_le_D
thf(fact_557_le__SucI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ M @ ( suc @ N2 ) ) ) ).

% le_SucI
thf(fact_558_le__SucE,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N2 )
       => ( M
          = ( suc @ N2 ) ) ) ) ).

% le_SucE
thf(fact_559_Suc__leD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% Suc_leD
thf(fact_560_add__Suc__shift,axiom,
    ! [M: nat,N2: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N2 )
      = ( plus_plus @ nat @ M @ ( suc @ N2 ) ) ) ).

% add_Suc_shift
thf(fact_561_add__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N2 )
      = ( suc @ ( plus_plus @ nat @ M @ N2 ) ) ) ).

% add_Suc
thf(fact_562_nat__arith_Osuc1,axiom,
    ! [A3: nat,K: nat,A2: nat] :
      ( ( A3
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A3 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_563_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( minus_minus @ nat @ K @ I ) ) ) ) ).

% zero_induct_lemma
thf(fact_564_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( M = N2 ) ) ).

% Suc_mult_cancel1
thf(fact_565_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ nat @ N2 @ N4 )
           => ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ N4 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_566_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,M: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ M ) )
            = ( ord_less @ nat @ N2 @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_567_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_568_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_Suc
thf(fact_569_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
         => ( ( ord_less_eq @ nat @ N2 @ N4 )
           => ( ord_less_eq @ A @ ( F2 @ N4 ) @ ( F2 @ N2 ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_570_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less_eq @ nat @ N2 @ N4 )
           => ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( F2 @ N4 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_571_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J2: nat] :
            ( ( M
              = ( suc @ J2 ) )
            & ( ord_less @ nat @ J2 @ N2 ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_572_gr0__implies__Suc,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ? [M4: nat] :
          ( N2
          = ( suc @ M4 ) ) ) ).

% gr0_implies_Suc
thf(fact_573_All__less__Suc2,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N2 ) )
           => ( P @ I3 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N2 )
           => ( P @ ( suc @ I3 ) ) ) ) ) ).

% All_less_Suc2
thf(fact_574_gr0__conv__Suc,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( ? [M3: nat] :
            ( N2
            = ( suc @ M3 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_575_Ex__less__Suc2,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N2 ) )
            & ( P @ I3 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N2 )
            & ( P @ ( suc @ I3 ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_576_Suc__leI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_leI
thf(fact_577_Suc__le__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_le_eq
thf(fact_578_dec__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( P @ I )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ N3 )
                 => ( P @ ( suc @ N3 ) ) ) ) )
         => ( P @ J ) ) ) ) ).

% dec_induct
thf(fact_579_inc__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( P @ J )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ ( suc @ N3 ) )
                 => ( P @ N3 ) ) ) )
         => ( P @ I ) ) ) ) ).

% inc_induct
thf(fact_580_Suc__le__lessD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
     => ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_le_lessD
thf(fact_581_le__less__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
        = ( N2 = M ) ) ) ).

% le_less_Suc_eq
thf(fact_582_less__Suc__eq__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% less_Suc_eq_le
thf(fact_583_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N: nat] : ( ord_less_eq @ nat @ ( suc @ N ) ) ) ) ).

% less_eq_Suc_le
thf(fact_584_le__imp__less__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less @ nat @ M @ ( suc @ N2 ) ) ) ).

% le_imp_less_Suc
thf(fact_585_one__is__add,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N2 ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N2
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N2
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_586_add__is__1,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M @ N2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N2
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N2
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_587_less__natE,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ~ ! [Q3: nat] :
            ( N2
           != ( suc @ ( plus_plus @ nat @ M @ Q3 ) ) ) ) ).

% less_natE
thf(fact_588_less__add__Suc1,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ I @ M ) ) ) ).

% less_add_Suc1
thf(fact_589_less__add__Suc2,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ M @ I ) ) ) ).

% less_add_Suc2
thf(fact_590_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N: nat] :
        ? [K3: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M3 @ K3 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_591_less__imp__Suc__add,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ? [K2: nat] :
          ( N2
          = ( suc @ ( plus_plus @ nat @ M @ K2 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_592_Suc__diff__Suc,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N2 ) ) )
        = ( minus_minus @ nat @ M @ N2 ) ) ) ).

% Suc_diff_Suc
thf(fact_593_diff__less__Suc,axiom,
    ! [M: nat,N2: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N2 ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_594_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_mult_less_cancel1
thf(fact_595_Suc__diff__le,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N2 )
        = ( suc @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% Suc_diff_le
thf(fact_596_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% Suc_mult_le_cancel1
thf(fact_597_Suc__div__le__mono,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N2 ) @ ( divide_divide @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_div_le_mono
thf(fact_598_mult__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N2 )
      = ( plus_plus @ nat @ N2 @ ( times_times @ nat @ M @ N2 ) ) ) ).

% mult_Suc
thf(fact_599_not__exp__less__eq__0__int,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_600_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ ( power_power @ A @ B2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_601_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
            = ( power_power @ A @ B2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_602_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_603_ex__least__nat__less,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less @ nat @ K2 @ N2 )
            & ! [I2: nat] :
                ( ( ord_less_eq @ nat @ I2 @ K2 )
               => ~ ( P @ I2 ) )
            & ( P @ ( suc @ K2 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_604_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X2: A] :
          ( ( ( zero_zero @ A )
            = X2 )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_605_diff__Suc__less,axiom,
    ! [N2: nat,I: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ I ) ) @ N2 ) ) ).

% diff_Suc_less
thf(fact_606_one__less__mult,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N2 ) ) ) ) ).

% one_less_mult
thf(fact_607_n__less__m__mult__n,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N2 @ ( times_times @ nat @ M @ N2 ) ) ) ) ).

% n_less_m_mult_n
thf(fact_608_n__less__n__mult__m,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N2 @ ( times_times @ nat @ N2 @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_609_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X4: A] :
        ? [Y3: A] : ( ord_less @ A @ Y3 @ X4 ) ) ).

% linordered_field_no_lb
thf(fact_610_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X4: A] :
        ? [X_1: A] : ( ord_less @ A @ X4 @ X_1 ) ) ).

% linordered_field_no_ub
thf(fact_611_power__gt__expt,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N2 @ K ) ) ) ).

% power_gt_expt
thf(fact_612_nat__one__le__power,axiom,
    ! [I: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I @ N2 ) ) ) ).

% nat_one_le_power
thf(fact_613_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_614_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ B3 @ A4 ) ) ) ) ).

% mult.commute
thf(fact_615_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_616_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_617_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_618_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_619_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_620_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ B3 @ A4 ) ) ) ) ).

% add.commute
thf(fact_621_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_622_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_623_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_624_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B4: A,K: A,B2: A,A2: A] :
          ( ( B4
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B4 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_625_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_626_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( I = J )
            & ( K = L2 ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_627_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_628_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( A2 = B2 )
            = ( C2 = D3 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_629_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_630_realpow__pos__nth__unique,axiom,
    ! [N2: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
            & ( ( power_power @ real @ X3 @ N2 )
              = A2 )
            & ! [Y4: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y4 )
                  & ( ( power_power @ real @ Y4 @ N2 )
                    = A2 ) )
               => ( Y4 = X3 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_631_realpow__pos__nth,axiom,
    ! [N2: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ( ( power_power @ real @ R2 @ N2 )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_632_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_633_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M3 @ N )
            | ( N
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M3 @ N ) @ N ) ) ) ) ) ).

% div_if
thf(fact_634_div__nat__eqI,axiom,
    ! [N2: nat,Q2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ Q2 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N2 @ ( suc @ Q2 ) ) )
       => ( ( divide_divide @ nat @ M @ N2 )
          = Q2 ) ) ) ).

% div_nat_eqI
thf(fact_635_Suc__nat__number__of__add,axiom,
    ! [V: num,N2: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N2 ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V @ one2 ) ) @ N2 ) ) ).

% Suc_nat_number_of_add
thf(fact_636_less__2__cases__iff,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_637_less__2__cases,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N2
          = ( zero_zero @ nat ) )
        | ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_638_le__div__geq,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ M )
       => ( ( divide_divide @ nat @ M @ N2 )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ) ) ).

% le_div_geq
thf(fact_639_split__div_H,axiom,
    ! [P: nat > $o,M: nat,N2: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q4: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ Q4 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N2 @ ( suc @ Q4 ) ) )
            & ( P @ Q4 ) ) ) ) ).

% split_div'
thf(fact_640_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_641_nat__bit__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_bit_induct
thf(fact_642_Suc__n__div__2__gt__zero,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_643_div__2__gt__zero,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_644_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) ).

% zero_le
thf(fact_645_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( N2
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) ) ) ).

% gr_zeroI
thf(fact_646_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ~ ( ord_less @ A @ N2 @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_647_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N2: A] :
          ( ( ord_less @ A @ M @ N2 )
         => ( N2
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_648_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N2 )
          = ( ( N2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_649_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_650_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_651_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
            ? [C3: A] :
              ( B3
              = ( plus_plus @ A @ A4 @ C3 ) ) ) ) ) ).

% le_iff_add
thf(fact_652_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_653_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C4: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C4 ) ) ) ) ).

% less_eqE
thf(fact_654_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_655_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D3 ) ) ) ) ) ).

% add_mono
thf(fact_656_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L2 ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_657_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( I = J )
            & ( ord_less_eq @ A @ K @ L2 ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_658_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( K = L2 ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_659_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_660_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_661_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_662_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D3 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_663_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_664_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_665_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D3: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D3 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D3 ) ) ) ) ) ).

% diff_mono
thf(fact_666_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_667_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_668_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_669_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_670_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D3 ) ) ) ) ) ).

% add_strict_mono
thf(fact_671_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( K = L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_672_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( I = J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_673_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_674_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( minus_minus @ A @ A4 @ B3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_675_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D3: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D3 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D3 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_676_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D3 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_677_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_678_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_679_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_680_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,Z: A,W: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X2 @ W ) @ ( times_times @ A @ Y2 @ Z ) ) ) ) ).

% divide_divide_times_eq
thf(fact_681_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,Z: A,W: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ Y2 @ W ) ) ) ) ).

% times_divide_times_eq
thf(fact_682_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_683_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_684_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_685_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_686_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_687_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_688_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_689_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_690_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_691_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_692_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_693_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_694_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_695_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X2 @ Y2 )
                = ( zero_zero @ A ) )
              = ( ( X2
                  = ( zero_zero @ A ) )
                & ( Y2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_696_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ( plus_plus @ A @ X2 @ Y2 )
                = ( zero_zero @ A ) )
              = ( ( X2
                  = ( zero_zero @ A ) )
                & ( Y2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_697_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_698_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_699_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_700_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_701_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_702_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_703_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D3 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_704_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D3 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_705_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_706_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_707_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_708_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_709_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_710_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C4: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C4 ) )
               => ( C4
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_711_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_712_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_713_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_714_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_715_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_716_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_717_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_718_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_719_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_720_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] : ( ord_less @ A @ ( minus_minus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_721_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_neg_neg
thf(fact_722_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_723_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_724_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_pos_pos
thf(fact_725_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_726_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_727_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_728_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_729_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_730_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_731_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_732_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_733_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_734_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_735_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_736_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X2 @ Y2 )
                = ( divide_divide @ A @ W @ Z ) )
              = ( ( times_times @ A @ X2 @ Z )
                = ( times_times @ A @ W @ Y2 ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_737_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_738_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_739_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_740_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_741_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_742_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_743_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_744_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_745_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_746_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_747_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_748_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_749_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_750_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_751_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_752_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_753_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_754_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_755_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_756_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_757_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ X2 @ ( plus_plus @ A @ Y2 @ E ) ) )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% field_le_epsilon
thf(fact_758_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_759_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_760_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_761_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_762_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_763_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,W: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Z ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_764_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ X2 @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Z ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_less
thf(fact_765_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Z ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_le
thf(fact_766_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_767_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_768_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less @ A @ ( times_times @ A @ Z @ Y2 ) @ X2 )
           => ( ord_less @ A @ Z @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_769_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ Z ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_770_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_771_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_772_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_773_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_774_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_775_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_776_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ Z ) @ Y2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X2 @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% divide_add_eq_iff
thf(fact_777_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X2 @ ( divide_divide @ A @ Y2 @ Z ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ Z ) @ Y2 ) @ Z ) ) ) ) ).

% add_divide_eq_iff
thf(fact_778_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z @ ( divide_divide @ A @ X2 @ Y2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) ) @ Y2 ) ) ) ) ).

% add_num_frac
thf(fact_779_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ Z )
            = ( divide_divide @ A @ ( plus_plus @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) ) @ Y2 ) ) ) ) ).

% add_frac_num
thf(fact_780_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_781_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_782_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_783_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X2 @ Z ) @ Y2 )
            = ( divide_divide @ A @ ( minus_minus @ A @ X2 @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_784_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X2 @ ( divide_divide @ A @ Y2 @ Z ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ Y2 ) @ Z ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_785_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_786_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_787_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_788_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ Y2 ) @ X2 )
           => ( ord_less_eq @ A @ Z @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_789_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ Z ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_790_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_791_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_792_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_793_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_794_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_795_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_796_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_797_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_798_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_799_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V: A,R: A,S2: A] :
          ( ( ord_less_eq @ A @ U @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
           => ( ( ord_less_eq @ A @ R @ S2 )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R @ ( minus_minus @ A @ V @ U ) ) @ S2 ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_800_div__geq,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ~ ( ord_less @ nat @ M @ N2 )
       => ( ( divide_divide @ nat @ M @ N2 )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ) ) ).

% div_geq
thf(fact_801_enat__ord__number_I1_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N2 ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% enat_ord_number(1)
thf(fact_802_enat__ord__number_I2_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N2 ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% enat_ord_number(2)
thf(fact_803_double__not__eq__Suc__double,axiom,
    ! [M: nat,N2: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% double_not_eq_Suc_double
thf(fact_804_Suc__double__not__eq__double,axiom,
    ! [M: nat,N2: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% Suc_double_not_eq_double
thf(fact_805_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_806_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_807_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_808_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_809_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_810_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_811_i0__less,axiom,
    ! [N2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 )
      = ( ( N2
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_812_unset__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_813_unset__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_814_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit0
thf(fact_815_div__neg__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L2 @ K )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_816_div__pos__pos__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L2 )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_817_less__int__code_I1_J,axiom,
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) ).

% less_int_code(1)
thf(fact_818_plus__int__code_I2_J,axiom,
    ! [L2: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L2 )
      = L2 ) ).

% plus_int_code(2)
thf(fact_819_plus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% plus_int_code(1)
thf(fact_820_minus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( minus_minus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% minus_int_code(1)
thf(fact_821_times__int__code_I2_J,axiom,
    ! [L2: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L2 )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_822_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_823_less__eq__int__code_I1_J,axiom,
    ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ).

% less_eq_int_code(1)
thf(fact_824_split__zdiv,axiom,
    ! [P: int > $o,N2: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N2 @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I3: int,J2: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J2 )
                & ( ord_less @ int @ J2 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J2 ) ) )
             => ( P @ I3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I3: int,J2: int] :
              ( ( ( ord_less @ int @ K @ J2 )
                & ( ord_less_eq @ int @ J2 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J2 ) ) )
             => ( P @ I3 ) ) ) ) ) ).

% split_zdiv
thf(fact_825_zdiv__mono1,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A5 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A5 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_826_zdiv__mono2,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B5 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_827_i0__lb,axiom,
    ! [N2: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 ) ).

% i0_lb
thf(fact_828_q__pos__lemma,axiom,
    ! [B5: int,Q5: int,R4: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) )
     => ( ( ord_less @ int @ R4 @ B5 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q5 ) ) ) ) ).

% q_pos_lemma
thf(fact_829_ile0__eq,axiom,
    ! [N2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) )
      = ( N2
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_830_zdiv__eq__0__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( divide_divide @ int @ I @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_831_zmult__zless__mono2,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less @ int @ I @ J )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I ) @ ( times_times @ int @ K @ J ) ) ) ) ).

% zmult_zless_mono2
thf(fact_832_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_neg_eq
thf(fact_833_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_pos_eq
thf(fact_834_zdiv__mono1__neg,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A5 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A5 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_835_zdiv__mono2__neg,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B5 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_836_div__int__pos__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L2 ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L2
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_837_not__iless0,axiom,
    ! [N2: extended_enat] :
      ~ ( ord_less @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_838_div__positive__int,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less_eq @ int @ L2 @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L2 ) ) ) ) ).

% div_positive_int
thf(fact_839_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B5: int,Q5: int,R4: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) )
       => ( ( ord_less @ int @ R4 @ B5 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_840_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_841_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_842_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_843_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_844_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_845_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I @ K ) )
        = ( ord_less_eq @ int @ K @ I ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_846_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B5: int,Q5: int,R4: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R4 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R4 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_847_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R4: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R4 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R4 )
       => ( ( ord_less @ int @ R4 @ B2 )
         => ( ( ord_less @ int @ R @ B2 )
           => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_848_enat__less__induct,axiom,
    ! [P: extended_enat > $o,N2: extended_enat] :
      ( ! [N3: extended_enat] :
          ( ! [M2: extended_enat] :
              ( ( ord_less @ extended_enat @ M2 @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) ).

% enat_less_induct
thf(fact_849_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_850_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_851_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_852_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y2: extended_enat,X2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z @ Y2 )
     => ( ( plus_plus @ extended_enat @ X2 @ ( minus_minus @ extended_enat @ Y2 @ Z ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X2 @ Y2 ) @ Z ) ) ) ).

% add_diff_assoc_enat
thf(fact_853_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R4: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R4 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( ord_less @ int @ B2 @ R4 )
           => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_854_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_855_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N2 ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 ) ) ) ).

% enat_0_less_mult_iff
thf(fact_856_unset__bit__less__eq,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_857_Bolzano,axiom,
    ! [A2: real,B2: real,P: real > real > $o] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [A6: real,B6: real,C4: real] :
            ( ( P @ A6 @ B6 )
           => ( ( P @ B6 @ C4 )
             => ( ( ord_less_eq @ real @ A6 @ B6 )
               => ( ( ord_less_eq @ real @ B6 @ C4 )
                 => ( P @ A6 @ C4 ) ) ) ) )
       => ( ! [X3: real] :
              ( ( ord_less_eq @ real @ A2 @ X3 )
             => ( ( ord_less_eq @ real @ X3 @ B2 )
               => ? [D4: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                    & ! [A6: real,B6: real] :
                        ( ( ( ord_less_eq @ real @ A6 @ X3 )
                          & ( ord_less_eq @ real @ X3 @ B6 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B6 @ A6 ) @ D4 ) )
                       => ( P @ A6 @ B6 ) ) ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_858_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ Y2 @ Z ) )
            = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_859_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ X2 ) @ ( times_times @ A @ Z @ Y2 ) )
            = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_860_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X: nat,N: nat] : ( modulo_modulo @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% low_def
thf(fact_861_decr__mult__lemma,axiom,
    ! [D3: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D3 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X4: int] :
              ( ( P @ X4 )
             => ( P @ ( minus_minus @ int @ X4 @ ( times_times @ int @ K @ D3 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_862_incr__mult__lemma,axiom,
    ! [D3: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D3 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X4: int] :
              ( ( P @ X4 )
             => ( P @ ( plus_plus @ int @ X4 @ ( times_times @ int @ K @ D3 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_863_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,N2: nat] :
      ( ( P @ K )
     => ( ! [X3: A] :
            ( ( P @ X3 )
           => ? [Y4: A] :
                ( ( P @ Y4 )
                & ~ ( ord_less_eq @ nat @ ( F2 @ Y4 ) @ ( F2 @ X3 ) ) ) )
       => ? [Y3: A] :
            ( ( P @ Y3 )
            & ~ ( ord_less @ nat @ ( F2 @ Y3 ) @ ( plus_plus @ nat @ ( F2 @ K ) @ N2 ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_864_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R: A,A2: A,B2: A,C2: A,D3: A] :
          ( ( R
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D3 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R @ D3 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_865_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ Y2 @ Z ) )
            = ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% mult_less_iff1
thf(fact_866_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mod_trivial
thf(fact_867_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_868_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% mod_by_0
thf(fact_869_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_870_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_871_mod__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self2
thf(fact_872_mod__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self1
thf(fact_873_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mod_self2
thf(fact_874_mod__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( modulo_modulo @ nat @ M @ N2 )
        = M ) ) ).

% mod_less
thf(fact_875_idiff__0,axiom,
    ! [N2: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_876_idiff__0__right,axiom,
    ! [N2: extended_enat] :
      ( ( minus_minus @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) )
      = N2 ) ).

% idiff_0_right
thf(fact_877_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_878_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_879_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_880_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_881_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_882_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_883_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_884_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_885_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_886_Suc__mod__mult__self4,axiom,
    ! [N2: nat,K: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ K ) @ M ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self4
thf(fact_887_Suc__mod__mult__self3,axiom,
    ! [K: nat,N2: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ K @ N2 ) @ M ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self3
thf(fact_888_Suc__mod__mult__self2,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ N2 @ K ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self2
thf(fact_889_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ K @ N2 ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self1
thf(fact_890_mod2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_891_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N2: nat] :
      ( ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_892_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_893_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( minus_minus @ int @ Z1 @ Z22 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(4)
thf(fact_894_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z1 @ Z22 ) @ W )
      = ( minus_minus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(3)
thf(fact_895_iadd__is__0,axiom,
    ! [M: extended_enat,N2: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N2 )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N2
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_896_imult__is__0,axiom,
    ! [M: extended_enat,N2: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N2 )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N2
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_897_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z22 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(1)
thf(fact_898_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z22 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(2)
thf(fact_899_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_900_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_901_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_902_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_903_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A5 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A5 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_904_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_905_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_right_eq
thf(fact_906_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_left_eq
thf(fact_907_mod__add__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A5 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( plus_plus @ A @ A5 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_add_cong
thf(fact_908_mod__add__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_eq
thf(fact_909_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_eq
thf(fact_910_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A5 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( minus_minus @ A @ A5 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_diff_cong
thf(fact_911_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_left_eq
thf(fact_912_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_right_eq
thf(fact_913_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ N2 ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A2 @ N2 ) @ B2 ) ) ) ).

% power_mod
thf(fact_914_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( modulo_modulo @ nat @ M @ N2 ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ N2 ) ) ).

% mod_Suc_Suc_eq
thf(fact_915_mod__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( modulo_modulo @ nat @ M @ N2 ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% mod_Suc_eq
thf(fact_916_mod__less__eq__dividend,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N2 ) @ M ) ).

% mod_less_eq_dividend
thf(fact_917_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_918_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_919_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_920_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(9)
thf(fact_921_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ one2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% cong_exp_iff_simps(4)
thf(fact_922_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D5: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ D5 ) ) ) ) ) ).

% mod_eqE
thf(fact_923_div__add1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_add1_eq
thf(fact_924_mod__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N2 ) )
          = N2 )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N2 )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N2 ) )
         != N2 )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N2 )
          = ( suc @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ) ) ).

% mod_Suc
thf(fact_925_mod__induct,axiom,
    ! [P: nat > $o,N2: nat,P2: nat,M: nat] :
      ( ( P @ N2 )
     => ( ( ord_less @ nat @ N2 @ P2 )
       => ( ( ord_less @ nat @ M @ P2 )
         => ( ! [N3: nat] :
                ( ( ord_less @ nat @ N3 @ P2 )
               => ( ( P @ N3 )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N3 ) @ P2 ) ) ) )
           => ( P @ M ) ) ) ) ) ).

% mod_induct
thf(fact_926_mod__less__divisor,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N2 ) @ N2 ) ) ).

% mod_less_divisor
thf(fact_927_mod__Suc__le__divisor,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N2 ) ) @ N2 ) ).

% mod_Suc_le_divisor
thf(fact_928_mod__eq__0D,axiom,
    ! [M: nat,D3: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D3 )
        = ( zero_zero @ nat ) )
     => ? [Q3: nat] :
          ( M
          = ( times_times @ nat @ D3 @ Q3 ) ) ) ).

% mod_eq_0D
thf(fact_929_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N: nat] : ( if @ nat @ ( ord_less @ nat @ M3 @ N ) @ M3 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M3 @ N ) @ N ) ) ) ) ).

% mod_if
thf(fact_930_mod__geq,axiom,
    ! [M: nat,N2: nat] :
      ( ~ ( ord_less @ nat @ M @ N2 )
     => ( ( modulo_modulo @ nat @ M @ N2 )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ).

% mod_geq
thf(fact_931_le__mod__geq,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( modulo_modulo @ nat @ M @ N2 )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ).

% le_mod_geq
thf(fact_932_nat__mod__eq__iff,axiom,
    ! [X2: nat,N2: nat,Y2: nat] :
      ( ( ( modulo_modulo @ nat @ X2 @ N2 )
        = ( modulo_modulo @ nat @ Y2 @ N2 ) )
      = ( ? [Q1: nat,Q22: nat] :
            ( ( plus_plus @ nat @ X2 @ ( times_times @ nat @ N2 @ Q1 ) )
            = ( plus_plus @ nat @ Y2 @ ( times_times @ nat @ N2 @ Q22 ) ) ) ) ) ).

% nat_mod_eq_iff
thf(fact_933_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_934_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_935_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_936_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_937_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(6)
thf(fact_938_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(8)
thf(fact_939_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_940_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% mult_div_mod_eq
thf(fact_941_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = A2 ) ) ).

% mod_mult_div_eq
thf(fact_942_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = A2 ) ) ).

% mod_div_mult_eq
thf(fact_943_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% div_mult_mod_eq
thf(fact_944_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( A2
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_945_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_946_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_947_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_948_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_949_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_950_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_951_mod__le__divisor,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N2 ) @ N2 ) ) ).

% mod_le_divisor
thf(fact_952_nat__mod__eq__lemma,axiom,
    ! [X2: nat,N2: nat,Y2: nat] :
      ( ( ( modulo_modulo @ nat @ X2 @ N2 )
        = ( modulo_modulo @ nat @ Y2 @ N2 ) )
     => ( ( ord_less_eq @ nat @ Y2 @ X2 )
       => ? [Q3: nat] :
            ( X2
            = ( plus_plus @ nat @ Y2 @ ( times_times @ nat @ N2 @ Q3 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_953_mod__eq__nat2E,axiom,
    ! [M: nat,Q2: nat,N2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N2 @ Q2 ) )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ~ ! [S3: nat] :
              ( N2
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_954_mod__eq__nat1E,axiom,
    ! [M: nat,Q2: nat,N2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N2 @ Q2 ) )
     => ( ( ord_less_eq @ nat @ N2 @ M )
       => ~ ! [S3: nat] :
              ( M
             != ( plus_plus @ nat @ N2 @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_955_mod__mult2__eq,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( modulo_modulo @ nat @ M @ ( times_times @ nat @ N2 @ Q2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( modulo_modulo @ nat @ ( divide_divide @ nat @ M @ N2 ) @ Q2 ) ) @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ).

% mod_mult2_eq
thf(fact_956_modulo__nat__def,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N: nat] : ( minus_minus @ nat @ M3 @ ( times_times @ nat @ ( divide_divide @ nat @ M3 @ N ) @ N ) ) ) ) ).

% modulo_nat_def
thf(fact_957_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F3: D] :
        ? [Z3: C] :
        ! [X4: C] :
          ( ( ord_less @ C @ X4 @ Z3 )
         => ( F3 = F3 ) ) ) ).

% minf(11)
thf(fact_958_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z3 )
         => ~ ( ord_less @ A @ T2 @ X4 ) ) ) ).

% minf(7)
thf(fact_959_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z3 )
         => ( ord_less @ A @ X4 @ T2 ) ) ) ).

% minf(5)
thf(fact_960_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z3 )
         => ( X4 != T2 ) ) ) ).

% minf(4)
thf(fact_961_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z3 )
         => ( X4 != T2 ) ) ) ).

% minf(3)
thf(fact_962_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P3: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z2: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z2 )
             => ( ( P @ X3 )
                = ( P3 @ X3 ) ) )
         => ( ? [Z2: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z2 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ X4 @ Z3 )
               => ( ( ( P @ X4 )
                    | ( Q @ X4 ) )
                  = ( ( P3 @ X4 )
                    | ( Q6 @ X4 ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_963_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P3: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z2: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z2 )
             => ( ( P @ X3 )
                = ( P3 @ X3 ) ) )
         => ( ? [Z2: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z2 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ X4 @ Z3 )
               => ( ( ( P @ X4 )
                    & ( Q @ X4 ) )
                  = ( ( P3 @ X4 )
                    & ( Q6 @ X4 ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_964_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F3: D] :
        ? [Z3: C] :
        ! [X4: C] :
          ( ( ord_less @ C @ Z3 @ X4 )
         => ( F3 = F3 ) ) ) ).

% pinf(11)
thf(fact_965_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z3 @ X4 )
         => ( ord_less @ A @ T2 @ X4 ) ) ) ).

% pinf(7)
thf(fact_966_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z3 @ X4 )
         => ~ ( ord_less @ A @ X4 @ T2 ) ) ) ).

% pinf(5)
thf(fact_967_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z3 @ X4 )
         => ( X4 != T2 ) ) ) ).

% pinf(4)
thf(fact_968_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z3 @ X4 )
         => ( X4 != T2 ) ) ) ).

% pinf(3)
thf(fact_969_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P3: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z2: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z2 @ X3 )
             => ( ( P @ X3 )
                = ( P3 @ X3 ) ) )
         => ( ? [Z2: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z2 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ Z3 @ X4 )
               => ( ( ( P @ X4 )
                    | ( Q @ X4 ) )
                  = ( ( P3 @ X4 )
                    | ( Q6 @ X4 ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_970_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P3: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z2: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z2 @ X3 )
             => ( ( P @ X3 )
                = ( P3 @ X3 ) ) )
         => ( ? [Z2: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z2 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ Z3 @ X4 )
               => ( ( ( P @ X4 )
                    & ( Q @ X4 ) )
                  = ( ( P3 @ X4 )
                    & ( Q6 @ X4 ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_971_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ? [X3: A] :
          ( ( P @ X3 )
          & ! [Y4: A] :
              ( ( P @ Y4 )
             => ( ord_less_eq @ nat @ ( M @ X3 ) @ ( M @ Y4 ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_972_split__mod,axiom,
    ! [P: nat > $o,M: nat,N2: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ M ) )
        & ( ( N2
           != ( zero_zero @ nat ) )
         => ! [I3: nat,J2: nat] :
              ( ( ord_less @ nat @ J2 @ N2 )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ I3 ) @ J2 ) )
               => ( P @ J2 ) ) ) ) ) ) ).

% split_mod
thf(fact_973_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_974_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_975_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_976_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_977_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_978_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z3 @ X4 )
         => ~ ( ord_less_eq @ A @ X4 @ T2 ) ) ) ).

% pinf(6)
thf(fact_979_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z3 @ X4 )
         => ( ord_less_eq @ A @ T2 @ X4 ) ) ) ).

% pinf(8)
thf(fact_980_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z3 )
         => ( ord_less_eq @ A @ X4 @ T2 ) ) ) ).

% minf(6)
thf(fact_981_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z3 )
         => ~ ( ord_less_eq @ A @ T2 @ X4 ) ) ) ).

% minf(8)
thf(fact_982_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_983_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_984_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D3 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A2 @ D3 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_985_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W: A,Y2: A,X2: A,Z: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y2 ) @ ( times_times @ A @ X2 @ Z ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z ) @ ( times_times @ A @ X2 @ Y2 ) ) )
          = ( ( W = X2 )
            | ( Y2 = Z ) ) ) ) ).

% crossproduct_eq
thf(fact_986_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D6: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D6 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D6 ) ) ) )
           => ! [X4: A,K4: A] :
                ( ( ( P @ X4 )
                  & ( Q @ X4 ) )
                = ( ( P @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K4 @ D6 ) ) )
                  & ( Q @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K4 @ D6 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_987_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D6: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D6 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D6 ) ) ) )
           => ! [X4: A,K4: A] :
                ( ( ( P @ X4 )
                  | ( Q @ X4 ) )
                = ( ( P @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K4 @ D6 ) ) )
                  | ( Q @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K4 @ D6 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_988_list__decode_Ocases,axiom,
    ! [X2: nat] :
      ( ( X2
       != ( zero_zero @ nat ) )
     => ~ ! [N3: nat] :
            ( X2
           != ( suc @ N3 ) ) ) ).

% list_decode.cases
thf(fact_989_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: A] :
            ( ( P @ Y3 )
           => ( ord_less @ nat @ ( F2 @ Y3 ) @ B2 ) )
       => ? [X3: A] :
            ( ( P @ X3 )
            & ! [Y4: A] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ nat @ ( F2 @ Y4 ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_990_conj__le__cong,axiom,
    ! [X2: int,X5: int,P: $o,P3: $o] :
      ( ( X2 = X5 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X5 )
         => ( P = P3 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
            & P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X5 )
            & P3 ) ) ) ) ).

% conj_le_cong
thf(fact_991_imp__le__cong,axiom,
    ! [X2: int,X5: int,P: $o,P3: $o] :
      ( ( X2 = X5 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X5 )
         => ( P = P3 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
           => P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X5 )
           => P3 ) ) ) ) ).

% imp_le_cong
thf(fact_992_minusinfinity,axiom,
    ! [D3: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ! [X3: int,K2: int] :
            ( ( P1 @ X3 )
            = ( P1 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D3 ) ) ) )
       => ( ? [Z2: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ X3 @ Z2 )
             => ( ( P @ X3 )
                = ( P1 @ X3 ) ) )
         => ( ? [X_12: int] : ( P1 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% minusinfinity
thf(fact_993_plusinfinity,axiom,
    ! [D3: int,P3: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ! [X3: int,K2: int] :
            ( ( P3 @ X3 )
            = ( P3 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D3 ) ) ) )
       => ( ? [Z2: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ Z2 @ X3 )
             => ( ( P @ X3 )
                = ( P3 @ X3 ) ) )
         => ( ? [X_12: int] : ( P3 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% plusinfinity
thf(fact_994_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ( ( modulo_modulo @ A @ X2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X2 @ M ) )
              | ( ( modulo_modulo @ A @ X2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X2 @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_995_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_996_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_997_div__mod__decomp,axiom,
    ! [A3: nat,N2: nat] :
      ( A3
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A3 @ N2 ) @ N2 ) @ ( modulo_modulo @ nat @ A3 @ N2 ) ) ) ).

% div_mod_decomp
thf(fact_998_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_999_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_1000_div__less__mono,axiom,
    ! [A3: nat,B4: nat,N2: nat] :
      ( ( ord_less @ nat @ A3 @ B4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( modulo_modulo @ nat @ A3 @ N2 )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B4 @ N2 )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A3 @ N2 ) @ ( divide_divide @ nat @ B4 @ N2 ) ) ) ) ) ) ).

% div_less_mono
thf(fact_1001_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_1002_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N2: nat] :
      ( ! [M4: nat] : ( P @ M4 @ ( zero_zero @ nat ) )
     => ( ! [M4: nat,N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ( P @ N3 @ ( modulo_modulo @ nat @ M4 @ N3 ) )
             => ( P @ M4 @ N3 ) ) )
       => ( P @ M @ N2 ) ) ) ).

% gcd_nat_induct
thf(fact_1003_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_1004_set__decode__Suc,axiom,
    ! [N2: nat,X2: nat] :
      ( ( member @ nat @ ( suc @ N2 ) @ ( nat_set_decode @ X2 ) )
      = ( member @ nat @ N2 @ ( nat_set_decode @ ( divide_divide @ nat @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_1005_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1006__092_060open_0621_A_092_060le_062_An_092_060close_062,axiom,
    ord_less_eq @ nat @ ( one_one @ nat ) @ na ).

% \<open>1 \<le> n\<close>
thf(fact_1007_verit__eq__simplify_I8_J,axiom,
    ! [X22: num,Y22: num] :
      ( ( ( bit0 @ X22 )
        = ( bit0 @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% verit_eq_simplify(8)
thf(fact_1008_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_1009_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N2 ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N2
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_1010_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ N2 )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N2
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_1011_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_1012_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_1013_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% div_by_1
thf(fact_1014_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% bits_div_by_1
thf(fact_1015_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N2 )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_1016_less__one,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( one_one @ nat ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_1017_diff__Suc__1,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ N2 ) @ ( one_one @ nat ) )
      = N2 ) ).

% diff_Suc_1
thf(fact_1018_set__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_1019_flip__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_1020_set__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_1021_flip__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_1022_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_1023_triangle__0,axiom,
    ( ( nat_triangle @ ( zero_zero @ nat ) )
    = ( zero_zero @ nat ) ) ).

% triangle_0
thf(fact_1024_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_1025_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_1026_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_1027_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_1028_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_1029_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_1030_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_1031_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_1032_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_1033_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_1034_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_1035_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_1036_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_1037_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_1038_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( numeral_numeral @ A @ N2 )
            = ( one_one @ A ) )
          = ( N2 = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_1039_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N2 ) )
          = ( one2 = N2 ) ) ) ).

% one_eq_numeral_iff
thf(fact_1040_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M )
              = ( power_power @ A @ A2 @ N2 ) )
            = ( M = N2 ) ) ) ) ).

% power_inject_exp
thf(fact_1041_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_1042_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_1043_mod__neg__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L2 @ K )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_1044_mod__pos__pos__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L2 )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_1045_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_1046_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_1047_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z ) ) ).

% zle_add1_eq_le
thf(fact_1048_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z ) ) ).

% zle_diff1_eq
thf(fact_1049_triangle__Suc,axiom,
    ! [N2: nat] :
      ( ( nat_triangle @ ( suc @ N2 ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N2 ) @ ( suc @ N2 ) ) ) ).

% triangle_Suc
thf(fact_1050_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_1051_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_1052_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_1053_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_1054_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_1055_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_1056_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_1057_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_1058_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_1059_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_1060_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X2: nat,Y2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X2 ) @ ( power_power @ A @ B2 @ Y2 ) )
            = ( ord_less @ nat @ X2 @ Y2 ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_1061_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_1062_Suc__diff__1,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
        = N2 ) ) ).

% Suc_diff_1
thf(fact_1063_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_1064_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N2: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N2 ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_1065_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_1066_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_1067_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_1068_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_1069_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_1070_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N2 ) )
              = ( ord_less @ nat @ N2 @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_1071_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X2: nat,Y2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X2 ) @ ( power_power @ A @ B2 @ Y2 ) )
            = ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ).

% power_increasing_iff
thf(fact_1072_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_1073_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_1074_signed__take__bit__Suc__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_1075_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N2 @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_1076_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N2 ) ) ) ) ).

% one_plus_numeral
thf(fact_1077_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N2 @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_1078_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ num @ one2 @ N2 ) ) ) ).

% one_less_numeral_iff
thf(fact_1079_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_1080_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_1081_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N2 ) )
              = ( ord_less_eq @ nat @ N2 @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_1082_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_1083_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_1084_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_1085_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_1086_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X2: A] :
          ( ( ( one_one @ A )
            = X2 )
          = ( X2
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_1087_signed__take__bit__mult,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( times_times @ int @ K @ L2 ) ) ) ).

% signed_take_bit_mult
thf(fact_1088_signed__take__bit__add,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% signed_take_bit_add
thf(fact_1089_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_1090_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_1091_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_1092_signed__take__bit__diff,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ L2 ) ) ) ).

% signed_take_bit_diff
thf(fact_1093_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_1094_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_1095_nat__mult__1,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N2 )
      = N2 ) ).

% nat_mult_1
thf(fact_1096_nat__mult__1__right,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ N2 @ ( one_one @ nat ) )
      = N2 ) ).

% nat_mult_1_right
thf(fact_1097_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_1098_set__bit__greater__eq,axiom,
    ! [K: int,N2: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) ) ).

% set_bit_greater_eq
thf(fact_1099_subset__decode__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M ) @ ( nat_set_decode @ N2 ) )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% subset_decode_imp_le
thf(fact_1100_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P4: A,M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P4 @ ( power_power @ A @ P4 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1101_verit__le__mono__div__int,axiom,
    ! [A3: int,B4: int,N2: int] :
      ( ( ord_less @ int @ A3 @ B4 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A3 @ N2 )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B4 @ N2 )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B4 @ N2 ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1102_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_1103_neg__mod__bound,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L2 @ ( modulo_modulo @ int @ K @ L2 ) ) ) ).

% neg_mod_bound
thf(fact_1104_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L2 ) @ L2 ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_1105_zmod__eq__0D,axiom,
    ! [M: int,D3: int] :
      ( ( ( modulo_modulo @ int @ M @ D3 )
        = ( zero_zero @ int ) )
     => ? [Q3: int] :
          ( M
          = ( times_times @ int @ D3 @ Q3 ) ) ) ).

% zmod_eq_0D
thf(fact_1106_zmod__eq__0__iff,axiom,
    ! [M: int,D3: int] :
      ( ( ( modulo_modulo @ int @ M @ D3 )
        = ( zero_zero @ int ) )
      = ( ? [Q4: int] :
            ( M
            = ( times_times @ int @ D3 @ Q4 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_1107_zdiv__mono__strict,axiom,
    ! [A3: int,B4: int,N2: int] :
      ( ( ord_less @ int @ A3 @ B4 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ( ( modulo_modulo @ int @ A3 @ N2 )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B4 @ N2 )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A3 @ N2 ) @ ( divide_divide @ int @ B4 @ N2 ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_1108_div__mod__decomp__int,axiom,
    ! [A3: int,N2: int] :
      ( A3
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A3 @ N2 ) @ N2 ) @ ( modulo_modulo @ int @ A3 @ N2 ) ) ) ).

% div_mod_decomp_int
thf(fact_1109_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_1110_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_1111_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_1112_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_1113_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_1114_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_1115_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% one_le_numeral
thf(fact_1116_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_1117_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N2 ) ) ) ) ) ).

% less_1_mult
thf(fact_1118_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_1119_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_1120_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_1121_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_1122_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_1123_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% one_le_power
thf(fact_1124_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X2: A,Y2: A,N2: nat] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_1125_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N2 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_one_over
thf(fact_1126_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_1127_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_1128_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_1129_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N: nat] : ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_1130_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_1131_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_1132_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N2 ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_1133_mult__eq__self__implies__10,axiom,
    ! [M: nat,N2: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N2 ) )
     => ( ( N2
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_1134_real__arch__pow,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ? [N3: nat] : ( ord_less @ real @ Y2 @ ( power_power @ real @ X2 @ N3 ) ) ) ).

% real_arch_pow
thf(fact_1135_odd__nonzero,axiom,
    ! [Z: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_1136_int__ge__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I )
     => ( ( P @ K )
       => ( ! [I4: int] :
              ( ( ord_less_eq @ int @ K @ I4 )
             => ( ( P @ I4 )
               => ( P @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_ge_induct
thf(fact_1137_int__gr__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I4: int] :
              ( ( ord_less @ int @ K @ I4 )
             => ( ( P @ I4 )
               => ( P @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_gr_induct
thf(fact_1138_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z )
        | ( W = Z ) ) ) ).

% zless_add1_eq
thf(fact_1139_int__le__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I @ K )
     => ( ( P @ K )
       => ( ! [I4: int] :
              ( ( ord_less_eq @ int @ I4 @ K )
             => ( ( P @ I4 )
               => ( P @ ( minus_minus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_le_induct
thf(fact_1140_int__less__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I4: int] :
              ( ( ord_less @ int @ I4 @ K )
             => ( ( P @ I4 )
               => ( P @ ( minus_minus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_less_induct
thf(fact_1141_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_1142_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A2 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_1143_zmod__trivial__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( modulo_modulo @ int @ I @ K )
        = I )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zmod_trivial_iff
thf(fact_1144_neg__mod__sign,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L2 ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_1145_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L2 ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_1146_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ord_less_eq @ A @ Y2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y2 @ X2 ) @ X2 ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_1147_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ord_less_eq @ A @ Y2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X2 @ Y2 ) @ X2 ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_1148_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_1149_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_1150_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_1151_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_1152_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_1153_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_1154_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1155_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1156_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_1157_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_1158_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1159_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1160_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_1161_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_1162_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_1163_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_1164_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_1165_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) ) ) ) ).

% power_gt1
thf(fact_1166_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_1167_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N5: nat,A2: A] :
          ( ( ord_less @ nat @ N2 @ N5 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ A2 @ N5 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_1168_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
           => ( ord_less @ nat @ M @ N2 ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_1169_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N5: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N2 @ N5 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ A2 @ N5 ) ) ) ) ) ).

% power_increasing
thf(fact_1170_nat__induct__non__zero,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct_non_zero
thf(fact_1171_div__eq__dividend__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N2 )
          = M )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1172_div__less__dividend,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N2 ) @ M ) ) ) ).

% div_less_dividend
thf(fact_1173_real__arch__pow__inv,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ? [N3: nat] : ( ord_less @ real @ ( power_power @ real @ X2 @ N3 ) @ Y2 ) ) ) ).

% real_arch_pow_inv
thf(fact_1174_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% int_one_le_iff_zero_less
thf(fact_1175_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N2 )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N2
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_1176_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_1177_verit__la__generic,axiom,
    ! [A2: int,X2: int] :
      ( ( ord_less_eq @ int @ A2 @ X2 )
      | ( A2 = X2 )
      | ( ord_less_eq @ int @ X2 @ A2 ) ) ).

% verit_la_generic
thf(fact_1178_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z )
      = ( ord_less @ int @ W @ Z ) ) ).

% add1_zle_eq
thf(fact_1179_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ Z )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z ) ) ).

% zless_imp_add1_zle
thf(fact_1180_int__div__less__self,axiom,
    ! [X2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X2 @ K ) @ X2 ) ) ) ).

% int_div_less_self
thf(fact_1181_int__induct,axiom,
    ! [P: int > $o,K: int,I: int] :
      ( ( P @ K )
     => ( ! [I4: int] :
            ( ( ord_less_eq @ int @ K @ I4 )
           => ( ( P @ I4 )
             => ( P @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) ) ) )
       => ( ! [I4: int] :
              ( ( ord_less_eq @ int @ I4 @ K )
             => ( ( P @ I4 )
               => ( P @ ( minus_minus @ int @ I4 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_induct
thf(fact_1182_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_1183_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_1184_mod__pos__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L2 ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = ( plus_plus @ int @ K @ L2 ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_1185_mod__pos__geq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ( ord_less_eq @ int @ L2 @ K )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L2 ) @ L2 ) ) ) ) ).

% mod_pos_geq
thf(fact_1186_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_1187_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_1188_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_1189_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_1190_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_1191_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_1192_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_1193_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_1194_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z3 )
             => ( ( ord_less @ A @ Z3 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z3 @ X2 ) @ Y2 ) ) )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% field_le_mult_one_interval
thf(fact_1195_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1196_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1197_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X2: A,A2: A,Y2: A,U: A,V: A] :
          ( ( ord_less_eq @ A @ X2 @ A2 )
         => ( ( ord_less_eq @ A @ Y2 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X2 ) @ ( times_times @ A @ V @ Y2 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_1198_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_Suc_less
thf(fact_1199_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_1200_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_1201_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N5: nat,A2: A] :
          ( ( ord_less @ nat @ N2 @ N5 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N5 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_1202_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N5: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N2 @ N5 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N5 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_decreasing
thf(fact_1203_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
           => ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_1204_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_1205_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% self_le_power
thf(fact_1206_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% one_less_power
thf(fact_1207_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_1208_Suc__diff__eq__diff__pred,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N2 )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1209_Suc__pred_H,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( N2
        = ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1210_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N ) ) ) ) ) ).

% add_eq_if
thf(fact_1211_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N ) ) ) ) ) ).

% mult_eq_if
thf(fact_1212_le__imp__0__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ).

% le_imp_0_less
thf(fact_1213_verit__le__mono__div,axiom,
    ! [A3: nat,B4: nat,N2: nat] :
      ( ( ord_less @ nat @ A3 @ B4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A3 @ N2 )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B4 @ N2 )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B4 @ N2 ) ) ) ) ).

% verit_le_mono_div
thf(fact_1214_split__zmod,axiom,
    ! [P: int > $o,N2: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N2 @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N2 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I3: int,J2: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J2 )
                & ( ord_less @ int @ J2 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J2 ) ) )
             => ( P @ J2 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I3: int,J2: int] :
              ( ( ( ord_less @ int @ K @ J2 )
                & ( ord_less_eq @ int @ J2 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J2 ) ) )
             => ( P @ J2 ) ) ) ) ) ).

% split_zmod
thf(fact_1215_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_neg_eq
thf(fact_1216_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_pos_eq
thf(fact_1217_signed__take__bit__int__less__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% signed_take_bit_int_less_exp
thf(fact_1218_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_1219_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X2: A,A2: A,Y2: A,U: A,V: A] :
          ( ( ord_less @ A @ X2 @ A2 )
         => ( ( ord_less @ A @ Y2 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X2 ) @ ( times_times @ A @ V @ Y2 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_1220_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N2 @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N2 ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N2 @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1221_nat__induct2,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct2
thf(fact_1222_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N2: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_minus_mult
thf(fact_1223_two__realpow__ge__one,axiom,
    ! [N2: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% two_realpow_ge_one
thf(fact_1224_Suc__times__mod__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N2 ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_1225_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_1226_signed__take__bit__int__less__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_1227_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N2: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N2 @ K ) @ ( modulo_modulo @ int @ N2 @ K ) )
        = ( ! [I3: int,J2: int] :
              ( ( ( ord_less @ int @ K @ J2 )
                & ( ord_less_eq @ int @ J2 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J2 ) ) )
             => ( P @ I3 @ J2 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_1228_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N2 @ K ) @ ( modulo_modulo @ int @ N2 @ K ) )
        = ( ! [I3: int,J2: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J2 )
                & ( ord_less @ int @ J2 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J2 ) ) )
             => ( P @ I3 @ J2 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_1229_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B5: B,A5: B] :
          ( ( ~ ( ord_less_eq @ B @ B5 @ A5 ) )
          = ( ord_less @ B @ A5 @ B5 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_1230_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_1231_verit__eq__simplify_I10_J,axiom,
    ! [X22: num] :
      ( one2
     != ( bit0 @ X22 ) ) ).

% verit_eq_simplify(10)
thf(fact_1232_div__pos__geq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ( ord_less_eq @ int @ L2 @ K )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L2 ) @ L2 ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1233_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A6: nat,B6: nat] :
          ( ( P @ A6 @ B6 )
          = ( P @ B6 @ A6 ) )
     => ( ! [A6: nat] : ( P @ A6 @ ( zero_zero @ nat ) )
       => ( ! [A6: nat,B6: nat] :
              ( ( P @ A6 @ B6 )
             => ( P @ A6 @ ( plus_plus @ nat @ A6 @ B6 ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_1234_signed__take__bit__int__less__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_1235_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N3: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_1236_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N3: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_1237_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_1238_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_1239_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_1240_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1241_Suc__if__eq,axiom,
    ! [A: $tType,F2: nat > A,H2: nat > A,G: A,N2: nat] :
      ( ! [N3: nat] :
          ( ( F2 @ ( suc @ N3 ) )
          = ( H2 @ N3 ) )
     => ( ( ( F2 @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( F2 @ N2 )
              = G ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( F2 @ N2 )
              = ( H2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_1242_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1243_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N: nat,A4: A] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1244_num_Osize__gen_I2_J,axiom,
    ! [X22: num] :
      ( ( size_num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_1245_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ( ord_less @ nat @ N2 @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N2 )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1246_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L2 ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L2 ) ) ) ) ).

% power_numeral
thf(fact_1247_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_1248_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) ).

% add.inverse_inverse
thf(fact_1249_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_1250_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_1251_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_1252_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_1253_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_1254_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_1255_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_1256_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_1257_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( M = N2 ) ) ) ).

% neg_numeral_eq_iff
thf(fact_1258_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_1259_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A2 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_1260_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_1261_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_1262_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_1263_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1264_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1265_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1266_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% minus_diff_eq
thf(fact_1267_div__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% div_minus_minus
thf(fact_1268_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_1269_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_1270_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_1271_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_1272_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( divide_divide @ A @ C2 @ A2 ) )
              = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_1273_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( dvd_dvd @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 )
          = ( dvd_dvd @ A @ X2 @ Y2 ) ) ) ).

% minus_dvd_iff
thf(fact_1274_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( dvd_dvd @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) )
          = ( dvd_dvd @ A @ X2 @ Y2 ) ) ) ).

% dvd_minus_iff
thf(fact_1275_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_minus_minus
thf(fact_1276_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_1277_real__add__minus__iff,axiom,
    ! [X2: real,A2: real] :
      ( ( ( plus_plus @ real @ X2 @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X2 = A2 ) ) ).

% real_add_minus_iff
thf(fact_1278_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_1279_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_1280_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_1281_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_1282_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_1283_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_1284_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_1285_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_1286_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_1287_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1288_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1289_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% diff_0
thf(fact_1290_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( minus_minus @ B @ ( zero_zero @ B ) @ B2 )
          = ( uminus_uminus @ B @ B2 ) ) ) ).

% verit_minus_simplify(3)
thf(fact_1291_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_1292_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1293_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1294_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1295_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1296_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1
thf(fact_1297_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1_right
thf(fact_1298_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1299_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1300_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A] :
          ( ( divide_divide @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X2 ) ) ) ).

% divide_minus1
thf(fact_1301_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% div_minus1_right
thf(fact_1302_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_1303_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_1304_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_1305_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_1306_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_1307_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = A2 ) ) ) ).

% unit_div_1_div_1
thf(fact_1308_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_1309_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_1310_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_1311_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_1312_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_1313_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_mod_self1
thf(fact_1314_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_1315_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_1316_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_1317_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_1318_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_1319_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_1320_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N2 = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_1321_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( N2 = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_1322_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_1323_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_1324_even__Suc__Suc__iff,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N2 ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% even_Suc_Suc_iff
thf(fact_1325_even__Suc,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% even_Suc
thf(fact_1326_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_1327_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = ( divide_divide @ A @ B2 @ A2 ) ) ) ) ).

% unit_mult_div_div
thf(fact_1328_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1329_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_1330_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(168)
thf(fact_1331_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N2 ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_1332_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N2 ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_1333_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_1334_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_1335_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_1336_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(170)
thf(fact_1337_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(171)
thf(fact_1338_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Y2 ) ) ) ).

% semiring_norm(172)
thf(fact_1339_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( ord_less_eq @ num @ N2 @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_1340_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( ord_less @ num @ N2 @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_1341_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_1342_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_1343_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_1344_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_1345_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_1346_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_1347_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_1348_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_1349_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1350_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_1351_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_1352_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_1353_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_minus_odd
thf(fact_1354_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_1355_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_mod_2_iff
thf(fact_1356_even__Suc__div__two,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_1357_odd__Suc__div__two,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_1358_set__decode__0,axiom,
    ! [X2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X2 ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X2 ) ) ) ).

% set_decode_0
thf(fact_1359_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_1360_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_1361_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_1362_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_1363_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_1364_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_1365_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_1366_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_plus_one_iff
thf(fact_1367_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% even_diff
thf(fact_1368_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_1369_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_1370_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_1371_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_1372_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_1373_odd__Suc__minus__one,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N2 ) ) ).

% odd_Suc_minus_one
thf(fact_1374_even__diff__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N2 ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ).

% even_diff_nat
thf(fact_1375_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_1376_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N2 ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_1377_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_1378_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_1379_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( ( numeral_numeral @ nat @ W )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_1380_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1381_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1382_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1383_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% even_power
thf(fact_1384_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_1385_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_1386_odd__two__times__div__two__nat,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1387_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A2 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1388_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_1389_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1390_signed__take__bit__minus,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) ) ) ).

% signed_take_bit_minus
thf(fact_1391_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_1392_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_1393_dvd__trans,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_trans
thf(fact_1394_dvd__refl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ A2 ) ) ).

% dvd_refl
thf(fact_1395_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) ).

% minus_equation_iff
thf(fact_1396_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% equation_minus_iff
thf(fact_1397_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( A4
                = ( zero_zero @ A ) )
             => ( B3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_1398_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_1399_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) ) ) ).

% dvd_triv_right
thf(fact_1400_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1401_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D3 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1402_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1403_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1404_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1405_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1406_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B3: A,A4: A] :
            ? [K3: A] :
              ( A4
              = ( times_times @ A @ B3 @ K3 ) ) ) ) ) ).

% dvd_def
thf(fact_1407_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A2: A,B2: A,K: A] :
          ( ( A2
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% dvdI
thf(fact_1408_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ~ ! [K2: A] :
                ( A2
               != ( times_times @ A @ B2 @ K2 ) ) ) ) ).

% dvdE
thf(fact_1409_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ P2 @ ( times_times @ A @ A2 @ B2 ) )
         => ~ ! [X3: A,Y3: A] :
                ( ( P2
                  = ( times_times @ A @ X3 @ Y3 ) )
               => ( ( dvd_dvd @ A @ X3 @ A2 )
                 => ~ ( dvd_dvd @ A @ Y3 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1410_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B7: A,C5: A] :
              ( ( A2
                = ( times_times @ A @ B7 @ C5 ) )
              & ( dvd_dvd @ A @ B7 @ B2 )
              & ( dvd_dvd @ A @ C5 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1411_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_1412_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% unit_imp_dvd
thf(fact_1413_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A2 ) ) ).

% one_dvd
thf(fact_1414_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_1415_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_1416_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_1417_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_1418_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_1419_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_1420_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( ( euclid5891614535332579305n_ring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% dvd_diff_commute
thf(fact_1421_dvd__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( ( dvd_dvd @ A @ X2 @ Z )
           => ( dvd_dvd @ A @ X2 @ ( minus_minus @ A @ Y2 @ Z ) ) ) ) ) ).

% dvd_diff
thf(fact_1422_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_1423_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_1424_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_1425_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D3: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ D3 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ D3 ) @ ( divide_divide @ A @ B2 @ D3 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_div_div_same
thf(fact_1426_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_1427_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( ( divide_divide @ A @ A2 @ C2 )
                = ( divide_divide @ A @ B2 @ C2 ) )
              = ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_1428_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_1429_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_1430_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: A,Y2: A,N2: nat] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( dvd_dvd @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) ) ) ) ).

% dvd_power_same
thf(fact_1431_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_1432_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A2 = B2 )
            | ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_1433_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_1434_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_1435_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_1436_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_1437_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A2 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_1438_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_1439_minus__divide__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_divide_left
thf(fact_1440_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% minus_divide_divide
thf(fact_1441_minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_divide_right
thf(fact_1442_div__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% div_minus_right
thf(fact_1443_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% gcd_nat.extremum
thf(fact_1444_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
        & ( ( zero_zero @ nat )
         != A2 ) ) ).

% gcd_nat.extremum_strict
thf(fact_1445_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_unique
thf(fact_1446_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) )
        & ( A2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.not_eq_extremum
thf(fact_1447_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_uniqueI
thf(fact_1448_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_imp_dvd
thf(fact_1449_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
            = ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_iff
thf(fact_1450_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 )
            = ( modulo_modulo @ A @ A2 @ C2 ) ) ) ) ).

% mod_mod_cancel
thf(fact_1451_dvd__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [K: A,M: A,N2: A] :
          ( ( dvd_dvd @ A @ K @ M )
         => ( ( dvd_dvd @ A @ K @ N2 )
           => ( dvd_dvd @ A @ K @ ( modulo_modulo @ A @ M @ N2 ) ) ) ) ) ).

% dvd_mod
thf(fact_1452_mod__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% mod_minus_right
thf(fact_1453_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,A5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( modulo_modulo @ A @ A5 @ B2 ) )
         => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A5 ) @ B2 ) ) ) ) ).

% mod_minus_cong
thf(fact_1454_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% mod_minus_eq
thf(fact_1455_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N2 )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% dvd_diff_nat
thf(fact_1456_uminus__int__code_I1_J,axiom,
    ( ( uminus_uminus @ int @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) ) ).

% uminus_int_code(1)
thf(fact_1457_zmod__zminus1__not__zero,axiom,
    ! [K: int,L2: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L2 )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L2 )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_1458_zmod__zminus2__not__zero,axiom,
    ! [K: int,L2: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L2 ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L2 )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_1459_zmult__eq__1__iff,axiom,
    ! [M: int,N2: int] :
      ( ( ( times_times @ int @ M @ N2 )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N2
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_1460_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N2: int] :
      ( ( ( times_times @ int @ M @ N2 )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_1461_zdvd__zdiffD,axiom,
    ! [K: int,M: int,N2: int] :
      ( ( dvd_dvd @ int @ K @ ( minus_minus @ int @ M @ N2 ) )
     => ( ( dvd_dvd @ int @ K @ N2 )
       => ( dvd_dvd @ int @ K @ M ) ) ) ).

% zdvd_zdiffD
thf(fact_1462_even__minus,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( uminus_uminus @ A @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_minus
thf(fact_1463_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( power_power @ A @ A2 @ N2 ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_1464_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_1465_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D3: B,S2: B] :
        ? [Z3: B] :
        ! [X4: B] :
          ( ( ord_less @ B @ X4 @ Z3 )
         => ( ( ~ ( dvd_dvd @ B @ D3 @ ( plus_plus @ B @ X4 @ S2 ) ) )
            = ( ~ ( dvd_dvd @ B @ D3 @ ( plus_plus @ B @ X4 @ S2 ) ) ) ) ) ) ).

% minf(10)
thf(fact_1466_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D3: B,S2: B] :
        ? [Z3: B] :
        ! [X4: B] :
          ( ( ord_less @ B @ X4 @ Z3 )
         => ( ( dvd_dvd @ B @ D3 @ ( plus_plus @ B @ X4 @ S2 ) )
            = ( dvd_dvd @ B @ D3 @ ( plus_plus @ B @ X4 @ S2 ) ) ) ) ) ).

% minf(9)
thf(fact_1467_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D3: B,S2: B] :
        ? [Z3: B] :
        ! [X4: B] :
          ( ( ord_less @ B @ Z3 @ X4 )
         => ( ( ~ ( dvd_dvd @ B @ D3 @ ( plus_plus @ B @ X4 @ S2 ) ) )
            = ( ~ ( dvd_dvd @ B @ D3 @ ( plus_plus @ B @ X4 @ S2 ) ) ) ) ) ) ).

% pinf(10)
thf(fact_1468_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D3: B,S2: B] :
        ? [Z3: B] :
        ! [X4: B] :
          ( ( ord_less @ B @ Z3 @ X4 )
         => ( ( dvd_dvd @ B @ D3 @ ( plus_plus @ B @ X4 @ S2 ) )
            = ( dvd_dvd @ B @ D3 @ ( plus_plus @ B @ X4 @ S2 ) ) ) ) ) ).

% pinf(9)
thf(fact_1469_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_1470_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A2 )
              = ( times_times @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_1471_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A2 @ B2 )
              = ( times_times @ A @ A2 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_1472_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_1473_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_1474_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_1475_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_1476_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_1477_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,D3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( dvd_dvd @ A @ D3 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( divide_divide @ A @ C2 @ D3 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1478_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1479_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1480_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1481_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1482_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1483_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_1484_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_le_numeral
thf(fact_1485_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_1486_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A2 )
              = ( divide_divide @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_1487_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_1488_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_1489_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_right
thf(fact_1490_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_left
thf(fact_1491_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_less_numeral
thf(fact_1492_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_1493_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_1494_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_1495_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_1496_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_1497_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_1498_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_1499_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_1500_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_1501_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_1502_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_1503_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X2 ) )
          = ( times_times @ A @ X2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_1504_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N2 )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% div_power
thf(fact_1505_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_1506_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_1507_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_1508_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ N2 )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_1509_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X2: A] :
          ( ( ( times_times @ A @ X2 @ X2 )
            = ( one_one @ A ) )
          = ( ( X2
              = ( one_one @ A ) )
            | ( X2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_1510_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_0_imp_dvd
thf(fact_1511_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( modulo_modulo @ A @ B3 @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_1512_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_1513_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B4: A,K: A,B2: A,A2: A] :
          ( ( B4
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B4 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1514_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1515_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1516_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% le_imp_power_dvd
thf(fact_1517_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N2 )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_1518_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: A,Y2: A,N2: nat,M: nat] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_1519_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A] : ( dvd_dvd @ A @ B2 @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% dvd_minus_mod
thf(fact_1520_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
          = ( dvd_dvd @ A @ C2 @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% mod_eq_dvd_iff
thf(fact_1521_nat__dvd__not__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N2 )
       => ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_1522_dvd__pos__nat,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( dvd_dvd @ nat @ M @ N2 )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_1523_dvd__minus__self,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N2 @ M ) )
      = ( ( ord_less @ nat @ N2 @ M )
        | ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% dvd_minus_self
thf(fact_1524_zdvd__antisym__nonneg,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
       => ( ( dvd_dvd @ int @ M @ N2 )
         => ( ( dvd_dvd @ int @ N2 @ M )
           => ( M = N2 ) ) ) ) ) ).

% zdvd_antisym_nonneg
thf(fact_1525_dvd__diffD,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) )
     => ( ( dvd_dvd @ nat @ K @ N2 )
       => ( ( ord_less_eq @ nat @ N2 @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_1526_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N2 @ M )
         => ( dvd_dvd @ nat @ K @ N2 ) ) ) ) ).

% dvd_diffD1
thf(fact_1527_less__eq__dvd__minus,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( dvd_dvd @ nat @ M @ N2 )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_1528_zdvd__not__zless,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less @ int @ M @ N2 )
       => ~ ( dvd_dvd @ int @ N2 @ M ) ) ) ).

% zdvd_not_zless
thf(fact_1529_bezout__lemma__nat,axiom,
    ! [D3: nat,A2: nat,B2: nat,X2: nat,Y2: nat] :
      ( ( dvd_dvd @ nat @ D3 @ A2 )
     => ( ( dvd_dvd @ nat @ D3 @ B2 )
       => ( ( ( ( times_times @ nat @ A2 @ X2 )
              = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ D3 ) )
            | ( ( times_times @ nat @ B2 @ X2 )
              = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y2 ) @ D3 ) ) )
         => ? [X3: nat,Y3: nat] :
              ( ( dvd_dvd @ nat @ D3 @ A2 )
              & ( dvd_dvd @ nat @ D3 @ ( plus_plus @ nat @ A2 @ B2 ) )
              & ( ( ( times_times @ nat @ A2 @ X3 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ Y3 ) @ D3 ) )
                | ( ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ X3 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ D3 ) ) ) ) ) ) ) ).

% bezout_lemma_nat
thf(fact_1530_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D5: nat,X3: nat,Y3: nat] :
      ( ( dvd_dvd @ nat @ D5 @ A2 )
      & ( dvd_dvd @ nat @ D5 @ B2 )
      & ( ( ( times_times @ nat @ A2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ D5 ) )
        | ( ( times_times @ nat @ B2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ D5 ) ) ) ) ).

% bezout_add_nat
thf(fact_1531_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M @ T2 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ T2 ) ) ) ) ).

% zdvd_mono
thf(fact_1532_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N2: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N2 ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M @ N2 ) ) ) ).

% zdvd_mult_cancel
thf(fact_1533_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D5: nat,X3: nat,Y3: nat] :
      ( ( dvd_dvd @ nat @ D5 @ A2 )
      & ( dvd_dvd @ nat @ D5 @ B2 )
      & ( ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X3 ) @ ( times_times @ nat @ B2 @ Y3 ) )
          = D5 )
        | ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X3 ) @ ( times_times @ nat @ A2 @ Y3 ) )
          = D5 ) ) ) ).

% bezout1_nat
thf(fact_1534_real__minus__mult__self__le,axiom,
    ! [U: real,X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X2 @ X2 ) ) ).

% real_minus_mult_self_le
thf(fact_1535_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X: A] : ( plus_plus @ A @ X @ X ) ) ) ) ).

% dbl_def
thf(fact_1536_zdvd__reduce,axiom,
    ! [K: int,N2: int,M: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N2 @ ( times_times @ int @ K @ M ) ) )
      = ( dvd_dvd @ int @ K @ N2 ) ) ).

% zdvd_reduce
thf(fact_1537_zdvd__period,axiom,
    ! [A2: int,D3: int,X2: int,T2: int,C2: int] :
      ( ( dvd_dvd @ int @ A2 @ D3 )
     => ( ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ X2 @ T2 ) )
        = ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ ( plus_plus @ int @ X2 @ ( times_times @ int @ C2 @ D3 ) ) @ T2 ) ) ) ) ).

% zdvd_period
thf(fact_1538_minus__int__code_I2_J,axiom,
    ! [L2: int] :
      ( ( minus_minus @ int @ ( zero_zero @ int ) @ L2 )
      = ( uminus_uminus @ int @ L2 ) ) ).

% minus_int_code(2)
thf(fact_1539_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_1540_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_1541_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X: real,Y: real] : ( plus_plus @ real @ X @ ( uminus_uminus @ real @ Y ) ) ) ) ).

% minus_real_def
thf(fact_1542_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_1543_pow_Osimps_I1_J,axiom,
    ! [X2: num] :
      ( ( pow @ X2 @ one2 )
      = X2 ) ).

% pow.simps(1)
thf(fact_1544_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C4: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C4 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1545_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L2: A] :
          ( ( ? [X: A] : ( P @ ( times_times @ A @ L2 @ X ) ) )
          = ( ? [X: A] :
                ( ( dvd_dvd @ A @ L2 @ ( plus_plus @ A @ X @ ( zero_zero @ A ) ) )
                & ( P @ X ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1546_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D3: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D3 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D3 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D3 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1547_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1548_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1549_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1550_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1551_even__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: num] : ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) ) ) ).

% even_numeral
thf(fact_1552_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D3: A,D6: A,T2: A] :
          ( ( dvd_dvd @ A @ D3 @ D6 )
         => ! [X4: A,K4: A] :
              ( ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ X4 @ T2 ) )
              = ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K4 @ D6 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1553_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D3: A,D6: A,T2: A] :
          ( ( dvd_dvd @ A @ D3 @ D6 )
         => ! [X4: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ X4 @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K4 @ D6 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1554_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_1555_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_1556_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_1557_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_1558_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_1559_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_1560_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A2 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_1561_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = C2 )
            = ( A2
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_1562_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_1563_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_1564_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_1565_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_1566_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_1567_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_1568_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_1569_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_1570_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_1571_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_1572_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_1573_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_1574_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_1575_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_1576_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_1577_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_1578_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_1579_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_1580_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_1581_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_1582_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_1583_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_1584_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_1585_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_1586_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_1587_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_1588_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_minus
thf(fact_1589_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_1590_dvd__imp__le,axiom,
    ! [K: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ nat @ K @ N2 ) ) ) ).

% dvd_imp_le
thf(fact_1591_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% dvd_mult_cancel
thf(fact_1592_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_1593_dvd__mult__cancel1,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N2 ) @ M )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1594_dvd__mult__cancel2,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N2 @ M ) @ M )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1595_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D5: nat,X3: nat,Y3: nat] :
          ( ( dvd_dvd @ nat @ D5 @ A2 )
          & ( dvd_dvd @ nat @ D5 @ B2 )
          & ( ( times_times @ nat @ A2 @ X3 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ D5 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_1596_power__dvd__imp__le,axiom,
    ! [I: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N2 ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I )
       => ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% power_dvd_imp_le
thf(fact_1597_zdvd__imp__le,axiom,
    ! [Z: int,N2: int] :
      ( ( dvd_dvd @ int @ Z @ N2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ord_less_eq @ int @ Z @ N2 ) ) ) ).

% zdvd_imp_le
thf(fact_1598_mod__int__pos__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L2 ) )
      = ( ( dvd_dvd @ int @ L2 @ K )
        | ( ( L2
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% mod_int_pos_iff
thf(fact_1599_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N2 ) )
      = ( ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_1600_real__add__less__0__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y2 @ ( uminus_uminus @ real @ X2 ) ) ) ).

% real_add_less_0_iff
thf(fact_1601_real__0__less__add__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X2 @ Y2 ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X2 ) @ Y2 ) ) ).

% real_0_less_add_iff
thf(fact_1602_real__add__le__0__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y2 @ ( uminus_uminus @ real @ X2 ) ) ) ).

% real_add_le_0_iff
thf(fact_1603_real__0__le__add__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X2 @ Y2 ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X2 ) @ Y2 ) ) ).

% real_0_le_add_iff
thf(fact_1604_mod__eq__dvd__iff__nat,axiom,
    ! [N2: nat,M: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q2 )
          = ( modulo_modulo @ nat @ N2 @ Q2 ) )
        = ( dvd_dvd @ nat @ Q2 @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_1605_minus__mod__int__eq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L2 )
        = ( minus_minus @ int @ ( minus_minus @ int @ L2 @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L2 ) ) ) ) ).

% minus_mod_int_eq
thf(fact_1606_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_1607_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_1608_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_1609_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_1610_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_1611_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1612_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1613_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B6: A] :
                  ( ( B6
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B6 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B6 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B6 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B6 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B6 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1614_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B6: A] :
                ( A2
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) ) ) ) ).

% evenE
thf(fact_1615_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1616_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_1617_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
                = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) )
              & ( ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% bit_eq_rec
thf(fact_1618_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X2: A,M: nat,N2: nat] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ X2 @ N2 ) )
            = ( ( dvd_dvd @ A @ X2 @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1619_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_1620_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_1621_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_1622_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_1623_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_1624_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_1625_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_1626_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_1627_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X2 @ Z ) ) @ Y2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X2 ) @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_1628_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_1629_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X2 @ Z ) ) @ Y2 )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X2 ) @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_1630_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_1631_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_1632_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat,X2: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            | ( X2
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X2 @ ( power_power @ A @ X2 @ N2 ) ) ) ) ).

% dvd_power
thf(fact_1633_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X2 = Y2 )
            | ( X2
              = ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% power2_eq_iff
thf(fact_1634_div2__even__ext__nat,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( ( divide_divide @ nat @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X2 )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y2 ) )
       => ( X2 = Y2 ) ) ) ).

% div2_even_ext_nat
thf(fact_1635_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_signed_take_bit_iff
thf(fact_1636_even__even__mod__4__iff,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_1637_dvd__minus__add,axiom,
    ! [Q2: nat,N2: nat,R: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q2 @ N2 )
     => ( ( ord_less_eq @ nat @ Q2 @ ( times_times @ nat @ R @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N2 @ Q2 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N2 @ ( minus_minus @ nat @ ( times_times @ nat @ R @ M ) @ Q2 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_1638_mod__nat__eqI,axiom,
    ! [R: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ R @ N2 )
     => ( ( ord_less_eq @ nat @ R @ M )
       => ( ( dvd_dvd @ nat @ N2 @ ( minus_minus @ nat @ M @ R ) )
         => ( ( modulo_modulo @ nat @ M @ N2 )
            = R ) ) ) ) ).

% mod_nat_eqI
thf(fact_1639_verit__less__mono__div__int2,axiom,
    ! [A3: int,B4: int,N2: int] :
      ( ( ord_less_eq @ int @ A3 @ B4 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N2 ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B4 @ N2 ) @ ( divide_divide @ int @ A3 @ N2 ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_1640_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A2 ) ) ) ).

% even_two_times_div_two
thf(fact_1641_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_1642_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_1643_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_1644_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_1645_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_1646_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_1647_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_1648_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_1649_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_1650_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_1651_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono_odd
thf(fact_1652_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_1653_odd__pos,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% odd_pos
thf(fact_1654_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N2 ) )
        = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% dvd_power_iff_le
thf(fact_1655_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N2 @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_1656_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_1657_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_1658_realpow__square__minus__le,axiom,
    ! [U: real,X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_1659_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_1660_even__diff__iff,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L2 ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% even_diff_iff
thf(fact_1661_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_1662_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_1663_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_1664_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_1665_minus__1__div__exp__eq__int,axiom,
    ! [N2: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_1666_div__pos__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L2 ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_1667_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B6: A] :
                ( A2
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1668_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1669_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1670_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_1671_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_1672_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_le_even_power
thf(fact_1673_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_1674_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_1675_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_1676_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% minus_power_mult_self
thf(fact_1677_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K2: int] :
              ( ( P @ K2 )
             => ( ( K2
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K2: int] :
                ( ( P @ K2 )
               => ( ( K2
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_1678_signed__take__bit__int__eq__self,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_1679_signed__take__bit__int__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_1680_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( N2
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_1681_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_1682_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% even_mask_div_iff'
thf(fact_1683_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_1684_even__mod__4__div__2,axiom,
    ! [N2: nat] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_1685_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_1686_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ).

% even_mask_div_iff
thf(fact_1687_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% compl_less_compl_iff
thf(fact_1688_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% compl_le_compl_iff
thf(fact_1689_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_1690_concat__bit__Suc,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_concat_bit @ ( suc @ N2 ) @ K @ L2 )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N2 @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L2 ) ) ) ) ).

% concat_bit_Suc
thf(fact_1691_semiring__norm_I90_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N2 ) )
      = ( M = N2 ) ) ).

% semiring_norm(90)
thf(fact_1692_semiring__norm_I89_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N2 ) ) ).

% semiring_norm(89)
thf(fact_1693_semiring__norm_I88_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N2 ) ) ).

% semiring_norm(88)
thf(fact_1694_semiring__norm_I86_J,axiom,
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) ).

% semiring_norm(86)
thf(fact_1695_semiring__norm_I84_J,axiom,
    ! [N2: num] :
      ( one2
     != ( bit1 @ N2 ) ) ).

% semiring_norm(84)
thf(fact_1696_concat__bit__0,axiom,
    ! [K: int,L2: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L2 )
      = L2 ) ).

% concat_bit_0
thf(fact_1697_semiring__norm_I80_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(80)
thf(fact_1698_semiring__norm_I73_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(73)
thf(fact_1699_semiring__norm_I7_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N2 ) ) ) ).

% semiring_norm(7)
thf(fact_1700_semiring__norm_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N2 ) ) ) ).

% semiring_norm(9)
thf(fact_1701_semiring__norm_I14_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N2 ) ) ) ) ).

% semiring_norm(14)
thf(fact_1702_semiring__norm_I15_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N2 ) ) ) ).

% semiring_norm(15)
thf(fact_1703_semiring__norm_I81_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(81)
thf(fact_1704_semiring__norm_I72_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(72)
thf(fact_1705_semiring__norm_I77_J,axiom,
    ! [N2: num] : ( ord_less @ num @ one2 @ ( bit1 @ N2 ) ) ).

% semiring_norm(77)
thf(fact_1706_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_1707_concat__bit__nonnegative__iff,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N2 @ K @ L2 ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ).

% concat_bit_nonnegative_iff
thf(fact_1708_concat__bit__negative__iff,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N2 @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_1709_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit1
thf(fact_1710_semiring__norm_I10_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N2 ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_1711_semiring__norm_I8_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_1712_semiring__norm_I5_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% semiring_norm(5)
thf(fact_1713_semiring__norm_I4_J,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ N2 @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_1714_semiring__norm_I3_J,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N2 ) )
      = ( bit1 @ N2 ) ) ).

% semiring_norm(3)
thf(fact_1715_semiring__norm_I16_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N2 ) @ ( bit0 @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_1716_semiring__norm_I79_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(79)
thf(fact_1717_semiring__norm_I74_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(74)
thf(fact_1718_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N2: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N2 ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_1719_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_1720_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( suc @ ( suc @ N2 ) ) ) )
      = ( modulo_modulo @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_1721_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_1722_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_1723_signed__take__bit__Suc__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_1724_dvd__antisym,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ M @ N2 )
     => ( ( dvd_dvd @ nat @ N2 @ M )
       => ( M = N2 ) ) ) ).

% dvd_antisym
thf(fact_1725_uminus__dvd__conv_I1_J,axiom,
    ( ( dvd_dvd @ int )
    = ( ^ [D2: int] : ( dvd_dvd @ int @ ( uminus_uminus @ int @ D2 ) ) ) ) ).

% uminus_dvd_conv(1)
thf(fact_1726_uminus__dvd__conv_I2_J,axiom,
    ( ( dvd_dvd @ int )
    = ( ^ [D2: int,T3: int] : ( dvd_dvd @ int @ D2 @ ( uminus_uminus @ int @ T3 ) ) ) ) ).

% uminus_dvd_conv(2)
thf(fact_1727_verit__eq__simplify_I14_J,axiom,
    ! [X22: num,X32: num] :
      ( ( bit0 @ X22 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_1728_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_1729_concat__bit__assoc,axiom,
    ! [N2: nat,K: int,M: nat,L2: int,R: int] :
      ( ( bit_concat_bit @ N2 @ K @ ( bit_concat_bit @ M @ L2 @ R ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M @ N2 ) @ ( bit_concat_bit @ N2 @ K @ L2 ) @ R ) ) ).

% concat_bit_assoc
thf(fact_1730_num_Oexhaust,axiom,
    ! [Y2: num] :
      ( ( Y2 != one2 )
     => ( ! [X23: num] :
            ( Y2
           != ( bit0 @ X23 ) )
       => ~ ! [X33: num] :
              ( Y2
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_1731_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N2 ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_1732_eval__nat__numeral_I3_J,axiom,
    ! [N2: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N2 ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N2 ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_1733_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(13)
thf(fact_1734_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(12)
thf(fact_1735_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(10)
thf(fact_1736_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_1737_bounded__Max__nat,axiom,
    ! [P: nat > $o,X2: nat,M7: nat] :
      ( ( P @ X2 )
     => ( ! [X3: nat] :
            ( ( P @ X3 )
           => ( ord_less_eq @ nat @ X3 @ M7 ) )
       => ~ ! [M4: nat] :
              ( ( P @ M4 )
             => ~ ! [X4: nat] :
                    ( ( P @ X4 )
                   => ( ord_less_eq @ nat @ X4 @ M4 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_1738_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% numeral_Bit1_div_2
thf(fact_1739_odd__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) ) ) ).

% odd_numeral
thf(fact_1740_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_1741_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_1742_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_1743_Suc3__eq__add__3,axiom,
    ! [N2: nat] :
      ( ( suc @ ( suc @ ( suc @ N2 ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ).

% Suc3_eq_add_3
thf(fact_1744_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_1745_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_1746_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_1747_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N2: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N2 )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N2 ) ) ).

% Suc_div_eq_add3_div
thf(fact_1748_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N2 ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_1749_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y2 ) @ X2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) ) ) ).

% compl_le_swap2
thf(fact_1750_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ ( uminus_uminus @ A @ X2 ) )
         => ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% compl_le_swap1
thf(fact_1751_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y2 ) @ ( uminus_uminus @ A @ X2 ) ) ) ) ).

% compl_mono
thf(fact_1752_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ ( uminus_uminus @ A @ X2 ) )
         => ( ord_less @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% compl_less_swap1
thf(fact_1753_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y2 ) @ X2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) ) ) ).

% compl_less_swap2
thf(fact_1754_odd__mod__4__div__2,axiom,
    ! [N2: nat] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_1755_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_1756_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_1757_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_1758_signed__take__bit__numeral__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_1759_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_1760_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1761_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_1762_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_1763_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_1764_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_1765_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_1766_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_1767_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_1768_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_1769_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_1770_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_1771_Suc__0__mod__eq,axiom,
    ! [N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( zero_neq_one_of_bool @ nat
        @ ( N2
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_1772_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_1773_Suc__eq__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ( suc @ N2 )
        = ( numeral_numeral @ nat @ K ) )
      = ( N2
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_1774_eq__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N2 ) )
      = ( ( pred_numeral @ K )
        = N2 ) ) ).

% eq_numeral_Suc
thf(fact_1775_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_1776_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_1777_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_1778_less__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_1779_less__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% less_numeral_Suc
thf(fact_1780_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_1781_le__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% le_numeral_Suc
thf(fact_1782_le__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_1783_diff__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_1784_diff__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% diff_numeral_Suc
thf(fact_1785_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_1786_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_1787_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_1788_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [P2: $o] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_neq_one_of_bool @ A @ P2 ) ) )
          = P2 ) ) ).

% odd_of_bool_self
thf(fact_1789_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_1790_signed__take__bit__numeral__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_1791_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_1792_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_1793_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_1794_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_1795_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P2: $o,Q2: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P2 )
            = ( zero_neq_one_of_bool @ A @ Q2 ) )
          = ( P2 = Q2 ) ) ) ).

% of_bool_eq_iff
thf(fact_1796_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_1797_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_1798_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_1799_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P4: $o] : ( if @ A @ P4 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_1800_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P2: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P2 ) )
          = ( ( P2
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P2
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_1801_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P2: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P2 ) )
          = ( ~ ( ( P2
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P2
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_1802_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K3: num] : ( suc @ ( pred_numeral @ K3 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_1803_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K3: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K3 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_1804_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X: A] : ( plus_plus @ A @ ( plus_plus @ A @ X @ X ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_1805_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( zero_neq_one_of_bool @ A
            @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_bool_odd_eq_mod_2
thf(fact_1806_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [A6: A] :
              ( ( ( divide_divide @ A @ A6 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A6 )
             => ( P @ A6 ) )
         => ( ! [A6: A,B6: $o] :
                ( ( P @ A6 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A6 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A6 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A6 ) ) ) ) )
           => ( P @ A2 ) ) ) ) ).

% bits_induct
thf(fact_1807_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X: A] : ( minus_minus @ A @ ( plus_plus @ A @ X @ X ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_1808_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_1809_eq__diff__eq_H,axiom,
    ! [X2: real,Y2: real,Z: real] :
      ( ( X2
        = ( minus_minus @ real @ Y2 @ Z ) )
      = ( Y2
        = ( plus_plus @ real @ X2 @ Z ) ) ) ).

% eq_diff_eq'
thf(fact_1810_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N2 @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_1811_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N2 ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N2 ) ) ) ) ) ) ).

% mask_numeral
thf(fact_1812_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A4: A] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_1813_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L: int] :
          ( if @ int
          @ ( ( K3
              = ( zero_zero @ int ) )
            | ( L
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L
            @ ( if @ int
              @ ( L
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K3
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_1814_exp__lower__Taylor__quadratic,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( divide_divide @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X2 ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_1815_sqrt__sum__squares__half__less,axiom,
    ! [X2: real,U: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_1816_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N2: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_1817_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_1818_of__int__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: int,Z: int] :
          ( ( ( ring_1_of_int @ A @ W )
            = ( ring_1_of_int @ A @ Z ) )
          = ( W = Z ) ) ) ).

% of_int_eq_iff
thf(fact_1819_and_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ A2 )
          = A2 ) ) ).

% and.idem
thf(fact_1820_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.left_idem
thf(fact_1821_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.right_idem
thf(fact_1822_real__sqrt__eq__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( sqrt @ X2 )
        = ( sqrt @ Y2 ) )
      = ( X2 = Y2 ) ) ).

% real_sqrt_eq_iff
thf(fact_1823_mask__nat__positive__iff,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% mask_nat_positive_iff
thf(fact_1824_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_1825_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_1826_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_1827_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X2 )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_1828_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_1829_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_1830_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X2: real] :
      ( ( ( sqrt @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_1831_real__sqrt__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% real_sqrt_less_iff
thf(fact_1832_real__sqrt__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% real_sqrt_le_iff
thf(fact_1833_real__sqrt__eq__1__iff,axiom,
    ! [X2: real] :
      ( ( ( sqrt @ X2 )
        = ( one_one @ real ) )
      = ( X2
        = ( one_one @ real ) ) ) ).

% real_sqrt_eq_1_iff
thf(fact_1834_real__sqrt__one,axiom,
    ( ( sqrt @ ( one_one @ real ) )
    = ( one_one @ real ) ) ).

% real_sqrt_one
thf(fact_1835_take__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_and
thf(fact_1836_of__int__of__bool,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( ring_1_of_int @ A @ ( zero_neq_one_of_bool @ int @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_int_of_bool
thf(fact_1837_concat__bit__of__zero__2,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_concat_bit @ N2 @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_1838_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( zero_zero @ A ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_eq_0_iff
thf(fact_1839_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( zero_zero @ A )
            = ( ring_1_of_int @ A @ Z ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_0_eq_iff
thf(fact_1840_of__int__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( zero_zero @ int ) )
        = ( zero_zero @ A ) ) ) ).

% of_int_0
thf(fact_1841_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_1842_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_1843_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X2 ) ) ).

% bit.conj_one_right
thf(fact_1844_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A2 ) ) ).

% and.right_neutral
thf(fact_1845_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A2 )
          = A2 ) ) ).

% and.left_neutral
thf(fact_1846_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_1847_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int,N2: num] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( numeral_numeral @ A @ N2 ) )
          = ( Z
            = ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_1848_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% of_int_le_iff
thf(fact_1849_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_1850_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ W @ Z ) ) ) ).

% of_int_less_iff
thf(fact_1851_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_1852_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( one_one @ A ) )
          = ( Z
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_1853_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_mult
thf(fact_1854_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W @ Z ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_add
thf(fact_1855_of__int__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ Z ) )
          = ( uminus_uminus @ A @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_minus
thf(fact_1856_real__sqrt__lt__0__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( sqrt @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_1857_real__sqrt__gt__0__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y2 ) ) ).

% real_sqrt_gt_0_iff
thf(fact_1858_real__sqrt__ge__0__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 ) ) ).

% real_sqrt_ge_0_iff
thf(fact_1859_real__sqrt__le__0__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_1860_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_1861_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N2 )
            = ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_1862_of__int__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( minus_minus @ int @ W @ Z ) )
          = ( minus_minus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_diff
thf(fact_1863_real__sqrt__gt__1__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y2 ) ) ).

% real_sqrt_gt_1_iff
thf(fact_1864_real__sqrt__lt__1__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( sqrt @ X2 ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_1865_real__sqrt__le__1__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_1866_real__sqrt__ge__1__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 ) ) ).

% real_sqrt_ge_1_iff
thf(fact_1867_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int,N2: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z @ N2 ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z ) @ N2 ) ) ) ).

% of_int_power
thf(fact_1868_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W: nat,X2: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W )
            = ( ring_1_of_int @ A @ X2 ) )
          = ( ( power_power @ int @ B2 @ W )
            = X2 ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_1869_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X2: int,B2: int,W: nat] :
          ( ( ( ring_1_of_int @ A @ X2 )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( X2
            = ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_1870_and__nonnegative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% and_nonnegative_int_iff
thf(fact_1871_and__negative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_1872_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_1873_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_1874_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_1875_real__sqrt__four,axiom,
    ( ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% real_sqrt_four
thf(fact_1876_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_1877_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_1878_take__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% take_bit_of_Suc_0
thf(fact_1879_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_1880_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_1881_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(3)
thf(fact_1882_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_le_iff
thf(fact_1883_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_1884_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_less_iff
thf(fact_1885_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_1886_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N2: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less_eq @ int @ Z @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_1887_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,Z: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N2 ) @ Z ) ) ) ).

% of_int_numeral_le_iff
thf(fact_1888_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,Z: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N2 ) @ Z ) ) ) ).

% of_int_numeral_less_iff
thf(fact_1889_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N2: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ int @ Z @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_1890_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_1891_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_le_iff
thf(fact_1892_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_less_iff
thf(fact_1893_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_1894_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% take_bit_of_1
thf(fact_1895_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X2: num,N2: nat,Y2: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 )
            = ( ring_1_of_int @ A @ Y2 ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 )
            = Y2 ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_1896_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y2: int,X2: num,N2: nat] :
          ( ( ( ring_1_of_int @ A @ Y2 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( Y2
            = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_1897_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W ) @ X2 ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_1898_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: int,B2: int,W: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X2 ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ int @ X2 @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_1899_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: int,B2: int,W: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X2 ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less @ int @ X2 @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_1900_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X2 ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W ) @ X2 ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_1901_and__minus__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_1902_and__minus__numerals_I6_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_1903_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(6)
thf(fact_1904_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(4)
thf(fact_1905_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( ( N2
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_1906_and__minus__numerals_I5_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_1907_and__minus__numerals_I1_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_1908_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_1909_real__sqrt__pow2,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( power_power @ real @ ( sqrt @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X2 ) ) ).

% real_sqrt_pow2
thf(fact_1910_real__sqrt__pow2__iff,axiom,
    ! [X2: real] :
      ( ( ( power_power @ real @ ( sqrt @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X2 )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% real_sqrt_pow2_iff
thf(fact_1911_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N2: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_1912_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_1913_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N2: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_1914_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_1915_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X2: real,Y2: real,Xa: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_1916_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y2: int,X2: num,N2: nat] :
          ( ( ( ring_1_of_int @ A @ Y2 )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) )
          = ( Y2
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_1917_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X2: num,N2: nat,Y2: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 )
            = ( ring_1_of_int @ A @ Y2 ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 )
            = Y2 ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_1918_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_1919_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N2 @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_of_exp
thf(fact_1920_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_1921_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N2: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_1922_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_1923_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L2: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) ) ) ).

% of_int_and_eq
thf(fact_1924_and_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.assoc
thf(fact_1925_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( ring_1_of_int @ A @ ( bit_se2239418461657761734s_mask @ int @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% of_int_mask_eq
thf(fact_1926_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: int] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_of_int
thf(fact_1927_and_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A4: A,B3: A] : ( bit_se5824344872417868541ns_and @ A @ B3 @ A4 ) ) ) ) ).

% and.commute
thf(fact_1928_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ B2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ C2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.left_commute
thf(fact_1929_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% take_bit_eq_mask
thf(fact_1930_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_1931_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_1932_take__bit__nat__less__eq__self,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_1933_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q2 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ Q2 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_1934_real__sqrt__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ( ord_less @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_less_mono
thf(fact_1935_real__sqrt__le__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ Y2 )
     => ( ord_less_eq @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_le_mono
thf(fact_1936_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: int,Y2: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X2 ) @ Y2 )
          = ( times_times @ A @ Y2 @ ( ring_1_of_int @ A @ X2 ) ) ) ) ).

% mult_of_int_commute
thf(fact_1937_real__sqrt__divide,axiom,
    ! [X2: real,Y2: real] :
      ( ( sqrt @ ( divide_divide @ real @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_divide
thf(fact_1938_real__sqrt__mult,axiom,
    ! [X2: real,Y2: real] :
      ( ( sqrt @ ( times_times @ real @ X2 @ Y2 ) )
      = ( times_times @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_mult
thf(fact_1939_real__sqrt__power,axiom,
    ! [X2: real,K: nat] :
      ( ( sqrt @ ( power_power @ real @ X2 @ K ) )
      = ( power_power @ real @ ( sqrt @ X2 ) @ K ) ) ).

% real_sqrt_power
thf(fact_1940_real__sqrt__minus,axiom,
    ! [X2: real] :
      ( ( sqrt @ ( uminus_uminus @ real @ X2 ) )
      = ( uminus_uminus @ real @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_minus
thf(fact_1941_take__bit__minus,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) ) ) ).

% take_bit_minus
thf(fact_1942_take__bit__mult,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( times_times @ int @ K @ L2 ) ) ) ).

% take_bit_mult
thf(fact_1943_take__bit__diff,axiom,
    ! [N2: nat,K: int,L2: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ L2 ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ L2 ) ) ) ).

% take_bit_diff
thf(fact_1944_concat__bit__eq__iff,axiom,
    ! [N2: nat,K: int,L2: int,R: int,S2: int] :
      ( ( ( bit_concat_bit @ N2 @ K @ L2 )
        = ( bit_concat_bit @ N2 @ R @ S2 ) )
      = ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
          = ( bit_se2584673776208193580ke_bit @ int @ N2 @ R ) )
        & ( L2 = S2 ) ) ) ).

% concat_bit_eq_iff
thf(fact_1945_concat__bit__take__bit__eq,axiom,
    ! [N2: nat,B2: int] :
      ( ( bit_concat_bit @ N2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ B2 ) )
      = ( bit_concat_bit @ N2 @ B2 ) ) ).

% concat_bit_take_bit_eq
thf(fact_1946_less__eq__mask,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ).

% less_eq_mask
thf(fact_1947_take__bit__eq__mask__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_1948_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_1949_real__sqrt__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_gt_zero
thf(fact_1950_real__sqrt__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_ge_zero
thf(fact_1951_real__sqrt__eq__zero__cancel,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( sqrt @ X2 )
          = ( zero_zero @ real ) )
       => ( X2
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_1952_real__sqrt__ge__one,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_ge_one
thf(fact_1953_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N2: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_1954_AND__lower,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) ) ) ).

% AND_lower
thf(fact_1955_AND__upper1,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ X2 ) ) ).

% AND_upper1
thf(fact_1956_AND__upper2,axiom,
    ! [Y2: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ Y2 ) ) ).

% AND_upper2
thf(fact_1957_AND__upper1_H,axiom,
    ! [Y2: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less_eq @ int @ Y2 @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y2 @ Ya ) @ Z ) ) ) ).

% AND_upper1'
thf(fact_1958_AND__upper2_H,axiom,
    ! [Y2: int,Z: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less_eq @ int @ Y2 @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ Z ) ) ) ).

% AND_upper2'
thf(fact_1959_take__bit__nonnegative,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ).

% take_bit_nonnegative
thf(fact_1960_take__bit__int__less__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_1961_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N2 @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_1962_not__take__bit__negative,axiom,
    ! [N2: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_1963_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_1964_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N2 @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_1965_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_1966_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_1967_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_1968_mask__nonnegative__int,axiom,
    ! [N2: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N2 ) ) ).

% mask_nonnegative_int
thf(fact_1969_not__mask__negative__int,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N2 ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_1970_real__div__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( divide_divide @ real @ X2 @ ( sqrt @ X2 ) )
        = ( sqrt @ X2 ) ) ) ).

% real_div_sqrt
thf(fact_1971_sqrt__add__le__add__sqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X2 @ Y2 ) ) @ ( plus_plus @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_1972_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_1973_le__real__sqrt__sumsq,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X2 @ X2 ) @ ( times_times @ real @ Y2 @ Y2 ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_1974_and__less__eq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) @ K ) ) ).

% and_less_eq
thf(fact_1975_AND__upper1_H_H,axiom,
    ! [Y2: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less @ int @ Y2 @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y2 @ Ya ) @ Z ) ) ) ).

% AND_upper1''
thf(fact_1976_AND__upper2_H_H,axiom,
    ! [Y2: int,Z: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less @ int @ Y2 @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ Z ) ) ) ).

% AND_upper2''
thf(fact_1977_take__bit__decr__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_1978_real__of__int__div4,axiom,
    ! [N2: int,X2: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X2 ) ) ) ).

% real_of_int_div4
thf(fact_1979_real__of__int__div,axiom,
    ! [D3: int,N2: int] :
      ( ( dvd_dvd @ int @ D3 @ N2 )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ D3 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ D3 ) ) ) ) ).

% real_of_int_div
thf(fact_1980_less__mask,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ N2 @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ) ).

% less_mask
thf(fact_1981_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_1982_even__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_and_iff
thf(fact_1983_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_1984_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_nonneg
thf(fact_1985_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_pos
thf(fact_1986_even__and__iff__int,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) )
      = ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
        | ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) ).

% even_and_iff_int
thf(fact_1987_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_1988_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N: int,M3: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_1989_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N: int,M3: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M3 ) ) ) ) ).

% int_less_real_le
thf(fact_1990_real__of__int__div__aux,axiom,
    ! [X2: int,D3: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X2 ) @ ( ring_1_of_int @ real @ D3 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X2 @ D3 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X2 @ D3 ) ) @ ( ring_1_of_int @ real @ D3 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_1991_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_1992_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A4: A] : ( modulo_modulo @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_1993_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_1994_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_1995_take__bit__nat__eq__self,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M )
        = M ) ) ).

% take_bit_nat_eq_self
thf(fact_1996_take__bit__nat__less__exp,axiom,
    ! [N2: nat,M: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% take_bit_nat_less_exp
thf(fact_1997_take__bit__nat__eq__self__iff,axiom,
    ! [N2: nat,M: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M )
        = M )
      = ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_1998_real__less__rsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 )
     => ( ord_less @ real @ X2 @ ( sqrt @ Y2 ) ) ) ).

% real_less_rsqrt
thf(fact_1999_sqrt__le__D,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ Y2 )
     => ( ord_less_eq @ real @ X2 @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_2000_real__le__rsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 )
     => ( ord_less_eq @ real @ X2 @ ( sqrt @ Y2 ) ) ) ).

% real_le_rsqrt
thf(fact_2001_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N: nat,M3: nat] : ( modulo_modulo @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_nat_def
thf(fact_2002_take__bit__int__less__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% take_bit_int_less_exp
thf(fact_2003_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N: nat,K3: int] : ( modulo_modulo @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_def
thf(fact_2004_real__of__int__div2,axiom,
    ! [N2: int,X2: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X2 ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X2 ) ) ) ) ).

% real_of_int_div2
thf(fact_2005_real__of__int__div3,axiom,
    ! [N2: int,X2: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X2 ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X2 ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_2006_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_2007_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_2008_take__bit__nat__less__self__iff,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_2009_real__le__lsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ X2 @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X2 ) @ Y2 ) ) ) ) ).

% real_le_lsqrt
thf(fact_2010_real__sqrt__unique,axiom,
    ! [Y2: real,X2: real] :
      ( ( ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( sqrt @ X2 )
          = Y2 ) ) ) ).

% real_sqrt_unique
thf(fact_2011_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_2012_Suc__mask__eq__exp,axiom,
    ! [N2: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% Suc_mask_eq_exp
thf(fact_2013_mask__nat__less__exp,axiom,
    ! [N2: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% mask_nat_less_exp
thf(fact_2014_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X2 )
     => ( Y2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_2015_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y2 )
     => ( X2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_2016_real__sqrt__sum__squares__ge1,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_2017_real__sqrt__sum__squares__ge2,axiom,
    ! [Y2: real,X2: real] : ( ord_less_eq @ real @ Y2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_2018_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D3: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_2019_take__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_2020_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ K ) )
          = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_of_int_iff
thf(fact_2021_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_2022_take__bit__int__less__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_2023_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_2024_real__less__lsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ X2 @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X2 ) @ Y2 ) ) ) ) ).

% real_less_lsqrt
thf(fact_2025_sqrt__sum__squares__le__sum,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X2 @ Y2 ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_2026_sqrt__even__pow2,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N2 ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_2027_take__bit__int__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_2028_take__bit__int__eq__self,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_2029_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_2030_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_2031_take__bit__numeral__minus__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_2032_mask__half__int,axiom,
    ! [N2: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N2 ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_2033_take__bit__incr__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_2034_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_2035_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_2036_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_2037_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_2038_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_2039_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_2040_real__sqrt__power__even,axiom,
    ! [N2: nat,X2: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( power_power @ real @ ( sqrt @ X2 ) @ N2 )
          = ( power_power @ real @ X2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_2041_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X2: real,Y2: real,Xa: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_2042_arith__geo__mean__sqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X2 @ Y2 ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_2043_take__bit__int__less__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_2044_take__bit__int__greater__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_2045_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( plus_plus @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_2046_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_2047_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_2048_take__bit__minus__small__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_2049_exp__le__one__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_2050_one__le__exp__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% one_le_exp_iff
thf(fact_2051_exp__less__one__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( exp @ real @ X2 ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_2052_one__less__exp__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% one_less_exp_iff
thf(fact_2053_real__exp__bound__lemma,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_2054_exp__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_2055_arsinh__real__aux,axiom,
    ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_2056_exp__less__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% exp_less_cancel_iff
thf(fact_2057_exp__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ( ord_less @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) ) ) ).

% exp_less_mono
thf(fact_2058_exp__le__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% exp_le_cancel_iff
thf(fact_2059_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_2060_exp__eq__one__iff,axiom,
    ! [X2: real] :
      ( ( ( exp @ real @ X2 )
        = ( one_one @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_2061_and__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_2062_and__nat__numerals_I3_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_2063_and__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_2064_and__nat__numerals_I4_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_2065_and__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_2066_Suc__0__and__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_2067_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( exp @ A @ X2 )
         != ( zero_zero @ A ) ) ) ).

% exp_not_eq_zero
thf(fact_2068_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [A3: A] :
          ( ( times_times @ A @ ( exp @ A @ A3 ) @ A3 )
          = ( times_times @ A @ A3 @ ( exp @ A @ A3 ) ) ) ) ).

% exp_times_arg_commute
thf(fact_2069_exp__less__cancel,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) )
     => ( ord_less @ real @ X2 @ Y2 ) ) ).

% exp_less_cancel
thf(fact_2070_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( ( M3
              = ( zero_zero @ nat ) )
            | ( N
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_2071_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_2072_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( times_times @ A @ Y2 @ X2 ) )
         => ( ( exp @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
            = ( times_times @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ Y2 ) ) ) ) ) ).

% exp_add_commuting
thf(fact_2073_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( times_times @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ Y2 ) )
          = ( exp @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% mult_exp_exp
thf(fact_2074_exp__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( exp @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( divide_divide @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ Y2 ) ) ) ) ).

% exp_diff
thf(fact_2075_exp__total,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X3: real] :
          ( ( exp @ real @ X3 )
          = Y2 ) ) ).

% exp_total
thf(fact_2076_exp__gt__zero,axiom,
    ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( exp @ real @ X2 ) ) ).

% exp_gt_zero
thf(fact_2077_not__exp__less__zero,axiom,
    ! [X2: real] :
      ~ ( ord_less @ real @ ( exp @ real @ X2 ) @ ( zero_zero @ real ) ) ).

% not_exp_less_zero
thf(fact_2078_exp__ge__zero,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X2 ) ) ).

% exp_ge_zero
thf(fact_2079_not__exp__le__zero,axiom,
    ! [X2: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_2080_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( times_times @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) )
          = ( one_one @ A ) ) ) ).

% exp_minus_inverse
thf(fact_2081_exp__gt__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X2 ) ) ) ).

% exp_gt_one
thf(fact_2082_exp__ge__add__one__self,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( exp @ real @ X2 ) ) ).

% exp_ge_add_one_self
thf(fact_2083_exp__ge__add__one__self__aux,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( exp @ real @ X2 ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_2084_lemma__exp__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less_eq @ real @ X3 @ ( minus_minus @ real @ Y2 @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X3 )
            = Y2 ) ) ) ).

% lemma_exp_total
thf(fact_2085_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_2086_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) )
          = ( power_power @ A @ ( exp @ A @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_2087_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_2088_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_2089_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z3 ) @ X2 )
          & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z3 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_2090_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [X3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X3 ) @ X2 )
          & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X3 @ ( one_one @ int ) ) ) )
          & ! [Y4: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y4 ) @ X2 )
                & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y4 @ ( one_one @ int ) ) ) ) )
             => ( Y4 = X3 ) ) ) ) ).

% floor_exists1
thf(fact_2091_take__bit__numeral__minus__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_2092_arsinh__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arsinh_0
thf(fact_2093_artanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% artanh_0
thf(fact_2094_take__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_2095_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_2096_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_2097_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_2098_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_2099_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_2100_num__induct,axiom,
    ! [P: num > $o,X2: num] :
      ( ( P @ one2 )
     => ( ! [X3: num] :
            ( ( P @ X3 )
           => ( P @ ( inc @ X3 ) ) )
       => ( P @ X2 ) ) ) ).

% num_induct
thf(fact_2101_add__inc,axiom,
    ! [X2: num,Y2: num] :
      ( ( plus_plus @ num @ X2 @ ( inc @ Y2 ) )
      = ( inc @ ( plus_plus @ num @ X2 @ Y2 ) ) ) ).

% add_inc
thf(fact_2102_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_2103_inc_Osimps_I3_J,axiom,
    ! [X2: num] :
      ( ( inc @ ( bit1 @ X2 ) )
      = ( bit0 @ ( inc @ X2 ) ) ) ).

% inc.simps(3)
thf(fact_2104_inc_Osimps_I2_J,axiom,
    ! [X2: num] :
      ( ( inc @ ( bit0 @ X2 ) )
      = ( bit1 @ X2 ) ) ).

% inc.simps(2)
thf(fact_2105_add__One,axiom,
    ! [X2: num] :
      ( ( plus_plus @ num @ X2 @ one2 )
      = ( inc @ X2 ) ) ).

% add_One
thf(fact_2106_mult__inc,axiom,
    ! [X2: num,Y2: num] :
      ( ( times_times @ num @ X2 @ ( inc @ Y2 ) )
      = ( plus_plus @ num @ ( times_times @ num @ X2 @ Y2 ) @ X2 ) ) ).

% mult_inc
thf(fact_2107_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X2: num] :
          ( ( numeral_numeral @ A @ ( inc @ X2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_2108_exists__least__lemma,axiom,
    ! [P: nat > $o] :
      ( ~ ( P @ ( zero_zero @ nat ) )
     => ( ? [X_12: nat] : ( P @ X_12 )
       => ? [N3: nat] :
            ( ~ ( P @ N3 )
            & ( P @ ( suc @ N3 ) ) ) ) ) ).

% exists_least_lemma
thf(fact_2109_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z3: int] : ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_le_of_int
thf(fact_2110_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z3: int] : ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_less_of_int
thf(fact_2111_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z3: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z3 ) @ X2 ) ) ).

% ex_of_int_less
thf(fact_2112_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_2113_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y2 ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y2 ) @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X2 )
              = Y2 ) ) ) ) ).

% round_unique
thf(fact_2114_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_2115_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less @ A @ ( minus_minus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) ) ) ).

% of_int_round_gt
thf(fact_2116_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) ) ) ).

% of_int_round_ge
thf(fact_2117_ln__one__minus__pos__lower__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X2 ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_2118_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_2119_tanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tanh_0
thf(fact_2120_tanh__real__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( tanh @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% tanh_real_zero_iff
thf(fact_2121_tanh__real__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X2 ) @ ( tanh @ real @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% tanh_real_less_iff
thf(fact_2122_tanh__real__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X2 ) @ ( tanh @ real @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% tanh_real_le_iff
thf(fact_2123_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_2124_ln__inj__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( ln_ln @ real @ X2 )
            = ( ln_ln @ real @ Y2 ) )
          = ( X2 = Y2 ) ) ) ) ).

% ln_inj_iff
thf(fact_2125_ln__less__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) )
          = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ).

% ln_less_cancel_iff
thf(fact_2126_round__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% round_0
thf(fact_2127_tanh__real__neg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% tanh_real_neg_iff
thf(fact_2128_tanh__real__pos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% tanh_real_pos_iff
thf(fact_2129_tanh__real__nonneg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% tanh_real_nonneg_iff
thf(fact_2130_tanh__real__nonpos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_2131_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ int @ N2 ) ) ) ).

% round_numeral
thf(fact_2132_ln__le__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) )
          = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_2133_ln__less__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_2134_ln__gt__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_gt_zero_iff
thf(fact_2135_ln__eq__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ln_ln @ real @ X2 )
          = ( zero_zero @ real ) )
        = ( X2
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_2136_exp__ln,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( exp @ real @ ( ln_ln @ real @ X2 ) )
        = X2 ) ) ).

% exp_ln
thf(fact_2137_exp__ln__iff,axiom,
    ! [X2: real] :
      ( ( ( exp @ real @ ( ln_ln @ real @ X2 ) )
        = X2 )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% exp_ln_iff
thf(fact_2138_ln__ge__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_ge_zero_iff
thf(fact_2139_ln__le__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_2140_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% round_neg_numeral
thf(fact_2141_ln__less__self,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ X2 ) ) ).

% ln_less_self
thf(fact_2142_tanh__real__lt__1,axiom,
    ! [X2: real] : ( ord_less @ real @ ( tanh @ real @ X2 ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_2143_ln__bound,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ X2 ) ) ).

% ln_bound
thf(fact_2144_ln__gt__zero__imp__gt__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_2145_ln__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_2146_ln__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) ) ) ).

% ln_gt_zero
thf(fact_2147_ln__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) ) ) ).

% ln_ge_zero
thf(fact_2148_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X2 ) @ ( archimedean_round @ A @ Y2 ) ) ) ) ).

% round_mono
thf(fact_2149_tanh__real__gt__neg1,axiom,
    ! [X2: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X2 ) ) ).

% tanh_real_gt_neg1
thf(fact_2150_ln__ge__zero__imp__ge__one,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_2151_ln__add__one__self__le__self,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) ).

% ln_add_one_self_le_self
thf(fact_2152_ln__mult,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ln_ln @ real @ ( times_times @ real @ X2 @ Y2 ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) ) ) ) ) ).

% ln_mult
thf(fact_2153_ln__eq__minus__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ln_ln @ real @ X2 )
          = ( minus_minus @ real @ X2 @ ( one_one @ real ) ) )
       => ( X2
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_2154_ln__div,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X2 @ Y2 ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) ) ) ) ) ).

% ln_div
thf(fact_2155_ln__ge__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( ln_ln @ real @ X2 ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y2 ) @ X2 ) ) ) ).

% ln_ge_iff
thf(fact_2156_ln__x__over__x__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y2 ) @ Y2 ) @ ( divide_divide @ real @ ( ln_ln @ real @ X2 ) @ X2 ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_2157_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_2158_ln__le__minus__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( minus_minus @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_2159_ln__diff__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X2 @ Y2 ) @ Y2 ) ) ) ) ).

% ln_diff_le
thf(fact_2160_ln__add__one__self__le__self2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) ).

% ln_add_one_self_le_self2
thf(fact_2161_tanh__ln__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( tanh @ real @ ( ln_ln @ real @ X2 ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_2162_ln__one__minus__pos__upper__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X2 ) ) @ ( uminus_uminus @ real @ X2 ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_2163_ln__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ln_ln @ real @ ( sqrt @ X2 ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_2164_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X: real] : ( ln_ln @ real @ ( plus_plus @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_2165_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ X ) @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X ) @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) ) ) ) ) ) ).

% tanh_altdef
thf(fact_2166_ln__one__plus__pos__lower__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X2 @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_2167_arcosh__real__def,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ( arcosh @ real @ X2 )
        = ( ln_ln @ real @ ( plus_plus @ real @ X2 @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_2168_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2169_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_2170_arctan__half,axiom,
    ( arctan
    = ( ^ [X: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_2171_log__base__10__eq1,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X2 )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X2 ) ) ) ) ).

% log_base_10_eq1
thf(fact_2172_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K3 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_2173_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_2174_log__base__10__eq2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X2 )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X2 ) ) ) ) ).

% log_base_10_eq2
thf(fact_2175_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_idempotent
thf(fact_2176_abs__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_abs
thf(fact_2177_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_2178_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_2179_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_2180_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_2181_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% abs_numeral
thf(fact_2182_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% abs_mult_self_eq
thf(fact_2183_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_2184_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_2185_abs__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_divide
thf(fact_2186_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus_cancel
thf(fact_2187_abs__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus
thf(fact_2188_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ ( abs_abs @ A @ M ) @ K )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% abs_dvd_iff
thf(fact_2189_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ M @ ( abs_abs @ A @ K ) )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% dvd_abs_iff
thf(fact_2190_of__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: int] :
          ( ( ring_1_of_int @ A @ ( abs_abs @ int @ X2 ) )
          = ( abs_abs @ A @ ( ring_1_of_int @ A @ X2 ) ) ) ) ).

% of_int_abs
thf(fact_2191_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: $o] :
          ( ( abs_abs @ A @ ( zero_neq_one_of_bool @ A @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% abs_bool_eq
thf(fact_2192_arctan__zero__zero,axiom,
    ( ( arctan @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arctan_zero_zero
thf(fact_2193_arctan__eq__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( arctan @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% arctan_eq_zero_iff
thf(fact_2194_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_2195_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_2196_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_2197_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_2198_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% abs_neg_numeral
thf(fact_2199_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_2200_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% abs_power_minus
thf(fact_2201_log__one,axiom,
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_2202_zero__less__arctan__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arctan @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% zero_less_arctan_iff
thf(fact_2203_arctan__less__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( arctan @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% arctan_less_zero_iff
thf(fact_2204_zero__le__arctan__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% zero_le_arctan_iff
thf(fact_2205_arctan__le__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_2206_real__sqrt__abs2,axiom,
    ! [X2: real] :
      ( ( sqrt @ ( times_times @ real @ X2 @ X2 ) )
      = ( abs_abs @ real @ X2 ) ) ).

% real_sqrt_abs2
thf(fact_2207_real__sqrt__mult__self,axiom,
    ! [A2: real] :
      ( ( times_times @ real @ ( sqrt @ A2 ) @ ( sqrt @ A2 ) )
      = ( abs_abs @ real @ A2 ) ) ).

% real_sqrt_mult_self
thf(fact_2208_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_2209_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_2210_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_2211_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N2 ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_2212_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N2 ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_2213_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_2214_log__less__cancel__iff,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) )
            = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_2215_log__less__one__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( log @ A2 @ X2 ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X2 @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_2216_one__less__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less @ real @ A2 @ X2 ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_2217_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( log @ A2 @ X2 ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_2218_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X2 ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_2219_artanh__minus__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X2 ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X2 ) ) ) ) ).

% artanh_minus_real
thf(fact_2220_signed__take__bit__nonnegative__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_2221_signed__take__bit__negative__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ).

% signed_take_bit_negative_iff
thf(fact_2222_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_2223_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_2224_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_2225_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X2 ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_2226_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X2 ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_2227_one__le__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less_eq @ real @ A2 @ X2 ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_2228_log__le__one__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X2 ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X2 @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_2229_log__le__cancel__iff,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) )
            = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_2230_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_numeral_simps(2)
thf(fact_2231_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( suc @ N2 ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ N2 ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_2232_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_numeral_simps(3)
thf(fact_2233_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( suc @ N2 ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ N2 ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_2234_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_2235_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: num,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ W ) )
            = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_2236_real__sqrt__abs,axiom,
    ! [X2: real] :
      ( ( sqrt @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X2 ) ) ).

% real_sqrt_abs
thf(fact_2237_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,N2: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( numeral_numeral @ nat @ N2 ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( pred_numeral @ N2 ) ) ) ).

% bit_minus_numeral_int(1)
thf(fact_2238_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,N2: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( numeral_numeral @ nat @ N2 ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_minus_numeral_int(2)
thf(fact_2239_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 )
          = ( ( N2
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_2240_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N2 )
          = ( bit_se5641148757651400278ts_bit @ nat @ ( numeral_numeral @ nat @ M ) @ N2 ) ) ) ).

% bit_numeral_iff
thf(fact_2241_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_2242_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_2243_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_2244_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_2245_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_2246_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_2247_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_minus_commute
thf(fact_2248_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( abs_abs @ A @ X2 )
            = ( abs_abs @ A @ Y2 ) )
          = ( ( X2 = Y2 )
            | ( X2
              = ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% abs_eq_iff
thf(fact_2249_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N2 ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) ) ) ).

% power_abs
thf(fact_2250_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [L2: A,K: A] :
          ( ( ( abs_abs @ A @ L2 )
            = ( abs_abs @ A @ K ) )
         => ( dvd_dvd @ A @ L2 @ K ) ) ) ).

% dvd_if_abs_eq
thf(fact_2251_bit__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            & ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ).

% bit_and_iff
thf(fact_2252_bit__and__int__iff,axiom,
    ! [K: int,L2: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) @ N2 )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
        & ( bit_se5641148757651400278ts_bit @ int @ L2 @ N2 ) ) ) ).

% bit_and_int_iff
thf(fact_2253_arctan__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% arctan_less_iff
thf(fact_2254_arctan__monotone,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ( ord_less @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) ) ) ).

% arctan_monotone
thf(fact_2255_arctan__monotone_H,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ Y2 )
     => ( ord_less_eq @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) ) ) ).

% arctan_monotone'
thf(fact_2256_arctan__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% arctan_le_iff
thf(fact_2257_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            & ( M != N2 ) ) ) ) ).

% bit_unset_bit_iff
thf(fact_2258_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N2 ) ) ) ).

% not_bit_1_Suc
thf(fact_2259_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N2 )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_2260_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% bit_numeral_simps(1)
thf(fact_2261_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_2262_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_2263_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_2264_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_2265_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D3 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D3 ) ) ) ) ) ).

% abs_mult_less
thf(fact_2266_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_2267_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_2268_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_2269_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_2270_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_2271_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_2272_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_2273_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_2274_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_2275_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) @ N2 )
          = ( ( ord_less @ nat @ N2 @ M )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% bit_take_bit_iff
thf(fact_2276_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N2 )
          = ( B2
            & ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_2277_log__def,axiom,
    ( log
    = ( ^ [A4: real,X: real] : ( divide_divide @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ A4 ) ) ) ) ).

% log_def
thf(fact_2278_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ).

% signed_take_bit_eq_if_positive
thf(fact_2279_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ E ) )
         => ( X2
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_2280_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y2 ) @ X2 )
            = ( abs_abs @ A @ ( times_times @ A @ Y2 @ X2 ) ) ) ) ) ).

% abs_mult_pos
thf(fact_2281_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_2282_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_2283_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_2284_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_2285_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X2 ) @ Y2 )
            = ( abs_abs @ A @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% abs_div_pos
thf(fact_2286_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) ) ) ).

% zero_le_power_abs
thf(fact_2287_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if_raw
thf(fact_2288_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if
thf(fact_2289_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_2290_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,A2: A,R: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ R )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R ) @ X2 )
            & ( ord_less_eq @ A @ X2 @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_2291_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_2292_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D3 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D3 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_2293_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,A2: A,R: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ R )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R ) @ X2 )
            & ( ord_less @ A @ X2 @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_2294_bit__not__int__iff_H,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N2 )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_not_int_iff'
thf(fact_2295_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A4: real] : ( if @ real @ ( ord_less @ real @ A4 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A4 ) @ A4 ) ) ) ).

% abs_real_def
thf(fact_2296_lemma__interval__lt,axiom,
    ! [A2: real,X2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X2 )
     => ( ( ord_less @ real @ X2 @ B2 )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [Y4: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y4 ) ) @ D5 )
               => ( ( ord_less @ real @ A2 @ Y4 )
                  & ( ord_less @ real @ Y4 @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_2297_sin__bound__lemma,axiom,
    ! [X2: real,Y2: real,U: real,V: real] :
      ( ( X2 = Y2 )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ U ) @ V )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( plus_plus @ real @ X2 @ U ) @ Y2 ) ) @ V ) ) ) ).

% sin_bound_lemma
thf(fact_2298_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N: nat,A4: A] : ( if @ ( nat > A > A ) @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N ) @ ( bit_se2638667681897837118et_bit @ A ) @ ( bit_se5668285175392031749et_bit @ A ) @ N @ A4 ) ) ) ) ).

% flip_bit_eq_if
thf(fact_2299_arctan__add,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X2 @ Y2 ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_2300_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X2 ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_2301_log__base__change,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X2 )
          = ( divide_divide @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_2302_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: int,X2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N2 ) ) @ X2 )
         => ( ( N2
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% of_int_leD
thf(fact_2303_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: int,X2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N2 ) ) @ X2 )
         => ( ( N2
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% of_int_lessD
thf(fact_2304_bit__imp__take__bit__positive,axiom,
    ! [N2: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_2305_lemma__interval,axiom,
    ! [A2: real,X2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X2 )
     => ( ( ord_less @ real @ X2 @ B2 )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [Y4: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y4 ) ) @ D5 )
               => ( ( ord_less_eq @ real @ A2 @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_2306_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L2: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L2 ) @ N2 )
      = ( ( ( ord_less @ nat @ N2 @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) )
        | ( ( ord_less_eq @ nat @ M @ N2 )
          & ( bit_se5641148757651400278ts_bit @ int @ L2 @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_2307_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: A,M: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ M ) ) ) ) ) ).

% round_diff_minimal
thf(fact_2308_signed__take__bit__eq__concat__bit,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N: nat,K3: int] : ( bit_concat_bit @ N @ K3 @ ( uminus_uminus @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_concat_bit
thf(fact_2309_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_2310_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 ) ) ) ).

% bit_Suc
thf(fact_2311_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
         => ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 ) ) ) ).

% bit_iff_idd_imp_stable
thf(fact_2312_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% stable_imp_bit_iff_odd
thf(fact_2313_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ ( abs_abs @ A @ Y2 ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_2314_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X2 )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_2315_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_even_abs
thf(fact_2316_log__mult,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ( log @ A2 @ ( times_times @ real @ X2 @ Y2 ) )
              = ( plus_plus @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) ) ) ) ) ) ) ).

% log_mult
thf(fact_2317_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ N3 @ M2 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M2 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) ) ) ) ).

% int_bit_bound
thf(fact_2318_log__divide,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ( log @ A2 @ ( divide_divide @ real @ X2 @ Y2 ) )
              = ( minus_minus @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) ) ) ) ) ) ) ).

% log_divide
thf(fact_2319_arctan__double,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X2 ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_2320_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_2321_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_2322_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ Y2 ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_2323_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_2324_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_2325_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono_even
thf(fact_2326_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
             => ( ( log @ A2 @ X2 )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log @ B2 @ X2 ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_2327_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K3: int,N: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% bit_int_def
thf(fact_2328_sqrt__ge__absD,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( sqrt @ Y2 ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 ) ) ).

% sqrt_ge_absD
thf(fact_2329_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ( N2
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_2330_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N2 )
              | ( N2
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_2331_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X2 ) @ ( abs_abs @ real @ Y2 ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_2332_real__sqrt__ge__abs2,axiom,
    ! [Y2: real,X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_2333_real__sqrt__ge__abs1,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_2334_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ! [J3: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N2 )
            = ( ( ( N2
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N2
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N2 ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_2335_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_2336_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N: nat,K3: int] :
          ( plus_plus @ int @ K3
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% set_bit_eq
thf(fact_2337_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N: nat,K3: int] : ( minus_minus @ int @ K3 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% unset_bit_eq
thf(fact_2338_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) @ X2 ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_2339_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ ( ring_1_of_int @ A @ N2 ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X2 )
            = N2 ) ) ) ).

% round_unique'
thf(fact_2340_cos__x__y__le__one,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_2341_real__sqrt__sum__squares__less,axiom,
    ! [X2: real,U: real,Y2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y2 ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_2342_take__bit__Suc__from__most,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_2343_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X2: A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
             => ( P @ X3 @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X2 ) @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_2344_log2__of__power__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log2_of_power_le
thf(fact_2345_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_2346_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_2347_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less_eq @ real @ X2 @ ( semiring_1_of_nat @ real @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 ) @ ( exp @ real @ ( uminus_uminus @ real @ X2 ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_2348_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ X2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 ) @ ( exp @ real @ X2 ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_2349_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_2350_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( M = N2 ) ) ) ).

% of_nat_eq_iff
thf(fact_2351_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% abs_of_nat
thf(fact_2352_of__int__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( ring_1_of_int @ A @ ( semiring_1_of_nat @ int @ N2 ) )
          = ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% of_int_of_nat_eq
thf(fact_2353_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) )
            = X2 )
          = ( ? [N: int] :
                ( X2
                = ( ring_1_of_int @ A @ N ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_2354_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_2355_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( ( zero_zero @ nat )
            = N2 ) ) ) ).

% of_nat_0_eq_iff
thf(fact_2356_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_2357_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less @ nat @ M @ N2 ) ) ) ).

% of_nat_less_iff
thf(fact_2358_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N2 ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% of_nat_numeral
thf(fact_2359_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% of_nat_le_iff
thf(fact_2360_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N2 ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_add
thf(fact_2361_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_mult
thf(fact_2362_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ N2 )
            = ( one_one @ A ) )
          = ( N2
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_2363_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( N2
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_2364_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_2365_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( ( semiring_1_of_nat @ A @ X2 )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( X2
            = ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_2366_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W )
            = ( semiring_1_of_nat @ A @ X2 ) )
          = ( ( power_power @ nat @ B2 @ W )
            = X2 ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_2367_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N2 ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N2 ) ) ) ).

% of_nat_power
thf(fact_2368_floor__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% floor_zero
thf(fact_2369_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% floor_numeral
thf(fact_2370_zdvd1__eq,axiom,
    ! [X2: int] :
      ( ( dvd_dvd @ int @ X2 @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X2 )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_2371_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_2372_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_2373_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_2374_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z ) @ ( one_one @ int ) )
      = ( Z
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_2375_floor__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z ) ) ) ).

% floor_diff_of_int
thf(fact_2376_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% of_nat_0_less_iff
thf(fact_2377_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less @ nat @ X2 @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_2378_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W ) @ X2 ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_2379_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y2: nat,X2: num,N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y2 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( Y2
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_2380_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X2: num,N2: nat,Y2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 )
            = ( semiring_1_of_nat @ A @ Y2 ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 )
            = Y2 ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_2381_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ nat @ X2 @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_2382_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W ) @ X2 ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_2383_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) ) ).

% zero_le_floor
thf(fact_2384_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X2 @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_2385_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V ) @ X2 ) ) ) ).

% numeral_le_floor
thf(fact_2386_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ).

% zero_less_floor
thf(fact_2387_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_2388_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X2 @ ( numeral_numeral @ A @ V ) ) ) ) ).

% floor_less_numeral
thf(fact_2389_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ).

% one_le_floor
thf(fact_2390_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,N2: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W ) @ ( semiring_1_of_nat @ real @ N2 ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W ) @ N2 ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_2391_real__of__nat__less__numeral__iff,axiom,
    ! [N2: nat,W: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( numeral_numeral @ real @ W ) )
      = ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ W ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_2392_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_2393_numeral__le__real__of__nat__iff,axiom,
    ! [N2: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N2 ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N2 ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_2394_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_neg_numeral
thf(fact_2395_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X2 @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_diff_numeral
thf(fact_2396_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_2397_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: num,N2: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% floor_numeral_power
thf(fact_2398_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_2399_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X2 ) @ N2 ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X2 )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_2400_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_2401_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% even_of_nat
thf(fact_2402_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,I: num,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N2 ) )
          = ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N2 ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_2403_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N2: nat,X2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N2 ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N2 ) @ X2 ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_2404_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,I: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N2 ) )
          = ( ord_less_eq @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N2 ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_2405_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N2: nat,X2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N2 ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N2 ) @ X2 ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_2406_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% numeral_less_floor
thf(fact_2407_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_2408_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) ) ) ).

% one_less_floor
thf(fact_2409_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_2410_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X2 ) ) ) ).

% neg_numeral_le_floor
thf(fact_2411_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_2412_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_2413_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_2414_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% neg_numeral_less_floor
thf(fact_2415_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_2416_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N2: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N2 ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_2417_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [N3: nat] : ( ord_less_eq @ A @ X2 @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% real_arch_simple
thf(fact_2418_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [N3: nat] : ( ord_less @ A @ X2 @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% reals_Archimedean2
thf(fact_2419_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X2: nat,Y2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X2 ) @ Y2 )
          = ( times_times @ A @ Y2 @ ( semiring_1_of_nat @ A @ X2 ) ) ) ) ).

% mult_of_nat_commute
thf(fact_2420_pi__neq__zero,axiom,
    pi
 != ( zero_zero @ real ) ).

% pi_neq_zero
thf(fact_2421_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N2 )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N2 ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_2422_zdvd__antisym__abs,axiom,
    ! [A2: int,B2: int] :
      ( ( dvd_dvd @ int @ A2 @ B2 )
     => ( ( dvd_dvd @ int @ B2 @ A2 )
       => ( ( abs_abs @ int @ A2 )
          = ( abs_abs @ int @ B2 ) ) ) ) ).

% zdvd_antisym_abs
thf(fact_2423_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,X2: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( ring_1_of_int @ A @ X2 ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N2 ) @ X2 ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_2424_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) ) ).

% floor_mono
thf(fact_2425_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) @ X2 ) ) ).

% of_int_floor_le
thf(fact_2426_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) )
         => ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% floor_less_cancel
thf(fact_2427_not__bit__Suc__0__Suc,axiom,
    ! [N2: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N2 ) ) ).

% not_bit_Suc_0_Suc
thf(fact_2428_bit__Suc__0__iff,axiom,
    ! [N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_2429_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% of_nat_0_le_iff
thf(fact_2430_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_2431_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N2 ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_2432_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% div_mult2_eq'
thf(fact_2433_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_2434_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
         => ( ord_less @ nat @ M @ N2 ) ) ) ).

% of_nat_less_imp_less
thf(fact_2435_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I: nat,J: nat] :
          ( ( ord_less_eq @ nat @ I @ J )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ).

% of_nat_mono
thf(fact_2436_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N2 ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_2437_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% of_nat_dvd_iff
thf(fact_2438_abs__zmult__eq__1,axiom,
    ! [M: int,N2: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N2 ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_2439_pi__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ pi ).

% pi_gt_zero
thf(fact_2440_pi__not__less__zero,axiom,
    ~ ( ord_less @ real @ pi @ ( zero_zero @ real ) ) ).

% pi_not_less_zero
thf(fact_2441_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_2442_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N2 ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_mod
thf(fact_2443_floor__le__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archimedean_round @ A @ X2 ) ) ) ).

% floor_le_round
thf(fact_2444_abs__div,axiom,
    ! [Y2: int,X2: int] :
      ( ( dvd_dvd @ int @ Y2 @ X2 )
     => ( ( abs_abs @ int @ ( divide_divide @ int @ X2 @ Y2 ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ X2 ) @ ( abs_abs @ int @ Y2 ) ) ) ) ).

% abs_div
thf(fact_2445_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_2446_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_and_eq
thf(fact_2447_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% of_nat_mask_eq
thf(fact_2448_not__bit__Suc__0__numeral,axiom,
    ! [N2: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N2 ) ) ).

% not_bit_Suc_0_numeral
thf(fact_2449_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less_eq @ int @ Z @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X2 ) ) ) ).

% le_floor_iff
thf(fact_2450_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z )
          = ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% floor_less_iff
thf(fact_2451_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% le_floor_add
thf(fact_2452_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( plus_plus @ int @ Z @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ X2 ) ) ) ) ).

% int_add_floor
thf(fact_2453_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) ) ) ) ).

% floor_add_int
thf(fact_2454_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ? [N3: nat] : ( ord_less @ A @ Y2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ X2 ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_2455_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L2: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) )
          = ( divide_divide @ int @ K @ L2 ) ) ) ).

% floor_divide_of_int_eq
thf(fact_2456_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,N2: nat] :
          ( ( X2
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X2 @ N2 ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ N2 ) ) ) ) ).

% floor_power
thf(fact_2457_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N2: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N2 ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% of_nat_diff
thf(fact_2458_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N2: nat,X2: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ X2 ) )
          = ( power_power @ A @ ( exp @ A @ X2 ) @ N2 ) ) ) ).

% exp_of_nat_mult
thf(fact_2459_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( exp @ A @ ( times_times @ A @ X2 @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( power_power @ A @ ( exp @ A @ X2 ) @ N2 ) ) ) ).

% exp_of_nat2_mult
thf(fact_2460_zabs__def,axiom,
    ( ( abs_abs @ int )
    = ( ^ [I3: int] : ( if @ int @ ( ord_less @ int @ I3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ int @ I3 ) @ I3 ) ) ) ).

% zabs_def
thf(fact_2461_reals__Archimedean3,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ! [Y4: real] :
        ? [N3: nat] : ( ord_less @ real @ Y4 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ X2 ) ) ) ).

% reals_Archimedean3
thf(fact_2462_dvd__imp__le__int,axiom,
    ! [I: int,D3: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ D3 @ I )
       => ( ord_less_eq @ int @ ( abs_abs @ int @ D3 ) @ ( abs_abs @ int @ I ) ) ) ) ).

% dvd_imp_le_int
thf(fact_2463_real__of__nat__div4,axiom,
    ! [N2: nat,X2: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X2 ) ) ) ).

% real_of_nat_div4
thf(fact_2464_abs__mod__less,axiom,
    ! [L2: int,K: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L2 ) ) @ ( abs_abs @ int @ L2 ) ) ) ).

% abs_mod_less
thf(fact_2465_real__of__nat__div,axiom,
    ! [D3: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ D3 @ N2 )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ D3 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ D3 ) ) ) ) ).

% real_of_nat_div
thf(fact_2466_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_2467_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_2468_floor__eq,axiom,
    ! [N2: int,X2: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N2 ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X2 )
          = N2 ) ) ) ).

% floor_eq
thf(fact_2469_real__of__int__floor__add__one__gt,axiom,
    ! [R: real] : ( ord_less @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_2470_real__of__int__floor__add__one__ge,axiom,
    ! [R: real] : ( ord_less_eq @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_2471_real__of__int__floor__gt__diff__one,axiom,
    ! [R: real] : ( ord_less @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_2472_real__of__int__floor__ge__diff__one,axiom,
    ! [R: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_2473_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N2 ) ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2474_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_2475_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N: nat,M3: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M3 ) ) ) ) ).

% nat_less_real_le
thf(fact_2476_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_2477_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N: nat,M3: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_2478_zdvd__mult__cancel1,axiom,
    ! [M: int,N2: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N2 ) @ M )
        = ( ( abs_abs @ int @ N2 )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_2479_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_2480_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N2: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N2 )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_2481_less__log__of__power,axiom,
    ! [B2: real,N2: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N2 ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_2482_real__of__nat__div__aux,axiom,
    ! [X2: nat,D3: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X2 ) @ ( semiring_1_of_nat @ real @ D3 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X2 @ D3 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X2 @ D3 ) ) @ ( semiring_1_of_nat @ real @ D3 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_2483_floor__log2__div2,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_2484_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I3: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I3 ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I3 ) @ ( one_one @ A ) ) ) )
               => ( P @ I3 ) ) ) ) ) ).

% floor_split
thf(fact_2485_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X2 )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X2 )
            & ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_2486_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X2 )
         => ( ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X2 )
              = Z ) ) ) ) ).

% floor_unique
thf(fact_2487_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_2488_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less @ int @ Z @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% less_floor_iff
thf(fact_2489_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z )
          = ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_2490_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) @ X2 )
          & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_2491_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
         => ~ ! [N3: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ E2 ) ) ) ).

% nat_approx_posE
thf(fact_2492_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% of_nat_less_two_power
thf(fact_2493_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M )
         => ( ( N2
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_2494_floor__eq2,axiom,
    ! [N2: int,X2: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N2 ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X2 )
          = N2 ) ) ) ).

% floor_eq2
thf(fact_2495_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_2496_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N2: nat,X2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X2 @ ( semiring_1_of_nat @ A @ N2 ) ) ) @ N2 )
            = ( exp @ A @ X2 ) ) ) ) ).

% exp_divide_power_eq
thf(fact_2497_even__abs__add__iff,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L2 ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% even_abs_add_iff
thf(fact_2498_even__add__abs__iff,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L2 ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% even_add_abs_iff
thf(fact_2499_real__archimedian__rdiv__eq__0,axiom,
    ! [X2: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M4: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M4 ) @ X2 ) @ C2 ) )
         => ( X2
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_2500_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_2501_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_2502_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_2503_real__of__nat__div2,axiom,
    ! [N2: nat,X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X2 ) ) ) ) ).

% real_of_nat_div2
thf(fact_2504_real__of__nat__div3,axiom,
    ! [N2: nat,X2: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X2 ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_2505_le__log__of__power,axiom,
    ! [B2: real,N2: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N2 ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_2506_log__base__pow,axiom,
    ! [A2: real,N2: nat,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log @ ( power_power @ real @ A2 @ N2 ) @ X2 )
        = ( divide_divide @ real @ ( log @ A2 @ X2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log_base_pow
thf(fact_2507_ln__realpow,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ln_ln @ real @ ( power_power @ real @ X2 @ N2 ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( ln_ln @ real @ X2 ) ) ) ) ).

% ln_realpow
thf(fact_2508_log__nat__power,axiom,
    ! [X2: real,B2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( log @ B2 @ ( power_power @ real @ X2 @ N2 ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ X2 ) ) ) ) ).

% log_nat_power
thf(fact_2509_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ Q2 ) @ P2 ) ) ) ).

% floor_divide_lower
thf(fact_2510_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M3: nat,N: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% bit_nat_def
thf(fact_2511_nat__intermed__int__val,axiom,
    ! [M: nat,N2: nat,F2: nat > int,K: int] :
      ( ! [I4: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I4 )
            & ( ord_less @ nat @ I4 @ N2 ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ( ord_less_eq @ int @ ( F2 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
           => ? [I4: nat] :
                ( ( ord_less_eq @ nat @ M @ I4 )
                & ( ord_less_eq @ nat @ I4 @ N2 )
                & ( ( F2 @ I4 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_2512_incr__lemma,axiom,
    ! [D3: int,Z: int,X2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ord_less @ int @ Z @ ( plus_plus @ int @ X2 @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X2 @ Z ) ) @ ( one_one @ int ) ) @ D3 ) ) ) ) ).

% incr_lemma
thf(fact_2513_decr__lemma,axiom,
    ! [D3: int,X2: int,Z: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ord_less @ int @ ( minus_minus @ int @ X2 @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X2 @ Z ) ) @ ( one_one @ int ) ) @ D3 ) ) @ Z ) ) ).

% decr_lemma
thf(fact_2514_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_2515_log2__of__power__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( semiring_1_of_nat @ real @ N2 )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_2516_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_2517_linear__plus__1__le__power,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X2 @ ( one_one @ real ) ) @ N2 ) ) ) ).

% linear_plus_1_le_power
thf(fact_2518_log__of__power__less,axiom,
    ! [M: nat,B2: real,N2: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_of_power_less
thf(fact_2519_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_2520_Bernoulli__inequality,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ N2 ) ) ) ).

% Bernoulli_inequality
thf(fact_2521_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ P2 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) ) ) ) ).

% floor_divide_upper
thf(fact_2522_arctan__ubound,axiom,
    ! [Y2: real] : ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_2523_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_2524_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_2525_nat__ivt__aux,axiom,
    ! [N2: nat,F2: nat > int,K: int] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ N2 )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
         => ? [I4: nat] :
              ( ( ord_less_eq @ nat @ I4 @ N2 )
              & ( ( F2 @ I4 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_2526_log__of__power__le,axiom,
    ! [M: nat,B2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_of_power_le
thf(fact_2527_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_2528_arctan__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) )
      & ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_2529_arctan__lbound,axiom,
    ! [Y2: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) ) ).

% arctan_lbound
thf(fact_2530_nat0__intermed__int__val,axiom,
    ! [N2: nat,F2: nat > int,K: int] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ N2 )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) @ ( F2 @ I4 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
         => ? [I4: nat] :
              ( ( ord_less_eq @ nat @ I4 @ N2 )
              & ( ( F2 @ I4 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_2531_less__log2__of__power,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_2532_le__log2__of__power,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_2533_log2__of__power__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log2_of_power_less
thf(fact_2534_Bernoulli__inequality__even,axiom,
    ! [N2: nat,X2: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ N2 ) ) ) ).

% Bernoulli_inequality_even
thf(fact_2535_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H2: A,Z: A,K5: real,N2: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z @ H2 ) ) @ K5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K5 @ ( minus_minus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2536_sin__cos__npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% sin_cos_npi
thf(fact_2537_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_2538_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N2 ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_2539_ceiling__log2__div2,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_2540_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_2541_sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sin_zero
thf(fact_2542_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) )
            = X2 )
          = ( ? [N: int] :
                ( X2
                = ( ring_1_of_int @ A @ N ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_2543_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_2544_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V ) )
      = ( M
        = ( numeral_numeral @ nat @ V ) ) ) ).

% int_eq_iff_numeral
thf(fact_2545_ceiling__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% ceiling_zero
thf(fact_2546_negative__eq__positive,axiom,
    ! [N2: nat,M: nat] :
      ( ( ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) )
        = ( semiring_1_of_nat @ int @ M ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% negative_eq_positive
thf(fact_2547_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% ceiling_numeral
thf(fact_2548_negative__zle,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zle
thf(fact_2549_sin__pi,axiom,
    ( ( sin @ real @ pi )
    = ( zero_zero @ real ) ) ).

% sin_pi
thf(fact_2550_int__dvd__int__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N2 ) )
      = ( dvd_dvd @ nat @ M @ N2 ) ) ).

% int_dvd_int_iff
thf(fact_2551_sin__pi__minus,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( minus_minus @ real @ pi @ X2 ) )
      = ( sin @ real @ X2 ) ) ).

% sin_pi_minus
thf(fact_2552_negative__zless,axiom,
    ! [N2: nat,M: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zless
thf(fact_2553_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ Z ) ) ) ).

% ceiling_add_of_int
thf(fact_2554_ceiling__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X2 ) @ Z ) ) ) ).

% ceiling_diff_of_int
thf(fact_2555_cos__periodic__pi,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X2 @ pi ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X2 ) ) ) ).

% cos_periodic_pi
thf(fact_2556_cos__periodic__pi2,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( plus_plus @ real @ pi @ X2 ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X2 ) ) ) ).

% cos_periodic_pi2
thf(fact_2557_sin__periodic__pi,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X2 @ pi ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X2 ) ) ) ).

% sin_periodic_pi
thf(fact_2558_sin__periodic__pi2,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( plus_plus @ real @ pi @ X2 ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X2 ) ) ) ).

% sin_periodic_pi2
thf(fact_2559_cos__pi__minus,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( minus_minus @ real @ pi @ X2 ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X2 ) ) ) ).

% cos_pi_minus
thf(fact_2560_cos__minus__pi,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( minus_minus @ real @ X2 @ pi ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X2 ) ) ) ).

% cos_minus_pi
thf(fact_2561_sin__minus__pi,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( minus_minus @ real @ X2 @ pi ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X2 ) ) ) ).

% sin_minus_pi
thf(fact_2562_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ X2 ) ) @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ X2 ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add3
thf(fact_2563_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_2564_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) ) ) ).

% zero_less_ceiling
thf(fact_2565_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X2 @ ( numeral_numeral @ A @ V ) ) ) ) ).

% ceiling_le_numeral
thf(fact_2566_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_2567_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V ) @ X2 ) ) ) ).

% numeral_less_ceiling
thf(fact_2568_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) ) ) ).

% one_le_ceiling
thf(fact_2569_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_2570_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X2 ) ) ) ).

% one_less_ceiling
thf(fact_2571_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ ( numeral_numeral @ A @ V ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_add_numeral
thf(fact_2572_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_2573_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_2574_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X2 @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_2575_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_2576_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: num,N2: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% ceiling_numeral_power
thf(fact_2577_sin__npi2,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_2578_sin__npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_2579_sin__npi__int,axiom,
    ! [N2: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_2580_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_2581_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 ) ) ) ).

% zero_le_ceiling
thf(fact_2582_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_2583_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X2 @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_2584_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% numeral_le_ceiling
thf(fact_2585_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_2586_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X2 ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_2587_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_2588_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_2589_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_2590_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_2591_cos__periodic,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X2 ) ) ).

% cos_periodic
thf(fact_2592_sin__periodic,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X2 ) ) ).

% sin_periodic
thf(fact_2593_cos__2pi__minus,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X2 ) )
      = ( cos @ real @ X2 ) ) ).

% cos_2pi_minus
thf(fact_2594_cos__npi,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% cos_npi
thf(fact_2595_cos__npi2,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% cos_npi2
thf(fact_2596_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_2597_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_2598_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_2599_sin__2npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_2600_cos__2npi,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_2601_sin__2pi__minus,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X2 ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X2 ) ) ) ).

% sin_2pi_minus
thf(fact_2602_sin__int__2pin,axiom,
    ! [N2: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_2603_cos__int__2pin,axiom,
    ! [N2: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_2604_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X2 @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_2605_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_2606_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_2607_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_2608_cos__npi__int,axiom,
    ! [N2: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_2609_int__int__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( semiring_1_of_nat @ int @ N2 ) )
      = ( M = N2 ) ) ).

% int_int_eq
thf(fact_2610_polar__Ex,axiom,
    ! [X2: real,Y2: real] :
    ? [R2: real,A6: real] :
      ( ( X2
        = ( times_times @ real @ R2 @ ( cos @ real @ A6 ) ) )
      & ( Y2
        = ( times_times @ real @ R2 @ ( sin @ real @ A6 ) ) ) ) ).

% polar_Ex
thf(fact_2611_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sin @ A @ X2 )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X2 ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_2612_sin__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sin @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% sin_diff
thf(fact_2613_sin__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sin @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% sin_add
thf(fact_2614_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X2 )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_2615_int__cases2,axiom,
    ! [Z: int] :
      ( ! [N3: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% int_cases2
thf(fact_2616_int__diff__cases,axiom,
    ! [Z: int] :
      ~ ! [M4: nat,N3: nat] :
          ( Z
         != ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_diff_cases
thf(fact_2617_cos__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cos @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% cos_diff
thf(fact_2618_cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% cos_add
thf(fact_2619_sin__zero__abs__cos__one,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X2 ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_2620_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X2 ) ) @ ( cos @ A @ X2 ) ) ) ) ).

% sin_double
thf(fact_2621_sincos__principal__value,axiom,
    ! [X2: real] :
    ? [Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y3 )
      & ( ord_less_eq @ real @ Y3 @ pi )
      & ( ( sin @ real @ Y3 )
        = ( sin @ real @ X2 ) )
      & ( ( cos @ real @ Y3 )
        = ( cos @ real @ X2 ) ) ) ).

% sincos_principal_value
thf(fact_2622_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y2 ) @ ( archimedean_ceiling @ A @ X2 ) ) ) ) ).

% ceiling_mono
thf(fact_2623_sin__x__le__x,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ X2 ) ) ).

% sin_x_le_x
thf(fact_2624_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) ) ) ) ).

% le_of_int_ceiling
thf(fact_2625_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( archimedean_ceiling @ A @ Y2 ) )
         => ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% ceiling_less_cancel
thf(fact_2626_sin__le__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_2627_cos__le__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( cos @ real @ X2 ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_2628_abs__sin__x__le__abs__x,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X2 ) ) @ ( abs_abs @ real @ X2 ) ) ).

% abs_sin_x_le_abs_x
thf(fact_2629_int__ops_I1_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( zero_zero @ nat ) )
    = ( zero_zero @ int ) ) ).

% int_ops(1)
thf(fact_2630_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archimedean_ceiling @ A @ X2 ) ) ) ).

% floor_le_ceiling
thf(fact_2631_complex__mod__minus__le__complex__mod,axiom,
    ! [X2: complex] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) ).

% complex_mod_minus_le_complex_mod
thf(fact_2632_int__ops_I3_J,axiom,
    ! [N2: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N2 ) )
      = ( numeral_numeral @ int @ N2 ) ) ).

% int_ops(3)
thf(fact_2633_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_2634_int__of__nat__induct,axiom,
    ! [P: int > $o,Z: int] :
      ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ int @ N3 ) )
     => ( ! [N3: nat] : ( P @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) )
       => ( P @ Z ) ) ) ).

% int_of_nat_induct
thf(fact_2635_int__cases,axiom,
    ! [Z: int] :
      ( ! [N3: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% int_cases
thf(fact_2636_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_2637_zle__int,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% zle_int
thf(fact_2638_cos__arctan__not__zero,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( arctan @ X2 ) )
     != ( zero_zero @ real ) ) ).

% cos_arctan_not_zero
thf(fact_2639_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ B2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ B2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ A2 ) ) ).

% complex_mod_triangle_ineq2
thf(fact_2640_nonneg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( K
           != ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% nonneg_int_cases
thf(fact_2641_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% zero_le_imp_eq_int
thf(fact_2642_int__plus,axiom,
    ! [N2: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N2 @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_2643_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_2644_zadd__int__left,axiom,
    ! [M: nat,N2: nat,Z: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ Z ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N2 ) ) @ Z ) ) ).

% zadd_int_left
thf(fact_2645_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_2646_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W2: int,Z5: int] :
        ? [N: nat] :
          ( Z5
          = ( plus_plus @ int @ W2 @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% zle_iff_zadd
thf(fact_2647_not__int__zless__negative,axiom,
    ! [N2: nat,M: nat] :
      ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% not_int_zless_negative
thf(fact_2648_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_2649_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ int @ ( archimedean_round @ A @ X2 ) @ ( archimedean_ceiling @ A @ X2 ) ) ) ).

% ceiling_ge_round
thf(fact_2650_zmod__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ A2 @ B2 ) )
      = ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zmod_int
thf(fact_2651_sin__cos__le1,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X2 ) @ ( sin @ real @ Y2 ) ) @ ( times_times @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_2652_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_2653_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_2654_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ Z )
          = ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% ceiling_le_iff
thf(fact_2655_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: int] :
          ( ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_2656_sin__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ pi )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_gt_zero
thf(fact_2657_sin__x__ge__neg__x,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X2 ) @ ( sin @ real @ X2 ) ) ) ).

% sin_x_ge_neg_x
thf(fact_2658_sin__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_ge_zero
thf(fact_2659_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less @ int @ Z @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ X2 ) ) ) ).

% less_ceiling_iff
thf(fact_2660_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( archimedean_ceiling @ A @ Y2 ) ) ) ) ).

% ceiling_add_le
thf(fact_2661_sin__ge__minus__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X2 ) ) ).

% sin_ge_minus_one
thf(fact_2662_cos__monotone__0__pi__le,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_2663_cos__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) )
              = ( ord_less_eq @ real @ Y2 @ X2 ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_2664_cos__inj__pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ( cos @ real @ X2 )
                = ( cos @ real @ Y2 ) )
             => ( X2 = Y2 ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_2665_cos__ge__minus__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X2 ) ) ).

% cos_ge_minus_one
thf(fact_2666_abs__sin__le__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X2 ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_2667_abs__cos__le__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X2 ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_2668_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z @ W ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_2669_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_2670_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_2671_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_2672_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_2673_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_2674_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_2675_int__cases4,axiom,
    ! [M: int] :
      ( ! [N3: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% int_cases4
thf(fact_2676_int__zle__neg,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% int_zle_neg
thf(fact_2677_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_2678_int__Suc,axiom,
    ! [N2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_2679_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W2: int,Z5: int] :
        ? [N: nat] :
          ( Z5
          = ( plus_plus @ int @ W2 @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_2680_negative__zle__0,axiom,
    ! [N2: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) @ ( zero_zero @ int ) ) ).

% negative_zle_0
thf(fact_2681_nonpos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( K
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% nonpos_int_cases
thf(fact_2682_norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ X2 ) ) @ ( exp @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ) ).

% norm_exp
thf(fact_2683_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_2684_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( plus_plus @ A @ R @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_2685_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( one_one @ A ) ) @ R ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_2686_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_2687_cos__monotone__0__pi,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ pi )
         => ( ord_less @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_2688_cos__mono__less__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) )
              = ( ord_less @ real @ Y2 @ X2 ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_2689_sin__eq__0__pi,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X2 )
     => ( ( ord_less @ real @ X2 @ pi )
       => ( ( ( sin @ real @ X2 )
            = ( zero_zero @ real ) )
         => ( X2
            = ( zero_zero @ real ) ) ) ) ) ).

% sin_eq_0_pi
thf(fact_2690_sin__zero__pi__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ pi )
     => ( ( ( sin @ real @ X2 )
          = ( zero_zero @ real ) )
        = ( X2
          = ( zero_zero @ real ) ) ) ) ).

% sin_zero_pi_iff
thf(fact_2691_cos__monotone__minus__pi__0_H,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y2 ) @ ( cos @ real @ X2 ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_2692_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_2693_sin__zero__iff__int2,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [I3: int] :
            ( X2
            = ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_2694_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X: A] :
              ( if @ int
              @ ( X
                = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) )
              @ ( archim6421214686448440834_floor @ A @ X )
              @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_altdef
thf(fact_2695_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ X2 ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_2696_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% pos_int_cases
thf(fact_2697_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
          & ( K
            = ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_2698_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) )
       => ~ ! [N3: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% int_cases3
thf(fact_2699_zmult__zless__mono2__lemma,axiom,
    ! [I: int,J: int,K: nat] :
      ( ( ord_less @ int @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_2700_not__zle__0__negative,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ).

% not_zle_0_negative
thf(fact_2701_negD,axiom,
    ! [X2: int] :
      ( ( ord_less @ int @ X2 @ ( zero_zero @ int ) )
     => ? [N3: nat] :
          ( X2
          = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% negD
thf(fact_2702_negative__zless__0,axiom,
    ! [N2: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) @ ( zero_zero @ int ) ) ).

% negative_zless_0
thf(fact_2703_sincos__total__pi,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ pi )
            & ( X2
              = ( cos @ real @ T4 ) )
            & ( Y2
              = ( sin @ real @ T4 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_2704_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_2705_sin__cos__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) )
     => ( ( sin @ real @ X2 )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_2706_sin__expansion__lemma,axiom,
    ! [X2: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_2707_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) ) @ ( one_one @ A ) ) @ X2 )
          & ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) ) ) ) ) ).

% ceiling_correct
thf(fact_2708_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ Z ) )
           => ( ( archimedean_ceiling @ A @ X2 )
              = Z ) ) ) ) ).

% ceiling_unique
thf(fact_2709_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X2 )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X2 )
            & ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_2710_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I3: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I3 ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I3 ) ) )
               => ( P @ I3 ) ) ) ) ) ).

% ceiling_split
thf(fact_2711_cos__expansion__lemma,axiom,
    ! [X2: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_2712_sin__gt__zero__02,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_gt_zero_02
thf(fact_2713_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_2714_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ Z )
          = ( ord_less_eq @ A @ X2 @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_2715_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less_eq @ int @ Z @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% le_ceiling_iff
thf(fact_2716_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_2717_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_2718_cos__is__zero,axiom,
    ? [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
      & ( ord_less_eq @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X3 )
        = ( zero_zero @ real ) )
      & ! [Y4: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 )
            & ( ord_less_eq @ real @ Y4 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y4 )
              = ( zero_zero @ real ) ) )
         => ( Y4 = X3 ) ) ) ).

% cos_is_zero
thf(fact_2719_cos__monotone__minus__pi__0,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y2 ) @ ( cos @ real @ X2 ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_2720_cos__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ pi )
            & ( ( cos @ real @ X3 )
              = Y2 )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ pi )
                  & ( ( cos @ real @ Y4 )
                    = Y2 ) )
               => ( Y4 = X3 ) ) ) ) ) ).

% cos_total
thf(fact_2721_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X6: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X6 @ N ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X6 @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_2722_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X6: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X6 @ N ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X6 @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_2723_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% neg_int_cases
thf(fact_2724_zdiff__int__split,axiom,
    ! [P: int > $o,X2: nat,Y2: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X2 @ Y2 ) ) )
      = ( ( ( ord_less_eq @ nat @ Y2 @ X2 )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X2 ) @ ( semiring_1_of_nat @ int @ Y2 ) ) ) )
        & ( ( ord_less @ nat @ X2 @ Y2 )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_2725_sincos__total__pi__half,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T4: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X2
                = ( cos @ real @ T4 ) )
              & ( Y2
                = ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_2726_sincos__total__2pi__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X2
            = ( cos @ real @ T4 ) )
          & ( Y2
            = ( sin @ real @ T4 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_2727_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ P2 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ Q2 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_2728_sincos__total__2pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X2
                  = ( cos @ real @ T4 ) )
               => ( Y2
                 != ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_2729_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_2730_sin__pi__divide__n__ge__0,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_2731_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_2732_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_2733_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_2734_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_2735_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_2736_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) @ P2 ) ) ) ).

% ceiling_divide_lower
thf(fact_2737_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: int,X2: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N2 ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N2 ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X2 )
              = ( plus_plus @ int @ N2 @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_2738_sin__gt__zero2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_gt_zero2
thf(fact_2739_sin__lt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ pi @ X2 )
     => ( ( ord_less @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_2740_cos__double__less__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_2741_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_2742_cos__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X2 ) ) ) ) ).

% cos_gt_zero
thf(fact_2743_sin__monotone__2pi__le,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y2 ) @ ( sin @ real @ X2 ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_2744_sin__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ ( sin @ real @ Y2 ) )
              = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_2745_sin__inj__pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X2 )
                = ( sin @ real @ Y2 ) )
             => ( X2 = Y2 ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_2746_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_2747_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_2748_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_2749_cos__one__2pi__int,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( one_one @ real ) )
      = ( ? [X: int] :
            ( X2
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_2750_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_2751_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_2752_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X2 ) ) ) ) ) ).

% cos_treble_cos
thf(fact_2753_sin__le__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ pi @ X2 )
     => ( ( ord_less @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_2754_sin__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_2755_sin__mono__less__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X2 ) @ ( sin @ real @ Y2 ) )
              = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_2756_sin__monotone__2pi,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y2 ) @ ( sin @ real @ X2 ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_2757_sin__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X3 )
              = Y2 )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y4 )
                    = Y2 ) )
               => ( Y4 = X3 ) ) ) ) ) ).

% sin_total
thf(fact_2758_cos__gt__zero__pi,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X2 ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_2759_cos__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X2 ) ) ) ) ).

% cos_ge_zero
thf(fact_2760_cos__one__2pi,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( one_one @ real ) )
      = ( ? [X: nat] :
            ( X2
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X: nat] :
            ( X2
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_2761_sin__pi__divide__n__gt__0,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_2762_sin__arctan,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( arctan @ X2 ) )
      = ( divide_divide @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_2763_cos__arctan,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( arctan @ X2 ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_2764_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_2765_sin__zero__iff__int,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [I3: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I3 )
            & ( X2
              = ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_2766_cos__zero__iff__int,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [I3: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I3 )
            & ( X2
              = ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_2767_sin__zero__lemma,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( sin @ real @ X2 )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_2768_sin__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [N: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X2
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_2769_cos__zero__lemma,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( cos @ real @ X2 )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_2770_cos__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [N: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X2
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_2771_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_divide_numeral
thf(fact_2772_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W: num,A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_2773_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_mult_numeral2
thf(fact_2774_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_neg_numeral
thf(fact_2775_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( zero_zero @ real ) )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_2776_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
          = ( ( X2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_norm_iff
thf(fact_2777_norm__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ real ) ) ) ).

% norm_zero
thf(fact_2778_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ( real_V7770717601297561774m_norm @ A @ X2 )
            = ( zero_zero @ real ) )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% norm_eq_zero
thf(fact_2779_norm__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( numeral_numeral @ A @ W ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_numeral
thf(fact_2780_norm__minus__commute,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% norm_minus_commute
thf(fact_2781_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ~ ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( zero_zero @ real ) ) ) ).

% norm_not_less_zero
thf(fact_2782_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ).

% norm_ge_zero
thf(fact_2783_norm__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X2 @ Y2 ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_mult
thf(fact_2784_norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_divide
thf(fact_2785_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,N2: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X2 @ N2 ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ N2 ) ) ) ).

% norm_power
thf(fact_2786_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) )
          = ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% norm_uminus_minus
thf(fact_2787_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2788_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N2: nat,Z: A] :
          ( ( ( power_power @ A @ W @ N2 )
            = ( power_power @ A @ Z @ N2 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2789_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X2: A,R: real,Y2: A,S2: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ S2 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X2 @ Y2 ) ) @ ( times_times @ real @ R @ S2 ) ) ) ) ) ).

% norm_mult_less
thf(fact_2790_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X2 @ Y2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_mult_ineq
thf(fact_2791_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E2 )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ E2 ) ) ) ).

% norm_triangle_lt
thf(fact_2792_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,R: real,Y2: A,S2: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ S2 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( plus_plus @ real @ R @ S2 ) ) ) ) ) ).

% norm_add_less
thf(fact_2793_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: A,N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X2 @ N2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ N2 ) ) ) ).

% norm_power_ineq
thf(fact_2794_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2795_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ E2 ) ) ) ).

% norm_triangle_le
thf(fact_2796_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2797_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R: real,B2: A,S2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S2 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R @ S2 ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2798_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E1: real,Z: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ Z ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_2799_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) ) ) ) ).

% norm_triangle_sub
thf(fact_2800_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_triangle_ineq4
thf(fact_2801_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E1: real,Z: A,E22: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ E1 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ Z ) ) @ E22 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_le
thf(fact_2802_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ E2 ) ) ) ).

% norm_triangle_le_diff
thf(fact_2803_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2804_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq2
thf(fact_2805_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N2: nat] :
          ( ( ( power_power @ A @ W @ N2 )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( one_one @ real ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2806_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D3 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D3 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2807_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq3
thf(fact_2808_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X2 )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2809_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A,W: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z @ M ) @ ( power_power @ A @ W @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z @ W ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_2810_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_2811_sin__tan,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X2 )
        = ( divide_divide @ real @ ( tan @ real @ X2 ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_2812_cos__tan,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X2 )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_2813_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z
               != ( complex2 @ ( cos @ real @ T4 ) @ ( sin @ real @ T4 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_2814_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X ) ) @ ( archimedean_ceiling @ A @ X ) @ ( archim6421214686448440834_floor @ A @ X ) ) ) ) ) ).

% round_altdef
thf(fact_2815_ceiling__log__eq__powr__iff,axiom,
    ! [X2: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X2 ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_2816_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [W: A,Z: A] :
          ( ( ( powr @ A @ W @ Z )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) ).

% powr_eq_0_iff
thf(fact_2817_powr__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [Z: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z )
          = ( zero_zero @ A ) ) ) ).

% powr_0
thf(fact_2818_tan__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tan_zero
thf(fact_2819_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X2: A] :
          ( ( ( X2
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X2 @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X2
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X2 @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_2820_powr__gt__zero,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X2 @ A2 ) )
      = ( ( X2
         != ( zero_zero @ real ) ) ) ) ).

% powr_gt_zero
thf(fact_2821_powr__nonneg__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A2 @ X2 ) @ ( zero_zero @ real ) )
      = ( A2
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_2822_powr__less__cancel__iff,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_2823_tan__pi,axiom,
    ( ( tan @ real @ pi )
    = ( zero_zero @ real ) ) ).

% tan_pi
thf(fact_2824_frac__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archimedean_frac @ A @ ( ring_1_of_int @ A @ Z ) )
          = ( zero_zero @ A ) ) ) ).

% frac_of_int
thf(fact_2825_tan__periodic__pi,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ pi ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_pi
thf(fact_2826_powr__eq__one__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X2 )
          = ( one_one @ real ) )
        = ( X2
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_2827_powr__one,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( one_one @ real ) )
        = X2 ) ) ).

% powr_one
thf(fact_2828_powr__one__gt__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( powr @ real @ X2 @ ( one_one @ real ) )
        = X2 )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% powr_one_gt_zero_iff
thf(fact_2829_powr__le__cancel__iff,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_2830_numeral__powr__numeral__real,axiom,
    ! [M: num,N2: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N2 ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% numeral_powr_numeral_real
thf(fact_2831_log__powr__cancel,axiom,
    ! [A2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( powr @ real @ A2 @ Y2 ) )
          = Y2 ) ) ) ).

% log_powr_cancel
thf(fact_2832_powr__log__cancel,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( powr @ real @ A2 @ ( log @ A2 @ X2 ) )
            = X2 ) ) ) ) ).

% powr_log_cancel
thf(fact_2833_tan__npi,axiom,
    ! [N2: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_2834_tan__periodic__n,axiom,
    ! [X2: real,N2: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ N2 ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_n
thf(fact_2835_tan__periodic__nat,axiom,
    ! [X2: real,N2: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_nat
thf(fact_2836_tan__periodic__int,axiom,
    ! [X2: real,I: int] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( ring_1_of_int @ real @ I ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_int
thf(fact_2837_powr__numeral,axiom,
    ! [X2: real,N2: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( numeral_numeral @ real @ N2 ) )
        = ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ N2 ) ) ) ) ).

% powr_numeral
thf(fact_2838_tan__periodic,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic
thf(fact_2839_square__powr__half,axiom,
    ! [X2: real] :
      ( ( powr @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X2 ) ) ).

% square_powr_half
thf(fact_2840_powr__powr,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X2 @ A2 ) @ B2 )
      = ( powr @ real @ X2 @ ( times_times @ real @ A2 @ B2 ) ) ) ).

% powr_powr
thf(fact_2841_zero__complex_Ocode,axiom,
    ( ( zero_zero @ complex )
    = ( complex2 @ ( zero_zero @ real ) @ ( zero_zero @ real ) ) ) ).

% zero_complex.code
thf(fact_2842_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( zero_zero @ complex ) )
      = ( ( A2
          = ( zero_zero @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_0
thf(fact_2843_complex__diff,axiom,
    ! [A2: real,B2: real,C2: real,D3: real] :
      ( ( minus_minus @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D3 ) )
      = ( complex2 @ ( minus_minus @ real @ A2 @ C2 ) @ ( minus_minus @ real @ B2 @ D3 ) ) ) ).

% complex_diff
thf(fact_2844_powr__less__mono2__neg,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ X2 @ Y2 )
         => ( ord_less @ real @ ( powr @ real @ Y2 @ A2 ) @ ( powr @ real @ X2 @ A2 ) ) ) ) ) ).

% powr_less_mono2_neg
thf(fact_2845_powr__non__neg,axiom,
    ! [A2: real,X2: real] :
      ~ ( ord_less @ real @ ( powr @ real @ A2 @ X2 ) @ ( zero_zero @ real ) ) ).

% powr_non_neg
thf(fact_2846_powr__ge__pzero,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X2 @ Y2 ) ) ).

% powr_ge_pzero
thf(fact_2847_powr__mono2,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ Y2 )
         => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_mono2
thf(fact_2848_powr__less__mono,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
       => ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_2849_powr__less__cancel,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_2850_powr__mono,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
       => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) ) ) ) ).

% powr_mono
thf(fact_2851_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_2852_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_2853_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( numeral_numeral @ complex @ W ) )
      = ( ( A2
          = ( numeral_numeral @ real @ W ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_2854_complex__add,axiom,
    ! [A2: real,B2: real,C2: real,D3: real] :
      ( ( plus_plus @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D3 ) )
      = ( complex2 @ ( plus_plus @ real @ A2 @ C2 ) @ ( plus_plus @ real @ B2 @ D3 ) ) ) ).

% complex_add
thf(fact_2855_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X2 ) ) ) ).

% frac_ge_0
thf(fact_2856_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X2 ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_2857_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X2 ) ) ) ).

% frac_1_eq
thf(fact_2858_powr__less__mono2,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ X2 @ Y2 )
         => ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_2859_powr__mono2_H,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ Y2 )
         => ( ord_less_eq @ real @ ( powr @ real @ Y2 @ A2 ) @ ( powr @ real @ X2 @ A2 ) ) ) ) ) ).

% powr_mono2'
thf(fact_2860_powr__inj,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X2 )
            = ( powr @ real @ A2 @ Y2 ) )
          = ( X2 = Y2 ) ) ) ) ).

% powr_inj
thf(fact_2861_gr__one__powr,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X2 @ Y2 ) ) ) ) ).

% gr_one_powr
thf(fact_2862_powr__le1,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_2863_powr__mono__both,axiom,
    ! [A2: real,B2: real,X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
         => ( ( ord_less_eq @ real @ X2 @ Y2 )
           => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_2864_ge__one__powr__ge__zero,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X2 @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_2865_powr__divide,axiom,
    ! [X2: real,Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( powr @ real @ ( divide_divide @ real @ X2 @ Y2 ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_2866_powr__mult,axiom,
    ! [X2: real,Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( powr @ real @ ( times_times @ real @ X2 @ Y2 ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_2867_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] :
      ( ( divide_divide @ real @ A2 @ ( powr @ real @ B2 @ C2 ) )
      = ( times_times @ real @ A2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ C2 ) ) ) ) ).

% divide_powr_uminus
thf(fact_2868_log__base__powr,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( A2
       != ( zero_zero @ real ) )
     => ( ( log @ ( powr @ real @ A2 @ B2 ) @ X2 )
        = ( divide_divide @ real @ ( log @ A2 @ X2 ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_2869_ln__powr,axiom,
    ! [X2: real,Y2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X2 @ Y2 ) )
        = ( times_times @ real @ Y2 @ ( ln_ln @ real @ X2 ) ) ) ) ).

% ln_powr
thf(fact_2870_log__powr,axiom,
    ! [X2: real,B2: real,Y2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X2 @ Y2 ) )
        = ( times_times @ real @ Y2 @ ( log @ B2 @ X2 ) ) ) ) ).

% log_powr
thf(fact_2871_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_2872_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_2873_powr__add,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X2: A,A2: A,B2: A] :
          ( ( powr @ A @ X2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( powr @ A @ X2 @ A2 ) @ ( powr @ A @ X2 @ B2 ) ) ) ) ).

% powr_add
thf(fact_2874_powr__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [W: A,Z1: A,Z22: A] :
          ( ( powr @ A @ W @ ( minus_minus @ A @ Z1 @ Z22 ) )
          = ( divide_divide @ A @ ( powr @ A @ W @ Z1 ) @ ( powr @ A @ W @ Z22 ) ) ) ) ).

% powr_diff
thf(fact_2875_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D3: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D3 ) )
      = ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ A2 @ C2 ) @ ( times_times @ real @ B2 @ D3 ) ) @ ( plus_plus @ real @ ( times_times @ real @ A2 @ D3 ) @ ( times_times @ real @ B2 @ C2 ) ) ) ) ).

% complex_mult
thf(fact_2876_tan__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X: A] : ( divide_divide @ A @ ( sin @ A @ X ) @ ( cos @ A @ X ) ) ) ) ) ).

% tan_def
thf(fact_2877_powr__realpow,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( semiring_1_of_nat @ real @ N2 ) )
        = ( power_power @ real @ X2 @ N2 ) ) ) ).

% powr_realpow
thf(fact_2878_less__log__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ Y2 @ ( log @ B2 @ X2 ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ).

% less_log_iff
thf(fact_2879_log__less__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( log @ B2 @ X2 ) @ Y2 )
          = ( ord_less @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ).

% log_less_iff
thf(fact_2880_less__powr__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) )
          = ( ord_less @ real @ ( log @ B2 @ X2 ) @ Y2 ) ) ) ) ).

% less_powr_iff
thf(fact_2881_powr__less__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 )
          = ( ord_less @ real @ Y2 @ ( log @ B2 @ X2 ) ) ) ) ) ).

% powr_less_iff
thf(fact_2882_frac__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_frac @ A )
        = ( ^ [X: A] : ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) ) ) ) ) ).

% frac_def
thf(fact_2883_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X2: A,A2: A] :
          ( ( powr @ A @ X2 @ ( uminus_uminus @ A @ A2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( powr @ A @ X2 @ A2 ) ) ) ) ).

% powr_minus_divide
thf(fact_2884_powr__neg__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% powr_neg_one
thf(fact_2885_powr__mult__base,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( times_times @ real @ X2 @ ( powr @ real @ X2 @ Y2 ) )
        = ( powr @ real @ X2 @ ( plus_plus @ real @ ( one_one @ real ) @ Y2 ) ) ) ) ).

% powr_mult_base
thf(fact_2886_le__log__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( log @ B2 @ X2 ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ).

% le_log_iff
thf(fact_2887_log__le__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X2 ) @ Y2 )
          = ( ord_less_eq @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ).

% log_le_iff
thf(fact_2888_le__powr__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X2 ) @ Y2 ) ) ) ) ).

% le_powr_iff
thf(fact_2889_powr__le__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 )
          = ( ord_less_eq @ real @ Y2 @ ( log @ B2 @ X2 ) ) ) ) ) ).

% powr_le_iff
thf(fact_2890_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( archimedean_frac @ A @ X2 )
            = X2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
            & ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_2891_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_2892_ln__powr__bound,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( divide_divide @ real @ ( powr @ real @ X2 @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_2893_ln__powr__bound2,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X2 ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X2 ) ) ) ) ).

% ln_powr_bound2
thf(fact_2894_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_2895_log__add__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( plus_plus @ real @ ( log @ B2 @ X2 ) @ Y2 )
            = ( log @ B2 @ ( times_times @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_2896_add__log__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( plus_plus @ real @ Y2 @ ( log @ B2 @ X2 ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_2897_minus__log__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( minus_minus @ real @ Y2 @ ( log @ B2 @ X2 ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_2898_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_2899_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X: A,A4: A] :
              ( if @ A
              @ ( X
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A4 @ ( ln_ln @ A @ X ) ) ) ) ) ) ) ).

% powr_def
thf(fact_2900_tan__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X2 ) ) ) ) ).

% tan_gt_zero
thf(fact_2901_lemma__tan__total,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X3: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y2 @ ( tan @ real @ X3 ) ) ) ) ).

% lemma_tan_total
thf(fact_2902_tan__total,axiom,
    ! [Y2: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y2 )
      & ! [Y4: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y4 )
            & ( ord_less @ real @ Y4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y4 )
              = Y2 ) )
         => ( Y4 = X3 ) ) ) ).

% tan_total
thf(fact_2903_tan__monotone,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y2 ) @ ( tan @ real @ X2 ) ) ) ) ) ).

% tan_monotone
thf(fact_2904_tan__monotone_H,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
         => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y2 @ X2 )
              = ( ord_less @ real @ ( tan @ real @ Y2 ) @ ( tan @ real @ X2 ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_2905_tan__mono__lt__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X2 ) @ ( tan @ real @ Y2 ) )
              = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_2906_lemma__tan__total1,axiom,
    ! [Y2: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y2 ) ) ).

% lemma_tan_total1
thf(fact_2907_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_2908_tan__inverse,axiom,
    ! [Y2: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y2 ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 ) ) ) ).

% tan_inverse
thf(fact_2909_log__minus__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( minus_minus @ real @ ( log @ B2 @ X2 ) @ Y2 )
            = ( log @ B2 @ ( times_times @ real @ X2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y2 ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_2910_complex__norm,axiom,
    ! [X2: real,Y2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X2 @ Y2 ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_2911_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_2912_powr__half__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X2 ) ) ) ).

% powr_half_sqrt
thf(fact_2913_powr__neg__numeral,axiom,
    ! [X2: real,N2: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N2 ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_2914_tan__total__pos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X3 )
            = Y2 ) ) ) ).

% tan_total_pos
thf(fact_2915_tan__pos__pi2__le,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X2 ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_2916_tan__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_2917_tan__mono__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X2 ) @ ( tan @ real @ Y2 ) ) ) ) ) ).

% tan_mono_le
thf(fact_2918_tan__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X2 ) @ ( tan @ real @ Y2 ) )
              = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_2919_tan__bound__pi2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X2 ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_2920_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_2921_arctan,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) )
      & ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y2 ) )
        = Y2 ) ) ).

% arctan
thf(fact_2922_arctan__tan,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X2 ) )
          = X2 ) ) ) ).

% arctan_tan
thf(fact_2923_arctan__unique,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X2 )
            = Y2 )
         => ( ( arctan @ Y2 )
            = X2 ) ) ) ) ).

% arctan_unique
thf(fact_2924_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_2925_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_2926_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_2927_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_2928_tan__total__pi4,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ? [Z3: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z3 )
          & ( ord_less @ real @ Z3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z3 )
            = X2 ) ) ) ).

% tan_total_pi4
thf(fact_2929_floor__log__eq__powr__iff,axiom,
    ! [X2: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X2 ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X2 )
            & ( ord_less @ real @ X2 @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_2930_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_2931_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X: A] : ( ln_ln @ A @ ( plus_plus @ A @ X @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_2932_cos__arcsin,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X2 ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_2933_sin__arccos__abs,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y2 ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_2934_sin__arccos,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X2 ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_2935_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X: A] : ( ln_ln @ A @ ( plus_plus @ A @ X @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_2936_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N2 ) ) ) ) ).

% pochhammer_double
thf(fact_2937_arcsin__0,axiom,
    ( ( arcsin @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arcsin_0
thf(fact_2938_pochhammer__1,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% pochhammer_1
thf(fact_2939_of__real__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( zero_zero @ real ) )
        = ( zero_zero @ A ) ) ) ).

% of_real_0
thf(fact_2940_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real] :
          ( ( ( real_Vector_of_real @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( X2
            = ( zero_zero @ real ) ) ) ) ).

% of_real_eq_0_iff
thf(fact_2941_of__real__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X2 @ Y2 ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_mult
thf(fact_2942_of__real__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( numeral_numeral @ real @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_real_numeral
thf(fact_2943_of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X2 @ Y2 ) )
          = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_divide
thf(fact_2944_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,N2: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X2 @ N2 ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X2 ) @ N2 ) ) ) ).

% of_real_power
thf(fact_2945_of__real__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_add
thf(fact_2946_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_2947_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% pochhammer_Suc0
thf(fact_2948_of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( minus_minus @ real @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_diff
thf(fact_2949_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_2950_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( zero_zero @ A ) ) ) ).

% sin_of_real_pi
thf(fact_2951_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_real_neg_numeral
thf(fact_2952_cos__arccos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y2 ) )
          = Y2 ) ) ) ).

% cos_arccos
thf(fact_2953_sin__arcsin,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y2 ) )
          = Y2 ) ) ) ).

% sin_arcsin
thf(fact_2954_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: real] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X2 @ ( one_one @ real ) ) ) ) ) ).

% norm_of_real_add1
thf(fact_2955_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X2 @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_2956_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_2957_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_2958_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_2959_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_2960_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_2961_pochhammer__of__nat,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: nat,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( semiring_1_of_nat @ A @ X2 ) @ N2 )
          = ( semiring_1_of_nat @ A @ ( comm_s3205402744901411588hammer @ nat @ X2 @ N2 ) ) ) ) ).

% pochhammer_of_nat
thf(fact_2962_pochhammer__of__int,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: int,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( ring_1_of_int @ A @ X2 ) @ N2 )
          = ( ring_1_of_int @ A @ ( comm_s3205402744901411588hammer @ int @ X2 @ N2 ) ) ) ) ).

% pochhammer_of_int
thf(fact_2963_complex__exp__exists,axiom,
    ! [Z: complex] :
    ? [A6: complex,R2: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( exp @ complex @ A6 ) ) ) ).

% complex_exp_exists
thf(fact_2964_complex__eq__cancel__iff2,axiom,
    ! [X2: real,Y2: real,Xa: real] :
      ( ( ( complex2 @ X2 @ Y2 )
        = ( real_Vector_of_real @ complex @ Xa ) )
      = ( ( X2 = Xa )
        & ( Y2
          = ( zero_zero @ real ) ) ) ) ).

% complex_eq_cancel_iff2
thf(fact_2965_complex__of__real__code,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [X: real] : ( complex2 @ X @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_code
thf(fact_2966_complex__of__real__def,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [R5: real] : ( complex2 @ R5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_def
thf(fact_2967_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X2 @ N2 ) ) ) ) ).

% pochhammer_pos
thf(fact_2968_Complex__mult__complex__of__real,axiom,
    ! [X2: real,Y2: real,R: real] :
      ( ( times_times @ complex @ ( complex2 @ X2 @ Y2 ) @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( times_times @ real @ X2 @ R ) @ ( times_times @ real @ Y2 @ R ) ) ) ).

% Complex_mult_complex_of_real
thf(fact_2969_complex__of__real__mult__Complex,axiom,
    ! [R: real,X2: real,Y2: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( complex2 @ X2 @ Y2 ) )
      = ( complex2 @ ( times_times @ real @ R @ X2 ) @ ( times_times @ real @ R @ Y2 ) ) ) ).

% complex_of_real_mult_Complex
thf(fact_2970_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_2971_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_2972_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y2: real,X2: real] :
          ( ( Y2
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X2 @ Y2 ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_2973_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X2 @ N2 ) ) ) ) ).

% pochhammer_nonneg
thf(fact_2974_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_2975_Complex__add__complex__of__real,axiom,
    ! [X2: real,Y2: real,R: real] :
      ( ( plus_plus @ complex @ ( complex2 @ X2 @ Y2 ) @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( plus_plus @ real @ X2 @ R ) @ Y2 ) ) ).

% Complex_add_complex_of_real
thf(fact_2976_complex__of__real__add__Complex,axiom,
    ! [R: real,X2: real,Y2: real] :
      ( ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( complex2 @ X2 @ Y2 ) )
      = ( complex2 @ ( plus_plus @ real @ R @ X2 ) @ Y2 ) ) ).

% complex_of_real_add_Complex
thf(fact_2977_arccos__le__arccos,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ ( arccos @ X2 ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_2978_arccos__le__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X2 ) @ ( arccos @ Y2 ) )
          = ( ord_less_eq @ real @ Y2 @ X2 ) ) ) ) ).

% arccos_le_mono
thf(fact_2979_arccos__eq__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X2 )
          = ( arccos @ Y2 ) )
        = ( X2 = Y2 ) ) ) ).

% arccos_eq_iff
thf(fact_2980_arcsin__minus,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X2 ) )
          = ( uminus_uminus @ real @ ( arcsin @ X2 ) ) ) ) ) ).

% arcsin_minus
thf(fact_2981_arcsin__le__arcsin,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_2982_arcsin__le__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) )
          = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ).

% arcsin_le_mono
thf(fact_2983_arcsin__eq__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X2 )
            = ( arcsin @ Y2 ) )
          = ( X2 = Y2 ) ) ) ) ).

% arcsin_eq_iff
thf(fact_2984_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_2985_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ A2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ N2 ) ) ) ) ).

% pochhammer_rec
thf(fact_2986_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N2 ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N2 ) ) ) ) ).

% pochhammer_rec'
thf(fact_2987_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N2 ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_2988_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ? [K3: nat] :
                ( ( ord_less @ nat @ K3 @ N2 )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K3 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_2989_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N2: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N2 @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_2990_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,K: nat] :
          ( ( ord_less @ nat @ N2 @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_2991_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_2992_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N2: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( plus_plus @ nat @ N2 @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ N2 ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N2 ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_2993_arccos__lbound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) ) ) ) ).

% arccos_lbound
thf(fact_2994_arccos__less__arccos,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y2 ) @ ( arccos @ X2 ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_2995_arccos__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X2 ) @ ( arccos @ Y2 ) )
          = ( ord_less @ real @ Y2 @ X2 ) ) ) ) ).

% arccos_less_mono
thf(fact_2996_arccos__ubound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_2997_arccos__cos,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( arccos @ ( cos @ real @ X2 ) )
          = X2 ) ) ) ).

% arccos_cos
thf(fact_2998_arcsin__less__arcsin,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_2999_arcsin__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) )
          = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ).

% arcsin_less_mono
thf(fact_3000_cos__arccos__abs,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y2 ) )
        = Y2 ) ) ).

% cos_arccos_abs
thf(fact_3001_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [B2: real,A2: real] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( real_Vector_of_real @ A @ B2 ) @ ( real_Vector_of_real @ A @ A2 ) ) ) @ ( abs_abs @ real @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ).

% norm_of_real_diff
thf(fact_3002_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Theta ) @ pi )
     => ( ( arccos @ ( cos @ real @ Theta ) )
        = ( abs_abs @ real @ Theta ) ) ) ).

% arccos_cos_eq_abs
thf(fact_3003_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N2: nat,Z: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( comm_s3205402744901411588hammer @ A @ Z @ N2 )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_3004_arccos__lt__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less @ real @ ( arccos @ Y2 ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3005_arccos__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3006_sin__arccos__nonzero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X2 ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3007_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X2: real] :
          ( ( cos @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X2 ) ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X2 ) ) ) ) ) ).

% cos_int_times_real
thf(fact_3008_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X2: real] :
          ( ( sin @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X2 ) ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X2 ) ) ) ) ) ).

% sin_int_times_real
thf(fact_3009_arccos__cos2,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X2 )
       => ( ( arccos @ ( cos @ real @ X2 ) )
          = ( uminus_uminus @ real @ X2 ) ) ) ) ).

% arccos_cos2
thf(fact_3010_arccos__minus,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X2 ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X2 ) ) ) ) ) ).

% arccos_minus
thf(fact_3011_cos__arcsin__nonzero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X2 ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_3012_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R ) @ K ) )
          = ( times_times @ A @ R @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_3013_arccos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y2 ) )
            = Y2 ) ) ) ) ).

% arccos
thf(fact_3014_arccos__minus__abs,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X2 ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X2 ) ) ) ) ).

% arccos_minus_abs
thf(fact_3015_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_3016_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_3017_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X ) ) ) ) ) ).

% sin_cos_eq
thf(fact_3018_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X ) ) ) ) ) ).

% cos_sin_eq
thf(fact_3019_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X2 ) )
          = ( cos @ A @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_3020_arccos__le__pi2,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3021_arcsin__lt__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_3022_arcsin__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_3023_arcsin__ubound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_3024_arcsin__lbound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) ) ) ) ).

% arcsin_lbound
thf(fact_3025_arcsin__sin,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X2 ) )
          = X2 ) ) ) ).

% arcsin_sin
thf(fact_3026_le__arcsin__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y2 @ ( arcsin @ X2 ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y2 ) @ X2 ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_3027_arcsin__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X2 ) @ Y2 )
              = ( ord_less_eq @ real @ X2 @ ( sin @ real @ Y2 ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_3028_arcsin__pi,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y2 ) )
            = Y2 ) ) ) ) ).

% arcsin_pi
thf(fact_3029_arcsin,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y2 ) )
            = Y2 ) ) ) ) ).

% arcsin
thf(fact_3030_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K2: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3031_central__binomial__lower__bound,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_3032_cot__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_3033_cot__periodic,axiom,
    ! [X2: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X2 ) ) ).

% cot_periodic
thf(fact_3034_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_double
thf(fact_3035_modulo__int__unfold,axiom,
    ! [L2: int,K: int,N2: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L2 )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N2
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L2 )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L2 ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L2 ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L2 )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N2
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_3036_sgn__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% sgn_sgn
thf(fact_3037_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_3038_sgn__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_zero
thf(fact_3039_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_3040_sgn__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_divide
thf(fact_3041_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% idom_abs_sgn_class.sgn_minus
thf(fact_3042_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N2 ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N2 ) ) ) ).

% power_sgn
thf(fact_3043_of__nat__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( semiring_char_0_fact @ nat @ N2 ) )
          = ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% of_nat_fact
thf(fact_3044_of__int__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( ring_1 @ A ) )
     => ! [N2: nat] :
          ( ( ring_1_of_int @ A @ ( semiring_char_0_fact @ int @ N2 ) )
          = ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% of_int_fact
thf(fact_3045_cot__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% cot_zero
thf(fact_3046_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_3047_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_3048_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A2 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_3049_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_3050_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_3051_cot__pi,axiom,
    ( ( cot @ real @ pi )
    = ( zero_zero @ real ) ) ).

% cot_pi
thf(fact_3052_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_3053_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_3054_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_3055_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_Suc
thf(fact_3056_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_3057_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_3058_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_3059_sgn__mult__dvd__iff,axiom,
    ! [R: int,L2: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ L2 ) @ K )
      = ( ( dvd_dvd @ int @ L2 @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_3060_mult__sgn__dvd__iff,axiom,
    ! [L2: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L2 @ ( sgn_sgn @ int @ R ) ) @ K )
      = ( ( dvd_dvd @ int @ L2 @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_3061_dvd__sgn__mult__iff,axiom,
    ! [L2: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ L2 @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ K ) )
      = ( ( dvd_dvd @ int @ L2 @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_3062_dvd__mult__sgn__iff,axiom,
    ! [L2: int,K: int,R: int] :
      ( ( dvd_dvd @ int @ L2 @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R ) ) )
      = ( ( dvd_dvd @ int @ L2 @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_3063_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_3064_fact__2,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% fact_2
thf(fact_3065_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% sgn_of_nat
thf(fact_3066_cot__npi,axiom,
    ! [N2: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_3067_fact__ge__self,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( semiring_char_0_fact @ nat @ N2 ) ) ).

% fact_ge_self
thf(fact_3068_fact__mono__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ).

% fact_mono_nat
thf(fact_3069_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ( sgn_sgn @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_zero_iff
thf(fact_3070_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_3071_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_3072_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X2 @ Y2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X2 ) @ ( sgn_sgn @ A @ Y2 ) ) ) ) ).

% Real_Vector_Spaces.sgn_mult
thf(fact_3073_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_3074_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( sgn_sgn @ A @ A2 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_3075_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ N2 )
         != ( zero_zero @ A ) ) ) ).

% fact_nonzero
thf(fact_3076_fact__less__mono__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N2 )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ) ).

% fact_less_mono_nat
thf(fact_3077_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A2 ) )
         => ( ( ( sgn_sgn @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A2 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_3078_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_3079_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_ge_zero
thf(fact_3080_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K3: A] : ( times_times @ A @ K3 @ ( sgn_sgn @ A @ K3 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_3081_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = A2 ) ) ).

% abs_mult_sgn
thf(fact_3082_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = A2 ) ) ).

% sgn_mult_abs
thf(fact_3083_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X2 ) @ ( abs_abs @ A @ X2 ) )
          = X2 ) ) ).

% mult_sgn_abs
thf(fact_3084_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_gt_zero
thf(fact_3085_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_3086_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N3: nat,L3: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L3 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_sgnE
thf(fact_3087_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_3088_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_ge_1
thf(fact_3089_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_mono
thf(fact_3090_div__eq__sgn__abs,axiom,
    ! [K: int,L2: int] :
      ( ( ( sgn_sgn @ int @ K )
        = ( sgn_sgn @ int @ L2 ) )
     => ( ( divide_divide @ int @ K @ L2 )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) ) ) ).

% div_eq_sgn_abs
thf(fact_3091_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ M ) ) ) ) ).

% fact_dvd
thf(fact_3092_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_3093_fact__ge__Suc__0__nat,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ).

% fact_ge_Suc_0_nat
thf(fact_3094_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_3095_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_3096_dvd__fact,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( dvd_dvd @ nat @ M @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ) ).

% dvd_fact
thf(fact_3097_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N2 )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ) ).

% fact_less_mono
thf(fact_3098_sgn__mod,axiom,
    ! [L2: int,K: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L2 @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L2 ) )
          = ( sgn_sgn @ int @ L2 ) ) ) ) ).

% sgn_mod
thf(fact_3099_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_3100_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N2 @ N2 ) ) ) ) ).

% fact_le_power
thf(fact_3101_fact__diff__Suc,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N2 ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N2 ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_3102_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X: A] :
              ( if @ A
              @ ( X
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_3103_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_3104_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I3: int] :
          ( if @ int
          @ ( I3
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I3 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_3105_fact__div__fact__le__pow,axiom,
    ! [R: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ R @ N2 )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N2 ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ R ) ) ) @ ( power_power @ nat @ N2 @ R ) ) ) ).

% fact_div_fact_le_pow
thf(fact_3106_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ( X2
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X2 ) )
              = ( zero_zero @ real ) ) )
          & ( ( X2
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X2 ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_3107_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L2: int] :
      ( ( V
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ L2 ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_3108_div__dvd__sgn__abs,axiom,
    ! [L2: int,K: int] :
      ( ( dvd_dvd @ int @ L2 @ K )
     => ( ( divide_divide @ int @ K @ L2 )
        = ( times_times @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( sgn_sgn @ int @ L2 ) ) @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) ) ) ) ).

% div_dvd_sgn_abs
thf(fact_3109_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_3110_binomial__mono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N2 )
       => ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ K7 ) ) ) ) ).

% binomial_mono
thf(fact_3111_binomial__maximum_H,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ).

% binomial_maximum'
thf(fact_3112_binomial__maximum,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_3113_binomial__antimono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K7 @ N2 )
         => ( ord_less_eq @ nat @ ( binomial @ N2 @ K7 ) @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_3114_cot__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X: A] : ( divide_divide @ A @ ( cos @ A @ X ) @ ( sin @ A @ X ) ) ) ) ) ).

% cot_def
thf(fact_3115_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_3116_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N2 )
       => ( ord_less @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ K7 ) ) ) ) ).

% binomial_strict_mono
thf(fact_3117_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ N2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K7 @ N2 )
         => ( ord_less @ nat @ ( binomial @ N2 @ K7 ) @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_3118_central__binomial__odd,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( binomial @ N2 @ ( suc @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_3119_square__fact__le__2__fact,axiom,
    ! [N2: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N2 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% square_fact_le_2_fact
thf(fact_3120_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M3 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_3121_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( semiring_char_0_fact @ A @ N2 )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_3122_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% pochhammer_same
thf(fact_3123_div__noneq__sgn__abs,axiom,
    ! [L2: int,K: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L2 ) )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L2 @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_3124_cot__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X2 ) ) ) ) ).

% cot_gt_zero
thf(fact_3125_tan__cot_H,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) )
      = ( cot @ real @ X2 ) ) ).

% tan_cot'
thf(fact_3126_divide__int__unfold,axiom,
    ! [L2: int,K: int,N2: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L2 )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N2
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L2 )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L2 ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N2 ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L2 ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N2 )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_3127_zero__less__binomial__iff,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N2 @ K ) )
      = ( ord_less_eq @ nat @ K @ N2 ) ) ).

% zero_less_binomial_iff
thf(fact_3128_choose__two,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_3129_binomial__n__0,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_3130_binomial__Suc__Suc,axiom,
    ! [N2: nat,K: nat] :
      ( ( binomial @ ( suc @ N2 ) @ ( suc @ K ) )
      = ( plus_plus @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) ) ) ).

% binomial_Suc_Suc
thf(fact_3131_binomial__eq__0__iff,axiom,
    ! [N2: nat,K: nat] :
      ( ( ( binomial @ N2 @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N2 @ K ) ) ).

% binomial_eq_0_iff
thf(fact_3132_sgn__le__0__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_3133_zero__le__sgn__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% zero_le_sgn_iff
thf(fact_3134_binomial__Suc__n,axiom,
    ! [N2: nat] :
      ( ( binomial @ ( suc @ N2 ) @ N2 )
      = ( suc @ N2 ) ) ).

% binomial_Suc_n
thf(fact_3135_binomial__0__Suc,axiom,
    ! [K: nat] :
      ( ( binomial @ ( zero_zero @ nat ) @ ( suc @ K ) )
      = ( zero_zero @ nat ) ) ).

% binomial_0_Suc
thf(fact_3136_binomial__1,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = N2 ) ).

% binomial_1
thf(fact_3137_real__sgn__eq,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [X: real] : ( divide_divide @ real @ X @ ( abs_abs @ real @ X ) ) ) ) ).

% real_sgn_eq
thf(fact_3138_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A4: real] :
          ( if @ real
          @ ( A4
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A4 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_3139_sgn__power__injE,axiom,
    ! [A2: real,N2: nat,X2: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N2 ) )
        = X2 )
     => ( ( X2
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N2 ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_3140_arctan__inverse,axiom,
    ! [X2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X2 ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X2 ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X2 ) ) ) ) ).

% arctan_inverse
thf(fact_3141_binomial__eq__0,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ N2 @ K )
     => ( ( binomial @ N2 @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_3142_Suc__times__binomial,axiom,
    ! [K: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ ( suc @ N2 ) @ ( suc @ K ) ) )
      = ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) ) ) ).

% Suc_times_binomial
thf(fact_3143_Suc__times__binomial__eq,axiom,
    ! [N2: nat,K: nat] :
      ( ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) )
      = ( times_times @ nat @ ( binomial @ ( suc @ N2 ) @ ( suc @ K ) ) @ ( suc @ K ) ) ) ).

% Suc_times_binomial_eq
thf(fact_3144_binomial__symmetric,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( binomial @ N2 @ K )
        = ( binomial @ N2 @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_3145_choose__mult__lemma,axiom,
    ! [M: nat,R: nat,K: nat] :
      ( ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ ( plus_plus @ nat @ M @ K ) ) @ ( binomial @ ( plus_plus @ nat @ M @ K ) @ K ) )
      = ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ K ) @ ( binomial @ ( plus_plus @ nat @ M @ R ) @ M ) ) ) ).

% choose_mult_lemma
thf(fact_3146_binomial__le__pow,axiom,
    ! [R: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ R @ N2 )
     => ( ord_less_eq @ nat @ ( binomial @ N2 @ R ) @ ( power_power @ nat @ N2 @ R ) ) ) ).

% binomial_le_pow
thf(fact_3147_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N2: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N2 ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N2 ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_3148_zero__less__binomial,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N2 @ K ) ) ) ).

% zero_less_binomial
thf(fact_3149_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( times_times @ nat @ ( suc @ A2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( suc @ A2 ) ) )
      = ( times_times @ nat @ ( suc @ B2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ A2 ) ) ) ).

% Suc_times_binomial_add
thf(fact_3150_binomial__Suc__Suc__eq__times,axiom,
    ! [N2: nat,K: nat] :
      ( ( binomial @ ( suc @ N2 ) @ ( suc @ K ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) ) @ ( suc @ K ) ) ) ).

% binomial_Suc_Suc_eq_times
thf(fact_3151_choose__mult,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ( times_times @ nat @ ( binomial @ N2 @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ ( minus_minus @ nat @ N2 @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_3152_binomial__fact__lemma,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( binomial @ N2 @ K ) )
        = ( semiring_char_0_fact @ nat @ N2 ) ) ) ).

% binomial_fact_lemma
thf(fact_3153_binomial__absorb__comp,axiom,
    ! [N2: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N2 @ K ) @ ( binomial @ N2 @ K ) )
      = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_3154_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% choose_dvd
thf(fact_3155_binomial__absorption,axiom,
    ! [K: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) )
      = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_3156_binomial__altdef__nat,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( binomial @ N2 @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N2 ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_3157_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_3158_binomial__le__pow2,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% binomial_le_pow2
thf(fact_3159_choose__reduce__nat,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N2 @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_3160_times__binomial__minus1__eq,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N2 @ K ) )
        = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_3161_binomial__addition__formula,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( binomial @ N2 @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_3162_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_3163_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_3164_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ).

% sin_coeff_def
thf(fact_3165_binomial__code,axiom,
    ( binomial
    = ( ^ [N: nat,K3: nat] : ( if @ nat @ ( ord_less @ nat @ N @ K3 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( binomial @ N @ ( minus_minus @ nat @ N @ K3 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N @ K3 ) @ ( one_one @ nat ) ) @ N @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K3 ) ) ) ) ) ) ).

% binomial_code
thf(fact_3166_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_3167_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_3168_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_3169_sin__coeff__0,axiom,
    ( ( sin_coeff @ ( zero_zero @ nat ) )
    = ( zero_zero @ real ) ) ).

% sin_coeff_0
thf(fact_3170_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_3171_complex__i__mult__minus,axiom,
    ! [X2: complex] :
      ( ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ imaginary_unit @ X2 ) )
      = ( uminus_uminus @ complex @ X2 ) ) ).

% complex_i_mult_minus
thf(fact_3172_divide__i,axiom,
    ! [X2: complex] :
      ( ( divide_divide @ complex @ X2 @ imaginary_unit )
      = ( times_times @ complex @ ( uminus_uminus @ complex @ imaginary_unit ) @ X2 ) ) ).

% divide_i
thf(fact_3173_i__squared,axiom,
    ( ( times_times @ complex @ imaginary_unit @ imaginary_unit )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% i_squared
thf(fact_3174_divide__numeral__i,axiom,
    ! [Z: complex,N2: num] :
      ( ( divide_divide @ complex @ Z @ ( times_times @ complex @ ( numeral_numeral @ complex @ N2 ) @ imaginary_unit ) )
      = ( divide_divide @ complex @ ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) @ ( numeral_numeral @ complex @ N2 ) ) ) ).

% divide_numeral_i
thf(fact_3175_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3176_i__even__power,axiom,
    ! [N2: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N2 ) ) ).

% i_even_power
thf(fact_3177_exp__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ imaginary_unit ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i
thf(fact_3178_exp__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ pi ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i'
thf(fact_3179_complex__i__not__zero,axiom,
    imaginary_unit
 != ( zero_zero @ complex ) ).

% complex_i_not_zero
thf(fact_3180_sin__coeff__Suc,axiom,
    ! [N2: nat] :
      ( ( sin_coeff @ ( suc @ N2 ) )
      = ( divide_divide @ real @ ( cos_coeff @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ).

% sin_coeff_Suc
thf(fact_3181_i__times__eq__iff,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( times_times @ complex @ imaginary_unit @ W )
        = Z )
      = ( W
        = ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) ) ) ).

% i_times_eq_iff
thf(fact_3182_cos__coeff__Suc,axiom,
    ! [N2: nat] :
      ( ( cos_coeff @ ( suc @ N2 ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ).

% cos_coeff_Suc
thf(fact_3183_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3184_Complex__eq__i,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( complex2 @ X2 @ Y2 )
        = imaginary_unit )
      = ( ( X2
          = ( zero_zero @ real ) )
        & ( Y2
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3185_i__mult__Complex,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% i_mult_Complex
thf(fact_3186_Complex__mult__i,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ imaginary_unit )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% Complex_mult_i
thf(fact_3187_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F4: nat > A > A,A4: nat,B3: nat,Acc: A] : ( if @ A @ ( ord_less @ nat @ B3 @ A4 ) @ Acc @ ( set_fo6178422350223883121st_nat @ A @ F4 @ ( plus_plus @ nat @ A4 @ ( one_one @ nat ) ) @ B3 @ ( F4 @ A4 @ Acc ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_3188_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X2: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y2: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X2 @ Xa @ Xb @ Xc )
        = Y2 )
     => ( ( ( ord_less @ nat @ Xb @ Xa )
         => ( Y2 = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb @ Xa )
         => ( Y2
            = ( set_fo6178422350223883121st_nat @ A @ X2 @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X2 @ Xa @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_3189_complex__of__real__i,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% complex_of_real_i
thf(fact_3190_i__complex__of__real,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% i_complex_of_real
thf(fact_3191_Complex__eq,axiom,
    ( complex2
    = ( ^ [A4: real,B3: real] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ A4 ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B3 ) ) ) ) ) ).

% Complex_eq
thf(fact_3192_complex__split__polar,axiom,
    ! [Z: complex] :
    ? [R2: real,A6: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A6 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A6 ) ) ) ) ) ) ).

% complex_split_polar
thf(fact_3193_cmod__unit__one,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) )
      = ( one_one @ real ) ) ).

% cmod_unit_one
thf(fact_3194_cmod__complex__polar,axiom,
    ! [R: real,A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) ) )
      = ( abs_abs @ real @ R ) ) ).

% cmod_complex_polar
thf(fact_3195_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_3196_Arg__minus__ii,axiom,
    ( ( arg @ ( uminus_uminus @ complex @ imaginary_unit ) )
    = ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_minus_ii
thf(fact_3197_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_3198_Arg__ii,axiom,
    ( ( arg @ imaginary_unit )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_ii
thf(fact_3199_cis__minus__pi__half,axiom,
    ( ( cis @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% cis_minus_pi_half
thf(fact_3200_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K3: int,L: int] :
          ( if @ int
          @ ( L
            = ( zero_zero @ int ) )
          @ K3
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L @ K3 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_3201_nat__int,axiom,
    ! [N2: nat] :
      ( ( nat2 @ ( semiring_1_of_nat @ int @ N2 ) )
      = N2 ) ).

% nat_int
thf(fact_3202_csqrt__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( csqrt @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% csqrt_eq_0
thf(fact_3203_csqrt__0,axiom,
    ( ( csqrt @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% csqrt_0
thf(fact_3204_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_3205_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3206_nat__of__bool,axiom,
    ! [P: $o] :
      ( ( nat2 @ ( zero_neq_one_of_bool @ int @ P ) )
      = ( zero_neq_one_of_bool @ nat @ P ) ) ).

% nat_of_bool
thf(fact_3207_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_3208_nat__le__0,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ Z )
        = ( zero_zero @ nat ) ) ) ).

% nat_le_0
thf(fact_3209_nat__0__iff,axiom,
    ! [I: int] :
      ( ( ( nat2 @ I )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ int @ I @ ( zero_zero @ int ) ) ) ).

% nat_0_iff
thf(fact_3210_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
        & ( ord_less @ int @ W @ Z ) ) ) ).

% zless_nat_conj
thf(fact_3211_nat__neg__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_neg_numeral
thf(fact_3212_nat__zminus__int,axiom,
    ! [N2: nat] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_zminus_int
thf(fact_3213_int__nat__eq,axiom,
    ! [Z: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = Z ) )
      & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = ( zero_zero @ int ) ) ) ) ).

% int_nat_eq
thf(fact_3214_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_3215_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% zero_less_nat_eq
thf(fact_3216_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ( semiring_1_of_nat @ A @ ( nat2 @ Z ) )
            = ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_nat_nat
thf(fact_3217_diff__nat__numeral,axiom,
    ! [V: num,V3: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( numeral_numeral @ nat @ V3 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ V3 ) ) ) ) ).

% diff_nat_numeral
thf(fact_3218_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X2: num,N2: nat,Y2: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 )
        = ( nat2 @ Y2 ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 )
        = Y2 ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_3219_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y2: int,X2: num,N2: nat] :
      ( ( ( nat2 @ Y2 )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) )
      = ( Y2
        = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_3220_dvd__nat__abs__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( dvd_dvd @ nat @ N2 @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ N2 ) @ K ) ) ).

% dvd_nat_abs_iff
thf(fact_3221_nat__abs__dvd__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N2 )
      = ( dvd_dvd @ int @ K @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% nat_abs_dvd_iff
thf(fact_3222_power2__csqrt,axiom,
    ! [Z: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z ) ).

% power2_csqrt
thf(fact_3223_nat__ceiling__le__eq,axiom,
    ! [X2: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X2 ) ) @ A2 )
      = ( ord_less_eq @ real @ X2 @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_3224_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ).

% one_less_nat_eq
thf(fact_3225_nat__numeral__diff__1,axiom,
    ! [V: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_3226_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X2: num,N2: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_3227_numeral__power__less__nat__cancel__iff,axiom,
    ! [X2: num,N2: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_3228_numeral__power__le__nat__cancel__iff,axiom,
    ! [X2: num,N2: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_3229_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X2: num,N2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_3230_cis__pi__half,axiom,
    ( ( cis @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = imaginary_unit ) ).

% cis_pi_half
thf(fact_3231_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3232_cis__Arg,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( cis @ ( arg @ Z ) )
        = ( sgn_sgn @ complex @ Z ) ) ) ).

% cis_Arg
thf(fact_3233_cis__divide,axiom,
    ! [A2: real,B2: real] :
      ( ( divide_divide @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% cis_divide
thf(fact_3234_cis__neq__zero,axiom,
    ! [A2: real] :
      ( ( cis @ A2 )
     != ( zero_zero @ complex ) ) ).

% cis_neq_zero
thf(fact_3235_nat__zero__as__int,axiom,
    ( ( zero_zero @ nat )
    = ( nat2 @ ( zero_zero @ int ) ) ) ).

% nat_zero_as_int
thf(fact_3236_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I3: num] : ( nat2 @ ( numeral_numeral @ int @ I3 ) ) ) ) ).

% nat_numeral_as_int
thf(fact_3237_nat__mono,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ X2 @ Y2 )
     => ( ord_less_eq @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ).

% nat_mono
thf(fact_3238_eq__nat__nat__iff,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
       => ( ( ( nat2 @ Z )
            = ( nat2 @ Z6 ) )
          = ( Z = Z6 ) ) ) ) ).

% eq_nat_nat_iff
thf(fact_3239_all__nat,axiom,
    ( ( ^ [P5: nat > $o] :
        ! [X7: nat] : ( P5 @ X7 ) )
    = ( ^ [P6: nat > $o] :
        ! [X: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
         => ( P6 @ ( nat2 @ X ) ) ) ) ) ).

% all_nat
thf(fact_3240_ex__nat,axiom,
    ( ( ^ [P5: nat > $o] :
        ? [X7: nat] : ( P5 @ X7 ) )
    = ( ^ [P6: nat > $o] :
        ? [X: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
          & ( P6 @ ( nat2 @ X ) ) ) ) ) ).

% ex_nat
thf(fact_3241_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M3: nat,N: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M3 @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_3242_DeMoivre,axiom,
    ! [A2: real,N2: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N2 )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_3243_nat__mask__eq,axiom,
    ! [N2: nat] :
      ( ( nat2 @ ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ).

% nat_mask_eq
thf(fact_3244_cis__Arg__unique,axiom,
    ! [Z: complex,X2: real] :
      ( ( ( sgn_sgn @ complex @ Z )
        = ( cis @ X2 ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ pi )
         => ( ( arg @ Z )
            = X2 ) ) ) ) ).

% cis_Arg_unique
thf(fact_3245_cis__mult,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% cis_mult
thf(fact_3246_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_mono_iff
thf(fact_3247_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ R @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_3248_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z ) ) ).

% zless_nat_eq_int_zless
thf(fact_3249_nat__le__iff,axiom,
    ! [X2: int,N2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X2 ) @ N2 )
      = ( ord_less_eq @ int @ X2 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% nat_le_iff
thf(fact_3250_int__eq__iff,axiom,
    ! [M: nat,Z: int] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = Z )
      = ( ( M
          = ( nat2 @ Z ) )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% int_eq_iff
thf(fact_3251_nat__0__le,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
        = Z ) ) ).

% nat_0_le
thf(fact_3252_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_3253_int__minus,axiom,
    ! [N2: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ N2 @ M ) )
      = ( semiring_1_of_nat @ int @ ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( semiring_1_of_nat @ int @ M ) ) ) ) ) ).

% int_minus
thf(fact_3254_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W @ Z ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W ) ) @ ( nat2 @ ( abs_abs @ int @ Z ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_3255_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% and_nat_def
thf(fact_3256_real__nat__ceiling__ge,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ X2 @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X2 ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_3257_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z )
          = ( cis @ ( arg @ Z ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
        & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ) ).

% Arg_correct
thf(fact_3258_Arg__zero,axiom,
    ( ( arg @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% Arg_zero
thf(fact_3259_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R ) ) ) @ R ) ) ) ).

% of_nat_floor
thf(fact_3260_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_less_eq_zless
thf(fact_3261_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% nat_le_eq_zle
thf(fact_3262_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M
        = ( nat2 @ W ) )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff2
thf(fact_3263_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ( nat2 @ W )
        = M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff
thf(fact_3264_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_3265_split__nat,axiom,
    ! [P: nat > $o,I: int] :
      ( ( P @ ( nat2 @ I ) )
      = ( ! [N: nat] :
            ( ( I
              = ( semiring_1_of_nat @ int @ N ) )
           => ( P @ N ) )
        & ( ( ord_less @ int @ I @ ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ nat ) ) ) ) ) ).

% split_nat
thf(fact_3266_le__nat__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N2 @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N2 ) @ K ) ) ) ).

% le_nat_iff
thf(fact_3267_nat__add__distrib,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
       => ( ( nat2 @ ( plus_plus @ int @ Z @ Z6 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_3268_nat__mult__distrib,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) ) ) ) ).

% nat_mult_distrib
thf(fact_3269_Suc__as__int,axiom,
    ( suc
    = ( ^ [A4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_3270_nat__diff__distrib,axiom,
    ! [Z6: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
     => ( ( ord_less_eq @ int @ Z6 @ Z )
       => ( ( nat2 @ ( minus_minus @ int @ Z @ Z6 ) )
          = ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) ) ) ) ) ).

% nat_diff_distrib
thf(fact_3271_nat__diff__distrib_H,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ( nat2 @ ( minus_minus @ int @ X2 @ Y2 ) )
          = ( minus_minus @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ) ).

% nat_diff_distrib'
thf(fact_3272_nat__abs__triangle__ineq,axiom,
    ! [K: int,L2: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L2 ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_3273_nat__div__distrib,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( nat2 @ ( divide_divide @ int @ X2 @ Y2 ) )
        = ( divide_divide @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ).

% nat_div_distrib
thf(fact_3274_nat__div__distrib_H,axiom,
    ! [Y2: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( nat2 @ ( divide_divide @ int @ X2 @ Y2 ) )
        = ( divide_divide @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ).

% nat_div_distrib'
thf(fact_3275_nat__power__eq,axiom,
    ! [Z: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( power_power @ int @ Z @ N2 ) )
        = ( power_power @ nat @ ( nat2 @ Z ) @ N2 ) ) ) ).

% nat_power_eq
thf(fact_3276_nat__floor__neg,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X2 ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_3277_nat__mod__distrib,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ( nat2 @ ( modulo_modulo @ int @ X2 @ Y2 ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_3278_div__abs__eq__div__nat,axiom,
    ! [K: int,L2: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_3279_floor__eq3,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X2 ) )
          = N2 ) ) ) ).

% floor_eq3
thf(fact_3280_le__nat__floor,axiom,
    ! [X2: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X2 ) @ A2 )
     => ( ord_less_eq @ nat @ X2 @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_3281_mod__abs__eq__div__nat,axiom,
    ! [K: int,L2: int] :
      ( ( modulo_modulo @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) )
      = ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ).

% mod_abs_eq_div_nat
thf(fact_3282_take__bit__nat__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_3283_nat__take__bit__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_3284_bit__nat__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N2 )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_nat_iff
thf(fact_3285_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_3286_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( suc @ ( nat2 @ Z ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_3287_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ M )
        = ( ord_less @ int @ W @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_3288_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z6 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_3289_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A2 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A2 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_3290_floor__eq4,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X2 ) )
          = N2 ) ) ) ).

% floor_eq4
thf(fact_3291_cis__conv__exp,axiom,
    ( cis
    = ( ^ [B3: real] : ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B3 ) ) ) ) ) ).

% cis_conv_exp
thf(fact_3292_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] : ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( uminus_uminus @ int @ K3 ) ) ) ) @ ( semiring_1_of_nat @ A @ ( nat2 @ K3 ) ) ) ) ) ) ).

% of_int_of_nat
thf(fact_3293_nat__dvd__iff,axiom,
    ! [Z: int,M: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ Z ) @ M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( dvd_dvd @ int @ Z @ ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_dvd_iff
thf(fact_3294_of__real__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X2 ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X2 ) ) ) ) ).

% of_real_sqrt
thf(fact_3295_Arg__bounded,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
      & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ).

% Arg_bounded
thf(fact_3296_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_3297_powr__int,axiom,
    ! [X2: real,I: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ I ) )
            = ( power_power @ real @ X2 @ ( nat2 @ I ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ I ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( nat2 @ ( uminus_uminus @ int @ I ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_3298_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K3: int,L: int] :
          ( if @ int
          @ ( L
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L @ K3 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_3299_cis__multiple__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_3300_powr__real__of__int,axiom,
    ! [X2: real,N2: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ N2 ) )
            = ( power_power @ real @ X2 @ ( nat2 @ N2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ N2 ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X2 @ ( nat2 @ ( uminus_uminus @ int @ N2 ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_3301_xor__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_3302_Suc__0__xor__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_3303_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_3304_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% inverse_eq_iff_eq
thf(fact_3305_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
          = A2 ) ) ).

% inverse_inverse_eq
thf(fact_3306_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( bit_se5824344971392196577ns_xor @ A @ X2 @ Y2 ) )
          = Y2 ) ) ).

% bit.xor_left_self
thf(fact_3307_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_3308_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_3309_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3310_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A] :
          ( ( ( inverse_inverse @ A @ X2 )
            = ( one_one @ A ) )
          = ( X2
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3311_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3312_inverse__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ B2 @ A2 ) ) ) ).

% inverse_divide
thf(fact_3313_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% inverse_minus_eq
thf(fact_3314_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ X2 )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_3315_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_3316_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_3317_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_3318_abs__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ).

% abs_inverse
thf(fact_3319_sgn__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% sgn_inverse
thf(fact_3320_inverse__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% inverse_sgn
thf(fact_3321_take__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_xor
thf(fact_3322_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_3323_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_3324_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_3325_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_3326_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_3327_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_3328_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( ( semiring_char_0 @ B )
        & ( semidom_divide @ B ) )
     => ! [K: nat] :
          ( ( gbinomial @ B @ ( zero_zero @ B ) @ ( suc @ K ) )
          = ( zero_zero @ B ) ) ) ).

% gbinomial_0(2)
thf(fact_3329_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_3330_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% gbinomial_Suc0
thf(fact_3331_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( archimedean_frac @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( member @ A @ X2 @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_eq_0_iff
thf(fact_3332_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_3333_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_3334_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3335_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3336_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3337_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y2 @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) ) ) ).

% floor_add2
thf(fact_3338_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X2 ) )
          = ( ~ ( member @ A @ X2 @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_3339_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3340_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_3341_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X2 ) ) ) ) ).

% xor_numerals(8)
thf(fact_3342_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X2 ) ) ) ) ).

% xor_numerals(5)
thf(fact_3343_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) ) ) ).

% xor_numerals(2)
thf(fact_3344_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% xor_numerals(1)
thf(fact_3345_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_3346_xor__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% xor_nat_numerals(1)
thf(fact_3347_xor__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) ) ).

% xor_nat_numerals(2)
thf(fact_3348_xor__nat__numerals_I3_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) ) ).

% xor_nat_numerals(3)
thf(fact_3349_xor__nat__numerals_I4_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) ) ).

% xor_nat_numerals(4)
thf(fact_3350_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_3351_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_3352_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N2 )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_inverse
thf(fact_3353_Ints__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_0
thf(fact_3354_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y2: A,X2: A] :
          ( ( ( times_times @ A @ Y2 @ X2 )
            = ( times_times @ A @ X2 @ Y2 ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y2 ) @ X2 )
            = ( times_times @ A @ X2 @ ( inverse_inverse @ A @ Y2 ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3355_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_3356_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
            = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_3357_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_3358_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_3359_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_3360_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ) ).

% nonzero_norm_inverse
thf(fact_3361_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L2: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) ) ) ).

% of_int_xor_eq
thf(fact_3362_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( A2 = B2 ) ) ) ).

% inverse_eq_imp_eq
thf(fact_3363_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.assoc
thf(fact_3364_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [A4: A,B3: A] : ( bit_se5824344971392196577ns_xor @ A @ B3 @ A4 ) ) ) ) ).

% xor.commute
thf(fact_3365_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ B2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ C2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.left_commute
thf(fact_3366_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_xor_eq
thf(fact_3367_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X2: real] :
          ( ( X2
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( inverse_inverse @ real @ X2 ) )
            = ( inverse_inverse @ A @ ( real_Vector_of_real @ A @ X2 ) ) ) ) ) ).

% nonzero_of_real_inverse
thf(fact_3368_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: num] : ( member @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_3369_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_3370_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_3371_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_3372_real__sqrt__inverse,axiom,
    ! [X2: real] :
      ( ( sqrt @ ( inverse_inverse @ real @ X2 ) )
      = ( inverse_inverse @ real @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_inverse
thf(fact_3373_Ints__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_diff
thf(fact_3374_Ints__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( uminus_uminus @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_minus
thf(fact_3375_minus__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A] :
          ( ( member @ A @ ( uminus_uminus @ A @ X2 ) @ ( ring_1_Ints @ A ) )
          = ( member @ A @ X2 @ ( ring_1_Ints @ A ) ) ) ) ).

% minus_in_Ints_iff
thf(fact_3376_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_3377_Ints__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_nat
thf(fact_3378_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_se5824344971392196577ns_xor @ A @ Y2 @ Z ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 ) @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Z ) ) ) ) ).

% bit.conj_xor_distrib
thf(fact_3379_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344971392196577ns_xor @ A @ Y2 @ Z ) @ X2 )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ X2 ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X2 ) ) ) ) ).

% bit.conj_xor_distrib2
thf(fact_3380_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ N2 )
          = ( ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
             != ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ) ).

% bit_xor_iff
thf(fact_3381_Ints__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( abs_abs @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_abs
thf(fact_3382_Ints__cases,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q2: A] :
          ( ( member @ A @ Q2 @ ( ring_1_Ints @ A ) )
         => ~ ! [Z3: int] :
                ( Q2
               != ( ring_1_of_int @ A @ Z3 ) ) ) ) ).

% Ints_cases
thf(fact_3383_Ints__induct,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q2: A,P: A > $o] :
          ( ( member @ A @ Q2 @ ( ring_1_Ints @ A ) )
         => ( ! [Z3: int] : ( P @ ( ring_1_of_int @ A @ Z3 ) )
           => ( P @ Q2 ) ) ) ) ).

% Ints_induct
thf(fact_3384_Ints__of__int,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] : ( member @ A @ ( ring_1_of_int @ A @ Z ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_int
thf(fact_3385_fact__in__Ints,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( ring_1 @ A ) )
     => ! [N2: nat] : ( member @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( ring_1_Ints @ A ) ) ) ).

% fact_in_Ints
thf(fact_3386_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R: real,X2: A] :
          ( ( ord_less_eq @ real @ R @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X2 ) ) @ ( inverse_inverse @ real @ R ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_3387_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_3388_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_3389_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_3390_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_3391_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_3392_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_3393_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_3394_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_3395_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3396_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_3397_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_3398_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_3399_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3400_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% divide_inverse
thf(fact_3401_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ ( inverse_inverse @ A @ B3 ) @ A4 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3402_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3403_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( inverse_inverse @ A @ X2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X2 ) @ ( power_power @ A @ X2 @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3404_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: nat,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ N2 ) @ ( power_power @ A @ X2 @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3405_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X2: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X2 )
          = ( times_times @ A @ X2 @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3406_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_3407_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X2: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X2 )
          = ( times_times @ A @ X2 @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3408_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X: real,Y: real] : ( times_times @ real @ X @ ( inverse_inverse @ real @ Y ) ) ) ) ).

% divide_real_def
thf(fact_3409_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_3410_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_3411_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_3412_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_3413_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_3414_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X2 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3415_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3416_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X2 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
            & ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3417_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3418_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3419_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3420_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3421_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3422_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_3423_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N2 ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_3424_inverse__powr,axiom,
    ! [Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y2 ) @ A2 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y2 @ A2 ) ) ) ) ).

% inverse_powr
thf(fact_3425_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_3426_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_3427_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3428_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3429_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X2 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
            & ( ord_less_eq @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3430_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X2 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3431_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3432_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_3433_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ? [N3: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ X2 ) ) ) ).

% reals_Archimedean
thf(fact_3434_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_3435_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_3436_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_3437_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_3438_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_3439_forall__pos__mono__1,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D5: real,E: real] :
          ( ( ord_less @ real @ D5 @ E )
         => ( ( P @ D5 )
           => ( P @ E ) ) )
     => ( ! [N3: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono_1
thf(fact_3440_real__arch__inverse,axiom,
    ! [E2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
      = ( ? [N: nat] :
            ( ( N
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N ) ) @ E2 ) ) ) ) ).

% real_arch_inverse
thf(fact_3441_forall__pos__mono,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D5: real,E: real] :
          ( ( ord_less @ real @ D5 @ E )
         => ( ( P @ D5 )
           => ( P @ E ) ) )
     => ( ! [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono
thf(fact_3442_even__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_xor_iff
thf(fact_3443_sqrt__divide__self__eq,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( divide_divide @ real @ ( sqrt @ X2 ) @ X2 )
        = ( inverse_inverse @ real @ ( sqrt @ X2 ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3444_ln__inverse,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ln_ln @ real @ ( inverse_inverse @ real @ X2 ) )
        = ( uminus_uminus @ real @ ( ln_ln @ real @ X2 ) ) ) ) ).

% ln_inverse
thf(fact_3445_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_3446_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
         => ( ( X2
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X2 ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_3447_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X2 ) @ ( one_one @ A ) )
           => ( X2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_3448_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y2 @ ( ring_1_Ints @ A ) )
           => ( ( X2 = Y2 )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_3449_sin__times__pi__eq__0,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X2 @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X2 @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_3450_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) ) @ X2 ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_3451_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: nat,N2: nat] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N2 )
           => ( ( power_power @ A @ X2 @ ( minus_minus @ nat @ N2 @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3452_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_3453_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_3454_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_3455_log__inverse,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( log @ A2 @ ( inverse_inverse @ real @ X2 ) )
            = ( uminus_uminus @ real @ ( log @ A2 @ X2 ) ) ) ) ) ) ).

% log_inverse
thf(fact_3456_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X2 ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X2 ) ) ) ) ) ) ).

% frac_neg
thf(fact_3457_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_3458_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_3459_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A4 ) @ ( one_one @ A ) ) @ K3 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_3460_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N2 ) ) ) ) ).

% gbinomial_index_swap
thf(fact_3461_exp__plus__inverse__exp,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X2 ) @ ( inverse_inverse @ real @ ( exp @ real @ X2 ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_3462_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_3463_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X2 )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X2 @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_3464_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_3465_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_3466_plus__inverse__ge__2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X2 @ ( inverse_inverse @ real @ X2 ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_3467_real__inv__sqrt__pow2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X2 ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3468_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_3469_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A4 ) @ K3 ) ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_3470_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ K3 ) ) @ ( one_one @ A ) ) @ K3 ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_3471_tan__cot,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X2 ) ) ) ).

% tan_cot
thf(fact_3472_sin__integer__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_3473_cos__integer__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_3474_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N
          @ ( if @ nat
            @ ( N
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_3475_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_3476_real__le__x__sinh,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X2 ) @ ( inverse_inverse @ real @ ( exp @ real @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_3477_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_xor_eq
thf(fact_3478_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% xor_one_eq
thf(fact_3479_real__le__abs__sinh,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X2 ) @ ( inverse_inverse @ real @ ( exp @ real @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_3480_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3481_sinh__ln__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( sinh @ real @ ( ln_ln @ real @ X2 ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X2 @ ( inverse_inverse @ real @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3482_cosh__ln__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( cosh @ real @ ( ln_ln @ real @ X2 ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X2 @ ( inverse_inverse @ real @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3483_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cosh @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3484_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_3485_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: A > B,B8: A > B,X: A] : ( minus_minus @ B @ ( A7 @ X ) @ ( B8 @ X ) ) ) ) ) ).

% minus_apply
thf(fact_3486_push__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_3487_push__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_3488_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_3489_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_3490_sinh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sinh_0
thf(fact_3491_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ A2 ) ) ) ).

% push_bit_push_bit
thf(fact_3492_push__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_and
thf(fact_3493_push__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_xor
thf(fact_3494_concat__bit__of__zero__1,axiom,
    ! [N2: nat,L2: int] :
      ( ( bit_concat_bit @ N2 @ ( zero_zero @ int ) @ L2 )
      = ( bit_se4730199178511100633sh_bit @ int @ N2 @ L2 ) ) ).

% concat_bit_of_zero_1
thf(fact_3495_sinh__real__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( sinh @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% sinh_real_zero_iff
thf(fact_3496_sinh__real__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X2 ) @ ( sinh @ real @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% sinh_real_less_iff
thf(fact_3497_sinh__real__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X2 ) @ ( sinh @ real @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% sinh_real_le_iff
thf(fact_3498_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3499_sinh__real__neg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% sinh_real_neg_iff
thf(fact_3500_sinh__real__pos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% sinh_real_pos_iff
thf(fact_3501_sinh__real__nonneg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% sinh_real_nonneg_iff
thf(fact_3502_sinh__real__nonpos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3503_xor__nonnegative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_3504_xor__negative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_3505_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_3506_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_3507_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_numeral
thf(fact_3508_push__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% push_bit_of_Suc_0
thf(fact_3509_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_3510_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% push_bit_of_1
thf(fact_3511_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( ( N2
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_3512_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_minus_numeral
thf(fact_3513_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N: nat,K3: int] : ( bit_se5824344971392196577ns_xor @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_3514_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_3515_push__bit__minus,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) ) ) ) ).

% push_bit_minus
thf(fact_3516_tanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X: A] : ( divide_divide @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ X ) ) ) ) ) ).

% tanh_def
thf(fact_3517_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N2 @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_3518_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_push_bit
thf(fact_3519_sinh__le__cosh__real,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( sinh @ real @ X2 ) @ ( cosh @ real @ X2 ) ) ).

% sinh_le_cosh_real
thf(fact_3520_sinh__less__cosh__real,axiom,
    ! [X2: real] : ( ord_less @ real @ ( sinh @ real @ X2 ) @ ( cosh @ real @ X2 ) ) ).

% sinh_less_cosh_real
thf(fact_3521_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: int] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) ) ) ) ).

% push_bit_of_int
thf(fact_3522_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cosh @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% cosh_diff
thf(fact_3523_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sinh @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% sinh_diff
thf(fact_3524_sinh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sinh @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% sinh_add
thf(fact_3525_cosh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cosh @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% cosh_add
thf(fact_3526_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ X2 ) )
          = ( exp @ A @ X2 ) ) ) ).

% cosh_plus_sinh
thf(fact_3527_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ X2 ) )
          = ( exp @ A @ X2 ) ) ) ).

% sinh_plus_cosh
thf(fact_3528_cosh__real__nonzero,axiom,
    ! [X2: real] :
      ( ( cosh @ real @ X2 )
     != ( zero_zero @ real ) ) ).

% cosh_real_nonzero
thf(fact_3529_push__bit__nat__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N2 @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) ) ) ).

% push_bit_nat_eq
thf(fact_3530_bit__xor__int__iff,axiom,
    ! [K: int,L2: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) @ N2 )
      = ( ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
         != ( bit_se5641148757651400278ts_bit @ int @ L2 @ N2 ) ) ) ) ).

% bit_xor_int_iff
thf(fact_3531_cosh__minus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( minus_minus @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ X2 ) )
          = ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ).

% cosh_minus_sinh
thf(fact_3532_sinh__minus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( minus_minus @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ X2 ) )
          = ( uminus_uminus @ A @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ).

% sinh_minus_cosh
thf(fact_3533_XOR__lower,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X2 @ Y2 ) ) ) ) ).

% XOR_lower
thf(fact_3534_cosh__real__pos,axiom,
    ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X2 ) ) ).

% cosh_real_pos
thf(fact_3535_cosh__real__nonneg,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X2 ) ) ).

% cosh_real_nonneg
thf(fact_3536_cosh__real__nonneg__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_3537_cosh__real__nonpos__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y2 @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less_eq @ real @ Y2 @ X2 ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_3538_cosh__real__ge__1,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X2 ) ) ).

% cosh_real_ge_1
thf(fact_3539_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X2 ) ) @ ( cosh @ A @ X2 ) ) ) ) ).

% sinh_double
thf(fact_3540_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) ) ) ) ).

% push_bit_take_bit
thf(fact_3541_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M @ N2 ) @ A2 ) ) ) ) ).

% take_bit_push_bit
thf(fact_3542_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X: complex,Y: complex] : ( times_times @ complex @ X @ ( inverse_inverse @ complex @ Y ) ) ) ) ).

% divide_complex_def
thf(fact_3543_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M3: nat,N: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_3544_cosh__real__strict__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ord_less @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_3545_cosh__real__nonneg__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_3546_cosh__real__nonpos__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y2 @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less @ real @ Y2 @ X2 ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_3547_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N2 )
      = ( ( ord_less_eq @ nat @ M @ N2 )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_3548_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3549_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3550_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3551_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: A > B,B8: A > B,X: A] : ( minus_minus @ B @ ( A7 @ X ) @ ( B8 @ X ) ) ) ) ) ).

% fun_diff_def
thf(fact_3552_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% xor_nat_def
thf(fact_3553_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q2: nat,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q2 ) @ N2 )
      = ( ( ord_less_eq @ nat @ M @ N2 )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q2 @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_3554_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N: nat,K3: int,L: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ) ) ).

% concat_bit_eq
thf(fact_3555_arcosh__cosh__real,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( arcosh @ real @ ( cosh @ real @ X2 ) )
        = X2 ) ) ).

% arcosh_cosh_real
thf(fact_3556_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se5824344971392196577ns_xor @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_3557_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3558_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_3559_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_3560_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N: nat,M3: nat] : ( times_times @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% push_bit_nat_def
thf(fact_3561_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N: nat,K3: int] : ( times_times @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% push_bit_int_def
thf(fact_3562_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N: nat,A4: A] : ( times_times @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_3563_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ A2 )
         => ~ ! [B6: A] :
                ( A2
               != ( bit_se4730199178511100633sh_bit @ A @ N2 @ B6 ) ) ) ) ).

% exp_dvdE
thf(fact_3564_push__bit__minus__one,axiom,
    ! [N2: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% push_bit_minus_one
thf(fact_3565_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cosh @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X2 ) @ ( tanh @ A @ Y2 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X2 ) @ ( tanh @ A @ Y2 ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3566_XOR__upper,axiom,
    ! [X2: int,N2: nat,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less @ int @ X2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ int @ Y2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X2 @ Y2 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% XOR_upper
thf(fact_3567_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z5: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z5 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z5 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_3568_complex__inverse,axiom,
    ! [A2: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A2 @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_3569_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_3570_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z5 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z5 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3571_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L: int] :
          ( if @ int
          @ ( K3
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L )
          @ ( if @ int
            @ ( L
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K3 )
            @ ( if @ int
              @ ( K3
                = ( zero_zero @ int ) )
              @ L
              @ ( if @ int
                @ ( L
                  = ( zero_zero @ int ) )
                @ K3
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_3572_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X8: nat > real] :
        ! [J2: nat] :
        ? [M8: nat] :
        ! [M3: nat] :
          ( ( ord_less_eq @ nat @ M8 @ M3 )
         => ! [N: nat] :
              ( ( ord_less_eq @ nat @ M8 @ N )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X8 @ M3 ) @ ( X8 @ N ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J2 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_3573_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% dual_order.refl
thf(fact_3574_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ X2 @ X2 ) ) ).

% order_refl
thf(fact_3575_csqrt_Osimps_I1_J,axiom,
    ! [Z: complex] :
      ( ( re @ ( csqrt @ Z ) )
      = ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% csqrt.simps(1)
thf(fact_3576_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = X2 ) ) ).

% bit.double_compl
thf(fact_3577_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( bit_ri4277139882892585799ns_not @ A @ X2 )
            = ( bit_ri4277139882892585799ns_not @ A @ Y2 ) )
          = ( X2 = Y2 ) ) ) ).

% bit.compl_eq_compl_iff
thf(fact_3578_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ Y2 )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X2 @ Y2 ) ) ) ) ).

% bit.xor_compl_left
thf(fact_3579_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X2 @ Y2 ) ) ) ) ).

% bit.xor_compl_right
thf(fact_3580_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ X2 )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_3581_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_3582_complex__Re__numeral,axiom,
    ! [V: num] :
      ( ( re @ ( numeral_numeral @ complex @ V ) )
      = ( numeral_numeral @ real @ V ) ) ).

% complex_Re_numeral
thf(fact_3583_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_3584_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_3585_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_3586_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ X2 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_3587_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X2 ) ) ) ).

% bit.xor_one_right
thf(fact_3588_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 )
          = ( bit_ri4277139882892585799ns_not @ A @ X2 ) ) ) ).

% bit.xor_one_left
thf(fact_3589_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_3590_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_3591_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ).

% minus_not_numeral_eq
thf(fact_3592_Re__divide__of__nat,axiom,
    ! [Z: complex,N2: nat] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N2 ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ).

% Re_divide_of_nat
thf(fact_3593_Re__divide__of__real,axiom,
    ! [Z: complex,R: real] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( real_Vector_of_real @ complex @ R ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ R ) ) ).

% Re_divide_of_real
thf(fact_3594_Re__sgn,axiom,
    ! [Z: complex] :
      ( ( re @ ( sgn_sgn @ complex @ Z ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% Re_sgn
thf(fact_3595_even__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_not_iff
thf(fact_3596_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_3597_Re__divide__numeral,axiom,
    ! [Z: complex,W: num] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Re_divide_numeral
thf(fact_3598_cos__Arg__i__mult__zero,axiom,
    ! [Y2: complex] :
      ( ( Y2
       != ( zero_zero @ complex ) )
     => ( ( ( re @ Y2 )
          = ( zero_zero @ real ) )
       => ( ( cos @ real @ ( arg @ Y2 ) )
          = ( zero_zero @ real ) ) ) ) ).

% cos_Arg_i_mult_zero
thf(fact_3599_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_3600_bit__not__int__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ N2 )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_not_int_iff
thf(fact_3601_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( ring_1_of_int @ A @ K ) ) ) ) ).

% of_int_not_eq
thf(fact_3602_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) ) ) ) ).

% take_bit_not_take_bit
thf(fact_3603_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_not_iff
thf(fact_3604_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_not_numeral
thf(fact_3605_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_3606_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_3607_imaginary__unit_Osimps_I1_J,axiom,
    ( ( re @ imaginary_unit )
    = ( zero_zero @ real ) ) ).

% imaginary_unit.simps(1)
thf(fact_3608_complex__Re__le__cmod,axiom,
    ! [X2: complex] : ( ord_less_eq @ real @ ( re @ X2 ) @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) ).

% complex_Re_le_cmod
thf(fact_3609_zero__complex_Osimps_I1_J,axiom,
    ( ( re @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(1)
thf(fact_3610_plus__complex_Osimps_I1_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( re @ ( plus_plus @ complex @ X2 @ Y2 ) )
      = ( plus_plus @ real @ ( re @ X2 ) @ ( re @ Y2 ) ) ) ).

% plus_complex.simps(1)
thf(fact_3611_minus__complex_Osimps_I1_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( re @ ( minus_minus @ complex @ X2 @ Y2 ) )
      = ( minus_minus @ real @ ( re @ X2 ) @ ( re @ Y2 ) ) ) ).

% minus_complex.simps(1)
thf(fact_3612_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_3613_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_3614_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A4: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_3615_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_3616_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_3617_abs__Re__le__cmod,axiom,
    ! [X2: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) ).

% abs_Re_le_cmod
thf(fact_3618_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 )
             => ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_3619_Re__csqrt,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) ) ).

% Re_csqrt
thf(fact_3620_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A2 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( B2 != A2 ) ) ) ) ).

% nle_le
thf(fact_3621_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ~ ( ord_less_eq @ A @ Y2 @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y2 @ X2 )
             => ~ ( ord_less_eq @ A @ X2 @ Z ) )
           => ( ( ( ord_less_eq @ A @ X2 @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y2 ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y2 )
                 => ~ ( ord_less_eq @ A @ Y2 @ X2 ) )
               => ( ( ( ord_less_eq @ A @ Y2 @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X2 ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X2 )
                     => ~ ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_3622_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [X: A,Y: A] :
              ( ( ord_less_eq @ A @ X @ Y )
              & ( ord_less_eq @ A @ Y @ X ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_3623_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_3624_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_3625_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ X2 )
           => ( X2 = Y2 ) ) ) ) ).

% order_antisym
thf(fact_3626_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% order.trans
thf(fact_3627_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z )
           => ( ord_less_eq @ A @ X2 @ Z ) ) ) ) ).

% order_trans
thf(fact_3628_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A6: A,B6: A] :
              ( ( ord_less_eq @ A @ A6 @ B6 )
             => ( P @ A6 @ B6 ) )
         => ( ! [A6: A,B6: A] :
                ( ( P @ B6 @ A6 )
               => ( P @ A6 @ B6 ) )
           => ( P @ A2 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_3629_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ B3 @ A4 )
              & ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_3630_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_3631_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.trans
thf(fact_3632_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) ).

% antisym
thf(fact_3633_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ).

% le_funD
thf(fact_3634_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ).

% le_funE
thf(fact_3635_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B] :
          ( ! [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) ).

% le_funI
thf(fact_3636_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F4: A > B,G2: A > B] :
            ! [X: A] : ( ord_less_eq @ B @ ( F4 @ X ) @ ( G2 @ X ) ) ) ) ) ).

% le_fun_def
thf(fact_3637_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ A4 @ B3 )
              & ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_3638_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_3639_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_3640_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 = Y2 )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% order_eq_refl
thf(fact_3641_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
          | ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% linorder_linear
thf(fact_3642_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_3643_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_3644_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% linorder_le_cases
thf(fact_3645_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
            = ( X2 = Y2 ) ) ) ) ).

% order_antisym_conv
thf(fact_3646_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% order_less_imp_not_less
thf(fact_3647_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( Y2 != X2 ) ) ) ).

% order_less_imp_not_eq2
thf(fact_3648_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( X2 != Y2 ) ) ) ).

% order_less_imp_not_eq
thf(fact_3649_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
          | ( X2 = Y2 )
          | ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% linorder_less_linear
thf(fact_3650_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,P: $o] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ X2 )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_3651_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% order_less_not_sym
thf(fact_3652_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less @ A @ X3 @ Y3 )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_3653_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less @ B @ X3 @ Y3 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_3654_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A] :
          ~ ( ord_less @ A @ X2 @ X2 ) ) ).

% order_less_irrefl
thf(fact_3655_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less @ A @ X3 @ Y3 )
                 => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_3656_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less @ B @ X3 @ Y3 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_3657_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z )
           => ( ord_less @ A @ X2 @ Z ) ) ) ) ).

% order_less_trans
thf(fact_3658_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order_less_asym'
thf(fact_3659_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( X2 != Y2 ) )
          = ( ( ord_less @ A @ X2 @ Y2 )
            | ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_neq_iff
thf(fact_3660_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% order_less_asym
thf(fact_3661_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ~ ( ord_less @ A @ X2 @ Y2 )
           => ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_neqE
thf(fact_3662_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_3663_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_3664_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_3665_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
          = ( ( ord_less @ A @ Y2 @ X2 )
            | ( X2 = Y2 ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_3666_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_3667_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A6: A,B6: A] :
              ( ( ord_less @ A @ A6 @ B6 )
             => ( P @ A6 @ B6 ) )
         => ( ! [A6: A] : ( P @ A6 @ A6 )
           => ( ! [A6: A,B6: A] :
                  ( ( P @ B6 @ A6 )
                 => ( P @ A6 @ B6 ) )
             => ( P @ A2 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_3668_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P5: A > $o] :
            ? [X7: A] : ( P5 @ X7 ) )
        = ( ^ [P6: A > $o] :
            ? [N: A] :
              ( ( P6 @ N )
              & ! [M3: A] :
                  ( ( ord_less @ A @ M3 @ N )
                 => ~ ( P6 @ M3 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_3669_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% dual_order.irrefl
thf(fact_3670_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_3671_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less @ A @ X2 @ Y2 )
         => ( ( X2 != Y2 )
           => ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_cases
thf(fact_3672_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X2: A] :
          ( ~ ( ord_less @ A @ Y2 @ X2 )
         => ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
            = ( X2 = Y2 ) ) ) ) ).

% antisym_conv3
thf(fact_3673_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ A @ Y4 @ X3 )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% less_induct
thf(fact_3674_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_3675_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_3676_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order.asym
thf(fact_3677_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( X2 != Y2 ) ) ) ).

% less_imp_neq
thf(fact_3678_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ? [Z3: A] :
              ( ( ord_less @ A @ X2 @ Z3 )
              & ( ord_less @ A @ Z3 @ Y2 ) ) ) ) ).

% dense
thf(fact_3679_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X2: A] :
        ? [X_1: A] : ( ord_less @ A @ X2 @ X_1 ) ) ).

% gt_ex
thf(fact_3680_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X2: A] :
        ? [Y3: A] : ( ord_less @ A @ Y3 @ X2 ) ) ).

% lt_ex
thf(fact_3681_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_3682_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% minus_numeral_inc_eq
thf(fact_3683_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N: nat,K3: int] : ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_3684_not__int__div__2,axiom,
    ! [K: int] :
      ( ( divide_divide @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% not_int_div_2
thf(fact_3685_even__not__iff__int,axiom,
    ! [K: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_not_iff_int
thf(fact_3686_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) ) ) ) ).

% not_numeral_Bit0_eq
thf(fact_3687_and__not__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_3688_and__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(4)
thf(fact_3689_bit__minus__int__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N2 )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N2 ) ) ).

% bit_minus_int_iff
thf(fact_3690_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_3691_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N2 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_3692_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_3693_and__not__numerals_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_3694_and__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(7)
thf(fact_3695_and__not__numerals_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_3696_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_3697_cos__n__Re__cis__pow__n,axiom,
    ! [N2: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N2 ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_3698_and__not__numerals_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_3699_and__not__numerals_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_3700_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N2 )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% bit_not_iff_eq
thf(fact_3701_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_3702_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X6 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M9: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M9 @ M2 )
               => ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ M9 @ N7 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X6 @ M2 ) @ ( X6 @ N7 ) ) ) @ E2 ) ) ) ) ) ) ).

% CauchyD
thf(fact_3703_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X6 @ M4 ) @ ( X6 @ N3 ) ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X6 ) ) ) ).

% CauchyI
thf(fact_3704_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M3 ) @ ( X8 @ N ) ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_3705_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ~ ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% leD
thf(fact_3706_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% leI
thf(fact_3707_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_3708_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
            = ( X2 = Y2 ) ) ) ) ).

% antisym_conv1
thf(fact_3709_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
            = ( X2 = Y2 ) ) ) ) ).

% antisym_conv2
thf(fact_3710_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,Y2: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ Z @ X3 )
             => ( ord_less_eq @ A @ Y2 @ X3 ) )
         => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ).

% dense_ge
thf(fact_3711_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y2: A,Z: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Y2 )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ).

% dense_le
thf(fact_3712_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X: A,Y: A] :
              ( ( ord_less_eq @ A @ X @ Y )
              & ~ ( ord_less_eq @ A @ Y @ X ) ) ) ) ) ).

% less_le_not_le
thf(fact_3713_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X2: A] :
          ( ~ ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% not_le_imp_less
thf(fact_3714_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less @ A @ A4 @ B3 )
              | ( A4 = B3 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_3715_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ A4 @ B3 )
              & ( A4 != B3 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_3716_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_3717_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_3718_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ A4 @ B3 )
              & ~ ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_3719_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ Z @ X2 )
         => ( ! [W3: A] :
                ( ( ord_less @ A @ Z @ W3 )
               => ( ( ord_less @ A @ W3 @ X2 )
                 => ( ord_less_eq @ A @ Y2 @ W3 ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ) ).

% dense_ge_bounded
thf(fact_3720_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ! [W3: A] :
                ( ( ord_less @ A @ X2 @ W3 )
               => ( ( ord_less @ A @ W3 @ Y2 )
                 => ( ord_less_eq @ A @ W3 @ Z ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ) ).

% dense_le_bounded
thf(fact_3721_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_less @ A @ B3 @ A4 )
              | ( A4 = B3 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_3722_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_less_eq @ A @ B3 @ A4 )
              & ( A4 != B3 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_3723_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_3724_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_3725_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_less_eq @ A @ B3 @ A4 )
              & ~ ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_3726_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_3727_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_3728_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X: A,Y: A] :
              ( ( ord_less @ A @ X @ Y )
              | ( X = Y ) ) ) ) ) ).

% order_le_less
thf(fact_3729_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X: A,Y: A] :
              ( ( ord_less_eq @ A @ X @ Y )
              & ( X != Y ) ) ) ) ) ).

% order_less_le
thf(fact_3730_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ~ ( ord_less_eq @ A @ X2 @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% linorder_not_le
thf(fact_3731_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% linorder_not_less
thf(fact_3732_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% order_less_imp_le
thf(fact_3733_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_3734_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_3735_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z )
           => ( ord_less @ A @ X2 @ Z ) ) ) ) ).

% order_le_less_trans
thf(fact_3736_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z )
           => ( ord_less @ A @ X2 @ Z ) ) ) ) ).

% order_less_le_trans
thf(fact_3737_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less @ B @ X3 @ Y3 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_3738_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_3739_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_3740_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less @ A @ X3 @ Y3 )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_3741_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
          | ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% linorder_le_less_linear
thf(fact_3742_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ X2 @ Y2 )
            | ( X2 = Y2 ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_3743_and__not__numerals_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_3744_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_3745_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z5: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) @ ( re @ Z5 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z5 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z5 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) @ ( re @ Z5 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_3746_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( ( im @ ( csqrt @ Z ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_3747_csqrt__of__real__nonpos,axiom,
    ! [X2: complex] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X2 ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X2 )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X2 ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_3748_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X: complex,Y: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_3749_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_3750_complex__Im__of__int,axiom,
    ! [Z: int] :
      ( ( im @ ( ring_1_of_int @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_int
thf(fact_3751_complex__Im__fact,axiom,
    ! [N2: nat] :
      ( ( im @ ( semiring_char_0_fact @ complex @ N2 ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_fact
thf(fact_3752_Im__complex__of__real,axiom,
    ! [Z: real] :
      ( ( im @ ( real_Vector_of_real @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% Im_complex_of_real
thf(fact_3753_Im__power__real,axiom,
    ! [X2: complex,N2: nat] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X2 @ N2 ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_3754_complex__Im__numeral,axiom,
    ! [V: num] :
      ( ( im @ ( numeral_numeral @ complex @ V ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_numeral
thf(fact_3755_complex__Im__of__nat,axiom,
    ! [N2: nat] :
      ( ( im @ ( semiring_1_of_nat @ complex @ N2 ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_nat
thf(fact_3756_Im__i__times,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( re @ Z ) ) ).

% Im_i_times
thf(fact_3757_Im__divide__of__real,axiom,
    ! [Z: complex,R: real] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( real_Vector_of_real @ complex @ R ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ R ) ) ).

% Im_divide_of_real
thf(fact_3758_Im__sgn,axiom,
    ! [Z: complex] :
      ( ( im @ ( sgn_sgn @ complex @ Z ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% Im_sgn
thf(fact_3759_Re__power__real,axiom,
    ! [X2: complex,N2: nat] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X2 @ N2 ) )
        = ( power_power @ real @ ( re @ X2 ) @ N2 ) ) ) ).

% Re_power_real
thf(fact_3760_Re__i__times,axiom,
    ! [Z: complex] :
      ( ( re @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( uminus_uminus @ real @ ( im @ Z ) ) ) ).

% Re_i_times
thf(fact_3761_Im__divide__numeral,axiom,
    ! [Z: complex,W: num] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Im_divide_numeral
thf(fact_3762_Im__divide__of__nat,axiom,
    ! [Z: complex,N2: nat] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N2 ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ).

% Im_divide_of_nat
thf(fact_3763_csqrt__of__real__nonneg,axiom,
    ! [X2: complex] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X2 ) )
       => ( ( csqrt @ X2 )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X2 ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_3764_csqrt__minus,axiom,
    ! [X2: complex] :
      ( ( ( ord_less @ real @ ( im @ X2 ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X2 ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X2 ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X2 ) ) ) ) ).

% csqrt_minus
thf(fact_3765_zero__complex_Osimps_I2_J,axiom,
    ( ( im @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(2)
thf(fact_3766_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_3767_plus__complex_Osimps_I2_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( im @ ( plus_plus @ complex @ X2 @ Y2 ) )
      = ( plus_plus @ real @ ( im @ X2 ) @ ( im @ Y2 ) ) ) ).

% plus_complex.simps(2)
thf(fact_3768_minus__complex_Osimps_I2_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( im @ ( minus_minus @ complex @ X2 @ Y2 ) )
      = ( minus_minus @ real @ ( im @ X2 ) @ ( im @ Y2 ) ) ) ).

% minus_complex.simps(2)
thf(fact_3769_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( ring_1_Ints @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I3: int] :
            ( ( re @ Z )
            = ( ring_1_of_int @ real @ I3 ) ) ) ) ).

% complex_is_Int_iff
thf(fact_3770_abs__Im__le__cmod,axiom,
    ! [X2: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) ).

% abs_Im_le_cmod
thf(fact_3771_times__complex_Osimps_I2_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( im @ ( times_times @ complex @ X2 @ Y2 ) )
      = ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y2 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y2 ) ) ) ) ).

% times_complex.simps(2)
thf(fact_3772_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( ( im @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( re @ Z ) ) ) ) ).

% cmod_eq_Re
thf(fact_3773_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( ( re @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_eq_Im
thf(fact_3774_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( abs_abs @ real @ ( re @ Z ) )
        = ( real_V7770717601297561774m_norm @ complex @ Z ) )
     => ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% Im_eq_0
thf(fact_3775_cmod__Re__le__iff,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( ( im @ X2 )
        = ( im @ Y2 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X2 ) @ ( real_V7770717601297561774m_norm @ complex @ Y2 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X2 ) ) @ ( abs_abs @ real @ ( re @ Y2 ) ) ) ) ) ).

% cmod_Re_le_iff
thf(fact_3776_cmod__Im__le__iff,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( ( re @ X2 )
        = ( re @ Y2 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X2 ) @ ( real_V7770717601297561774m_norm @ complex @ Y2 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X2 ) ) @ ( abs_abs @ real @ ( im @ Y2 ) ) ) ) ) ).

% cmod_Im_le_iff
thf(fact_3777_times__complex_Osimps_I1_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( re @ ( times_times @ complex @ X2 @ Y2 ) )
      = ( minus_minus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y2 ) ) ) ) ).

% times_complex.simps(1)
thf(fact_3778_plus__complex_Ocode,axiom,
    ( ( plus_plus @ complex )
    = ( ^ [X: complex,Y: complex] : ( complex2 @ ( plus_plus @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( plus_plus @ real @ ( im @ X ) @ ( im @ Y ) ) ) ) ) ).

% plus_complex.code
thf(fact_3779_minus__complex_Ocode,axiom,
    ( ( minus_minus @ complex )
    = ( ^ [X: complex,Y: complex] : ( complex2 @ ( minus_minus @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( minus_minus @ real @ ( im @ X ) @ ( im @ Y ) ) ) ) ) ).

% minus_complex.code
thf(fact_3780_csqrt__principal,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) )
      | ( ( ( re @ ( csqrt @ Z ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z ) ) ) ) ) ).

% csqrt_principal
thf(fact_3781_cmod__le,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_le
thf(fact_3782_sin__n__Im__cis__pow__n,axiom,
    ! [N2: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N2 ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_3783_Re__exp,axiom,
    ! [Z: complex] :
      ( ( re @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( cos @ real @ ( im @ Z ) ) ) ) ).

% Re_exp
thf(fact_3784_Im__exp,axiom,
    ! [Z: complex] :
      ( ( im @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( sin @ real @ ( im @ Z ) ) ) ) ).

% Im_exp
thf(fact_3785_fun__complex__eq,axiom,
    ! [A: $tType,F2: A > complex] :
      ( F2
      = ( ^ [X: A] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ ( F2 @ X ) ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ ( F2 @ X ) ) ) ) ) ) ) ).

% fun_complex_eq
thf(fact_3786_complex__eq,axiom,
    ! [A2: complex] :
      ( A2
      = ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ A2 ) ) ) ) ) ).

% complex_eq
thf(fact_3787_times__complex_Ocode,axiom,
    ( ( times_times @ complex )
    = ( ^ [X: complex,Y: complex] : ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) ) ) ) ) ).

% times_complex.code
thf(fact_3788_exp__eq__polar,axiom,
    ( ( exp @ complex )
    = ( ^ [Z5: complex] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( exp @ real @ ( re @ Z5 ) ) ) @ ( cis @ ( im @ Z5 ) ) ) ) ) ).

% exp_eq_polar
thf(fact_3789_cmod__power2,axiom,
    ! [Z: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_3790_Im__power2,axiom,
    ! [X2: complex] :
      ( ( im @ ( power_power @ complex @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X2 ) ) @ ( im @ X2 ) ) ) ).

% Im_power2
thf(fact_3791_Re__power2,axiom,
    ! [X2: complex] :
      ( ( re @ ( power_power @ complex @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_3792_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_3793_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z5: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_3794_inverse__complex_Osimps_I1_J,axiom,
    ! [X2: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X2 ) )
      = ( divide_divide @ real @ ( re @ X2 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_3795_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( ( Z
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_3796_Re__divide,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( re @ ( divide_divide @ complex @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y2 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_3797_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_3798_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( power_power @ complex @ W @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W ) )
          | ( ( ( re @ W )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W ) ) ) )
       => ( ( csqrt @ Z )
          = W ) ) ) ).

% csqrt_unique
thf(fact_3799_inverse__complex_Osimps_I2_J,axiom,
    ! [X2: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X2 ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X2 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_3800_Im__divide,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( im @ ( divide_divide @ complex @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y2 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_3801_complex__abs__le__norm,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% complex_abs_le_norm
thf(fact_3802_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_3803_Im__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R ) ) @ ( im @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_3804_Re__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R ) @ ( re @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_3805_complex__diff__cnj,axiom,
    ! [Z: complex] :
      ( ( minus_minus @ complex @ Z @ ( cnj @ Z ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_3806_complex__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( times_times @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_3807_complex__cnj__mult,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( cnj @ ( times_times @ complex @ X2 @ Y2 ) )
      = ( times_times @ complex @ ( cnj @ X2 ) @ ( cnj @ Y2 ) ) ) ).

% complex_cnj_mult
thf(fact_3808_complex__cnj__zero,axiom,
    ( ( cnj @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% complex_cnj_zero
thf(fact_3809_complex__cnj__zero__iff,axiom,
    ! [Z: complex] :
      ( ( ( cnj @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% complex_cnj_zero_iff
thf(fact_3810_complex__cnj__add,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( cnj @ ( plus_plus @ complex @ X2 @ Y2 ) )
      = ( plus_plus @ complex @ ( cnj @ X2 ) @ ( cnj @ Y2 ) ) ) ).

% complex_cnj_add
thf(fact_3811_complex__cnj__diff,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( cnj @ ( minus_minus @ complex @ X2 @ Y2 ) )
      = ( minus_minus @ complex @ ( cnj @ X2 ) @ ( cnj @ Y2 ) ) ) ).

% complex_cnj_diff
thf(fact_3812_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_3813_Re__divide__Reals,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ Z @ R ) )
        = ( divide_divide @ real @ ( re @ Z ) @ ( re @ R ) ) ) ) ).

% Re_divide_Reals
thf(fact_3814_real__eq__imaginary__iff,axiom,
    ! [Y2: complex,X2: complex] :
      ( ( member @ complex @ Y2 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X2 @ ( real_Vector_Reals @ complex ) )
       => ( ( X2
            = ( times_times @ complex @ imaginary_unit @ Y2 ) )
          = ( ( X2
              = ( zero_zero @ complex ) )
            & ( Y2
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_3815_imaginary__eq__real__iff,axiom,
    ! [Y2: complex,X2: complex] :
      ( ( member @ complex @ Y2 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X2 @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y2 )
            = X2 )
          = ( ( X2
              = ( zero_zero @ complex ) )
            & ( Y2
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_3816_Im__divide__Reals,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ Z @ R ) )
        = ( divide_divide @ real @ ( im @ Z ) @ ( re @ R ) ) ) ) ).

% Im_divide_Reals
thf(fact_3817_Reals__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_0
thf(fact_3818_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_3819_Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_divide
thf(fact_3820_Reals__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_diff
thf(fact_3821_Reals__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_add
thf(fact_3822_Reals__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_mult
thf(fact_3823_Reals__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_numeral
thf(fact_3824_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( real_Vector_Reals @ complex ) )
      = ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% complex_is_Real_iff
thf(fact_3825_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_3826_Complex__in__Reals,axiom,
    ! [X2: real] : ( member @ complex @ ( complex2 @ X2 @ ( zero_zero @ real ) ) @ ( real_Vector_Reals @ complex ) ) ).

% Complex_in_Reals
thf(fact_3827_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( member @ A @ ( inverse_inverse @ A @ A2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% nonzero_Reals_inverse
thf(fact_3828_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_3829_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_3830_complex__mod__sqrt__Re__mult__cnj,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z5: complex] : ( sqrt @ ( re @ ( times_times @ complex @ Z5 @ ( cnj @ Z5 ) ) ) ) ) ) ).

% complex_mod_sqrt_Re_mult_cnj
thf(fact_3831_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_3832_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_3833_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_3834_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_3835_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_3836_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_3837_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_3838_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_3839_complex__mod__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_3840_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_3841_complex__norm__square,axiom,
    ! [Z: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z @ ( cnj @ Z ) ) ) ).

% complex_norm_square
thf(fact_3842_complex__add__cnj,axiom,
    ! [Z: complex] :
      ( ( plus_plus @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z ) ) ) ) ).

% complex_add_cnj
thf(fact_3843_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A4: complex,B3: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A4 @ ( cnj @ B3 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_3844_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z @ ( cnj @ W ) ) @ ( times_times @ complex @ ( cnj @ Z ) @ W ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z @ ( cnj @ W ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_3845_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X ) @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_3846_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X ) @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_3847_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_3848_num_Osize_I5_J,axiom,
    ! [X22: num] :
      ( ( size_size @ num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_3849_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_right
thf(fact_3850_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,B2: real] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
            = ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) )
          = ( ( A2 = B2 )
            | ( X2
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_cancel_right
thf(fact_3851_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [X2: A,A2: real,Y2: A] :
          ( ( times_times @ A @ X2 @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X2 @ Y2 ) ) ) ) ).

% mult_scaleR_right
thf(fact_3852_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ Y2 )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X2 @ Y2 ) ) ) ) ).

% mult_scaleR_left
thf(fact_3853_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
            = ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
          = ( ( X2 = Y2 )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_cancel_left
thf(fact_3854_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ A2 @ B2 ) @ X2 ) ) ) ).

% scaleR_scaleR
thf(fact_3855_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ real ) )
            | ( X2
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_eq_0_iff
thf(fact_3856_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( zero_zero @ real ) @ X2 )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_left
thf(fact_3857_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,U: real,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
            = ( plus_plus @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ U @ B2 ) ) )
          = ( ( A2 = B2 )
            | ( U
              = ( one_one @ real ) ) ) ) ) ).

% scaleR_eq_iff
thf(fact_3858_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: real,Y2: A,N2: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ Y2 ) @ N2 )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) ) ) ) ).

% scaleR_power
thf(fact_3859_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,A2: A] :
          ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ ( one_one @ real ) @ U ) @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
          = A2 ) ) ).

% scaleR_collapse
thf(fact_3860_norm__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: real,X2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ) ).

% norm_scaleR
thf(fact_3861_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ A2 ) ) ) ).

% scaleR_times
thf(fact_3862_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% inverse_scaleR_times
thf(fact_3863_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% fraction_scaleR_times
thf(fact_3864_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = A2 ) ) ).

% scaleR_half_double
thf(fact_3865_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
              = ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
           => ( X2 = Y2 ) ) ) ) ).

% scaleR_left_imp_eq
thf(fact_3866_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( size_size @ A @ X2 )
           != ( size_size @ A @ Y2 ) )
         => ( X2 != Y2 ) ) ) ).

% size_neq_size_imp_neq
thf(fact_3867_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ).

% scaleR_right_distrib
thf(fact_3868_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,A2: real,B2: real] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
              = ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
thf(fact_3869_real__scaleR__def,axiom,
    ( ( real_V8093663219630862766scaleR @ real )
    = ( times_times @ real ) ) ).

% real_scaleR_def
thf(fact_3870_scaleR__right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ).

% scaleR_right_diff_distrib
thf(fact_3871_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X2 )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ).

% scaleR_left_distrib
thf(fact_3872_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: real,Y2: real,Xa: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ X2 @ Y2 ) @ Xa )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ Xa ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ Xa ) ) ) ) ).

% scaleR_left.add
thf(fact_3873_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_V8093663219630862766scaleR @ A )
        = ( ^ [R5: real] : ( times_times @ A @ ( real_Vector_of_real @ A @ R5 ) ) ) ) ) ).

% scaleR_conv_of_real
thf(fact_3874_scaleR__left_Odiff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: real,Y2: real,Xa: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ X2 @ Y2 ) @ Xa )
          = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ Xa ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ Xa ) ) ) ) ).

% scaleR_left.diff
thf(fact_3875_scaleR__left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X2 )
          = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ).

% scaleR_left_diff_distrib
thf(fact_3876_scaleR__complex_Osimps_I1_J,axiom,
    ! [R: real,X2: complex] :
      ( ( re @ ( real_V8093663219630862766scaleR @ complex @ R @ X2 ) )
      = ( times_times @ real @ R @ ( re @ X2 ) ) ) ).

% scaleR_complex.simps(1)
thf(fact_3877_scaleR__complex_Osimps_I2_J,axiom,
    ! [R: real,X2: complex] :
      ( ( im @ ( real_V8093663219630862766scaleR @ complex @ R @ X2 ) )
      = ( times_times @ real @ R @ ( im @ X2 ) ) ) ).

% scaleR_complex.simps(2)
thf(fact_3878_complex__scaleR,axiom,
    ! [R: real,A2: real,B2: real] :
      ( ( real_V8093663219630862766scaleR @ complex @ R @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ B2 ) ) ) ).

% complex_scaleR
thf(fact_3879_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_3880_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_3881_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_3882_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_3883_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_3884_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_3885_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X2: A,Y2: A,A2: real] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_3886_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V: real,A2: A,X2: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 )
            = X2 )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X2
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A2 )
                = ( real_V8093663219630862766scaleR @ A @ V @ X2 ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_3887_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,U: real,V: real,A2: A] :
          ( ( X2
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 ) )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X2
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V @ X2 )
                = ( real_V8093663219630862766scaleR @ A @ U @ A2 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_3888_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E2 ) @ D3 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_3889_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E2 ) @ C2 ) @ D3 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_3890_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_3891_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_3892_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_3893_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_3894_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_3895_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_3896_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_3897_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_3898_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D3: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_3899_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X2: A,Y2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y2 ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_3900_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X2: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ X2 ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_3901_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 )
          = ( plus_plus @ A @ X2 @ X2 ) ) ) ).

% scaleR_2
thf(fact_3902_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X2: A,C2: A,Y2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X2 ) @ C2 )
              = Y2 )
            = ( X2
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_3903_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y2: A,X2: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y2
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X2 ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X2 ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_3904_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_3905_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_3906_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_3907_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_3908_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_3909_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_3910_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_3911_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_3912_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: real,X2: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( X2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) )
              = ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ A2 ) @ ( inverse_inverse @ A @ X2 ) ) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
thf(fact_3913_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_3914_scaleR__complex_Ocode,axiom,
    ( ( real_V8093663219630862766scaleR @ complex )
    = ( ^ [R5: real,X: complex] : ( complex2 @ ( times_times @ real @ R5 @ ( re @ X ) ) @ ( times_times @ real @ R5 @ ( im @ X ) ) ) ) ) ).

% scaleR_complex.code
thf(fact_3915_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_3916_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_3917_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_3918_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_3919_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_3920_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_3921_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_3922_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_3923_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_3924_drop__bit__numeral__minus__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_numeral_minus_bit1
thf(fact_3925_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_3926_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_3927_or_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ A2 )
          = A2 ) ) ).

% or.idem
thf(fact_3928_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.left_idem
thf(fact_3929_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.right_idem
thf(fact_3930_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_3931_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_3932_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_3933_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ A2 ) ) ) ).

% drop_bit_drop_bit
thf(fact_3934_take__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_or
thf(fact_3935_push__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_or
thf(fact_3936_drop__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_and
thf(fact_3937_drop__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_or
thf(fact_3938_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_xor
thf(fact_3939_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_3940_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_3941_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N2
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_3942_or__nonnegative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% or_nonnegative_int_iff
thf(fact_3943_or__negative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_3944_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Y2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) ) ) ) ).

% bit.de_Morgan_disj
thf(fact_3945_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) ) ) ) ).

% bit.de_Morgan_conj
thf(fact_3946_drop__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_3947_drop__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_3948_drop__bit__minus__one,axiom,
    ! [N2: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_3949_or__nat__numerals_I4_J,axiom,
    ! [X2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) ) ).

% or_nat_numerals(4)
thf(fact_3950_or__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% or_nat_numerals(2)
thf(fact_3951_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X2 ) ) ) ) ).

% or_numerals(8)
thf(fact_3952_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% or_numerals(2)
thf(fact_3953_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_3954_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_3955_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_3956_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ X2 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_3957_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_3958_or__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% or_nat_numerals(1)
thf(fact_3959_or__nat__numerals_I3_J,axiom,
    ! [X2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) ) ).

% or_nat_numerals(3)
thf(fact_3960_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% or_numerals(3)
thf(fact_3961_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X2 ) ) ) ) ).

% or_numerals(5)
thf(fact_3962_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% or_numerals(1)
thf(fact_3963_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit0
thf(fact_3964_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit1
thf(fact_3965_or__minus__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_3966_or__minus__numerals_I6_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_3967_drop__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_3968_drop__bit__numeral__minus__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_numeral_minus_bit0
thf(fact_3969_drop__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_3970_and__minus__minus__numerals,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_3971_or__minus__minus__numerals,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_3972_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_3973_length__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs2: list @ A] :
      ( ! [Xs3: list @ A] :
          ( ! [Ys: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys ) @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P @ Ys ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs2 ) ) ).

% length_induct
thf(fact_3974_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_drop_bit
thf(fact_3975_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N2 @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_3976_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_or_eq
thf(fact_3977_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% or_nat_def
thf(fact_3978_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ Z ) @ X2 )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ X2 ) @ ( bit_se1065995026697491101ons_or @ A @ Z @ X2 ) ) ) ) ).

% bit.disj_conj_distrib2
thf(fact_3979_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ Z ) @ X2 )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ X2 ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X2 ) ) ) ) ).

% bit.conj_disj_distrib2
thf(fact_3980_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ Z ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Y2 ) @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Z ) ) ) ) ).

% bit.disj_conj_distrib
thf(fact_3981_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ Z ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 ) @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Z ) ) ) ) ).

% bit.conj_disj_distrib
thf(fact_3982_bit__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ).

% bit_or_iff
thf(fact_3983_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_3984_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( zero_zero @ A ) )
          = X2 ) ) ).

% bit.disj_zero_right
thf(fact_3985_or_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.assoc
thf(fact_3986_or_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A4: A,B3: A] : ( bit_se1065995026697491101ons_or @ A @ B3 @ A4 ) ) ) ) ).

% or.commute
thf(fact_3987_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ B2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ C2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.left_commute
thf(fact_3988_bit__or__int__iff,axiom,
    ! [K: int,L2: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) @ N2 )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
        | ( bit_se5641148757651400278ts_bit @ int @ L2 @ N2 ) ) ) ).

% bit_or_int_iff
thf(fact_3989_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L2: int] :
          ( ( ring_1_of_int @ A @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) ) ) ).

% of_int_or_eq
thf(fact_3990_OR__lower,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X2 @ Y2 ) ) ) ) ).

% OR_lower
thf(fact_3991_or__greater__eq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) ) ) ).

% or_greater_eq
thf(fact_3992_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_3993_plus__and__or,axiom,
    ! [X2: int,Y2: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ ( bit_se1065995026697491101ons_or @ int @ X2 @ Y2 ) )
      = ( plus_plus @ int @ X2 @ Y2 ) ) ).

% plus_and_or
thf(fact_3994_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A4: A,B3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( bit_ri4277139882892585799ns_not @ A @ B3 ) ) ) ) ) ) ).

% or_eq_not_not_and
thf(fact_3995_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A4: A,B3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( bit_ri4277139882892585799ns_not @ A @ B3 ) ) ) ) ) ) ).

% and_eq_not_not_or
thf(fact_3996_or__int__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L: int] : ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ ( bit_ri4277139882892585799ns_not @ int @ L ) ) ) ) ) ).

% or_int_def
thf(fact_3997_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M3: nat,N: nat] : ( bit_se1065995026697491101ons_or @ nat @ N @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_3998_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_3999_drop__bit__push__bit__int,axiom,
    ! [M: nat,N2: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M @ N2 ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N2 @ M ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_4000_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ A2 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_4001_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N2 @ M ) @ ( bit_se4197421643247451524op_bit @ A @ M @ A2 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_4002_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_4003_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X: A,Y: A] : ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y ) @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ) ) ).

% bit.xor_def2
thf(fact_4004_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X: A,Y: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ Y ) ) ) ) ) ).

% bit.xor_def
thf(fact_4005_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_4006_xor__int__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ L ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ L ) ) ) ) ).

% xor_int_def
thf(fact_4007_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( divide_divide @ A @ A2 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_4008_concat__bit__def,axiom,
    ( bit_concat_bit
    = ( ^ [N: nat,K3: int,L: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ) ) ).

% concat_bit_def
thf(fact_4009_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A4 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_4010_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N: nat,K3: int] : ( bit_se1065995026697491101ons_or @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_4011_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = A2 ) ) ).

% bits_ident
thf(fact_4012_even__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_or_iff
thf(fact_4013_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X2: A,Y2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X2 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y2 )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y2 )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X2 = Y2 ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_4014_or__not__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) ) ).

% or_not_numerals(2)
thf(fact_4015_or__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_4016_drop__bit__half,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% drop_bit_half
thf(fact_4017_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 )
            = A2 ) ) ) ).

% stable_imp_drop_bit_eq
thf(fact_4018_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X2 @ Y2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X2 )
              = Y2 ) ) ) ) ).

% bit.compl_unique
thf(fact_4019_or__not__numerals_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) ) ).

% or_not_numerals(3)
thf(fact_4020_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_4021_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N: nat,K3: int] : ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% drop_bit_int_def
thf(fact_4022_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_if_negative
thf(fact_4023_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_4024_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N: nat,A4: A] : ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_4025_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N @ A4 ) ) ) ) ) ).

% bit_iff_odd_drop_bit
thf(fact_4026_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% even_drop_bit_iff_not_bit
thf(fact_4027_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% mask_Suc_exp
thf(fact_4028_or__not__numerals_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_4029_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A2 )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_or_eq
thf(fact_4030_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% or_one_eq
thf(fact_4031_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ).

% mask_Suc_double
thf(fact_4032_OR__upper,axiom,
    ! [X2: int,N2: nat,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less @ int @ X2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ int @ Y2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X2 @ Y2 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% OR_upper
thf(fact_4033_or__not__numerals_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_4034_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M @ N2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_4035_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A4 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_4036_Suc__0__or__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Suc_0_or_eq
thf(fact_4037_or__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% or_Suc_0_eq
thf(fact_4038_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N: nat,A4: A] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ A4
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_4039_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_4040_or__not__numerals_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_4041_or__not__numerals_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_4042__C5_Ohyps_C_I4_J,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% "5.hyps"(4)
thf(fact_4043_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L: int] :
          ( if @ int
          @ ( ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ int ) )
            @ L
            @ ( if @ int
              @ ( L
                = ( zero_zero @ int ) )
              @ K3
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_4044_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_4045_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_4046_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb1
thf(fact_4047_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_4048_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.bounded_iff
thf(fact_4049_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb3
thf(fact_4050_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_4051_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X2 @ Y2 ) @ Z )
          = ( ( ord_less @ A @ X2 @ Z )
            & ( ord_less @ A @ Y2 @ Z ) ) ) ) ).

% max_less_iff_conj
thf(fact_4052_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_4053_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_4054_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X2 ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(4)
thf(fact_4055_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(3)
thf(fact_4056_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_4057_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_4058_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(5)
thf(fact_4059_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(6)
thf(fact_4060_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_4061_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_4062_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_4063_drop__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_4064_of__int__max,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: int,Y2: int] :
          ( ( ring_1_of_int @ A @ ( ord_max @ int @ X2 @ Y2 ) )
          = ( ord_max @ A @ ( ring_1_of_int @ A @ X2 ) @ ( ring_1_of_int @ A @ Y2 ) ) ) ) ).

% of_int_max
thf(fact_4065_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X2 @ Y2 ) @ Z )
          = ( ord_max @ A @ ( plus_plus @ A @ X2 @ Z ) @ ( plus_plus @ A @ Y2 @ Z ) ) ) ) ).

% max_add_distrib_left
thf(fact_4066_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ X2 @ ( ord_max @ A @ Y2 @ Z ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( plus_plus @ A @ X2 @ Z ) ) ) ) ).

% max_add_distrib_right
thf(fact_4067_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X2 @ Y2 ) @ Z )
          = ( ord_max @ A @ ( minus_minus @ A @ X2 @ Z ) @ ( minus_minus @ A @ Y2 @ Z ) ) ) ) ).

% max_diff_distrib_left
thf(fact_4068_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ Z @ ( ord_max @ A @ X2 @ Y2 ) )
          = ( ( ord_less @ A @ Z @ X2 )
            | ( ord_less @ A @ Z @ Y2 ) ) ) ) ).

% less_max_iff_disj
thf(fact_4069_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% max.strict_boundedE
thf(fact_4070_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( A4
                = ( ord_max @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_4071_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_4072_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_4073_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_4074_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_4075_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_max @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% max.absorb_iff2
thf(fact_4076_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_max @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% max.absorb_iff1
thf(fact_4077_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ Z @ ( ord_max @ A @ X2 @ Y2 ) )
          = ( ( ord_less_eq @ A @ Z @ X2 )
            | ( ord_less_eq @ A @ Z @ Y2 ) ) ) ) ).

% le_max_iff_disj
thf(fact_4078_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_4079_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_4080_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( A4
              = ( ord_max @ A @ A4 @ B3 ) ) ) ) ) ).

% max.order_iff
thf(fact_4081_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% max.boundedI
thf(fact_4082_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.boundedE
thf(fact_4083_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_max @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% max.orderI
thf(fact_4084_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_4085_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,D3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D3 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D3 ) @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_4086_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: nat,Y2: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X2 @ Y2 ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( semiring_1_of_nat @ A @ Y2 ) ) ) ) ).

% of_nat_max
thf(fact_4087_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_max @ A @ X2 @ Y2 )
            = Y2 ) ) ) ).

% max_absorb2
thf(fact_4088_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( ord_max @ A @ X2 @ Y2 )
            = X2 ) ) ) ).

% max_absorb1
thf(fact_4089_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ B3 @ A4 ) ) ) ) ).

% max_def
thf(fact_4090_drop__bit__nat__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N2 @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) ) ) ).

% drop_bit_nat_eq
thf(fact_4091_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N: nat,M3: nat] : ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% drop_bit_nat_def
thf(fact_4092__C5_Ohyps_C_I11_J,axiom,
    ( ( mi != ma )
   => ! [I2: nat] :
        ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
       => ( ( ( ( vEBT_VEBT_high @ ma @ na )
              = I2 )
           => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I2 ) @ ( vEBT_VEBT_low @ ma @ na ) ) )
          & ! [X4: nat] :
              ( ( ( ( vEBT_VEBT_high @ X4 @ na )
                  = I2 )
                & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I2 ) @ ( vEBT_VEBT_low @ X4 @ na ) ) )
             => ( ( ord_less @ nat @ mi @ X4 )
                & ( ord_less_eq @ nat @ X4 @ ma ) ) ) ) ) ) ).

% "5.hyps"(11)
thf(fact_4093__C04_C,axiom,
    vEBT_is_succ_in_set @ ( vEBT_VEBT_set_vebt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ succy ).

% "04"
thf(fact_4094__C06_C,axiom,
    member @ nat @ succy @ ( vEBT_VEBT_set_vebt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% "06"
thf(fact_4095__092_060open_062vebt__member_A_ItreeList_A_B_Ahigh_Ax_A_Ideg_Adiv_A2_J_J_A_Ilow_Az_A_Ideg_Adiv_A2_J_J_092_060close_062,axiom,
    vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ z @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% \<open>vebt_member (treeList ! high x (deg div 2)) (low z (deg div 2))\<close>
thf(fact_4096_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = Q2 ) ).

% max_enat_simps(3)
thf(fact_4097_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = Q2 ) ).

% max_enat_simps(2)
thf(fact_4098_succ__member,axiom,
    ! [T2: vEBT_VEBT,X2: nat,Y2: nat] :
      ( ( vEBT_is_succ_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X2 @ Y2 )
      = ( ( vEBT_vebt_member @ T2 @ Y2 )
        & ( ord_less @ nat @ X2 @ Y2 )
        & ! [Z5: nat] :
            ( ( ( vEBT_vebt_member @ T2 @ Z5 )
              & ( ord_less @ nat @ X2 @ Z5 ) )
           => ( ord_less_eq @ nat @ Y2 @ Z5 ) ) ) ) ).

% succ_member
thf(fact_4099_max__Suc__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_max @ nat @ M @ N2 ) ) ) ).

% max_Suc_Suc
thf(fact_4100_max__0R,axiom,
    ! [N2: nat] :
      ( ( ord_max @ nat @ N2 @ ( zero_zero @ nat ) )
      = N2 ) ).

% max_0R
thf(fact_4101_max__0L,axiom,
    ! [N2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N2 )
      = N2 ) ).

% max_0L
thf(fact_4102_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_4103_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_4104_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_4105_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_4106__C09_C,axiom,
    vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ).

% "09"
thf(fact_4107__C08_C,axiom,
    vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ).

% "08"
thf(fact_4108__C03_C,axiom,
    ? [Y3: nat] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Y3 )
      & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Y3 ) ) ).

% "03"
thf(fact_4109__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062succy_O_Ais__succ__in__set_A_Iset__vebt_H_A_ItreeList_A_B_Ahigh_Ax_A_Ideg_Adiv_A2_J_J_J_A_Ilow_Ax_A_Ideg_Adiv_A2_J_J_Asuccy_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,
    ~ ! [Succy: nat] :
        ~ ( vEBT_is_succ_in_set @ ( vEBT_VEBT_set_vebt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Succy ) ).

% \<open>\<And>thesis. (\<And>succy. is_succ_in_set (set_vebt' (treeList ! high x (deg div 2))) (low x (deg div 2)) succy \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_4110_max__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N2 ) ) ) ).

% max_numeral_Suc
thf(fact_4111_max__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N2 @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_4112__C02_C,axiom,
    vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ maxl ).

% "02"
thf(fact_4113_nat__mult__max__left,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N2 ) @ Q2 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N2 @ Q2 ) ) ) ).

% nat_mult_max_left
thf(fact_4114_nat__mult__max__right,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N2 @ Q2 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N2 ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_max_right
thf(fact_4115_nat__add__max__left,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N2 ) @ Q2 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q2 ) @ ( plus_plus @ nat @ N2 @ Q2 ) ) ) ).

% nat_add_max_left
thf(fact_4116_nat__add__max__right,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N2 @ Q2 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( plus_plus @ nat @ M @ Q2 ) ) ) ).

% nat_add_max_right
thf(fact_4117_nth__equalityI,axiom,
    ! [A: $tType,Xs2: list @ A,Ys2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ A ) @ Ys2 ) )
     => ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( ( nth @ A @ Xs2 @ I4 )
              = ( nth @ A @ Ys2 @ I4 ) ) )
       => ( Xs2 = Ys2 ) ) ) ).

% nth_equalityI
thf(fact_4118_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: nat > A > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ K )
           => ? [X8: A] : ( P @ I3 @ X8 ) ) )
      = ( ? [Xs: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs )
              = K )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ K )
               => ( P @ I3 @ ( nth @ A @ Xs @ I3 ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_4119_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y5: list @ A,Z4: list @ A] : ( Y5 = Z4 ) )
      = ( ^ [Xs: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I3 )
                  = ( nth @ A @ Ys3 @ I3 ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_4120_nat__minus__add__max,axiom,
    ! [N2: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N2 @ M ) @ M )
      = ( ord_max @ nat @ N2 @ M ) ) ).

% nat_minus_add_max
thf(fact_4121_is__succ__in__set__def,axiom,
    ( vEBT_is_succ_in_set
    = ( ^ [Xs: set @ nat,X: nat,Y: nat] :
          ( ( member @ nat @ Y @ Xs )
          & ( ord_less @ nat @ X @ Y )
          & ! [Z5: nat] :
              ( ( member @ nat @ Z5 @ Xs )
             => ( ( ord_less @ nat @ X @ Z5 )
               => ( ord_less_eq @ nat @ Y @ Z5 ) ) ) ) ) ) ).

% is_succ_in_set_def
thf(fact_4122_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N
          @ ( if @ nat
            @ ( N
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_4123_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N: nat,TreeList: list @ vEBT_VEBT,X: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ N ) ) @ ( vEBT_VEBT_low @ X @ N ) ) ) ) ).

% in_children_def
thf(fact_4124_afinite,axiom,
    finite_finite @ nat @ ( vEBT_VEBT_set_vebt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% afinite
thf(fact_4125_member__bound,axiom,
    ! [Tree: vEBT_VEBT,X2: nat,N2: nat] :
      ( ( vEBT_vebt_member @ Tree @ X2 )
     => ( ( vEBT_invar_vebt @ Tree @ N2 )
       => ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% member_bound
thf(fact_4126__C5_Ohyps_C_I7_J,axiom,
    ! [I2: nat] :
      ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I2 ) @ X8 ) )
        = ( vEBT_V8194947554948674370ptions @ summary @ I2 ) ) ) ).

% "5.hyps"(7)
thf(fact_4127_valid__0__not,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_0_not
thf(fact_4128_valid__tree__deg__neq__0,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_tree_deg_neq_0
thf(fact_4129__C5_Ohyps_C_I2_J,axiom,
    vEBT_invar_vebt @ summary @ m ).

% "5.hyps"(2)
thf(fact_4130_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% deg_not_0
thf(fact_4131_both__member__options__equiv__member,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X2 )
        = ( vEBT_vebt_member @ T2 @ X2 ) ) ) ).

% both_member_options_equiv_member
thf(fact_4132_valid__member__both__member__options,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X2 )
       => ( vEBT_vebt_member @ T2 @ X2 ) ) ) ).

% valid_member_both_member_options
thf(fact_4133_set__vebt__finite,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( finite_finite @ nat @ ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_finite
thf(fact_4134_succ__none__empty,axiom,
    ! [Xs2: set @ nat,A2: nat] :
      ( ~ ? [X_1: nat] : ( vEBT_is_succ_in_set @ Xs2 @ A2 @ X_1 )
     => ( ( finite_finite @ nat @ Xs2 )
       => ~ ? [X4: nat] :
              ( ( member @ nat @ X4 @ Xs2 )
              & ( ord_less @ nat @ A2 @ X4 ) ) ) ) ).

% succ_none_empty
thf(fact_4135_obtain__set__succ,axiom,
    ! [X2: nat,Z: nat,A3: set @ nat,B4: set @ nat] :
      ( ( ord_less @ nat @ X2 @ Z )
     => ( ( vEBT_VEBT_max_in_set @ A3 @ Z )
       => ( ( finite_finite @ nat @ B4 )
         => ( ( A3 = B4 )
           => ? [X_1: nat] : ( vEBT_is_succ_in_set @ A3 @ X2 @ X_1 ) ) ) ) ) ).

% obtain_set_succ
thf(fact_4136_member__correct,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_vebt_member @ T2 @ X2 )
        = ( member @ nat @ X2 @ ( vEBT_set_vebt @ T2 ) ) ) ) ).

% member_correct
thf(fact_4137_set__vebt__set__vebt_H__valid,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_set_vebt @ T2 )
        = ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_set_vebt'_valid
thf(fact_4138__092_060open_062length_AtreeList_A_061_A2_A_094_Am_A_092_060and_062_Ainvar__vebt_Asummary_Am_092_060close_062,axiom,
    ( ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
    & ( vEBT_invar_vebt @ summary @ m ) ) ).

% \<open>length treeList = 2 ^ m \<and> invar_vebt summary m\<close>
thf(fact_4139__C5_Ohyps_C_I8_J,axiom,
    ( ( mi = ma )
   => ! [X4: vEBT_VEBT] :
        ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ treeList ) )
       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) ) ) ).

% "5.hyps"(8)
thf(fact_4140_bounded__nat__set__is__finite,axiom,
    ! [N5: set @ nat,N2: nat] :
      ( ! [X3: nat] :
          ( ( member @ nat @ X3 @ N5 )
         => ( ord_less @ nat @ X3 @ N2 ) )
     => ( finite_finite @ nat @ N5 ) ) ).

% bounded_nat_set_is_finite
thf(fact_4141_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X: nat] :
          ( ( member @ nat @ X @ N6 )
         => ( ord_less @ nat @ X @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_4142_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X: nat] :
          ( ( member @ nat @ X @ N6 )
         => ( ord_less_eq @ nat @ X @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_4143_finite__set__decode,axiom,
    ! [N2: nat] : ( finite_finite @ nat @ ( nat_set_decode @ N2 ) ) ).

% finite_set_decode
thf(fact_4144_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N2 )
          = ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N2 ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_4145_post__member__pre__member,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat,Y2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ( vEBT_vebt_member @ ( vEBT_vebt_insert @ T2 @ X2 ) @ Y2 )
           => ( ( vEBT_vebt_member @ T2 @ Y2 )
              | ( X2 = Y2 ) ) ) ) ) ) ).

% post_member_pre_member
thf(fact_4146_valid__insert__both__member__options__pres,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat,Y2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ( vEBT_V8194947554948674370ptions @ T2 @ X2 )
           => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ Y2 ) @ X2 ) ) ) ) ) ).

% valid_insert_both_member_options_pres
thf(fact_4147_valid__insert__both__member__options__add,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ X2 ) @ X2 ) ) ) ).

% valid_insert_both_member_options_add
thf(fact_4148__C01_C,axiom,
    ( ( vEBT_invar_vebt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ na )
    & ( member @ vEBT_VEBT @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( set2 @ vEBT_VEBT @ treeList ) ) ) ).

% "01"
thf(fact_4149_inthall,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,N2: nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
         => ( P @ X3 ) )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( P @ ( nth @ A @ Xs2 @ N2 ) ) ) ) ).

% inthall
thf(fact_4150_set__n__deg__not__0,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,M: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 ) ) ) ).

% set_n_deg_not_0
thf(fact_4151_length__pos__if__in__set,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_pos_if_in_set
thf(fact_4152_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( ! [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
           => ( P @ X ) ) )
      = ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( P @ ( nth @ A @ Xs2 @ I3 ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_4153_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,X2: A] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( P @ ( nth @ A @ Xs2 @ I4 ) ) )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
       => ( P @ X2 ) ) ) ).

% all_nth_imp_all_set
thf(fact_4154_in__set__conv__nth,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
      = ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ( nth @ A @ Xs2 @ I3 )
              = X2 ) ) ) ) ).

% in_set_conv_nth
thf(fact_4155_list__ball__nth,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,P: A > $o] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X3 ) )
       => ( P @ ( nth @ A @ Xs2 @ N2 ) ) ) ) ).

% list_ball_nth
thf(fact_4156_nth__mem,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( member @ A @ ( nth @ A @ Xs2 @ N2 ) @ ( set2 @ A @ Xs2 ) ) ) ).

% nth_mem
thf(fact_4157_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ X2 ) ) ) ) ).

% both_member_options_ding
thf(fact_4158_inrange,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ord_less_eq @ ( set @ nat ) @ ( vEBT_VEBT_set_vebt @ T2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ).

% inrange
thf(fact_4159_buildup__gives__valid,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N2 ) @ N2 ) ) ).

% buildup_gives_valid
thf(fact_4160__C00_C,axiom,
    ( ( ( some @ nat @ maxl )
      = ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
    & ( ord_less @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ maxl ) ) ).

% "00"
thf(fact_4161_deg__deg__n,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( Deg = N2 ) ) ).

% deg_deg_n
thf(fact_4162_deg__SUcn__Node,axiom,
    ! [Tree: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ Tree @ ( suc @ ( suc @ N2 ) ) )
     => ? [Info2: option @ ( product_prod @ nat @ nat ),TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
          ( Tree
          = ( vEBT_Node @ Info2 @ ( suc @ ( suc @ N2 ) ) @ TreeList3 @ S3 ) ) ) ).

% deg_SUcn_Node
thf(fact_4163_maxbmo,axiom,
    ! [T2: vEBT_VEBT,X2: nat] :
      ( ( ( vEBT_vebt_maxt @ T2 )
        = ( some @ nat @ X2 ) )
     => ( vEBT_V8194947554948674370ptions @ T2 @ X2 ) ) ).

% maxbmo
thf(fact_4164_power__shift,axiom,
    ! [X2: nat,Y2: nat,Z: nat] :
      ( ( ( power_power @ nat @ X2 @ Y2 )
        = Z )
      = ( ( vEBT_VEBT_power @ ( some @ nat @ X2 ) @ ( some @ nat @ Y2 ) )
        = ( some @ nat @ Z ) ) ) ).

% power_shift
thf(fact_4165_maxt__member,axiom,
    ! [T2: vEBT_VEBT,N2: nat,Maxi: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ( vEBT_vebt_maxt @ T2 )
          = ( some @ nat @ Maxi ) )
       => ( vEBT_vebt_member @ T2 @ Maxi ) ) ) ).

% maxt_member
thf(fact_4166_VEBT_Oinject_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_4167_maxt__corr__help,axiom,
    ! [T2: vEBT_VEBT,N2: nat,Maxi: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ( vEBT_vebt_maxt @ T2 )
          = ( some @ nat @ Maxi ) )
       => ( ( vEBT_vebt_member @ T2 @ X2 )
         => ( ord_less_eq @ nat @ X2 @ Maxi ) ) ) ) ).

% maxt_corr_help
thf(fact_4168_maxt__corr,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ( vEBT_vebt_maxt @ T2 )
          = ( some @ nat @ X2 ) )
       => ( vEBT_VEBT_max_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X2 ) ) ) ).

% maxt_corr
thf(fact_4169_maxt__sound,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_VEBT_max_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X2 )
       => ( ( vEBT_vebt_maxt @ T2 )
          = ( some @ nat @ X2 ) ) ) ) ).

% maxt_sound
thf(fact_4170_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L2: A,H2: A,L4: A,H3: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L2 @ H2 )
            = ( set_or1337092689740270186AtMost @ A @ L4 @ H3 ) )
          = ( ( ( L2 = L4 )
              & ( H2 = H3 ) )
            | ( ~ ( ord_less_eq @ A @ L2 @ H2 )
              & ~ ( ord_less_eq @ A @ L4 @ H3 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_4171_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L2: A,U: A] :
          ( ( member @ A @ I @ ( set_or1337092689740270186AtMost @ A @ L2 @ U ) )
          = ( ( ord_less_eq @ A @ L2 @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_4172_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D3 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_4173_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_4174__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062maxl_O_ASome_Amaxl_A_061_Avebt__maxt_A_ItreeList_A_B_Ahigh_Ax_A_Ideg_Adiv_A2_J_J_A_092_060and_062_Alow_Ax_A_Ideg_Adiv_A2_J_A_060_Amaxl_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,
    ~ ! [Maxl: nat] :
        ~ ( ( ( some @ nat @ Maxl )
            = ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Maxl ) ) ).

% \<open>\<And>thesis. (\<And>maxl. Some maxl = vebt_maxt (treeList ! high x (deg div 2)) \<and> low x (deg div 2) < maxl \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_4175_greater__shift,axiom,
    ( ( ord_less @ nat )
    = ( ^ [Y: nat,X: nat] : ( vEBT_VEBT_greater @ ( some @ nat @ X ) @ ( some @ nat @ Y ) ) ) ) ).

% greater_shift
thf(fact_4176_lesseq__shift,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [X: nat,Y: nat] : ( vEBT_VEBT_lesseq @ ( some @ nat @ X ) @ ( some @ nat @ Y ) ) ) ) ).

% lesseq_shift
thf(fact_4177__C5_Ohyps_C_I1_J,axiom,
    ! [X4: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( ( vEBT_invar_vebt @ X4 @ na )
        & ! [Xa2: nat,Xb2: nat] :
            ( ( ( vEBT_vebt_succ @ X4 @ Xa2 )
              = ( some @ nat @ Xb2 ) )
            = ( vEBT_is_succ_in_set @ ( vEBT_VEBT_set_vebt @ X4 ) @ Xa2 @ Xb2 ) ) ) ) ).

% "5.hyps"(1)
thf(fact_4178_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D3 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D3 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D3 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_4179_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_4180_all__nat__less,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N2 )
           => ( P @ M3 ) ) )
      = ( ! [X: nat] :
            ( ( member @ nat @ X @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
           => ( P @ X ) ) ) ) ).

% all_nat_less
thf(fact_4181_ex__nat__less,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N2 )
            & ( P @ M3 ) ) )
      = ( ? [X: nat] :
            ( ( member @ nat @ X @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
            & ( P @ X ) ) ) ) ).

% ex_nat_less
thf(fact_4182_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N5: set @ nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
     => ( finite_finite @ nat @ N5 ) ) ).

% subset_eq_atLeast0_atMost_finite
thf(fact_4183__C05_C,axiom,
    ( ( some @ nat @ succy )
    = ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% "05"
thf(fact_4184_mul__shift,axiom,
    ! [X2: nat,Y2: nat,Z: nat] :
      ( ( ( times_times @ nat @ X2 @ Y2 )
        = Z )
      = ( ( vEBT_VEBT_mul @ ( some @ nat @ X2 ) @ ( some @ nat @ Y2 ) )
        = ( some @ nat @ Z ) ) ) ).

% mul_shift
thf(fact_4185_add__shift,axiom,
    ! [X2: nat,Y2: nat,Z: nat] :
      ( ( ( plus_plus @ nat @ X2 @ Y2 )
        = Z )
      = ( ( vEBT_VEBT_add @ ( some @ nat @ X2 ) @ ( some @ nat @ Y2 ) )
        = ( some @ nat @ Z ) ) ) ).

% add_shift
thf(fact_4186_misiz,axiom,
    ! [T2: vEBT_VEBT,N2: nat,M: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ( some @ nat @ M )
          = ( vEBT_vebt_mint @ T2 ) )
       => ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% misiz
thf(fact_4187_mint__member,axiom,
    ! [T2: vEBT_VEBT,N2: nat,Maxi: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ( vEBT_vebt_mint @ T2 )
          = ( some @ nat @ Maxi ) )
       => ( vEBT_vebt_member @ T2 @ Maxi ) ) ) ).

% mint_member
thf(fact_4188_mint__corr__help,axiom,
    ! [T2: vEBT_VEBT,N2: nat,Mini: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ( vEBT_vebt_mint @ T2 )
          = ( some @ nat @ Mini ) )
       => ( ( vEBT_vebt_member @ T2 @ X2 )
         => ( ord_less_eq @ nat @ Mini @ X2 ) ) ) ) ).

% mint_corr_help
thf(fact_4189_mint__sound,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_VEBT_min_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X2 )
       => ( ( vEBT_vebt_mint @ T2 )
          = ( some @ nat @ X2 ) ) ) ) ).

% mint_sound
thf(fact_4190_mint__corr,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ( vEBT_vebt_mint @ T2 )
          = ( some @ nat @ X2 ) )
       => ( vEBT_VEBT_min_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X2 ) ) ) ).

% mint_corr
thf(fact_4191__C5_Ohyps_C_I3_J,axiom,
    ! [X2: nat,Sx: nat] :
      ( ( ( vEBT_vebt_succ @ summary @ X2 )
        = ( some @ nat @ Sx ) )
      = ( vEBT_is_succ_in_set @ ( vEBT_VEBT_set_vebt @ summary ) @ X2 @ Sx ) ) ).

% "5.hyps"(3)
thf(fact_4192_add__def,axiom,
    ( vEBT_VEBT_add
    = ( vEBT_V2048590022279873568_shift @ nat @ ( plus_plus @ nat ) ) ) ).

% add_def
thf(fact_4193_mul__def,axiom,
    ( vEBT_VEBT_mul
    = ( vEBT_V2048590022279873568_shift @ nat @ ( times_times @ nat ) ) ) ).

% mul_def
thf(fact_4194_local_Opower__def,axiom,
    ( vEBT_VEBT_power
    = ( vEBT_V2048590022279873568_shift @ nat @ ( power_power @ nat ) ) ) ).

% local.power_def
thf(fact_4195_finite__maxlen,axiom,
    ! [A: $tType,M7: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M7 )
     => ? [N3: nat] :
        ! [X4: list @ A] :
          ( ( member @ ( list @ A ) @ X4 @ M7 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X4 ) @ N3 ) ) ) ).

% finite_maxlen
thf(fact_4196_aset_I2_J,axiom,
    ! [D6: int,A3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D6 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( plus_plus @ int @ X3 @ D6 ) ) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X4 )
                | ( Q @ X4 ) )
             => ( ( P @ ( plus_plus @ int @ X4 @ D6 ) )
                | ( Q @ ( plus_plus @ int @ X4 @ D6 ) ) ) ) ) ) ) ).

% aset(2)
thf(fact_4197_aset_I1_J,axiom,
    ! [D6: int,A3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D6 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( plus_plus @ int @ X3 @ D6 ) ) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X4 )
                & ( Q @ X4 ) )
             => ( ( P @ ( plus_plus @ int @ X4 @ D6 ) )
                & ( Q @ ( plus_plus @ int @ X4 @ D6 ) ) ) ) ) ) ) ).

% aset(1)
thf(fact_4198_bset_I2_J,axiom,
    ! [D6: int,B4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B4 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D6 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( minus_minus @ int @ X3 @ D6 ) ) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X4 )
                | ( Q @ X4 ) )
             => ( ( P @ ( minus_minus @ int @ X4 @ D6 ) )
                | ( Q @ ( minus_minus @ int @ X4 @ D6 ) ) ) ) ) ) ) ).

% bset(2)
thf(fact_4199_bset_I1_J,axiom,
    ! [D6: int,B4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B4 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D6 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( minus_minus @ int @ X3 @ D6 ) ) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X4 )
                & ( Q @ X4 ) )
             => ( ( P @ ( minus_minus @ int @ X4 @ D6 ) )
                & ( Q @ ( minus_minus @ int @ X4 @ D6 ) ) ) ) ) ) ) ).

% bset(1)
thf(fact_4200_aset_I10_J,axiom,
    ! [D3: int,D6: int,A3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D3 @ D6 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A3 )
                 => ( X4
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ X4 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ ( plus_plus @ int @ X4 @ D6 ) @ T2 ) ) ) ) ) ).

% aset(10)
thf(fact_4201_aset_I9_J,axiom,
    ! [D3: int,D6: int,A3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D3 @ D6 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A3 )
                 => ( X4
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ X4 @ T2 ) )
           => ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ ( plus_plus @ int @ X4 @ D6 ) @ T2 ) ) ) ) ) ).

% aset(9)
thf(fact_4202_bset_I10_J,axiom,
    ! [D3: int,D6: int,B4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D3 @ D6 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ X4 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ ( minus_minus @ int @ X4 @ D6 ) @ T2 ) ) ) ) ) ).

% bset(10)
thf(fact_4203_bset_I9_J,axiom,
    ! [D3: int,D6: int,B4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D3 @ D6 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ X4 @ T2 ) )
           => ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ ( minus_minus @ int @ X4 @ D6 ) @ T2 ) ) ) ) ) ).

% bset(9)
thf(fact_4204_periodic__finite__ex,axiom,
    ! [D3: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ! [X3: int,K2: int] :
            ( ( P @ X3 )
            = ( P @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D3 ) ) ) )
       => ( ( ? [X8: int] : ( P @ X8 ) )
          = ( ? [X: int] :
                ( ( member @ int @ X @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
                & ( P @ X ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_4205_aset_I7_J,axiom,
    ! [D6: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A3 )
                 => ( X4
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X4 )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X4 @ D6 ) ) ) ) ) ).

% aset(7)
thf(fact_4206_aset_I5_J,axiom,
    ! [D6: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X4 @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X4 @ D6 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_4207_aset_I4_J,axiom,
    ! [D6: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X4 != T2 )
             => ( ( plus_plus @ int @ X4 @ D6 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_4208_aset_I3_J,axiom,
    ! [D6: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X4 = T2 )
             => ( ( plus_plus @ int @ X4 @ D6 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_4209_bset_I7_J,axiom,
    ! [D6: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ( member @ int @ T2 @ B4 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X4 )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X4 @ D6 ) ) ) ) ) ) ).

% bset(7)
thf(fact_4210_bset_I5_J,axiom,
    ! [D6: int,B4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X4 @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X4 @ D6 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_4211_bset_I4_J,axiom,
    ! [D6: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ( member @ int @ T2 @ B4 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X4 != T2 )
             => ( ( minus_minus @ int @ X4 @ D6 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_4212_bset_I3_J,axiom,
    ! [D6: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B4 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X4 = T2 )
             => ( ( minus_minus @ int @ X4 @ D6 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_4213_aset_I8_J,axiom,
    ! [D6: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A3 )
                 => ( X4
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X4 )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X4 @ D6 ) ) ) ) ) ).

% aset(8)
thf(fact_4214_aset_I6_J,axiom,
    ! [D6: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X4 @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X4 @ D6 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_4215_bset_I8_J,axiom,
    ! [D6: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B4 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X4 )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X4 @ D6 ) ) ) ) ) ) ).

% bset(8)
thf(fact_4216_bset_I6_J,axiom,
    ! [D6: int,B4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X4 @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X4 @ D6 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_4217_cpmi,axiom,
    ! [D6: int,P: int > $o,P3: int > $o,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ? [Z2: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ X3 @ Z2 )
           => ( ( P @ X3 )
              = ( P3 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
                 => ! [Xb2: int] :
                      ( ( member @ int @ Xb2 @ B4 )
                     => ( X3
                       != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( minus_minus @ int @ X3 @ D6 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P3 @ X3 )
                = ( P3 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D6 ) ) ) )
           => ( ( ? [X8: int] : ( P @ X8 ) )
              = ( ? [X: int] :
                    ( ( member @ int @ X @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
                    & ( P3 @ X ) )
                | ? [X: int] :
                    ( ( member @ int @ X @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
                    & ? [Y: int] :
                        ( ( member @ int @ Y @ B4 )
                        & ( P @ ( plus_plus @ int @ Y @ X ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_4218_cppi,axiom,
    ! [D6: int,P: int > $o,P3: int > $o,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D6 )
     => ( ? [Z2: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ Z2 @ X3 )
           => ( ( P @ X3 )
              = ( P3 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
                 => ! [Xb2: int] :
                      ( ( member @ int @ Xb2 @ A3 )
                     => ( X3
                       != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( plus_plus @ int @ X3 @ D6 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P3 @ X3 )
                = ( P3 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D6 ) ) ) )
           => ( ( ? [X8: int] : ( P @ X8 ) )
              = ( ? [X: int] :
                    ( ( member @ int @ X @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
                    & ( P3 @ X ) )
                | ? [X: int] :
                    ( ( member @ int @ X @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D6 ) )
                    & ? [Y: int] :
                        ( ( member @ int @ Y @ A3 )
                        & ( P @ ( minus_minus @ int @ Y @ X ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_4219_less__shift,axiom,
    ( ( ord_less @ nat )
    = ( ^ [X: nat,Y: nat] : ( vEBT_VEBT_less @ ( some @ nat @ X ) @ ( some @ nat @ Y ) ) ) ) ).

% less_shift
thf(fact_4220__C16_C,axiom,
    ( ( some @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) )
    = ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa ) ) ).

% "16"
thf(fact_4221__C15_C,axiom,
    vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) ).

% "15"
thf(fact_4222__C14_C,axiom,
    vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) ).

% "14"
thf(fact_4223_mi__eq__ma__no__ch,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg )
     => ( ( Mi = Ma )
       => ( ! [X4: vEBT_VEBT] :
              ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
             => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) )
          & ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 ) ) ) ) ).

% mi_eq_ma_no_ch
thf(fact_4224__092_060open_062vebt__member_A_INode_A_ISome_A_Imi_M_Ama_J_J_Adeg_AtreeList_Asummary_J_Az_092_060close_062,axiom,
    vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ z ).

% \<open>vebt_member (Node (Some (mi, ma)) deg treeList summary) z\<close>
thf(fact_4225_insert__simp__mima,axiom,
    ! [X2: nat,Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ( X2 = Mi )
        | ( X2 = Ma ) )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
       => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 )
          = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) ) ) ) ).

% insert_simp_mima
thf(fact_4226_mi__ma__2__deg,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( ( ord_less_eq @ nat @ Mi @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_4227_succ__min,axiom,
    ! [Deg: nat,X2: nat,Mi: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
     => ( ( ord_less @ nat @ X2 @ Mi )
       => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 )
          = ( some @ nat @ Mi ) ) ) ) ).

% succ_min
thf(fact_4228_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X2 = Mi )
          | ( X2 = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_4229_mintlistlength,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( ( Mi != Ma )
       => ( ( ord_less @ nat @ Mi @ Ma )
          & ? [M4: nat] :
              ( ( ( some @ nat @ M4 )
                = ( vEBT_vebt_mint @ Summary ) )
              & ( ord_less @ nat @ M4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% mintlistlength
thf(fact_4230_member__inv,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
        & ( ( X2 = Mi )
          | ( X2 = Ma )
          | ( ( ord_less @ nat @ X2 @ Ma )
            & ( ord_less @ nat @ Mi @ X2 )
            & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
            & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% member_inv
thf(fact_4231_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X2: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_4232_prod__decode__aux_Ocases,axiom,
    ! [X2: product_prod @ nat @ nat] :
      ~ ! [K2: nat,M4: nat] :
          ( X2
         != ( product_Pair @ nat @ nat @ K2 @ M4 ) ) ).

% prod_decode_aux.cases
thf(fact_4233_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N2 )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I4: nat] :
                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N2 )
                                    = I4 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ Ma @ N2 ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N2 )
                                        = I4 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ X3 @ N2 ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_4234_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N2 ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I4: nat] :
                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N2 )
                                    = I4 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ Ma @ N2 ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N2 )
                                        = I4 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ X3 @ N2 ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_4235__C11_C,axiom,
    ( ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy )
   => ( vEBT_V5719532721284313246member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) ) ) ).

% "11"
thf(fact_4236__C13_C,axiom,
    ( ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy )
   => ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) ) ) ).

% "13"
thf(fact_4237_nested__mint,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat,Va2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( ( N2
          = ( suc @ ( suc @ Va2 ) ) )
       => ( ~ ( ord_less @ nat @ Ma @ Mi )
         => ( ( Ma != Mi )
           => ( ord_less @ nat @ ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ ( the2 @ nat @ ( vEBT_vebt_mint @ Summary ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Va2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( the2 @ nat @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList2 @ ( the2 @ nat @ ( vEBT_vebt_mint @ Summary ) ) ) ) ) ) @ ( suc @ ( divide_divide @ nat @ Va2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ).

% nested_mint
thf(fact_4238_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L2: num,R: A,Q2: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L2 @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R @ ( numeral_numeral @ A @ L2 ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L2 @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ R ) ) ) ) ) ).

% divmod_step_eq
thf(fact_4239_buildup__nothing__in__min__max,axiom,
    ! [N2: nat,X2: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N2 ) @ X2 ) ).

% buildup_nothing_in_min_max
thf(fact_4240_buildup__nothing__in__leaf,axiom,
    ! [N2: nat,X2: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N2 ) @ X2 ) ).

% buildup_nothing_in_leaf
thf(fact_4241_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T3: vEBT_VEBT,X: nat] :
          ( ( vEBT_V5719532721284313246member @ T3 @ X )
          | ( vEBT_VEBT_membermima @ T3 @ X ) ) ) ) ).

% both_member_options_def
thf(fact_4242_member__valid__both__member__options,axiom,
    ! [Tree: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ Tree @ N2 )
     => ( ( vEBT_vebt_member @ Tree @ X2 )
       => ( ( vEBT_V5719532721284313246member @ Tree @ X2 )
          | ( vEBT_VEBT_membermima @ Tree @ X2 ) ) ) ) ).

% member_valid_both_member_options
thf(fact_4243_summaxma,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg )
     => ( ( Mi != Ma )
       => ( ( the2 @ nat @ ( vEBT_vebt_maxt @ Summary ) )
          = ( vEBT_VEBT_high @ Ma @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% summaxma
thf(fact_4244_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_4245_xor__num_Ocases,axiom,
    ! [X2: product_prod @ num @ num] :
      ( ( X2
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N3: num] :
            ( X2
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) )
       => ( ! [N3: num] :
              ( X2
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) )
         => ( ! [M4: num] :
                ( X2
               != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) )
           => ( ! [M4: num,N3: num] :
                  ( X2
                 != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) )
             => ( ! [M4: num,N3: num] :
                    ( X2
                   != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) )
               => ( ! [M4: num] :
                      ( X2
                     != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) )
                 => ( ! [M4: num,N3: num] :
                        ( X2
                       != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) )
                   => ~ ! [M4: num,N3: num] :
                          ( X2
                         != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_4246_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi: nat,Ma: nat,Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) @ X2 )
      = ( ( X2 = Mi )
        | ( X2 = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_4247__C1_C,axiom,
    ( ( ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
         != ( none @ nat ) )
        & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
     => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
        = ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
    & ( ~ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
           != ( none @ nat ) )
          & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
     => ( ( ( ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
            = ( none @ nat ) )
         => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
            = ( none @ nat ) ) )
        & ( ( ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
           != ( none @ nat ) )
         => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
            = ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ treeList @ ( the2 @ nat @ ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% "1"
thf(fact_4248_succ__list__to__short,axiom,
    ! [Deg: nat,Mi: nat,X2: nat,TreeList2: list @ vEBT_VEBT,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
     => ( ( ord_less_eq @ nat @ Mi @ X2 )
       => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 )
            = ( none @ nat ) ) ) ) ) ).

% succ_list_to_short
thf(fact_4249_vebt__member_Osimps_I4_J,axiom,
    ! [V: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT,X2: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ X2 ) ).

% vebt_member.simps(4)
thf(fact_4250_vebt__member_Osimps_I3_J,axiom,
    ! [V: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,X2: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ X2 ) ).

% vebt_member.simps(3)
thf(fact_4251_vebt__succ_Osimps_I4_J,axiom,
    ! [V: product_prod @ nat @ nat,Vc: list @ vEBT_VEBT,Vd: vEBT_VEBT,Ve: nat] :
      ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( zero_zero @ nat ) @ Vc @ Vd ) @ Ve )
      = ( none @ nat ) ) ).

% vebt_succ.simps(4)
thf(fact_4252_vebt__succ_Osimps_I5_J,axiom,
    ! [V: product_prod @ nat @ nat,Vg: list @ vEBT_VEBT,Vh: vEBT_VEBT,Vi: nat] :
      ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg @ Vh ) @ Vi )
      = ( none @ nat ) ) ).

% vebt_succ.simps(5)
thf(fact_4253_minminNull,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_mint @ T2 )
        = ( none @ nat ) )
     => ( vEBT_VEBT_minNull @ T2 ) ) ).

% minminNull
thf(fact_4254_minNullmin,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_VEBT_minNull @ T2 )
     => ( ( vEBT_vebt_mint @ T2 )
        = ( none @ nat ) ) ) ).

% minNullmin
thf(fact_4255_succ__greatereq__min,axiom,
    ! [Deg: nat,Mi: nat,X2: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
     => ( ( ord_less_eq @ nat @ Mi @ X2 )
       => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 )
          = ( if @ ( option @ nat ) @ ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
            @ ( if @ ( option @ nat )
              @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                 != ( none @ nat ) )
                & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
              @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
              @ ( if @ ( option @ nat )
                @ ( ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  = ( none @ nat ) )
                @ ( none @ nat )
                @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList2 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
            @ ( none @ nat ) ) ) ) ) ).

% succ_greatereq_min
thf(fact_4256_succ__less__length__list,axiom,
    ! [Deg: nat,Mi: nat,X2: nat,TreeList2: list @ vEBT_VEBT,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
     => ( ( ord_less_eq @ nat @ Mi @ X2 )
       => ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 )
            = ( if @ ( option @ nat )
              @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                 != ( none @ nat ) )
                & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
              @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
              @ ( if @ ( option @ nat )
                @ ( ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  = ( none @ nat ) )
                @ ( none @ nat )
                @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList2 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% succ_less_length_list
thf(fact_4257_not__min__Null__member,axiom,
    ! [T2: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ T2 )
     => ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ T2 @ X_1 ) ) ).

% not_min_Null_member
thf(fact_4258_min__Null__member,axiom,
    ! [T2: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_minNull @ T2 )
     => ~ ( vEBT_vebt_member @ T2 @ X2 ) ) ).

% min_Null_member
thf(fact_4259_set__vebt_H__def,axiom,
    ( vEBT_VEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_vebt_member @ T3 ) ) ) ) ).

% set_vebt'_def
thf(fact_4260_finite__interval__int1,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less_eq @ int @ A2 @ I3 )
            & ( ord_less_eq @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int1
thf(fact_4261_finite__interval__int4,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less @ int @ A2 @ I3 )
            & ( ord_less @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int4
thf(fact_4262_finite__interval__int3,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less @ int @ A2 @ I3 )
            & ( ord_less_eq @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_4263_finite__interval__int2,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less_eq @ int @ A2 @ I3 )
            & ( ord_less @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_4264_finite__nth__roots,axiom,
    ! [N2: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z5: complex] :
              ( ( power_power @ complex @ Z5 @ N2 )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_4265_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X: A] :
                ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X )
                & ( ord_less_eq @ A @ X @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_4266_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [K3: nat] :
            ( ( P @ K3 )
            & ( ord_less @ nat @ K3 @ I ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_4267_finite__divisors__int,axiom,
    ! [I: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( finite_finite @ int
        @ ( collect @ int
          @ ^ [D2: int] : ( dvd_dvd @ int @ D2 @ I ) ) ) ) ).

% finite_divisors_int
thf(fact_4268_finite__less__ub,axiom,
    ! [F2: nat > nat,U: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( F2 @ N3 ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N: nat] : ( ord_less_eq @ nat @ ( F2 @ N ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_4269_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_code(2)
thf(fact_4270_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [C2: A] :
          ( ( ^ [X: A] : ( times_times @ A @ X @ C2 ) )
          = ( times_times @ A @ C2 ) ) ) ).

% mult_commute_abs
thf(fact_4271_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X: A] : X )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_4272_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_4273_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T3 ) ) ) ) ).

% set_vebt_def
thf(fact_4274_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ A2 ) )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ B2 ) ) )
          = ( ( dvd_dvd @ A @ A2 @ B2 )
            & ~ ( dvd_dvd @ A @ B2 @ A2 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_4275_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_leq_as_int
thf(fact_4276_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_less_as_int
thf(fact_4277_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ A2 ) )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ B2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_4278_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ B3 @ A4 ) ) ) ) ).

% max_def_raw
thf(fact_4279_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_4280_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N2 ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_4281_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_4282_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K3: A] :
                ( ( member @ A @ K3 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K3 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_4283_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D2: nat] : ( dvd_dvd @ nat @ D2 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_4284_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_4285_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_4286_nat__minus__as__int,axiom,
    ( ( minus_minus @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_minus_as_int
thf(fact_4287_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_4288_nat__mod__as__int,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_mod_as_int
thf(fact_4289_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N2: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z5: A] :
                  ( ( power_power @ A @ Z5 @ N2 )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_4290_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs: list @ A] :
            ( collect @ A
            @ ^ [Uu2: A] :
              ? [I3: nat] :
                ( ( Uu2
                  = ( nth @ A @ Xs @ I3 ) )
                & ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_4291_diff__nat__eq__if,axiom,
    ! [Z6: int,Z: int] :
      ( ( ( ord_less @ int @ Z6 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) )
          = ( nat2 @ Z ) ) )
      & ( ~ ( ord_less @ int @ Z6 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z @ Z6 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z @ Z6 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_4292_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_4293_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X: nat] :
          ( collect @ nat
          @ ^ [N: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% set_decode_def
thf(fact_4294_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N: nat,A4: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A4 ) @ N ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A4 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A4 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_4295_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N: nat] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_4296_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L: nat] : ( times_times @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ L ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_4297_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option @ ( product_prod @ nat @ nat ),V: nat,TreeList2: list @ vEBT_VEBT,S2: vEBT_VEBT,X2: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy @ ( suc @ V ) @ TreeList2 @ S2 ) @ X2 )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_4298_vebt__member_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va2: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList2 @ Summary ) @ X2 )
      = ( ( X2 != Mi )
       => ( ( X2 != Ma )
         => ( ~ ( ord_less @ nat @ X2 @ Mi )
            & ( ~ ( ord_less @ nat @ X2 @ Mi )
             => ( ~ ( ord_less @ nat @ Ma @ X2 )
                & ( ~ ( ord_less @ nat @ Ma @ X2 )
                 => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                     => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.simps(5)
thf(fact_4299_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi: nat,Ma: nat,V: nat,TreeList2: list @ vEBT_VEBT,Vc: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ V ) @ TreeList2 @ Vc ) @ X2 )
      = ( ( X2 = Mi )
        | ( X2 = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_4300_vebt__succ_Osimps_I6_J,axiom,
    ! [X2: nat,Mi: nat,Ma: nat,Va2: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ( ord_less @ nat @ X2 @ Mi )
       => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList2 @ Summary ) @ X2 )
          = ( some @ nat @ Mi ) ) )
      & ( ~ ( ord_less @ nat @ X2 @ Mi )
       => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList2 @ Summary ) @ X2 )
          = ( if @ ( option @ nat ) @ ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
            @ ( if @ ( option @ nat )
              @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                 != ( none @ nat ) )
                & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
              @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
              @ ( if @ ( option @ nat )
                @ ( ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  = ( none @ nat ) )
                @ ( none @ nat )
                @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList2 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
            @ ( none @ nat ) ) ) ) ) ).

% vebt_succ.simps(6)
thf(fact_4301_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K3 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_4302_insert__simp__norm,axiom,
    ! [X2: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ Mi @ X2 )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X2 != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ ( ord_max @ nat @ X2 @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_norm
thf(fact_4303_insert__simp__excp,axiom,
    ! [Mi: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,X2: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ X2 @ Mi )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X2 != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X2 )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X2 @ ( ord_max @ nat @ Mi @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_excp
thf(fact_4304_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N: nat] : ( ord_less_eq @ nat @ N @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_4305_finite__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% finite_Diff
thf(fact_4306_finite__Diff2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
        = ( finite_finite @ A @ A3 ) ) ) ).

% finite_Diff2
thf(fact_4307_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N: nat] : ( ord_less @ nat @ N @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_4308_list__update__beyond,axiom,
    ! [A: $tType,Xs2: list @ A,I: nat,X2: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I )
     => ( ( list_update @ A @ Xs2 @ I @ X2 )
        = Xs2 ) ) ).

% list_update_beyond
thf(fact_4309_nth__list__update__eq,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A,X2: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I @ X2 ) @ I )
        = X2 ) ) ).

% nth_list_update_eq
thf(fact_4310_set__swap,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A,J: nat] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs2 @ I @ ( nth @ A @ Xs2 @ J ) ) @ J @ ( nth @ A @ Xs2 @ I ) ) )
          = ( set2 @ A @ Xs2 ) ) ) ) ).

% set_swap
thf(fact_4311_set__update__memI,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,X2: A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( member @ A @ X2 @ ( set2 @ A @ ( list_update @ A @ Xs2 @ N2 @ X2 ) ) ) ) ).

% set_update_memI
thf(fact_4312_nth__list__update,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A,J: nat,X2: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ( I = J )
         => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I @ X2 ) @ J )
            = X2 ) )
        & ( ( I != J )
         => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I @ X2 ) @ J )
            = ( nth @ A @ Xs2 @ J ) ) ) ) ) ).

% nth_list_update
thf(fact_4313_list__update__same__conv,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A,X2: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ( list_update @ A @ Xs2 @ I @ X2 )
          = Xs2 )
        = ( ( nth @ A @ Xs2 @ I )
          = X2 ) ) ) ).

% list_update_same_conv
thf(fact_4314_Diff__infinite__finite,axiom,
    ! [A: $tType,T5: set @ A,S: set @ A] :
      ( ( finite_finite @ A @ T5 )
     => ( ~ ( finite_finite @ A @ S )
       => ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ S @ T5 ) ) ) ) ).

% Diff_infinite_finite
thf(fact_4315_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ( ord_less_eq @ A @ A2 @ X3 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A3 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa2 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_4316_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ( ord_less_eq @ A @ X3 @ A2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A3 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X3 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_4317_vebt__insert_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va2: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList2 @ Summary ) @ X2 )
      = ( if @ vEBT_VEBT
        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
          & ~ ( ( X2 = Mi )
              | ( X2 = Ma ) ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ X2 @ Mi ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ Ma ) ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList2 @ Summary ) ) ) ).

% vebt_insert.simps(5)
thf(fact_4318_monoseq__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_4319_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X2 @ Xa )
     => ( ! [Mi2: nat,Ma2: nat] :
            ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
           => ~ ( ( Xa = Mi2 )
                | ( Xa = Ma2 ) ) )
       => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Vc2: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
             => ~ ( ( Xa = Mi2 )
                  | ( Xa = Ma2 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
         => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [Vd2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_4320_vebt__member_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_vebt_member @ X2 @ Xa )
     => ( ! [A6: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A6 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B6 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Summary2: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
             => ~ ( ( Xa != Mi2 )
                 => ( ( Xa != Ma2 )
                   => ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                      & ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                       => ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                          & ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                           => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                               => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                              & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(2)
thf(fact_4321_Leaf__0__not,axiom,
    ! [A2: $o,B2: $o] :
      ~ ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( zero_zero @ nat ) ) ).

% Leaf_0_not
thf(fact_4322_deg1Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
      = ( ? [A4: $o,B3: $o] :
            ( T2
            = ( vEBT_Leaf @ A4 @ B3 ) ) ) ) ).

% deg1Leaf
thf(fact_4323_deg__1__Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
     => ? [A6: $o,B6: $o] :
          ( T2
          = ( vEBT_Leaf @ A6 @ B6 ) ) ) ).

% deg_1_Leaf
thf(fact_4324_deg__1__Leafy,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( N2
          = ( one_one @ nat ) )
       => ? [A6: $o,B6: $o] :
            ( T2
            = ( vEBT_Leaf @ A6 @ B6 ) ) ) ) ).

% deg_1_Leafy
thf(fact_4325_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y222: $o] :
      ( ( ( vEBT_Leaf @ X21 @ X222 )
        = ( vEBT_Leaf @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% VEBT.inject(2)
thf(fact_4326_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu3: $o,Uv2: $o,D5: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv2 ) @ D5 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,Deg3: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Deg3 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_4327_VEBT_Oexhaust,axiom,
    ! [Y2: vEBT_VEBT] :
      ( ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y2
         != ( vEBT_Node @ X112 @ X122 @ X132 @ X142 ) )
     => ~ ! [X212: $o,X223: $o] :
            ( Y2
           != ( vEBT_Leaf @ X212 @ X223 ) ) ) ).

% VEBT.exhaust
thf(fact_4328_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,X21: $o,X222: $o] :
      ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
     != ( vEBT_Leaf @ X21 @ X222 ) ) ).

% VEBT.distinct(1)
thf(fact_4329_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_4330_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,Uw: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Leaf @ Uu @ Uv ) @ Uw ) ).

% VEBT_internal.membermima.simps(1)
thf(fact_4331_vebt__insert_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A6: $o,B6: $o,X3: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ X3 ) )
     => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) @ X3 ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) @ X3 ) )
         => ( ! [V4: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                ( X2
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary2 ) @ X3 ) )
           => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                  ( X2
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) @ X3 ) ) ) ) ) ) ).

% vebt_insert.cases
thf(fact_4332_vebt__insert_Osimps_I1_J,axiom,
    ! [X2: nat,A2: $o,B2: $o] :
      ( ( ( X2
          = ( zero_zero @ nat ) )
       => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
          = ( vEBT_Leaf @ $true @ B2 ) ) )
      & ( ( X2
         != ( zero_zero @ nat ) )
       => ( ( ( X2
              = ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
              = ( vEBT_Leaf @ A2 @ $true ) ) )
          & ( ( X2
             != ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
              = ( vEBT_Leaf @ A2 @ B2 ) ) ) ) ) ) ).

% vebt_insert.simps(1)
thf(fact_4333_vebt__buildup_Osimps_I1_J,axiom,
    ( ( vEBT_vebt_buildup @ ( zero_zero @ nat ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(1)
thf(fact_4334_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu3: $o,Uv2: $o,Uw2: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv2 ) @ Uw2 ) )
     => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Uz2 ) )
       => ( ! [Mi2: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X3: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ X3 ) )
         => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X3: nat] :
                ( X2
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ X3 ) )
           => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X3: nat] :
                  ( X2
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) @ X3 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_4335_vebt__succ_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu3: $o,B6: $o] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ B6 ) @ ( zero_zero @ nat ) ) )
     => ( ! [Uv2: $o,Uw2: $o,N3: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uv2 @ Uw2 ) @ ( suc @ N3 ) ) )
       => ( ! [Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,Va3: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux2 @ Uy2 @ Uz2 ) @ Va3 ) )
         => ( ! [V4: product_prod @ nat @ nat,Vc2: list @ vEBT_VEBT,Vd2: vEBT_VEBT,Ve2: nat] :
                ( X2
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Vc2 @ Vd2 ) @ Ve2 ) )
           => ( ! [V4: product_prod @ nat @ nat,Vg2: list @ vEBT_VEBT,Vh2: vEBT_VEBT,Vi2: nat] :
                  ( X2
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg2 @ Vh2 ) @ Vi2 ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                    ( X2
                   != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) @ X3 ) ) ) ) ) ) ) ).

% vebt_succ.cases
thf(fact_4336_vebt__member_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A6: $o,B6: $o,X3: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ X3 ) )
     => ( ! [Uu3: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,X3: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) @ X3 ) )
       => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,X3: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ X3 ) )
         => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X3: nat] :
                ( X2
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ X3 ) )
           => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                  ( X2
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) @ X3 ) ) ) ) ) ) ).

% vebt_member.cases
thf(fact_4337_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A6: $o,B6: $o,X3: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ X3 ) )
     => ( ! [Uu3: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ X3 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_4338_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_4339_vebt__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X2: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
      = ( ( ( X2
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X2
           != ( zero_zero @ nat ) )
         => ( ( ( X2
                = ( one_one @ nat ) )
             => B2 )
            & ( X2
              = ( one_one @ nat ) ) ) ) ) ) ).

% vebt_member.simps(1)
thf(fact_4340_vebt__buildup_Osimps_I2_J,axiom,
    ( ( vEBT_vebt_buildup @ ( suc @ ( zero_zero @ nat ) ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(2)
thf(fact_4341_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X2: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
      = ( ( ( X2
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X2
           != ( zero_zero @ nat ) )
         => ( ( ( X2
                = ( one_one @ nat ) )
             => B2 )
            & ( X2
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_4342_vebt__succ_Osimps_I2_J,axiom,
    ! [Uv: $o,Uw: $o,N2: nat] :
      ( ( vEBT_vebt_succ @ ( vEBT_Leaf @ Uv @ Uw ) @ ( suc @ N2 ) )
      = ( none @ nat ) ) ).

% vebt_succ.simps(2)
thf(fact_4343_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Uz ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_4344_vebt__succ_Osimps_I3_J,axiom,
    ! [Ux: nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,Va2: nat] :
      ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux @ Uy @ Uz ) @ Va2 )
      = ( none @ nat ) ) ).

% vebt_succ.simps(3)
thf(fact_4345_vebt__insert_Osimps_I4_J,axiom,
    ! [V: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V ) ) @ TreeList2 @ Summary ) @ X2 )
      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X2 @ X2 ) ) @ ( suc @ ( suc @ V ) ) @ TreeList2 @ Summary ) ) ).

% vebt_insert.simps(4)
thf(fact_4346_vebt__succ_Osimps_I1_J,axiom,
    ! [B2: $o,Uu: $o] :
      ( ( B2
       => ( ( vEBT_vebt_succ @ ( vEBT_Leaf @ Uu @ B2 ) @ ( zero_zero @ nat ) )
          = ( some @ nat @ ( one_one @ nat ) ) ) )
      & ( ~ B2
       => ( ( vEBT_vebt_succ @ ( vEBT_Leaf @ Uu @ B2 ) @ ( zero_zero @ nat ) )
          = ( none @ nat ) ) ) ) ).

% vebt_succ.simps(1)
thf(fact_4347_monoseq__realpow,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X2 ) ) ) ) ).

% monoseq_realpow
thf(fact_4348_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X2 @ Xa )
     => ( ! [Uu3: $o,Uv2: $o] :
            ( X2
           != ( vEBT_Leaf @ Uu3 @ Uv2 ) )
       => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X2
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( ( Xa = Mi2 )
                  | ( Xa = Ma2 ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                 => ( ( Xa = Mi2 )
                    | ( Xa = Ma2 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
             => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd2: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_4349_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_membermima @ X2 @ Xa )
        = Y2 )
     => ( ( ? [Uu3: $o,Uv2: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu3 @ Uv2 ) )
         => Y2 )
       => ( ( ? [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
           => Y2 )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( Y2
                  = ( ~ ( ( Xa = Mi2 )
                        | ( Xa = Ma2 ) ) ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                 => ( Y2
                    = ( ~ ( ( Xa = Mi2 )
                          | ( Xa = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) )
             => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd2: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) )
                   => ( Y2
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_4350_vebt__member_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_vebt_member @ X2 @ Xa )
     => ( ! [A6: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A6 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B6 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu3: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X2
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) )
         => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                ( X2
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
           => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X2
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary2: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
                   => ( ( Xa != Mi2 )
                     => ( ( Xa != Ma2 )
                       => ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                          & ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                           => ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                              & ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(3)
thf(fact_4351_vebt__member_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_vebt_member @ X2 @ Xa )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( Y2
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu3: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) )
           => Y2 )
         => ( ( ? [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
             => Y2 )
           => ( ( ? [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
               => Y2 )
             => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary2: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
                   => ( Y2
                      = ( ~ ( ( Xa != Mi2 )
                           => ( ( Xa != Ma2 )
                             => ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                                & ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                                 => ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                                    & ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(1)
thf(fact_4352_vebt__insert_Oelims,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X2 @ Xa )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => ( Y2
                    = ( vEBT_Leaf @ $true @ B6 ) ) )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => ( Y2
                        = ( vEBT_Leaf @ A6 @ $true ) ) )
                    & ( ( Xa
                       != ( one_one @ nat ) )
                     => ( Y2
                        = ( vEBT_Leaf @ A6 @ B6 ) ) ) ) ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) )
             => ( Y2
               != ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) )
               => ( Y2
                 != ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) ) )
           => ( ! [V4: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary2 ) )
                 => ( Y2
                   != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa @ Xa ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary2 ) ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
                   => ( Y2
                     != ( if @ vEBT_VEBT
                        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                          & ~ ( ( Xa = Mi2 )
                              | ( Xa = Ma2 ) ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Xa @ Mi2 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ Ma2 ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary2 ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) ) ) ) ) ) ) ) ) ).

% vebt_insert.elims
thf(fact_4353_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A1: vEBT_VEBT,A22: nat] :
          ( ( ? [A4: $o,B3: $o] :
                ( A1
                = ( vEBT_Leaf @ A4 @ B3 ) )
            & ( A22
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary3: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList @ Summary3 ) )
              & ! [X: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X @ N ) )
              & ( vEBT_invar_vebt @ Summary3 @ N )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
              & ( A22
                = ( plus_plus @ nat @ N @ N ) )
              & ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
              & ! [X: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary3: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList @ Summary3 ) )
              & ! [X: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X @ N ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
              & ( A22
                = ( plus_plus @ nat @ N @ ( suc @ N ) ) )
              & ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
              & ! [X: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A22 @ TreeList @ Summary3 ) )
              & ! [X: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X @ N ) )
              & ( vEBT_invar_vebt @ Summary3 @ N )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
              & ( A22
                = ( plus_plus @ nat @ N @ N ) )
              & ! [I3: nat] :
                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X8 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N )
                          = I3 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ Ma3 @ N ) ) )
                      & ! [X: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X @ N )
                              = I3 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ X @ N ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X )
                            & ( ord_less_eq @ nat @ X @ Ma3 ) ) ) ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A22 @ TreeList @ Summary3 ) )
              & ! [X: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X @ N ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
              & ( A22
                = ( plus_plus @ nat @ N @ ( suc @ N ) ) )
              & ! [I3: nat] :
                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X8 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N )
                          = I3 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ Ma3 @ N ) ) )
                      & ! [X: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X @ N )
                              = I3 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ ( vEBT_VEBT_low @ X @ N ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X )
                            & ( ord_less_eq @ nat @ X @ Ma3 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_4354_invar__vebt_Ocases,axiom,
    ! [A12: vEBT_VEBT,A23: nat] :
      ( ( vEBT_invar_vebt @ A12 @ A23 )
     => ( ( ? [A6: $o,B6: $o] :
              ( A12
              = ( vEBT_Leaf @ A6 @ B6 ) )
         => ( A23
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( ( A23 = Deg2 )
               => ( ! [X4: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_invar_vebt @ X4 @ N3 ) )
                 => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                     => ( ( M4 = N3 )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N3 @ M4 ) )
                         => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_12 )
                           => ~ ! [X4: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
                ( ( A12
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( A23 = Deg2 )
                 => ( ! [X4: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_invar_vebt @ X4 @ N3 ) )
                   => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                       => ( ( M4
                            = ( suc @ N3 ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N3 @ M4 ) )
                           => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_12 )
                             => ~ ! [X4: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                  ( ( A12
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
                 => ( ( A23 = Deg2 )
                   => ( ! [X4: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_invar_vebt @ X4 @ N3 ) )
                     => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                         => ( ( M4 = N3 )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N3 @ M4 ) )
                             => ( ! [I2: nat] :
                                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ X8 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
                               => ( ( ( Mi2 = Ma2 )
                                   => ! [X4: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                                   => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi2 != Ma2 )
                                         => ! [I2: nat] :
                                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                    = I2 )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                & ! [X4: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X4 @ N3 )
                                                        = I2 )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ ( vEBT_VEBT_low @ X4 @ N3 ) ) )
                                                   => ( ( ord_less @ nat @ Mi2 @ X4 )
                                                      & ( ord_less_eq @ nat @ X4 @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                    ( ( A12
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
                   => ( ( A23 = Deg2 )
                     => ( ! [X4: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ( vEBT_invar_vebt @ X4 @ N3 ) )
                       => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                           => ( ( M4
                                = ( suc @ N3 ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N3 @ M4 ) )
                               => ( ! [I2: nat] :
                                      ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                     => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ X8 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
                                 => ( ( ( Mi2 = Ma2 )
                                     => ! [X4: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                         => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                                     => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi2 != Ma2 )
                                           => ! [I2: nat] :
                                                ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                      = I2 )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                  & ! [X4: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X4 @ N3 )
                                                          = I2 )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ ( vEBT_VEBT_low @ X4 @ N3 ) ) )
                                                     => ( ( ord_less @ nat @ Mi2 @ X4 )
                                                        & ( ord_less_eq @ nat @ X4 @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_4355_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N2 )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_4356_vebt__insert_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S2: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts2 @ S2 ) @ X2 )
      = ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts2 @ S2 ) ) ).

% vebt_insert.simps(2)
thf(fact_4357_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N2 ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_4358_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList2: list @ vEBT_VEBT,Vd: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V ) @ TreeList2 @ Vd ) @ X2 )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_4359_vebt__succ_Oelims,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: option @ nat] :
      ( ( ( vEBT_vebt_succ @ X2 @ Xa )
        = Y2 )
     => ( ! [Uu3: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ Uu3 @ B6 ) )
           => ( ( Xa
                = ( zero_zero @ nat ) )
             => ~ ( ( B6
                   => ( Y2
                      = ( some @ nat @ ( one_one @ nat ) ) ) )
                  & ( ~ B6
                   => ( Y2
                      = ( none @ nat ) ) ) ) ) )
       => ( ( ? [Uv2: $o,Uw2: $o] :
                ( X2
                = ( vEBT_Leaf @ Uv2 @ Uw2 ) )
           => ( ? [N3: nat] :
                  ( Xa
                  = ( suc @ N3 ) )
             => ( Y2
               != ( none @ nat ) ) ) )
         => ( ( ? [Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux2 @ Uy2 @ Uz2 ) )
             => ( Y2
               != ( none @ nat ) ) )
           => ( ( ? [V4: product_prod @ nat @ nat,Vc2: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Vc2 @ Vd2 ) )
               => ( Y2
                 != ( none @ nat ) ) )
             => ( ( ? [V4: product_prod @ nat @ nat,Vg2: list @ vEBT_VEBT,Vh2: vEBT_VEBT] :
                      ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg2 @ Vh2 ) )
                 => ( Y2
                   != ( none @ nat ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
                     => ~ ( ( ( ord_less @ nat @ Xa @ Mi2 )
                           => ( Y2
                              = ( some @ nat @ Mi2 ) ) )
                          & ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                           => ( Y2
                              = ( if @ ( option @ nat ) @ ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                @ ( if @ ( option @ nat )
                                  @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                     != ( none @ nat ) )
                                    & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                                  @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  @ ( if @ ( option @ nat )
                                    @ ( ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                                      = ( none @ nat ) )
                                    @ ( none @ nat )
                                    @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList3 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
                                @ ( none @ nat ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_succ.elims
thf(fact_4360_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X2 @ Xa )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( Y2
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu3: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
           => Y2 )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( Y2
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_4361_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X2 @ Xa )
     => ( ! [A6: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A6 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B6 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [S3: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_4362_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X2 @ Xa )
     => ( ! [A6: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A6 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B6 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu3: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X2
             != ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_4363_vebt__insert_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S2: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S2 ) @ X2 )
      = ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S2 ) ) ).

% vebt_insert.simps(3)
thf(fact_4364_vebt__maxt_Oelims,axiom,
    ! [X2: vEBT_VEBT,Y2: option @ nat] :
      ( ( ( vEBT_vebt_maxt @ X2 )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( B6
                 => ( Y2
                    = ( some @ nat @ ( one_one @ nat ) ) ) )
                & ( ~ B6
                 => ( ( A6
                     => ( Y2
                        = ( some @ nat @ ( zero_zero @ nat ) ) ) )
                    & ( ~ A6
                     => ( Y2
                        = ( none @ nat ) ) ) ) ) ) )
       => ( ( ? [Uu3: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) )
           => ( Y2
             != ( none @ nat ) ) )
         => ~ ! [Mi2: nat,Ma2: nat] :
                ( ? [Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) )
               => ( Y2
                 != ( some @ nat @ Ma2 ) ) ) ) ) ) ).

% vebt_maxt.elims
thf(fact_4365_vebt__mint_Oelims,axiom,
    ! [X2: vEBT_VEBT,Y2: option @ nat] :
      ( ( ( vEBT_vebt_mint @ X2 )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( A6
                 => ( Y2
                    = ( some @ nat @ ( zero_zero @ nat ) ) ) )
                & ( ~ A6
                 => ( ( B6
                     => ( Y2
                        = ( some @ nat @ ( one_one @ nat ) ) ) )
                    & ( ~ B6
                     => ( Y2
                        = ( none @ nat ) ) ) ) ) ) )
       => ( ( ? [Uu3: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) )
           => ( Y2
             != ( none @ nat ) ) )
         => ~ ! [Mi2: nat] :
                ( ? [Ma2: nat,Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) )
               => ( Y2
                 != ( some @ nat @ Mi2 ) ) ) ) ) ) ).

% vebt_mint.elims
thf(fact_4366_vebt__mint_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o] :
      ( ( A2
       => ( ( vEBT_vebt_mint @ ( vEBT_Leaf @ A2 @ B2 ) )
          = ( some @ nat @ ( zero_zero @ nat ) ) ) )
      & ( ~ A2
       => ( ( B2
           => ( ( vEBT_vebt_mint @ ( vEBT_Leaf @ A2 @ B2 ) )
              = ( some @ nat @ ( one_one @ nat ) ) ) )
          & ( ~ B2
           => ( ( vEBT_vebt_mint @ ( vEBT_Leaf @ A2 @ B2 ) )
              = ( none @ nat ) ) ) ) ) ) ).

% vebt_mint.simps(1)
thf(fact_4367_vebt__maxt_Osimps_I1_J,axiom,
    ! [B2: $o,A2: $o] :
      ( ( B2
       => ( ( vEBT_vebt_maxt @ ( vEBT_Leaf @ A2 @ B2 ) )
          = ( some @ nat @ ( one_one @ nat ) ) ) )
      & ( ~ B2
       => ( ( A2
           => ( ( vEBT_vebt_maxt @ ( vEBT_Leaf @ A2 @ B2 ) )
              = ( some @ nat @ ( zero_zero @ nat ) ) ) )
          & ( ~ A2
           => ( ( vEBT_vebt_maxt @ ( vEBT_Leaf @ A2 @ B2 ) )
              = ( none @ nat ) ) ) ) ) ) ).

% vebt_maxt.simps(1)
thf(fact_4368_vebt__succ_Opelims,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: option @ nat] :
      ( ( ( vEBT_vebt_succ @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu3: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu3 @ B6 ) )
             => ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( ( ( B6
                     => ( Y2
                        = ( some @ nat @ ( one_one @ nat ) ) ) )
                    & ( ~ B6
                     => ( Y2
                        = ( none @ nat ) ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ B6 ) @ ( zero_zero @ nat ) ) ) ) ) )
         => ( ! [Uv2: $o,Uw2: $o] :
                ( ( X2
                  = ( vEBT_Leaf @ Uv2 @ Uw2 ) )
               => ! [N3: nat] :
                    ( ( Xa
                      = ( suc @ N3 ) )
                   => ( ( Y2
                        = ( none @ nat ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uv2 @ Uw2 ) @ ( suc @ N3 ) ) ) ) ) )
           => ( ! [Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux2 @ Uy2 @ Uz2 ) )
                 => ( ( Y2
                      = ( none @ nat ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux2 @ Uy2 @ Uz2 ) @ Xa ) ) ) )
             => ( ! [V4: product_prod @ nat @ nat,Vc2: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Vc2 @ Vd2 ) )
                   => ( ( Y2
                        = ( none @ nat ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Vc2 @ Vd2 ) @ Xa ) ) ) )
               => ( ! [V4: product_prod @ nat @ nat,Vg2: list @ vEBT_VEBT,Vh2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg2 @ Vh2 ) )
                     => ( ( Y2
                          = ( none @ nat ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg2 @ Vh2 ) @ Xa ) ) ) )
                 => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                        ( ( X2
                          = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
                       => ( ( ( ( ord_less @ nat @ Xa @ Mi2 )
                             => ( Y2
                                = ( some @ nat @ Mi2 ) ) )
                            & ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                             => ( Y2
                                = ( if @ ( option @ nat ) @ ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                  @ ( if @ ( option @ nat )
                                    @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                       != ( none @ nat ) )
                                      & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                                    @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                    @ ( if @ ( option @ nat )
                                      @ ( ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                                        = ( none @ nat ) )
                                      @ ( none @ nat )
                                      @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList3 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
                                  @ ( none @ nat ) ) ) ) )
                         => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) @ Xa ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_succ.pelims
thf(fact_4369_maxt__corr__help__empty,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ( vEBT_vebt_maxt @ T2 )
          = ( none @ nat ) )
       => ( ( vEBT_VEBT_set_vebt @ T2 )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% maxt_corr_help_empty
thf(fact_4370_mint__corr__help__empty,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ( vEBT_vebt_mint @ T2 )
          = ( none @ nat ) )
       => ( ( vEBT_VEBT_set_vebt @ T2 )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mint_corr_help_empty
thf(fact_4371_vebt__insert_Opelims,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => ( Y2
                      = ( vEBT_Leaf @ $true @ B6 ) ) )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => ( Y2
                          = ( vEBT_Leaf @ A6 @ $true ) ) )
                      & ( ( Xa
                         != ( one_one @ nat ) )
                       => ( Y2
                          = ( vEBT_Leaf @ A6 @ B6 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) )
               => ( ( Y2
                    = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) @ Xa ) ) ) )
           => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) )
                 => ( ( Y2
                      = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) @ Xa ) ) ) )
             => ( ! [V4: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary2 ) )
                   => ( ( Y2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa @ Xa ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary2 ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary2 ) @ Xa ) ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
                     => ( ( Y2
                          = ( if @ vEBT_VEBT
                            @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                              & ~ ( ( Xa = Mi2 )
                                  | ( Xa = Ma2 ) ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Xa @ Mi2 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ Ma2 ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi2 ) @ Mi2 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary2 ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% vebt_insert.pelims
thf(fact_4372_buildup__gives__empty,axiom,
    ! [N2: nat] :
      ( ( vEBT_VEBT_set_vebt @ ( vEBT_vebt_buildup @ N2 ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% buildup_gives_empty
thf(fact_4373_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_4374_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_4375_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_4376_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_4377_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_4378_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) ).

% bot.not_eq_extremum
thf(fact_4379_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_4380_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_4381_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) ).

% bot.extremum
thf(fact_4382_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( minus_minus @ A @ X2 @ Y2 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% diff_shunt_var
thf(fact_4383_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A3 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X3 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_4384_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A3 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa2 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_4385_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X6: set @ A] :
          ( ( X6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X6 )
               => ? [Xa2: A] :
                    ( ( member @ A @ Xa2 @ X6 )
                    & ( ord_less @ A @ X3 @ Xa2 ) ) )
           => ~ ( finite_finite @ A @ X6 ) ) ) ) ).

% infinite_growing
thf(fact_4386_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S: set @ A] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S )
                & ~ ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S )
                      & ( ord_less @ A @ Xa2 @ X3 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_4387_vebt__member_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_vebt_member @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A6 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B6 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu3: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa ) ) )
             => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) @ Xa ) )
                       => ( ( Xa != Mi2 )
                         => ( ( Xa != Ma2 )
                           => ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                              & ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                               => ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                                  & ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                       => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(3)
thf(fact_4388_vebt__member_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_vebt_member @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( Y2
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa ) ) ) )
         => ( ! [Uu3: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ( ~ Y2
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa ) ) ) )
             => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ( ~ Y2
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa ) ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
                     => ( ( Y2
                          = ( ( Xa != Mi2 )
                           => ( ( Xa != Ma2 )
                             => ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                                & ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                                 => ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                                    & ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(1)
thf(fact_4389_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( Y2
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa ) ) ) )
         => ( ! [Uu3: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
                 => ( ( Y2
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_4390_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_4391_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_4392_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_4393_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_4394_vebt__member_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_vebt_member @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary2 ) @ Xa ) )
                 => ~ ( ( Xa != Mi2 )
                     => ( ( Xa != Ma2 )
                       => ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                          & ( ~ ( ord_less @ nat @ Xa @ Mi2 )
                           => ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                              & ( ~ ( ord_less @ nat @ Ma2 @ Xa )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(2)
thf(fact_4395_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A6 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B6 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu3: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_4396_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu3: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu3 @ Uv2 ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv2 ) @ Xa ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) )
           => ( ! [Mi2: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
                   => ( ( Xa = Mi2 )
                      | ( Xa = Ma2 ) ) ) )
             => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ Xa ) )
                     => ( ( Xa = Mi2 )
                        | ( Xa = Ma2 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
               => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) @ Xa ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_4397_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_membermima @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu3: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu3 @ Uv2 ) )
             => ( ~ Y2
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv2 ) @ Xa ) ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) ) )
           => ( ! [Mi2: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( Y2
                      = ( ( Xa = Mi2 )
                        | ( Xa = Ma2 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) ) ) )
             => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                   => ( ( Y2
                        = ( ( Xa = Mi2 )
                          | ( Xa = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ Xa ) ) ) )
               => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) )
                     => ( ( Y2
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_4398_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Mi2: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
               => ~ ( ( Xa = Mi2 )
                    | ( Xa = Ma2 ) ) ) )
         => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ Xa ) )
                 => ~ ( ( Xa = Mi2 )
                      | ( Xa = Ma2 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
           => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd2 ) @ Xa ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_4399_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A3 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_eq_empty_iff
thf(fact_4400_Diff__idemp,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ B4 )
      = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_idemp
thf(fact_4401_Diff__iff,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( member @ A @ C2 @ A3 )
        & ~ ( member @ A @ C2 @ B4 ) ) ) ).

% Diff_iff
thf(fact_4402_DiffI,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ A3 )
     => ( ~ ( member @ A @ C2 @ B4 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% DiffI
thf(fact_4403_Diff__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = A3 ) ).

% Diff_empty
thf(fact_4404_empty__Diff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% empty_Diff
thf(fact_4405_Diff__cancel,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_cancel
thf(fact_4406_DiffD2,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ( member @ A @ C2 @ B4 ) ) ).

% DiffD2
thf(fact_4407_DiffD1,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
     => ( member @ A @ C2 @ A3 ) ) ).

% DiffD1
thf(fact_4408_DiffE,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ( ( member @ A @ C2 @ A3 )
         => ( member @ A @ C2 @ B4 ) ) ) ).

% DiffE
thf(fact_4409_set__diff__eq,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( collect @ A
            @ ^ [X: A] :
                ( ( member @ A @ X @ A7 )
                & ~ ( member @ A @ X @ B8 ) ) ) ) ) ).

% set_diff_eq
thf(fact_4410_minus__set__def,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( collect @ A
            @ ( minus_minus @ ( A > $o )
              @ ^ [X: A] : ( member @ A @ X @ A7 )
              @ ^ [X: A] : ( member @ A @ X @ B8 ) ) ) ) ) ).

% minus_set_def
thf(fact_4411_Diff__mono,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,D6: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ D6 @ B4 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ C6 @ D6 ) ) ) ) ).

% Diff_mono
thf(fact_4412_Diff__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ A3 ) ).

% Diff_subset
thf(fact_4413_double__diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C6 )
       => ( ( minus_minus @ ( set @ A ) @ B4 @ ( minus_minus @ ( set @ A ) @ C6 @ A3 ) )
          = A3 ) ) ) ).

% double_diff
thf(fact_4414_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
     => ? [B6: A] : ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) ).

% psubset_imp_ex_mem
thf(fact_4415_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N2: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_4416_ln__series,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X2 )
          = ( suminf @ real
            @ ^ [N: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X2 @ ( one_one @ real ) ) @ ( suc @ N ) ) ) ) ) ) ) ).

% ln_series
thf(fact_4417_arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( arctan @ X2 )
        = ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_4418_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( ( ord_less @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N2 ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_4419_Ints__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ B )
        & ( ring_1 @ B ) )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( member @ B @ ( F2 @ X3 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_prod
thf(fact_4420_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > nat,A3: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X: B] : ( semiring_1_of_nat @ A @ ( F2 @ X ) )
            @ A3 ) ) ) ).

% of_nat_prod
thf(fact_4421_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [F2: B > int,A3: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7121269368397514597t_prod @ B @ int @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X: B] : ( ring_1_of_int @ A @ ( F2 @ X ) )
            @ A3 ) ) ) ).

% of_int_prod
thf(fact_4422_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_4423_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: nat > A] :
          ( ( suminf @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) ) )
          = ( F2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_4424_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N2 ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_4425_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N2 ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_4426_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_4427_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( ( ord_less_eq @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N2 ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_4428_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7121269368397514597t_prod @ B @ A
              @ ^ [I3: B] : ( modulo_modulo @ A @ ( F2 @ I3 ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ A2 ) ) ) ).

% mod_prod_eq
thf(fact_4429_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F2: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A4: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ A4 ) )
            @ A3 ) ) ) ).

% norm_prod_le
thf(fact_4430_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
thf(fact_4431_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_4432_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_4433_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_4434_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_4435_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_4436_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M3: num,N: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% divmod_int_def
thf(fact_4437_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) )
            = ( times_times @ A @ ( G @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_4438_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X: nat] : X
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) ) ) ) ).

% fact_prod
thf(fact_4439_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X: A] :
              ( suminf @ A
              @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ) ).

% sin_def
thf(fact_4440_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X: A] :
              ( suminf @ A
              @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ) ).

% cos_def
thf(fact_4441_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( times_times @ A @ ( F2 @ A4 ) )
            @ A2
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_4442_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) )
            = ( ? [X: B] :
                  ( ( member @ B @ X @ A3 )
                  & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% even_prod_iff
thf(fact_4443_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A,P2: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N2 @ P2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ P2 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_4444_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X: A] :
              ( suminf @ A
              @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) ) ) ) ) ) ).

% exp_def
thf(fact_4445_fact__eq__fact__times,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N2 )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X: nat] : X
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_4446_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ) ).

% divmod_def
thf(fact_4447_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M3: num,N: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_4448_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_4449_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I3 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_4450_fact__div__fact,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N2 ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X: nat] : X
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_4451_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.in_pairs
thf(fact_4452_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I3 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_4453_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N ) ) ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_4454_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_4455_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M3 @ N ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M3 ) ) @ ( unique1321980374590559556d_step @ A @ N @ ( unique8689654367752047608divmod @ A @ M3 @ ( bit0 @ N ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_4456_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X )
              @ ( suminf @ A
                @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X @ ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_4457_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K3: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_4458_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_4459_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 )
              = ( zero_zero @ A ) )
            = ( ? [X: B] :
                  ( ( member @ B @ X @ A3 )
                  & ( ( F2 @ X )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% prod_zero_iff
thf(fact_4460_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B4: set @ A,A3: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B6 ) ) )
             => ( ! [A6: A] :
                    ( ( member @ A @ A6 @ A3 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A6 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B4 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_4461_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ( ( suminf @ A
          @ ^ [N: nat] : ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% suminf_zero
thf(fact_4462_prod__pos__nat__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A3 ) )
        = ( ! [X: A] :
              ( ( member @ A @ X @ A3 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_4463_int__prod,axiom,
    ! [B: $tType,F2: B > nat,A3: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A3 ) )
      = ( groups7121269368397514597t_prod @ B @ int
        @ ^ [X: B] : ( semiring_1_of_nat @ int @ ( F2 @ X ) )
        @ A3 ) ) ).

% int_prod
thf(fact_4464_prod__int__plus__eq,axiom,
    ! [I: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I @ ( plus_plus @ nat @ I @ J ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X: int] : X
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I @ J ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_4465_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X: B] : ( times_times @ A @ ( G @ X ) @ ( H2 @ X ) )
            @ A3 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ A3 ) ) ) ) ).

% prod.distrib
thf(fact_4466_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X: B] : ( divide_divide @ A @ ( F2 @ X ) @ ( G @ X ) )
            @ A3 )
          = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_dividef
thf(fact_4467_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A3: set @ A,N2: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ N2 )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X: A] : ( power_power @ B @ ( F2 @ X ) @ N2 )
            @ A3 ) ) ) ).

% prod_power_distrib
thf(fact_4468_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_nonneg
thf(fact_4469_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) )
                & ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_mono
thf(fact_4470_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_pos
thf(fact_4471_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_ge_1
thf(fact_4472_prod__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ? [X4: B] :
                ( ( member @ B @ X4 @ A3 )
                & ( ( F2 @ X4 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% prod_zero
thf(fact_4473_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,X2: B > A,Y2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I3: B] :
                  ( ( member @ B @ I3 @ I5 )
                  & ( ( X2 @ I3 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                    & ( ( Y2 @ I3 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                    & ( ( plus_plus @ A @ ( X2 @ I3 ) @ ( Y2 @ I3 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_4474_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,X2: B > A,Y2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I3: B] :
                  ( ( member @ B @ I3 @ I5 )
                  & ( ( X2 @ I3 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                    & ( ( Y2 @ I3 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                    & ( ( times_times @ A @ ( X2 @ I3 ) @ ( Y2 @ I3 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_4475_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) )
                & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_4476_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R3: A > A > $o,S: set @ B,H2: B > A,G: B > A] :
          ( ( R3 @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( ( R3 @ X1 @ X23 )
                  & ( R3 @ Y1 @ Y23 ) )
               => ( R3 @ ( times_times @ A @ X1 @ Y1 ) @ ( times_times @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ( R3 @ ( H2 @ X3 ) @ ( G @ X3 ) ) )
               => ( R3 @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ S ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S ) ) ) ) ) ) ) ).

% prod.related
thf(fact_4477_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S4: set @ B,T6: set @ C,S: set @ B,I: C > B,J: B > C,T5: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T6 )
           => ( ! [A6: B] :
                  ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S @ S4 ) )
                 => ( ( I @ ( J @ A6 ) )
                    = A6 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S @ S4 ) )
                   => ( member @ C @ ( J @ A6 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                     => ( ( J @ ( I @ B6 ) )
                        = B6 ) )
                 => ( ! [B6: C] :
                        ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                       => ( member @ B @ ( I @ B6 ) @ ( minus_minus @ ( set @ B ) @ S @ S4 ) ) )
                   => ( ! [A6: B] :
                          ( ( member @ B @ A6 @ S4 )
                         => ( ( G @ A6 )
                            = ( one_one @ A ) ) )
                     => ( ! [B6: C] :
                            ( ( member @ C @ B6 @ T6 )
                           => ( ( H2 @ B6 )
                              = ( one_one @ A ) ) )
                       => ( ! [A6: B] :
                              ( ( member @ B @ A6 @ S )
                             => ( ( H2 @ ( J @ A6 ) )
                                = ( G @ A6 ) ) )
                         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S )
                            = ( groups7121269368397514597t_prod @ C @ A @ H2 @ T5 ) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
thf(fact_4478_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X: B] :
                      ( ( G @ X )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_4479_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,I: A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( member @ A @ I @ I5 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I ) )
             => ( ! [I4: A] :
                    ( ( member @ A @ I4 @ I5 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I4 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_4480_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I4: A] :
                  ( ( member @ A @ I4 @ I5 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I4 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_4481_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B4: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_4482_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T5 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_4483_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( H2 @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T5 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_4484_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T5 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_4485_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T5 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_4486_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A3: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C6 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B4 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B4 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_4487_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A3: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C6 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B4 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B4 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_4488_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ A3 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) )
                  & ( ord_less @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) ) )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_4489_minus__one__div__numeral,axiom,
    ! [N2: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% minus_one_div_numeral
thf(fact_4490_one__div__minus__numeral,axiom,
    ! [N2: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% one_div_minus_numeral
thf(fact_4491_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( unique5940410009612947441es_aux @ A @ ( unique8689654367752047608divmod @ A @ N2 @ M ) ) ) ) ).

% dvd_numeral_simp
thf(fact_4492_minus__numeral__div__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ).

% minus_numeral_div_numeral
thf(fact_4493_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: A,R: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q2 @ R ) )
          = ( R
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_4494_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( plus_plus @ int @ Q2
        @ ( zero_neq_one_of_bool @ int
          @ ( R
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_4495_numeral__div__minus__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ).

% numeral_div_minus_numeral
thf(fact_4496_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_4497_summable__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_4498_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_4499_product__nth,axiom,
    ! [A: $tType,B: $tType,N2: nat,Xs2: list @ A,Ys2: list @ B] :
      ( ( ord_less @ nat @ N2 @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs2 @ Ys2 ) @ N2 )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ ( divide_divide @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) @ ( nth @ B @ Ys2 @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ) ) ) ).

% product_nth
thf(fact_4500_summable__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A
        @ ^ [N: nat] : ( zero_zero @ A ) ) ) ).

% summable_zero
thf(fact_4501_summable__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F2: nat > A] :
          ( summable @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ).

% summable_single
thf(fact_4502_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_iff_shift
thf(fact_4503_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_cmult_iff
thf(fact_4504_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_divide_iff
thf(fact_4505_length__product,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys2: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs2 @ Ys2 ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ).

% length_product
thf(fact_4506_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A3: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A3 )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A3 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite_set
thf(fact_4507_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite
thf(fact_4508_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_4509_summable__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 ) ) ) ) ).

% summable_divide
thf(fact_4510_summable__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 ) ) ) ) ).

% summable_mult2
thf(fact_4511_summable__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) ) ) ) ).

% summable_mult
thf(fact_4512_summable__const__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: A] :
          ( ( summable @ A
            @ ^ [Uu2: nat] : C2 )
          = ( C2
            = ( zero_zero @ A ) ) ) ) ).

% summable_const_iff
thf(fact_4513_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% summable_ignore_initial_segment
thf(fact_4514_summable__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N: nat] : ( plus_plus @ A @ ( F2 @ N ) @ ( G @ N ) ) ) ) ) ) ).

% summable_add
thf(fact_4515_summable__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_Suc_iff
thf(fact_4516_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > real,N5: nat,F2: nat > A] :
          ( ( summable @ real @ G )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test'
thf(fact_4517_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test
thf(fact_4518_summable__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( G @ N ) ) ) ) ) ) ).

% summable_diff
thf(fact_4519_unique__quotient,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R4: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R4 ) )
       => ( Q2 = Q5 ) ) ) ).

% unique_quotient
thf(fact_4520_unique__remainder,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R4: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R4 ) )
       => ( R = R4 ) ) ) ).

% unique_remainder
thf(fact_4521_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,X2: A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ X2 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
           => ( summable @ real
              @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_4522_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( summable @ A @ F2 )
           => ( ( summable @ A @ G )
             => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) ) ) ) ) ) ).

% suminf_le
thf(fact_4523_summable__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N5 )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_finite
thf(fact_4524_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_mult_D
thf(fact_4525_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_4526_suminf__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( times_times @ A @ ( suminf @ A @ F2 ) @ C2 )
            = ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 ) ) ) ) ) ).

% suminf_mult2
thf(fact_4527_suminf__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) )
            = ( times_times @ A @ C2 @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mult
thf(fact_4528_suminf__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( ( plus_plus @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N: nat] : ( plus_plus @ A @ ( F2 @ N ) @ ( G @ N ) ) ) ) ) ) ) ).

% suminf_add
thf(fact_4529_suminf__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( G @ N ) ) ) ) ) ) ) ).

% suminf_diff
thf(fact_4530_suminf__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 ) )
            = ( divide_divide @ A @ ( suminf @ A @ F2 ) @ C2 ) ) ) ) ).

% suminf_divide
thf(fact_4531_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ( suminf @ A @ F2 )
                = ( zero_zero @ A ) )
              = ( ! [N: nat] :
                    ( ( F2 @ N )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_4532_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_4533_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_pos
thf(fact_4534_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) ) ) ) ).

% summable_zero_power'
thf(fact_4535_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) ) ) ) ).

% summable_0_powser
thf(fact_4536_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_4537_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) ) )
          = ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_4538_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,M: nat,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( plus_plus @ nat @ N @ M ) ) @ ( power_power @ A @ Z @ N ) ) )
          = ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_4539_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_4540_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ real
              @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_4541_summable__rabs__comparison__test,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ? [N8: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N3 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
     => ( ( summable @ real @ G )
       => ( summable @ real
          @ ^ [N: nat] : ( abs_abs @ real @ ( F2 @ N ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_4542_div__int__unique,axiom,
    ! [K: int,L2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( divide_divide @ int @ K @ L2 )
        = Q2 ) ) ).

% div_int_unique
thf(fact_4543_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > complex,N5: nat,F2: nat > A] :
          ( ( summable @ complex @ G )
         => ( ! [N3: nat] : ( member @ complex @ ( G @ N3 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G @ N3 ) ) )
             => ( ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ N5 @ N3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G @ N3 ) ) ) )
               => ( summable @ A @ F2 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_4544_mod__int__unique,axiom,
    ! [K: int,L2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( modulo_modulo @ int @ K @ L2 )
        = R ) ) ).

% mod_int_unique
thf(fact_4545_summable__rabs,axiom,
    ! [F2: nat > real] :
      ( ( summable @ real
        @ ^ [N: nat] : ( abs_abs @ real @ ( F2 @ N ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F2 ) )
        @ ( suminf @ real
          @ ^ [N: nat] : ( abs_abs @ real @ ( F2 @ N ) ) ) ) ) ).

% summable_rabs
thf(fact_4546_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_4547_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) )
              = ( ? [I3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_4548_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,X2: A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ X2 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
           => ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ) ).

% powser_inside
thf(fact_4549_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_4550_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X2 ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_4551_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( F2 @ ( suc @ N ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_4552_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( summable @ A
          @ ^ [N: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N ) ) @ ( power_power @ A @ X2 @ N ) ) ) ) ).

% summable_exp
thf(fact_4553_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X2 @ N ) ) ) ) ).

% summable_exp_generic
thf(fact_4554_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A] :
          ( ( summable @ real
            @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F2 ) )
            @ ( suminf @ real
              @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) ) ) ) ) ).

% summable_norm
thf(fact_4555_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ real
          @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ).

% summable_norm_sin
thf(fact_4556_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ real
          @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ).

% summable_norm_cos
thf(fact_4557_eucl__rel__int__dividesI,axiom,
    ! [L2: int,K: int,Q2: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q2 @ L2 ) )
       => ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_4558_eucl__rel__int,axiom,
    ! [K: int,L2: int] : ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ ( divide_divide @ int @ K @ L2 ) @ ( modulo_modulo @ int @ K @ L2 ) ) ) ).

% eucl_rel_int
thf(fact_4559_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ real
          @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ).

% summable_norm_exp
thf(fact_4560_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
            = ( plus_plus @ A @ ( F2 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) ) )
                @ Z ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_4561_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) ) )
              @ Z )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
              @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_4562_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,F2: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( ( summable @ A @ F2 )
           => ? [N9: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ N9 @ N7 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N7 ) ) ) )
                  @ R ) ) ) ) ) ).

% suminf_exist_split
thf(fact_4563_summable__power__series,axiom,
    ! [F2: nat > real,Z: real] :
      ( ! [I4: nat] : ( ord_less_eq @ real @ ( F2 @ I4 ) @ ( one_one @ real ) )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ I4 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z )
         => ( ( ord_less @ real @ Z @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( F2 @ I3 ) @ ( power_power @ real @ Z @ I3 ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_4564_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,R0: real,A2: nat > A,M7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R )
         => ( ( ord_less @ real @ R @ R0 )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R0 @ N3 ) ) @ M7 )
             => ( summable @ real
                @ ^ [N: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N ) ) @ ( power_power @ real @ R @ N ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_4565_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N5: nat,F2: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ ( suc @ N3 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_ratio_test
thf(fact_4566_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q2 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q2 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_4567_eucl__rel__int__iff,axiom,
    ! [K: int,L2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L2 @ Q2 ) @ R ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
            & ( ord_less @ int @ R @ L2 ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
         => ( ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L2 @ R )
                & ( ord_less_eq @ int @ R @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
             => ( Q2
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_4568_eucl__rel__int__remainderI,axiom,
    ! [R: int,L2: int,K: int,Q2: int] :
      ( ( ( sgn_sgn @ int @ R )
        = ( sgn_sgn @ int @ L2 ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R ) @ ( abs_abs @ int @ L2 ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q2 @ L2 ) @ R ) )
         => ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_4569_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A1: int,A22: int,A32: product_prod @ int @ int] :
          ( ? [K3: int] :
              ( ( A1 = K3 )
              & ( A22
                = ( zero_zero @ int ) )
              & ( A32
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K3 ) ) )
          | ? [L: int,K3: int,Q4: int] :
              ( ( A1 = K3 )
              & ( A22 = L )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) )
              & ( L
               != ( zero_zero @ int ) )
              & ( K3
                = ( times_times @ int @ Q4 @ L ) ) )
          | ? [R5: int,L: int,K3: int,Q4: int] :
              ( ( A1 = K3 )
              & ( A22 = L )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L ) )
              & ( K3
                = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_4570_eucl__rel__int_Ocases,axiom,
    ! [A12: int,A23: int,A33: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A12 @ A23 @ A33 )
     => ( ( ( A23
            = ( zero_zero @ int ) )
         => ( A33
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A12 ) ) )
       => ( ! [Q3: int] :
              ( ( A33
                = ( product_Pair @ int @ int @ Q3 @ ( zero_zero @ int ) ) )
             => ( ( A23
                 != ( zero_zero @ int ) )
               => ( A12
                 != ( times_times @ int @ Q3 @ A23 ) ) ) )
         => ~ ! [R2: int,Q3: int] :
                ( ( A33
                  = ( product_Pair @ int @ int @ Q3 @ R2 ) )
               => ( ( ( sgn_sgn @ int @ R2 )
                    = ( sgn_sgn @ int @ A23 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R2 ) @ ( abs_abs @ int @ A23 ) )
                   => ( A12
                     != ( plus_plus @ int @ ( times_times @ int @ Q3 @ A23 ) @ R2 ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_4571_and__int_Oelims,axiom,
    ! [X2: int,Xa: int,Y2: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X2 @ Xa )
        = Y2 )
     => ( ( ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y2
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y2
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_4572_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L: int] :
          ( if @ int
          @ ( ( member @ int @ K3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_4573_vebt__buildup_Oelims,axiom,
    ! [X2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X2 )
        = Y2 )
     => ( ( ( X2
            = ( zero_zero @ nat ) )
         => ( Y2
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X2
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y2
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va: nat] :
                ( ( X2
                  = ( suc @ ( suc @ Va ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_4574_infinite__int__iff__unbounded,axiom,
    ! [S: set @ int] :
      ( ( ~ ( finite_finite @ int @ S ) )
      = ( ! [M3: int] :
          ? [N: int] :
            ( ( ord_less @ int @ M3 @ ( abs_abs @ int @ N ) )
            & ( member @ int @ N @ S ) ) ) ) ).

% infinite_int_iff_unbounded
thf(fact_4575_intind,axiom,
    ! [A: $tType,I: nat,N2: nat,P: A > $o,X2: A] :
      ( ( ord_less @ nat @ I @ N2 )
     => ( ( P @ X2 )
       => ( P @ ( nth @ A @ ( replicate @ A @ N2 @ X2 ) @ I ) ) ) ) ).

% intind
thf(fact_4576_insert__Diff1,axiom,
    ! [A: $tType,X2: A,B4: set @ A,A3: set @ A] :
      ( ( member @ A @ X2 @ B4 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ B4 )
        = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% insert_Diff1
thf(fact_4577_Diff__insert0,axiom,
    ! [A: $tType,X2: A,A3: set @ A,B4: set @ A] :
      ( ~ ( member @ A @ X2 @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ B4 ) )
        = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% Diff_insert0
thf(fact_4578_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X2: A,N2: nat,Y2: A] :
      ( ( ( replicate @ A @ M @ X2 )
        = ( replicate @ A @ N2 @ Y2 ) )
      = ( ( M = N2 )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X2 = Y2 ) ) ) ) ).

% replicate_eq_replicate
thf(fact_4579_insert__Diff__single,axiom,
    ! [A: $tType,A2: A,A3: set @ A] :
      ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A2 @ A3 ) ) ).

% insert_Diff_single
thf(fact_4580_finite__Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,A2: A,B4: set @ A] :
      ( ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) ) )
      = ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% finite_Diff_insert
thf(fact_4581_in__set__replicate,axiom,
    ! [A: $tType,X2: A,N2: nat,Y2: A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N2 @ Y2 ) ) )
      = ( ( X2 = Y2 )
        & ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_4582_Bex__set__replicate,axiom,
    ! [A: $tType,N2: nat,A2: A,P: A > $o] :
      ( ( ? [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ ( replicate @ A @ N2 @ A2 ) ) )
            & ( P @ X ) ) )
      = ( ( P @ A2 )
        & ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_4583_Ball__set__replicate,axiom,
    ! [A: $tType,N2: nat,A2: A,P: A > $o] :
      ( ( ! [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ ( replicate @ A @ N2 @ A2 ) ) )
           => ( P @ X ) ) )
      = ( ( P @ A2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_4584_nth__replicate,axiom,
    ! [A: $tType,I: nat,N2: nat,X2: A] :
      ( ( ord_less @ nat @ I @ N2 )
     => ( ( nth @ A @ ( replicate @ A @ N2 @ X2 ) @ I )
        = X2 ) ) ).

% nth_replicate
thf(fact_4585_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X2 @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
              = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod.insert
thf(fact_4586_set__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N2 @ X2 ) )
        = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_4587_set__replicate__conv__if,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N2 @ X2 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N2 @ X2 ) )
          = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_4588_set__replicate__Suc,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N2 ) @ X2 ) )
      = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_4589_insert__Diff__if,axiom,
    ! [A: $tType,X2: A,B4: set @ A,A3: set @ A] :
      ( ( ( member @ A @ X2 @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ B4 )
          = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) )
      & ( ~ ( member @ A @ X2 @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ B4 )
          = ( insert @ A @ X2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ).

% insert_Diff_if
thf(fact_4590_Diff__insert__absorb,axiom,
    ! [A: $tType,X2: A,A3: set @ A] :
      ( ~ ( member @ A @ X2 @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
        = A3 ) ) ).

% Diff_insert_absorb
thf(fact_4591_Diff__insert2,axiom,
    ! [A: $tType,A3: set @ A,A2: A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) ) ).

% Diff_insert2
thf(fact_4592_insert__Diff,axiom,
    ! [A: $tType,A2: A,A3: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A3 ) ) ).

% insert_Diff
thf(fact_4593_Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,A2: A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Diff_insert
thf(fact_4594_Compl__insert,axiom,
    ! [A: $tType,X2: A,A3: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) )
      = ( minus_minus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Compl_insert
thf(fact_4595_subset__Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,X2: A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ ( insert @ A @ X2 @ C6 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ C6 ) )
        & ~ ( member @ A @ X2 @ A3 ) ) ) ).

% subset_Diff_insert
thf(fact_4596_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B,S5: set @ B] :
                  ( ( finite_finite @ B @ S5 )
                 => ( ! [Y4: B] :
                        ( ( member @ B @ Y4 @ S5 )
                       => ( ord_less_eq @ A @ ( F2 @ Y4 ) @ ( F2 @ X3 ) ) )
                   => ( ( P @ S5 )
                     => ( P @ ( insert @ B @ X3 @ S5 ) ) ) ) )
             => ( P @ S ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_4597_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A8 )
                       => ( ord_less @ A @ B6 @ X4 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B6 @ A8 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_4598_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A8 )
                       => ( ord_less @ A @ X4 @ B6 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B6 @ A8 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_4599_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X2 @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X2 @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_4600_finite__empty__induct,axiom,
    ! [A: $tType,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ A3 )
     => ( ( P @ A3 )
       => ( ! [A6: A,A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( member @ A @ A6 @ A8 )
               => ( ( P @ A8 )
                 => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ A6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
         => ( P @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% finite_empty_induct
thf(fact_4601_infinite__coinduct,axiom,
    ! [A: $tType,X6: ( set @ A ) > $o,A3: set @ A] :
      ( ( X6 @ A3 )
     => ( ! [A8: set @ A] :
            ( ( X6 @ A8 )
           => ? [X4: A] :
                ( ( member @ A @ X4 @ A8 )
                & ( ( X6 @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  | ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
       => ~ ( finite_finite @ A @ A3 ) ) ) ).

% infinite_coinduct
thf(fact_4602_infinite__remove,axiom,
    ! [A: $tType,S: set @ A,A2: A] :
      ( ~ ( finite_finite @ A @ S )
     => ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ S @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_remove
thf(fact_4603_Diff__single__insert,axiom,
    ! [A: $tType,A3: set @ A,X2: A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ B4 ) ) ) ).

% Diff_single_insert
thf(fact_4604_subset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X2: A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ B4 ) )
      = ( ( ( member @ A @ X2 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) )
        & ( ~ ( member @ A @ X2 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% subset_insert_iff
thf(fact_4605_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B4: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B4 )
         => ( P @ B4 ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B4 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B4 ) ) ) ) ).

% remove_induct
thf(fact_4606_finite__remove__induct,axiom,
    ! [A: $tType,B4: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B4 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B4 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B4 ) ) ) ) ).

% finite_remove_induct
thf(fact_4607_finite__induct__select,axiom,
    ! [A: $tType,S: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ S )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T7 @ S )
             => ( ( P @ T7 )
               => ? [X4: A] :
                    ( ( member @ A @ X4 @ ( minus_minus @ ( set @ A ) @ S @ T7 ) )
                    & ( P @ ( insert @ A @ X4 @ T7 ) ) ) ) )
         => ( P @ S ) ) ) ) ).

% finite_induct_select
thf(fact_4608_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X2: A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ B4 ) )
      = ( ( ( member @ A @ X2 @ B4 )
         => ( ord_less @ ( set @ A ) @ A3 @ B4 ) )
        & ( ~ ( member @ A @ X2 @ B4 )
         => ( ( ( member @ A @ X2 @ A3 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) )
            & ( ~ ( member @ A @ X2 @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_4609_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less_eq @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) )
        = ( insert @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) @ ( set_or1337092689740270186AtMost @ int @ M @ N2 ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_4610_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I3: int,J2: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J2 @ I3 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert @ int @ I3 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J2 ) ) ) ) ) ).

% simp_from_to
thf(fact_4611_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X2 @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_4612_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,X2: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
            = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_4613_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member @ B @ A2 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_4614_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: set @ B,F2: B > A,A2: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( F2 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_4615_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sinh @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X2 ) @ ( insert @ A @ ( one_one @ A ) @ ( insert @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_4616_infinite__nat__iff__unbounded,axiom,
    ! [S: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S ) )
      = ( ! [M3: nat] :
          ? [N: nat] :
            ( ( ord_less @ nat @ M3 @ N )
            & ( member @ nat @ N @ S ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_4617_unbounded__k__infinite,axiom,
    ! [K: nat,S: set @ nat] :
      ( ! [M4: nat] :
          ( ( ord_less @ nat @ K @ M4 )
         => ? [N7: nat] :
              ( ( ord_less @ nat @ M4 @ N7 )
              & ( member @ nat @ N7 @ S ) ) )
     => ~ ( finite_finite @ nat @ S ) ) ).

% unbounded_k_infinite
thf(fact_4618_infinite__nat__iff__unbounded__le,axiom,
    ! [S: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S ) )
      = ( ! [M3: nat] :
          ? [N: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
            & ( member @ nat @ N @ S ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_4619_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va2: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_4620_infinite__int__iff__unbounded__le,axiom,
    ! [S: set @ int] :
      ( ( ~ ( finite_finite @ int @ S ) )
      = ( ! [M3: int] :
          ? [N: int] :
            ( ( ord_less_eq @ int @ M3 @ ( abs_abs @ int @ N ) )
            & ( member @ int @ N @ S ) ) ) ) ).

% infinite_int_iff_unbounded_le
thf(fact_4621_and__int_Opelims,axiom,
    ! [X2: int,Xa: int,Y2: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X2 @ Xa ) )
       => ~ ( ( ( ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y2
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y2
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X2 @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_4622_and__int_Opsimps,axiom,
    ! [K: int,L2: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L2 ) )
     => ( ( ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L2 )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L2 )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_4623_sin__paired,axiom,
    ! [X2: real] :
      ( sums @ real
      @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X2 ) ) ).

% sin_paired
thf(fact_4624_sums__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( sums @ A
        @ ^ [N: nat] : ( zero_zero @ A )
        @ ( zero_zero @ A ) ) ) ).

% sums_zero
thf(fact_4625_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X2: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) )
            @ X2 )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X2 ) ) ) ).

% powser_sums_zero_iff
thf(fact_4626_sums__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 )
            @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ).

% sums_divide
thf(fact_4627_sums__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 )
            @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% sums_mult2
thf(fact_4628_sums__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) )
            @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% sums_mult
thf(fact_4629_sums__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F2: nat > A] :
          ( sums @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
          @ ( F2 @ I ) ) ) ).

% sums_single
thf(fact_4630_sums__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N: nat] : ( plus_plus @ A @ ( F2 @ N ) @ ( G @ N ) )
              @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_add
thf(fact_4631_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A,S2: A,T2: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( sums @ A @ F2 @ S2 )
           => ( ( sums @ A @ G @ T2 )
             => ( ord_less_eq @ A @ S2 @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_4632_sums__0,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( ! [N3: nat] :
              ( ( F2 @ N3 )
              = ( zero_zero @ A ) )
         => ( sums @ A @ F2 @ ( zero_zero @ A ) ) ) ) ).

% sums_0
thf(fact_4633_sums__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( G @ N ) )
              @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_diff
thf(fact_4634_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) )
              @ ( times_times @ A @ C2 @ D3 ) )
            = ( sums @ A @ F2 @ D3 ) ) ) ) ).

% sums_mult_iff
thf(fact_4635_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 )
              @ ( times_times @ A @ D3 @ C2 ) )
            = ( sums @ A @ F2 @ D3 ) ) ) ) ).

% sums_mult2_iff
thf(fact_4636_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F2 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_4637_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S2: A] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
              @ S2 )
           => ( sums @ A @ F2 @ S2 ) ) ) ) ).

% sums_Suc_imp
thf(fact_4638_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,L2: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ L2 )
         => ( sums @ A @ F2 @ ( plus_plus @ A @ L2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_4639_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S2: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ S2 )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_4640_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N2: nat,F2: nat > A,S2: A] :
          ( ! [I4: nat] :
              ( ( ord_less @ nat @ I4 @ N2 )
             => ( ( F2 @ I4 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N2 ) )
              @ S2 )
            = ( sums @ A @ F2 @ S2 ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_4641_atLeast0__atMost__Suc,axiom,
    ! [N2: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ ( suc @ N2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% atLeast0_atMost_Suc
thf(fact_4642_atLeastAtMost__insertL,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ).

% atLeastAtMost_insertL
thf(fact_4643_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) )
        = ( insert @ nat @ ( suc @ N2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_4644_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N2 )
        = ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_4645_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z: A] :
          ( sums @ A
          @ ^ [N: nat] : ( times_times @ A @ ( if @ A @ ( N = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z @ N ) )
          @ ( power_power @ A @ Z @ M ) ) ) ).

% powser_sums_if
thf(fact_4646_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_4647_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ X2 @ N ) )
          @ ( sin @ A @ X2 ) ) ) ).

% sin_converges
thf(fact_4648_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ X2 @ N ) )
          @ ( cos @ A @ X2 ) ) ) ).

% cos_converges
thf(fact_4649_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X2 @ N ) )
          @ ( exp @ A @ X2 ) ) ) ).

% exp_converges
thf(fact_4650_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ N ) ) )
          @ ( sin @ A @ X2 ) ) ) ).

% sin_minus_converges
thf(fact_4651_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ N ) )
          @ ( cos @ A @ X2 ) ) ) ).

% cos_minus_converges
thf(fact_4652_set__decode__plus__power__2,axiom,
    ! [N2: nat,Z: nat] :
      ( ~ ( member @ nat @ N2 @ ( nat_set_decode @ Z ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ Z ) )
        = ( insert @ nat @ N2 @ ( nat_set_decode @ Z ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_4653_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_4654_power__half__series,axiom,
    ( sums @ real
    @ ^ [N: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_4655_sums__if_H,axiom,
    ! [G: nat > real,X2: real] :
      ( ( sums @ real @ G @ X2 )
     => ( sums @ real
        @ ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ real ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X2 ) ) ).

% sums_if'
thf(fact_4656_sums__if,axiom,
    ! [G: nat > real,X2: real,F2: nat > real,Y2: real] :
      ( ( sums @ real @ G @ X2 )
     => ( ( sums @ real @ F2 @ Y2 )
       => ( sums @ real
          @ ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( F2 @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X2 @ Y2 ) ) ) ) ).

% sums_if
thf(fact_4657_and__int_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [K2: int,L3: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L3 ) )
           => ( ( ~ ( ( member @ int @ K2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K2 @ L3 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% and_int.pinduct
thf(fact_4658_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X2 @ N ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X2 ) ) ) ).

% cosh_converges
thf(fact_4659_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X2 @ N ) ) )
          @ ( sinh @ A @ X2 ) ) ) ).

% sinh_converges
thf(fact_4660_cos__paired,axiom,
    ! [X2: real] :
      ( sums @ real
      @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( power_power @ real @ X2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
      @ ( cos @ real @ X2 ) ) ).

% cos_paired
thf(fact_4661_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_4662_upto_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [I4: int,J3: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I4 @ J3 ) )
           => ( ( ( ord_less_eq @ int @ I4 @ J3 )
               => ( P @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) )
             => ( P @ I4 @ J3 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% upto.pinduct
thf(fact_4663_set__encode__insert,axiom,
    ! [A3: set @ nat,N2: nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ~ ( member @ nat @ N2 @ A3 )
       => ( ( nat_set_encode @ ( insert @ nat @ N2 @ A3 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( nat_set_encode @ A3 ) ) ) ) ) ).

% set_encode_insert
thf(fact_4664_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( C2 @ N ) ) @ ( power_power @ A @ X2 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_4665_set__decode__inverse,axiom,
    ! [N2: nat] :
      ( ( nat_set_encode @ ( nat_set_decode @ N2 ) )
      = N2 ) ).

% set_decode_inverse
thf(fact_4666_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_4667_set__encode__inverse,axiom,
    ! [A3: set @ nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ( nat_set_decode @ ( nat_set_encode @ A3 ) )
        = A3 ) ) ).

% set_encode_inverse
thf(fact_4668_set__encode__eq,axiom,
    ! [A3: set @ nat,B4: set @ nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ( finite_finite @ nat @ B4 )
       => ( ( ( nat_set_encode @ A3 )
            = ( nat_set_encode @ B4 ) )
          = ( A3 = B4 ) ) ) ) ).

% set_encode_eq
thf(fact_4669_set__encode__inf,axiom,
    ! [A3: set @ nat] :
      ( ~ ( finite_finite @ nat @ A3 )
     => ( ( nat_set_encode @ A3 )
        = ( zero_zero @ nat ) ) ) ).

% set_encode_inf
thf(fact_4670_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C3: nat > A,N: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( C3 @ ( suc @ N ) ) ) ) ) ) ).

% diffs_def
thf(fact_4671_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ! [X3: A] :
              ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X3 @ N ) ) )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_4672_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,K5: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K5 )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 )
               => ( summable @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X3 @ N ) ) ) )
           => ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_4673_even__set__encode__iff,axiom,
    ! [A3: set @ nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A3 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) ) ) ) ).

% even_set_encode_iff
thf(fact_4674_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N2: nat,M: nat,X2: A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( ( X2
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X2
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_4675_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X8: nat > A] :
              ( ! [M3: nat,N: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N )
                 => ( ord_less_eq @ A @ ( X8 @ M3 ) @ ( X8 @ N ) ) )
              | ! [M3: nat,N: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N )
                 => ( ord_less_eq @ A @ ( X8 @ N ) @ ( X8 @ M3 ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_4676_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X6: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X6 @ N3 ) @ ( X6 @ M4 ) ) )
         => ( topological_monoseq @ A @ X6 ) ) ) ).

% monoI2
thf(fact_4677_Ints__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ B )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( member @ B @ ( F2 @ X3 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_sum
thf(fact_4678_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [Uu2: B] : ( zero_zero @ A )
            @ A3 )
          = ( zero_zero @ A ) ) ) ).

% sum.neutral_const
thf(fact_4679_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [F2: B > nat,A3: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X: B] : ( semiring_1_of_nat @ A @ ( F2 @ X ) )
            @ A3 ) ) ) ).

% of_nat_sum
thf(fact_4680_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: B > int,A3: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7311177749621191930dd_sum @ B @ int @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X: B] : ( ring_1_of_int @ A @ ( F2 @ X ) )
            @ A3 ) ) ) ).

% of_int_sum
thf(fact_4681_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_4682_sum_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.infinite
thf(fact_4683_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [F3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ F3 )
         => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ F3 )
              = ( zero_zero @ A ) )
            = ( ! [X: B] :
                  ( ( member @ B @ X @ F3 )
                 => ( ( F2 @ X )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_eq_0_iff
thf(fact_4684_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta'
thf(fact_4685_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta
thf(fact_4686_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I3: A] : ( abs_abs @ B @ ( F2 @ I3 ) )
            @ A3 ) ) ) ).

% sum_abs
thf(fact_4687_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X2 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
              = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum.insert
thf(fact_4688_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I3: A] : ( abs_abs @ B @ ( F2 @ I3 ) )
            @ A3 ) ) ) ).

% sum_abs_ge_zero
thf(fact_4689_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_4690_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) )
                @ A3 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_4691_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: set @ nat,C2: nat > A,D3: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) ) @ ( D3 @ I3 ) )
                @ A3 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D3 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) ) @ ( D3 @ I3 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_4692_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S: set @ B,F2: B > A,G: B > real] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ S )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ ( G @ X3 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) ) @ ( groups7311177749621191930dd_sum @ B @ real @ G @ S ) ) ) ) ).

% sum_norm_le
thf(fact_4693_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I3: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ I3 ) )
            @ A3 ) ) ) ).

% norm_sum
thf(fact_4694_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [I3: B] : ( modulo_modulo @ A @ ( F2 @ I3 ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ A2 ) ) ) ).

% mod_sum_eq
thf(fact_4695_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,A3: set @ B,R: A] :
          ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N: B] : ( divide_divide @ A @ ( F2 @ N ) @ R )
            @ A3 ) ) ) ).

% sum_divide_distrib
thf(fact_4696_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,A3: set @ A,G: C > B,B4: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B4 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I3: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J2: C] : ( times_times @ B @ ( F2 @ I3 ) @ ( G @ J2 ) )
                @ B4 )
            @ A3 ) ) ) ).

% sum_product
thf(fact_4697_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,A3: set @ B,R: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N: B] : ( times_times @ A @ ( F2 @ N ) @ R )
            @ A3 ) ) ) ).

% sum_distrib_right
thf(fact_4698_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R: A,F2: B > A,A3: set @ B] :
          ( ( times_times @ A @ R @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N: B] : ( times_times @ A @ R @ ( F2 @ N ) )
            @ A3 ) ) ) ).

% sum_distrib_left
thf(fact_4699_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X: B] : ( plus_plus @ A @ ( G @ X ) @ ( H2 @ X ) )
            @ A3 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ A3 ) ) ) ) ).

% sum.distrib
thf(fact_4700_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K5: set @ B,F2: B > A,G: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ K5 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K5 ) ) ) ) ).

% sum_mono
thf(fact_4701_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
           != ( zero_zero @ A ) )
         => ~ ! [A6: B] :
                ( ( member @ B @ A6 @ A3 )
               => ( ( G @ A6 )
                  = ( zero_zero @ A ) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
thf(fact_4702_sum_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ( G @ X3 )
                = ( zero_zero @ A ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.neutral
thf(fact_4703_sum__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X: B] : ( minus_minus @ A @ ( F2 @ X ) @ ( G @ X ) )
            @ A3 )
          = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum_subtractf
thf(fact_4704_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_4705_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_nonneg
thf(fact_4706_sum__mono__inv,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F2: I6 > A,I5: set @ I6,G: I6 > A,I: I6] :
          ( ( ( groups7311177749621191930dd_sum @ I6 @ A @ F2 @ I5 )
            = ( groups7311177749621191930dd_sum @ I6 @ A @ G @ I5 ) )
         => ( ! [I4: I6] :
                ( ( member @ I6 @ I4 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) )
           => ( ( member @ I6 @ I @ I5 )
             => ( ( finite_finite @ I6 @ I5 )
               => ( ( F2 @ I )
                  = ( G @ I ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_4707_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ nat,F2: nat > A,G: nat > A] :
          ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 )
         => ( ! [X3: nat] :
                ( ( member @ nat @ ( suc @ X3 ) @ A3 )
               => ( ( F2 @ ( suc @ X3 ) )
                  = ( G @ ( suc @ X3 ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A3 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ A3 ) ) ) ) ) ).

% sum_cong_Suc
thf(fact_4708_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( collect @ B
                @ ^ [X: B] :
                    ( ( member @ B @ X @ A3 )
                    & ( P @ X ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X: B] : ( if @ A @ ( P @ X ) @ ( G @ X ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_filter
thf(fact_4709_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
thf(fact_4710_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_4711_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 )
                = ( zero_zero @ A ) )
              = ( ! [X: B] :
                    ( ( member @ B @ X @ A3 )
                   => ( ( F2 @ X )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_4712_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S2: set @ B,T2: set @ C,G: C > A,I: C > B,F2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G @ X3 ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ? [Xa2: C] :
                        ( ( member @ C @ Xa2 @ T2 )
                        & ( ( I @ Xa2 )
                          = X3 )
                        & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ Xa2 ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) @ ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_4713_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: set @ I6,F2: I6 > A,G: I6 > A] :
          ( ( finite_finite @ I6 @ A3 )
         => ( ! [X3: I6] :
                ( ( member @ I6 @ X3 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ? [X4: I6] :
                  ( ( member @ I6 @ X4 @ A3 )
                  & ( ord_less @ A @ ( F2 @ X4 ) @ ( G @ X4 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I6 @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ I6 @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_4714_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R3: A > A > $o,S: set @ B,H2: B > A,G: B > A] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( ( R3 @ X1 @ X23 )
                  & ( R3 @ Y1 @ Y23 ) )
               => ( R3 @ ( plus_plus @ A @ X1 @ Y1 ) @ ( plus_plus @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ( R3 @ ( H2 @ X3 ) @ ( G @ X3 ) ) )
               => ( R3 @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ S ) ) ) ) ) ) ) ).

% sum.related
thf(fact_4715_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A3 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_4716_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% sum.insert_if
thf(fact_4717_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S4: set @ B,T6: set @ C,S: set @ B,I: C > B,J: B > C,T5: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T6 )
           => ( ! [A6: B] :
                  ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S @ S4 ) )
                 => ( ( I @ ( J @ A6 ) )
                    = A6 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S @ S4 ) )
                   => ( member @ C @ ( J @ A6 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                     => ( ( J @ ( I @ B6 ) )
                        = B6 ) )
                 => ( ! [B6: C] :
                        ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                       => ( member @ B @ ( I @ B6 ) @ ( minus_minus @ ( set @ B ) @ S @ S4 ) ) )
                   => ( ! [A6: B] :
                          ( ( member @ B @ A6 @ S4 )
                         => ( ( G @ A6 )
                            = ( zero_zero @ A ) ) )
                     => ( ! [B6: C] :
                            ( ( member @ C @ B6 @ T6 )
                           => ( ( H2 @ B6 )
                              = ( zero_zero @ A ) ) )
                       => ( ! [A6: B] :
                              ( ( member @ B @ A6 @ S )
                             => ( ( H2 @ ( J @ A6 ) )
                                = ( G @ A6 ) ) )
                         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S )
                            = ( groups7311177749621191930dd_sum @ C @ A @ H2 @ T5 ) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
thf(fact_4718_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S2: set @ B,F2: B > A,I: B] :
          ( ( finite_finite @ B @ S2 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ S2 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I @ S2 )
               => ( ( F2 @ I )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_4719_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S2: set @ B,F2: B > A,B4: A,I: B] :
          ( ( finite_finite @ B @ S2 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ S2 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 )
                = B4 )
             => ( ( member @ B @ I @ S2 )
               => ( ord_less_eq @ A @ ( F2 @ I ) @ B4 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_4720_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X: B] :
                      ( ( G @ X )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_4721_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,M: nat,I5: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( power_power @ A @ X2 @ ( plus_plus @ nat @ M @ I3 ) )
            @ I5 )
          = ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ I5 ) ) ) ) ).

% sum_power_add
thf(fact_4722_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_4723_sums__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N5 )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( sums @ A @ F2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N5 ) ) ) ) ) ).

% sums_finite
thf(fact_4724_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( collect @ nat @ P ) ) ) ) ) ).

% sums_If_finite
thf(fact_4725_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A3: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A3 )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A3 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A3 ) ) ) ) ).

% sums_If_finite_set
thf(fact_4726_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [N5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N5 )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A @ F2 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N5 ) ) ) ) ) ).

% suminf_finite
thf(fact_4727_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,I: B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( member @ B @ I @ I5 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
             => ( ! [I4: B] :
                    ( ( member @ B @ I4 @ I5 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_4728_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I4: B] :
                  ( ( member @ B @ I4 @ I5 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ).

% sum_pos
thf(fact_4729_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A3: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C6 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B4 ) )
                     => ( ( H2 @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B4 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_4730_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A3: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C6 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B4 ) )
                     => ( ( H2 @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B4 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_4731_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ T5 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_4732_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T5 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ S ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_4733_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( H2 @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T5 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_4734_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T5 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_4735_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B4: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_4736_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) )
              = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B4 ) ) ) ) ) ) ).

% sum_diff
thf(fact_4737_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0
thf(fact_4738_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_4739_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
            = ( plus_plus @ A @ ( G @ ( suc @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_4740_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_4741_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) )
            = ( plus_plus @ A @ ( G @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_4742_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_4743_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( ( topolo1287966508704411220up_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > A,S: A,A3: set @ nat,S4: A,F2: nat > A] :
          ( ( sums @ A @ G @ S )
         => ( ( finite_finite @ nat @ A3 )
           => ( ( S4
                = ( plus_plus @ A @ S
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( G @ N ) )
                    @ A3 ) ) )
             => ( sums @ A
                @ ^ [N: nat] : ( if @ A @ ( member @ nat @ N @ A3 ) @ ( F2 @ N ) @ ( G @ N ) )
                @ S4 ) ) ) ) ) ).

% sums_If_finite_set'
thf(fact_4744_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( plus_plus @ A @ ( F2 @ A4 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_4745_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B4: set @ B,A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
           => ( ! [B6: B] :
                  ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ B4 @ A3 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ B6 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B4 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_4746_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,X2: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
            = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_4747_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X2 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_4748_sum__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,A2: B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ A2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( F2 @ A2 ) ) ) )
            & ( ~ ( member @ B @ A2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% sum_diff1
thf(fact_4749_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A,P2: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N2 @ P2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ P2 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_4750_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I5: set @ nat] :
          ( ( summable @ A @ F2 )
         => ( ( finite_finite @ nat @ I5 )
           => ( ! [N3: nat] :
                  ( ( member @ nat @ N3 @ ( uminus_uminus @ ( set @ nat ) @ I5 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ I5 ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_4751_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S )
                = ( plus_plus @ A @ ( B2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_4752_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4753_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B4: set @ A,A3: set @ A,B2: A,F2: A > B] :
          ( ( finite_finite @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F2 @ B2 ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ B4 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ B4 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_4754_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I: C,A3: set @ C,F2: C > B] :
          ( ( member @ C @ I @ A3 )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ ( minus_minus @ ( set @ C ) @ A3 @ ( insert @ C @ I @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
           => ( ( finite_finite @ C @ A3 )
             => ( ord_less_eq @ B @ ( F2 @ I ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A3 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_4755_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,X2: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I5 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X2 @ I4 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X2 @ I5 )
              = ( one_one @ B ) )
           => ( ! [I4: A] :
                  ( ( member @ A @ I4 @ I5 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I4 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I3: A] : ( times_times @ B @ ( A2 @ I3 ) @ ( X2 @ I3 ) )
                      @ I5 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_4756_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_4757_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_4758_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,E2: real] :
          ( ( summable @ A @ F2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ~ ! [N9: nat] :
                  ~ ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ M2 )
                     => ! [N7: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N7 ) ) ) @ E2 ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_4759_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N2 ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_4760_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N2: nat,X2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_4761_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.in_pairs
thf(fact_4762_mask__eq__sum__exp__nat,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N2 ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_4763_gauss__sum__nat,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X: nat] : X
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( suc @ N2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_4764_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J2: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J2 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_4765_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_4766_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D3: A,N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I3 ) @ D3 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ D3 ) ) ) ) ) ).

% double_arith_series
thf(fact_4767_arith__series__nat,axiom,
    ! [A2: nat,D3: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I3: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I3 @ D3 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N2 @ D3 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_4768_Sum__Icc__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X: nat] : X
        @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_4769_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_4770_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D3: A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I3 ) @ D3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ D3 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_4771_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_4772_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,M: nat,N2: nat] :
          ( ( ( X2
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N2 ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) )
          & ( ( X2
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N2 ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_4773_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_4774_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ R @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_4775_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X8: nat > A] :
              ( ! [N: nat] : ( ord_less_eq @ A @ ( X8 @ N ) @ ( X8 @ ( suc @ N ) ) )
              | ! [N: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N ) ) @ ( X8 @ N ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_4776_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X6: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X6 @ ( suc @ N3 ) ) @ ( X6 @ N3 ) )
         => ( topological_monoseq @ A @ X6 ) ) ) ).

% mono_SucI2
thf(fact_4777_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X6: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X6 @ N3 ) @ ( X6 @ ( suc @ N3 ) ) )
         => ( topological_monoseq @ A @ X6 ) ) ) ).

% mono_SucI1
thf(fact_4778_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X6: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X6 @ M4 ) @ ( X6 @ N3 ) ) )
         => ( topological_monoseq @ A @ X6 ) ) ) ).

% monoI1
thf(fact_4779_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( sums @ A
          @ ^ [P4: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P4 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P4 @ N ) ) ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) ) @ ( power_power @ A @ X2 @ N ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P4 @ N ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P4 ) )
          @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ).

% sin_x_sin_y
thf(fact_4780_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( sums @ A
          @ ^ [P4: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P4 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P4 @ N ) ) ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) @ ( power_power @ A @ X2 @ N ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P4 @ N ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P4 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_4781_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( sums @ A
          @ ^ [P4: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P4 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P4 @ N ) ) ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) @ ( power_power @ A @ X2 @ N ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P4 @ N ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P4 ) )
          @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) ) ) ).

% cos_x_cos_y
thf(fact_4782_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I @ K ) ) ) ).

% atMost_iff
thf(fact_4783_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X2 ) @ ( set_ord_atMost @ A @ Y2 ) )
          = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% atMost_subset_iff
thf(fact_4784_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L2: A,H2: A,H3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ H2 ) @ ( set_ord_atMost @ A @ H3 ) )
          = ( ~ ( ord_less_eq @ A @ L2 @ H2 )
            | ( ord_less_eq @ A @ H2 @ H3 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_4785_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% sum.atMost_Suc
thf(fact_4786_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_4787_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_4788_Complex__sum_H,axiom,
    ! [A: $tType,F2: A > real,S2: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ complex
        @ ^ [X: A] : ( complex2 @ ( F2 @ X ) @ ( zero_zero @ real ) )
        @ S2 )
      = ( complex2 @ ( groups7311177749621191930dd_sum @ A @ real @ F2 @ S2 ) @ ( zero_zero @ real ) ) ) ).

% Complex_sum'
thf(fact_4789_int__sum,axiom,
    ! [B: $tType,F2: B > nat,A3: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A3 ) )
      = ( groups7311177749621191930dd_sum @ B @ int
        @ ^ [X: B] : ( semiring_1_of_nat @ int @ ( F2 @ X ) )
        @ A3 ) ) ).

% int_sum
thf(fact_4790_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X: A] : ( ord_less_eq @ A @ X @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_4791_atMost__atLeast0,axiom,
    ( ( set_ord_atMost @ nat )
    = ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) ) ) ).

% atMost_atLeast0
thf(fact_4792_atMost__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ K ) )
      = ( insert @ nat @ ( suc @ K ) @ ( set_ord_atMost @ nat @ K ) ) ) ).

% atMost_Suc
thf(fact_4793_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A3: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A4: B] : ( power_power @ A @ C2 @ ( F2 @ A4 ) )
            @ A3 ) ) ) ).

% power_sum
thf(fact_4794_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set @ A,G: A > nat,F2: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A3 )
         => ( ord_less_eq @ nat @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X: A] : ( minus_minus @ nat @ ( F2 @ X ) @ ( G @ X ) )
          @ A3 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A3 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_4795_sum__choose__upper,axiom,
    ! [M: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( binomial @ K3 @ M )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( suc @ N2 ) @ ( suc @ M ) ) ) ).

% sum_choose_upper
thf(fact_4796_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
          = ( suc @ ( zero_zero @ nat ) ) )
        = ( ? [X: A] :
              ( ( member @ A @ X @ A3 )
              & ( ( F2 @ X )
                = ( suc @ ( zero_zero @ nat ) ) )
              & ! [Y: A] :
                  ( ( member @ A @ Y @ A3 )
                 => ( ( X != Y )
                   => ( ( F2 @ Y )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
thf(fact_4797_sum__SucD,axiom,
    ! [A: $tType,F2: A > nat,A3: set @ A,N2: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
        = ( suc @ N2 ) )
     => ? [X3: A] :
          ( ( member @ A @ X3 @ A3 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) ).

% sum_SucD
thf(fact_4798_sum__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
          = ( one_one @ nat ) )
        = ( ? [X: A] :
              ( ( member @ A @ X @ A3 )
              & ( ( F2 @ X )
                = ( one_one @ nat ) )
              & ! [Y: A] :
                  ( ( member @ A @ Y @ A3 )
                 => ( ( X != Y )
                   => ( ( F2 @ Y )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_4799_atMost__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_atMost @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( numeral_numeral @ nat @ K ) @ ( set_ord_atMost @ nat @ ( pred_numeral @ K ) ) ) ) ).

% atMost_nat_numeral
thf(fact_4800_sum__choose__lower,axiom,
    ! [R: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( binomial @ ( plus_plus @ nat @ R @ K3 ) @ K3 )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R @ N2 ) ) @ N2 ) ) ).

% sum_choose_lower
thf(fact_4801_choose__rising__sum_I2_J,axiom,
    ! [N2: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J2: nat] : ( binomial @ ( plus_plus @ nat @ N2 @ J2 ) @ N2 )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N2 @ M ) @ ( one_one @ nat ) ) @ M ) ) ).

% choose_rising_sum(2)
thf(fact_4802_choose__rising__sum_I1_J,axiom,
    ! [N2: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J2: nat] : ( binomial @ ( plus_plus @ nat @ N2 @ J2 ) @ N2 )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N2 @ M ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_4803_sum__diff__nat,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B4 ) ) ) ) ) ).

% sum_diff_nat
thf(fact_4804_sum__diff1__nat,axiom,
    ! [A: $tType,A2: A,A3: set @ A,F2: A > nat] :
      ( ( ( member @ A @ A2 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( F2 @ A2 ) ) ) )
      & ( ~ ( member @ A @ A2 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) ) ) ) ).

% sum_diff1_nat
thf(fact_4805_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_4806_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,I: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ ( F2 @ I3 ) @ ( F2 @ ( suc @ I3 ) ) )
            @ ( set_ord_atMost @ nat @ I ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ ( suc @ I ) ) ) ) ) ).

% sum_telescope
thf(fact_4807_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat,D3: nat > A] :
          ( ( ! [X: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( D3 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) ) ) )
          = ( ! [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ N2 )
               => ( ( C2 @ I3 )
                  = ( D3 @ I3 ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_4808_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B4: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N3 ) ) @ B4 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_4809_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_4810_sum__choose__diagonal,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K3: nat] : ( binomial @ ( minus_minus @ nat @ N2 @ K3 ) @ ( minus_minus @ nat @ M @ K3 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N2 ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_4811_vandermonde,axiom,
    ! [M: nat,N2: nat,R: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( binomial @ M @ K3 ) @ ( binomial @ N2 @ ( minus_minus @ nat @ R @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ R ) )
      = ( binomial @ ( plus_plus @ nat @ M @ N2 ) @ R ) ) ).

% vandermonde
thf(fact_4812_sum__nth__roots,axiom,
    ! [N2: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X: complex] : X
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_4813_norm__prod__diff,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I5: set @ I6,Z: I6 > A,W: I6 > A] :
          ( ! [I4: I6] :
              ( ( member @ I6 @ I4 @ I5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z @ I4 ) ) @ ( one_one @ real ) ) )
         => ( ! [I4: I6] :
                ( ( member @ I6 @ I4 @ I5 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W @ I4 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I6 @ A @ Z @ I5 ) @ ( groups7121269368397514597t_prod @ I6 @ A @ W @ I5 ) ) )
              @ ( groups7311177749621191930dd_sum @ I6 @ real
                @ ^ [I3: I6] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z @ I3 ) @ ( W @ I3 ) ) )
                @ I5 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_4814_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N2: nat,K: nat] :
          ( ! [W3: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ W3 @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_4815_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat] :
          ( ( ! [X: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ N2 )
               => ( ( C2 @ I3 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_4816_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ M ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum_up_index_split
thf(fact_4817_choose__row__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N2 ) @ ( set_ord_atMost @ nat @ N2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% choose_row_sum
thf(fact_4818_atLeast1__atMost__eq__remove0,axiom,
    ! [N2: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N2 ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_4819_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K3 ) ) @ K3 )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( one_one @ A ) ) @ N2 ) ) ) ).

% gbinomial_parallel_sum
thf(fact_4820_binomial,axiom,
    ! [A2: nat,B2: nat,N2: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N2 )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N2 @ K3 ) ) @ ( power_power @ nat @ A2 @ K3 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N2 @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ N2 ) ) ) ).

% binomial
thf(fact_4821_sum__roots__unity,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X: complex] : X
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_4822_ln__prod,axiom,
    ! [A: $tType,I5: set @ A,F2: A > real] :
      ( ( finite_finite @ A @ I5 )
     => ( ! [I4: A] :
            ( ( member @ A @ I4 @ I5 )
           => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ I4 ) ) )
       => ( ( ln_ln @ real @ ( groups7121269368397514597t_prod @ A @ real @ F2 @ I5 ) )
          = ( groups7311177749621191930dd_sum @ A @ real
            @ ^ [X: A] : ( ln_ln @ real @ ( F2 @ X ) )
            @ I5 ) ) ) ) ).

% ln_prod
thf(fact_4823_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ N2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) ) ) ).

% sum_gp_basic
thf(fact_4824_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z5: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z5 @ I3 ) )
                      @ ( set_ord_atMost @ nat @ N2 ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_4825_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                    @ ( set_ord_atMost @ nat @ N2 ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ N2 )
                & ( ( C2 @ I3 )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_4826_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N2: nat,X2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_4827_polynomial__product__nat,axiom,
    ! [M: nat,A2: nat > nat,N2: nat,B2: nat > nat,X2: nat] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ M @ I4 )
         => ( ( A2 @ I4 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J3: nat] :
            ( ( ord_less @ nat @ N2 @ J3 )
           => ( ( B2 @ J3 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I3: nat] : ( times_times @ nat @ ( A2 @ I3 ) @ ( power_power @ nat @ X2 @ I3 ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J2: nat] : ( times_times @ nat @ ( B2 @ J2 ) @ ( power_power @ nat @ X2 @ J2 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K3: nat] : ( times_times @ nat @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X2 @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_4828_choose__square__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( power_power @ nat @ ( binomial @ N2 @ K3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ).

% choose_square_sum
thf(fact_4829_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( summable @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I3 ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ).

% summable_Cauchy_product
thf(fact_4830_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) )
              = ( suminf @ A
                @ ^ [K3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I3 ) ) )
                    @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ) ).

% Cauchy_product
thf(fact_4831_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% sum.in_pairs_0
thf(fact_4832_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A2: nat > A,N2: nat,B2: nat > A,X2: A] :
          ( ! [I4: nat] :
              ( ( ord_less @ nat @ M @ I4 )
             => ( ( A2 @ I4 )
                = ( zero_zero @ A ) ) )
         => ( ! [J3: nat] :
                ( ( ord_less @ nat @ N2 @ J3 )
               => ( ( B2 @ J3 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ X2 @ I3 ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J2: nat] : ( times_times @ A @ ( B2 @ J2 ) @ ( power_power @ A @ X2 @ J2 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X2 @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_4833_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% prod.in_pairs_0
thf(fact_4834_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat,K: A] :
          ( ( ! [X: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X: nat] :
                ( ( member @ nat @ X @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) )
               => ( ( C2 @ X )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_4835_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_4836_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K3 ) ) @ ( power_power @ A @ A2 @ K3 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% binomial_ring
thf(fact_4837_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_4838_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( sums @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I3 ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) )
              @ ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) ) ) ) ) ) ).

% Cauchy_product_sums
thf(fact_4839_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P2: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P2 )
         => ( ( ord_less_eq @ nat @ K @ P2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( if @ A @ ( J2 = K ) @ ( zero_zero @ A ) @ ( H2 @ ( minus_minus @ nat @ J2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P2 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( H2 @ J2 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_4840_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P2: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P2 )
         => ( ( ord_less_eq @ nat @ K @ P2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( if @ A @ ( J2 = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P2 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( H2 @ J2 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_4841_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X2: A,Y2: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K3 ) @ ( power_power @ A @ X2 @ K3 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_4842_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_4843_choose__linear__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I3: nat] : ( times_times @ nat @ I3 @ ( binomial @ N2 @ I3 ) )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( times_times @ nat @ N2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_4844_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A,Y2: A,N2: nat] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( times_times @ A @ Y2 @ X2 ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ N2 ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I3 ) ) @ ( power_power @ A @ X2 @ I3 ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ I3 ) ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N2 @ I3 ) ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_4845_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,Z: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( ( power_power @ A @ Z @ N2 )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I3
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I3 = N2 ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_4846_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( ( X2
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) )
          & ( ( X2
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ N2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ).

% sum_gp0
thf(fact_4847_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( N2
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I3 ) @ ( semiring_1_of_nat @ A @ I3 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I3 ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_4848_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K3 ) ) @ K3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_4849_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X2: A,Y2: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K3 ) @ ( power_power @ A @ X2 @ K3 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A2 ) @ ( one_one @ A ) ) @ K3 ) @ ( power_power @ A @ X2 @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_4850_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I3 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I3 ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_4851_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E2: real,C2: nat > A,N2: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ? [M9: real] :
            ! [Z2: A] :
              ( ( ord_less_eq @ real @ M9 @ ( real_V7770717601297561774m_norm @ A @ Z2 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z2 @ I3 ) )
                    @ ( set_ord_atMost @ nat @ N2 ) ) )
                @ ( times_times @ real @ E2 @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( suc @ N2 ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_4852_Sum__Icc__int,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less_eq @ int @ M @ N2 )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X: int] : X
          @ ( set_or1337092689740270186AtMost @ int @ M @ N2 ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N2 @ ( plus_plus @ int @ N2 @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_4853_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_4854_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I3 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% choose_odd_sum
thf(fact_4855_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I3 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% choose_even_sum
thf(fact_4856_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_4857_Maclaurin__minus__cos__expansion,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ? [T4: real] :
            ( ( ord_less @ real @ X2 @ T4 )
            & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X2 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_4858_Maclaurin__cos__expansion2,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X2 )
            & ( ( cos @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X2 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_4859_Maclaurin__sin__expansion3,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X2 )
            & ( ( sin @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X2 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_4860_of__nat__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( ^ [N: nat] : N ) ) ).

% of_nat_id
thf(fact_4861_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I @ K ) ) ) ).

% lessThan_iff
thf(fact_4862_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X2 ) @ ( set_ord_lessThan @ A @ Y2 ) )
          = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% lessThan_subset_iff
thf(fact_4863_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_4864_single__Diff__lessThan,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A] :
          ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ K @ ( bot_bot @ ( set @ A ) ) ) @ ( set_ord_lessThan @ A @ K ) )
          = ( insert @ A @ K @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% single_Diff_lessThan
thf(fact_4865_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% sum.lessThan_Suc
thf(fact_4866_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_4867_sumr__cos__zero__one,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M3 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_4868_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X: A] : ( ord_less @ A @ X @ U2 ) ) ) ) ) ).

% lessThan_def
thf(fact_4869_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: A,N2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M ) @ ( set_ord_lessThan @ A @ N2 ) )
          = ( ord_less @ A @ M @ N2 ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_4870_lessThan__Suc__atMost,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( set_ord_atMost @ nat @ K ) ) ).

% lessThan_Suc_atMost
thf(fact_4871_lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( insert @ nat @ K @ ( set_ord_lessThan @ nat @ K ) ) ) ).

% lessThan_Suc
thf(fact_4872_lessThan__empty__iff,axiom,
    ! [N2: nat] :
      ( ( ( set_ord_lessThan @ nat @ N2 )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_4873_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_4874_lessThan__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_lessThan @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_ord_lessThan @ nat @ ( pred_numeral @ K ) ) ) ) ).

% lessThan_nat_numeral
thf(fact_4875_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ N2 @ ( suc @ I3 ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.nat_diff_reindex
thf(fact_4876_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ N2 @ ( suc @ I3 ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.nat_diff_reindex
thf(fact_4877_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N2: A] :
          ( ! [X3: A] : ( ord_less_eq @ nat @ ( Q @ X3 ) @ ( P @ X3 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N2 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N2 ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X: A] : ( minus_minus @ nat @ ( P @ X ) @ ( Q @ X ) )
              @ ( set_ord_lessThan @ A @ N2 ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_4878_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X2: A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X2 )
           => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ X2 ) ) ) ) ).

% suminf_le_const
thf(fact_4879_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_4880_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: nat > A,N2: nat,R: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ R ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ ( F2 @ I3 ) @ R )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_4881_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ N ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_4882_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_4883_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X2: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X2 )
           => ( summable @ A @ F2 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_4884_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_4885_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_4886_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N2: nat,S2: A] :
          ( ( sums @ A
            @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N2 ) )
            @ S2 )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% sums_iff_shift
thf(fact_4887_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N2: nat,S2: A] :
          ( ( sums @ A
            @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N2 ) )
            @ ( minus_minus @ A @ S2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) )
          = ( sums @ A @ F2 @ S2 ) ) ) ).

% sums_iff_shift'
thf(fact_4888_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S2: A,N2: nat] :
          ( ( sums @ A @ F2 @ S2 )
         => ( sums @ A
            @ ^ [I3: nat] : ( F2 @ ( plus_plus @ nat @ I3 @ N2 ) )
            @ ( minus_minus @ A @ S2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% sums_split_initial_segment
thf(fact_4889_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( F2 @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_4890_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_4891_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I3 ) @ ( set_ord_lessThan @ nat @ I3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J2 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J2 ) @ N2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.nested_swap'
thf(fact_4892_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I3 ) @ ( set_ord_lessThan @ nat @ I3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J2 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J2 ) @ N2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.nested_swap'
thf(fact_4893_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X2 @ N2 ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_4894_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_4895_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,N2: nat] :
          ( ( X2
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X2 @ N2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_4896_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_4897_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_4898_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A @ F2 )
            = ( plus_plus @ A
              @ ( suminf @ A
                @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_split_initial_segment
thf(fact_4899_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_minus_initial_segment
thf(fact_4900_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N2 @ M4 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_4901_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( ( X2
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ N2 ) ) )
          & ( ( X2
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ N2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_4902_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z: A,H2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P4: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M @ P4 ) ) @ ( power_power @ A @ Z @ P4 ) ) @ ( power_power @ A @ Z @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P4: nat] : ( times_times @ A @ ( power_power @ A @ Z @ P4 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M @ P4 ) ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ M @ P4 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_4903_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat,Y2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Y2 @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P4: nat] : ( times_times @ A @ ( power_power @ A @ X2 @ P4 ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N2 @ P4 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_4904_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat,Y2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N2 @ ( suc @ I3 ) ) ) @ ( power_power @ A @ X2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_4905_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N2: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ A2 @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) )
         => ~ ! [B6: nat > A] :
                ~ ! [Z2: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z2 @ I3 ) )
                      @ ( set_ord_atMost @ nat @ N2 ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z2 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( B6 @ I3 ) @ ( power_power @ A @ Z2 @ I3 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_4906_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N2: nat,A2: A] :
        ? [B6: nat > A] :
        ! [Z2: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z2 @ I3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z2 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( B6 @ I3 ) @ ( power_power @ A @ Z2 @ I3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ A2 @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_4907_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,F2: nat > A,K5: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N2 )
             => ( ord_less_eq @ A @ ( F2 @ P7 ) @ K5 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K5 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ K5 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_4908_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N2: nat,I: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N2 @ M4 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ( ord_less_eq @ nat @ N2 @ I )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_4909_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( power_power @ A @ X2 @ ( minus_minus @ nat @ N2 @ ( suc @ I3 ) ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_4910_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X2: real,N2: nat,Diff: nat > A > real] :
          ( ( X2
            = ( zero_zero @ real ) )
         => ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X2 @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_4911_Maclaurin__lemma,axiom,
    ! [H2: real,F2: real > real,J: nat > real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ? [B9: real] :
          ( ( F2 @ H2 )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) )
            @ ( times_times @ real @ B9 @ ( divide_divide @ real @ ( power_power @ real @ H2 @ N2 ) @ ( semiring_char_0_fact @ real @ N2 ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_4912_sum__split__even__odd,axiom,
    ! [F2: nat > real,G: nat > real,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) @ ( F2 @ I3 ) @ ( G @ I3 ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I3: nat] : ( F2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) )
          @ ( set_ord_lessThan @ nat @ N2 ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum_split_even_odd
thf(fact_4913_Maclaurin__exp__le,axiom,
    ! [X2: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
      & ( ( exp @ real @ X2 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X2 @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_4914_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,A2: nat > A,X2: A,Y2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ X2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ Y2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J2 @ K3 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y2 @ K3 ) ) @ ( power_power @ A @ X2 @ J2 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ J2 ) ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_4915_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N @ K ) ) ) @ ( power_power @ A @ X @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_4916_Maclaurin__sin__bound,axiom,
    ! [X2: real,N2: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X2 )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X2 @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( abs_abs @ real @ X2 ) @ N2 ) ) ) ).

% Maclaurin_sin_bound
thf(fact_4917_sum__pos__lt__pair,axiom,
    ! [F2: nat > real,K: nat] :
      ( ( summable @ real @ F2 )
     => ( ! [D5: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F2 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D5 ) ) ) @ ( F2 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D5 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F2 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F2 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_4918_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,A2: nat > A,X2: A,Y2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ X2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ Y2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J2: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ ( minus_minus @ nat @ I3 @ J2 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J2 ) @ N2 ) )
                    @ ( power_power @ A @ X2 @ J2 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_4919_Maclaurin__exp__lt,axiom,
    ! [X2: real,N2: nat] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
            & ( ( exp @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X2 @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_4920_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H2: A,Z: A,N2: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H2
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P4: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q4: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ Q4 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ ( minus_minus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q4 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ P4 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_4921_Maclaurin__sin__expansion,axiom,
    ! [X2: real,N2: nat] :
    ? [T4: real] :
      ( ( sin @ real @ X2 )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X2 @ M3 ) )
          @ ( set_ord_lessThan @ nat @ N2 ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_4922_Maclaurin__sin__expansion2,axiom,
    ! [X2: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
      & ( ( sin @ real @ X2 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X2 @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_4923_Maclaurin__cos__expansion,axiom,
    ! [X2: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
      & ( ( cos @ real @ X2 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X2 @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_4924_Maclaurin__sin__expansion4,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ? [T4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ X2 )
          & ( ( sin @ real @ X2 )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X2 @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_4925_bij__betw__roots__unity,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( bij_betw @ nat @ complex
        @ ^ [K3: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K3 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        @ ( set_ord_lessThan @ nat @ N2 )
        @ ( collect @ complex
          @ ^ [Z5: complex] :
              ( ( power_power @ complex @ Z5 @ N2 )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_4926_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I3: A] : ( plus_plus @ A @ I3 @ ( one_one @ A ) )
              @ N
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_4927_Arg__def,axiom,
    ( arg
    = ( ^ [Z5: complex] :
          ( if @ real
          @ ( Z5
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A4: real] :
                ( ( ( sgn_sgn @ complex @ Z5 )
                  = ( cis @ A4 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A4 )
                & ( ord_less_eq @ real @ A4 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_4928_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N2: nat,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N2 ) @ I )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N2 @ ( Inc @ I ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_4929_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I )
          = I ) ) ).

% of_nat_aux.simps(1)
thf(fact_4930_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S4: set @ B,T6: set @ C,H2: B > C,S: set @ B,T5: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S @ S4 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ S4 )
                   => ( ( G @ ( H2 @ A6 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ T6 )
                     => ( ( G @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X: B] : ( G @ ( H2 @ X ) )
                      @ S )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G @ T5 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_4931_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S4: set @ B,T6: set @ C,H2: B > C,S: set @ B,T5: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S @ S4 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ S4 )
                   => ( ( G @ ( H2 @ A6 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ T6 )
                     => ( ( G @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X: B] : ( G @ ( H2 @ X ) )
                      @ S )
                    = ( groups7121269368397514597t_prod @ C @ A @ G @ T5 ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_4932_infinite__imp__bij__betw,axiom,
    ! [A: $tType,A3: set @ A,A2: A] :
      ( ~ ( finite_finite @ A @ A3 )
     => ? [H4: A > A] : ( bij_betw @ A @ A @ H4 @ A3 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_imp_bij_betw
thf(fact_4933_divmod__BitM__2__eq,axiom,
    ! [M: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_4934_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_4935_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_4936_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_4937_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_4938_semiring__norm_I28_J,axiom,
    ! [N2: num] :
      ( ( bitM @ ( bit1 @ N2 ) )
      = ( bit1 @ ( bit0 @ N2 ) ) ) ).

% semiring_norm(28)
thf(fact_4939_semiring__norm_I27_J,axiom,
    ! [N2: num] :
      ( ( bitM @ ( bit0 @ N2 ) )
      = ( bit1 @ ( bitM @ N2 ) ) ) ).

% semiring_norm(27)
thf(fact_4940_inc__BitM__eq,axiom,
    ! [N2: num] :
      ( ( inc @ ( bitM @ N2 ) )
      = ( bit0 @ N2 ) ) ).

% inc_BitM_eq
thf(fact_4941_BitM__inc__eq,axiom,
    ! [N2: num] :
      ( ( bitM @ ( inc @ N2 ) )
      = ( bit1 @ N2 ) ) ).

% BitM_inc_eq
thf(fact_4942_option_Osize__neq,axiom,
    ! [A: $tType,X2: option @ A] :
      ( ( size_size @ ( option @ A ) @ X2 )
     != ( zero_zero @ nat ) ) ).

% option.size_neq
thf(fact_4943_eval__nat__numeral_I2_J,axiom,
    ! [N2: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N2 ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N2 ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_4944_BitM__plus__one,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ ( bitM @ N2 ) @ one2 )
      = ( bit0 @ N2 ) ) ).

% BitM_plus_one
thf(fact_4945_one__plus__BitM,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N2 ) )
      = ( bit0 @ N2 ) ) ).

% one_plus_BitM
thf(fact_4946_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N2 ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_4947_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [W: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bitM @ W ) ) ) ) ).

% odd_numeral_BitM
thf(fact_4948_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bitM @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) ) ) ) ).

% not_numeral_BitM_eq
thf(fact_4949_dependent__nat__choice,axiom,
    ! [A: $tType,P: nat > A > $o,Q: nat > A > A > $o] :
      ( ? [X_12: A] : ( P @ ( zero_zero @ nat ) @ X_12 )
     => ( ! [X3: A,N3: nat] :
            ( ( P @ N3 @ X3 )
           => ? [Y4: A] :
                ( ( P @ ( suc @ N3 ) @ Y4 )
                & ( Q @ N3 @ X3 @ Y4 ) ) )
       => ? [F5: nat > A] :
          ! [N7: nat] :
            ( ( P @ N7 @ ( F5 @ N7 ) )
            & ( Q @ N7 @ ( F5 @ N7 ) @ ( F5 @ ( suc @ N7 ) ) ) ) ) ) ).

% dependent_nat_choice
thf(fact_4950_option_Osize_I4_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_4951_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N2: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N2 @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4952_or__minus__numerals_I5_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_4953_or__minus__numerals_I1_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_4954_real__root__zero,axiom,
    ! [N2: nat] :
      ( ( root @ N2 @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_4955_real__root__Suc__0,axiom,
    ! [X2: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X2 )
      = X2 ) ).

% real_root_Suc_0
thf(fact_4956_real__root__eq__iff,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X2 )
          = ( root @ N2 @ Y2 ) )
        = ( X2 = Y2 ) ) ) ).

% real_root_eq_iff
thf(fact_4957_root__0,axiom,
    ! [X2: real] :
      ( ( root @ ( zero_zero @ nat ) @ X2 )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_4958_real__root__eq__0__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X2 )
          = ( zero_zero @ real ) )
        = ( X2
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_4959_real__root__less__iff,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less @ real @ X2 @ Y2 ) ) ) ).

% real_root_less_iff
thf(fact_4960_real__root__le__iff,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ).

% real_root_le_iff
thf(fact_4961_real__root__eq__1__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X2 )
          = ( one_one @ real ) )
        = ( X2
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_4962_real__root__one,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_4963_real__root__lt__0__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_4964_real__root__gt__0__iff,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y2 ) ) ) ).

% real_root_gt_0_iff
thf(fact_4965_real__root__le__0__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_4966_real__root__ge__0__iff,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 ) ) ) ).

% real_root_ge_0_iff
thf(fact_4967_real__root__lt__1__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_4968_real__root__gt__1__iff,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y2 ) ) ) ).

% real_root_gt_1_iff
thf(fact_4969_real__root__le__1__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_4970_real__root__ge__1__iff,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 ) ) ) ).

% real_root_ge_1_iff
thf(fact_4971_real__root__pow__pos2,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( power_power @ real @ ( root @ N2 @ X2 ) @ N2 )
          = X2 ) ) ) ).

% real_root_pow_pos2
thf(fact_4972_or__minus__numerals_I4_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N2 ) ) ) ) ) ).

% or_minus_numerals(4)
thf(fact_4973_or__minus__numerals_I8_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N2 ) ) ) ) ) ).

% or_minus_numerals(8)
thf(fact_4974_or__minus__numerals_I7_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(7)
thf(fact_4975_or__minus__numerals_I3_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(3)
thf(fact_4976_real__root__inverse,axiom,
    ! [N2: nat,X2: real] :
      ( ( root @ N2 @ ( inverse_inverse @ real @ X2 ) )
      = ( inverse_inverse @ real @ ( root @ N2 @ X2 ) ) ) ).

% real_root_inverse
thf(fact_4977_real__root__commute,axiom,
    ! [M: nat,N2: nat,X2: real] :
      ( ( root @ M @ ( root @ N2 @ X2 ) )
      = ( root @ N2 @ ( root @ M @ X2 ) ) ) ).

% real_root_commute
thf(fact_4978_real__root__mult,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( root @ N2 @ ( times_times @ real @ X2 @ Y2 ) )
      = ( times_times @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) ) ) ).

% real_root_mult
thf(fact_4979_real__root__mult__exp,axiom,
    ! [M: nat,N2: nat,X2: real] :
      ( ( root @ ( times_times @ nat @ M @ N2 ) @ X2 )
      = ( root @ M @ ( root @ N2 @ X2 ) ) ) ).

% real_root_mult_exp
thf(fact_4980_real__root__divide,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( root @ N2 @ ( divide_divide @ real @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) ) ) ).

% real_root_divide
thf(fact_4981_or__not__num__neg_Osimps_I1_J,axiom,
    ( ( bit_or_not_num_neg @ one2 @ one2 )
    = one2 ) ).

% or_not_num_neg.simps(1)
thf(fact_4982_real__root__minus,axiom,
    ! [N2: nat,X2: real] :
      ( ( root @ N2 @ ( uminus_uminus @ real @ X2 ) )
      = ( uminus_uminus @ real @ ( root @ N2 @ X2 ) ) ) ).

% real_root_minus
thf(fact_4983_real__root__pos__pos__le,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X2 ) ) ) ).

% real_root_pos_pos_le
thf(fact_4984_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N2: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ one2 )
      = ( bit0 @ one2 ) ) ).

% or_not_num_neg.simps(4)
thf(fact_4985_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ ( bit1 @ M ) )
      = ( bit0 @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(6)
thf(fact_4986_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit1 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(3)
thf(fact_4987_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N2: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ one2 )
      = one2 ) ).

% or_not_num_neg.simps(7)
thf(fact_4988_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(5)
thf(fact_4989_real__root__less__mono,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) ) ) ) ).

% real_root_less_mono
thf(fact_4990_real__root__le__mono,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) ) ) ) ).

% real_root_le_mono
thf(fact_4991_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ ( bit1 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(9)
thf(fact_4992_real__root__power,axiom,
    ! [N2: nat,X2: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( power_power @ real @ X2 @ K ) )
        = ( power_power @ real @ ( root @ N2 @ X2 ) @ K ) ) ) ).

% real_root_power
thf(fact_4993_real__root__abs,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( abs_abs @ real @ X2 ) )
        = ( abs_abs @ real @ ( root @ N2 @ X2 ) ) ) ) ).

% real_root_abs
thf(fact_4994_sgn__root,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( sgn_sgn @ real @ ( root @ N2 @ X2 ) )
        = ( sgn_sgn @ real @ X2 ) ) ) ).

% sgn_root
thf(fact_4995_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit0 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(2)
thf(fact_4996_real__root__gt__zero,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X2 ) ) ) ) ).

% real_root_gt_zero
thf(fact_4997_real__root__strict__decreasing,axiom,
    ! [N2: nat,N5: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ N2 @ N5 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
         => ( ord_less @ real @ ( root @ N5 @ X2 ) @ ( root @ N2 @ X2 ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_4998_sqrt__def,axiom,
    ( sqrt
    = ( root @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% sqrt_def
thf(fact_4999_root__abs__power,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( abs_abs @ real @ ( root @ N2 @ ( power_power @ real @ Y2 @ N2 ) ) )
        = ( abs_abs @ real @ Y2 ) ) ) ).

% root_abs_power
thf(fact_5000_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(8)
thf(fact_5001_real__root__pos__pos,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X2 ) ) ) ) ).

% real_root_pos_pos
thf(fact_5002_real__root__strict__increasing,axiom,
    ! [N2: nat,N5: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ N2 @ N5 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( root @ N5 @ X2 ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_5003_real__root__decreasing,axiom,
    ! [N2: nat,N5: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ N5 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
         => ( ord_less_eq @ real @ ( root @ N5 @ X2 ) @ ( root @ N2 @ X2 ) ) ) ) ) ).

% real_root_decreasing
thf(fact_5004_real__root__pow__pos,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( power_power @ real @ ( root @ N2 @ X2 ) @ N2 )
          = X2 ) ) ) ).

% real_root_pow_pos
thf(fact_5005_real__root__power__cancel,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( root @ N2 @ ( power_power @ real @ X2 @ N2 ) )
          = X2 ) ) ) ).

% real_root_power_cancel
thf(fact_5006_real__root__pos__unique,axiom,
    ! [N2: nat,Y2: real,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( power_power @ real @ Y2 @ N2 )
            = X2 )
         => ( ( root @ N2 @ X2 )
            = Y2 ) ) ) ) ).

% real_root_pos_unique
thf(fact_5007_odd__real__root__power__cancel,axiom,
    ! [N2: nat,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( root @ N2 @ ( power_power @ real @ X2 @ N2 ) )
        = X2 ) ) ).

% odd_real_root_power_cancel
thf(fact_5008_odd__real__root__unique,axiom,
    ! [N2: nat,Y2: real,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( ( power_power @ real @ Y2 @ N2 )
          = X2 )
       => ( ( root @ N2 @ X2 )
          = Y2 ) ) ) ).

% odd_real_root_unique
thf(fact_5009_odd__real__root__pow,axiom,
    ! [N2: nat,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( power_power @ real @ ( root @ N2 @ X2 ) @ N2 )
        = X2 ) ) ).

% odd_real_root_pow
thf(fact_5010_or__not__num__neg_Oelims,axiom,
    ! [X2: num,Xa: num,Y2: num] :
      ( ( ( bit_or_not_num_neg @ X2 @ Xa )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y2 != one2 ) ) )
       => ( ( ( X2 = one2 )
           => ! [M4: num] :
                ( ( Xa
                  = ( bit0 @ M4 ) )
               => ( Y2
                 != ( bit1 @ M4 ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [M4: num] :
                  ( ( Xa
                    = ( bit1 @ M4 ) )
                 => ( Y2
                   != ( bit1 @ M4 ) ) ) )
           => ( ( ? [N3: num] :
                    ( X2
                    = ( bit0 @ N3 ) )
               => ( ( Xa = one2 )
                 => ( Y2
                   != ( bit0 @ one2 ) ) ) )
             => ( ! [N3: num] :
                    ( ( X2
                      = ( bit0 @ N3 ) )
                   => ! [M4: num] :
                        ( ( Xa
                          = ( bit0 @ M4 ) )
                       => ( Y2
                         != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X2
                        = ( bit0 @ N3 ) )
                     => ! [M4: num] :
                          ( ( Xa
                            = ( bit1 @ M4 ) )
                         => ( Y2
                           != ( bit0 @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                 => ( ( ? [N3: num] :
                          ( X2
                          = ( bit1 @ N3 ) )
                     => ( ( Xa = one2 )
                       => ( Y2 != one2 ) ) )
                   => ( ! [N3: num] :
                          ( ( X2
                            = ( bit1 @ N3 ) )
                         => ! [M4: num] :
                              ( ( Xa
                                = ( bit0 @ M4 ) )
                             => ( Y2
                               != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                     => ~ ! [N3: num] :
                            ( ( X2
                              = ( bit1 @ N3 ) )
                           => ! [M4: num] :
                                ( ( Xa
                                  = ( bit1 @ M4 ) )
                               => ( Y2
                                 != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
thf(fact_5011_numeral__or__not__num__eq,axiom,
    ! [M: num,N2: num] :
      ( ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N2 ) )
      = ( uminus_uminus @ int @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% numeral_or_not_num_eq
thf(fact_5012_int__numeral__not__or__num__neg,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ) ).

% int_numeral_not_or_num_neg
thf(fact_5013_int__numeral__or__not__num__neg,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N2 ) ) ) ) ).

% int_numeral_or_not_num_neg
thf(fact_5014_real__root__increasing,axiom,
    ! [N2: nat,N5: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ N5 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( root @ N5 @ X2 ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_5015_sgn__power__root,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N2 @ X2 ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N2 @ X2 ) ) @ N2 ) )
        = X2 ) ) ).

% sgn_power_root
thf(fact_5016_root__sgn__power,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( times_times @ real @ ( sgn_sgn @ real @ Y2 ) @ ( power_power @ real @ ( abs_abs @ real @ Y2 ) @ N2 ) ) )
        = Y2 ) ) ).

% root_sgn_power
thf(fact_5017_ln__root,axiom,
    ! [N2: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N2 @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% ln_root
thf(fact_5018_log__root,axiom,
    ! [N2: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log @ B2 @ ( root @ N2 @ A2 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_root
thf(fact_5019_log__base__root,axiom,
    ! [N2: nat,B2: real,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N2 @ B2 ) @ X2 )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ X2 ) ) ) ) ) ).

% log_base_root
thf(fact_5020_split__root,axiom,
    ! [P: real > $o,N2: nat,X2: real] :
      ( ( P @ ( root @ N2 @ X2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ! [Y: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N2 ) )
                = X2 )
             => ( P @ Y ) ) ) ) ) ).

% split_root
thf(fact_5021_root__powr__inverse,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( root @ N2 @ X2 )
          = ( powr @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_5022_vebt__buildup_Opelims,axiom,
    ! [X2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X2 )
        = Y2 )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X2 )
       => ( ( ( X2
              = ( zero_zero @ nat ) )
           => ( ( Y2
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X2
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y2
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va: nat] :
                  ( ( X2
                    = ( suc @ ( suc @ Va ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y2
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y2
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_5023_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N2 ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_5024_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X2: A > nat,X22: A] :
      ( ( size_option @ A @ X2 @ ( some @ A @ X22 ) )
      = ( plus_plus @ nat @ ( X2 @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_5025_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N2 ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_5026_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X2: A > nat] :
      ( ( size_option @ A @ X2 @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_5027_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q4: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_5028_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q4: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_5029_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q4: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_5030_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M3 @ N ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M3 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q4: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q4 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M3 @ N ) @ N ) ) ) ) ) ).

% divmod_nat_if
thf(fact_5031_arctan__def,axiom,
    ( arctan
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
              & ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X )
                = Y ) ) ) ) ) ).

% arctan_def
thf(fact_5032_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
              & ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X )
                = Y ) ) ) ) ) ).

% arcsin_def
thf(fact_5033_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J2: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K3 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_5034_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J2: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K3 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_5035_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J2: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K3 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.triangle_reindex
thf(fact_5036_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J2: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K3 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.triangle_reindex
thf(fact_5037_ln__neg__is__const,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X2 )
        = ( the @ real
          @ ^ [X: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_5038_arccos__def,axiom,
    ( arccos
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
              & ( ord_less_eq @ real @ X @ pi )
              & ( ( cos @ real @ X )
                = Y ) ) ) ) ) ).

% arccos_def
thf(fact_5039_divmod__nat__def,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N: nat] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ M3 @ N ) @ ( modulo_modulo @ nat @ M3 @ N ) ) ) ) ).

% divmod_nat_def
thf(fact_5040_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
          & ( ord_less_eq @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_5041_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
            & ( ord_less_eq @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_5042_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N: nat] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M3: nat,Q4: nat] :
                    ( if @ A
                    @ ( Q4
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_5043_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F3: set @ A,I5: set @ A,F2: A > B,I: A] :
          ( ( finite_finite @ A @ F3 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I3: A] :
                    ( ( member @ A @ I3 @ I5 )
                    & ( ( F2 @ I3 )
                     != ( zero_zero @ B ) ) ) )
              @ F3 )
           => ( ( ( member @ A @ I @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I ) ) ) )
              & ( ~ ( member @ A @ I @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_5044_Sum__Ico__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X: nat] : X
        @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_5045_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L2: A,U: A] :
          ( ( member @ A @ I @ ( set_or7035219750837199246ssThan @ A @ L2 @ U ) )
          = ( ( ord_less_eq @ A @ L2 @ I )
            & ( ord_less @ A @ I @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_5046_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_5047_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,J: A,M: A,N2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ J ) @ ( set_or7035219750837199246ssThan @ A @ M @ N2 ) )
          = ( ( ord_less_eq @ A @ J @ I )
            | ( ( ord_less_eq @ A @ M @ I )
              & ( ord_less_eq @ A @ J @ N2 ) ) ) ) ) ).

% ivl_subset
thf(fact_5048_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_5049_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_5050_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_5051_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,N2: A,M: A] :
          ( ( ord_less_eq @ A @ I @ N2 )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ M ) @ ( set_or7035219750837199246ssThan @ A @ I @ N2 ) )
            = ( set_or7035219750837199246ssThan @ A @ N2 @ M ) ) ) ) ).

% ivl_diff
thf(fact_5052_lessThan__minus__lessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N2: A,M: A] :
          ( ( minus_minus @ ( set @ A ) @ ( set_ord_lessThan @ A @ N2 ) @ ( set_ord_lessThan @ A @ M ) )
          = ( set_or7035219750837199246ssThan @ A @ M @ N2 ) ) ) ).

% lessThan_minus_lessThan
thf(fact_5053_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P2: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P2 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_5054_atLeastLessThan__singleton,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ M ) )
      = ( insert @ nat @ M @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atLeastLessThan_singleton
thf(fact_5055_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,P2: B > A,I: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X: B] :
                  ( ( member @ B @ X @ I5 )
                  & ( ( P2 @ X )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P2 @ ( insert @ B @ I @ I5 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P2 @ I5 ) ) )
            & ( ~ ( member @ B @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P2 @ ( insert @ B @ I @ I5 ) )
                = ( plus_plus @ A @ ( P2 @ I ) @ ( groups1027152243600224163dd_sum @ B @ A @ P2 @ I5 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_5056_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_5057_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_5058_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,I5: set @ B] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ G
            @ ( collect @ B
              @ ^ [X: B] :
                  ( ( member @ B @ X @ I5 )
                  & ( ( G @ X )
                   != ( zero_zero @ A ) ) ) ) )
          = ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) ) ) ).

% sum.non_neutral'
thf(fact_5059_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D3 )
             => ( B2 = D3 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_5060_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D3 )
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_5061_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D3 ) )
              = ( ( A2 = C2 )
                & ( B2 = D3 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_5062_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D3 ) )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D3 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_5063_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_5064_ex__nat__less__eq,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N2 )
            & ( P @ M3 ) ) )
      = ( ? [X: nat] :
            ( ( member @ nat @ X @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
            & ( P @ X ) ) ) ) ).

% ex_nat_less_eq
thf(fact_5065_all__nat__less__eq,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N2 )
           => ( P @ M3 ) ) )
      = ( ! [X: nat] :
            ( ( member @ nat @ X @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
           => ( P @ X ) ) ) ) ).

% all_nat_less_eq
thf(fact_5066_atLeastLessThanSuc__atLeastAtMost,axiom,
    ! [L2: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ L2 @ ( suc @ U ) )
      = ( set_or1337092689740270186AtMost @ nat @ L2 @ U ) ) ).

% atLeastLessThanSuc_atLeastAtMost
thf(fact_5067_lessThan__atLeast0,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) ) ) ).

% lessThan_atLeast0
thf(fact_5068_atLeastLessThan0,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_5069_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_Suc_ivl
thf(fact_5070_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_5071_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_Suc_ivl
thf(fact_5072_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_5073_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I3: B] : ( plus_plus @ A @ ( G @ I3 ) @ ( H2 @ I3 ) )
              @ I5 )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I5 ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_5074_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D3: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D3 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D3 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D3 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_5075_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D3: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D3 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D3 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D3 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_5076_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,P2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P2 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P2 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_5077_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,P2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P2 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P2 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_5078_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,P2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P2 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P2 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P2 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_5079_atLeast0__lessThan__Suc,axiom,
    ! [N2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ N2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% atLeast0_lessThan_Suc
thf(fact_5080_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N5: set @ nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
     => ( finite_finite @ nat @ N5 ) ) ).

% subset_eq_atLeast0_lessThan_finite
thf(fact_5081_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ T5 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_5082_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T5 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ S ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_5083_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,T5: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
               => ( ( H2 @ I4 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ T5 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_5084_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,T5: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T5 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ S ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_5085_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D3 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D3 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_5086_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D3 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_5087_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
thf(fact_5088_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_5089_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_5090_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_5091_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X: B] :
                  ( ( member @ B @ X @ I5 )
                  & ( ( G @ X )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X: B] :
                    ( ( member @ B @ X @ I5 )
                    & ( ( H2 @ X )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I3: B] : ( plus_plus @ A @ ( G @ I3 ) @ ( H2 @ I3 ) )
                @ I5 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I5 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_5092_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or7035219750837199246ssThan @ A )
        = ( ^ [A4: A,B3: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
thf(fact_5093_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_5094_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_5095_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_5096_sum_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ B @ A )
        = ( ^ [P4: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X: B] :
                      ( ( member @ B @ X @ I7 )
                      & ( ( P4 @ X )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( groups7311177749621191930dd_sum @ B @ A @ P4
                @ ( collect @ B
                  @ ^ [X: B] :
                      ( ( member @ B @ X @ I7 )
                      & ( ( P4 @ X )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( zero_zero @ A ) ) ) ) ) ).

% sum.G_def
thf(fact_5097_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ N2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_5098_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ N2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_5099_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_5100_atLeastLessThanSuc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) )
          = ( insert @ nat @ N2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N2 )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_5101_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( suc @ I3 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_5102_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J2 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J2 ) @ N2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% sum.nested_swap
thf(fact_5103_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( suc @ I3 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_5104_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J2 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J2 ) @ N2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% prod.nested_swap
thf(fact_5105_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N2 @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_5106_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N2 @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_5107_prod__Suc__fact,axiom,
    ! [N2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( semiring_char_0_fact @ nat @ N2 ) ) ).

% prod_Suc_fact
thf(fact_5108_prod__Suc__Suc__fact,axiom,
    ! [N2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
      = ( semiring_char_0_fact @ nat @ N2 ) ) ).

% prod_Suc_Suc_fact
thf(fact_5109_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% sum.head_if
thf(fact_5110_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% prod.head_if
thf(fact_5111_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% fact_prod_Suc
thf(fact_5112_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_5113_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_5114_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ I3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% pochhammer_prod
thf(fact_5115_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_5116_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_5117_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F4: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ M3 )
                 => ! [N: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F4 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N ) ) ) @ E3 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_5118_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A,S2: A,K: nat] :
          ( ( sums @ A @ F2 @ S2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N @ K ) @ K ) ) )
              @ S2 ) ) ) ) ).

% sums_group
thf(fact_5119_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A4: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( bit_se4730199178511100633sh_bit @ A @ K3 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ K3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% take_bit_sum
thf(fact_5120_atLeast1__lessThan__eq__remove0,axiom,
    ! [N2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N2 ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_5121_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_char_0_fact @ A @ N2 )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N2 @ K ) @ N2 ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_5122_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I3 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_5123_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I3 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K3 @ I3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_5124_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_5125_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_5126_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I3 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) )
              @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_5127_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I5: set @ A,F2: A > B,I: A] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [I3: A] :
                  ( ( member @ A @ I3 @ I5 )
                  & ( ( F2 @ I3 )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I ) ) ) )
            & ( ~ ( member @ A @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_5128_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_5129_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F4: B > A,A4: A,Xs: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F4 @ ( nth @ B @ Xs @ N ) ) @ ( power_power @ A @ A4 @ N ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_5130_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: nat > A,B2: nat > A] :
          ( ! [I4: nat,J3: nat] :
              ( ( ord_less_eq @ nat @ I4 @ J3 )
             => ( ( ord_less @ nat @ J3 @ N2 )
               => ( ord_less_eq @ A @ ( A2 @ I4 ) @ ( A2 @ J3 ) ) ) )
         => ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ N2 )
                 => ( ord_less_eq @ A @ ( B2 @ J3 ) @ ( B2 @ I4 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ K3 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_5131_Chebyshev__sum__upper__nat,axiom,
    ! [N2: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I4: nat,J3: nat] :
          ( ( ord_less_eq @ nat @ I4 @ J3 )
         => ( ( ord_less @ nat @ J3 @ N2 )
           => ( ord_less_eq @ nat @ ( A2 @ I4 ) @ ( A2 @ J3 ) ) ) )
     => ( ! [I4: nat,J3: nat] :
            ( ( ord_less_eq @ nat @ I4 @ J3 )
           => ( ( ord_less @ nat @ J3 @ N2 )
             => ( ord_less_eq @ nat @ ( B2 @ J3 ) @ ( B2 @ I4 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N2
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I3: nat] : ( times_times @ nat @ ( A2 @ I3 ) @ ( B2 @ I3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_5132_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( finite_finite @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) ) ).

% finite_atLeastZeroLessThan_int
thf(fact_5133_atLeastLessThanPlusOne__atLeastAtMost__int,axiom,
    ! [L2: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ L2 @ ( plus_plus @ int @ U @ ( one_one @ int ) ) )
      = ( set_or1337092689740270186AtMost @ int @ L2 @ U ) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_int
thf(fact_5134_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_5135_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_5136_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D3: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D3 )
     => ( vEBT_VEBT_valid @ T2 @ D3 ) ) ).

% valid_eq1
thf(fact_5137_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D3: nat] :
      ( ( vEBT_VEBT_valid @ T2 @ D3 )
     => ( vEBT_invar_vebt @ T2 @ D3 ) ) ).

% valid_eq2
thf(fact_5138_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,D3: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu @ Uv ) @ D3 )
      = ( D3
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_5139_size__list__estimation,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A,Y2: nat,F2: A > nat] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less @ nat @ Y2 @ ( F2 @ X2 ) )
       => ( ord_less @ nat @ Y2 @ ( size_list @ A @ F2 @ Xs2 ) ) ) ) ).

% size_list_estimation
thf(fact_5140_size__list__estimation_H,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A,Y2: nat,F2: A > nat] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ Y2 @ ( F2 @ X2 ) )
       => ( ord_less_eq @ nat @ Y2 @ ( size_list @ A @ F2 @ Xs2 ) ) ) ) ).

% size_list_estimation'
thf(fact_5141_size__list__pointwise,axiom,
    ! [A: $tType,Xs2: list @ A,F2: A > nat,G: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
         => ( ord_less_eq @ nat @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs2 ) @ ( size_list @ A @ G @ Xs2 ) ) ) ).

% size_list_pointwise
thf(fact_5142_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_5143_length__subseqs,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_subseqs
thf(fact_5144_Code__Target__Int_Opositive__def,axiom,
    ( code_Target_positive
    = ( numeral_numeral @ int ) ) ).

% Code_Target_Int.positive_def
thf(fact_5145_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_5146_length__mul__elem,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),N2: nat] :
      ( ! [X3: list @ A] :
          ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xs2 ) )
         => ( ( size_size @ ( list @ A ) @ X3 )
            = N2 ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs2 ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) @ N2 ) ) ) ).

% length_mul_elem
thf(fact_5147_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q4: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_5148_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A4: B] :
                      ( ( member @ B @ A4 @ A3 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ A4 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_5149_card__Collect__less__nat,axiom,
    ! [N2: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N2 ) ) )
      = N2 ) ).

% card_Collect_less_nat
thf(fact_5150_card__atMost,axiom,
    ! [U: nat] :
      ( ( finite_card @ nat @ ( set_ord_atMost @ nat @ U ) )
      = ( suc @ U ) ) ).

% card_atMost
thf(fact_5151_card__atLeastLessThan,axiom,
    ! [L2: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or7035219750837199246ssThan @ nat @ L2 @ U ) )
      = ( minus_minus @ nat @ U @ L2 ) ) ).

% card_atLeastLessThan
thf(fact_5152_card__Collect__le__nat,axiom,
    ! [N2: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I3: nat] : ( ord_less_eq @ nat @ I3 @ N2 ) ) )
      = ( suc @ N2 ) ) ).

% card_Collect_le_nat
thf(fact_5153_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_5154_card_Oinfinite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( finite_finite @ A @ A3 )
     => ( ( finite_card @ A @ A3 )
        = ( zero_zero @ nat ) ) ) ).

% card.infinite
thf(fact_5155_card__atLeastAtMost,axiom,
    ! [L2: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or1337092689740270186AtMost @ nat @ L2 @ U ) )
      = ( minus_minus @ nat @ ( suc @ U ) @ L2 ) ) ).

% card_atLeastAtMost
thf(fact_5156_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y2: A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X: B] : Y2
            @ A3 )
          = ( power_power @ A @ Y2 @ ( finite_card @ B @ A3 ) ) ) ) ).

% prod_constant
thf(fact_5157_card__atLeastLessThan__int,axiom,
    ! [L2: int,U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ L2 @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ L2 ) ) ) ).

% card_atLeastLessThan_int
thf(fact_5158_card__0__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( finite_card @ A @ A3 )
          = ( zero_zero @ nat ) )
        = ( A3
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_5159_card__insert__disjoint,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ~ ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
          = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_insert_disjoint
thf(fact_5160_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y2: A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X: B] : Y2
            @ A3 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ Y2 ) ) ) ).

% sum_constant
thf(fact_5161_card__Diff__insert,axiom,
    ! [A: $tType,A2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ A2 @ B4 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( one_one @ nat ) ) ) ) ) ).

% card_Diff_insert
thf(fact_5162_card__atLeastAtMost__int,axiom,
    ! [L2: int,U: int] :
      ( ( finite_card @ int @ ( set_or1337092689740270186AtMost @ int @ L2 @ U ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ U @ L2 ) @ ( one_one @ int ) ) ) ) ).

% card_atLeastAtMost_int
thf(fact_5163_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K3: code_integer] :
          ( if @ code_integer
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_5164_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_5165_times__integer__code_I2_J,axiom,
    ! [L2: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_5166_plus__integer__code_I2_J,axiom,
    ! [L2: code_integer] :
      ( ( plus_plus @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
      = L2 ) ).

% plus_integer_code(2)
thf(fact_5167_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( plus_plus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% plus_integer_code(1)
thf(fact_5168_less__eq__integer__code_I1_J,axiom,
    ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ).

% less_eq_integer_code(1)
thf(fact_5169_divmod__integer_H__def,axiom,
    ( ( unique8689654367752047608divmod @ code_integer )
    = ( ^ [M3: num,N: num] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N ) ) @ ( modulo_modulo @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N ) ) ) ) ) ).

% divmod_integer'_def
thf(fact_5170_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( minus_minus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% minus_integer_code(1)
thf(fact_5171_minus__integer__code_I2_J,axiom,
    ! [L2: code_integer] :
      ( ( minus_minus @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
      = ( uminus_uminus @ code_integer @ L2 ) ) ).

% minus_integer_code(2)
thf(fact_5172_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B4: set @ A,A3: set @ B,R: B > A > $o] :
      ( ( finite_finite @ A @ B4 )
     => ( ! [A6: B] :
            ( ( member @ B @ A6 @ A3 )
           => ? [B10: A] :
                ( ( member @ A @ B10 @ B4 )
                & ( R @ A6 @ B10 ) ) )
       => ( ! [A13: B,A24: B,B6: A] :
              ( ( member @ B @ A13 @ A3 )
             => ( ( member @ B @ A24 @ A3 )
               => ( ( member @ A @ B6 @ B4 )
                 => ( ( R @ A13 @ B6 )
                   => ( ( R @ A24 @ B6 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_5173_card__insert__le,axiom,
    ! [A: $tType,A3: set @ A,X2: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) ) ) ).

% card_insert_le
thf(fact_5174_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs )
                  = N2 ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A3 ) @ N2 ) ) ) ).

% card_lists_length_eq
thf(fact_5175_card__2__iff_H,axiom,
    ! [A: $tType,S: set @ A] :
      ( ( ( finite_card @ A @ S )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X: A] :
            ( ( member @ A @ X @ S )
            & ? [Y: A] :
                ( ( member @ A @ Y @ S )
                & ( X != Y )
                & ! [Z5: A] :
                    ( ( member @ A @ Z5 @ S )
                   => ( ( Z5 = X )
                      | ( Z5 = Y ) ) ) ) ) ) ) ).

% card_2_iff'
thf(fact_5176_card__eq__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( zero_zero @ nat ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite @ A @ A3 ) ) ) ).

% card_eq_0_iff
thf(fact_5177_card__ge__0__finite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
     => ( finite_finite @ A @ A3 ) ) ).

% card_ge_0_finite
thf(fact_5178_card__insert__if,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( member @ A @ X2 @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( finite_card @ A @ A3 ) ) )
        & ( ~ ( member @ A @ X2 @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_insert_if
thf(fact_5179_card__Suc__eq__finite,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B3: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ B3 @ B8 ) )
            & ~ ( member @ A @ B3 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_Suc_eq_finite
thf(fact_5180_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N2: nat,S: set @ A] :
      ( ( ord_less_eq @ nat @ N2 @ ( finite_card @ A @ S ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S )
           => ( ( ( finite_card @ A @ T7 )
                = N2 )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_5181_card__mono,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ).

% card_mono
thf(fact_5182_card__seteq,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B4 ) @ ( finite_card @ A @ A3 ) )
         => ( A3 = B4 ) ) ) ) ).

% card_seteq
thf(fact_5183_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F3: set @ A,C6: nat] :
      ( ! [G3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G3 @ F3 )
         => ( ( finite_finite @ A @ G3 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G3 ) @ C6 ) ) )
     => ( ( finite_finite @ A @ F3 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F3 ) @ C6 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_5184_card__less__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_5185_card__le__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_5186_card__length,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% card_length
thf(fact_5187_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: A > nat] : ( bij_betw @ A @ nat @ H4 @ M7 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) ) ) ).

% ex_bij_betw_finite_nat
thf(fact_5188_psubset__card__mono,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
       => ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ).

% psubset_card_mono
thf(fact_5189_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) ) ).

% zero_natural.rsp
thf(fact_5190_card__less__Suc2,axiom,
    ! [M7: set @ nat,I: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ ( suc @ K3 ) @ M7 )
                & ( ord_less @ nat @ K3 @ I ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_5191_card__less__Suc,axiom,
    ! [M7: set @ nat,I: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] :
                  ( ( member @ nat @ ( suc @ K3 ) @ M7 )
                  & ( ord_less @ nat @ K3 @ I ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_5192_card__less,axiom,
    ! [M7: set @ nat,I: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_5193_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) )
      = ( nat2 @ U ) ) ).

% card_atLeastZeroLessThan_int
thf(fact_5194_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) ) ).

% zero_integer.rsp
thf(fact_5195_sum__Suc,axiom,
    ! [A: $tType,F2: A > nat,A3: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X: A] : ( suc @ ( F2 @ X ) )
        @ A3 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( finite_card @ A @ A3 ) ) ) ).

% sum_Suc
thf(fact_5196_subset__card__intvl__is__intvl,axiom,
    ! [A3: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) )
     => ( A3
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_5197_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S: set @ A,T5: set @ B,R3: A > B > $o,K: nat] :
      ( ( finite_finite @ A @ S )
     => ( ( finite_finite @ B @ T5 )
       => ( ! [X3: B] :
              ( ( member @ B @ X3 @ T5 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I3: A] :
                        ( ( member @ A @ I3 @ S )
                        & ( R3 @ I3 @ X3 ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I3: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J2: B] :
                        ( ( member @ B @ J2 @ T5 )
                        & ( R3 @ I3 @ J2 ) ) ) )
              @ S )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T5 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_5198_real__of__card,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A3 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X: A] : ( one_one @ real )
        @ A3 ) ) ).

% real_of_card
thf(fact_5199_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,K5: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ K5 @ ( F2 @ I4 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_bounded_below
thf(fact_5200_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_5201_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A3 ) ) ) ).

% card_gt_0_iff
thf(fact_5202_card__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B3: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ B3 @ B8 ) )
            & ~ ( member @ A @ B3 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B8
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_5203_card__eq__SucD,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
     => ? [B6: A,B9: set @ A] :
          ( ( A3
            = ( insert @ A @ B6 @ B9 ) )
          & ~ ( member @ A @ B6 @ B9 )
          & ( ( finite_card @ A @ B9 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B9
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_5204_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X: A] :
            ( A3
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_5205_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X: A] :
              ( ( member @ A @ X @ A3 )
             => ! [Y: A] :
                  ( ( member @ A @ Y @ A3 )
                 => ( X = Y ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_5206_card__le__Suc__iff,axiom,
    ! [A: $tType,N2: nat,A3: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( finite_card @ A @ A3 ) )
      = ( ? [A4: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ A4 @ B8 ) )
            & ~ ( member @ A @ A4 @ B8 )
            & ( ord_less_eq @ nat @ N2 @ ( finite_card @ A @ B8 ) )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_5207_card__Diff1__le,axiom,
    ! [A: $tType,A3: set @ A,X2: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ).

% card_Diff1_le
thf(fact_5208_card__Diff__subset,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ).

% card_Diff_subset
thf(fact_5209_card__psubset,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
         => ( ord_less @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% card_psubset
thf(fact_5210_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_5211_card__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A3 ) ) @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% card_lists_length_le
thf(fact_5212_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite
thf(fact_5213_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N2: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z5: A] :
                    ( ( power_power @ A @ Z5 @ N2 )
                    = ( one_one @ A ) ) ) )
            @ N2 ) ) ) ).

% card_roots_unity
thf(fact_5214_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N5: set @ nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N5 ) @ N2 ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_5215_card__sum__le__nat__sum,axiom,
    ! [S: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X: nat] : X
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X: nat] : X
        @ S ) ) ).

% card_sum_le_nat_sum
thf(fact_5216_card__nth__roots,axiom,
    ! [C2: complex,N2: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z5: complex] :
                  ( ( power_power @ complex @ Z5 @ N2 )
                  = C2 ) ) )
          = N2 ) ) ) ).

% card_nth_roots
thf(fact_5217_card__roots__unity__eq,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = ( one_one @ complex ) ) ) )
        = N2 ) ) ).

% card_roots_unity_eq
thf(fact_5218_card__2__iff,axiom,
    ! [A: $tType,S: set @ A] :
      ( ( ( finite_card @ A @ S )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X: A,Y: A] :
            ( ( S
              = ( insert @ A @ X @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X != Y ) ) ) ) ).

% card_2_iff
thf(fact_5219_card__3__iff,axiom,
    ! [A: $tType,S: set @ A] :
      ( ( ( finite_card @ A @ S )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X: A,Y: A,Z5: A] :
            ( ( S
              = ( insert @ A @ X @ ( insert @ A @ Y @ ( insert @ A @ Z5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X != Y )
            & ( Y != Z5 )
            & ( X != Z5 ) ) ) ) ).

% card_3_iff
thf(fact_5220_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) )
     => ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_5221_card_Oremove,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ A3 )
          = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% card.remove
thf(fact_5222_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
        = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% card.insert_remove
thf(fact_5223_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Suc_Diff1
thf(fact_5224_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) )
      = ( ( finite_finite @ A @ A3 )
        & ( member @ A @ X2 @ A3 ) ) ) ).

% card_Diff1_less_iff
thf(fact_5225_card__Diff2__less,axiom,
    ! [A: $tType,A3: set @ A,X2: A,Y2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ( member @ A @ Y2 @ A3 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_5226_card__Diff1__less,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff1_less
thf(fact_5227_card__Diff__singleton__if,axiom,
    ! [A: $tType,X2: A,A3: set @ A] :
      ( ( ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff_singleton_if
thf(fact_5228_card__Diff__singleton,axiom,
    ! [A: $tType,X2: A,A3: set @ A] :
      ( ( member @ A @ X2 @ A3 )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) ) ).

% card_Diff_singleton
thf(fact_5229_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S: set @ B,F2: B > A,K5: real] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ S )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ K5 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S ) ) @ K5 ) ) ) ) ).

% sum_norm_bound
thf(fact_5230_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,N2: A,K: nat] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) )
                & ( ord_less_eq @ A @ ( F2 @ I4 ) @ N2 ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N2 )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( power_power @ A @ N2 @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_5231_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less @ A @ ( F2 @ I4 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A3 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_5232_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) ) ) )
         => ( ( finite_finite @ B @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_5233_card__insert__le__m1,axiom,
    ! [A: $tType,N2: nat,Y2: set @ A,X2: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y2 ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert @ A @ X2 @ Y2 ) ) @ N2 ) ) ) ).

% card_insert_le_m1
thf(fact_5234_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z5: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z5 @ I3 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) )
                      = ( zero_zero @ A ) ) ) )
              @ N2 ) ) ) ) ).

% polyfun_roots_card
thf(fact_5235_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member @ B @ A2 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_5236_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z5: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z5 @ I3 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z5: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z5 @ I3 ) )
                          @ ( set_ord_atMost @ nat @ N2 ) )
                        = ( zero_zero @ A ) ) ) )
                @ N2 ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_5237_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K3: int] :
          ( if @ code_integer @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K3 ) ) )
          @ ( if @ code_integer
            @ ( K3
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_5238_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A3 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs )
                    = K )
                  & ( distinct @ A @ Xs )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X: nat] : X
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_5239_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A3 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs )
                  = K )
                & ( distinct @ A @ Xs )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X: nat] : X
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_5240_distinct__swap,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A,J: nat] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs2 @ I @ ( nth @ A @ Xs2 @ J ) ) @ J @ ( nth @ A @ Xs2 @ I ) ) )
          = ( distinct @ A @ Xs2 ) ) ) ) ).

% distinct_swap
thf(fact_5241_uminus__integer__code_I1_J,axiom,
    ( ( uminus_uminus @ code_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ code_integer ) ) ).

% uminus_integer_code(1)
thf(fact_5242_abs__integer__code,axiom,
    ( ( abs_abs @ code_integer )
    = ( ^ [K3: code_integer] : ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ K3 ) @ K3 ) ) ) ).

% abs_integer_code
thf(fact_5243_divide__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( divide_divide @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( divide_divide @ int @ Xa @ X2 ) ) ) ).

% divide_integer.abs_eq
thf(fact_5244_zero__integer__def,axiom,
    ( ( zero_zero @ code_integer )
    = ( code_integer_of_int @ ( zero_zero @ int ) ) ) ).

% zero_integer_def
thf(fact_5245_modulo__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( modulo_modulo @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( modulo_modulo @ int @ Xa @ X2 ) ) ) ).

% modulo_integer.abs_eq
thf(fact_5246_unset__bit__integer_Oabs__eq,axiom,
    ! [Xa: nat,X2: int] :
      ( ( bit_se2638667681897837118et_bit @ code_integer @ Xa @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( bit_se2638667681897837118et_bit @ int @ Xa @ X2 ) ) ) ).

% unset_bit_integer.abs_eq
thf(fact_5247_less__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( ord_less @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( ord_less @ int @ Xa @ X2 ) ) ).

% less_integer.abs_eq
thf(fact_5248_less__integer__code_I1_J,axiom,
    ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(1)
thf(fact_5249_plus__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( plus_plus @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( plus_plus @ int @ Xa @ X2 ) ) ) ).

% plus_integer.abs_eq
thf(fact_5250_times__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( times_times @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( times_times @ int @ Xa @ X2 ) ) ) ).

% times_integer.abs_eq
thf(fact_5251_less__eq__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( ord_less_eq @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( ord_less_eq @ int @ Xa @ X2 ) ) ).

% less_eq_integer.abs_eq
thf(fact_5252_minus__integer_Oabs__eq,axiom,
    ! [Xa: int,X2: int] :
      ( ( minus_minus @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( minus_minus @ int @ Xa @ X2 ) ) ) ).

% minus_integer.abs_eq
thf(fact_5253_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs: list @ A] :
          ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ! [J2: nat] :
                ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( I3 != J2 )
                 => ( ( nth @ A @ Xs @ I3 )
                   != ( nth @ A @ Xs @ J2 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_5254_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs2: list @ A,I: nat,J: nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( ( ( nth @ A @ Xs2 @ I )
              = ( nth @ A @ Xs2 @ J ) )
            = ( I = J ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_5255_distinct__Ex1,axiom,
    ! [A: $tType,Xs2: list @ A,X2: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
       => ? [X3: nat] :
            ( ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ( nth @ A @ Xs2 @ X3 )
              = X2 )
            & ! [Y4: nat] :
                ( ( ( ord_less @ nat @ Y4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                  & ( ( nth @ A @ Xs2 @ Y4 )
                    = X2 ) )
               => ( Y4 = X3 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_5256_distinct__list__update,axiom,
    ! [A: $tType,Xs2: list @ A,A2: A,I: nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ~ ( member @ A @ A2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ ( nth @ A @ Xs2 @ I ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs2 @ I @ A2 ) ) ) ) ).

% distinct_list_update
thf(fact_5257_set__update__distinct,axiom,
    ! [A: $tType,Xs2: list @ A,N2: nat,X2: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs2 @ N2 @ X2 ) )
          = ( insert @ A @ X2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ ( nth @ A @ Xs2 @ N2 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_5258_integer__of__num_I3_J,axiom,
    ! [N2: num] :
      ( ( code_integer_of_num @ ( bit1 @ N2 ) )
      = ( plus_plus @ code_integer @ ( plus_plus @ code_integer @ ( code_integer_of_num @ N2 ) @ ( code_integer_of_num @ N2 ) ) @ ( one_one @ code_integer ) ) ) ).

% integer_of_num(3)
thf(fact_5259_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K3 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_5260_divmod__integer__def,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ K3 @ L ) @ ( modulo_modulo @ code_integer @ K3 @ L ) ) ) ) ).

% divmod_integer_def
thf(fact_5261_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_5262_integer__of__num_I2_J,axiom,
    ! [N2: num] :
      ( ( code_integer_of_num @ ( bit0 @ N2 ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N2 ) @ ( code_integer_of_num @ N2 ) ) ) ).

% integer_of_num(2)
thf(fact_5263_integer__of__num__triv_I2_J,axiom,
    ( ( code_integer_of_num @ ( bit0 @ one2 ) )
    = ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ).

% integer_of_num_triv(2)
thf(fact_5264_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S6: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S6 ) )
                @ ( S6
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_5265_divmod__abs__def,axiom,
    ( code_divmod_abs
    = ( ^ [K3: code_integer,L: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L ) ) @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L ) ) ) ) ) ).

% divmod_abs_def
thf(fact_5266_vebt__maxt_Opelims,axiom,
    ! [X2: vEBT_VEBT,Y2: option @ nat] :
      ( ( ( vEBT_vebt_maxt @ X2 )
        = Y2 )
     => ( ( accp @ vEBT_VEBT @ vEBT_vebt_maxt_rel @ X2 )
       => ( ! [A6: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( ( B6
                   => ( Y2
                      = ( some @ nat @ ( one_one @ nat ) ) ) )
                  & ( ~ B6
                   => ( ( A6
                       => ( Y2
                          = ( some @ nat @ ( zero_zero @ nat ) ) ) )
                      & ( ~ A6
                       => ( Y2
                          = ( none @ nat ) ) ) ) ) )
               => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_maxt_rel @ ( vEBT_Leaf @ A6 @ B6 ) ) ) )
         => ( ! [Uu3: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) )
               => ( ( Y2
                    = ( none @ nat ) )
                 => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_maxt_rel @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) ) ) )
           => ~ ! [Mi2: nat,Ma2: nat,Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) )
                 => ( ( Y2
                      = ( some @ nat @ Ma2 ) )
                   => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_maxt_rel @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) ) ) ) ) ) ) ) ).

% vebt_maxt.pelims
thf(fact_5267_divmod__abs__code_I6_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ ( zero_zero @ code_integer ) @ J )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ) ).

% divmod_abs_code(6)
thf(fact_5268_divmod__abs__code_I5_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ J @ ( zero_zero @ code_integer ) )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( abs_abs @ code_integer @ J ) ) ) ).

% divmod_abs_code(5)
thf(fact_5269_vebt__mint_Opelims,axiom,
    ! [X2: vEBT_VEBT,Y2: option @ nat] :
      ( ( ( vEBT_vebt_mint @ X2 )
        = Y2 )
     => ( ( accp @ vEBT_VEBT @ vEBT_vebt_mint_rel @ X2 )
       => ( ! [A6: $o,B6: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( ( A6
                   => ( Y2
                      = ( some @ nat @ ( zero_zero @ nat ) ) ) )
                  & ( ~ A6
                   => ( ( B6
                       => ( Y2
                          = ( some @ nat @ ( one_one @ nat ) ) ) )
                      & ( ~ B6
                       => ( Y2
                          = ( none @ nat ) ) ) ) ) )
               => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_mint_rel @ ( vEBT_Leaf @ A6 @ B6 ) ) ) )
         => ( ! [Uu3: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) )
               => ( ( Y2
                    = ( none @ nat ) )
                 => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_mint_rel @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu3 @ Uv2 @ Uw2 ) ) ) )
           => ~ ! [Mi2: nat,Ma2: nat,Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) )
                 => ( ( Y2
                      = ( some @ nat @ Mi2 ) )
                   => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_mint_rel @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) ) ) ) ) ) ) ) ).

% vebt_mint.pelims
thf(fact_5270_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ ( code_divmod_abs @ K3 @ L )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S6: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S6
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L @ S6 ) ) )
                @ ( code_divmod_abs @ K3 @ L ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K3 @ L )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S6: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S6
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L ) @ S6 ) ) )
                    @ ( code_divmod_abs @ K3 @ L ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_5271_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num,N2: nat] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N2 ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N2 ) @ ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N2 ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_5272_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( suc @ Nat ) )
      = ( F22 @ Nat @ ( rec_nat @ T @ F1 @ F22 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_5273_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_5274_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) @ ( rec_nat @ A @ A2 @ F2 @ ( pred_numeral @ V ) ) ) ) ).

% rec_nat_numeral
thf(fact_5275_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F23: nat > T > T,X: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F23 @ X ) ) ) ) ).

% old.rec_nat_def
thf(fact_5276_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( zero_zero @ nat ) )
        = F1 ) ) ).

% rec_nat_0_imp
thf(fact_5277_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A,N2: nat] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( suc @ N2 ) )
        = ( F22 @ N2 @ ( F2 @ N2 ) ) ) ) ).

% rec_nat_Suc_imp
thf(fact_5278_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X: real] :
          ( the @ int
          @ ^ [Z5: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z5 ) @ X )
              & ( ord_less @ real @ X @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_5279_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X: rat] :
          ( the @ int
          @ ^ [Z5: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z5 ) @ X )
              & ( ord_less @ rat @ X @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_5280_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num,N2: nat] :
      ( ( case_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N2 ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N2 ) ) ) ).

% case_nat_add_eq_if
thf(fact_5281_bezw__0,axiom,
    ! [X2: nat] :
      ( ( bezw @ X2 @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_5282_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num] :
      ( ( case_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) ) ) ).

% case_nat_numeral
thf(fact_5283_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: nat > A,Nat: nat] :
      ( ( H2 @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H2 @ F1 )
        @ ^ [X: nat] : ( H2 @ ( F22 @ X ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_5284_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A4: rat] :
          ( if @ rat
          @ ( A4
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A4 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_5285_obtain__pos__sum,axiom,
    ! [R: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
     => ~ ! [S3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S3 )
           => ! [T4: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T4 )
               => ( R
                 != ( plus_plus @ rat @ S3 @ T4 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_5286_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_5287_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A,X22: nat] :
      ( ( case_nat @ A @ F1 @ F22 @ ( suc @ X22 ) )
      = ( F22 @ X22 ) ) ).

% old.nat.simps(5)
thf(fact_5288_abs__rat__def,axiom,
    ( ( abs_abs @ rat )
    = ( ^ [A4: rat] : ( if @ rat @ ( ord_less @ rat @ A4 @ ( zero_zero @ rat ) ) @ ( uminus_uminus @ rat @ A4 ) @ A4 ) ) ) ).

% abs_rat_def
thf(fact_5289_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu2: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_5290_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu2: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_5291_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N2 ) ) ).

% less_eq_nat.simps(2)
thf(fact_5292_max__Suc1,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N2 ) @ M )
      = ( case_nat @ nat @ ( suc @ N2 )
        @ ^ [M5: nat] : ( suc @ ( ord_max @ nat @ N2 @ M5 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_5293_max__Suc2,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( suc @ N2 )
        @ ^ [M5: nat] : ( suc @ ( ord_max @ nat @ M5 @ N2 ) )
        @ M ) ) ).

% max_Suc2
thf(fact_5294_diff__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K3: nat] : K3
        @ ( minus_minus @ nat @ M @ N2 ) ) ) ).

% diff_Suc
thf(fact_5295_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ N2 )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N2 ) ) ) ).

% bit_numeral_rec(1)
thf(fact_5296_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ N2 )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N2 ) ) ) ).

% bit_numeral_rec(2)
thf(fact_5297_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X: A,F4: nat > A,N: nat] :
            ( if @ A
            @ ( N
              = ( zero_zero @ nat ) )
            @ X
            @ ( F4 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_5298_rat__inverse__code,axiom,
    ! [P2: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,B3: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A4
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A4 ) @ B3 ) @ ( abs_abs @ int @ A4 ) ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_inverse_code
thf(fact_5299_normalize__negative,axiom,
    ! [Q2: int,P2: int] :
      ( ( ord_less @ int @ Q2 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P2 @ Q2 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P2 ) @ ( uminus_uminus @ int @ Q2 ) ) ) ) ) ).

% normalize_negative
thf(fact_5300_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_5301_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_5302_normalize__denom__zero,axiom,
    ! [P2: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P2 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_5303_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_5304_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_5305_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( times_times @ rat @ Q4 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_5306_diff__rat__def,axiom,
    ( ( minus_minus @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( plus_plus @ rat @ Q4 @ ( uminus_uminus @ rat @ R5 ) ) ) ) ).

% diff_rat_def
thf(fact_5307_rat__divide__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P2 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D2: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A4 @ D2 ) @ ( times_times @ int @ C3 @ B3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_divide_code
thf(fact_5308_rat__times__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P2 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D2: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A4 @ B3 ) @ ( times_times @ int @ C3 @ D2 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_times_code
thf(fact_5309_rat__plus__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P2 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D2: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A4 @ D2 ) @ ( times_times @ int @ B3 @ C3 ) ) @ ( times_times @ int @ C3 @ D2 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_plus_code
thf(fact_5310_rat__minus__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P2 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D2: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A4 @ D2 ) @ ( times_times @ int @ B3 @ C3 ) ) @ ( times_times @ int @ C3 @ D2 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_minus_code
thf(fact_5311_quotient__of__denom__pos,axiom,
    ! [R: rat,P2: int,Q2: int] :
      ( ( ( quotient_of @ R )
        = ( product_Pair @ int @ int @ P2 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% quotient_of_denom_pos
thf(fact_5312_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X24: nat] : X24 ) ) ).

% pred_def
thf(fact_5313_normalize__denom__pos,axiom,
    ! [R: product_prod @ int @ int,P2: int,Q2: int] :
      ( ( ( normalize @ R )
        = ( product_Pair @ int @ int @ P2 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% normalize_denom_pos
thf(fact_5314_normalize__crossproduct,axiom,
    ! [Q2: int,S2: int,P2: int,R: int] :
      ( ( Q2
       != ( zero_zero @ int ) )
     => ( ( S2
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P2 @ Q2 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R @ S2 ) ) )
         => ( ( times_times @ int @ P2 @ S2 )
            = ( times_times @ int @ R @ Q2 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_5315_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_5316_prod__decode__aux_Oelims,axiom,
    ! [X2: nat,Xa: nat,Y2: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X2 @ Xa )
        = Y2 )
     => ( ( ( ord_less_eq @ nat @ Xa @ X2 )
         => ( Y2
            = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X2 @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa @ X2 )
         => ( Y2
            = ( nat_prod_decode_aux @ ( suc @ X2 ) @ ( minus_minus @ nat @ Xa @ ( suc @ X2 ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_5317_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K3: nat,M3: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M3 @ K3 ) @ ( product_Pair @ nat @ nat @ M3 @ ( minus_minus @ nat @ K3 @ M3 ) ) @ ( nat_prod_decode_aux @ ( suc @ K3 ) @ ( minus_minus @ nat @ M3 @ ( suc @ K3 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_5318_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_5319_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L2 ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L2 ) ) ) ) ).

% numeral_mod_numeral
thf(fact_5320_snd__divmod__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( product_snd @ nat @ nat @ ( divmod_nat @ M @ N2 ) )
      = ( modulo_modulo @ nat @ M @ N2 ) ) ).

% snd_divmod_nat
thf(fact_5321_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N2 ) ) ) ) ).

% one_mod_numeral
thf(fact_5322_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_5323_snd__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% snd_divmod
thf(fact_5324_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_5325_Frct__code__post_I6_J,axiom,
    ! [K: num,L2: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L2 ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L2 ) ) ) ).

% Frct_code_post(6)
thf(fact_5326_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_5327_snd__divmod__integer,axiom,
    ! [K: code_integer,L2: code_integer] :
      ( ( product_snd @ code_integer @ code_integer @ ( code_divmod_integer @ K @ L2 ) )
      = ( modulo_modulo @ code_integer @ K @ L2 ) ) ).

% snd_divmod_integer
thf(fact_5328_snd__divmod__abs,axiom,
    ! [K: code_integer,L2: code_integer] :
      ( ( product_snd @ code_integer @ code_integer @ ( code_divmod_abs @ K @ L2 ) )
      = ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K ) @ ( abs_abs @ code_integer @ L2 ) ) ) ).

% snd_divmod_abs
thf(fact_5329_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L2 ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L2 ) ) ) ) ).

% numeral_div_numeral
thf(fact_5330_fst__divmod__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( product_fst @ nat @ nat @ ( divmod_nat @ M @ N2 ) )
      = ( divide_divide @ nat @ M @ N2 ) ) ).

% fst_divmod_nat
thf(fact_5331_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N2 ) ) ) ) ).

% one_div_numeral
thf(fact_5332_fst__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N2 ) )
          = ( divide_divide @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% fst_divmod
thf(fact_5333_quotient__of__denom__pos_H,axiom,
    ! [R: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ ( quotient_of @ R ) ) ) ).

% quotient_of_denom_pos'
thf(fact_5334_Frct__code__post_I1_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A2 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_5335_Frct__code__post_I2_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A2 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_5336_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_5337_one__mod__minus__numeral,axiom,
    ! [N2: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_5338_minus__one__mod__numeral,axiom,
    ! [N2: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_5339_minus__numeral__mod__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ).

% minus_numeral_mod_numeral
thf(fact_5340_numeral__mod__minus__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ) ).

% numeral_mod_minus_numeral
thf(fact_5341_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_5342_bezw__non__0,axiom,
    ! [Y2: nat,X2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y2 )
     => ( ( bezw @ X2 @ Y2 )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Y2 ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_5343_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X: nat,Y: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Y ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_5344_bezw_Oelims,axiom,
    ! [X2: nat,Xa: nat,Y2: product_prod @ int @ int] :
      ( ( ( bezw @ X2 @ Xa )
        = Y2 )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y2
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y2
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Xa ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_5345_in__set__enumerate__eq,axiom,
    ! [A: $tType,P2: product_prod @ nat @ A,N2: nat,Xs2: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P2 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs2 ) ) )
      = ( ( ord_less_eq @ nat @ N2 @ ( product_fst @ nat @ A @ P2 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P2 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) )
        & ( ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P2 ) @ N2 ) )
          = ( product_snd @ nat @ A @ P2 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_5346_bezw_Opelims,axiom,
    ! [X2: nat,Xa: nat,Y2: product_prod @ int @ int] :
      ( ( ( bezw @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y2
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y2
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Xa ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) ) ) ) ) ).

% bezw.pelims
thf(fact_5347_normalize__def,axiom,
    ( normalize
    = ( ^ [P4: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P4 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P4 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P4 ) @ ( product_snd @ int @ int @ P4 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P4 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P4 ) @ ( product_snd @ int @ int @ P4 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P4 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P4 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P4 ) @ ( product_snd @ int @ int @ P4 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P4 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P4 ) @ ( product_snd @ int @ int @ P4 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_5348_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% gcd_eq_0_iff
thf(fact_5349_gcd__add1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N2: A] :
          ( ( gcd_gcd @ A @ ( plus_plus @ A @ M @ N2 ) @ N2 )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_add1
thf(fact_5350_gcd__add2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N2: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ M @ N2 ) )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_add2
thf(fact_5351_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N2 ) ) ) ).

% gcd_exp
thf(fact_5352_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N2: num,A2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ A2 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N2 ) @ A2 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_5353_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N2: num] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( gcd_gcd @ A @ A2 @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_5354_gcd__pos__int,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ M @ N2 ) )
      = ( ( M
         != ( zero_zero @ int ) )
        | ( N2
         != ( zero_zero @ int ) ) ) ) ).

% gcd_pos_int
thf(fact_5355_gcd__neg__numeral__1__int,axiom,
    ! [N2: num,X2: int] :
      ( ( gcd_gcd @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) @ X2 )
      = ( gcd_gcd @ int @ ( numeral_numeral @ int @ N2 ) @ X2 ) ) ).

% gcd_neg_numeral_1_int
thf(fact_5356_gcd__neg__numeral__2__int,axiom,
    ! [X2: int,N2: num] :
      ( ( gcd_gcd @ int @ X2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( gcd_gcd @ int @ X2 @ ( numeral_numeral @ int @ N2 ) ) ) ).

% gcd_neg_numeral_2_int
thf(fact_5357_gcd__0__int,axiom,
    ! [X2: int] :
      ( ( gcd_gcd @ int @ X2 @ ( zero_zero @ int ) )
      = ( abs_abs @ int @ X2 ) ) ).

% gcd_0_int
thf(fact_5358_gcd__0__left__int,axiom,
    ! [X2: int] :
      ( ( gcd_gcd @ int @ ( zero_zero @ int ) @ X2 )
      = ( abs_abs @ int @ X2 ) ) ).

% gcd_0_left_int
thf(fact_5359_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,K: A,N2: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ ( times_times @ A @ K @ M ) @ N2 ) )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_add_mult
thf(fact_5360_gcd__diff1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [M: A,N2: A] :
          ( ( gcd_gcd @ A @ ( minus_minus @ A @ M @ N2 ) @ N2 )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_diff1
thf(fact_5361_gcd__diff2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N2: A,M: A] :
          ( ( gcd_gcd @ A @ ( minus_minus @ A @ N2 @ M ) @ N2 )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_diff2
thf(fact_5362_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_5363_gcd__red__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [X: int,Y: int] : ( gcd_gcd @ int @ Y @ ( modulo_modulo @ int @ X @ Y ) ) ) ) ).

% gcd_red_int
thf(fact_5364_gcd__ge__0__int,axiom,
    ! [X2: int,Y2: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ X2 @ Y2 ) ) ).

% gcd_ge_0_int
thf(fact_5365_bezout__int,axiom,
    ! [X2: int,Y2: int] :
    ? [U3: int,V4: int] :
      ( ( plus_plus @ int @ ( times_times @ int @ U3 @ X2 ) @ ( times_times @ int @ V4 @ Y2 ) )
      = ( gcd_gcd @ int @ X2 @ Y2 ) ) ).

% bezout_int
thf(fact_5366_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,N2: int] :
      ( ( times_times @ int @ ( abs_abs @ int @ K ) @ ( gcd_gcd @ int @ M @ N2 ) )
      = ( gcd_gcd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N2 ) ) ) ).

% gcd_mult_distrib_int
thf(fact_5367_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_5368_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_5369_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_5370_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_5371_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_5372_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_int
thf(fact_5373_gcd__cases__int,axiom,
    ! [X2: int,Y2: int,P: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
         => ( P @ ( gcd_gcd @ int @ X2 @ Y2 ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
         => ( ( ord_less_eq @ int @ Y2 @ ( zero_zero @ int ) )
           => ( P @ ( gcd_gcd @ int @ X2 @ ( uminus_uminus @ int @ Y2 ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X2 @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
             => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X2 ) @ Y2 ) ) ) )
         => ( ( ( ord_less_eq @ int @ X2 @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y2 @ ( zero_zero @ int ) )
               => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X2 ) @ ( uminus_uminus @ int @ Y2 ) ) ) ) )
           => ( P @ ( gcd_gcd @ int @ X2 @ Y2 ) ) ) ) ) ) ).

% gcd_cases_int
thf(fact_5374_gcd__unique__int,axiom,
    ! [D3: int,A2: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D3 )
        & ( dvd_dvd @ int @ D3 @ A2 )
        & ( dvd_dvd @ int @ D3 @ B2 )
        & ! [E3: int] :
            ( ( ( dvd_dvd @ int @ E3 @ A2 )
              & ( dvd_dvd @ int @ E3 @ B2 ) )
           => ( dvd_dvd @ int @ E3 @ D3 ) ) )
      = ( D3
        = ( gcd_gcd @ int @ A2 @ B2 ) ) ) ).

% gcd_unique_int
thf(fact_5375_gcd__non__0__int,axiom,
    ! [Y2: int,X2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( gcd_gcd @ int @ X2 @ Y2 )
        = ( gcd_gcd @ int @ Y2 @ ( modulo_modulo @ int @ X2 @ Y2 ) ) ) ) ).

% gcd_non_0_int
thf(fact_5376_gcd__code__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [K3: int,L: int] :
          ( abs_abs @ int
          @ ( if @ int
            @ ( L
              = ( zero_zero @ int ) )
            @ K3
            @ ( gcd_gcd @ int @ L @ ( modulo_modulo @ int @ ( abs_abs @ int @ K3 ) @ ( abs_abs @ int @ L ) ) ) ) ) ) ) ).

% gcd_code_int
thf(fact_5377_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs2: list @ A,N2: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs2 ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N2 @ M ) @ ( nth @ A @ Xs2 @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_5378_prod__decode__aux_Opelims,axiom,
    ! [X2: nat,Xa: nat,Y2: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa @ X2 )
               => ( Y2
                  = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X2 @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa @ X2 )
               => ( Y2
                  = ( nat_prod_decode_aux @ ( suc @ X2 ) @ ( minus_minus @ nat @ Xa @ ( suc @ X2 ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_5379_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F4: A > nat,G2: B > nat,P4: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F4 @ ( product_fst @ A @ B @ P4 ) ) @ ( G2 @ ( product_snd @ A @ B @ P4 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_5380_finite__enumerate,axiom,
    ! [S: set @ nat] :
      ( ( finite_finite @ nat @ S )
     => ? [R2: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R2 @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S ) ) )
          & ! [N7: nat] :
              ( ( ord_less @ nat @ N7 @ ( finite_card @ nat @ S ) )
             => ( member @ nat @ ( R2 @ N7 ) @ S ) ) ) ) ).

% finite_enumerate
thf(fact_5381_gcd__0__left__nat,axiom,
    ! [X2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ X2 )
      = X2 ) ).

% gcd_0_left_nat
thf(fact_5382_gcd__0__nat,axiom,
    ! [X2: nat] :
      ( ( gcd_gcd @ nat @ X2 @ ( zero_zero @ nat ) )
      = X2 ) ).

% gcd_0_nat
thf(fact_5383_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% gcd_nat.right_neutral
thf(fact_5384_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( gcd_gcd @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.neutr_eq_iff
thf(fact_5385_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% gcd_nat.left_neutral
thf(fact_5386_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( gcd_gcd @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.eq_neutr_iff
thf(fact_5387_gcd__Suc__0,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% gcd_Suc_0
thf(fact_5388_gcd__pos__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N2 ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_5389_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( gcd_gcd @ nat @ M @ N2 ) )
      = ( gcd_gcd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% gcd_mult_distrib_nat
thf(fact_5390_gcd__red__nat,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X: nat,Y: nat] : ( gcd_gcd @ nat @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) ) ).

% gcd_red_nat
thf(fact_5391_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_5392_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_5393_gcd__diff2__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N2 @ M ) @ N2 )
        = ( gcd_gcd @ nat @ M @ N2 ) ) ) ).

% gcd_diff2_nat
thf(fact_5394_gcd__diff1__nat,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 )
        = ( gcd_gcd @ nat @ M @ N2 ) ) ) ).

% gcd_diff1_nat
thf(fact_5395_gcd__nat_Oelims,axiom,
    ! [X2: nat,Xa: nat,Y2: nat] :
      ( ( ( gcd_gcd @ nat @ X2 @ Xa )
        = Y2 )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y2 = X2 ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y2
            = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) ) ) ) ).

% gcd_nat.elims
thf(fact_5396_gcd__nat_Osimps,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X: nat,Y: nat] :
          ( if @ nat
          @ ( Y
            = ( zero_zero @ nat ) )
          @ X
          @ ( gcd_gcd @ nat @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) ) ) ).

% gcd_nat.simps
thf(fact_5397_gcd__non__0__nat,axiom,
    ! [Y2: nat,X2: nat] :
      ( ( Y2
       != ( zero_zero @ nat ) )
     => ( ( gcd_gcd @ nat @ X2 @ Y2 )
        = ( gcd_gcd @ nat @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) ) ).

% gcd_non_0_nat
thf(fact_5398_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X3: nat,Y3: nat] :
          ( ( times_times @ nat @ A2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_5399_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X3: nat,Y3: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ ( times_times @ nat @ A2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X3 ) @ ( times_times @ nat @ B2 @ Y3 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ ( times_times @ nat @ B2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X3 ) @ ( times_times @ nat @ A2 @ Y3 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_5400_gcd__code__integer,axiom,
    ( ( gcd_gcd @ code_integer )
    = ( ^ [K3: code_integer,L: code_integer] :
          ( abs_abs @ code_integer
          @ ( if @ code_integer
            @ ( L
              = ( zero_zero @ code_integer ) )
            @ K3
            @ ( gcd_gcd @ code_integer @ L @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L ) ) ) ) ) ) ) ).

% gcd_code_integer
thf(fact_5401_bezw__aux,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X2 @ Y2 ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X2 @ Y2 ) ) @ ( semiring_1_of_nat @ int @ X2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X2 @ Y2 ) ) @ ( semiring_1_of_nat @ int @ Y2 ) ) ) ) ).

% bezw_aux
thf(fact_5402_nat__descend__induct,axiom,
    ! [N2: nat,P: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less @ nat @ N2 @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N2 )
           => ( ! [I2: nat] :
                  ( ( ord_less @ nat @ K2 @ I2 )
                 => ( P @ I2 ) )
             => ( P @ K2 ) ) )
       => ( P @ M ) ) ) ).

% nat_descend_induct
thf(fact_5403_gcd__nat_Opelims,axiom,
    ! [X2: nat,Xa: nat,Y2: nat] :
      ( ( ( gcd_gcd @ nat @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y2 = X2 ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y2
                  = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X2 @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_5404_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F4: A > B,A7: set @ A] :
            ! [R5: A,S6: A] :
              ( ( ( member @ A @ R5 @ A7 )
                & ( member @ A @ S6 @ A7 )
                & ( ord_less @ A @ R5 @ S6 ) )
             => ( ord_less @ B @ ( F4 @ R5 ) @ ( F4 @ S6 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_5405_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [R2: A,S3: A] :
              ( ( member @ A @ R2 @ A3 )
             => ( ( member @ A @ S3 @ A3 )
               => ( ( ord_less @ A @ R2 @ S3 )
                 => ( ord_less @ B @ ( F2 @ R2 ) @ ( F2 @ S3 ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F2 @ A3 ) ) ) ).

% strict_mono_onI
thf(fact_5406_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( preorder @ B ) )
     => ! [F2: A > B,A3: set @ A,X2: A,Y2: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( member @ A @ Y2 @ A3 )
             => ( ( ord_less_eq @ A @ X2 @ Y2 )
               => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) ) ) ) ).

% strict_mono_on_leD
thf(fact_5407_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F2: A > B,A3: set @ A,R: A,S2: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A3 )
         => ( ( member @ A @ R @ A3 )
           => ( ( member @ A @ S2 @ A3 )
             => ( ( ord_less @ A @ R @ S2 )
               => ( ord_less @ B @ ( F2 @ R ) @ ( F2 @ S2 ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_5408_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K3 )
                  = ( sgn_sgn @ code_integer @ L ) )
                @ ( code_divmod_abs @ K3 @ L )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S6: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S6
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L ) @ S6 ) ) )
                  @ ( code_divmod_abs @ K3 @ L ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_5409_nth__rotate1,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs2 ) @ N2 )
        = ( nth @ A @ Xs2 @ ( modulo_modulo @ nat @ ( suc @ N2 ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% nth_rotate1
thf(fact_5410_set__remove1__eq,axiom,
    ! [A: $tType,Xs2: list @ A,X2: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( set2 @ A @ ( remove1 @ A @ X2 @ Xs2 ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_5411_rotate1__length01,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs2 )
        = Xs2 ) ) ).

% rotate1_length01
thf(fact_5412_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H2: B > A,G: C > B,A3: set @ C] :
          ( ( ( H2 @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X3: B,Y3: B] :
                ( ( H2 @ ( plus_plus @ B @ X3 @ Y3 ) )
                = ( plus_plus @ A @ ( H2 @ X3 ) @ ( H2 @ Y3 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H2 @ G ) @ A3 )
              = ( H2 @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A3 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_5413_length__remove1,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A] :
      ( ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X2 @ Xs2 ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X2 @ Xs2 ) )
          = ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% length_remove1
thf(fact_5414_card__greaterThanLessThan__int,axiom,
    ! [L2: int,U: int] :
      ( ( finite_card @ int @ ( set_or5935395276787703475ssThan @ int @ L2 @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ ( plus_plus @ int @ L2 @ ( one_one @ int ) ) ) ) ) ).

% card_greaterThanLessThan_int
thf(fact_5415_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N2: num] :
      ( ( bit_se5824344971392196577ns_xor @ int @ K @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ ( neg_numeral_sub @ int @ N2 @ one2 ) ) ) ) ).

% xor_minus_numerals(2)
thf(fact_5416_xor__minus__numerals_I1_J,axiom,
    ! [N2: num,K: int] :
      ( ( bit_se5824344971392196577ns_xor @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) @ K )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ ( neg_numeral_sub @ int @ N2 @ one2 ) @ K ) ) ) ).

% xor_minus_numerals(1)
thf(fact_5417_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L2: A,U: A] :
          ( ( member @ A @ I @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) )
          = ( ( ord_less @ A @ L2 @ I )
            & ( ord_less @ A @ I @ U ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_5418_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_5419_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_5420_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L2: A,K: A] :
          ( ( ord_less_eq @ A @ L2 @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_5421_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_5422_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_5423_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ M @ N2 ) ) ) ).

% diff_numeral_simps(1)
thf(fact_5424_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L2 ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(6)
thf(fact_5425_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L2 ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(9)
thf(fact_5426_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ M @ N2 ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_5427_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ N2 @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_5428_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V @ W ) @ Y2 ) ) ) ).

% semiring_norm(166)
thf(fact_5429_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W @ V ) @ Y2 ) ) ) ).

% semiring_norm(167)
thf(fact_5430_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_5431_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L2 ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(7)
thf(fact_5432_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L2 ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(8)
thf(fact_5433_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ one2 @ N2 ) ) ) ).

% diff_numeral_special(1)
thf(fact_5434_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_5435_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_5436_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% not_minus_numeral_eq
thf(fact_5437_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_5438_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_5439_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_5440_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_5441_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_5442_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_5443_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_5444_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_5445_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L2: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L2 ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_5446_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L2: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L2 ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_5447_card_Ocomp__fun__commute__on,axiom,
    ( ( comp @ nat @ nat @ nat @ suc @ suc )
    = ( comp @ nat @ nat @ nat @ suc @ suc ) ) ).

% card.comp_fun_commute_on
thf(fact_5448_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_5449_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K3: num,L: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K3 ) @ ( numeral_numeral @ A @ L ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_5450_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
thf(fact_5451_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
thf(fact_5452_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_5453_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_5454_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
thf(fact_5455_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
thf(fact_5456_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_5457_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_5458_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( plus_plus @ nat @ N2 ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_5459_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D3 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D3 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_5460_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ ( comp @ A @ A @ nat @ ( inverse_inverse @ A ) @ F2 ) )
         => ( summable @ A
            @ ^ [N: nat] : ( divide_divide @ A @ C2 @ ( F2 @ N ) ) ) ) ) ).

% summable_inverse_divide
thf(fact_5461_atLeastPlusOneLessThan__greaterThanLessThan__int,axiom,
    ! [L2: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ ( plus_plus @ int @ L2 @ ( one_one @ int ) ) @ U )
      = ( set_or5935395276787703475ssThan @ int @ L2 @ U ) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_int
thf(fact_5462_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N2 @ M ) )
          = ( ord_less_eq @ num @ M @ N2 ) ) ) ).

% sub_non_negative
thf(fact_5463_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N2 @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N2 @ M ) ) ) ).

% sub_non_positive
thf(fact_5464_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N2 @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N2 @ M ) ) ) ).

% sub_negative
thf(fact_5465_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N2 @ M ) )
          = ( ord_less @ num @ M @ N2 ) ) ) ).

% sub_positive
thf(fact_5466_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N2 ) @ one2 )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% sub_inc_One_eq
thf(fact_5467_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D3 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_5468_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D3 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D3 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_5469_atLeastAtMost__diff__ends,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( insert @ A @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ).

% atLeastAtMost_diff_ends
thf(fact_5470_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ) ).

% minus_numeral_eq_not_sub_one
thf(fact_5471_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_5472_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_5473_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_5474_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_5475_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_5476_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_5477_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_5478_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_5479_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_5480_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_5481_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_5482_sub__BitM__One__eq,axiom,
    ! [N2: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N2 ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N2 @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_5483_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_5484_Code__Target__Int_Onegative__def,axiom,
    ( code_Target_negative
    = ( comp @ int @ int @ num @ ( uminus_uminus @ int ) @ ( numeral_numeral @ int ) ) ) ).

% Code_Target_Int.negative_def
thf(fact_5485_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X2: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X2 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_5486_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X2: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X2 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_5487_card__greaterThanLessThan,axiom,
    ! [L2: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or5935395276787703475ssThan @ nat @ L2 @ U ) )
      = ( minus_minus @ nat @ U @ ( suc @ L2 ) ) ) ).

% card_greaterThanLessThan
thf(fact_5488_atLeastSucLessThan__greaterThanLessThan,axiom,
    ! [L2: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ L2 ) @ U )
      = ( set_or5935395276787703475ssThan @ nat @ L2 @ U ) ) ).

% atLeastSucLessThan_greaterThanLessThan
thf(fact_5489_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X2 @ Y2 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X2 @ Y2 ) )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scale_right_distrib_NO_MATCH
thf(fact_5490_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X2 @ Y2 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X2 @ Y2 ) )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
thf(fact_5491_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X2: B,Y2: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_5492_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X2: B,Y2: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_5493_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X2: B,Y2: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_5494_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X2: B,Y2: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_5495_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A,N2: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ N2 )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ).

% power_minus'
thf(fact_5496_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X2 @ Y2 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X2 )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ) ).

% scale_left_distrib_NO_MATCH
thf(fact_5497_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X2 @ Y2 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X2 )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
thf(fact_5498_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ? [K8: real] :
            ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K8 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F2 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_5499_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F4: A > B] :
            ? [K6: real] :
            ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F4 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K6 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_5500_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F4: B > A,A4: A,Xs: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] : ( compow @ ( A > A ) @ N @ ( times_times @ A @ A4 ) @ ( F4 @ ( nth @ B @ Xs @ N ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_5501_Suc__funpow,axiom,
    ! [N2: nat] :
      ( ( compow @ ( nat > nat ) @ N2 @ suc )
      = ( plus_plus @ nat @ N2 ) ) ).

% Suc_funpow
thf(fact_5502_funpow__0,axiom,
    ! [A: $tType,F2: A > A,X2: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 @ X2 )
      = X2 ) ).

% funpow_0
thf(fact_5503_funpow__add,axiom,
    ! [A: $tType,M: nat,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F2 ) @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% funpow_add
thf(fact_5504_funpow__Suc__right,axiom,
    ! [A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ F2 ) ) ).

% funpow_Suc_right
thf(fact_5505_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ F2 @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% funpow.simps(2)
thf(fact_5506_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N2 @ ( comp @ A @ A @ B @ F2 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% comp_funpow
thf(fact_5507_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X2: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X2 ) @ ( times_times @ A @ X2 ) )
          = ( times_times @ A @ ( power_power @ A @ X2 @ ( F2 @ X2 ) ) ) ) ) ).

% funpow_times_power
thf(fact_5508_funpow__mult,axiom,
    ! [A: $tType,N2: nat,M: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ N2 @ ( compow @ ( A > A ) @ M @ F2 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N2 ) @ F2 ) ) ).

% funpow_mult
thf(fact_5509_funpow__swap1,axiom,
    ! [A: $tType,F2: A > A,N2: nat,X2: A] :
      ( ( F2 @ ( compow @ ( A > A ) @ N2 @ F2 @ X2 ) )
      = ( compow @ ( A > A ) @ N2 @ F2 @ ( F2 @ X2 ) ) ) ).

% funpow_swap1
thf(fact_5510_bij__betw__funpow,axiom,
    ! [A: $tType,F2: A > A,S: set @ A,N2: nat] :
      ( ( bij_betw @ A @ A @ F2 @ S @ S )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ S @ S ) ) ).

% bij_betw_funpow
thf(fact_5511_funpow__mod__eq,axiom,
    ! [A: $tType,N2: nat,F2: A > A,X2: A,M: nat] :
      ( ( ( compow @ ( A > A ) @ N2 @ F2 @ X2 )
        = X2 )
     => ( ( compow @ ( A > A ) @ ( modulo_modulo @ nat @ M @ N2 ) @ F2 @ X2 )
        = ( compow @ ( A > A ) @ M @ F2 @ X2 ) ) ) ).

% funpow_mod_eq
thf(fact_5512_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_5513_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N: nat] : ( compow @ ( A > A ) @ N @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_5514_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K3: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K3 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_5515_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N: nat,P6: A > A > $o,X: A,Y: A] :
          ? [F4: nat > A] :
            ( ( ( F4 @ ( zero_zero @ nat ) )
              = X )
            & ( ( F4 @ N )
              = Y )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ N )
               => ( P6 @ ( F4 @ I3 ) @ ( F4 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_5516_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_5517_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( ( ord_less_eq @ code_integer @ K @ ( zero_zero @ code_integer ) )
     => ( ( code_nat_of_integer @ K )
        = ( zero_zero @ nat ) ) ) ).

% nat_of_integer_non_positive
thf(fact_5518_of__nat__of__integer,axiom,
    ! [K: code_integer] :
      ( ( semiring_1_of_nat @ code_integer @ ( code_nat_of_integer @ K ) )
      = ( ord_max @ code_integer @ ( zero_zero @ code_integer ) @ K ) ) ).

% of_nat_of_integer
thf(fact_5519_relpowp__Suc__E,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z )
     => ~ ! [Y3: A] :
            ( ( compow @ ( A > A > $o ) @ N2 @ P @ X2 @ Y3 )
           => ~ ( P @ Y3 @ Z ) ) ) ).

% relpowp_Suc_E
thf(fact_5520_relpowp__Suc__I,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Y2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N2 @ P @ X2 @ Y2 )
     => ( ( P @ Y2 @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z ) ) ) ).

% relpowp_Suc_I
thf(fact_5521_relpowp__Suc__D2,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z )
     => ? [Y3: A] :
          ( ( P @ X2 @ Y3 )
          & ( compow @ ( A > A > $o ) @ N2 @ P @ Y3 @ Z ) ) ) ).

% relpowp_Suc_D2
thf(fact_5522_relpowp__Suc__E2,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z )
     => ~ ! [Y3: A] :
            ( ( P @ X2 @ Y3 )
           => ~ ( compow @ ( A > A > $o ) @ N2 @ P @ Y3 @ Z ) ) ) ).

% relpowp_Suc_E2
thf(fact_5523_relpowp__Suc__I2,axiom,
    ! [A: $tType,P: A > A > $o,X2: A,Y2: A,N2: nat,Z: A] :
      ( ( P @ X2 @ Y2 )
     => ( ( compow @ ( A > A > $o ) @ N2 @ P @ Y2 @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z ) ) ) ).

% relpowp_Suc_I2
thf(fact_5524_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R3: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ R3 )
      = ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) ) ) ).

% relpowp.simps(1)
thf(fact_5525_relpowp__0__E,axiom,
    ! [A: $tType,P: A > A > $o,X2: A,Y2: A] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X2 @ Y2 )
     => ( X2 = Y2 ) ) ).

% relpowp_0_E
thf(fact_5526_relpowp__0__I,axiom,
    ! [A: $tType,P: A > A > $o,X2: A] : ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X2 @ X2 ) ).

% relpowp_0_I
thf(fact_5527_nat__of__integer__code__post_I1_J,axiom,
    ( ( code_nat_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ nat ) ) ).

% nat_of_integer_code_post(1)
thf(fact_5528_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] :
      ( ( code_nat_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_integer_code_post(3)
thf(fact_5529_relpowp__E2,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N2 @ P @ X2 @ Z )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y3: A,M4: nat] :
              ( ( N2
                = ( suc @ M4 ) )
             => ( ( P @ X2 @ Y3 )
               => ~ ( compow @ ( A > A > $o ) @ M4 @ P @ Y3 @ Z ) ) ) ) ) ).

% relpowp_E2
thf(fact_5530_relpowp__E,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N2 @ P @ X2 @ Z )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y3: A,M4: nat] :
              ( ( N2
                = ( suc @ M4 ) )
             => ( ( compow @ ( A > A > $o ) @ M4 @ P @ X2 @ Y3 )
               => ~ ( P @ Y3 @ Z ) ) ) ) ) ).

% relpowp_E
thf(fact_5531_relpowp__bot,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( compow @ ( A > A > $o ) @ N2 @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_5532_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L: code_integer,J2: code_integer] :
                ( if @ nat
                @ ( J2
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L ) @ ( code_nat_of_integer @ L ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L ) @ ( code_nat_of_integer @ L ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_5533_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X: nat,Y: nat] : ( ord_less_eq @ nat @ Y @ X )
    @ ^ [X: nat,Y: nat] : ( ord_less @ nat @ Y @ X ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_5534_set__removeAll,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X2 @ Xs2 ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_5535_length__removeAll__less__eq,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X2 @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_removeAll_less_eq
thf(fact_5536_length__removeAll__less,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X2 @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_removeAll_less
thf(fact_5537_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M3: nat,N: nat] :
        ( ( dvd_dvd @ nat @ M3 @ N )
        & ( M3 != N ) ) ) ).

% gcd_nat.semilattice_neutr_order_axioms
thf(fact_5538_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_5539_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K3 ) ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L: code_integer,J2: code_integer] :
                  ( if @ int
                  @ ( J2
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_5540_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X4: A] :
                  ( ( member @ A @ X4 @ S )
                  & ( ord_less @ B @ ( F2 @ X4 ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_5541_zero__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ int ) ) ).

% zero_integer.rep_eq
thf(fact_5542_int__of__integer__numeral,axiom,
    ! [K: num] :
      ( ( code_int_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ int @ K ) ) ).

% int_of_integer_numeral
thf(fact_5543_plus__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( plus_plus @ code_integer @ X2 @ Xa ) )
      = ( plus_plus @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa ) ) ) ).

% plus_integer.rep_eq
thf(fact_5544_times__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( times_times @ code_integer @ X2 @ Xa ) )
      = ( times_times @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa ) ) ) ).

% times_integer.rep_eq
thf(fact_5545_minus__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( minus_minus @ code_integer @ X2 @ Xa ) )
      = ( minus_minus @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa ) ) ) ).

% minus_integer.rep_eq
thf(fact_5546_divide__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( divide_divide @ code_integer @ X2 @ Xa ) )
      = ( divide_divide @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa ) ) ) ).

% divide_integer.rep_eq
thf(fact_5547_modulo__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( modulo_modulo @ code_integer @ X2 @ Xa ) )
      = ( modulo_modulo @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa ) ) ) ).

% modulo_integer.rep_eq
thf(fact_5548_integer__less__iff,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [K3: code_integer,L: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L ) ) ) ) ).

% integer_less_iff
thf(fact_5549_less__integer_Orep__eq,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [X: code_integer,Xa4: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_integer.rep_eq
thf(fact_5550_integer__less__eq__iff,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [K3: code_integer,L: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L ) ) ) ) ).

% integer_less_eq_iff
thf(fact_5551_less__eq__integer_Orep__eq,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [X: code_integer,Xa4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_eq_integer.rep_eq
thf(fact_5552_unset__bit__integer_Orep__eq,axiom,
    ! [X2: nat,Xa: code_integer] :
      ( ( code_int_of_integer @ ( bit_se2638667681897837118et_bit @ code_integer @ X2 @ Xa ) )
      = ( bit_se2638667681897837118et_bit @ int @ X2 @ ( code_int_of_integer @ Xa ) ) ) ).

% unset_bit_integer.rep_eq
thf(fact_5553_arg__min__if__finite_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S ) @ S ) ) ) ) ).

% arg_min_if_finite(1)
thf(fact_5554_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S: set @ A,Y2: A,F2: A > B] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y2 @ S )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S ) ) @ ( F2 @ Y2 ) ) ) ) ) ) ).

% arg_min_least
thf(fact_5555_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X @ U2 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X @ V5 ) @ ( times_times @ nat @ Y @ U2 ) ) ) )
          @ Xa
          @ X2 ) ) ) ).

% times_int.abs_eq
thf(fact_5556_Gcd__remove0__nat,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite @ nat @ M7 )
     => ( ( gcd_Gcd @ nat @ M7 )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M7 @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_5557_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X2 @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_5558_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_5559_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% iszero_neg_numeral
thf(fact_5560_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( gcd_Gcd @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_5561_eq__Abs__Integ,axiom,
    ! [Z: int] :
      ~ ! [X3: nat,Y3: nat] :
          ( Z
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X3 @ Y3 ) ) ) ).

% eq_Abs_Integ
thf(fact_5562_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [X: A,Y: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X @ Y ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_5563_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ).

% not_iszero_numeral
thf(fact_5564_int_Oabs__induct,axiom,
    ! [P: int > $o,X2: int] :
      ( ! [Y3: product_prod @ nat @ nat] : ( P @ ( abs_Integ @ Y3 ) )
     => ( P @ X2 ) ) ).

% int.abs_induct
thf(fact_5565_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_5566_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z5: A] :
              ( Z5
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_5567_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_5568_nat_Oabs__eq,axiom,
    ! [X2: product_prod @ nat @ nat] :
      ( ( nat2 @ ( abs_Integ @ X2 ) )
      = ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ X2 ) ) ).

% nat.abs_eq
thf(fact_5569_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_5570_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X2 ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_5571_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_5572_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_5573_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X2 @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_5574_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_5575_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_5576_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X2 ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_5577_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_5578_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_5579_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_5580_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_5581_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y2 @ X2 ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_5582_uminus__int_Oabs__eq,axiom,
    ! [X2: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X )
          @ X2 ) ) ) ).

% uminus_int.abs_eq
thf(fact_5583_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_5584_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: product_prod @ nat @ nat] :
          ( ( ring_1_of_int @ A @ ( abs_Integ @ X2 ) )
          = ( product_case_prod @ nat @ nat @ A
            @ ^ [I3: nat,J2: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J2 ) )
            @ X2 ) ) ) ).

% of_int.abs_eq
thf(fact_5585_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) )
        @ Xa
        @ X2 ) ) ).

% less_int.abs_eq
thf(fact_5586_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) )
        @ Xa
        @ X2 ) ) ).

% less_eq_int.abs_eq
thf(fact_5587_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X2 @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_5588_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_5589_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ U2 ) @ ( plus_plus @ nat @ Y @ V5 ) ) )
          @ Xa
          @ X2 ) ) ) ).

% plus_int.abs_eq
thf(fact_5590_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ Y @ U2 ) ) )
          @ Xa
          @ X2 ) ) ) ).

% minus_int.abs_eq
thf(fact_5591_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_5592_semiring__char__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiri4206861660011772517g_char @ A )
        = ( ^ [Uu4: itself @ A] :
              ( gcd_Gcd @ nat
              @ ( collect @ nat
                @ ^ [N: nat] :
                    ( ( semiring_1_of_nat @ A @ N )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% semiring_char_def
thf(fact_5593_num__of__nat_Osimps_I2_J,axiom,
    ! [N2: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( suc @ N2 ) )
          = ( inc @ ( num_of_nat @ N2 ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( suc @ N2 ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_5594_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,P2: B > A,I: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X: B] :
                  ( ( member @ B @ X @ I5 )
                  & ( ( P2 @ X )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P2 @ ( insert @ B @ I @ I5 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P2 @ I5 ) ) )
            & ( ~ ( member @ B @ I @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P2 @ ( insert @ B @ I @ I5 ) )
                = ( times_times @ A @ ( P2 @ I ) @ ( groups1962203154675924110t_prod @ B @ A @ P2 @ I5 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_5595_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q2 ) )
      = Q2 ) ).

% num_of_nat_numeral_eq
thf(fact_5596_Gcd__int__greater__eq__0,axiom,
    ! [K5: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Gcd @ int @ K5 ) ) ).

% Gcd_int_greater_eq_0
thf(fact_5597_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_5598_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I3: B] : ( times_times @ A @ ( G @ I3 ) @ ( H2 @ I3 ) )
              @ I5 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I5 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_5599_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,T5: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T5 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ S ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_5600_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,T5: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
               => ( ( H2 @ I4 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ T5 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_5601_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T5 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_5602_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T5 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T5 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_5603_numeral__num__of__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N2 ) )
        = N2 ) ) ).

% numeral_num_of_nat
thf(fact_5604_num__of__nat__One,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N2 )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_5605_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X: B] :
                  ( ( member @ B @ X @ I5 )
                  & ( ( G @ X )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X: B] :
                    ( ( member @ B @ X @ I5 )
                    & ( ( H2 @ X )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I3: B] : ( times_times @ A @ ( G @ I3 ) @ ( H2 @ I3 ) )
                @ I5 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I5 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_5606_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N2 ) )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_5607_num__of__nat__double,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N2 @ N2 ) )
        = ( bit0 @ ( num_of_nat @ N2 ) ) ) ) ).

% num_of_nat_double
thf(fact_5608_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N2 ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N2 ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_5609_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y: nat,Z5: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y @ V5 ) @ ( plus_plus @ nat @ U2 @ Z5 ) ) )
          @ ( rep_Integ @ X )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_5610_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y: nat,Z5: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y @ V5 ) @ ( plus_plus @ nat @ U2 @ Z5 ) ) )
          @ ( rep_Integ @ X )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_5611_prod__encode__def,axiom,
    ( nat_prod_encode
    = ( product_case_prod @ nat @ nat @ nat
      @ ^ [M3: nat,N: nat] : ( plus_plus @ nat @ ( nat_triangle @ ( plus_plus @ nat @ M3 @ N ) ) @ M3 ) ) ) ).

% prod_encode_def
thf(fact_5612_prod__encode__eq,axiom,
    ! [X2: product_prod @ nat @ nat,Y2: product_prod @ nat @ nat] :
      ( ( ( nat_prod_encode @ X2 )
        = ( nat_prod_encode @ Y2 ) )
      = ( X2 = Y2 ) ) ).

% prod_encode_eq
thf(fact_5613_le__prod__encode__1,axiom,
    ! [A2: nat,B2: nat] : ( ord_less_eq @ nat @ A2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_1
thf(fact_5614_le__prod__encode__2,axiom,
    ! [B2: nat,A2: nat] : ( ord_less_eq @ nat @ B2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_2
thf(fact_5615_nat_Orep__eq,axiom,
    ( nat2
    = ( ^ [X: int] : ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ ( rep_Integ @ X ) ) ) ) ).

% nat.rep_eq
thf(fact_5616_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [X: int] :
              ( product_case_prod @ nat @ nat @ A
              @ ^ [I3: nat,J2: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J2 ) )
              @ ( rep_Integ @ X ) ) ) ) ) ).

% of_int.rep_eq
thf(fact_5617_prod__encode__prod__decode__aux,axiom,
    ! [K: nat,M: nat] :
      ( ( nat_prod_encode @ ( nat_prod_decode_aux @ K @ M ) )
      = ( plus_plus @ nat @ ( nat_triangle @ K ) @ M ) ) ).

% prod_encode_prod_decode_aux
thf(fact_5618_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X ) ) ) ) ).

% uminus_int_def
thf(fact_5619_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X2 @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_5620_pow_Osimps_I3_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( pow @ X2 @ ( bit1 @ Y2 ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X2 @ Y2 ) ) @ X2 ) ) ).

% pow.simps(3)
thf(fact_5621_sqr_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( sqr @ ( bit0 @ N2 ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N2 ) ) ) ) ).

% sqr.simps(2)
thf(fact_5622_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_5623_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X: num] : ( times_times @ num @ X @ X ) ) ) ).

% sqr_conv_mult
thf(fact_5624_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_5625_pow_Osimps_I2_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( pow @ X2 @ ( bit0 @ Y2 ) )
      = ( sqr @ ( pow @ X2 @ Y2 ) ) ) ).

% pow.simps(2)
thf(fact_5626_sqr_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( sqr @ ( bit1 @ N2 ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N2 ) @ N2 ) ) ) ) ).

% sqr.simps(3)
thf(fact_5627_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N2: nat,J: nat,I: nat] :
      ( ( ord_less @ nat @ N2 @ ( minus_minus @ nat @ J @ ( suc @ I ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J ) ) @ N2 )
        = ( suc @ ( plus_plus @ nat @ I @ N2 ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_5628_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X @ U2 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X @ V5 ) @ ( times_times @ nat @ Y @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_5629_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ Y @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_5630_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ U2 ) @ ( plus_plus @ nat @ Y @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_5631_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X: A] : X
              @ X2
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_5632_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N2: nat,J: nat,I: nat] :
      ( ( ord_less @ nat @ N2 @ ( minus_minus @ nat @ J @ I ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J ) ) @ N2 )
        = ( suc @ ( plus_plus @ nat @ I @ N2 ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_5633_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X2 @ Xa )
     => ( ( ? [Uu3: $o,Uv2: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu3 @ Uv2 ) )
         => ( Xa
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( ( Deg2 = Xa )
                & ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                    & ! [X: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi3: nat,Ma3: nat] :
                        ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                        & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I3: nat] :
                            ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary2 @ I3 ) ) )
                        & ( ( Mi3 = Ma3 )
                         => ! [X: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                        & ( ( Mi3 != Ma3 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                            & ! [X: nat] :
                                ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X )
                                 => ( ( ord_less @ nat @ Mi3 @ X )
                                    & ( ord_less_eq @ nat @ X @ Ma3 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_5634_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L2: A,U: A] :
          ( ( member @ A @ I @ ( set_or3652927894154168847AtMost @ A @ L2 @ U ) )
          = ( ( ord_less @ A @ L2 @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_5635_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L2: A,K: A] :
          ( ( ord_less_eq @ A @ L2 @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_5636_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L2 ) )
          = ( ~ ( ord_less @ A @ K @ L2 ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_5637_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L2 ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_5638_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_5639_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Xs2: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs2 ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ).

% length_insort
thf(fact_5640_card__greaterThanAtMost,axiom,
    ! [L2: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or3652927894154168847AtMost @ nat @ L2 @ U ) )
      = ( minus_minus @ nat @ U @ L2 ) ) ).

% card_greaterThanAtMost
thf(fact_5641_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A2 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D3 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A2 )
              & ( ord_less_eq @ A @ D3 @ C2 ) )
            | ( ( A2 = C2 )
              & ( B2 = D3 ) ) ) ) ) ).

% Ioc_inj
thf(fact_5642_atLeastSucAtMost__greaterThanAtMost,axiom,
    ! [L2: nat,U: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ L2 ) @ U )
      = ( set_or3652927894154168847AtMost @ nat @ L2 @ U ) ) ).

% atLeastSucAtMost_greaterThanAtMost
thf(fact_5643_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D3 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D3 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_5644_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_5645_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.head
thf(fact_5646_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.head
thf(fact_5647_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D3 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_5648_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D3 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D3 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_5649_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D3 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D3 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_5650_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or3652927894154168847AtMost @ A )
        = ( ^ [A4: A,B3: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
thf(fact_5651_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X: A] : X
                @ X2
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_5652_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList2 @ Summary ) @ Deg4 )
      = ( ( Deg = Deg4 )
        & ! [X: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
           => ( vEBT_VEBT_valid @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X8 )
            & ! [X: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
               => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi3: nat,Ma3: nat] :
                ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
                & ( ( Mi3 = Ma3 )
                 => ! [X: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                & ( ( Mi3 != Ma3 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                    & ! [X: nat] :
                        ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X )
                         => ( ( ord_less @ nat @ Mi3 @ X )
                            & ( ord_less_eq @ nat @ X @ Ma3 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_5653_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_valid @ X2 @ Xa )
        = Y2 )
     => ( ( ? [Uu3: $o,Uv2: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu3 @ Uv2 ) )
         => ( Y2
            = ( ( Xa
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( Y2
                = ( ~ ( ( Deg2 = Xa )
                      & ! [X: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                          & ! [X: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I3: nat] :
                                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I3 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X: nat] :
                                      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X )
                                       => ( ( ord_less @ nat @ Mi3 @ X )
                                          & ( ord_less_eq @ nat @ X @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_5654_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X2 @ Xa )
     => ( ( ? [Uu3: $o,Uv2: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu3 @ Uv2 ) )
         => ( Xa
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ~ ( ( Deg2 = Xa )
                  & ! [X4: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                      & ! [X: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi3: nat,Ma3: nat] :
                          ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                          & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary2 @ I3 ) ) )
                          & ( ( Mi3 = Ma3 )
                           => ! [X: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                               => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                          & ( ( Mi3 != Ma3 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                              & ! [X: nat] :
                                  ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X )
                                   => ( ( ord_less @ nat @ Mi3 @ X )
                                      & ( ord_less_eq @ nat @ X @ Ma3 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_5655_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_valid @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu3: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu3 @ Uv2 ) )
             => ( ( Y2
                  = ( Xa
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv2 ) @ Xa ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( Y2
                    = ( ( Deg2 = Xa )
                      & ! [X: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                          & ! [X: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I3: nat] :
                                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I3 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X: nat] :
                                      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X )
                                       => ( ( ord_less @ nat @ Mi3 @ X )
                                          & ( ord_less_eq @ nat @ X @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_5656_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu3: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu3 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv2 ) @ Xa ) )
               => ( Xa
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa ) )
                 => ~ ( ( Deg2 = Xa )
                      & ! [X4: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                          & ! [X: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I3: nat] :
                                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I3 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X: nat] :
                                      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X )
                                       => ( ( ord_less @ nat @ Mi3 @ X )
                                          & ( ord_less_eq @ nat @ X @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_5657_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X2 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa ) )
       => ( ! [Uu3: $o,Uv2: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu3 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv2 ) @ Xa ) )
               => ( Xa
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa ) )
                 => ( ( Deg2 = Xa )
                    & ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
                        & ! [X: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi3: nat,Ma3: nat] :
                            ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                            & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I3: nat] :
                                ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary2 @ I3 ) ) )
                            & ( ( Mi3 = Ma3 )
                             => ! [X: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X @ X8 ) ) )
                            & ( ( Mi3 != Ma3 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                & ! [X: nat] :
                                    ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X )
                                     => ( ( ord_less @ nat @ Mi3 @ X )
                                        & ( ord_less_eq @ nat @ X @ Ma3 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_5658_card__greaterThanAtMost__int,axiom,
    ! [L2: int,U: int] :
      ( ( finite_card @ int @ ( set_or3652927894154168847AtMost @ int @ L2 @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ L2 ) ) ) ).

% card_greaterThanAtMost_int
thf(fact_5659_atLeastPlusOneAtMost__greaterThanAtMost__int,axiom,
    ! [L2: int,U: int] :
      ( ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ L2 @ ( one_one @ int ) ) @ U )
      = ( set_or3652927894154168847AtMost @ int @ L2 @ U ) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_int
thf(fact_5660_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P6: A > $o] :
              ( the @ A
              @ ^ [X: A] :
                  ( ( P6 @ X )
                  & ! [Y: A] :
                      ( ( P6 @ Y )
                     => ( ord_less_eq @ A @ Y @ X ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_5661_length__n__lists,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N2 @ Xs2 ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) ) ).

% length_n_lists
thf(fact_5662_set__nths,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs2 @ I5 ) )
      = ( collect @ A
        @ ^ [Uu2: A] :
          ? [I3: nat] :
            ( ( Uu2
              = ( nth @ A @ Xs2 @ I3 ) )
            & ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( member @ nat @ I3 @ I5 ) ) ) ) ).

% set_nths
thf(fact_5663_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_5664_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_5665_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_12: nat] : ( P @ X_12 )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_5666_nths__all,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( member @ nat @ I4 @ I5 ) )
     => ( ( nths @ A @ Xs2 @ I5 )
        = Xs2 ) ) ).

% nths_all
thf(fact_5667_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X2: A,Q: A > $o] :
          ( ( P @ X2 )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X2 ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y4: A] :
                        ( ( P @ Y4 )
                       => ( ord_less_eq @ A @ Y4 @ X3 ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_5668_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X2: A] :
          ( ( P @ X2 )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X2 ) )
           => ( ( order_Greatest @ A @ P )
              = X2 ) ) ) ) ).

% Greatest_equality
thf(fact_5669_length__nths,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs2 @ I5 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I3: nat] :
              ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
              & ( member @ nat @ I3 @ I5 ) ) ) ) ) ).

% length_nths
thf(fact_5670_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( fract @ A2 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_5671_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y2: nat,X2: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y2 )
       => ( ( image @ nat @ nat
            @ ^ [I3: nat] : ( minus_minus @ nat @ I3 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X2 @ Y2 ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X2 @ C2 ) @ ( minus_minus @ nat @ Y2 @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y2 )
       => ( ( ( ord_less @ nat @ X2 @ Y2 )
           => ( ( image @ nat @ nat
                @ ^ [I3: nat] : ( minus_minus @ nat @ I3 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X2 @ Y2 ) )
              = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X2 @ Y2 )
           => ( ( image @ nat @ nat
                @ ^ [I3: nat] : ( minus_minus @ nat @ I3 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X2 @ Y2 ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_5672_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ A @ A @ rep_Integ @ ( id @ A )
          @ ( product_case_prod @ nat @ nat @ A
            @ ^ [I3: nat,J2: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J2 ) ) ) ) ) ) ).

% ring_1_class.of_int_def
thf(fact_5673_of__nat__eq__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( id @ nat ) ) ).

% of_nat_eq_id
thf(fact_5674_id__funpow,axiom,
    ! [A: $tType,N2: nat] :
      ( ( compow @ ( A > A ) @ N2 @ ( id @ A ) )
      = ( id @ A ) ) ).

% id_funpow
thf(fact_5675_bij__betw__Suc,axiom,
    ! [M7: set @ nat,N5: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M7 @ N5 )
      = ( ( image @ nat @ nat @ suc @ M7 )
        = N5 ) ) ).

% bij_betw_Suc
thf(fact_5676_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S )
          = S ) ) ).

% image_add_0
thf(fact_5677_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or1337092689740270186AtMost @ A @ I @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost
thf(fact_5678_image__diff__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [D3: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ D3 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ D3 @ B2 ) @ ( minus_minus @ A @ D3 @ A2 ) ) ) ) ).

% image_diff_atLeastAtMost
thf(fact_5679_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or7035219750837199246ssThan @ A @ I @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan
thf(fact_5680_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_ord_atMost @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( plus_plus @ A @ C2 @ A2 ) ) ) ) ).

% image_add_atMost
thf(fact_5681_bij__betw__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A,B4: set @ A] :
          ( ( bij_betw @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 @ B4 )
          = ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 )
            = B4 ) ) ) ).

% bij_betw_add
thf(fact_5682_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% image_add_greaterThanAtMost
thf(fact_5683_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% push_bit_0_id
thf(fact_5684_drop__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% drop_bit_0
thf(fact_5685_image__Suc__atLeastAtMost,axiom,
    ! [I: nat,J: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ I @ J ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( suc @ I ) @ ( suc @ J ) ) ) ).

% image_Suc_atLeastAtMost
thf(fact_5686_image__Suc__atLeastLessThan,axiom,
    ! [I: nat,J: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ I @ J ) )
      = ( set_or7035219750837199246ssThan @ nat @ ( suc @ I ) @ ( suc @ J ) ) ) ).

% image_Suc_atLeastLessThan
thf(fact_5687_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N: A] : ( plus_plus @ A @ N @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_5688_image__minus__const__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [D3: A,A2: A,B2: A] :
          ( ( image @ A @ A
            @ ^ [T3: A] : ( minus_minus @ A @ T3 @ D3 )
            @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ A2 @ D3 ) @ ( minus_minus @ A @ B2 @ D3 ) ) ) ) ).

% image_minus_const_atLeastAtMost'
thf(fact_5689_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N: A] : ( plus_plus @ A @ N @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_5690_mult__rat,axiom,
    ! [A2: int,B2: int,C2: int,D3: int] :
      ( ( times_times @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D3 ) )
      = ( fract @ ( times_times @ int @ A2 @ C2 ) @ ( times_times @ int @ B2 @ D3 ) ) ) ).

% mult_rat
thf(fact_5691_divide__rat,axiom,
    ! [A2: int,B2: int,C2: int,D3: int] :
      ( ( divide_divide @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D3 ) )
      = ( fract @ ( times_times @ int @ A2 @ D3 ) @ ( times_times @ int @ B2 @ C2 ) ) ) ).

% divide_rat
thf(fact_5692_floor__Fract,axiom,
    ! [A2: int,B2: int] :
      ( ( archim6421214686448440834_floor @ rat @ ( fract @ A2 @ B2 ) )
      = ( divide_divide @ int @ A2 @ B2 ) ) ).

% floor_Fract
thf(fact_5693_image__minus__const__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( minus_minus @ A @ C2 @ B2 ) @ ( minus_minus @ A @ C2 @ A2 ) ) ) ) ).

% image_minus_const_greaterThanAtMost
thf(fact_5694_image__diff__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( minus_minus @ A @ C2 @ B2 ) @ ( minus_minus @ A @ C2 @ A2 ) ) ) ) ).

% image_diff_atLeastLessThan
thf(fact_5695_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D3: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D3 )
         => ( ( image @ A @ A @ ( times_times @ A @ D3 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D3 @ A2 ) @ ( times_times @ A @ D3 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_5696_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D3: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D3 )
         => ( ( image @ A @ A
              @ ^ [C3: A] : ( divide_divide @ A @ C3 @ D3 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D3 ) @ ( divide_divide @ A @ B2 @ D3 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_5697_less__rat,axiom,
    ! [B2: int,D3: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D3
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D3 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D3 ) @ ( times_times @ int @ B2 @ D3 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D3 ) ) ) ) ) ) ).

% less_rat
thf(fact_5698_add__rat,axiom,
    ! [B2: int,D3: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D3
         != ( zero_zero @ int ) )
       => ( ( plus_plus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D3 ) )
          = ( fract @ ( plus_plus @ int @ ( times_times @ int @ A2 @ D3 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D3 ) ) ) ) ) ).

% add_rat
thf(fact_5699_le__rat,axiom,
    ! [B2: int,D3: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D3
         != ( zero_zero @ int ) )
       => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D3 ) )
          = ( ord_less_eq @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D3 ) @ ( times_times @ int @ B2 @ D3 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D3 ) ) ) ) ) ) ).

% le_rat
thf(fact_5700_diff__rat,axiom,
    ! [B2: int,D3: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D3
         != ( zero_zero @ int ) )
       => ( ( minus_minus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D3 ) )
          = ( fract @ ( minus_minus @ int @ ( times_times @ int @ A2 @ D3 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D3 ) ) ) ) ) ).

% diff_rat
thf(fact_5701_sgn__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( sgn_sgn @ rat @ ( fract @ A2 @ B2 ) )
      = ( ring_1_of_int @ rat @ ( times_times @ int @ ( sgn_sgn @ int @ A2 ) @ ( sgn_sgn @ int @ B2 ) ) ) ) ).

% sgn_rat
thf(fact_5702_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( times_times @ int @ C2 @ A2 ) @ ( times_times @ int @ C2 @ B2 ) )
        = ( fract @ A2 @ B2 ) ) ) ).

% mult_rat_cancel
thf(fact_5703_eq__rat_I1_J,axiom,
    ! [B2: int,D3: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D3
         != ( zero_zero @ int ) )
       => ( ( ( fract @ A2 @ B2 )
            = ( fract @ C2 @ D3 ) )
          = ( ( times_times @ int @ A2 @ D3 )
            = ( times_times @ int @ C2 @ B2 ) ) ) ) ) ).

% eq_rat(1)
thf(fact_5704_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 )
      = ( id @ A ) ) ).

% funpow_simps_right(1)
thf(fact_5705_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B4: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ ( image @ B @ A @ F2 @ B4 ) ) @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) ) ).

% image_diff_subset
thf(fact_5706_eq__rat_I2_J,axiom,
    ! [A2: int] :
      ( ( fract @ A2 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_5707_Rat__induct__pos,axiom,
    ! [P: rat > $o,Q2: rat] :
      ( ! [A6: int,B6: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
         => ( P @ ( fract @ A6 @ B6 ) ) )
     => ( P @ Q2 ) ) ).

% Rat_induct_pos
thf(fact_5708_translation__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S2: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( minus_minus @ ( set @ A ) @ S2 @ T2 ) )
          = ( minus_minus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S2 ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_diff
thf(fact_5709_zero__notin__Suc__image,axiom,
    ! [A3: set @ nat] :
      ~ ( member @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ A3 ) ) ).

% zero_notin_Suc_image
thf(fact_5710_eq__rat_I3_J,axiom,
    ! [A2: int,C2: int] :
      ( ( fract @ ( zero_zero @ int ) @ A2 )
      = ( fract @ ( zero_zero @ int ) @ C2 ) ) ).

% eq_rat(3)
thf(fact_5711_translation__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Compl
thf(fact_5712_rat__number__collapse_I6_J,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(6)
thf(fact_5713_rat__number__collapse_I1_J,axiom,
    ! [K: int] :
      ( ( fract @ ( zero_zero @ int ) @ K )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(1)
thf(fact_5714_Fract__coprime,axiom,
    ! [A2: int,B2: int] :
      ( ( fract @ ( divide_divide @ int @ A2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) @ ( divide_divide @ int @ B2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) )
      = ( fract @ A2 @ B2 ) ) ).

% Fract_coprime
thf(fact_5715_less__int__def,axiom,
    ( ( ord_less @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) ) ) ) ).

% less_int_def
thf(fact_5716_less__eq__int__def,axiom,
    ( ( ord_less_eq @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) ) ) ) ).

% less_eq_int_def
thf(fact_5717_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A7: set @ A] :
          ? [N: nat,F4: nat > A] :
            ( A7
            = ( image @ nat @ A @ F4
              @ ( collect @ nat
                @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_5718_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A3: set @ A,F2: nat > A,N2: nat] :
      ( ( A3
        = ( image @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N2 ) ) ) )
     => ( finite_finite @ A @ A3 ) ) ).

% nat_seg_image_imp_finite
thf(fact_5719_translation__subtract__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S2: set @ A,T2: set @ A] :
          ( ( image @ A @ A
            @ ^ [X: A] : ( minus_minus @ A @ X @ A2 )
            @ ( minus_minus @ ( set @ A ) @ S2 @ T2 ) )
          = ( minus_minus @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X: A] : ( minus_minus @ A @ X @ A2 )
              @ S2 )
            @ ( image @ A @ A
              @ ^ [X: A] : ( minus_minus @ A @ X @ A2 )
              @ T2 ) ) ) ) ).

% translation_subtract_diff
thf(fact_5720_translation__subtract__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A
            @ ^ [X: A] : ( minus_minus @ A @ X @ A2 )
            @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X: A] : ( minus_minus @ A @ X @ A2 )
              @ T2 ) ) ) ) ).

% translation_subtract_Compl
thf(fact_5721_nat__def,axiom,
    ( nat2
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ nat @ nat @ rep_Integ @ ( id @ nat ) @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ) ).

% nat_def
thf(fact_5722_card__image__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F2 @ A3 ) ) @ ( finite_card @ A @ A3 ) ) ) ).

% card_image_le
thf(fact_5723_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_5724_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K3: num] : ( fract @ ( numeral_numeral @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_5725_rat__number__collapse_I3_J,axiom,
    ! [W: num] :
      ( ( fract @ ( numeral_numeral @ int @ W ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W ) ) ).

% rat_number_collapse(3)
thf(fact_5726_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X3: B,Y3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ( member @ B @ Y3 @ A3 )
                 => ( ( X3 != Y3 )
                   => ( ( ( H2 @ X3 )
                        = ( H2 @ Y3 ) )
                     => ( ( G @ ( H2 @ X3 ) )
                        = ( zero_zero @ A ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( image @ B @ C @ H2 @ A3 ) )
              = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A3 ) ) ) ) ) ).

% sum.reindex_nontrivial
thf(fact_5727_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ B4 @ ( image @ A @ B @ F2 @ A3 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B4 ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% surj_card_le
thf(fact_5728_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,X2: A,Y2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( image @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ Y2 ) ) ) ) ) ).

% scaleR_image_atLeastAtMost
thf(fact_5729_image__Suc__lessThan,axiom,
    ! [N2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ).

% image_Suc_lessThan
thf(fact_5730_image__Suc__atMost,axiom,
    ! [N2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( suc @ N2 ) ) ) ).

% image_Suc_atMost
thf(fact_5731_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast0_atMost_Suc_eq_insert_0
thf(fact_5732_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
thf(fact_5733_lessThan__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% lessThan_Suc_eq_insert_0
thf(fact_5734_atMost__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% atMost_Suc_eq_insert_0
thf(fact_5735_Fract__less__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_less_zero_iff
thf(fact_5736_zero__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_less_Fract_iff
thf(fact_5737_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ B2 @ A2 ) ) ) ).

% one_less_Fract_iff
thf(fact_5738_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A2 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_5739_Fract__add__one,axiom,
    ! [N2: int,M: int] :
      ( ( N2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M @ N2 ) @ N2 )
        = ( plus_plus @ rat @ ( fract @ M @ N2 ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_5740_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I5: set @ C,G: A > B,F2: C > A] :
          ( ( finite_finite @ C @ I5 )
         => ( ! [I4: C] :
                ( ( member @ C @ I4 @ I5 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F2 @ I4 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image @ C @ A @ F2 @ I5 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F2 ) @ I5 ) ) ) ) ) ).

% sum_image_le
thf(fact_5741_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_le_Fract_iff
thf(fact_5742_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_le_zero_iff
thf(fact_5743_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A2 ) ) ) ).

% one_le_Fract_iff
thf(fact_5744_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A2 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_5745_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_5746_rat__number__collapse_I4_J,axiom,
    ! [W: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) ) ).

% rat_number_collapse(4)
thf(fact_5747_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X2: A,Y2: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X2 ) @ ( times_times @ A @ C2 @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X2 @ Y2 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y2 ) @ ( times_times @ A @ C2 @ X2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X2 @ Y2 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_5748_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( times_times @ A @ X @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X2 @ C2 ) @ ( times_times @ A @ Y2 @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( times_times @ A @ X @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y2 @ C2 ) @ ( times_times @ A @ X2 @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( image @ A @ A
                @ ^ [X: A] : ( times_times @ A @ X @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_5749_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_5750_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_5751_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X: A] : ( plus_plus @ A @ ( divide_divide @ A @ X @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( plus_plus @ A @ ( divide_divide @ A @ X @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( plus_plus @ A @ ( divide_divide @ A @ X @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_5752_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X: A] : ( minus_minus @ A @ ( divide_divide @ A @ X @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( minus_minus @ A @ ( divide_divide @ A @ X @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X: A] : ( minus_minus @ A @ ( divide_divide @ A @ X @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_5753_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S: set @ A,R3: set @ B,G: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S )
         => ( ( finite_finite @ B @ R3 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G @ S ) @ R3 )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X: A] : ( F2 @ ( G @ X ) )
                  @ S )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X: A] :
                                ( ( member @ A @ X @ S )
                                & ( ( G @ X )
                                  = Y ) ) ) ) )
                      @ ( F2 @ Y ) )
                  @ R3 ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_5754_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q4: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q4 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N2 ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_5755_positive__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( positive @ ( fract @ A2 @ B2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ A2 @ B2 ) ) ) ).

% positive_rat
thf(fact_5756_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B2 )
             => ? [C4: A] :
                  ( ( ord_less_eq @ A @ A2 @ C4 )
                  & ( ord_less_eq @ A @ C4 @ B2 )
                  & ! [X4: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X4 )
                        & ( ord_less @ A @ X4 @ C4 ) )
                     => ( P @ X4 ) )
                  & ! [D4: A] :
                      ( ! [X3: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X3 )
                            & ( ord_less @ A @ X3 @ D4 ) )
                         => ( P @ X3 ) )
                     => ( ord_less_eq @ A @ D4 @ C4 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_5757_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_5758_take__bit__num__simps_I2_J,axiom,
    ! [N2: nat] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_5759_take__bit__num__simps_I5_J,axiom,
    ! [R: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(5)
thf(fact_5760_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N2: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N2 ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_5761_Rat_Opositive__zero,axiom,
    ~ ( positive @ ( zero_zero @ rat ) ) ).

% Rat.positive_zero
thf(fact_5762_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N2: nat] :
      ( ( bit_take_bit_num @ N2 @ one2 )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N: nat] : ( some @ num @ one2 )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
thf(fact_5763_Rat_Opositive__add,axiom,
    ! [X2: rat,Y2: rat] :
      ( ( positive @ X2 )
     => ( ( positive @ Y2 )
       => ( positive @ ( plus_plus @ rat @ X2 @ Y2 ) ) ) ) ).

% Rat.positive_add
thf(fact_5764_Rat_Opositive__mult,axiom,
    ! [X2: rat,Y2: rat] :
      ( ( positive @ X2 )
     => ( ( positive @ Y2 )
       => ( positive @ ( times_times @ rat @ X2 @ Y2 ) ) ) ) ).

% Rat.positive_mult
thf(fact_5765_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: num,Q2: num] :
          ( ( ( bit_take_bit_num @ M @ N2 )
            = ( some @ num @ Q2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% take_bit_num_eq_Some_imp
thf(fact_5766_in__image__insert__iff,axiom,
    ! [A: $tType,B4: set @ ( set @ A ),X2: A,A3: set @ A] :
      ( ! [C7: set @ A] :
          ( ( member @ ( set @ A ) @ C7 @ B4 )
         => ~ ( member @ A @ X2 @ C7 ) )
     => ( ( member @ ( set @ A ) @ A3 @ ( image @ ( set @ A ) @ ( set @ A ) @ ( insert @ A @ X2 ) @ B4 ) )
        = ( ( member @ A @ X2 @ A3 )
          & ( member @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) ) ) ) ).

% in_image_insert_iff
thf(fact_5767_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A2: A] :
        ? [B6: A] :
          ( ( ord_less @ A @ A2 @ B6 )
          | ( ord_less @ A @ B6 @ A2 ) ) ) ).

% ex_gt_or_lt
thf(fact_5768_Rat_Opositive__minus,axiom,
    ! [X2: rat] :
      ( ~ ( positive @ X2 )
     => ( ( X2
         != ( zero_zero @ rat ) )
       => ( positive @ ( uminus_uminus @ rat @ X2 ) ) ) ) ).

% Rat.positive_minus
thf(fact_5769_less__rat__def,axiom,
    ( ( ord_less @ rat )
    = ( ^ [X: rat,Y: rat] : ( positive @ ( minus_minus @ rat @ Y @ X ) ) ) ) ).

% less_rat_def
thf(fact_5770_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: num] :
          ( ( ( bit_take_bit_num @ M @ N2 )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_5771_image__add__int__atLeastLessThan,axiom,
    ! [L2: int,U: int] :
      ( ( image @ int @ int
        @ ^ [X: int] : ( plus_plus @ int @ X @ L2 )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U @ L2 ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L2 @ U ) ) ).

% image_add_int_atLeastLessThan
thf(fact_5772_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N: nat,M3: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( numeral_numeral @ nat @ M3 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ ( numeral_numeral @ nat @ M3 ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_5773_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ U )
     => ( ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U )
        = ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_ord_lessThan @ nat @ ( nat2 @ U ) ) ) ) ) ).

% image_atLeastZeroLessThan_int
thf(fact_5774_and__minus__numerals_I7_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N2 ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_5775_and__minus__numerals_I3_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N2 ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_5776_and__minus__numerals_I8_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N2 ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_5777_take__bit__num__simps_I4_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N2 @ M ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_5778_take__bit__num__simps_I3_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ N2 @ M ) ) ) ).

% take_bit_num_simps(3)
thf(fact_5779_take__bit__num__simps_I7_J,axiom,
    ! [R: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M ) ) ) ) ).

% take_bit_num_simps(7)
thf(fact_5780_take__bit__num__simps_I6_J,axiom,
    ! [R: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M ) ) ) ).

% take_bit_num_simps(6)
thf(fact_5781_and__minus__numerals_I4_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N2 ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_5782_and__not__num_Osimps_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(8)
thf(fact_5783_and__not__num_Osimps_I1_J,axiom,
    ( ( bit_and_not_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% and_not_num.simps(1)
thf(fact_5784_and__not__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(4)
thf(fact_5785_and__not__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_and_not_num @ one2 @ ( bit0 @ N2 ) )
      = ( some @ num @ one2 ) ) ).

% and_not_num.simps(2)
thf(fact_5786_and__not__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_and_not_num @ one2 @ ( bit1 @ N2 ) )
      = ( none @ num ) ) ).

% and_not_num.simps(3)
thf(fact_5787_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ N2 @ ( bit0 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N: nat] :
            ( case_option @ ( option @ num ) @ num @ ( none @ num )
            @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
            @ ( bit_take_bit_num @ N @ M ) )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
thf(fact_5788_and__not__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(7)
thf(fact_5789_and__not__num__eq__Some__iff,axiom,
    ! [M: num,N2: num,Q2: num] :
      ( ( ( bit_and_not_num @ M @ N2 )
        = ( some @ num @ Q2 ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
        = ( numeral_numeral @ int @ Q2 ) ) ) ).

% and_not_num_eq_Some_iff
thf(fact_5790_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ N2 @ ( bit1 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N: nat] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N @ M ) ) )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
thf(fact_5791_and__not__num__eq__None__iff,axiom,
    ! [M: num,N2: num] :
      ( ( ( bit_and_not_num @ M @ N2 )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_5792_int__numeral__not__and__num,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N2 @ M ) ) ) ).

% int_numeral_not_and_num
thf(fact_5793_int__numeral__and__not__num,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% int_numeral_and_not_num
thf(fact_5794_Rat_Opositive_Orep__eq,axiom,
    ( positive
    = ( ^ [X: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ ( rep_Rat @ X ) ) @ ( product_snd @ int @ int @ ( rep_Rat @ X ) ) ) ) ) ) ).

% Rat.positive.rep_eq
thf(fact_5795_nth__image,axiom,
    ! [A: $tType,L2: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ L2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( image @ nat @ A @ ( nth @ A @ Xs2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L2 ) )
        = ( set2 @ A @ ( take @ A @ L2 @ Xs2 ) ) ) ) ).

% nth_image
thf(fact_5796_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K3 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L: code_integer,J2: code_integer] :
                ( if @ num
                @ ( J2
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L ) @ ( code_num_of_integer @ L ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L ) @ ( code_num_of_integer @ L ) ) @ one2 ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_5797_take__all__iff,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ( take @ A @ N2 @ Xs2 )
        = Xs2 )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) ) ).

% take_all_iff
thf(fact_5798_take__all,axiom,
    ! [A: $tType,Xs2: list @ A,N2: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 )
     => ( ( take @ A @ N2 @ Xs2 )
        = Xs2 ) ) ).

% take_all
thf(fact_5799_nth__take,axiom,
    ! [A: $tType,I: nat,N2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I @ N2 )
     => ( ( nth @ A @ ( take @ A @ N2 @ Xs2 ) @ I )
        = ( nth @ A @ Xs2 @ I ) ) ) ).

% nth_take
thf(fact_5800_take__update__cancel,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs2: list @ A,Y2: A] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( take @ A @ N2 @ ( list_update @ A @ Xs2 @ M @ Y2 ) )
        = ( take @ A @ N2 @ Xs2 ) ) ) ).

% take_update_cancel
thf(fact_5801_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N2: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M @ Xs2 ) ) @ ( set2 @ A @ ( take @ A @ N2 @ Xs2 ) ) ) ) ).

% set_take_subset_set_take
thf(fact_5802_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,Ys2: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys2 ) )
       => ( ! [I4: nat] :
              ( ( ord_less @ nat @ I4 @ K )
             => ( ( nth @ A @ Xs2 @ I4 )
                = ( nth @ A @ Ys2 @ I4 ) ) )
         => ( ( take @ A @ K @ Xs2 )
            = ( take @ A @ K @ Ys2 ) ) ) ) ) ).

% nth_take_lemma
thf(fact_5803_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,Bs: list @ $o] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( take @ $o @ N2 @ Bs ) ) ) ) ).

% take_bit_horner_sum_bit_eq
thf(fact_5804_Rat_Opositive__def,axiom,
    ( positive
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ $o @ $o @ rep_Rat @ ( id @ $o )
      @ ^ [X: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ).

% Rat.positive_def
thf(fact_5805_and__not__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y2: option @ num] :
      ( ( ( bit_and_not_num @ X2 @ Xa )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y2
             != ( none @ num ) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N3: num] :
                  ( Xa
                  = ( bit0 @ N3 ) )
             => ( Y2
               != ( some @ num @ one2 ) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N3: num] :
                    ( Xa
                    = ( bit1 @ N3 ) )
               => ( Y2
                 != ( none @ num ) ) ) )
           => ( ! [M4: num] :
                  ( ( X2
                    = ( bit0 @ M4 ) )
                 => ( ( Xa = one2 )
                   => ( Y2
                     != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X2
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa
                          = ( bit0 @ N3 ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X2
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit1 @ N3 ) )
                         => ( Y2
                           != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X2
                          = ( bit1 @ M4 ) )
                       => ( ( Xa = one2 )
                         => ( Y2
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X2
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa
                                = ( bit0 @ N3 ) )
                             => ( Y2
                               != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                  @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                  @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X2
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit1 @ N3 ) )
                               => ( Y2
                                 != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
thf(fact_5806_Bit__Operations_Otake__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N: nat,M3: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A4: nat,X: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P4: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
                      @ ( bit_take_bit_num @ O @ P4 ) )
                  @ ^ [P4: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O @ P4 ) ) )
                  @ X )
              @ A4 )
          @ ( product_Pair @ nat @ num @ N @ M3 ) ) ) ) ).

% Bit_Operations.take_bit_num_code
thf(fact_5807_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: num > A,F32: num > A,Num: num] :
      ( ( H2 @ ( case_num @ A @ F1 @ F22 @ F32 @ Num ) )
      = ( case_num @ B @ ( H2 @ F1 )
        @ ^ [X: num] : ( H2 @ ( F22 @ X ) )
        @ ^ [X: num] : ( H2 @ ( F32 @ X ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_5808_and__not__num_Osimps_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(5)
thf(fact_5809_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A,X22: num] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X22 ) )
      = ( F22 @ X22 ) ) ).

% verit_eq_simplify(17)
thf(fact_5810_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(16)
thf(fact_5811_and__not__num_Osimps_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(9)
thf(fact_5812_and__not__num_Osimps_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(6)
thf(fact_5813_and__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y2: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X2 @ Xa )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y2
             != ( some @ num @ one2 ) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N3: num] :
                  ( Xa
                  = ( bit0 @ N3 ) )
             => ( Y2
               != ( none @ num ) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N3: num] :
                    ( Xa
                    = ( bit1 @ N3 ) )
               => ( Y2
                 != ( some @ num @ one2 ) ) ) )
           => ( ( ? [M4: num] :
                    ( X2
                    = ( bit0 @ M4 ) )
               => ( ( Xa = one2 )
                 => ( Y2
                   != ( none @ num ) ) ) )
             => ( ! [M4: num] :
                    ( ( X2
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa
                          = ( bit0 @ N3 ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X2
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit1 @ N3 ) )
                         => ( Y2
                           != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
                 => ( ( ? [M4: num] :
                          ( X2
                          = ( bit1 @ M4 ) )
                     => ( ( Xa = one2 )
                       => ( Y2
                         != ( some @ num @ one2 ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X2
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa
                                = ( bit0 @ N3 ) )
                             => ( Y2
                               != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X2
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit1 @ N3 ) )
                               => ( Y2
                                 != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                    @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                    @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
thf(fact_5814_xor__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y2: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X2 @ Xa )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y2
             != ( none @ num ) ) ) )
       => ( ( ( X2 = one2 )
           => ! [N3: num] :
                ( ( Xa
                  = ( bit0 @ N3 ) )
               => ( Y2
                 != ( some @ num @ ( bit1 @ N3 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit1 @ N3 ) )
                 => ( Y2
                   != ( some @ num @ ( bit0 @ N3 ) ) ) ) )
           => ( ! [M4: num] :
                  ( ( X2
                    = ( bit0 @ M4 ) )
                 => ( ( Xa = one2 )
                   => ( Y2
                     != ( some @ num @ ( bit1 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X2
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa
                          = ( bit0 @ N3 ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X2
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit1 @ N3 ) )
                         => ( Y2
                           != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X2
                          = ( bit1 @ M4 ) )
                       => ( ( Xa = one2 )
                         => ( Y2
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X2
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa
                                = ( bit0 @ N3 ) )
                             => ( Y2
                               != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X2
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit1 @ N3 ) )
                               => ( Y2
                                 != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
thf(fact_5815_of__rat__def,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A )
        = ( map_fun @ rat @ ( product_prod @ int @ int ) @ A @ A @ rep_Rat @ ( id @ A )
          @ ^ [X: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ).

% of_rat_def
thf(fact_5816_zero__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( zero_zero @ A )
            = ( field_char_0_of_rat @ A @ A2 ) )
          = ( ( zero_zero @ rat )
            = A2 ) ) ) ).

% zero_eq_of_rat_iff
thf(fact_5817_of__rat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( field_char_0_of_rat @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ rat ) ) ) ) ).

% of_rat_eq_0_iff
thf(fact_5818_of__rat__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( zero_zero @ rat ) )
        = ( zero_zero @ A ) ) ) ).

% of_rat_0
thf(fact_5819_of__rat__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] :
          ( ( field_char_0_of_rat @ A @ ( numeral_numeral @ rat @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_rat_numeral_eq
thf(fact_5820_zero__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less @ rat @ ( zero_zero @ rat ) @ R ) ) ) ).

% zero_less_of_rat_iff
thf(fact_5821_of__rat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R ) @ ( zero_zero @ A ) )
          = ( ord_less @ rat @ R @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_less_0_iff
thf(fact_5822_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less @ rat @ ( one_one @ rat ) @ R ) ) ) ).

% one_less_of_rat_iff
thf(fact_5823_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R ) @ ( one_one @ A ) )
          = ( ord_less @ rat @ R @ ( one_one @ rat ) ) ) ) ).

% of_rat_less_1_iff
thf(fact_5824_of__rat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ rat @ R @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_le_0_iff
thf(fact_5825_zero__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ R ) ) ) ).

% zero_le_of_rat_iff
thf(fact_5826_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less_eq @ rat @ ( one_one @ rat ) @ R ) ) ) ).

% one_le_of_rat_iff
thf(fact_5827_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R ) @ ( one_one @ A ) )
          = ( ord_less_eq @ rat @ R @ ( one_one @ rat ) ) ) ) ).

% of_rat_le_1_iff
thf(fact_5828_of__rat__neg__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] :
          ( ( field_char_0_of_rat @ A @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_rat_neg_numeral_eq
thf(fact_5829_of__rat__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,N2: nat] :
          ( ( field_char_0_of_rat @ A @ ( power_power @ rat @ A2 @ N2 ) )
          = ( power_power @ A @ ( field_char_0_of_rat @ A @ A2 ) @ N2 ) ) ) ).

% of_rat_power
thf(fact_5830_of__rat__dense,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ? [Q3: rat] :
          ( ( ord_less @ real @ X2 @ ( field_char_0_of_rat @ real @ Q3 ) )
          & ( ord_less @ real @ ( field_char_0_of_rat @ real @ Q3 ) @ Y2 ) ) ) ).

% of_rat_dense
thf(fact_5831_of__rat__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat,S2: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R ) @ ( field_char_0_of_rat @ A @ S2 ) )
          = ( ord_less @ rat @ R @ S2 ) ) ) ).

% of_rat_less
thf(fact_5832_of__rat__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( plus_plus @ rat @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_add
thf(fact_5833_of__rat__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat,S2: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R ) @ ( field_char_0_of_rat @ A @ S2 ) )
          = ( ord_less_eq @ rat @ R @ S2 ) ) ) ).

% of_rat_less_eq
thf(fact_5834_of__rat__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( times_times @ rat @ A2 @ B2 ) )
          = ( times_times @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_mult
thf(fact_5835_of__rat__diff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( minus_minus @ rat @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_diff
thf(fact_5836_of__rat__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( divide_divide @ rat @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_divide
thf(fact_5837_and__num_Osimps_I1_J,axiom,
    ( ( bit_un7362597486090784418nd_num @ one2 @ one2 )
    = ( some @ num @ one2 ) ) ).

% and_num.simps(1)
thf(fact_5838_xor__num_Osimps_I1_J,axiom,
    ( ( bit_un2480387367778600638or_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% xor_num.simps(1)
thf(fact_5839_and__num_Osimps_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(5)
thf(fact_5840_xor__num_Osimps_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ).

% xor_num.simps(5)
thf(fact_5841_nonzero__of__rat__inverse,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( A2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( inverse_inverse @ rat @ A2 ) )
            = ( inverse_inverse @ A @ ( field_char_0_of_rat @ A @ A2 ) ) ) ) ) ).

% nonzero_of_rat_inverse
thf(fact_5842_nonzero__of__rat__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: rat,A2: rat] :
          ( ( B2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( divide_divide @ rat @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ) ).

% nonzero_of_rat_divide
thf(fact_5843_and__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit1 @ N2 ) )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(3)
thf(fact_5844_and__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(7)
thf(fact_5845_and__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit0 @ N2 ) )
      = ( none @ num ) ) ).

% and_num.simps(2)
thf(fact_5846_and__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ one2 )
      = ( none @ num ) ) ).

% and_num.simps(4)
thf(fact_5847_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num,Q2: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N2 )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% and_num_eq_Some_iff
thf(fact_5848_of__rat__rat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: int,A2: int] :
          ( ( B2
           != ( zero_zero @ int ) )
         => ( ( field_char_0_of_rat @ A @ ( fract @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) ) ) ) ).

% of_rat_rat
thf(fact_5849_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num,Q2: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N2 )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% xor_num_eq_Some_iff
thf(fact_5850_xor__num_Osimps_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ).

% xor_num.simps(9)
thf(fact_5851_and__num_Osimps_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(6)
thf(fact_5852_and__num_Osimps_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(8)
thf(fact_5853_xor__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% xor_num.simps(7)
thf(fact_5854_xor__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit1 @ M ) ) ) ).

% xor_num.simps(4)
thf(fact_5855_xor__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit1 @ N2 ) )
      = ( some @ num @ ( bit0 @ N2 ) ) ) ).

% xor_num.simps(3)
thf(fact_5856_xor__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit0 @ N2 ) )
      = ( some @ num @ ( bit1 @ N2 ) ) ) ).

% xor_num.simps(2)
thf(fact_5857_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N2 )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_5858_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N2 )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_5859_of__rat_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A )
        = ( ^ [X: rat] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ ( rep_Rat @ X ) ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ ( rep_Rat @ X ) ) ) ) ) ) ) ).

% of_rat.rep_eq
thf(fact_5860_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ) ).

% numeral_and_num
thf(fact_5861_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ) ).

% numeral_xor_num
thf(fact_5862_and__num_Osimps_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(9)
thf(fact_5863_xor__num_Osimps_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ) ).

% xor_num.simps(8)
thf(fact_5864_xor__num_Osimps_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ) ).

% xor_num.simps(6)
thf(fact_5865_plus__rat__def,axiom,
    ( ( plus_plus @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y ) @ ( product_snd @ int @ int @ X ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) ) ) ) ).

% plus_rat_def
thf(fact_5866_inverse__rat__def,axiom,
    ( ( inverse_inverse @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int )
          @ ( ( product_fst @ int @ int @ X )
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) ) ) ) ).

% inverse_rat_def
thf(fact_5867_times__rat__def,axiom,
    ( ( times_times @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_fst @ int @ int @ Y ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) ) ) ) ).

% times_rat_def
thf(fact_5868_Fract_Oabs__eq,axiom,
    ( fract
    = ( ^ [Xa4: int,X: int] :
          ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( X
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ Xa4 @ X ) ) ) ) ) ).

% Fract.abs_eq
thf(fact_5869_zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ) ).

% zero_rat_def
thf(fact_5870_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
thf(fact_5871_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
thf(fact_5872_plus__rat_Oabs__eq,axiom,
    ! [Xa: product_prod @ int @ int,X2: product_prod @ int @ int] :
      ( ( ratrel @ Xa @ Xa )
     => ( ( ratrel @ X2 @ X2 )
       => ( ( plus_plus @ rat @ ( abs_Rat @ Xa ) @ ( abs_Rat @ X2 ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X2 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ) ) ).

% plus_rat.abs_eq
thf(fact_5873_ratrel__iff,axiom,
    ( ratrel
    = ( ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ).

% ratrel_iff
thf(fact_5874_zero__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ).

% zero_rat.rsp
thf(fact_5875_ratrel__def,axiom,
    ( ratrel
    = ( ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ).

% ratrel_def
thf(fact_5876_of__rat_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [X2: product_prod @ int @ int] :
          ( ( ratrel @ X2 @ X2 )
         => ( ( field_char_0_of_rat @ A @ ( abs_Rat @ X2 ) )
            = ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X2 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ) ).

% of_rat.abs_eq
thf(fact_5877_times__rat_Oabs__eq,axiom,
    ! [Xa: product_prod @ int @ int,X2: product_prod @ int @ int] :
      ( ( ratrel @ Xa @ Xa )
     => ( ( ratrel @ X2 @ X2 )
       => ( ( times_times @ rat @ ( abs_Rat @ Xa ) @ ( abs_Rat @ X2 ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa ) @ ( product_fst @ int @ int @ X2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ) ) ).

% times_rat.abs_eq
thf(fact_5878_Rat_Opositive_Oabs__eq,axiom,
    ! [X2: product_prod @ int @ int] :
      ( ( ratrel @ X2 @ X2 )
     => ( ( positive @ ( abs_Rat @ X2 ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ).

% Rat.positive.abs_eq
thf(fact_5879_inverse__rat_Oabs__eq,axiom,
    ! [X2: product_prod @ int @ int] :
      ( ( ratrel @ X2 @ X2 )
     => ( ( inverse_inverse @ rat @ ( abs_Rat @ X2 ) )
        = ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_fst @ int @ int @ X2 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) ) ) ) ) ).

% inverse_rat.abs_eq
thf(fact_5880_lex__take__index,axiom,
    ! [A: $tType,Xs2: list @ A,Ys2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys2 ) @ ( lex @ A @ R ) )
     => ~ ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Ys2 ) )
             => ( ( ( take @ A @ I4 @ Xs2 )
                  = ( take @ A @ I4 @ Ys2 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs2 @ I4 ) @ ( nth @ A @ Ys2 @ I4 ) ) @ R ) ) ) ) ) ).

% lex_take_index
thf(fact_5881_dual__min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( min @ A
          @ ^ [X: A,Y: A] : ( ord_less_eq @ A @ Y @ X ) )
        = ( ord_max @ A ) ) ) ).

% dual_min
thf(fact_5882_card__Min__le__sum,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ ( finite_card @ A @ A3 ) @ ( lattic643756798350308766er_Min @ nat @ ( image @ A @ nat @ F2 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) ) ) ).

% card_Min_le_sum
thf(fact_5883_Min__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A] :
          ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
          = X2 ) ) ).

% Min_singleton
thf(fact_5884_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X2 @ ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less_eq @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Min.bounded_iff
thf(fact_5885_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X2 @ ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Min_gr_iff
thf(fact_5886_Min__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [Uu2: B] : C2
                  @ A3 ) )
              = C2 ) ) ) ) ).

% Min_const
thf(fact_5887_Min__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ A3 ) ) ) ) ).

% Min_in
thf(fact_5888_Min_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ A2 ) ) ) ) ).

% Min.coboundedI
thf(fact_5889_Min__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [Y3: A] :
                ( ( member @ A @ Y3 @ A3 )
               => ( ord_less_eq @ A @ X2 @ Y3 ) )
           => ( ( member @ A @ X2 @ A3 )
             => ( ( lattic643756798350308766er_Min @ A @ A3 )
                = X2 ) ) ) ) ) ).

% Min_eqI
thf(fact_5890_Min__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ X2 ) ) ) ) ).

% Min_le
thf(fact_5891_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798350308766er_Min @ A @ A3 )
                = M )
              = ( ( member @ A @ M @ A3 )
                & ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less_eq @ A @ M @ X ) ) ) ) ) ) ) ).

% Min_eq_iff
thf(fact_5892_Min__le__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ X2 )
              = ( ? [X: A] :
                    ( ( member @ A @ X @ A3 )
                    & ( ord_less_eq @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Min_le_iff
thf(fact_5893_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ( member @ A @ M @ A3 )
                & ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less_eq @ A @ M @ X ) ) ) ) ) ) ) ).

% eq_Min_iff
thf(fact_5894_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X2 @ ( lattic643756798350308766er_Min @ A @ A3 ) )
             => ! [A9: A] :
                  ( ( member @ A @ A9 @ A3 )
                 => ( ord_less_eq @ A @ X2 @ A9 ) ) ) ) ) ) ).

% Min.boundedE
thf(fact_5895_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A6: A] :
                  ( ( member @ A @ A6 @ A3 )
                 => ( ord_less_eq @ A @ X2 @ A6 ) )
             => ( ord_less_eq @ A @ X2 @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min.boundedI
thf(fact_5896_Min__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ X2 )
              = ( ? [X: A] :
                    ( ( member @ A @ X @ A3 )
                    & ( ord_less @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Min_less_iff
thf(fact_5897_Min__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [B6: A] :
                ( ( member @ A @ B6 @ A3 )
               => ( ord_less_eq @ A @ A2 @ B6 ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ A2 @ A3 ) )
              = A2 ) ) ) ) ).

% Min_insert2
thf(fact_5898_Min_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite @ A @ A3 )
         => ( ( lattic643756798350308766er_Min @ A @ A3 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Min.infinite
thf(fact_5899_Min__antimono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M7: set @ A,N5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M7 @ N5 )
         => ( ( M7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N5 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ N5 ) @ ( lattic643756798350308766er_Min @ A @ M7 ) ) ) ) ) ) ).

% Min_antimono
thf(fact_5900_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ B4 ) @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min.subset_imp
thf(fact_5901_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S )
         => ( ( S
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [X: B] : ( plus_plus @ A @ ( F2 @ X ) @ K )
                  @ S ) )
              = ( plus_plus @ A @ ( lattic643756798350308766er_Min @ A @ ( image @ B @ A @ F2 @ S ) ) @ K ) ) ) ) ) ).

% Min_add_commute
thf(fact_5902_arg__min__SOME__Min,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S )
         => ( ( lattic7623131987881927897min_on @ A @ B @ F2 @ S )
            = ( fChoice @ A
              @ ^ [Y: A] :
                  ( ( member @ A @ Y @ S )
                  & ( ( F2 @ Y )
                    = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ S ) ) ) ) ) ) ) ) ).

% arg_min_SOME_Min
thf(fact_5903_dual__Max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Max @ A
          @ ^ [X: A,Y: A] : ( ord_less_eq @ A @ Y @ X ) )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% dual_Max
thf(fact_5904_listrel1__iff__update,axiom,
    ! [A: $tType,Xs2: list @ A,Ys2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys2 ) @ ( listrel1 @ A @ R ) )
      = ( ? [Y: A,N: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs2 @ N ) @ Y ) @ R )
            & ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( Ys2
              = ( list_update @ A @ Xs2 @ N @ Y ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_5905_minus__Min__eq__Max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S: set @ A] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798350308766er_Min @ A @ S ) )
              = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S ) ) ) ) ) ) ).

% minus_Min_eq_Max
thf(fact_5906_Max__divisors__self__nat,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D2: nat] : ( dvd_dvd @ nat @ D2 @ N2 ) ) )
        = N2 ) ) ).

% Max_divisors_self_nat
thf(fact_5907_Max__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A] :
          ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
          = X2 ) ) ).

% Max_singleton
thf(fact_5908_Max__divisors__self__int,axiom,
    ! [N2: int] :
      ( ( N2
       != ( zero_zero @ int ) )
     => ( ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D2: int] : ( dvd_dvd @ int @ D2 @ N2 ) ) )
        = ( abs_abs @ int @ N2 ) ) ) ).

% Max_divisors_self_int
thf(fact_5909_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X2 )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less_eq @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Max.bounded_iff
thf(fact_5910_Max__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X2 )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Max_less_iff
thf(fact_5911_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [Uu2: B] : C2
                  @ A3 ) )
              = C2 ) ) ) ) ).

% Max_const
thf(fact_5912_Max__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X2 @ A3 ) )
              = ( ord_max @ A @ X2 @ ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ) ).

% Max_insert
thf(fact_5913_minus__Max__eq__Min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S: set @ A] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798349783984er_Max @ A @ S ) )
              = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S ) ) ) ) ) ) ).

% minus_Max_eq_Min
thf(fact_5914_Max__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ A3 ) ) ) ) ).

% Max_in
thf(fact_5915_linorder_OMax_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Max @ A )
      = ( lattices_Max @ A ) ) ).

% linorder.Max.cong
thf(fact_5916_Max__ge,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ord_less_eq @ A @ X2 @ ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ).

% Max_ge
thf(fact_5917_Max__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [Y3: A] :
                ( ( member @ A @ Y3 @ A3 )
               => ( ord_less_eq @ A @ Y3 @ X2 ) )
           => ( ( member @ A @ X2 @ A3 )
             => ( ( lattic643756798349783984er_Max @ A @ A3 )
                = X2 ) ) ) ) ) ).

% Max_eqI
thf(fact_5918_Max__eq__if,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( finite_finite @ A @ B4 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A3 )
                 => ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ B4 )
                      & ( ord_less_eq @ A @ X3 @ Xa2 ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ B4 )
                   => ? [Xa2: A] :
                        ( ( member @ A @ Xa2 @ A3 )
                        & ( ord_less_eq @ A @ X3 @ Xa2 ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A3 )
                  = ( lattic643756798349783984er_Max @ A @ B4 ) ) ) ) ) ) ) ).

% Max_eq_if
thf(fact_5919_Max_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ A2 @ ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ).

% Max.coboundedI
thf(fact_5920_Max_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( ord_max @ A @ X2 @ ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ).

% Max.in_idem
thf(fact_5921_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A6: A] :
                  ( ( member @ A @ A6 @ A3 )
                 => ( ord_less_eq @ A @ A6 @ X2 ) )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X2 ) ) ) ) ) ).

% Max.boundedI
thf(fact_5922_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X2 )
             => ! [A9: A] :
                  ( ( member @ A @ A9 @ A3 )
                 => ( ord_less_eq @ A @ A9 @ X2 ) ) ) ) ) ) ).

% Max.boundedE
thf(fact_5923_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ( member @ A @ M @ A3 )
                & ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less_eq @ A @ X @ M ) ) ) ) ) ) ) ).

% eq_Max_iff
thf(fact_5924_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X2 @ ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ? [X: A] :
                    ( ( member @ A @ X @ A3 )
                    & ( ord_less_eq @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Max_ge_iff
thf(fact_5925_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798349783984er_Max @ A @ A3 )
                = M )
              = ( ( member @ A @ M @ A3 )
                & ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less_eq @ A @ X @ M ) ) ) ) ) ) ) ).

% Max_eq_iff
thf(fact_5926_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X2 @ ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ? [X: A] :
                    ( ( member @ A @ X @ A3 )
                    & ( ord_less @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Max_gr_iff
thf(fact_5927_Max__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [B6: A] :
                ( ( member @ A @ B6 @ A3 )
               => ( ord_less_eq @ A @ B6 @ A2 ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ A2 @ A3 ) )
              = A2 ) ) ) ) ).

% Max_insert2
thf(fact_5928_Max_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite @ A @ A3 )
         => ( ( lattic643756798349783984er_Max @ A @ A3 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Max.infinite
thf(fact_5929_gcd__is__Max__divisors__int,axiom,
    ! [N2: int,M: int] :
      ( ( N2
       != ( zero_zero @ int ) )
     => ( ( gcd_gcd @ int @ M @ N2 )
        = ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D2: int] :
                ( ( dvd_dvd @ int @ D2 @ M )
                & ( dvd_dvd @ int @ D2 @ N2 ) ) ) ) ) ) ).

% gcd_is_Max_divisors_int
thf(fact_5930_Max__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M7: set @ A,N5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M7 @ N5 )
         => ( ( M7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N5 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ M7 ) @ ( lattic643756798349783984er_Max @ A @ N5 ) ) ) ) ) ) ).

% Max_mono
thf(fact_5931_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ ( lattic643756798349783984er_Max @ A @ B4 ) ) ) ) ) ) ).

% Max.subset_imp
thf(fact_5932_hom__Max__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N5: set @ A] :
          ( ! [X3: A,Y3: A] :
              ( ( H2 @ ( ord_max @ A @ X3 @ Y3 ) )
              = ( ord_max @ A @ ( H2 @ X3 ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite @ A @ N5 )
           => ( ( N5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798349783984er_Max @ A @ N5 ) )
                = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ H2 @ N5 ) ) ) ) ) ) ) ).

% hom_Max_commute
thf(fact_5933_Max_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
             => ( ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ B4 ) @ ( lattic643756798349783984er_Max @ A @ A3 ) )
                = ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ) ).

% Max.subset
thf(fact_5934_Max_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X2 @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X2 @ A3 ) )
                = ( ord_max @ A @ X2 @ ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ) ) ).

% Max.insert_not_elem
thf(fact_5935_Max_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y3: A] : ( member @ A @ ( ord_max @ A @ X3 @ Y3 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ A3 ) ) ) ) ) ).

% Max.closed
thf(fact_5936_card__le__Suc__Max,axiom,
    ! [S: set @ nat] :
      ( ( finite_finite @ nat @ S )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ S ) @ ( suc @ ( lattic643756798349783984er_Max @ nat @ S ) ) ) ) ).

% card_le_Suc_Max
thf(fact_5937_divide__nat__def,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M3: nat,N: nat] :
          ( if @ nat
          @ ( N
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ K3 @ N ) @ M3 ) ) ) ) ) ) ).

% divide_nat_def
thf(fact_5938_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S )
         => ( ( S
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [X: B] : ( plus_plus @ A @ ( F2 @ X ) @ K )
                  @ S ) )
              = ( plus_plus @ A @ ( lattic643756798349783984er_Max @ A @ ( image @ B @ A @ F2 @ S ) ) @ K ) ) ) ) ) ).

% Max_add_commute
thf(fact_5939_gcd__is__Max__divisors__nat,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( gcd_gcd @ nat @ M @ N2 )
        = ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D2: nat] :
                ( ( dvd_dvd @ nat @ D2 @ M )
                & ( dvd_dvd @ nat @ D2 @ N2 ) ) ) ) ) ) ).

% gcd_is_Max_divisors_nat
thf(fact_5940_Max_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A3 )
                  = X2 ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A3 )
                  = ( ord_max @ A @ X2 @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Max.remove
thf(fact_5941_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X2 @ A3 ) )
                = X2 ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X2 @ A3 ) )
                = ( ord_max @ A @ X2 @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Max.insert_remove
thf(fact_5942_sum__le__card__Max,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ord_less_eq @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( times_times @ nat @ ( finite_card @ A @ A3 ) @ ( lattic643756798349783984er_Max @ nat @ ( image @ A @ nat @ F2 @ A3 ) ) ) ) ) ).

% sum_le_card_Max
thf(fact_5943_dual__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Min @ A
          @ ^ [X: A,Y: A] : ( ord_less_eq @ A @ Y @ X ) )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% dual_Min
thf(fact_5944_Max_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798349783984er_Max @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X: A,Y: option @ A] : ( some @ A @ ( case_option @ A @ A @ X @ ( ord_max @ A @ X ) @ Y ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Max.eq_fold'
thf(fact_5945_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_5946_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_5947_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_5948_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb1
thf(fact_5949_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ Z @ ( ord_min @ A @ X2 @ Y2 ) )
          = ( ( ord_less @ A @ Z @ X2 )
            & ( ord_less @ A @ Z @ Y2 ) ) ) ) ).

% min_less_iff_conj
thf(fact_5950_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_5951_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb3
thf(fact_5952_min__Suc__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_min @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_min @ nat @ M @ N2 ) ) ) ).

% min_Suc_Suc
thf(fact_5953_min__0R,axiom,
    ! [N2: nat] :
      ( ( ord_min @ nat @ N2 @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_5954_min__0L,axiom,
    ! [N2: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_5955_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( ord_min @ nat @ M @ N2 ) @ A2 ) ) ) ).

% take_bit_take_bit
thf(fact_5956_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 ) )
          = ( bit_ri4674362597316999326ke_bit @ A @ ( ord_min @ nat @ M @ N2 ) @ A2 ) ) ) ).

% signed_take_bit_signed_take_bit
thf(fact_5957_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(1)
thf(fact_5958_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X2 ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_5959_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_5960_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_5961_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_5962_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_5963_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_5964_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ ( ord_min @ nat @ M @ N2 ) ) ) ) ).

% take_bit_of_mask
thf(fact_5965_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_5966_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(3)
thf(fact_5967_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_5968_min__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N2 @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_5969_min__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N2 ) ) ) ).

% min_numeral_Suc
thf(fact_5970_Min__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X2 @ A3 ) )
              = ( ord_min @ A @ X2 @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min_insert
thf(fact_5971_Min_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( ord_min @ A @ X2 @ ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ).

% Min.in_idem
thf(fact_5972_Min_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( finite_fold @ A @ A @ ( ord_min @ A ) @ X2 @ A3 ) ) ) ) ).

% Min.eq_fold
thf(fact_5973_min__diff,axiom,
    ! [M: nat,I: nat,N2: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M @ I ) @ ( minus_minus @ nat @ N2 @ I ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M @ N2 ) @ I ) ) ).

% min_diff
thf(fact_5974_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X2 @ Y2 ) @ Z )
          = ( ord_min @ A @ ( minus_minus @ A @ X2 @ Z ) @ ( minus_minus @ A @ Y2 @ Z ) ) ) ) ).

% min_diff_distrib_left
thf(fact_5975_nat__mult__min__left,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M @ N2 ) @ Q2 )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N2 @ Q2 ) ) ) ).

% nat_mult_min_left
thf(fact_5976_nat__mult__min__right,axiom,
    ! [M: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_min @ nat @ N2 @ Q2 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ N2 ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_min_right
thf(fact_5977_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ A4 @ B3 ) ) ) ) ).

% min_def_raw
thf(fact_5978_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_5979_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_5980_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( A4
                = ( ord_min @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_5981_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_5982_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X2 @ Y2 ) @ Z )
          = ( ( ord_less @ A @ X2 @ Z )
            | ( ord_less @ A @ Y2 @ Z ) ) ) ) ).

% min_less_iff_disj
thf(fact_5983_of__int__min,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: int,Y2: int] :
          ( ( ring_1_of_int @ A @ ( ord_min @ int @ X2 @ Y2 ) )
          = ( ord_min @ A @ ( ring_1_of_int @ A @ X2 ) @ ( ring_1_of_int @ A @ Y2 ) ) ) ) ).

% of_int_min
thf(fact_5984_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ A4 @ B3 ) ) ) ) ).

% min_def
thf(fact_5985_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_min @ A @ X2 @ Y2 )
            = X2 ) ) ) ).

% min_absorb1
thf(fact_5986_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( ord_min @ A @ X2 @ Y2 )
            = Y2 ) ) ) ).

% min_absorb2
thf(fact_5987_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D3 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ C2 @ D3 ) ) ) ) ) ).

% min.mono
thf(fact_5988_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( ord_min @ A @ A2 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_5989_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_min @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% min.orderI
thf(fact_5990_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_5991_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_5992_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( A4
              = ( ord_min @ A @ A4 @ B3 ) ) ) ) ) ).

% min.order_iff
thf(fact_5993_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ A2 ) ) ).

% min.cobounded1
thf(fact_5994_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_5995_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_min @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% min.absorb_iff1
thf(fact_5996_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_min @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% min.absorb_iff2
thf(fact_5997_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_5998_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_5999_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X2 @ Y2 ) @ Z )
          = ( ( ord_less_eq @ A @ X2 @ Z )
            | ( ord_less_eq @ A @ Y2 @ Z ) ) ) ) ).

% min_le_iff_disj
thf(fact_6000_linorder_OMin_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Min @ A )
      = ( lattices_Min @ A ) ) ).

% linorder.Min.cong
thf(fact_6001_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X2 @ Y2 ) @ Z )
          = ( ord_min @ A @ ( plus_plus @ A @ X2 @ Z ) @ ( plus_plus @ A @ Y2 @ Z ) ) ) ) ).

% min_add_distrib_left
thf(fact_6002_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ X2 @ ( ord_min @ A @ Y2 @ Z ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( plus_plus @ A @ X2 @ Z ) ) ) ) ).

% min_add_distrib_right
thf(fact_6003_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: nat,Y2: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X2 @ Y2 ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( semiring_1_of_nat @ A @ Y2 ) ) ) ) ).

% of_nat_min
thf(fact_6004_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X2 @ Y2 ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% minus_max_eq_min
thf(fact_6005_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X2 @ Y2 ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% minus_min_eq_max
thf(fact_6006_concat__bit__assoc__sym,axiom,
    ! [M: nat,N2: nat,K: int,L2: int,R: int] :
      ( ( bit_concat_bit @ M @ ( bit_concat_bit @ N2 @ K @ L2 ) @ R )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N2 ) @ K @ ( bit_concat_bit @ ( minus_minus @ nat @ M @ N2 ) @ L2 @ R ) ) ) ).

% concat_bit_assoc_sym
thf(fact_6007_Min_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798350308766er_Min @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X: A,Y: option @ A] : ( some @ A @ ( case_option @ A @ A @ X @ ( ord_min @ A @ X ) @ Y ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Min.eq_fold'
thf(fact_6008_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N2: nat,K: int,L2: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ M @ ( bit_concat_bit @ N2 @ K @ L2 ) )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N2 ) @ K @ ( bit_se2584673776208193580ke_bit @ int @ ( minus_minus @ nat @ M @ N2 ) @ L2 ) ) ) ).

% take_bit_concat_bit_eq
thf(fact_6009_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_min @ A @ X2 @ Y2 ) @ P2 )
              = ( ord_min @ A @ ( times_times @ A @ X2 @ P2 ) @ ( times_times @ A @ Y2 @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_min @ A @ X2 @ Y2 ) @ P2 )
              = ( ord_max @ A @ ( times_times @ A @ X2 @ P2 ) @ ( times_times @ A @ Y2 @ P2 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_6010_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_max @ A @ X2 @ Y2 ) @ P2 )
              = ( ord_max @ A @ ( times_times @ A @ X2 @ P2 ) @ ( times_times @ A @ Y2 @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_max @ A @ X2 @ Y2 ) @ P2 )
              = ( ord_min @ A @ ( times_times @ A @ X2 @ P2 ) @ ( times_times @ A @ Y2 @ P2 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_6011_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_min @ A @ X2 @ Y2 ) )
              = ( ord_min @ A @ ( times_times @ A @ P2 @ X2 ) @ ( times_times @ A @ P2 @ Y2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_min @ A @ X2 @ Y2 ) )
              = ( ord_max @ A @ ( times_times @ A @ P2 @ X2 ) @ ( times_times @ A @ P2 @ Y2 ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_6012_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_max @ A @ X2 @ Y2 ) )
              = ( ord_max @ A @ ( times_times @ A @ P2 @ X2 ) @ ( times_times @ A @ P2 @ Y2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_max @ A @ X2 @ Y2 ) )
              = ( ord_min @ A @ ( times_times @ A @ P2 @ X2 ) @ ( times_times @ A @ P2 @ Y2 ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_6013_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P2: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X2 @ Y2 ) @ P2 )
              = ( ord_max @ A @ ( divide_divide @ A @ X2 @ P2 ) @ ( divide_divide @ A @ Y2 @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X2 @ Y2 ) @ P2 )
              = ( ord_min @ A @ ( divide_divide @ A @ X2 @ P2 ) @ ( divide_divide @ A @ Y2 @ P2 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_6014_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P2: A,X2: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X2 @ Y2 ) @ P2 )
              = ( ord_min @ A @ ( divide_divide @ A @ X2 @ P2 ) @ ( divide_divide @ A @ Y2 @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X2 @ Y2 ) @ P2 )
              = ( ord_max @ A @ ( divide_divide @ A @ X2 @ P2 ) @ ( divide_divide @ A @ Y2 @ P2 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_6015_min__Suc1,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_min @ nat @ ( suc @ N2 ) @ M )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M5: nat] : ( suc @ ( ord_min @ nat @ N2 @ M5 ) )
        @ M ) ) ).

% min_Suc1
thf(fact_6016_min__Suc2,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_min @ nat @ M @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M5: nat] : ( suc @ ( ord_min @ nat @ M5 @ N2 ) )
        @ M ) ) ).

% min_Suc2
thf(fact_6017_hom__Min__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N5: set @ A] :
          ( ! [X3: A,Y3: A] :
              ( ( H2 @ ( ord_min @ A @ X3 @ Y3 ) )
              = ( ord_min @ A @ ( H2 @ X3 ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite @ A @ N5 )
           => ( ( N5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798350308766er_Min @ A @ N5 ) )
                = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ H2 @ N5 ) ) ) ) ) ) ) ).

% hom_Min_commute
thf(fact_6018_Min_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
             => ( ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ B4 ) @ ( lattic643756798350308766er_Min @ A @ A3 ) )
                = ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min.subset
thf(fact_6019_Min_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y3: A] : ( member @ A @ ( ord_min @ A @ X3 @ Y3 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ A3 ) ) ) ) ) ).

% Min.closed
thf(fact_6020_Min_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X2 @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X2 @ A3 ) )
                = ( ord_min @ A @ X2 @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ) ).

% Min.insert_not_elem
thf(fact_6021_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_6022_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G2 ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_6023_Max_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( finite_fold @ A @ A @ ( ord_max @ A ) @ X2 @ A3 ) ) ) ) ).

% Max.eq_fold
thf(fact_6024_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N2 ) ) ) ) ) ).

% mod_exp_eq
thf(fact_6025_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X2 @ A3 ) )
                = X2 ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X2 @ A3 ) )
                = ( ord_min @ A @ X2 @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Min.insert_remove
thf(fact_6026_Min_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A3 )
                  = X2 ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A3 )
                  = ( ord_min @ A @ X2 @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Min.remove
thf(fact_6027_lexord__take__index__conv,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lexord @ A @ R ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X2 ) @ ( size_size @ ( list @ A ) @ Y2 ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X2 ) @ Y2 )
            = X2 ) )
        | ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X2 ) @ ( size_size @ ( list @ A ) @ Y2 ) ) )
            & ( ( take @ A @ I3 @ X2 )
              = ( take @ A @ I3 @ Y2 ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X2 @ I3 ) @ ( nth @ A @ Y2 @ I3 ) ) @ R ) ) ) ) ).

% lexord_take_index_conv
thf(fact_6028_Gcd__eq__Max,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite @ nat @ M7 )
     => ( ( M7
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
         => ( ( gcd_Gcd @ nat @ M7 )
            = ( lattic643756798349783984er_Max @ nat
              @ ( complete_Inf_Inf @ ( set @ nat )
                @ ( image @ nat @ ( set @ nat )
                  @ ^ [M3: nat] :
                      ( collect @ nat
                      @ ^ [D2: nat] : ( dvd_dvd @ nat @ D2 @ M3 ) )
                  @ M7 ) ) ) ) ) ) ) ).

% Gcd_eq_Max
thf(fact_6029_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S: set @ A,F2: A > B > B,A3: set @ A,X2: A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S )
       => ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z @ A3 )
              = ( F2 @ X2 @ ( finite_fold @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
thf(fact_6030_min__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(3)
thf(fact_6031_min__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(2)
thf(fact_6032_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_atLeastAtMost
thf(fact_6033_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_atLeastAtMost
thf(fact_6034_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_atLeastLessThan
thf(fact_6035_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_atLeastLessThan
thf(fact_6036_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_6037_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_6038_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_6039_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_6040_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X6: set @ A,X2: A,A2: A] :
          ( ( finite_finite @ A @ X6 )
         => ( ( member @ A @ X2 @ X6 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X6 )
                 => ( ord_less @ A @ A2 @ X3 ) )
             => ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X6 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_6041_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X6: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X6 )
             => ( ord_less_eq @ A @ A2 @ X3 ) )
         => ( ! [Y3: A] :
                ( ! [X4: A] :
                    ( ( member @ A @ X4 @ X6 )
                   => ( ord_less_eq @ A @ Y3 @ X4 ) )
               => ( ord_less_eq @ A @ Y3 @ A2 ) )
           => ( ( complete_Inf_Inf @ A @ X6 )
              = A2 ) ) ) ) ).

% cInf_eq
thf(fact_6042_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X6: set @ A] :
          ( ( member @ A @ Z @ X6 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X6 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ( complete_Inf_Inf @ A @ X6 )
              = Z ) ) ) ) ).

% cInf_eq_minimum
thf(fact_6043_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X6: set @ A,X2: A] :
          ( ( finite_finite @ A @ X6 )
         => ( ( member @ A @ X2 @ X6 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X6 ) @ X2 ) ) ) ) ).

% cInf_le_finite
thf(fact_6044_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X6: set @ A,A2: A] :
          ( ( X6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X6 )
               => ( ord_less_eq @ A @ A2 @ X3 ) )
           => ( ! [Y3: A] :
                  ( ! [X4: A] :
                      ( ( member @ A @ X4 @ X6 )
                     => ( ord_less_eq @ A @ Y3 @ X4 ) )
                 => ( ord_less_eq @ A @ Y3 @ A2 ) )
             => ( ( complete_Inf_Inf @ A @ X6 )
                = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_6045_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X6: set @ A,Z: A] :
          ( ( X6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X6 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ X6 ) ) ) ) ) ).

% cInf_greatest
thf(fact_6046_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X6: set @ A,Z: A] :
          ( ( X6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X6 ) @ Z )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X6 )
                & ( ord_less @ A @ X3 @ Z ) ) ) ) ) ).

% cInf_lessD
thf(fact_6047_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,M: A,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ M @ ( F2 @ X3 ) ) )
           => ( ord_less_eq @ A @ M @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_6048_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X6: set @ A,A2: A] :
          ( ( finite_finite @ A @ X6 )
         => ( ( X6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X6 ) )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ X6 )
                   => ( ord_less @ A @ A2 @ X ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_6049_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S: set @ A,A2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S ) ) @ A2 ) ) ) ) ).

% cInf_abs_ge
thf(fact_6050_Min__Inf,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ A3 )
              = ( complete_Inf_Inf @ A @ A3 ) ) ) ) ) ).

% Min_Inf
thf(fact_6051_card_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( finite_fold @ A @ nat
        @ ^ [Uu2: A] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card.eq_fold
thf(fact_6052_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S: set @ A,L2: A,E2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L2 ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S ) @ L2 ) ) @ E2 ) ) ) ) ).

% cInf_asclose
thf(fact_6053_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S: set @ A,F2: A > B > B,X2: A,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ S )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F2 @ Z @ ( insert @ A @ X2 @ A3 ) )
            = ( F2 @ X2 @ ( finite_fold @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
thf(fact_6054_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
            = ( bot_bot @ A ) )
          = ( ! [X: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X )
               => ? [Y: B] :
                    ( ( member @ B @ Y @ A3 )
                    & ( ord_less @ A @ ( F2 @ Y ) @ X ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_6055_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A3 )
            = ( bot_bot @ A ) )
          = ( ! [X: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X )
               => ? [Y: A] :
                    ( ( member @ A @ Y @ A3 )
                    & ( ord_less @ A @ Y @ X ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_6056_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( ord_less_eq @ A @ Z @ X3 ) )
         => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ).

% Inf_greatest
thf(fact_6057_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A3 ) )
          = ( ! [X: A] :
                ( ( member @ A @ X @ A3 )
               => ( ord_less_eq @ A @ B2 @ X ) ) ) ) ) ).

% le_Inf_iff
thf(fact_6058_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A3: set @ A,V: A] :
          ( ( member @ A @ U @ A3 )
         => ( ( ord_less_eq @ A @ U @ V )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ V ) ) ) ) ).

% Inf_lower2
thf(fact_6059_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,A3: set @ A] :
          ( ( member @ A @ X2 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X2 ) ) ) ).

% Inf_lower
thf(fact_6060_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ! [B6: A] :
              ( ( member @ A @ B6 @ B4 )
             => ? [X4: A] :
                  ( ( member @ A @ X4 @ A3 )
                  & ( ord_less_eq @ A @ X4 @ B6 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ).

% Inf_mono
thf(fact_6061_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X2: A] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ A3 )
             => ( ord_less_eq @ A @ X2 @ I4 ) )
         => ( ! [Y3: A] :
                ( ! [I2: A] :
                    ( ( member @ A @ I2 @ A3 )
                   => ( ord_less_eq @ A @ Y3 @ I2 ) )
               => ( ord_less_eq @ A @ Y3 @ X2 ) )
           => ( ( complete_Inf_Inf @ A @ A3 )
              = X2 ) ) ) ) ).

% Inf_eqI
thf(fact_6062_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S: set @ A,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S ) @ A2 )
          = ( ? [X: A] :
                ( ( member @ A @ X @ S )
                & ( ord_less @ A @ X @ A2 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_6063_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X2 )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ X2 @ Y )
               => ? [X: A] :
                    ( ( member @ A @ X @ A3 )
                    & ( ord_less @ A @ X @ Y ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_6064_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ C,G: C > A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ? [X4: C] :
                  ( ( member @ C @ X4 @ B4 )
                  & ( ord_less_eq @ A @ ( G @ X4 ) @ ( F2 @ I4 ) ) ) )
         => ( ! [J3: C] :
                ( ( member @ C @ J3 @ B4 )
               => ? [X4: B] :
                    ( ( member @ B @ X4 @ A3 )
                    & ( ord_less_eq @ A @ ( F2 @ X4 ) @ ( G @ J3 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ).

% INF_eq
thf(fact_6065_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A3 )
             => ( ord_less_eq @ A @ V4 @ U ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_6066_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ).

% Inf_superset_mono
thf(fact_6067_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,X2: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ X2 @ ( F2 @ I4 ) ) )
         => ( ! [Y3: A] :
                ( ! [I2: B] :
                    ( ( member @ B @ I2 @ A3 )
                   => ( ord_less_eq @ A @ Y3 @ ( F2 @ I2 ) ) )
               => ( ord_less_eq @ A @ Y3 @ X2 ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = X2 ) ) ) ) ).

% INF_eqI
thf(fact_6068_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ B,A3: set @ C,F2: C > A,G: B > A] :
          ( ! [M4: B] :
              ( ( member @ B @ M4 @ B4 )
             => ? [X4: C] :
                  ( ( member @ C @ X4 @ A3 )
                  & ( ord_less_eq @ A @ ( F2 @ X4 ) @ ( G @ M4 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ).

% INF_mono
thf(fact_6069_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( F2 @ I ) ) ) ) ).

% INF_lower
thf(fact_6070_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% INF_mono'
thf(fact_6071_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A3: set @ B,F2: B > A,U: A] :
          ( ( member @ B @ I @ A3 )
         => ( ( ord_less_eq @ A @ ( F2 @ I ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_6072_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F2: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ! [X: B] :
                ( ( member @ B @ X @ A3 )
               => ( ord_less_eq @ A @ U @ ( F2 @ X ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_6073_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,U: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ U @ ( F2 @ I4 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_greatest
thf(fact_6074_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ A2 )
          = ( ? [X: B] :
                ( ( member @ B @ X @ A3 )
                & ( ord_less @ A @ ( F2 @ X ) @ A2 ) ) ) ) ) ).

% INF_less_iff
thf(fact_6075_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y2: A,F2: B > A,A3: set @ B,I: B] :
          ( ( ord_less @ A @ Y2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
         => ( ( member @ B @ I @ A3 )
           => ( ord_less @ A @ Y2 @ ( F2 @ I ) ) ) ) ) ).

% less_INF_D
thf(fact_6076_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B,X2: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ X2 )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ X2 @ Y )
               => ? [X: B] :
                    ( ( member @ B @ X @ A3 )
                    & ( ord_less @ A @ ( F2 @ X ) @ Y ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_6077_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,F2: B > A,C2: A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I4 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X: B] :
                    ( ( member @ B @ X @ I5 )
                   => ( ( F2 @ X )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_6078_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ B,A3: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ B4 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_6079_card__UNION,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A3 )
     => ( ! [X3: set @ A] :
            ( ( member @ ( set @ A ) @ X3 @ A3 )
           => ( finite_finite @ A @ X3 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I7: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I7 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I7 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I7 @ A3 )
                    & ( I7
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_6080_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys2: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys2 ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu2: product_prod @ A @ B] :
          ? [I3: nat] :
            ( ( Uu2
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ I3 ) @ ( nth @ B @ Ys2 @ I3 ) ) )
            & ( ord_less @ nat @ I3 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ) ) ) ).

% set_zip
thf(fact_6081_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_atLeastAtMost
thf(fact_6082_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_atLeastAtMost
thf(fact_6083_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_atLeastLessThan
thf(fact_6084_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_atLeastLessThan
thf(fact_6085_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_6086_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_6087_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_6088_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_6089_nth__zip,axiom,
    ! [A: $tType,B: $tType,I: nat,Xs2: list @ A,Ys2: list @ B] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ B ) @ Ys2 ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys2 ) @ I )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ I ) @ ( nth @ B @ Ys2 @ I ) ) ) ) ) ).

% nth_zip
thf(fact_6090_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ C,F2: B > A,G: C > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ? [X4: C] :
                  ( ( member @ C @ X4 @ B4 )
                  & ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( G @ X4 ) ) ) )
         => ( ! [J3: C] :
                ( ( member @ C @ J3 @ B4 )
               => ? [X4: B] :
                    ( ( member @ B @ X4 @ A3 )
                    & ( ord_less_eq @ A @ ( G @ J3 ) @ ( F2 @ X4 ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_6091_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X2: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ A3 ) )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ Y @ X2 )
               => ? [X: A] :
                    ( ( member @ A @ X @ A3 )
                    & ( ord_less @ A @ Y @ X ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_6092_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,S: set @ A] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S ) )
          = ( ? [X: A] :
                ( ( member @ A @ X @ S )
                & ( ord_less @ A @ A2 @ X ) ) ) ) ) ).

% less_Sup_iff
thf(fact_6093_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A3: set @ A,V: A] :
          ( ( member @ A @ U @ A3 )
         => ( ( ord_less_eq @ A @ V @ U )
           => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% Sup_upper2
thf(fact_6094_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ B2 )
          = ( ! [X: A] :
                ( ( member @ A @ X @ A3 )
               => ( ord_less_eq @ A @ X @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_6095_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,A3: set @ A] :
          ( ( member @ A @ X2 @ A3 )
         => ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Sup_upper
thf(fact_6096_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ Z ) ) ) ).

% Sup_least
thf(fact_6097_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ! [A6: A] :
              ( ( member @ A @ A6 @ A3 )
             => ? [X4: A] :
                  ( ( member @ A @ X4 @ B4 )
                  & ( ord_less_eq @ A @ A6 @ X4 ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_mono
thf(fact_6098_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X2: A] :
          ( ! [Y3: A] :
              ( ( member @ A @ Y3 @ A3 )
             => ( ord_less_eq @ A @ Y3 @ X2 ) )
         => ( ! [Y3: A] :
                ( ! [Z2: A] :
                    ( ( member @ A @ Z2 @ A3 )
                   => ( ord_less_eq @ A @ Z2 @ Y3 ) )
               => ( ord_less_eq @ A @ X2 @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ A3 )
              = X2 ) ) ) ) ).

% Sup_eqI
thf(fact_6099_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_subset_mono
thf(fact_6100_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A3 )
             => ( ord_less_eq @ A @ U @ V4 ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_6101_card__Union__le__sum__card,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ).

% card_Union_le_sum_card
thf(fact_6102_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X6: set @ A,X2: A,A2: A] :
          ( ( finite_finite @ A @ X6 )
         => ( ( member @ A @ X2 @ X6 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X6 )
                 => ( ord_less @ A @ X3 @ A2 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X6 ) @ A2 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_6103_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X6: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X6 )
             => ( ord_less_eq @ A @ X3 @ A2 ) )
         => ( ! [Y3: A] :
                ( ! [X4: A] :
                    ( ( member @ A @ X4 @ X6 )
                   => ( ord_less_eq @ A @ X4 @ Y3 ) )
               => ( ord_less_eq @ A @ A2 @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ X6 )
              = A2 ) ) ) ) ).

% cSup_eq
thf(fact_6104_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X6: set @ A] :
          ( ( member @ A @ Z @ X6 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X6 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ( complete_Sup_Sup @ A @ X6 )
              = Z ) ) ) ) ).

% cSup_eq_maximum
thf(fact_6105_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X6: set @ A,X2: A] :
          ( ( finite_finite @ A @ X6 )
         => ( ( member @ A @ X2 @ X6 )
           => ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ X6 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_6106_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X6: set @ A,A2: A] :
          ( ( X6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X6 )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ! [Y3: A] :
                  ( ! [X4: A] :
                      ( ( member @ A @ X4 @ X6 )
                     => ( ord_less_eq @ A @ X4 @ Y3 ) )
                 => ( ord_less_eq @ A @ A2 @ Y3 ) )
             => ( ( complete_Sup_Sup @ A @ X6 )
                = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_6107_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X6: set @ A,Z: A] :
          ( ( X6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X6 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X6 ) @ Z ) ) ) ) ).

% cSup_least
thf(fact_6108_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X6: set @ A,Z: A] :
          ( ( X6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z @ ( complete_Sup_Sup @ A @ X6 ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X6 )
                & ( ord_less @ A @ Z @ X3 ) ) ) ) ) ).

% less_cSupD
thf(fact_6109_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y2: A,X6: set @ A] :
          ( ( ord_less @ A @ Y2 @ ( complete_Sup_Sup @ A @ X6 ) )
         => ( ( X6
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X3: A] :
                  ( ( member @ A @ X3 @ X6 )
                 => ~ ( ord_less @ A @ Y2 @ X3 ) ) ) ) ) ).

% less_cSupE
thf(fact_6110_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,X2: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ X2 ) )
         => ( ! [Y3: A] :
                ( ! [I2: B] :
                    ( ( member @ B @ I2 @ A3 )
                   => ( ord_less_eq @ A @ ( F2 @ I2 ) @ Y3 ) )
               => ( ord_less_eq @ A @ X2 @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = X2 ) ) ) ) ).

% SUP_eqI
thf(fact_6111_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ C,F2: B > A,G: C > A] :
          ( ! [N3: B] :
              ( ( member @ B @ N3 @ A3 )
             => ? [X4: C] :
                  ( ( member @ C @ X4 @ B4 )
                  & ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ X4 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ).

% SUP_mono
thf(fact_6112_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,U: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_6113_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% SUP_mono'
thf(fact_6114_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I @ A3 )
         => ( ord_less_eq @ A @ ( F2 @ I ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% SUP_upper
thf(fact_6115_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U )
          = ( ! [X: B] :
                ( ( member @ B @ X @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_6116_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A3: set @ B,U: A,F2: B > A] :
          ( ( member @ B @ I @ A3 )
         => ( ( ord_less_eq @ A @ U @ ( F2 @ I ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_6117_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,F2: B > A,A3: set @ B] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ? [X: B] :
                ( ( member @ B @ X @ A3 )
                & ( ord_less @ A @ A2 @ ( F2 @ X ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_6118_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,Y2: A,I: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ Y2 )
         => ( ( member @ B @ I @ A3 )
           => ( ord_less @ A @ ( F2 @ I ) @ Y2 ) ) ) ) ).

% SUP_lessD
thf(fact_6119_UN__extend__simps_I6_J,axiom,
    ! [L5: $tType,K9: $tType,A3: K9 > ( set @ L5 ),C6: set @ K9,B4: set @ L5] :
      ( ( minus_minus @ ( set @ L5 ) @ ( complete_Sup_Sup @ ( set @ L5 ) @ ( image @ K9 @ ( set @ L5 ) @ A3 @ C6 ) ) @ B4 )
      = ( complete_Sup_Sup @ ( set @ L5 )
        @ ( image @ K9 @ ( set @ L5 )
          @ ^ [X: K9] : ( minus_minus @ ( set @ L5 ) @ ( A3 @ X ) @ B4 )
          @ C6 ) ) ) ).

% UN_extend_simps(6)
thf(fact_6120_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X2: A,F2: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ Y @ X2 )
               => ? [X: B] :
                    ( ( member @ B @ X @ A3 )
                    & ( ord_less @ A @ Y @ ( F2 @ X ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_6121_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,M7: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M7 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ M7 ) ) ) ) ).

% cSUP_least
thf(fact_6122_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,C2: A,F2: B > A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ I5 )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I4 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X: B] :
                    ( ( member @ B @ X @ I5 )
                   => ( ( F2 @ X )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_6123_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X6: set @ A,A2: A] :
          ( ( finite_finite @ A @ X6 )
         => ( ( X6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X6 ) @ A2 )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ X6 )
                   => ( ord_less @ A @ X @ A2 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_6124_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Inf_le_Sup
thf(fact_6125_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S: set @ A,A2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S ) ) @ A2 ) ) ) ) ).

% cSup_abs_le
thf(fact_6126_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B4: set @ ( set @ B ),G: B > A] :
          ( ! [X3: set @ B] :
              ( ( member @ ( set @ B ) @ X3 @ B4 )
             => ( finite_finite @ B @ X3 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B4 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B4 )
                   => ( ( A14 != A25 )
                     => ! [X3: B] :
                          ( ( member @ B @ X3 @ A14 )
                         => ( ( member @ B @ X3 @ A25 )
                           => ( ( G @ X3 )
                              = ( zero_zero @ A ) ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B4 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ B4 ) ) ) ) ) ).

% sum.Union_comp
thf(fact_6127_Max__Sup,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ A3 )
              = ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% Max_Sup
thf(fact_6128_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] :
      ( ! [X3: set @ A] :
          ( ( member @ ( set @ A ) @ X3 @ U4 )
         => ( finite_finite @ A @ X3 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_6129_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_6130_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X: A] :
                    ( ( member @ A @ X @ A7 )
                   => ( ord_less_eq @ A @ X @ B3 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_6131_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X: A] :
                    ( ( member @ A @ X @ A7 )
                   => ( ord_less_eq @ A @ B3 @ X ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_6132_UN__extend__simps_I7_J,axiom,
    ! [M11: $tType,N11: $tType,A3: set @ M11,B4: N11 > ( set @ M11 ),C6: set @ N11] :
      ( ( minus_minus @ ( set @ M11 ) @ A3 @ ( complete_Inf_Inf @ ( set @ M11 ) @ ( image @ N11 @ ( set @ M11 ) @ B4 @ C6 ) ) )
      = ( complete_Sup_Sup @ ( set @ M11 )
        @ ( image @ N11 @ ( set @ M11 )
          @ ^ [X: N11] : ( minus_minus @ ( set @ M11 ) @ A3 @ ( B4 @ X ) )
          @ C6 ) ) ) ).

% UN_extend_simps(7)
thf(fact_6133_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S: set @ A,L2: A,E2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L2 ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S ) @ L2 ) ) @ E2 ) ) ) ) ).

% cSup_asclose
thf(fact_6134_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_6135_INT__extend__simps_I4_J,axiom,
    ! [G4: $tType,H5: $tType,C6: set @ H5,A3: set @ G4,B4: H5 > ( set @ G4 )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ H5 ) ) )
       => ( ( minus_minus @ ( set @ G4 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G4 ) @ ( image @ H5 @ ( set @ G4 ) @ B4 @ C6 ) ) )
          = A3 ) )
      & ( ( C6
         != ( bot_bot @ ( set @ H5 ) ) )
       => ( ( minus_minus @ ( set @ G4 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G4 ) @ ( image @ H5 @ ( set @ G4 ) @ B4 @ C6 ) ) )
          = ( complete_Inf_Inf @ ( set @ G4 )
            @ ( image @ H5 @ ( set @ G4 )
              @ ^ [X: H5] : ( minus_minus @ ( set @ G4 ) @ A3 @ ( B4 @ X ) )
              @ C6 ) ) ) ) ) ).

% INT_extend_simps(4)
thf(fact_6136_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I3: nat] : ( M7 @ ( plus_plus @ nat @ I3 @ K ) )
          @ ( set_ord_lessThan @ nat @ N2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_6137_UN__le__add__shift,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I3: nat] : ( M7 @ ( plus_plus @ nat @ I3 @ K ) )
          @ ( set_ord_atMost @ nat @ N2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_6138_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,A3: A > ( set @ B )] :
      ( ( finite_finite @ A @ I5 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I5 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I3: A] : ( finite_card @ B @ ( A3 @ I3 ) )
          @ I5 ) ) ) ).

% card_UN_le
thf(fact_6139_in__set__zip,axiom,
    ! [B: $tType,A: $tType,P2: product_prod @ A @ B,Xs2: list @ A,Ys2: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ P2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys2 ) ) )
      = ( ? [N: nat] :
            ( ( ( nth @ A @ Xs2 @ N )
              = ( product_fst @ A @ B @ P2 ) )
            & ( ( nth @ B @ Ys2 @ N )
              = ( product_snd @ A @ B @ P2 ) )
            & ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ord_less @ nat @ N @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ) ) ).

% in_set_zip
thf(fact_6140_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S: set @ A] :
      ( ! [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I4 ) @ S )
     => ( ( finite_finite @ A @ S )
       => ( ? [N8: nat] :
              ( ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N3 @ N8 )
                 => ! [M4: nat] :
                      ( ( ord_less_eq @ nat @ M4 @ N8 )
                     => ( ( ord_less @ nat @ M4 @ N3 )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) ) ) )
              & ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N3 )
                 => ( ( F2 @ N8 )
                    = ( F2 @ N3 ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_6141_card__Pow,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A3 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Pow
thf(fact_6142_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_6143_range__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_add
thf(fact_6144_surj__plus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_plus
thf(fact_6145_range__diff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_diff
thf(fact_6146_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A3 )
            = ( top_top @ A ) )
          = ( ! [X: A] :
                ( ( ord_less @ A @ X @ ( top_top @ A ) )
               => ? [Y: A] :
                    ( ( member @ A @ Y @ A3 )
                    & ( ord_less @ A @ X @ Y ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_6147_Diff__UNIV,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_UNIV
thf(fact_6148_surj__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( ( image @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_6149_surj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A
            @ ^ [X: A] : ( minus_minus @ A @ X @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_diff_right
thf(fact_6150_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
            = ( top_top @ A ) )
          = ( ! [X: A] :
                ( ( ord_less @ A @ X @ ( top_top @ A ) )
               => ? [Y: B] :
                    ( ( member @ B @ Y @ A3 )
                    & ( ord_less @ A @ X @ ( F2 @ Y ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_6151_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X2 ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_6152_INT__simps_I3_J,axiom,
    ! [E4: $tType,F: $tType,C6: set @ E4,A3: E4 > ( set @ F ),B4: set @ F] :
      ( ( ( C6
          = ( bot_bot @ ( set @ E4 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E4 @ ( set @ F )
              @ ^ [X: E4] : ( minus_minus @ ( set @ F ) @ ( A3 @ X ) @ B4 )
              @ C6 ) )
          = ( top_top @ ( set @ F ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ E4 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E4 @ ( set @ F )
              @ ^ [X: E4] : ( minus_minus @ ( set @ F ) @ ( A3 @ X ) @ B4 )
              @ C6 ) )
          = ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E4 @ ( set @ F ) @ A3 @ C6 ) ) @ B4 ) ) ) ) ).

% INT_simps(3)
thf(fact_6153_INT__simps_I4_J,axiom,
    ! [G4: $tType,H5: $tType,C6: set @ H5,A3: set @ G4,B4: H5 > ( set @ G4 )] :
      ( ( ( C6
          = ( bot_bot @ ( set @ H5 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G4 )
            @ ( image @ H5 @ ( set @ G4 )
              @ ^ [X: H5] : ( minus_minus @ ( set @ G4 ) @ A3 @ ( B4 @ X ) )
              @ C6 ) )
          = ( top_top @ ( set @ G4 ) ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ H5 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G4 )
            @ ( image @ H5 @ ( set @ G4 )
              @ ^ [X: H5] : ( minus_minus @ ( set @ G4 ) @ A3 @ ( B4 @ X ) )
              @ C6 ) )
          = ( minus_minus @ ( set @ G4 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G4 ) @ ( image @ H5 @ ( set @ G4 ) @ B4 @ C6 ) ) ) ) ) ) ).

% INT_simps(4)
thf(fact_6154_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( sums @ A @ F2
          @ ( complete_Sup_Sup @ A
            @ ( image @ nat @ A
              @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% sums_SUP
thf(fact_6155_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X8: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X8 ) ) ) ) ) ).

% Inf_real_def
thf(fact_6156_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_6157_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_6158_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_6159_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( ( ( finite_card @ B @ ( top_top @ ( set @ B ) ) )
         != ( suc @ ( zero_zero @ nat ) ) )
       => ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_fun_UNIVD1
thf(fact_6160_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X8: set @ int] :
          ( the @ int
          @ ^ [X: int] :
              ( ( member @ int @ X @ X8 )
              & ! [Y: int] :
                  ( ( member @ int @ Y @ X8 )
                 => ( ord_less_eq @ int @ Y @ X ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_6161_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_6162_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) ).

% top.extremum_strict
thf(fact_6163_Compl__eq__Diff__UNIV,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) ) ) ).

% Compl_eq_Diff_UNIV
thf(fact_6164_bij__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( bij_betw @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_6165_suminf__eq__SUP__real,axiom,
    ! [X6: nat > real] :
      ( ( summable @ real @ X6 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X6 @ I4 ) )
       => ( ( suminf @ real @ X6 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I3: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X6 @ ( set_ord_lessThan @ nat @ I3 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_6166_Sup__nat__def,axiom,
    ( ( complete_Sup_Sup @ nat )
    = ( ^ [X8: set @ nat] :
          ( if @ nat
          @ ( X8
            = ( bot_bot @ ( set @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat @ X8 ) ) ) ) ).

% Sup_nat_def
thf(fact_6167_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_6168_INT__extend__simps_I3_J,axiom,
    ! [F: $tType,E4: $tType,C6: set @ E4,A3: E4 > ( set @ F ),B4: set @ F] :
      ( ( ( C6
          = ( bot_bot @ ( set @ E4 ) ) )
       => ( ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E4 @ ( set @ F ) @ A3 @ C6 ) ) @ B4 )
          = ( minus_minus @ ( set @ F ) @ ( top_top @ ( set @ F ) ) @ B4 ) ) )
      & ( ( C6
         != ( bot_bot @ ( set @ E4 ) ) )
       => ( ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E4 @ ( set @ F ) @ A3 @ C6 ) ) @ B4 )
          = ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E4 @ ( set @ F )
              @ ^ [X: E4] : ( minus_minus @ ( set @ F ) @ ( A3 @ X ) @ B4 )
              @ C6 ) ) ) ) ) ).

% INT_extend_simps(3)
thf(fact_6169_UN__UN__finite__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [N: nat] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
          @ ( top_top @ ( set @ nat ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UN_UN_finite_eq
thf(fact_6170_binomial__def,axiom,
    ( binomial
    = ( ^ [N: nat,K3: nat] :
          ( finite_card @ ( set @ nat )
          @ ( collect @ ( set @ nat )
            @ ^ [K6: set @ nat] :
                ( ( member @ ( set @ nat ) @ K6 @ ( pow2 @ nat @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
                & ( ( finite_card @ nat @ K6 )
                  = K3 ) ) ) ) ) ) ).

% binomial_def
thf(fact_6171_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_6172_UN__finite__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),C6: set @ A] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ C6 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ C6 ) ) ).

% UN_finite_subset
thf(fact_6173_UN__finite2__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B4: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_6174_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F4: nat > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F4 @ ( set_ord_lessThan @ nat @ N ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP
thf(fact_6175_range__mod,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( image @ nat @ nat
          @ ^ [M3: nat] : ( modulo_modulo @ nat @ M3 @ N2 )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% range_mod
thf(fact_6176_UN__finite2__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B4: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_6177_UNIV__nat__eq,axiom,
    ( ( top_top @ ( set @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UNIV_nat_eq
thf(fact_6178_card__partition,axiom,
    ! [A: $tType,C6: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C6 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) )
       => ( ! [C4: set @ A] :
              ( ( member @ ( set @ A ) @ C4 @ C6 )
             => ( ( finite_card @ A @ C4 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C6 )
               => ( ( member @ ( set @ A ) @ C22 @ C6 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C6 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_6179_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_6180_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ ( inf_inf @ A @ Y2 @ Z ) )
          = ( ( ord_less_eq @ A @ X2 @ Y2 )
            & ( ord_less_eq @ A @ X2 @ Z ) ) ) ) ).

% le_inf_iff
thf(fact_6181_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_6182_Diff__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_disjoint
thf(fact_6183_Diff__Compl,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_Compl
thf(fact_6184_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_6185_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P: B > $o,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X ) ) @ ( F2 @ X ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_6186_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,F2: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X: B] : ( times_times @ A @ ( F2 @ X ) @ ( zero_neq_one_of_bool @ A @ ( P @ X ) ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_6187_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_6188_infinite__UNIV__int,axiom,
    ~ ( finite_finite @ int @ ( top_top @ ( set @ int ) ) ) ).

% infinite_UNIV_int
thf(fact_6189_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S2: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( inf_inf @ ( set @ A ) @ S2 @ T2 ) )
          = ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S2 ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Int
thf(fact_6190_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% less_infI1
thf(fact_6191_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ X2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% less_infI2
thf(fact_6192_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb3
thf(fact_6193_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_6194_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_6195_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( A4
                = ( inf_inf @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_6196_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_6197_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_6198_Diff__Int__distrib2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C6: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ C6 )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C6 ) @ ( inf_inf @ ( set @ A ) @ B4 @ C6 ) ) ) ).

% Diff_Int_distrib2
thf(fact_6199_Diff__Int__distrib,axiom,
    ! [A: $tType,C6: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ C6 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ C6 @ A3 ) @ ( inf_inf @ ( set @ A ) @ C6 @ B4 ) ) ) ).

% Diff_Int_distrib
thf(fact_6200_Diff__Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_Diff_Int
thf(fact_6201_Diff__Int2,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C6 ) @ ( inf_inf @ ( set @ A ) @ B4 @ C6 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C6 ) @ B4 ) ) ).

% Diff_Int2
thf(fact_6202_Int__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C6: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ C6 )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ C6 ) ) ) ).

% Int_Diff
thf(fact_6203_diff__eq,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( minus_minus @ A )
        = ( ^ [X: A,Y: A] : ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% diff_eq
thf(fact_6204_Diff__eq,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] : ( inf_inf @ ( set @ A ) @ A7 @ ( uminus_uminus @ ( set @ A ) @ B8 ) ) ) ) ).

% Diff_eq
thf(fact_6205_Diff__triv,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ B4 )
        = A3 ) ) ).

% Diff_triv
thf(fact_6206_Int__Diff__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_Diff_disjoint
thf(fact_6207_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ Y2 ) ) ).

% inf_sup_ord(2)
thf(fact_6208_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ X2 ) ) ).

% inf_sup_ord(1)
thf(fact_6209_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ X2 ) ) ).

% inf_le1
thf(fact_6210_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ Y2 ) ) ).

% inf_le2
thf(fact_6211_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( inf_inf @ A @ A2 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X2 @ A2 )
             => ~ ( ord_less_eq @ A @ X2 @ B2 ) ) ) ) ).

% le_infE
thf(fact_6212_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X2 @ A2 )
         => ( ( ord_less_eq @ A @ X2 @ B2 )
           => ( ord_less_eq @ A @ X2 @ ( inf_inf @ A @ A2 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_6213_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D3 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ ( inf_inf @ A @ C2 @ D3 ) ) ) ) ) ).

% inf_mono
thf(fact_6214_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% le_infI1
thf(fact_6215_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ X2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% le_infI2
thf(fact_6216_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( inf_inf @ A @ A2 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_6217_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( inf_inf @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% inf.orderI
thf(fact_6218_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X2: A,Y2: A] :
          ( ! [X3: A,Y3: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y3 ) @ X3 )
         => ( ! [X3: A,Y3: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y3 ) @ Y3 )
           => ( ! [X3: A,Y3: A,Z3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ( ord_less_eq @ A @ X3 @ Z3 )
                   => ( ord_less_eq @ A @ X3 @ ( F2 @ Y3 @ Z3 ) ) ) )
             => ( ( inf_inf @ A @ X2 @ Y2 )
                = ( F2 @ X2 @ Y2 ) ) ) ) ) ) ).

% inf_unique
thf(fact_6219_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X: A,Y: A] :
              ( ( inf_inf @ A @ X @ Y )
              = X ) ) ) ) ).

% le_iff_inf
thf(fact_6220_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb1
thf(fact_6221_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_6222_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( inf_inf @ A @ X2 @ Y2 )
            = X2 ) ) ) ).

% inf_absorb1
thf(fact_6223_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( inf_inf @ A @ X2 @ Y2 )
            = Y2 ) ) ) ).

% inf_absorb2
thf(fact_6224_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_6225_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_6226_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ Z )
           => ( ord_less_eq @ A @ X2 @ ( inf_inf @ A @ Y2 @ Z ) ) ) ) ) ).

% inf_greatest
thf(fact_6227_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( A4
              = ( inf_inf @ A @ A4 @ B3 ) ) ) ) ) ).

% inf.order_iff
thf(fact_6228_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ A2 ) ) ).

% inf.cobounded1
thf(fact_6229_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_6230_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( inf_inf @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_6231_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( inf_inf @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_6232_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_6233_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_6234_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S2: set @ A,T2: set @ A] :
          ( ( image @ A @ A
            @ ^ [X: A] : ( minus_minus @ A @ X @ A2 )
            @ ( inf_inf @ ( set @ A ) @ S2 @ T2 ) )
          = ( inf_inf @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X: A] : ( minus_minus @ A @ X @ A2 )
              @ S2 )
            @ ( image @ A @ A
              @ ^ [X: A] : ( minus_minus @ A @ X @ A2 )
              @ T2 ) ) ) ) ).

% translation_subtract_Int
thf(fact_6235_bij__prod__encode,axiom,
    bij_betw @ ( product_prod @ nat @ nat ) @ nat @ nat_prod_encode @ ( top_top @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( top_top @ ( set @ nat ) ) ).

% bij_prod_encode
thf(fact_6236_surj__prod__encode,axiom,
    ( ( image @ ( product_prod @ nat @ nat ) @ nat @ nat_prod_encode @ ( top_top @ ( set @ ( product_prod @ nat @ nat ) ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% surj_prod_encode
thf(fact_6237_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( inf_inf @ A @ X2 @ Y2 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% inf_shunt
thf(fact_6238_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D3: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D3 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ord_less_eq @ A @ D3 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D3 @ A2 ) ) ) ) ).

% Ioc_disjoint
thf(fact_6239_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X: B] : ( if @ A @ ( member @ B @ X @ B4 ) @ ( G @ X ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_restrict
thf(fact_6240_Ints__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_Ints @ A )
        = ( image @ int @ A @ ( ring_1_of_int @ A ) @ ( top_top @ ( set @ int ) ) ) ) ) ).

% Ints_def
thf(fact_6241_int__in__range__abs,axiom,
    ! [N2: nat] : ( member @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) ) ) ).

% int_in_range_abs
thf(fact_6242_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( finite_finite @ B @ S )
           => ( ! [I4: B] :
                  ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( H2 @ I4 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I4: B] :
                    ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ S @ T5 ) )
                   => ( ( G @ I4 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X3: B] :
                      ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S @ T5 ) )
                     => ( ( G @ X3 )
                        = ( H2 @ X3 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T5 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_6243_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,K: A] :
          ( ( ( ord_less @ A @ X2 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X2 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_6244_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_6245_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_6246_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( finite_finite @ B @ S )
           => ( ! [I4: B] :
                  ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T5 @ S ) )
                 => ( ( H2 @ I4 )
                    = ( one_one @ A ) ) )
             => ( ! [I4: B] :
                    ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ S @ T5 ) )
                   => ( ( G @ I4 )
                      = ( one_one @ A ) ) )
               => ( ! [X3: B] :
                      ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S @ T5 ) )
                     => ( ( G @ X3 )
                        = ( H2 @ X3 ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S )
                    = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T5 ) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
thf(fact_6247_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_6248_card__Diff__subset__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ).

% card_Diff_subset_Int
thf(fact_6249_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X: B] : ( if @ A @ ( P @ X ) @ ( H2 @ X ) @ ( G @ X ) )
              @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_6250_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X: B] : ( if @ A @ ( P @ X ) @ ( H2 @ X ) @ ( G @ X ) )
              @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_6251_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: set @ B,F2: B > A,B2: A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A4: B] : ( divide_divide @ A @ ( F2 @ A4 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A3
                  @ ( collect @ B
                    @ ^ [A4: B] : ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F2
                  @ ( inf_inf @ ( set @ B ) @ A3
                    @ ( collect @ B
                      @ ^ [A4: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_6252_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B4: A] :
          ( ( inf_inf @ A @ A3
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X: nat] : B4
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A3 @ B4 ) ) ) ).

% INF_nat_binary
thf(fact_6253_root__def,axiom,
    ( root
    = ( ^ [N: nat,X: real] :
          ( if @ real
          @ ( N
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) )
            @ X ) ) ) ) ).

% root_def
thf(fact_6254_inf__enat__def,axiom,
    ( ( inf_inf @ extended_enat )
    = ( ord_min @ extended_enat ) ) ).

% inf_enat_def
thf(fact_6255_inf__int__def,axiom,
    ( ( inf_inf @ int )
    = ( ord_min @ int ) ) ).

% inf_int_def
thf(fact_6256_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_6257_card__UNIV__char,axiom,
    ( ( finite_card @ char @ ( top_top @ ( set @ char ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% card_UNIV_char
thf(fact_6258_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X: A,Y: option @ A] : ( some @ A @ ( case_option @ A @ A @ X @ ( inf_inf @ A @ X ) @ Y ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Inf_fin.eq_fold'
thf(fact_6259_Inf__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
          = X2 ) ) ).

% Inf_fin.singleton
thf(fact_6260_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X2 @ A3 ) )
              = ( inf_inf @ A @ X2 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.insert
thf(fact_6261_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( inf_inf @ A @ X2 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
              = ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ).

% Inf_fin.in_idem
thf(fact_6262_Inf__fin__Min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% Inf_fin_Min
thf(fact_6263_Inf__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ A2 ) ) ) ) ).

% Inf_fin.coboundedI
thf(fact_6264_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X2 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less_eq @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Inf_fin.bounded_iff
thf(fact_6265_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A6: A] :
                  ( ( member @ A @ A6 @ A3 )
                 => ( ord_less_eq @ A @ X2 @ A6 ) )
             => ( ord_less_eq @ A @ X2 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.boundedI
thf(fact_6266_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X2 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
             => ! [A9: A] :
                  ( ( member @ A @ A9 @ A3 )
                 => ( ord_less_eq @ A @ X2 @ A9 ) ) ) ) ) ) ).

% Inf_fin.boundedE
thf(fact_6267_Inf__fin__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
              = ( complete_Inf_Inf @ A @ A3 ) ) ) ) ) ).

% Inf_fin_Inf
thf(fact_6268_Inf__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite @ A @ A3 )
         => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Inf_fin.infinite
thf(fact_6269_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ B4 ) @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.subset_imp
thf(fact_6270_Inf__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [H2: A > A,N5: set @ A] :
          ( ! [X3: A,Y3: A] :
              ( ( H2 @ ( inf_inf @ A @ X3 @ Y3 ) )
              = ( inf_inf @ A @ ( H2 @ X3 ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite @ A @ N5 )
           => ( ( N5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic7752659483105999362nf_fin @ A @ N5 ) )
                = ( lattic7752659483105999362nf_fin @ A @ ( image @ A @ A @ H2 @ N5 ) ) ) ) ) ) ) ).

% Inf_fin.hom_commute
thf(fact_6271_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
             => ( ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ B4 ) @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
                = ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.subset
thf(fact_6272_Inf__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y3: A] : ( member @ A @ ( inf_inf @ A @ X3 @ Y3 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ A3 ) ) ) ) ) ).

% Inf_fin.closed
thf(fact_6273_Inf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X2 @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X2 @ A3 ) )
                = ( inf_inf @ A @ X2 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
thf(fact_6274_Inf__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ X2 @ A3 ) ) ) ) ).

% Inf_fin.eq_fold
thf(fact_6275_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X2 @ A3 ) )
                = X2 ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X2 @ A3 ) )
                = ( inf_inf @ A @ X2 @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.insert_remove
thf(fact_6276_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
                  = X2 ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
                  = ( inf_inf @ A @ X2 @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.remove
thf(fact_6277_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_6278_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: A] :
          ( ( unique5772411509450598832har_of @ A @ ( modulo_modulo @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
          = ( unique5772411509450598832har_of @ A @ N2 ) ) ) ).

% char_of_mod_256
thf(fact_6279_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: A,N2: A] :
          ( ( ( unique5772411509450598832har_of @ A @ M )
            = ( unique5772411509450598832har_of @ A @ N2 ) )
          = ( ( modulo_modulo @ A @ M @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
            = ( modulo_modulo @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% char_of_quasi_inj
thf(fact_6280_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,M: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N2 )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ M ) )
            = ( unique5772411509450598832har_of @ A @ M ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_6281_of__char__of,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [A2: A] :
          ( ( comm_s6883823935334413003f_char @ A @ ( unique5772411509450598832har_of @ A @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_of
thf(fact_6282_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_6283_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [C2: char] :
          ( ( modulo_modulo @ A @ ( comm_s6883823935334413003f_char @ A @ C2 ) @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
          = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ).

% of_char_mod_256
thf(fact_6284_char_Osize_I2_J,axiom,
    ! [X15: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_size @ char @ ( char2 @ X15 @ X22 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size(2)
thf(fact_6285_nat__of__char__less__256,axiom,
    ! [C2: char] : ( ord_less @ nat @ ( comm_s6883823935334413003f_char @ nat @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% nat_of_char_less_256
thf(fact_6286_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_6287_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: A,C2: char] :
          ( ( ( unique5772411509450598832har_of @ A @ N2 )
            = C2 )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N2 )
            = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ) ).

% char_of_eq_iff
thf(fact_6288_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B22 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B1 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_6289_char_Osize__gen,axiom,
    ! [X15: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_char @ ( char2 @ X15 @ X22 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size_gen
thf(fact_6290_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] :
      ( ( comm_s6883823935334413003f_char @ nat @ ( ascii_of @ C2 ) )
      = ( bit_se2584673776208193580ke_bit @ nat @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) @ ( comm_s6883823935334413003f_char @ nat @ C2 ) ) ) ).

% String.char_of_ascii_of
thf(fact_6291_DERIV__real__root__generic,axiom,
    ! [N2: nat,X2: real,D6: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( X2
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
             => ( D6
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
             => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
               => ( D6
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
               => ( D6
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N2 ) @ D6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_6292_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,Z: A,X2: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X2 ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S ) ) )
          = ( has_field_derivative @ A
            @ ^ [X: A] : ( F2 @ ( plus_plus @ A @ Z @ X ) )
            @ Y2
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% DERIV_at_within_shift
thf(fact_6293_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X2: A,S2: set @ A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( image @ A @ A @ G @ S2 ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_image_chain
thf(fact_6294_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,Z: A,X2: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X2 ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S ) ) )
         => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ ( plus_plus @ A @ Z ) ) @ Y2 @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% DERIV_at_within_shift_lemma
thf(fact_6295_DERIV__ln,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( inverse_inverse @ real @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln
thf(fact_6296_DERIV__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ B )
     => ! [S: set @ A,F2: B > A > B,F6: C > A > B,X2: C,F3: filter @ B] :
          ( ! [N3: A] :
              ( ( member @ A @ N3 @ S )
             => ( has_field_derivative @ B
                @ ^ [X: B] : ( F2 @ X @ N3 )
                @ ( F6 @ X2 @ N3 )
                @ F3 ) )
         => ( has_field_derivative @ B
            @ ^ [X: B] : ( groups7311177749621191930dd_sum @ A @ B @ ( F2 @ X ) @ S )
            @ ( groups7311177749621191930dd_sum @ A @ B @ ( F6 @ X2 ) @ S )
            @ F3 ) ) ) ).

% DERIV_sum
thf(fact_6297_has__real__derivative__pos__inc__right,axiom,
    ! [F2: real > real,L2: real,X2: real,S: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ S ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( plus_plus @ real @ X2 @ H6 ) @ S )
                 => ( ( ord_less @ real @ H6 @ D5 )
                   => ( ord_less @ real @ ( F2 @ X2 ) @ ( F2 @ ( plus_plus @ real @ X2 @ H6 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_6298_has__real__derivative__neg__dec__right,axiom,
    ! [F2: real > real,L2: real,X2: real,S: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ S ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( plus_plus @ real @ X2 @ H6 ) @ S )
                 => ( ( ord_less @ real @ H6 @ D5 )
                   => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X2 @ H6 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_6299_DERIV__const,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [K: A,F3: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X: A] : K
          @ ( zero_zero @ A )
          @ F3 ) ) ).

% DERIV_const
thf(fact_6300_field__differentiable__minus,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,F3: filter @ A] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ F3 )
         => ( has_field_derivative @ A
            @ ^ [Z5: A] : ( uminus_uminus @ A @ ( F2 @ Z5 ) )
            @ ( uminus_uminus @ A @ F6 )
            @ F3 ) ) ) ).

% field_differentiable_minus
thf(fact_6301_DERIV__minus,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] : ( uminus_uminus @ A @ ( F2 @ X ) )
            @ ( uminus_uminus @ A @ D6 )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_minus
thf(fact_6302_DERIV__ident,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X: A] : X
          @ ( one_one @ A )
          @ F3 ) ) ).

% DERIV_ident
thf(fact_6303_DERIV__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( plus_plus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( plus_plus @ A @ D6 @ E5 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_add
thf(fact_6304_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,F3: filter @ A,G: A > A,G5: A] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ F3 )
         => ( ( has_field_derivative @ A @ G @ G5 @ F3 )
           => ( has_field_derivative @ A
              @ ^ [Z5: A] : ( plus_plus @ A @ ( F2 @ Z5 ) @ ( G @ Z5 ) )
              @ ( plus_plus @ A @ F6 @ G5 )
              @ F3 ) ) ) ) ).

% field_differentiable_add
thf(fact_6305_DERIV__cong,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,X6: A,F3: filter @ A,Y6: A] :
          ( ( has_field_derivative @ A @ F2 @ X6 @ F3 )
         => ( ( X6 = Y6 )
           => ( has_field_derivative @ A @ F2 @ Y6 @ F3 ) ) ) ) ).

% DERIV_cong
thf(fact_6306_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,X2: A,S2: set @ A] : ( has_field_derivative @ A @ ( times_times @ A @ C2 ) @ C2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ).

% DERIV_cmult_Id
thf(fact_6307_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] : ( divide_divide @ A @ ( F2 @ X ) @ C2 )
            @ ( divide_divide @ A @ D6 @ C2 )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_cdivide
thf(fact_6308_DERIV__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( minus_minus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( minus_minus @ A @ D6 @ E5 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_diff
thf(fact_6309_field__differentiable__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,F3: filter @ A,G: A > A,G5: A] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ F3 )
         => ( ( has_field_derivative @ A @ G @ G5 @ F3 )
           => ( has_field_derivative @ A
              @ ^ [Z5: A] : ( minus_minus @ A @ ( F2 @ Z5 ) @ ( G @ Z5 ) )
              @ ( minus_minus @ A @ F6 @ G5 )
              @ F3 ) ) ) ) ).

% field_differentiable_diff
thf(fact_6310_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] : ( times_times @ A @ C2 @ ( F2 @ X ) )
            @ ( times_times @ A @ C2 @ D6 )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_cmult
thf(fact_6311_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] : ( times_times @ A @ ( F2 @ X ) @ C2 )
            @ ( times_times @ A @ D6 @ C2 )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_cmult_right
thf(fact_6312_has__field__derivative__cosh,axiom,
    ! [A10: $tType] :
      ( ( ( real_Vector_banach @ A10 )
        & ( real_V3459762299906320749_field @ A10 ) )
     => ! [G: A10 > A10,Db: A10,X2: A10,S2: set @ A10] :
          ( ( has_field_derivative @ A10 @ G @ Db @ ( topolo174197925503356063within @ A10 @ X2 @ S2 ) )
         => ( has_field_derivative @ A10
            @ ^ [X: A10] : ( cosh @ A10 @ ( G @ X ) )
            @ ( times_times @ A10 @ ( sinh @ A10 @ ( G @ X2 ) ) @ Db )
            @ ( topolo174197925503356063within @ A10 @ X2 @ S2 ) ) ) ) ).

% has_field_derivative_cosh
thf(fact_6313_has__field__derivative__sinh,axiom,
    ! [A10: $tType] :
      ( ( ( real_Vector_banach @ A10 )
        & ( real_V3459762299906320749_field @ A10 ) )
     => ! [G: A10 > A10,Db: A10,X2: A10,S2: set @ A10] :
          ( ( has_field_derivative @ A10 @ G @ Db @ ( topolo174197925503356063within @ A10 @ X2 @ S2 ) )
         => ( has_field_derivative @ A10
            @ ^ [X: A10] : ( sinh @ A10 @ ( G @ X ) )
            @ ( times_times @ A10 @ ( cosh @ A10 @ ( G @ X2 ) ) @ Db )
            @ ( topolo174197925503356063within @ A10 @ X2 @ S2 ) ) ) ) ).

% has_field_derivative_sinh
thf(fact_6314_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( inverse_inverse @ A @ ( F2 @ X ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X2 ) ) @ D6 ) @ ( inverse_inverse @ A @ ( F2 @ X2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_6315_DERIV__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,X2: A,S2: set @ A,G: A > A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( plus_plus @ A @ ( times_times @ A @ Da @ ( G @ X2 ) ) @ ( times_times @ A @ Db @ ( F2 @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_mult
thf(fact_6316_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X2 ) @ E5 ) @ ( times_times @ A @ D6 @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_mult'
thf(fact_6317_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X: A] : ( divide_divide @ A @ ( F2 @ X ) @ ( G @ X ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D6 @ ( G @ X2 ) ) @ ( times_times @ A @ ( F2 @ X2 ) @ E5 ) ) @ ( times_times @ A @ ( G @ X2 ) @ ( G @ X2 ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_6318_has__real__derivative__pos__inc__left,axiom,
    ! [F2: real > real,L2: real,X2: real,S: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ S ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( minus_minus @ real @ X2 @ H6 ) @ S )
                 => ( ( ord_less @ real @ H6 @ D5 )
                   => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X2 @ H6 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_6319_has__real__derivative__neg__dec__left,axiom,
    ! [F2: real > real,L2: real,X2: real,S: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ S ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( minus_minus @ real @ X2 @ H6 ) @ S )
                 => ( ( ord_less @ real @ H6 @ D5 )
                   => ( ord_less @ real @ ( F2 @ X2 ) @ ( F2 @ ( minus_minus @ real @ X2 @ H6 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_6320_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,X2: A,S2: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
           => ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ) ).

% has_field_derivative_subset
thf(fact_6321_DERIV__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,X2: A,S2: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
           => ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ) ).

% DERIV_subset
thf(fact_6322_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X2: real,Y2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
       => ( ( member @ real @ Y2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ! [X3: real] :
                ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
           => ( ( F2 @ X2 )
              = ( F2 @ Y2 ) ) ) ) ) ) ).

% DERIV_isconst3
thf(fact_6323_DERIV__pos__inc__right,axiom,
    ! [F2: real > real,L2: real,X2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D5 )
                 => ( ord_less @ real @ ( F2 @ X2 ) @ ( F2 @ ( plus_plus @ real @ X2 @ H6 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_6324_DERIV__neg__dec__right,axiom,
    ! [F2: real > real,L2: real,X2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D5 )
                 => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X2 @ H6 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_6325_DERIV__isconst__all,axiom,
    ! [F2: real > real,X2: real,Y2: real] :
      ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( F2 @ X2 )
        = ( F2 @ Y2 ) ) ) ).

% DERIV_isconst_all
thf(fact_6326_DERIV__mirror,axiom,
    ! [F2: real > real,Y2: real,X2: real] :
      ( ( has_field_derivative @ real @ F2 @ Y2 @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ X2 ) @ ( top_top @ ( set @ real ) ) ) )
      = ( has_field_derivative @ real
        @ ^ [X: real] : ( F2 @ ( uminus_uminus @ real @ X ) )
        @ ( uminus_uminus @ real @ Y2 )
        @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_mirror
thf(fact_6327_DERIV__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,X2: A,Z: A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ X2 @ Z ) @ ( top_top @ ( set @ A ) ) ) )
          = ( has_field_derivative @ A
            @ ^ [X: A] : ( F2 @ ( plus_plus @ A @ X @ Z ) )
            @ Y2
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_shift
thf(fact_6328_DERIV__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ E5 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
           => ( D6 = E5 ) ) ) ) ).

% DERIV_unique
thf(fact_6329_has__field__derivative__at__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,X2: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_field_derivative_at_within
thf(fact_6330_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
          = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ K ) ) ) ) ).

% DERIV_const_ratio_const
thf(fact_6331_DERIV__const__ratio__const2,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( divide_divide @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ real @ B2 @ A2 ) )
          = K ) ) ) ).

% DERIV_const_ratio_const2
thf(fact_6332_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ ( F2 @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( G @ ( F2 @ X ) )
              @ ( times_times @ A @ E5 @ D6 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_chain'
thf(fact_6333_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X2: A,Db: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( F2 @ ( G @ X ) )
              @ ( times_times @ A @ Da @ Db )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_chain2
thf(fact_6334_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [G: A > A,G5: A > A,F2: A > A,F6: A,X2: A] :
          ( ! [X3: A] : ( has_field_derivative @ A @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( G @ ( F2 @ X ) )
              @ ( times_times @ A @ F6 @ ( G5 @ ( F2 @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% DERIV_chain3
thf(fact_6335_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S2: set @ A,G: A > A,G5: A > A,F2: A > A,F6: A,X2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ S2 )
             => ( has_field_derivative @ A @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
           => ( ( member @ A @ ( F2 @ X2 ) @ S2 )
             => ( has_field_derivative @ A
                @ ^ [X: A] : ( G @ ( F2 @ X ) )
                @ ( times_times @ A @ F6 @ ( G5 @ ( F2 @ X2 ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% DERIV_chain_s
thf(fact_6336_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X2: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] : ( sin @ A @ ( G @ X ) )
            @ ( times_times @ A @ ( cos @ A @ ( G @ X2 ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_sin
thf(fact_6337_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X2: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] : ( exp @ A @ ( G @ X ) )
            @ ( times_times @ A @ ( exp @ A @ ( G @ X2 ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_exp
thf(fact_6338_DERIV__local__const,axiom,
    ! [F2: real > real,L2: real,X2: real,D3: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
       => ( ! [Y3: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y3 ) ) @ D3 )
             => ( ( F2 @ X2 )
                = ( F2 @ Y3 ) ) )
         => ( L2
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_6339_DERIV__pos__inc__left,axiom,
    ! [F2: real > real,L2: real,X2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D5 )
                 => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X2 @ H6 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_6340_DERIV__neg__dec__left,axiom,
    ! [F2: real > real,L2: real,X2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D5 )
                 => ( ord_less @ real @ ( F2 @ X2 ) @ ( F2 @ ( minus_minus @ real @ X2 @ H6 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_6341_DERIV__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X2: A,Db: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_chain
thf(fact_6342_MVT2,axiom,
    ! [A2: real,B2: real,F2: real > real,F6: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ( has_field_derivative @ real @ F2 @ ( F6 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z3: real] :
            ( ( ord_less @ real @ A2 @ Z3 )
            & ( ord_less @ real @ Z3 @ B2 )
            & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F6 @ Z3 ) ) ) ) ) ) ).

% MVT2
thf(fact_6343_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_6344_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_6345_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_6346_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_6347_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: real > real,G5: real > real] :
      ( ! [X3: real] :
          ( ( member @ real @ X3 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
         => ( has_field_derivative @ real @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G5 @ X3 ) ) )
       => ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ord_less_eq @ real @ ( G @ A2 ) @ ( G @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_6348_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X2: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] : ( cos @ A @ ( G @ X ) )
            @ ( times_times @ A @ ( uminus_uminus @ A @ ( sin @ A @ ( G @ X2 ) ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_cos
thf(fact_6349_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K: A,Xa: A] :
          ( has_field_derivative @ A
          @ ^ [X: A] : ( cos @ A @ ( plus_plus @ A @ X @ K ) )
          @ ( uminus_uminus @ A @ ( sin @ A @ ( plus_plus @ A @ Xa @ K ) ) )
          @ ( topolo174197925503356063within @ A @ Xa @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos_add
thf(fact_6350_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,N2: nat] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] : ( power_power @ A @ ( F2 @ X ) @ ( suc @ N2 ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( times_times @ A @ D6 @ ( power_power @ A @ ( F2 @ X2 ) @ N2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_power_Suc
thf(fact_6351_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ V @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( V @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ real @ ( plus_plus @ real @ ( V @ A2 ) @ ( V @ B2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% DERIV_const_average
thf(fact_6352_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X2: A,S2: set @ A] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_inverse
thf(fact_6353_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A,N2: nat] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] : ( power_power @ A @ ( F2 @ X ) @ N2 )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( times_times @ A @ D6 @ ( power_power @ A @ ( F2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_power
thf(fact_6354_DERIV__local__min,axiom,
    ! [F2: real > real,L2: real,X2: real,D3: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
       => ( ! [Y3: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y3 ) ) @ D3 )
             => ( ord_less_eq @ real @ ( F2 @ X2 ) @ ( F2 @ Y3 ) ) )
         => ( L2
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_6355_DERIV__local__max,axiom,
    ! [F2: real > real,L2: real,X2: real,D3: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
       => ( ! [Y3: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y3 ) ) @ D3 )
             => ( ord_less_eq @ real @ ( F2 @ Y3 ) @ ( F2 @ X2 ) ) )
         => ( L2
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_6356_DERIV__ln__divide,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_6357_DERIV__pow,axiom,
    ! [N2: nat,X2: real,S2: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X: real] : ( power_power @ real @ X @ N2 )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ X2 @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X2 @ S2 ) ) ).

% DERIV_pow
thf(fact_6358_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ! [Y3: A] :
              ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Y3 @ N ) ) )
         => ( has_field_derivative @ A
            @ ^ [X: A] :
                ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
            @ ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_6359_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X2 )
         => ( ( ord_less @ A @ X2 @ B2 )
           => ( ( topolo174197925503356063within @ A @ X2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_6360_DERIV__fun__pow,axiom,
    ! [G: real > real,M: real,X2: real,N2: nat] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X: real] : ( power_power @ real @ ( G @ X ) @ N2 )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( G @ X2 ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_6361_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_6362_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D3: A,X2: A,S2: set @ A,G: A > A,E2: A] :
          ( ( has_field_derivative @ A @ F2 @ D3 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y: A] : ( divide_divide @ A @ ( F2 @ Y ) @ ( G @ Y ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D3 @ ( G @ X2 ) ) @ ( times_times @ A @ E2 @ ( F2 @ X2 ) ) ) @ ( power_power @ A @ ( G @ X2 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_6363_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D3: A,X2: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D3 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( inverse_inverse @ A @ ( F2 @ X ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D3 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F2 @ X2 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_6364_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,F2: A > A,F6: A,Z: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K5 )
             => ( sums @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Z3 @ N ) )
                @ ( F2 @ Z3 ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
             => ( sums @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ Z @ N ) )
                @ F6 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_6365_has__real__derivative__powr,axiom,
    ! [Z: real,R: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z )
     => ( has_field_derivative @ real
        @ ^ [Z5: real] : ( powr @ real @ Z5 @ R )
        @ ( times_times @ real @ R @ ( powr @ real @ Z @ ( minus_minus @ real @ R @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_6366_DERIV__series_H,axiom,
    ! [F2: real > nat > real,F6: real > nat > real,X0: real,A2: real,B2: real,L6: nat > real] :
      ( ! [N3: nat] :
          ( has_field_derivative @ real
          @ ^ [X: real] : ( F2 @ X @ N3 )
          @ ( F6 @ X0 @ N3 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F2 @ X3 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F6 @ X0 ) )
           => ( ( summable @ real @ L6 )
             => ( ! [N3: nat,X3: real,Y3: real] :
                    ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F2 @ X3 @ N3 ) @ ( F2 @ Y3 @ N3 ) ) ) @ ( times_times @ real @ ( L6 @ N3 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y3 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X: real] : ( suminf @ real @ ( F2 @ X ) )
                  @ ( suminf @ real @ ( F6 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_6367_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,Z: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K5 )
             => ( summable @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Z3 @ N ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( has_field_derivative @ A
              @ ^ [Z5: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Z5 @ N ) ) )
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
              @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_6368_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_6369_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
           => ( ( summable @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N ) @ ( power_power @ A @ K5 @ N ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
               => ( has_field_derivative @ A
                  @ ^ [X: A] :
                      ( suminf @ A
                      @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
                  @ ( suminf @ A
                    @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X2 @ N ) ) )
                  @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_6370_DERIV__log,axiom,
    ! [X2: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X2 ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_6371_DERIV__fun__powr,axiom,
    ! [G: real > real,M: real,X2: real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
       => ( has_field_derivative @ real
          @ ^ [X: real] : ( powr @ real @ ( G @ X ) @ R )
          @ ( times_times @ real @ ( times_times @ real @ R @ ( powr @ real @ ( G @ X2 ) @ ( minus_minus @ real @ R @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_6372_DERIV__powr,axiom,
    ! [G: real > real,M: real,X2: real,F2: real > real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
       => ( ( has_field_derivative @ real @ F2 @ R @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X: real] : ( powr @ real @ ( G @ X ) @ ( F2 @ X ) )
            @ ( times_times @ real @ ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ R @ ( ln_ln @ real @ ( G @ X2 ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F2 @ X2 ) ) @ ( G @ X2 ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_6373_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_6374_DERIV__real__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_6375_DERIV__arctan,axiom,
    ! [X2: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_6376_arsinh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ A3 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_6377_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sin @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_6378_has__field__derivative__tanh,axiom,
    ! [A10: $tType] :
      ( ( ( real_Vector_banach @ A10 )
        & ( real_V3459762299906320749_field @ A10 ) )
     => ! [G: A10 > A10,X2: A10,Db: A10,S2: set @ A10] :
          ( ( ( cosh @ A10 @ ( G @ X2 ) )
           != ( zero_zero @ A10 ) )
         => ( ( has_field_derivative @ A10 @ G @ Db @ ( topolo174197925503356063within @ A10 @ X2 @ S2 ) )
           => ( has_field_derivative @ A10
              @ ^ [X: A10] : ( tanh @ A10 @ ( G @ X ) )
              @ ( times_times @ A10 @ ( minus_minus @ A10 @ ( one_one @ A10 ) @ ( power_power @ A10 @ ( tanh @ A10 @ ( G @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A10 @ X2 @ S2 ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_6379_DERIV__real__sqrt__generic,axiom,
    ! [X2: real,D6: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( D6
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
           => ( D6
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_6380_arcosh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ A3 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_6381_artanh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ A3 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_6382_DERIV__power__series_H,axiom,
    ! [R3: real,F2: nat > real,X0: real] :
      ( ! [X3: real] :
          ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R3 ) @ R3 ) )
         => ( summable @ real
            @ ^ [N: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) @ ( power_power @ real @ X3 @ N ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R3 ) @ R3 ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
         => ( has_field_derivative @ real
            @ ^ [X: real] :
                ( suminf @ real
                @ ^ [N: nat] : ( times_times @ real @ ( F2 @ N ) @ ( power_power @ real @ X @ ( suc @ N ) ) ) )
            @ ( suminf @ real
              @ ^ [N: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) @ ( power_power @ real @ X0 @ N ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_6383_DERIV__real__root,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_6384_DERIV__arccos,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_6385_DERIV__arcsin,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_6386_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F2: real > real,X2: real,N2: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
        & ! [M4: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
          & ( ( F2 @ X2 )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X2 @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_6387_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,X2: real,N2: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
            & ( ( F2 @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X2 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_6388_DERIV__odd__real__root,axiom,
    ! [N2: nat,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( X2
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_6389_Maclaurin,axiom,
    ! [H2: real,N2: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N2 )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                  & ( ord_less_eq @ real @ T4 @ H2 ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less @ real @ T4 @ H2 )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_6390_Maclaurin2,axiom,
    ! [H2: real,Diff: nat > real > real,F2: real > real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less_eq @ real @ T4 @ H2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ H2 )
              & ( ( F2 @ H2 )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                    @ ( set_ord_lessThan @ nat @ N2 ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_6391_Maclaurin__minus,axiom,
    ! [H2: real,N2: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ H2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N2 )
                  & ( ord_less_eq @ real @ H2 @ T4 )
                  & ( ord_less_eq @ real @ T4 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ H2 @ T4 )
                & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_6392_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F2: real > real,N2: nat,X2: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( X2
           != ( zero_zero @ real ) )
         => ( ! [M4: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
                & ( ( F2 @ X2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X2 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_6393_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,N2: nat,X2: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,T4: real] :
            ( ( ( ord_less @ nat @ M4 @ N2 )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
            & ( ( F2 @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X2 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_6394_Taylor,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X2 )
               => ( ( ord_less_eq @ real @ X2 @ B2 )
                 => ( ( X2 != C2 )
                   => ? [T4: real] :
                        ( ( ( ord_less @ real @ X2 @ C2 )
                         => ( ( ord_less @ real @ X2 @ T4 )
                            & ( ord_less @ real @ T4 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X2 @ C2 )
                         => ( ( ord_less @ real @ C2 @ T4 )
                            & ( ord_less @ real @ T4 @ X2 ) ) )
                        & ( ( F2 @ X2 )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X2 @ C2 ) @ M3 ) )
                              @ ( set_ord_lessThan @ nat @ N2 ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_6395_Taylor__up,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ C2 @ T4 )
                  & ( ord_less @ real @ T4 @ B2 )
                  & ( ( F2 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_6396_Taylor__down,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ A2 @ T4 )
                  & ( ord_less @ real @ T4 @ C2 )
                  & ( ( F2 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_6397_Maclaurin__lemma2,axiom,
    ! [N2: nat,H2: real,Diff: nat > real > real,K: nat,B4: real] :
      ( ! [M4: nat,T4: real] :
          ( ( ( ord_less @ nat @ M4 @ N2 )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ H2 ) )
         => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N2
          = ( suc @ K ) )
       => ! [M2: nat,T8: real] :
            ( ( ( ord_less @ nat @ M2 @ N2 )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H2 ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M2 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M2 @ P4 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) @ ( power_power @ real @ U2 @ P4 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ M2 ) ) )
                    @ ( times_times @ real @ B4 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N2 @ M2 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M2 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P4: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M2 ) @ P4 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P4 ) ) @ ( power_power @ real @ T8 @ P4 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ M2 ) ) ) )
                  @ ( times_times @ real @ B4 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N2 @ ( suc @ M2 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ ( suc @ M2 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_6398_DERIV__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X9: real] :
            ( suminf @ real
            @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X9 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( power_power @ real @ X2 @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_6399_DERIV__even__real__root,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_6400_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G5: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X2 ) )
         => ( ( ord_less @ real @ ( G @ X2 ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
             => ( has_derivative @ A @ real
                @ ^ [X: A] : ( arcsin @ ( G @ X ) )
                @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_6401_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G5: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X2 ) )
         => ( ( ord_less @ real @ ( G @ X2 ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
             => ( has_derivative @ A @ real
                @ ^ [X: A] : ( arccos @ ( G @ X ) )
                @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_6402_has__derivative__in__compose,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F2: A > B,F6: A > B,X2: A,S2: set @ A,G: B > C,G5: B > C] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_derivative @ B @ C @ G @ G5 @ ( topolo174197925503356063within @ B @ ( F2 @ X2 ) @ ( image @ A @ B @ F2 @ S2 ) ) )
           => ( has_derivative @ A @ C
              @ ^ [X: A] : ( G @ ( F2 @ X ) )
              @ ^ [X: A] : ( G5 @ ( F6 @ X ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_in_compose
thf(fact_6403_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F2: D > real,F6: D > real,X2: D,S2: set @ D,G: D > C,G5: D > C] :
          ( ( has_derivative @ D @ real @ F2 @ F6 @ ( topolo174197925503356063within @ D @ X2 @ S2 ) )
         => ( ( has_derivative @ D @ C @ G @ G5 @ ( topolo174197925503356063within @ D @ X2 @ S2 ) )
           => ( has_derivative @ D @ C
              @ ^ [X: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X ) @ ( G @ X ) )
              @ ^ [H: D] : ( plus_plus @ C @ ( real_V8093663219630862766scaleR @ C @ ( F2 @ X2 ) @ ( G5 @ H ) ) @ ( real_V8093663219630862766scaleR @ C @ ( F6 @ H ) @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ D @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_scaleR
thf(fact_6404_has__derivative__transform,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X2: A,S2: set @ A,G: A > B,F2: A > B,F6: A > B] :
          ( ( member @ A @ X2 @ S2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( G @ X3 )
                  = ( F2 @ X3 ) ) )
           => ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
             => ( has_derivative @ A @ B @ G @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% has_derivative_transform
thf(fact_6405_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( has_field_derivative @ A )
        = ( ^ [F4: A > A,D7: A] : ( has_derivative @ A @ A @ F4 @ ( times_times @ A @ D7 ) ) ) ) ) ).

% has_field_derivative_def
thf(fact_6406_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A > A,F3: filter @ A,D8: A] :
          ( ( has_derivative @ A @ A @ F2 @ D6 @ F3 )
         => ( ! [X3: A] :
                ( ( times_times @ A @ X3 @ D8 )
                = ( D6 @ X3 ) )
           => ( has_field_derivative @ A @ F2 @ D8 @ F3 ) ) ) ) ).

% has_derivative_imp_has_field_derivative
thf(fact_6407_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,F3: filter @ A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ F3 )
         => ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D6 ) @ F3 ) ) ) ).

% has_field_derivative_imp_has_derivative
thf(fact_6408_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A,S2: set @ A,T2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
           => ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ) ).

% has_derivative_subset
thf(fact_6409_has__derivative__compose,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F2: A > B,F6: A > B,X2: A,S2: set @ A,G: B > C,G5: B > C] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_derivative @ B @ C @ G @ G5 @ ( topolo174197925503356063within @ B @ ( F2 @ X2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( has_derivative @ A @ C
              @ ^ [X: A] : ( G @ ( F2 @ X ) )
              @ ^ [X: A] : ( G5 @ ( F6 @ X ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_compose
thf(fact_6410_has__derivative__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F3: A > B,X2: A,F7: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F3 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
           => ( F3 = F7 ) ) ) ) ).

% has_derivative_unique
thf(fact_6411_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G5: C > A,F3: filter @ C,X2: A] :
          ( ( has_derivative @ C @ A @ G @ G5 @ F3 )
         => ( has_derivative @ C @ A
            @ ^ [X: C] : ( times_times @ A @ X2 @ ( G @ X ) )
            @ ^ [X: C] : ( times_times @ A @ X2 @ ( G5 @ X ) )
            @ F3 ) ) ) ).

% has_derivative_mult_right
thf(fact_6412_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G5: C > A,F3: filter @ C,Y2: A] :
          ( ( has_derivative @ C @ A @ G @ G5 @ F3 )
         => ( has_derivative @ C @ A
            @ ^ [X: C] : ( times_times @ A @ ( G @ X ) @ Y2 )
            @ ^ [X: C] : ( times_times @ A @ ( G5 @ X ) @ Y2 )
            @ F3 ) ) ) ).

% has_derivative_mult_left
thf(fact_6413_has__derivative__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,F3: filter @ A,G: A > B,G5: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ F3 )
         => ( ( has_derivative @ A @ B @ G @ G5 @ F3 )
           => ( has_derivative @ A @ B
              @ ^ [X: A] : ( minus_minus @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ ^ [X: A] : ( minus_minus @ B @ ( F6 @ X ) @ ( G5 @ X ) )
              @ F3 ) ) ) ) ).

% has_derivative_diff
thf(fact_6414_has__derivative__eq__rhs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,F3: filter @ A,G5: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ F3 )
         => ( ( F6 = G5 )
           => ( has_derivative @ A @ B @ F2 @ G5 @ F3 ) ) ) ) ).

% has_derivative_eq_rhs
thf(fact_6415_has__derivative__scaleR__right,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [G: C > B,G5: C > B,F3: filter @ C,R: real] :
          ( ( has_derivative @ C @ B @ G @ G5 @ F3 )
         => ( has_derivative @ C @ B
            @ ^ [X: C] : ( real_V8093663219630862766scaleR @ B @ R @ ( G @ X ) )
            @ ^ [X: C] : ( real_V8093663219630862766scaleR @ B @ R @ ( G5 @ X ) )
            @ F3 ) ) ) ).

% has_derivative_scaleR_right
thf(fact_6416_has__derivative__scaleR__left,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [G: C > real,G5: C > real,F3: filter @ C,X2: B] :
          ( ( has_derivative @ C @ real @ G @ G5 @ F3 )
         => ( has_derivative @ C @ B
            @ ^ [X: C] : ( real_V8093663219630862766scaleR @ B @ ( G @ X ) @ X2 )
            @ ^ [X: C] : ( real_V8093663219630862766scaleR @ B @ ( G5 @ X ) @ X2 )
            @ F3 ) ) ) ).

% has_derivative_scaleR_left
thf(fact_6417_has__derivative__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [G: C > real,G5: C > real,F3: filter @ C] :
          ( ( has_derivative @ C @ real @ G @ G5 @ F3 )
         => ( has_derivative @ C @ A
            @ ^ [X: C] : ( real_Vector_of_real @ A @ ( G @ X ) )
            @ ^ [X: C] : ( real_Vector_of_real @ A @ ( G5 @ X ) )
            @ F3 ) ) ) ).

% has_derivative_of_real
thf(fact_6418_has__derivative__ident,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: filter @ A] :
          ( has_derivative @ A @ A
          @ ^ [X: A] : X
          @ ^ [X: A] : X
          @ F3 ) ) ).

% has_derivative_ident
thf(fact_6419_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,F3: filter @ A,G: A > B,G5: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ F3 )
         => ( ( has_derivative @ A @ B @ G @ G5 @ F3 )
           => ( has_derivative @ A @ B
              @ ^ [X: A] : ( plus_plus @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ ^ [X: A] : ( plus_plus @ B @ ( F6 @ X ) @ ( G5 @ X ) )
              @ F3 ) ) ) ) ).

% has_derivative_add
thf(fact_6420_has__derivative__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,F3: filter @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ F3 )
         => ( has_derivative @ A @ B
            @ ^ [X: A] : ( uminus_uminus @ B @ ( F2 @ X ) )
            @ ^ [X: A] : ( uminus_uminus @ B @ ( F6 @ X ) )
            @ F3 ) ) ) ).

% has_derivative_minus
thf(fact_6421_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [C2: B,F3: filter @ A] :
          ( has_derivative @ A @ B
          @ ^ [X: A] : C2
          @ ^ [X: A] : ( zero_zero @ B )
          @ F3 ) ) ).

% has_derivative_const
thf(fact_6422_has__derivative__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [I5: set @ A,F2: A > B > C,F6: A > B > C,F3: filter @ B] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I5 )
             => ( has_derivative @ B @ C @ ( F2 @ I4 ) @ ( F6 @ I4 ) @ F3 ) )
         => ( has_derivative @ B @ C
            @ ^ [X: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ I5 )
            @ ^ [X: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I3: A] : ( F6 @ I3 @ X )
                @ I5 )
            @ F3 ) ) ) ).

% has_derivative_sum
thf(fact_6423_has__derivative__id,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A] : ( has_derivative @ A @ A @ ( id @ A ) @ ( id @ A ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% has_derivative_id
thf(fact_6424_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F2: D > A,F6: D > A,X2: D,S2: set @ D,G: D > A,G5: D > A] :
          ( ( has_derivative @ D @ A @ F2 @ F6 @ ( topolo174197925503356063within @ D @ X2 @ S2 ) )
         => ( ( has_derivative @ D @ A @ G @ G5 @ ( topolo174197925503356063within @ D @ X2 @ S2 ) )
           => ( has_derivative @ D @ A
              @ ^ [X: D] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ^ [H: D] : ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X2 ) @ ( G5 @ H ) ) @ ( times_times @ A @ ( F6 @ H ) @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ D @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_mult
thf(fact_6425_has__derivative__zero__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,X2: A] :
          ( ( has_derivative @ A @ B
            @ ^ [X: A] : ( zero_zero @ B )
            @ F3
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( F3
            = ( ^ [H: A] : ( zero_zero @ B ) ) ) ) ) ).

% has_derivative_zero_unique
thf(fact_6426_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T2: set @ A,G: A > B,G5: A > A > B,F2: C > A,S2: set @ C,X2: C,F6: C > A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ T2 )
             => ( has_derivative @ A @ B @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ T2 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S2 ) @ T2 )
           => ( ( member @ C @ X2 @ S2 )
             => ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X2 @ S2 ) )
               => ( has_derivative @ C @ B
                  @ ^ [X: C] : ( G @ ( F2 @ X ) )
                  @ ^ [Y: C] : ( G5 @ ( F2 @ X2 ) @ ( F6 @ Y ) )
                  @ ( topolo174197925503356063within @ C @ X2 @ S2 ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_6427_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ real
            @ ^ [X: A] : ( exp @ real @ ( G @ X ) )
            @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( exp @ real @ ( G @ X2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_exp
thf(fact_6428_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ real
            @ ^ [X: A] : ( sin @ real @ ( G @ X ) )
            @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( cos @ real @ ( G @ X2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_sin
thf(fact_6429_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ A
            @ ^ [X: A] : ( sinh @ A @ ( G @ X ) )
            @ ( times_times @ A @ ( times_times @ A @ ( cosh @ A @ ( G @ X2 ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_sinh
thf(fact_6430_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ A
            @ ^ [X: A] : ( cosh @ A @ ( G @ X ) )
            @ ( times_times @ A @ ( times_times @ A @ ( sinh @ A @ ( G @ X2 ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_cosh
thf(fact_6431_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,F6: C > A,X2: C,S: set @ C,G: C > A,G5: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X2 @ S ) )
         => ( ( has_derivative @ C @ A @ G @ G5 @ ( topolo174197925503356063within @ C @ X2 @ S ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X: C] : ( divide_divide @ A @ ( F2 @ X ) @ ( G @ X ) )
                @ ^ [H: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F6 @ H ) @ ( G @ X2 ) ) @ ( times_times @ A @ ( F2 @ X2 ) @ ( G5 @ H ) ) ) @ ( times_times @ A @ ( G @ X2 ) @ ( G @ X2 ) ) )
                @ ( topolo174197925503356063within @ C @ X2 @ S ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_6432_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,S: set @ A] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X2 ) @ H ) @ ( inverse_inverse @ A @ X2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_inverse'
thf(fact_6433_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,X2: C,F6: C > A,S: set @ C] :
          ( ( ( F2 @ X2 )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X2 @ S ) )
           => ( has_derivative @ C @ A
              @ ^ [X: C] : ( inverse_inverse @ A @ ( F2 @ X ) )
              @ ^ [H: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X2 ) ) @ ( F6 @ H ) ) @ ( inverse_inverse @ A @ ( F2 @ X2 ) ) ) )
              @ ( topolo174197925503356063within @ C @ X2 @ S ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_6434_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > real,F6: real,G: A > real,X2: A,G5: A > real,S2: set @ A] :
          ( ( has_field_derivative @ real @ F2 @ F6 @ ( topolo174197925503356063within @ real @ ( G @ X2 ) @ ( top_top @ ( set @ real ) ) ) )
         => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X: A] : ( F2 @ ( G @ X ) )
              @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ F6 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_compose_FDERIV
thf(fact_6435_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ real
            @ ^ [X: A] : ( cos @ real @ ( G @ X ) )
            @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( uminus_uminus @ real @ ( sin @ real @ ( G @ X2 ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_cos
thf(fact_6436_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A,S: set @ A,N2: nat] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( has_derivative @ A @ B
            @ ^ [X: A] : ( power_power @ B @ ( F2 @ X ) @ N2 )
            @ ^ [Y: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N2 ) @ ( F6 @ Y ) ) @ ( power_power @ B @ ( F2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_power
thf(fact_6437_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G5: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
         => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X: A] : ( ln_ln @ real @ ( G @ X ) )
              @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( inverse_inverse @ real @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_ln
thf(fact_6438_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,F6: C > A,X2: C,S: set @ C,G: C > A,G5: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X2 @ S ) )
         => ( ( has_derivative @ C @ A @ G @ G5 @ ( topolo174197925503356063within @ C @ X2 @ S ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X: C] : ( divide_divide @ A @ ( F2 @ X ) @ ( G @ X ) )
                @ ^ [H: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F2 @ X2 ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G @ X2 ) ) @ ( G5 @ H ) ) @ ( inverse_inverse @ A @ ( G @ X2 ) ) ) ) @ ( divide_divide @ A @ ( F6 @ H ) @ ( G @ X2 ) ) )
                @ ( topolo174197925503356063within @ C @ X2 @ S ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_6439_has__derivative__prod,axiom,
    ! [B: $tType,I6: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [I5: set @ I6,F2: I6 > A > B,F6: I6 > A > B,X2: A,S: set @ A] :
          ( ! [I4: I6] :
              ( ( member @ I6 @ I4 @ I5 )
             => ( has_derivative @ A @ B @ ( F2 @ I4 ) @ ( F6 @ I4 ) @ ( topolo174197925503356063within @ A @ X2 @ S ) ) )
         => ( has_derivative @ A @ B
            @ ^ [X: A] :
                ( groups7121269368397514597t_prod @ I6 @ B
                @ ^ [I3: I6] : ( F2 @ I3 @ X )
                @ I5 )
            @ ^ [Y: A] :
                ( groups7311177749621191930dd_sum @ I6 @ B
                @ ^ [I3: I6] :
                    ( times_times @ B @ ( F6 @ I3 @ Y )
                    @ ( groups7121269368397514597t_prod @ I6 @ B
                      @ ^ [J2: I6] : ( F2 @ J2 @ X2 )
                      @ ( minus_minus @ ( set @ I6 ) @ I5 @ ( insert @ I6 @ I3 @ ( bot_bot @ ( set @ I6 ) ) ) ) ) )
                @ I5 )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_prod
thf(fact_6440_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X2: A,X6: set @ A,F2: A > real,F6: A > real] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ X6 ) )
         => ( ( has_derivative @ A @ real @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ X6 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
             => ( ( member @ A @ X2 @ X6 )
               => ( has_derivative @ A @ real
                  @ ^ [X: A] : ( powr @ real @ ( G @ X ) @ ( F2 @ X ) )
                  @ ^ [H: A] : ( times_times @ real @ ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F6 @ H ) @ ( ln_ln @ real @ ( G @ X2 ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G5 @ H ) @ ( F2 @ X2 ) ) @ ( G @ X2 ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X2 @ X6 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_6441_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G5: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
         => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X: A] : ( sqrt @ ( G @ X ) )
              @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_6442_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ real
            @ ^ [X: A] : ( arctan @ ( G @ X ) )
            @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_arctan
thf(fact_6443_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G5: A > real,S2: set @ A] :
          ( ( ( cos @ real @ ( G @ X2 ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X: A] : ( tan @ real @ ( G @ X ) )
              @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_tan
thf(fact_6444_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G: A > real,X2: A,F2: real > Aa,G5: A > real,S2: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G @ X2 ) @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ Aa @ ( F2 @ ( G @ X2 ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
             => ( has_derivative @ A @ real
                @ ^ [X: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F2 @ ( G @ X ) ) ) )
                @ ^ [X: A] : ( times_times @ real @ ( G5 @ X ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_6445_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( filterlim @ A @ A
              @ ^ [H: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X2 @ H ) @ N ) @ ( power_power @ A @ X2 @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ X2 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_6446_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L2: A,F3: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X: B] : ( times_times @ A @ ( F2 @ X ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L2 @ C2 ) )
              @ F3 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_6447_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L2: A,F3: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X: B] : ( times_times @ A @ C2 @ ( F2 @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L2 ) )
              @ F3 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_6448_power__tendsto__0__iff,axiom,
    ! [A: $tType,N2: nat,F2: A > real,F3: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ A @ real
          @ ^ [X: A] : ( power_power @ real @ ( F2 @ X ) @ N2 )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F3 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ) ).

% power_tendsto_0_iff
thf(fact_6449_Lim__cong__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,X2: B,Y2: B,S: set @ A,T5: set @ A,F2: A > B,G: A > B] :
          ( ( A2 = B2 )
         => ( ( X2 = Y2 )
           => ( ( S = T5 )
             => ( ! [X3: A] :
                    ( ( X3 != B2 )
                   => ( ( member @ A @ X3 @ T5 )
                     => ( ( F2 @ X3 )
                        = ( G @ X3 ) ) ) )
               => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ X2 ) @ ( topolo174197925503356063within @ A @ A2 @ S ) )
                  = ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ Y2 ) @ ( topolo174197925503356063within @ A @ B2 @ T5 ) ) ) ) ) ) ) ) ).

% Lim_cong_within
thf(fact_6450_Lim__transform__away__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t1_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,S: set @ A,F2: A > B,G: A > B,L2: B] :
          ( ( A2 != B2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( ( X3 != A2 )
                    & ( X3 != B2 ) )
                 => ( ( F2 @ X3 )
                    = ( G @ X3 ) ) ) )
           => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ S ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ S ) ) ) ) ) ) ).

% Lim_transform_away_within
thf(fact_6451_DERIV__continuous,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S2 ) @ F2 ) ) ) ).

% DERIV_continuous
thf(fact_6452_has__derivative__continuous,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ S2 ) @ F2 ) ) ) ).

% has_derivative_continuous
thf(fact_6453_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
          = ( filterlim @ A @ A
            @ ^ [Y: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y ) @ ( F2 @ X2 ) ) @ ( minus_minus @ A @ Y @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D6 )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_field_derivative_iff
thf(fact_6454_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( filterlim @ A @ A
            @ ^ [Y: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y ) @ ( F2 @ X2 ) ) @ ( minus_minus @ A @ Y @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D6 )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_field_derivativeD
thf(fact_6455_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,L6: B] :
          ( ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_6456_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L6: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_6457_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_6458_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X2: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ X2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_6459_LIM__not__zero,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topolo8386298272705272623_space @ A )
        & ( zero @ Aa )
        & ( topological_t2_space @ Aa ) )
     => ! [K: Aa,A2: A] :
          ( ( K
           != ( zero_zero @ Aa ) )
         => ~ ( filterlim @ A @ Aa
              @ ^ [X: A] : K
              @ ( topolo7230453075368039082e_nhds @ Aa @ ( zero_zero @ Aa ) )
              @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_not_zero
thf(fact_6460_isCont__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) ) ) ) ).

% isCont_norm
thf(fact_6461_isCont__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [A2: C,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
         => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
            @ ^ [X: C] : ( real_Vector_of_real @ A @ ( G @ X ) ) ) ) ) ).

% isCont_of_real
thf(fact_6462_isCont__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [A2: D,F2: D > real,G: D > C] :
          ( ( topolo3448309680560233919inuous @ D @ real @ ( topolo174197925503356063within @ D @ A2 @ ( top_top @ ( set @ D ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ C @ ( topolo174197925503356063within @ D @ A2 @ ( top_top @ ( set @ D ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ D @ C @ ( topolo174197925503356063within @ D @ A2 @ ( top_top @ ( set @ D ) ) )
              @ ^ [X: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% isCont_scaleR
thf(fact_6463_Lim__transform__away__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t1_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B,G: A > B,L2: B] :
          ( ( A2 != B2 )
         => ( ! [X3: A] :
                ( ( ( X3 != A2 )
                  & ( X3 != B2 ) )
               => ( ( F2 @ X3 )
                  = ( G @ X3 ) ) )
           => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% Lim_transform_away_at
thf(fact_6464_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L6: B,A2: A,K: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [X: A] : ( F2 @ ( plus_plus @ A @ X @ K ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L6 )
            @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ K ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset
thf(fact_6465_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G: B > C,L2: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ L2 ) @ ( topolo174197925503356063within @ B @ ( F2 @ A2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D4: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ D4 ) )
                     => ( ( F2 @ X3 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X: A] : ( G @ ( F2 @ X ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_6466_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L2: B,A2: A,G: A > C,M: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( minus_minus @ C @ ( G @ X3 ) @ M ) ) @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L2 ) ) ) )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ M ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_imp_LIM
thf(fact_6467_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > real,A2: A,G: A > real] :
          ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) )
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => ( ord_less_eq @ real @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
             => ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_6468_tendsto__null__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I5: set @ B,F2: A > B > C,F3: filter @ A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ I5 )
             => ( filterlim @ A @ C
                @ ^ [X: A] : ( F2 @ X @ I4 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F3 ) )
         => ( filterlim @ A @ C
            @ ^ [I3: A] : ( groups7311177749621191930dd_sum @ B @ C @ ( F2 @ I3 ) @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
            @ F3 ) ) ) ).

% tendsto_null_sum
thf(fact_6469_tendsto__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I5: set @ A,F2: A > B > C,A2: A > C,F3: filter @ B] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I5 )
             => ( filterlim @ B @ C @ ( F2 @ I4 ) @ ( topolo7230453075368039082e_nhds @ C @ ( A2 @ I4 ) ) @ F3 ) )
         => ( filterlim @ B @ C
            @ ^ [X: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( groups7311177749621191930dd_sum @ A @ C @ A2 @ I5 ) )
            @ F3 ) ) ) ).

% tendsto_sum
thf(fact_6470_continuous__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( topolo5987344860129210374id_add @ C ) )
     => ! [I5: set @ A,F3: filter @ B,F2: A > B > C] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I5 )
             => ( topolo3448309680560233919inuous @ B @ C @ F3 @ ( F2 @ I4 ) ) )
         => ( topolo3448309680560233919inuous @ B @ C @ F3
            @ ^ [X: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ I5 ) ) ) ) ).

% continuous_sum
thf(fact_6471_tendsto__artanh,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( artanh @ real @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F3 ) ) ) ) ).

% tendsto_artanh
thf(fact_6472_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F2: A > B,F3: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( filterlim @ A @ B
              @ ^ [X: A] : ( power_power @ B @ ( F2 @ X ) @ N2 )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F3 ) ) ) ) ).

% tendsto_null_power
thf(fact_6473_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: C > B,A2: B,F3: filter @ C,G: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F3 )
         => ( ( filterlim @ C @ nat @ G @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F3 )
           => ( filterlim @ C @ B
              @ ^ [X: C] : ( power_power @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ B2 ) )
              @ F3 ) ) ) ) ).

% tendsto_power_strong
thf(fact_6474_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F3: filter @ C,F2: C > B,G: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F3 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F3
              @ ^ [X: C] : ( power_power @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_power'
thf(fact_6475_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F3: filter @ A,F2: A > B,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F3
            @ ^ [X: A] : ( power_power @ B @ ( F2 @ X ) @ N2 ) ) ) ) ).

% continuous_power
thf(fact_6476_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,A2: B,F3: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F3 )
         => ( filterlim @ A @ B
            @ ^ [X: A] : ( power_power @ B @ ( F2 @ X ) @ N2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ N2 ) )
            @ F3 ) ) ) ).

% tendsto_power
thf(fact_6477_tendsto__arcosh,axiom,
    ! [B: $tType,F2: B > real,A2: real,F3: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X: B] : ( arcosh @ real @ ( F2 @ X ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F3 ) ) ) ).

% tendsto_arcosh
thf(fact_6478_tendsto__uminus__nhds,axiom,
    ! [A: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [A2: A] : ( filterlim @ A @ A @ ( uminus_uminus @ A ) @ ( topolo7230453075368039082e_nhds @ A @ ( uminus_uminus @ A @ A2 ) ) @ ( topolo7230453075368039082e_nhds @ A @ A2 ) ) ) ).

% tendsto_uminus_nhds
thf(fact_6479_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F2: D > B,F3: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
           => ( filterlim @ D @ B
              @ ^ [X: D] : ( plus_plus @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F3 ) ) ) ) ).

% tendsto_add_zero
thf(fact_6480_tendsto__powr,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( A2
           != ( zero_zero @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( powr @ real @ ( F2 @ X ) @ ( G @ X ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F3 ) ) ) ) ).

% tendsto_powr
thf(fact_6481_tendsto__ln,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( A2
         != ( zero_zero @ real ) )
       => ( filterlim @ A @ real
          @ ^ [X: A] : ( ln_ln @ real @ ( F2 @ X ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( ln_ln @ real @ A2 ) )
          @ F3 ) ) ) ).

% tendsto_ln
thf(fact_6482_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F3 ) ) ) ).

% tendsto_norm_zero
thf(fact_6483_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F3 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 ) ) ) ).

% tendsto_norm_zero_iff
thf(fact_6484_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F3 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 ) ) ) ).

% tendsto_norm_zero_cancel
thf(fact_6485_tendsto__sgn,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,L2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 )
         => ( ( L2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X: B] : ( sgn_sgn @ A @ ( F2 @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( sgn_sgn @ A @ L2 ) )
              @ F3 ) ) ) ) ).

% tendsto_sgn
thf(fact_6486_tendsto__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X: B] : ( inverse_inverse @ A @ ( F2 @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( inverse_inverse @ A @ A2 ) )
              @ F3 ) ) ) ) ).

% tendsto_inverse
thf(fact_6487_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F3: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( ( cos @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X: A] : ( tan @ A @ ( F2 @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tan @ A @ A2 ) )
              @ F3 ) ) ) ) ).

% tendsto_tan
thf(fact_6488_tendsto__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,A2: A,F3: filter @ C] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( ( cosh @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ C @ A
              @ ^ [X: C] : ( tanh @ A @ ( F2 @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tanh @ A @ A2 ) )
              @ F3 ) ) ) ) ).

% tendsto_tanh
thf(fact_6489_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F3: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( ( sin @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X: A] : ( cot @ A @ ( F2 @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( cot @ A @ A2 ) )
              @ F3 ) ) ) ) ).

% tendsto_cot
thf(fact_6490_tendsto__minus__cancel__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1633459387980952147up_add @ B )
     => ! [F2: A > B,Y2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( uminus_uminus @ B @ Y2 ) ) @ F3 )
          = ( filterlim @ A @ B
            @ ^ [X: A] : ( uminus_uminus @ B @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ B @ Y2 )
            @ F3 ) ) ) ).

% tendsto_minus_cancel_left
thf(fact_6491_tendsto__minus__cancel,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X: B] : ( uminus_uminus @ A @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( uminus_uminus @ A @ A2 ) )
            @ F3 )
         => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 ) ) ) ).

% tendsto_minus_cancel
thf(fact_6492_continuous__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [F3: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F3
            @ ^ [X: A] : ( uminus_uminus @ B @ ( F2 @ X ) ) ) ) ) ).

% continuous_minus
thf(fact_6493_tendsto__minus,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( filterlim @ B @ A
            @ ^ [X: B] : ( uminus_uminus @ A @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( uminus_uminus @ A @ A2 ) )
            @ F3 ) ) ) ).

% tendsto_minus
thf(fact_6494_tendsto__one__prod_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4987421752381908075d_mult @ C )
     => ! [I5: set @ B,F2: A > B > C,F3: filter @ A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ I5 )
             => ( filterlim @ A @ C
                @ ^ [X: A] : ( F2 @ X @ I4 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
                @ F3 ) )
         => ( filterlim @ A @ C
            @ ^ [I3: A] : ( groups7121269368397514597t_prod @ B @ C @ ( F2 @ I3 ) @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
            @ F3 ) ) ) ).

% tendsto_one_prod'
thf(fact_6495_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [C2: A,F2: B > A,D3: A,F3: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X: B] : ( plus_plus @ A @ C2 @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ C2 @ D3 ) )
            @ F3 )
          = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ D3 ) @ F3 ) ) ) ).

% tendsto_add_const_iff
thf(fact_6496_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [F3: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F3 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F3
              @ ^ [X: D] : ( plus_plus @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_add
thf(fact_6497_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F3 )
           => ( filterlim @ B @ A
              @ ^ [X: B] : ( plus_plus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
              @ F3 ) ) ) ) ).

% tendsto_add
thf(fact_6498_tendsto__rabs,axiom,
    ! [A: $tType,F2: A > real,L2: real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ F3 )
     => ( filterlim @ A @ real
        @ ^ [X: A] : ( abs_abs @ real @ ( F2 @ X ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( abs_abs @ real @ L2 ) )
        @ F3 ) ) ).

% tendsto_rabs
thf(fact_6499_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X: A] : ( abs_abs @ real @ ( F2 @ X ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F3 )
     => ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ).

% tendsto_rabs_zero_cancel
thf(fact_6500_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X: A] : ( abs_abs @ real @ ( F2 @ X ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F3 )
      = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ).

% tendsto_rabs_zero_iff
thf(fact_6501_tendsto__rabs__zero,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
     => ( filterlim @ A @ real
        @ ^ [X: A] : ( abs_abs @ real @ ( F2 @ X ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F3 ) ) ).

% tendsto_rabs_zero
thf(fact_6502_tendsto__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( real_V4412858255891104859lgebra @ C )
        & ( comm_ring_1 @ C ) )
     => ! [S: set @ A,F2: A > B > C,L6: A > C,F3: filter @ B] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ S )
             => ( filterlim @ B @ C @ ( F2 @ I4 ) @ ( topolo7230453075368039082e_nhds @ C @ ( L6 @ I4 ) ) @ F3 ) )
         => ( filterlim @ B @ C
            @ ^ [X: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ S )
            @ ( topolo7230453075368039082e_nhds @ C @ ( groups7121269368397514597t_prod @ A @ C @ L6 @ S ) )
            @ F3 ) ) ) ).

% tendsto_prod
thf(fact_6503_tendsto__prod_H,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo4987421752381908075d_mult @ C )
     => ! [I5: set @ A,F2: A > B > C,A2: A > C,F3: filter @ B] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I5 )
             => ( filterlim @ B @ C @ ( F2 @ I4 ) @ ( topolo7230453075368039082e_nhds @ C @ ( A2 @ I4 ) ) @ F3 ) )
         => ( filterlim @ B @ C
            @ ^ [X: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( groups7121269368397514597t_prod @ A @ C @ A2 @ I5 ) )
            @ F3 ) ) ) ).

% tendsto_prod'
thf(fact_6504_continuous__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ C )
        & ( comm_ring_1 @ C ) )
     => ! [S: set @ A,F3: filter @ B,F2: A > B > C] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ S )
             => ( topolo3448309680560233919inuous @ B @ C @ F3 @ ( F2 @ I4 ) ) )
         => ( topolo3448309680560233919inuous @ B @ C @ F3
            @ ^ [X: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ S ) ) ) ) ).

% continuous_prod
thf(fact_6505_continuous__prod_H,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( topolo4987421752381908075d_mult @ C ) )
     => ! [I5: set @ A,F3: filter @ B,F2: A > B > C] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I5 )
             => ( topolo3448309680560233919inuous @ B @ C @ F3 @ ( F2 @ I4 ) ) )
         => ( topolo3448309680560233919inuous @ B @ C @ F3
            @ ^ [X: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ I5 ) ) ) ) ).

% continuous_prod'
thf(fact_6506_tendsto__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,A2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( real_V7770717601297561774m_norm @ B @ A2 ) )
            @ F3 ) ) ) ).

% tendsto_norm
thf(fact_6507_continuous__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F3
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) ) ) ) ).

% continuous_norm
thf(fact_6508_tendsto__real__sqrt,axiom,
    ! [A: $tType,F2: A > real,X2: real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X2 ) @ F3 )
     => ( filterlim @ A @ real
        @ ^ [X: A] : ( sqrt @ ( F2 @ X ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( sqrt @ X2 ) )
        @ F3 ) ) ).

% tendsto_real_sqrt
thf(fact_6509_tendsto__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [G: C > real,A2: real,F3: filter @ C] :
          ( ( filterlim @ C @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
         => ( filterlim @ C @ A
            @ ^ [X: C] : ( real_Vector_of_real @ A @ ( G @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( real_Vector_of_real @ A @ A2 ) )
            @ F3 ) ) ) ).

% tendsto_of_real
thf(fact_6510_continuous__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: filter @ C,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ F3 @ G )
         => ( topolo3448309680560233919inuous @ C @ A @ F3
            @ ^ [X: C] : ( real_Vector_of_real @ A @ ( G @ X ) ) ) ) ) ).

% continuous_of_real
thf(fact_6511_tendsto__of__real__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > real,C2: real,F3: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X: B] : ( real_Vector_of_real @ A @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( real_Vector_of_real @ A @ C2 ) )
            @ F3 )
          = ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 ) ) ) ).

% tendsto_of_real_iff
thf(fact_6512_tendsto__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( real_V822414075346904944vector @ C )
     => ! [F2: D > real,A2: real,F3: filter @ D,G: D > C,B2: C] :
          ( ( filterlim @ D @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
         => ( ( filterlim @ D @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ B2 ) @ F3 )
           => ( filterlim @ D @ C
              @ ^ [X: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ C @ ( real_V8093663219630862766scaleR @ C @ A2 @ B2 ) )
              @ F3 ) ) ) ) ).

% tendsto_scaleR
thf(fact_6513_continuous__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F3: filter @ D,F2: D > real,G: D > C] :
          ( ( topolo3448309680560233919inuous @ D @ real @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ C @ F3 @ G )
           => ( topolo3448309680560233919inuous @ D @ C @ F3
              @ ^ [X: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_scaleR
thf(fact_6514_tendsto__real__root,axiom,
    ! [A: $tType,F2: A > real,X2: real,F3: filter @ A,N2: nat] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X2 ) @ F3 )
     => ( filterlim @ A @ real
        @ ^ [X: A] : ( root @ N2 @ ( F2 @ X ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( root @ N2 @ X2 ) )
        @ F3 ) ) ).

% tendsto_real_root
thf(fact_6515_tendsto__of__int__ceiling,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( ring_1 @ C )
        & ( topolo4958980785337419405_space @ C )
        & ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( filterlim @ A @ C
              @ ^ [X: A] : ( ring_1_of_int @ C @ ( archimedean_ceiling @ B @ ( F2 @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ C @ ( ring_1_of_int @ C @ ( archimedean_ceiling @ B @ L2 ) ) )
              @ F3 ) ) ) ) ).

% tendsto_of_int_ceiling
thf(fact_6516_tendsto__of__int__floor,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( ring_1 @ C )
        & ( topolo4958980785337419405_space @ C )
        & ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( filterlim @ A @ C
              @ ^ [X: A] : ( ring_1_of_int @ C @ ( archim6421214686448440834_floor @ B @ ( F2 @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ C @ ( ring_1_of_int @ C @ ( archim6421214686448440834_floor @ B @ L2 ) ) )
              @ F3 ) ) ) ) ).

% tendsto_of_int_floor
thf(fact_6517_tendsto__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F3 )
           => ( filterlim @ B @ A
              @ ^ [X: B] : ( minus_minus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( minus_minus @ A @ A2 @ B2 ) )
              @ F3 ) ) ) ) ).

% tendsto_diff
thf(fact_6518_continuous__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [F3: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ F3
              @ ^ [X: A] : ( minus_minus @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_diff
thf(fact_6519_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F3: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F3
            @ ^ [X: B] : ( times_times @ A @ ( F2 @ X ) @ C2 ) ) ) ) ).

% continuous_mult_right
thf(fact_6520_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F3: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F3
            @ ^ [X: B] : ( times_times @ A @ C2 @ ( F2 @ X ) ) ) ) ) ).

% continuous_mult_left
thf(fact_6521_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L2: A,F3: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 )
         => ( filterlim @ B @ A
            @ ^ [X: B] : ( times_times @ A @ ( F2 @ X ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L2 @ C2 ) )
            @ F3 ) ) ) ).

% tendsto_mult_right
thf(fact_6522_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L2: A,F3: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 )
         => ( filterlim @ B @ A
            @ ^ [X: B] : ( times_times @ A @ C2 @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L2 ) )
            @ F3 ) ) ) ).

% tendsto_mult_left
thf(fact_6523_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [F3: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F3 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F3
              @ ^ [X: D] : ( times_times @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_mult'
thf(fact_6524_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F3: filter @ D,F2: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F3 @ G )
           => ( topolo3448309680560233919inuous @ D @ A @ F3
              @ ^ [X: D] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_mult
thf(fact_6525_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F3 )
           => ( filterlim @ B @ A
              @ ^ [X: B] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
              @ F3 ) ) ) ) ).

% tendsto_mult
thf(fact_6526_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: D > B,F3: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F3 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F3 )
           => ( filterlim @ D @ B
              @ ^ [X: D] : ( times_times @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) )
              @ F3 ) ) ) ) ).

% tendsto_mult_one
thf(fact_6527_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,F3: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
         => ( filterlim @ B @ A
            @ ^ [X: B] : ( divide_divide @ A @ ( F2 @ X ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F3 ) ) ) ).

% tendsto_divide_zero
thf(fact_6528_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F3 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X: B] : ( divide_divide @ A @ ( F2 @ X ) @ ( G @ X ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F3 ) ) ) ) ) ).

% tendsto_divide
thf(fact_6529_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,G: B > A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A
            @ ^ [X: B] : ( minus_minus @ A @ ( F2 @ X ) @ ( G @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F3 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
            = ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 ) ) ) ) ).

% Lim_transform_eq
thf(fact_6530_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X: A] : ( minus_minus @ B @ ( F2 @ X ) @ L2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F3 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 ) ) ) ).

% LIM_zero_cancel
thf(fact_6531_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A
              @ ^ [X: B] : ( minus_minus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 )
           => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 ) ) ) ) ).

% Lim_transform2
thf(fact_6532_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: B > A,A2: A,F3: filter @ B,F2: B > A] :
          ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A
              @ ^ [X: B] : ( minus_minus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 ) ) ) ) ).

% Lim_transform
thf(fact_6533_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X: A] : ( minus_minus @ B @ ( F2 @ X ) @ L2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F3 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 ) ) ) ).

% LIM_zero_iff
thf(fact_6534_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 )
         => ( filterlim @ A @ B
            @ ^ [X: A] : ( minus_minus @ B @ ( F2 @ X ) @ L2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F3 ) ) ) ).

% LIM_zero
thf(fact_6535_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F3: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
         => ( filterlim @ D @ A
            @ ^ [X: D] : ( times_times @ A @ C2 @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F3 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_6536_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F3: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
         => ( filterlim @ D @ A
            @ ^ [X: D] : ( times_times @ A @ ( F2 @ X ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F3 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_6537_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F3: filter @ D,G: D > A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
         => ( ( filterlim @ D @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
           => ( filterlim @ D @ A
              @ ^ [X: D] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_6538_tendsto__log,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X: A] : ( log @ ( F2 @ X ) @ ( G @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A2 @ B2 ) )
                @ F3 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_6539_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F2: A > D,L6: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L6 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_6540_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y2: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT2
thf(fact_6541_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y2: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT
thf(fact_6542_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R3: real,A2: A,F2: A > B,G: A > B,L2: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ R3 )
                 => ( ( F2 @ X3 )
                    = ( G @ X3 ) ) ) )
           => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_6543_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L6: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X: A] :
                        ( ( ( X != A2 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ A2 ) ) @ S6 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X ) @ L6 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_6544_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B,L6: B] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [S7: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ S7 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L6 ) ) @ R2 ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_6545_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L6: B,A2: A,R: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X4: A] :
                    ( ( ( X4 != A2 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X4 @ A2 ) ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X4 ) @ L6 ) ) @ R ) ) ) ) ) ) ).

% LIM_D
thf(fact_6546_DERIV__isCont,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F2 ) ) ) ).

% DERIV_isCont
thf(fact_6547_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > A,A2: A,D6: A] :
          ( ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ A2 @ H ) ) @ ( F2 @ A2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ X ) @ ( F2 @ A2 ) ) @ ( minus_minus @ A @ X @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D6 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_6548_isCont__Lb__Ub,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X3 )
              & ( ord_less_eq @ real @ X3 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ? [L7: real,M9: real] :
            ( ! [X4: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X4 )
                  & ( ord_less_eq @ real @ X4 @ B2 ) )
               => ( ( ord_less_eq @ real @ L7 @ ( F2 @ X4 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X4 ) @ M9 ) ) )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ L7 @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ M9 ) )
               => ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y4 ) ) ) ) ) ) ).

% isCont_Lb_Ub
thf(fact_6549_LIM__fun__less__zero,axiom,
    ! [F2: real > real,L2: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ! [X4: real] :
                ( ( ( X4 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X4 ) ) @ R2 ) )
               => ( ord_less @ real @ ( F2 @ X4 ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_6550_LIM__fun__not__zero,axiom,
    ! [F2: real > real,L2: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L2
         != ( zero_zero @ real ) )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ! [X4: real] :
                ( ( ( X4 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X4 ) ) @ R2 ) )
               => ( ( F2 @ X4 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_6551_LIM__fun__gt__zero,axiom,
    ! [F2: real > real,L2: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ! [X4: real] :
                ( ( ( X4 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X4 ) ) @ R2 ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X4 ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_6552_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D4: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ D4 ) )
                     => ( ( F2 @ X3 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X: A] : ( G @ ( F2 @ X ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_6553_isCont__real__sqrt,axiom,
    ! [X2: real] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ sqrt ) ).

% isCont_real_sqrt
thf(fact_6554_isCont__real__root,axiom,
    ! [X2: real,N2: nat] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( root @ N2 ) ) ).

% isCont_real_root
thf(fact_6555_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
                @ ^ [X: A] : ( divide_divide @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_6556_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X: A] : ( times_times @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% isCont_mult
thf(fact_6557_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X: A] : ( plus_plus @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% isCont_add
thf(fact_6558_isCont__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X: A] : ( minus_minus @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% isCont_diff
thf(fact_6559_isCont__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X: A] : ( uminus_uminus @ B @ ( F2 @ X ) ) ) ) ) ).

% isCont_minus
thf(fact_6560_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X: A] : ( power_power @ B @ ( F2 @ X ) @ N2 ) ) ) ) ).

% isCont_power
thf(fact_6561_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
              @ ^ [X: A] : ( inverse_inverse @ B @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_at_within_inverse
thf(fact_6562_isCont__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( topolo5987344860129210374id_add @ C ) )
     => ! [A3: set @ A,A2: B,F2: A > B > C] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( topolo3448309680560233919inuous @ B @ C @ ( topolo174197925503356063within @ B @ A2 @ ( top_top @ ( set @ B ) ) ) @ ( F2 @ X3 ) ) )
         => ( topolo3448309680560233919inuous @ B @ C @ ( topolo174197925503356063within @ B @ A2 @ ( top_top @ ( set @ B ) ) )
            @ ^ [X: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ A3 ) ) ) ) ).

% isCont_sum
thf(fact_6563_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
              @ ^ [X: A] : ( sgn_sgn @ B @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_at_within_sgn
thf(fact_6564_continuous__frac,axiom,
    ! [X2: real] :
      ( ~ ( member @ real @ X2 @ ( ring_1_Ints @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( archimedean_frac @ real ) ) ) ).

% continuous_frac
thf(fact_6565_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X2 @ H ) ) @ ( F2 @ X2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_6566_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A] :
          ( ( has_field_derivative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X2 @ H ) ) @ ( F2 @ X2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_6567_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z5 ) @ ( one_one @ A ) ) @ Z5 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_6568_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F2: A > B,K5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ H4 ) ) @ ( times_times @ real @ K5 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_6569_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M9: A] :
              ! [X4: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X4 )
                  & ( ord_less_eq @ real @ X4 @ B2 ) )
               => ( ord_less_eq @ A @ ( F2 @ X4 ) @ M9 ) ) ) ) ) ).

% isCont_bounded
thf(fact_6570_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M9: A] :
                ( ! [X4: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X4 )
                      & ( ord_less_eq @ real @ X4 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X4 ) @ M9 ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M9 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_6571_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M9: A] :
                ( ! [X4: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X4 )
                      & ( ord_less_eq @ real @ X4 @ B2 ) )
                   => ( ord_less_eq @ A @ M9 @ ( F2 @ X4 ) ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M9 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_6572_isCont__inverse__function2,axiom,
    ! [A2: real,X2: real,B2: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ X2 )
     => ( ( ord_less @ real @ X2 @ B2 )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ A2 @ Z3 )
             => ( ( ord_less_eq @ real @ Z3 @ B2 )
               => ( ( G @ ( F2 @ Z3 ) )
                  = Z3 ) ) )
         => ( ! [Z3: real] :
                ( ( ord_less_eq @ real @ A2 @ Z3 )
               => ( ( ord_less_eq @ real @ Z3 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X2 ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_6573_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D6: A,X2: A] :
          ( ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D6 ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X2 @ H ) ) @ ( F2 @ X2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_6574_isCont__ln,axiom,
    ! [X2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( ln_ln @ real ) ) ) ).

% isCont_ln
thf(fact_6575_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X: A] : ( divide_divide @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_6576_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X: A] : ( sgn_sgn @ B @ ( F2 @ X ) ) ) ) ) ) ).

% isCont_sgn
thf(fact_6577_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F3: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ F3 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X: A] : ( F2 @ ( plus_plus @ A @ X @ A2 ) )
            @ F3
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_6578_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,S2: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S2 ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ X2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S2 )
              @ ^ [X: A] : ( tan @ A @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_within_tan
thf(fact_6579_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,S2: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S2 ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ X2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S2 )
              @ ^ [X: A] : ( cot @ A @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_within_cot
thf(fact_6580_continuous__at__within__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: C,A3: set @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X2 @ A3 ) @ F2 )
         => ( ( ( cosh @ A @ ( F2 @ X2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X2 @ A3 )
              @ ^ [X: C] : ( tanh @ A @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_at_within_tanh
thf(fact_6581_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L2: A,X2: A] :
          ( ( has_field_derivative @ A @ F2 @ L2 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ? [G2: A > A] :
                ( ! [Z5: A] :
                    ( ( minus_minus @ A @ ( F2 @ Z5 ) @ ( F2 @ X2 ) )
                    = ( times_times @ A @ ( G2 @ Z5 ) @ ( minus_minus @ A @ Z5 @ X2 ) ) )
                & ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ G2 )
                & ( ( G2 @ X2 )
                  = L2 ) ) ) ) ) ).

% CARAT_DERIV
thf(fact_6582_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M9: A] :
                ( ! [X4: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X4 )
                      & ( ord_less_eq @ real @ X4 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X4 ) @ M9 ) )
                & ! [N8: A] :
                    ( ( ord_less @ A @ N8 @ M9 )
                   => ? [X3: real] :
                        ( ( ord_less_eq @ real @ A2 @ X3 )
                        & ( ord_less_eq @ real @ X3 @ B2 )
                        & ( ord_less @ A @ N8 @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_6583_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ ( tan @ A ) ) ) ) ).

% isCont_tan
thf(fact_6584_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F3: filter @ B,A2: A,D3: A] :
          ( ( filterlim @ A @ B @ F2 @ F3 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D3 ) ) @ F3 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D3 ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift
thf(fact_6585_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,D3: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D3 ) ) @ F3 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D3 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B @ F2 @ F3 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift_iff
thf(fact_6586_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sin @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ ( cot @ A ) ) ) ) ).

% isCont_cot
thf(fact_6587_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cosh @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ ( tanh @ A ) ) ) ) ).

% isCont_tanh
thf(fact_6588_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
         => ( ! [X3: A] :
                ( ( X3
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S2 )
                 => ( sums @ A
                    @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ X3 @ N ) )
                    @ ( F2 @ X3 ) ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_6589_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S2 )
               => ( sums @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ X3 @ N ) )
                  @ ( F2 @ X3 ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_6590_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F2: nat > real,G: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F2 )
           => ( ! [H4: A,N3: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G @ H4 @ N3 ) ) @ ( times_times @ real @ ( F2 @ N3 ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H: A] : ( suminf @ B @ ( G @ H ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_6591_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X: A] : ( tan @ A @ ( F2 @ X ) ) ) ) ) ) ).

% isCont_tan'
thf(fact_6592_isCont__arcosh,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_6593_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X: real] : ( divide_divide @ real @ ( cos @ real @ X ) @ ( sin @ real @ X ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_6594_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X: A] : ( cot @ A @ ( F2 @ X ) ) ) ) ) ) ).

% isCont_cot'
thf(fact_6595_continuous__floor,axiom,
    ! [X2: real] :
      ( ~ ( member @ real @ X2 @ ( ring_1_Ints @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( comp @ int @ real @ real @ ( ring_1_of_int @ real ) @ ( archim6421214686448440834_floor @ real ) ) ) ) ).

% continuous_floor
thf(fact_6596_DERIV__inverse__function,axiom,
    ! [F2: real > real,D6: real,G: real > real,X2: real,A2: real,B2: real] :
      ( ( has_field_derivative @ real @ F2 @ D6 @ ( topolo174197925503356063within @ real @ ( G @ X2 ) @ ( top_top @ ( set @ real ) ) ) )
     => ( ( D6
         != ( zero_zero @ real ) )
       => ( ( ord_less @ real @ A2 @ X2 )
         => ( ( ord_less @ real @ X2 @ B2 )
           => ( ! [Y3: real] :
                  ( ( ord_less @ real @ A2 @ Y3 )
                 => ( ( ord_less @ real @ Y3 @ B2 )
                   => ( ( F2 @ ( G @ Y3 ) )
                      = Y3 ) ) )
             => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ G )
               => ( has_field_derivative @ real @ G @ ( inverse_inverse @ real @ D6 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_inverse_function
thf(fact_6597_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N2: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W2: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ W2 @ I3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% isCont_polynom
thf(fact_6598_isCont__arccos,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_6599_isCont__arcsin,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_6600_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ! [Y3: A] :
              ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Y3 @ N ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X: A] :
                ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_6601_LIM__less__bound,axiom,
    ! [B2: real,X2: real,F2: real > real] :
      ( ( ord_less @ real @ B2 @ X2 )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) ) ) ) ) ).

% LIM_less_bound
thf(fact_6602_isCont__artanh,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_6603_isCont__inverse__function,axiom,
    ! [D3: real,X2: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
     => ( ! [Z3: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z3 @ X2 ) ) @ D3 )
           => ( ( G @ ( F2 @ Z3 ) )
              = Z3 ) )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z3 @ X2 ) ) @ D3 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X2 ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ).

% isCont_inverse_function
thf(fact_6604_GMVT_H,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real,G5: real > real,F6: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z3: real] :
            ( ( ord_less_eq @ real @ A2 @ Z3 )
           => ( ( ord_less_eq @ real @ Z3 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ A2 @ Z3 )
             => ( ( ord_less_eq @ real @ Z3 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ G ) ) )
         => ( ! [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
               => ( ( ord_less @ real @ Z3 @ B2 )
                 => ( has_field_derivative @ real @ G @ ( G5 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z3: real] :
                  ( ( ord_less @ real @ A2 @ Z3 )
                 => ( ( ord_less @ real @ Z3 @ B2 )
                   => ( has_field_derivative @ real @ F2 @ ( F6 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C4: real] :
                  ( ( ord_less @ real @ A2 @ C4 )
                  & ( ord_less @ real @ C4 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( G5 @ C4 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ ( F6 @ C4 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_6605_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A ) )
     => ! [X2: real,F2: real > A] :
          ( ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ A @ ( F2 @ X2 ) @ ( ring_1_Ints @ A ) )
           => ( has_field_derivative @ real
              @ ^ [X: real] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ A @ ( F2 @ X ) ) )
              @ ( zero_zero @ real )
              @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% floor_has_real_derivative
thf(fact_6606_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F2: A > Aa,C2: nat > Aa,K5: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( summable @ Aa
              @ ^ [N: nat] : ( times_times @ Aa @ ( C2 @ N ) @ ( power_power @ Aa @ K5 @ N ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K5 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X: A] :
                    ( suminf @ Aa
                    @ ^ [N: nat] : ( times_times @ Aa @ ( C2 @ N ) @ ( power_power @ Aa @ ( F2 @ X ) @ N ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_6607_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_6608_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N7: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_6609_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N7: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_6610_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N: nat] : ( times_times @ A @ C2 @ ( A2 @ N ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_6611_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_6612_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N: nat] : ( divide_divide @ A @ ( A2 @ N ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_6613_continuous__rabs,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F3
            @ ^ [X: A] : ( abs_abs @ real @ ( F2 @ X ) ) ) ) ) ).

% continuous_rabs
thf(fact_6614_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F3
            @ ^ [X: A] : ( sqrt @ ( F2 @ X ) ) ) ) ) ).

% continuous_real_sqrt
thf(fact_6615_continuous__real__root,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F3
            @ ^ [X: A] : ( root @ N2 @ ( F2 @ X ) ) ) ) ) ).

% continuous_real_root
thf(fact_6616_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ? [U3: nat > A] :
              ( ! [N7: nat] : ( ord_less @ A @ ( U3 @ N7 ) @ X2 )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_6617_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ? [U3: nat > A] :
              ( ! [N7: nat] : ( ord_less @ A @ X2 @ ( U3 @ N7 ) )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_6618_LIMSEQ__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_Suc
thf(fact_6619_LIMSEQ__imp__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_imp_Suc
thf(fact_6620_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,A2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_ignore_initial_segment
thf(fact_6621_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,K: nat,A2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_offset
thf(fact_6622_seq__offset__neg,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [I3: nat] : ( F2 @ ( minus_minus @ nat @ I3 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( at_top @ nat ) ) ) ) ).

% seq_offset_neg
thf(fact_6623_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N5: nat,X6: nat > A,Y6: nat > A,X2: A,Y2: A] :
          ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N5 @ N3 )
             => ( ord_less_eq @ A @ ( X6 @ N3 ) @ ( Y6 @ N3 ) ) )
         => ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y6 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ).

% lim_mono
thf(fact_6624_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X6: nat > A,X2: A,Y6: nat > A,Y2: A] :
          ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y6 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ ( at_top @ nat ) )
           => ( ? [N8: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N3 )
                 => ( ord_less_eq @ A @ ( X6 @ N3 ) @ ( Y6 @ N3 ) ) )
             => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_6625_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L2: A,M7: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M7 @ N3 )
               => ( ord_less_eq @ A @ ( F2 @ N3 ) @ C6 ) )
           => ( ord_less_eq @ A @ L2 @ C6 ) ) ) ) ).

% Lim_bounded
thf(fact_6626_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L2: A,N5: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ A @ C6 @ ( F2 @ N3 ) ) )
           => ( ord_less_eq @ A @ C6 @ L2 ) ) ) ) ).

% Lim_bounded2
thf(fact_6627_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X6: nat > A,X2: A,A2: A] :
          ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N3 )
               => ( ord_less_eq @ A @ A2 @ ( X6 @ N3 ) ) )
           => ( ord_less_eq @ A @ A2 @ X2 ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_6628_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X6: nat > A,X2: A,A2: A] :
          ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N3 )
               => ( ord_less_eq @ A @ ( X6 @ N3 ) @ A2 ) )
           => ( ord_less_eq @ A @ X2 @ A2 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_6629_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S2: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S2 )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) ) ) ) ) ).

% Sup_lim
thf(fact_6630_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S2: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S2 )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 ) ) ) ) ).

% Inf_lim
thf(fact_6631_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ_zero
thf(fact_6632_isCont__rabs,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X: A] : ( abs_abs @ real @ ( F2 @ X ) ) ) ) ) ).

% isCont_rabs
thf(fact_6633_continuous__at__within__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,S2: set @ C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S2 ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S2 ) @ G )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S2 )
                @ ^ [X: C] : ( powr @ real @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% continuous_at_within_powr
thf(fact_6634_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X2: A,S2: set @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ S2 ) @ F2 )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ S2 )
              @ ^ [X: A] : ( ln_ln @ real @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_within_ln
thf(fact_6635_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_6636_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X: nat] : ( times_times @ nat @ X @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_6637_monoseq__convergent,axiom,
    ! [X6: nat > real,B4: real] :
      ( ( topological_monoseq @ real @ X6 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( X6 @ I4 ) ) @ B4 )
       => ~ ! [L7: real] :
              ~ ( filterlim @ nat @ real @ X6 @ ( topolo7230453075368039082e_nhds @ real @ L7 ) @ ( at_top @ nat ) ) ) ) ).

% monoseq_convergent
thf(fact_6638_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N: nat] : ( root @ N @ ( semiring_1_of_nat @ real @ N ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_6639_isCont__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
                @ ^ [X: C] : ( powr @ real @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% isCont_powr
thf(fact_6640_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X2: A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X: A] : ( ln_ln @ real @ ( F2 @ X ) ) ) ) ) ) ).

% isCont_ln'
thf(fact_6641_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: nat > A,X2: A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
           => ( ( ! [N7: nat] : ( ord_less_eq @ A @ ( A2 @ N7 ) @ X2 )
                & ! [M2: nat,N7: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N7 )
                   => ( ord_less_eq @ A @ ( A2 @ M2 ) @ ( A2 @ N7 ) ) ) )
              | ( ! [N7: nat] : ( ord_less_eq @ A @ X2 @ ( A2 @ N7 ) )
                & ! [M2: nat,N7: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N7 )
                   => ( ord_less_eq @ A @ ( A2 @ N7 ) @ ( A2 @ M2 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_6642_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_6643_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_inverse_n
thf(fact_6644_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X6: nat > A,X2: A,L2: nat] :
          ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L2 )
           => ( filterlim @ nat @ A
              @ ^ [N: nat] : ( X6 @ ( times_times @ nat @ N @ L2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X2 )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_6645_telescope__summable,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ N ) ) ) ) ) ).

% telescope_summable
thf(fact_6646_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) ) ) ) ) ).

% telescope_summable'
thf(fact_6647_nested__sequence__unique,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( G @ ( suc @ N3 ) ) @ ( G @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N: nat] : ( minus_minus @ real @ ( F2 @ N ) @ ( G @ N ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L3: real] :
                ( ! [N7: nat] : ( ord_less_eq @ real @ ( F2 @ N7 ) @ L3 )
                & ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L3 ) @ ( at_top @ nat ) )
                & ! [N7: nat] : ( ord_less_eq @ real @ L3 @ ( G @ N7 ) )
                & ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ L3 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_6648_LIMSEQ__inverse__zero,axiom,
    ! [X6: nat > real] :
      ( ! [R2: real] :
        ? [N8: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N3 )
         => ( ord_less @ real @ R2 @ ( X6 @ N3 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( inverse_inverse @ real @ ( X6 @ N ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_6649_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_6650_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( root @ N @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_6651_LIMSEQ__inverse__real__of__nat,axiom,
    ( filterlim @ nat @ real
    @ ^ [N: nat] : ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat
thf(fact_6652_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( plus_plus @ real @ R @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add
thf(fact_6653_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S2: set @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S2 )
                    @ ^ [X: A] : ( log @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_6654_increasing__LIMSEQ,axiom,
    ! [F2: nat > real,L2: real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ L2 )
       => ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [N7: nat] : ( ord_less_eq @ real @ L2 @ ( plus_plus @ real @ ( F2 @ N7 ) @ E ) ) )
         => ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_6655_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_6656_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_6657_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_1_of_nat @ A @ N ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_6658_LIMSEQ__realpow__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_6659_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) )
            @ ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_6660_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ N ) )
            @ ( minus_minus @ A @ C2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_6661_LIMSEQ__divide__realpow__zero,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X2 @ N ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_6662_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_6663_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_6664_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X2 @ N ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_6665_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F4: nat > A,S6: A] :
              ( filterlim @ nat @ A
              @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F4 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S6 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def'
thf(fact_6666_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,X2: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N: nat] : ( root @ N @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X2 )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% root_test_convergence
thf(fact_6667_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( plus_plus @ real @ R @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus
thf(fact_6668_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X: A] : ( log @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_6669_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A,L6: A] :
          ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N: nat] :
                    ( ( ord_less_eq @ nat @ No @ N )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X6 @ N ) @ L6 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_6670_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A,L6: A] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X6 @ N3 ) @ L6 ) ) @ R2 ) ) )
         => ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_6671_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A,L6: A,R: real] :
          ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No3: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N7 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X6 @ N7 ) @ L6 ) ) @ R ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_6672_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X2 ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_6673_tendsto__exp__limit__sequentially,axiom,
    ! [X2: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ ( semiring_1_of_nat @ real @ N ) ) ) @ N )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X2 ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_6674_tendsto__at__iff__sequentially,axiom,
    ! [C: $tType,A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > C,A2: C,X2: A,S2: set @ A] :
          ( ( filterlim @ A @ C @ F2 @ ( topolo7230453075368039082e_nhds @ C @ A2 ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
          = ( ! [X8: nat > A] :
                ( ! [I3: nat] : ( member @ A @ ( X8 @ I3 ) @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
               => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
                 => ( filterlim @ nat @ C @ ( comp @ A @ C @ nat @ F2 @ X8 ) @ ( topolo7230453075368039082e_nhds @ C @ A2 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% tendsto_at_iff_sequentially
thf(fact_6675_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: B > nat,F3: filter @ B,X2: A] :
          ( ( filterlim @ B @ nat @ F2 @ ( at_top @ nat ) @ F3 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y: B] : ( power_power @ A @ X2 @ ( F2 @ Y ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 ) ) ) ) ).

% tendsto_power_zero
thf(fact_6676_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( times_times @ real @ R @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_6677_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_6678_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( A2 @ N ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_6679_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Df: A,Z: A,S2: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F2 @ Df @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N3: nat] :
                  ( ( S2 @ N3 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ Z @ ( S2 @ N ) ) ) @ ( F2 @ Z ) ) @ ( S2 @ N ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_6680_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ X2 @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_6681_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ X2 @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_6682_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( summable @ real
            @ ^ [N: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( A2 @ N ) ) ) ) ) ) ).

% summable
thf(fact_6683_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J2: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J2 ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K2: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J2: nat] : ( minus_minus @ real @ ( Theta @ J2 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_6684_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J2: nat] : ( cos @ real @ ( Theta @ J2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K2: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J2: nat] : ( minus_minus @ real @ ( Theta @ J2 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_6685_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_6686_zeroseq__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_6687_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_6688_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N2: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_6689_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L3: real] :
              ( ! [N7: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) )
                  @ L3 )
              & ( filterlim @ nat @ real
                @ ^ [N: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L3 )
                @ ( at_top @ nat ) )
              & ! [N7: nat] :
                  ( ord_less_eq @ real @ L3
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L3 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_6690_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_6691_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N2: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_6692_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_6693_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F2: nat > A,F3: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X: nat] : ( F2 @ ( suc @ X ) )
        @ F3
        @ ( at_top @ nat ) )
      = ( filterlim @ nat @ A @ F2 @ F3 @ ( at_top @ nat ) ) ) ).

% filterlim_sequentially_Suc
thf(fact_6694_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A4: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A4 )
               => ! [B3: nat] :
                    ( ( ord_less @ nat @ A4 @ B3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or3652927894154168847AtMost @ nat @ A4 @ B3 ) ) ) @ ( G @ A4 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_bounded_partials
thf(fact_6695_eventually__sequentially__Suc,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat
        @ ^ [I3: nat] : ( P @ ( suc @ I3 ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_Suc
thf(fact_6696_eventually__sequentially__seg,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N: nat] : ( P @ ( plus_plus @ nat @ N @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_6697_Lim__transform__eventually,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ B )
     => ! [F2: A > B,L2: B,F3: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 )
         => ( ( eventually @ A
              @ ^ [X: A] :
                  ( ( F2 @ X )
                  = ( G @ X ) )
              @ F3 )
           => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 ) ) ) ) ).

% Lim_transform_eventually
thf(fact_6698_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F3 )
          = ( ! [Z7: B] :
                ( eventually @ A
                @ ^ [X: A] : ( ord_less @ B @ Z7 @ ( F2 @ X ) )
                @ F3 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_6699_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F3 )
          = ( ! [Z7: B] :
                ( eventually @ A
                @ ^ [X: A] : ( ord_less_eq @ B @ Z7 @ ( F2 @ X ) )
                @ F3 ) ) ) ) ).

% filterlim_at_top
thf(fact_6700_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F3: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F3 )
          = ( ! [Z7: B] :
                ( ( ord_less_eq @ B @ C2 @ Z7 )
               => ( eventually @ A
                  @ ^ [X: A] : ( ord_less_eq @ B @ Z7 @ ( F2 @ X ) )
                  @ F3 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_6701_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F3: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F3 )
         => ( ( eventually @ B
              @ ^ [X: B] : ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ F3 )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F3 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_6702_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A] :
          ( ! [X3: A,Y3: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y3 )
               => ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_6703_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ C2 @ X3 )
             => ( P @ X3 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_6704_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N: A] :
                ( ( ord_less_eq @ A @ N6 @ N )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_6705_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X3: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X3 )
         => ( P @ X3 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_6706_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N6: nat] :
          ! [N: nat] :
            ( ( ord_less_eq @ nat @ N6 @ N )
           => ( P @ N ) ) ) ) ).

% eventually_sequentially
thf(fact_6707_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_6708_le__sequentially,axiom,
    ! [F3: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F3 @ ( at_top @ nat ) )
      = ( ! [N6: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N6 ) @ F3 ) ) ) ).

% le_sequentially
thf(fact_6709_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X: A] :
              ! [Y: A] :
                ( ( ord_less_eq @ A @ X @ Y )
               => ( P @ Y ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_6710_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_6711_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N: A] :
                ( ( ord_less @ A @ N6 @ N )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_6712_sequentially__offset,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
     => ( eventually @ nat
        @ ^ [I3: nat] : ( P @ ( plus_plus @ nat @ I3 @ K ) )
        @ ( at_top @ nat ) ) ) ).

% sequentially_offset
thf(fact_6713_has__field__derivative__cong__eventually,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,G: A > A,X2: A,S: set @ A,U: A] :
          ( ( eventually @ A
            @ ^ [X: A] :
                ( ( F2 @ X )
                = ( G @ X ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( ( F2 @ X2 )
              = ( G @ X2 ) )
           => ( ( has_field_derivative @ A @ F2 @ U @ ( topolo174197925503356063within @ A @ X2 @ S ) )
              = ( has_field_derivative @ A @ G @ U @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ).

% has_field_derivative_cong_eventually
thf(fact_6714_has__derivative__transform__eventually,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A,S2: set @ A,G: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( eventually @ A
              @ ^ [X9: A] :
                  ( ( F2 @ X9 )
                  = ( G @ X9 ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( ( ( F2 @ X2 )
                = ( G @ X2 ) )
             => ( ( member @ A @ X2 @ S2 )
               => ( has_derivative @ A @ B @ G @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ) ).

% has_derivative_transform_eventually
thf(fact_6715_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ ( top_top @ A ) )
                  & ! [Z5: A] :
                      ( ( ord_less @ A @ B3 @ Z5 )
                     => ( P @ Z5 ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_6716_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_lessThan @ A @ X2 ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ B3 @ X2 )
                & ! [Y: A] :
                    ( ( ord_less @ A @ B3 @ Y )
                   => ( ( ord_less @ A @ Y @ X2 )
                     => ( P @ Y ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_6717_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y2: A,X2: A,P: A > $o] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_lessThan @ A @ X2 ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ X2 )
                  & ! [Y: A] :
                      ( ( ord_less @ A @ B3 @ Y )
                     => ( ( ord_less @ A @ Y @ X2 )
                       => ( P @ Y ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_6718_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F3: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F3 )
          = ( ! [Z7: B] :
                ( ( ord_less @ B @ C2 @ Z7 )
               => ( eventually @ A
                  @ ^ [X: A] : ( ord_less_eq @ B @ Z7 @ ( F2 @ X ) )
                  @ F3 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_6719_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X2: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F3 )
         => ( ( eventually @ B
              @ ^ [I3: B] : ( ord_less_eq @ A @ ( F2 @ I3 ) @ A2 )
              @ F3 )
           => ( ( F3
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X2 @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_6720_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X2: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F3 )
         => ( ( eventually @ B
              @ ^ [I3: B] : ( ord_less_eq @ A @ A2 @ ( F2 @ I3 ) )
              @ F3 )
           => ( ( F3
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X2 ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_6721_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F3: filter @ B,F2: B > A,X2: A,G: B > A,Y2: A] :
          ( ( F3
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F3 )
           => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F3 )
             => ( ( eventually @ B
                  @ ^ [X: B] : ( ord_less_eq @ A @ ( G @ X ) @ ( F2 @ X ) )
                  @ F3 )
               => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ) ) ).

% tendsto_le
thf(fact_6722_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,G: B > A,Net: filter @ B,H2: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N: B] : ( ord_less_eq @ A @ ( F2 @ N ) @ ( G @ N ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N: B] : ( ord_less_eq @ A @ ( G @ N ) @ ( H2 @ N ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_6723_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,X2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F3 )
          = ( ! [L: A] :
                ( ( ord_less @ A @ L @ X2 )
               => ( eventually @ B
                  @ ^ [X: B] : ( ord_less @ A @ L @ ( F2 @ X ) )
                  @ F3 ) )
            & ! [U2: A] :
                ( ( ord_less @ A @ X2 @ U2 )
               => ( eventually @ B
                  @ ^ [X: B] : ( ord_less @ A @ ( F2 @ X ) @ U2 )
                  @ F3 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_6724_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y2: A,F2: B > A,F3: filter @ B] :
          ( ! [A6: A] :
              ( ( ord_less @ A @ A6 @ Y2 )
             => ( eventually @ B
                @ ^ [X: B] : ( ord_less @ A @ A6 @ ( F2 @ X ) )
                @ F3 ) )
         => ( ! [A6: A] :
                ( ( ord_less @ A @ Y2 @ A6 )
               => ( eventually @ B
                  @ ^ [X: B] : ( ord_less @ A @ ( F2 @ X ) @ A6 )
                  @ F3 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F3 ) ) ) ) ).

% order_tendstoI
thf(fact_6725_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y2: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F3 )
         => ( ( ord_less @ A @ A2 @ Y2 )
           => ( eventually @ B
              @ ^ [X: B] : ( ord_less @ A @ A2 @ ( F2 @ X ) )
              @ F3 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_6726_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y2: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F3 )
         => ( ( ord_less @ A @ Y2 @ A2 )
           => ( eventually @ B
              @ ^ [X: B] : ( ord_less @ A @ ( F2 @ X ) @ A2 )
              @ F3 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_6727_has__field__derivative__cong__ev,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X2: A,Y2: A,S: set @ A,F2: A > A,G: A > A,U: A,V: A,T2: set @ A] :
          ( ( X2 = Y2 )
         => ( ( eventually @ A
              @ ^ [X: A] :
                  ( ( member @ A @ X @ S )
                 => ( ( F2 @ X )
                    = ( G @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X2 ) )
           => ( ( U = V )
             => ( ( S = T2 )
               => ( ( member @ A @ X2 @ S )
                 => ( ( has_field_derivative @ A @ F2 @ U @ ( topolo174197925503356063within @ A @ X2 @ S ) )
                    = ( has_field_derivative @ A @ G @ V @ ( topolo174197925503356063within @ A @ Y2 @ T2 ) ) ) ) ) ) ) ) ) ).

% has_field_derivative_cong_ev
thf(fact_6728_real__tendsto__sandwich,axiom,
    ! [B: $tType,F2: B > real,G: B > real,Net: filter @ B,H2: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N: B] : ( ord_less_eq @ real @ ( F2 @ N ) @ ( G @ N ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N: B] : ( ord_less_eq @ real @ ( G @ N ) @ ( H2 @ N ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_6729_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_6730_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X: A] : ( P @ ( plus_plus @ A @ X @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_6731_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,L2: A,F3: filter @ B] :
          ( ( eventually @ B
            @ ^ [N: B] : ( ord_less_eq @ A @ ( F2 @ N ) @ L2 )
            @ F3 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ X3 @ L2 )
               => ( eventually @ B
                  @ ^ [N: B] : ( ord_less @ A @ X3 @ ( F2 @ N ) )
                  @ F3 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 ) ) ) ) ).

% increasing_tendsto
thf(fact_6732_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L2: A,F2: B > A,F3: filter @ B] :
          ( ( eventually @ B
            @ ^ [N: B] : ( ord_less_eq @ A @ L2 @ ( F2 @ N ) )
            @ F3 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ L2 @ X3 )
               => ( eventually @ B
                  @ ^ [N: B] : ( ord_less @ A @ ( F2 @ N ) @ X3 )
                  @ F3 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 ) ) ) ) ).

% decreasing_tendsto
thf(fact_6733_DERIV__cong__ev,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X2: A,Y2: A,F2: A > A,G: A > A,U: A,V: A] :
          ( ( X2 = Y2 )
         => ( ( eventually @ A
              @ ^ [X: A] :
                  ( ( F2 @ X )
                  = ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X2 ) )
           => ( ( U = V )
             => ( ( has_field_derivative @ A @ F2 @ U @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
                = ( has_field_derivative @ A @ G @ V @ ( topolo174197925503356063within @ A @ Y2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% DERIV_cong_ev
thf(fact_6734_eventually__floor__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X: A] :
                  ( ( archim6421214686448440834_floor @ B @ ( F2 @ X ) )
                  = ( archim6421214686448440834_floor @ B @ L2 ) )
              @ F3 ) ) ) ) ).

% eventually_floor_eq
thf(fact_6735_eventually__ceiling__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X: A] :
                  ( ( archimedean_ceiling @ B @ ( F2 @ X ) )
                  = ( archimedean_ceiling @ B @ L2 ) )
              @ F3 ) ) ) ) ).

% eventually_ceiling_eq
thf(fact_6736_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( eventually @ A
              @ ^ [X: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X ) )
              @ F3 )
           => ( topolo3448309680560233919inuous @ A @ real @ F3
              @ ^ [X: A] : ( arcosh @ real @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_6737_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L6: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ F3 )
         => ( ( eventually @ A
              @ ^ [X: A] : ( ord_less @ B @ ( F2 @ X ) @ L6 )
              @ F3 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L6 @ ( set_ord_lessThan @ B @ L6 ) ) @ F3 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_6738_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) @ ( G @ N ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_6739_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: B > real,A2: real,F3: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X ) )
            @ F3 )
         => ( filterlim @ B @ real
            @ ^ [X: B] : ( arcosh @ real @ ( F2 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F3 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_6740_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X3: A,Y3: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y3 )
               => ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B6: A] :
                      ( ( Q @ B6 )
                     => ( ord_less @ A @ B6 @ A2 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_6741_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F3: filter @ A,G: A > C,K5: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
         => ( ( eventually @ A
              @ ^ [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) @ K5 ) )
              @ F3 )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F3 ) ) ) ) ).

% tendsto_0_le
thf(fact_6742_filterlim__at__withinI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: B > A,C2: A,F3: filter @ B,A3: set @ A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F3 )
         => ( ( eventually @ B
              @ ^ [X: B] : ( member @ A @ ( F2 @ X ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) ) )
              @ F3 )
           => ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ C2 @ A3 ) @ F3 ) ) ) ) ).

% filterlim_at_withinI
thf(fact_6743_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( eventually @ A
            @ ^ [X: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X ) )
            @ F3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X: A] : ( powr @ real @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F3 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_6744_tendsto__powr2,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( eventually @ A
            @ ^ [X: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X ) )
            @ F3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X: A] : ( powr @ real @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
              @ F3 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_6745_tendsto__powr_H,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( ( A2
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X ) )
                @ F3 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( powr @ real @ ( F2 @ X ) @ ( G @ X ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F3 ) ) ) ) ).

% tendsto_powr'
thf(fact_6746_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L2 ) ) @ ( F2 @ X ) )
              @ F3 ) ) ) ) ).

% eventually_floor_less
thf(fact_6747_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X: A] : ( ord_less @ B @ ( F2 @ X ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L2 ) ) )
              @ F3 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_6748_filterlim__Suc,axiom,
    filterlim @ nat @ nat @ suc @ ( at_top @ nat ) @ ( at_top @ nat ) ).

% filterlim_Suc
thf(fact_6749_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [M3: nat] :
              ! [N: nat] :
                ( ( ord_less_eq @ nat @ M3 @ N )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N ) ) ) @ ( G @ M3 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_Cauchy'
thf(fact_6750_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N2: nat,B4: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N2 )
             => ( eventually @ A
                @ ^ [Z5: A] :
                    ( ord_less_eq @ real @ B4
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z5 @ I3 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_6751_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) ) @ ( minus_minus @ B @ ( F2 @ Y ) @ ( plus_plus @ B @ ( F2 @ X2 ) @ ( F6 @ ( minus_minus @ A @ Y @ X2 ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_6752_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F3 )
     => ( ( eventually @ A
          @ ^ [X: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X ) )
          @ F3 )
       => ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
thf(fact_6753_filterlim__abs__real,axiom,
    filterlim @ real @ real @ ( abs_abs @ real ) @ ( at_top @ real ) @ ( at_top @ real ) ).

% filterlim_abs_real
thf(fact_6754_filterlim__at__top__add__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X: A] : ( plus_plus @ real @ ( F2 @ X ) @ ( G @ X ) )
          @ ( at_top @ real )
          @ F3 ) ) ) ).

% filterlim_at_top_add_at_top
thf(fact_6755_filterlim__at__infinity__imp__norm__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) )
            @ ( at_top @ real )
            @ F3 ) ) ) ).

% filterlim_at_infinity_imp_norm_at_top
thf(fact_6756_filterlim__norm__at__top__imp__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) )
            @ ( at_top @ real )
            @ F3 )
         => ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F3 ) ) ) ).

% filterlim_norm_at_top_imp_at_infinity
thf(fact_6757_filterlim__at__infinity__conv__norm__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,G6: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ G6 )
          = ( filterlim @ A @ real
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) )
            @ ( at_top @ real )
            @ G6 ) ) ) ).

% filterlim_at_infinity_conv_norm_at_top
thf(fact_6758_bounded__linear_Otendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > B,G: C > A,A2: A,F3: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
           => ( filterlim @ C @ B
              @ ^ [X: C] : ( F2 @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) )
              @ F3 ) ) ) ) ).

% bounded_linear.tendsto
thf(fact_6759_filterlim__norm__at__top,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( filterlim @ A @ real @ ( real_V7770717601297561774m_norm @ A ) @ ( at_top @ real ) @ ( at_infinity @ A ) ) ) ).

% filterlim_norm_at_top
thf(fact_6760_filterlim__at__top__imp__at__infinity,axiom,
    ! [B: $tType,F2: B > real,F3: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( at_top @ real ) @ F3 )
     => ( filterlim @ B @ real @ F2 @ ( at_infinity @ real ) @ F3 ) ) ).

% filterlim_at_top_imp_at_infinity
thf(fact_6761_filterlim__of__real__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( filterlim @ real @ A @ ( real_Vector_of_real @ A ) @ ( at_infinity @ A ) @ ( at_top @ real ) ) ) ).

% filterlim_of_real_at_infinity
thf(fact_6762_filterlim__real__of__int__at__top,axiom,
    filterlim @ int @ real @ ( ring_1_of_int @ real ) @ ( at_top @ real ) @ ( at_top @ int ) ).

% filterlim_real_of_int_at_top
thf(fact_6763_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X: A] : ( times_times @ real @ ( F2 @ X ) @ ( G @ X ) )
          @ ( at_top @ real )
          @ F3 ) ) ) ).

% filterlim_at_top_mult_at_top
thf(fact_6764_eventually__not__equal__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A] :
          ( eventually @ A
          @ ^ [X: A] : ( X != A2 )
          @ ( at_infinity @ A ) ) ) ).

% eventually_not_equal_at_infinity
thf(fact_6765_sqrt__at__top,axiom,
    filterlim @ real @ real @ sqrt @ ( at_top @ real ) @ ( at_top @ real ) ).

% sqrt_at_top
thf(fact_6766_lhopital__left__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F6: real > real,G5: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_top
thf(fact_6767_lhopital__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F6: real > real,G5: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_top
thf(fact_6768_has__derivative__bounded__linear,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,F3: filter @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ F3 )
         => ( real_V3181309239436604168linear @ A @ B @ F6 ) ) ) ).

% has_derivative_bounded_linear
thf(fact_6769_bounded__linear_Ohas__derivative,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: C > A,G5: C > A,F3: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( has_derivative @ C @ A @ G @ G5 @ F3 )
           => ( has_derivative @ C @ B
              @ ^ [X: C] : ( F2 @ ( G @ X ) )
              @ ^ [X: C] : ( F2 @ ( G5 @ X ) )
              @ F3 ) ) ) ) ).

% bounded_linear.has_derivative
thf(fact_6770_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X2: A] : ( real_V3181309239436604168linear @ A @ A @ ( times_times @ A @ X2 ) ) ) ).

% bounded_linear_mult_right
thf(fact_6771_bounded__linear__mult__const,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,Y2: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X: C] : ( times_times @ A @ ( G @ X ) @ Y2 ) ) ) ) ).

% bounded_linear_mult_const
thf(fact_6772_bounded__linear__const__mult,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,X2: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X: C] : ( times_times @ A @ X2 @ ( G @ X ) ) ) ) ) ).

% bounded_linear_const_mult
thf(fact_6773_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [Y2: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X: A] : ( times_times @ A @ X @ Y2 ) ) ) ).

% bounded_linear_mult_left
thf(fact_6774_bounded__linear__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X: A] : ( minus_minus @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% bounded_linear_sub
thf(fact_6775_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Y2: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X: A] : ( divide_divide @ A @ X @ Y2 ) ) ) ).

% bounded_linear_divide
thf(fact_6776_real__bounded__linear,axiom,
    ( ( real_V3181309239436604168linear @ real @ real )
    = ( ^ [F4: real > real] :
        ? [C3: real] :
          ( F4
          = ( ^ [X: real] : ( times_times @ real @ X @ C3 ) ) ) ) ) ).

% real_bounded_linear
thf(fact_6777_bounded__linear_Obounded__linear,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ).

% bounded_linear.bounded_linear
thf(fact_6778_bounded__linear_OCauchy,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > B,X6: nat > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( topolo3814608138187158403Cauchy @ A @ X6 )
           => ( topolo3814608138187158403Cauchy @ B
              @ ^ [N: nat] : ( F2 @ ( X6 @ N ) ) ) ) ) ) ).

% bounded_linear.Cauchy
thf(fact_6779_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X: A] : ( plus_plus @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% bounded_linear_add
thf(fact_6780_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( real_V3181309239436604168linear @ A @ B
        @ ^ [X: A] : ( zero_zero @ B ) ) ) ).

% bounded_linear_zero
thf(fact_6781_bounded__linear_Ocontinuous,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > B,F3: filter @ C,G: C > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ A @ F3 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F3
              @ ^ [X: C] : ( F2 @ ( G @ X ) ) ) ) ) ) ).

% bounded_linear.continuous
thf(fact_6782_not__tendsto__and__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: filter @ B,F2: B > A,C2: A] :
          ( ( F3
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F3 )
           => ~ ( filterlim @ B @ A @ F2 @ ( at_infinity @ A ) @ F3 ) ) ) ) ).

% not_tendsto_and_filterlim_at_infinity
thf(fact_6783_filterlim__int__sequentially,axiom,
    filterlim @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( at_top @ int ) @ ( at_top @ nat ) ).

% filterlim_int_sequentially
thf(fact_6784_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K10: real] :
            ! [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ K10 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_6785_filterlim__at__infinity__imp__eventually__ne,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F3 )
         => ( eventually @ A
            @ ^ [Z5: A] :
                ( ( F2 @ Z5 )
               != C2 )
            @ F3 ) ) ) ).

% filterlim_at_infinity_imp_eventually_ne
thf(fact_6786_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: C > A,F3: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
           => ( filterlim @ C @ B
              @ ^ [X: C] : ( F2 @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F3 ) ) ) ) ).

% bounded_linear.tendsto_zero
thf(fact_6787_bounded__linear_OisCont,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > B,A2: C,G: C > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
              @ ^ [X: C] : ( F2 @ ( G @ X ) ) ) ) ) ) ).

% bounded_linear.isCont
thf(fact_6788_eventually__at__left__real,axiom,
    ! [B2: real,A2: real] :
      ( ( ord_less @ real @ B2 @ A2 )
     => ( eventually @ real
        @ ^ [X: real] : ( member @ real @ X @ ( set_or5935395276787703475ssThan @ real @ B2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ).

% eventually_at_left_real
thf(fact_6789_filterlim__tendsto__add__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X: A] : ( plus_plus @ real @ ( F2 @ X ) @ ( G @ X ) )
          @ ( at_top @ real )
          @ F3 ) ) ) ).

% filterlim_tendsto_add_at_top
thf(fact_6790_lhopital__at__top,axiom,
    ! [G: real > real,X2: real,G5: real > real,F2: real > real,F6: real > real,Y2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X: real] :
              ( ( G5 @ X )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_6791_lhospital__at__top__at__top,axiom,
    ! [G: real > real,G5: real > real,F2: real > real,F6: real > real,X2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X: real] :
              ( ( G5 @ X )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_6792_lhopital__left__at__top,axiom,
    ! [G: real > real,X2: real,G5: real > real,F2: real > real,F6: real > real,Y2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
     => ( ( eventually @ real
          @ ^ [X: real] :
              ( ( G5 @ X )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_6793_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K10: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K10 )
              & ! [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ K10 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_6794_has__derivative__within__singleton__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F2 @ G @ ( topolo174197925503356063within @ A @ X2 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( real_V3181309239436604168linear @ A @ B @ G ) ) ) ).

% has_derivative_within_singleton_iff
thf(fact_6795_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
              ! [X: A] :
                ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X ) )
               => ( P @ X ) ) ) ) ) ).

% eventually_at_infinity
thf(fact_6796_filterlim__real__at__infinity__sequentially,axiom,
    filterlim @ nat @ real @ ( semiring_1_of_nat @ real ) @ ( at_infinity @ real ) @ ( at_top @ nat ) ).

% filterlim_real_at_infinity_sequentially
thf(fact_6797_tendsto__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( filterlim @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ).

% tendsto_of_nat
thf(fact_6798_filterlim__pow__at__top,axiom,
    ! [A: $tType,N2: nat,F2: A > real,F3: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X: A] : ( power_power @ real @ ( F2 @ X ) @ N2 )
          @ ( at_top @ real )
          @ F3 ) ) ) ).

% filterlim_pow_at_top
thf(fact_6799_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,C2: B,F3: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F3 )
         => ( ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F3 )
           => ( filterlim @ A @ B
              @ ^ [X: A] : ( plus_plus @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ ( at_infinity @ B )
              @ F3 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity
thf(fact_6800_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A,G: A > B,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F3 )
         => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F3 )
           => ( filterlim @ A @ B
              @ ^ [X: A] : ( plus_plus @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ ( at_infinity @ B )
              @ F3 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
thf(fact_6801_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X: A] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F3 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_6802_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
     => ( filterlim @ A @ real
        @ ^ [X: A] : ( inverse_inverse @ real @ ( F2 @ X ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F3 ) ) ).

% tendsto_inverse_0_at_top
thf(fact_6803_filterlim__int__of__nat__at__topD,axiom,
    ! [A: $tType,F2: int > A,F3: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X: nat] : ( F2 @ ( semiring_1_of_nat @ int @ X ) )
        @ F3
        @ ( at_top @ nat ) )
     => ( filterlim @ int @ A @ F2 @ F3 @ ( at_top @ int ) ) ) ).

% filterlim_int_of_nat_at_topD
thf(fact_6804_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K10: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
              & ! [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ K10 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_6805_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,K5: real] :
          ( ! [X3: A,Y3: A] :
              ( ( F2 @ ( plus_plus @ A @ X3 @ Y3 ) )
              = ( plus_plus @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
         => ( ! [R2: real,X3: A] :
                ( ( F2 @ ( real_V8093663219630862766scaleR @ A @ R2 @ X3 ) )
                = ( real_V8093663219630862766scaleR @ B @ R2 @ ( F2 @ X3 ) ) )
           => ( ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_6806_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_infinity @ A ) ) ) ).

% tendsto_inverse_0
thf(fact_6807_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( times_times @ real @ ( G @ X ) @ ( F2 @ X ) )
            @ ( at_top @ real )
            @ F3 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_6808_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( times_times @ real @ ( F2 @ X ) @ ( G @ X ) )
            @ ( at_top @ real )
            @ F3 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_6809_tendsto__neg__powr,axiom,
    ! [A: $tType,S2: real,F2: A > real,F3: filter @ A] :
      ( ( ord_less @ real @ S2 @ ( zero_zero @ real ) )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X: A] : ( powr @ real @ ( F2 @ X ) @ S2 )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F3 ) ) ) ).

% tendsto_neg_powr
thf(fact_6810_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,C2: A,F3: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F3 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G @ ( at_infinity @ A ) @ F3 )
             => ( filterlim @ B @ A
                @ ^ [X: B] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) )
                @ ( at_infinity @ A )
                @ F3 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_6811_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X: real] : ( divide_divide @ real @ ( ln_ln @ real @ X ) @ X )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_6812_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: C > A,C2: A,F3: filter @ C,G: C > A] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F3 )
         => ( ( filterlim @ C @ A @ G @ ( at_infinity @ A ) @ F3 )
           => ( filterlim @ C @ A
              @ ^ [X: C] : ( divide_divide @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 ) ) ) ) ).

% tendsto_divide_0
thf(fact_6813_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F2: A > B,F3: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( filterlim @ A @ B
              @ ^ [X: A] : ( power_power @ B @ ( F2 @ X ) @ N2 )
              @ ( at_infinity @ B )
              @ F3 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_6814_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% filterlim_inverse_at_infinity
thf(fact_6815_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
         => ( ( eventually @ A
              @ ^ [X: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
              @ F3 )
           => ( filterlim @ A @ real
              @ ^ [X: A] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
              @ ( at_top @ real )
              @ F3 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_6816_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( eventually @ A
        @ ^ [X: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X ) )
        @ F3 )
     => ( ( filterlim @ A @ real
          @ ^ [X: A] : ( inverse_inverse @ real @ ( F2 @ X ) )
          @ ( at_top @ real )
          @ F3 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ) ).

% filterlim_inverse_at_top_iff
thf(fact_6817_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
     => ( ( eventually @ A
          @ ^ [X: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X ) )
          @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X: A] : ( inverse_inverse @ real @ ( F2 @ X ) )
          @ ( at_top @ real )
          @ F3 ) ) ) ).

% filterlim_inverse_at_top
thf(fact_6818_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( eventually @ A
        @ ^ [X: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X ) )
        @ F3 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
        = ( filterlim @ A @ real @ ( comp @ real @ real @ A @ ( inverse_inverse @ real ) @ F2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ) ).

% filterlim_at_top_iff_inverse_0
thf(fact_6819_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P2: A > $o] :
          ( ( eventually @ A @ P2 @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B3 )
                & ! [X: A] :
                    ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X ) )
                   => ( P2 @ X ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_6820_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X: real] : ( divide_divide @ real @ ( power_power @ real @ X @ K ) @ ( exp @ real @ X ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_6821_lim__infinity__imp__sequentially,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: real > A,L2: A] :
          ( ( filterlim @ real @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_infinity @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( semiring_1_of_nat @ real @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( at_top @ nat ) ) ) ) ).

% lim_infinity_imp_sequentially
thf(fact_6822_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [G: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X: A] : ( inverse_inverse @ B @ ( G @ X ) )
            @ ( topolo174197925503356063within @ B @ ( zero_zero @ B ) @ ( top_top @ ( set @ B ) ) )
            @ F3 )
          = ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F3 ) ) ) ).

% filterlim_inverse_at_iff
thf(fact_6823_lhopital,axiom,
    ! [F2: real > real,X2: real,G: real > real,G5: real > real,F6: real > real,F3: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] :
                ( ( G @ X )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] :
                  ( ( G5 @ X )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_6824_lhopital__left,axiom,
    ! [F2: real > real,X2: real,G: real > real,G5: real > real,F6: real > real,F3: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] :
                ( ( G @ X )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] :
                  ( ( G5 @ X )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
           => ( ( eventually @ real
                @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
             => ( ( eventually @ real
                  @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_6825_tendsto__exp__limit__at__top,axiom,
    ! [X2: real] :
      ( filterlim @ real @ real
      @ ^ [Y: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ Y ) ) @ Y )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X2 ) )
      @ ( at_top @ real ) ) ).

% tendsto_exp_limit_at_top
thf(fact_6826_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,C2: A,F3: filter @ A,G: A > A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F3 )
         => ( ( filterlim @ A @ A @ G @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F3 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X: A] : ( divide_divide @ A @ ( F2 @ X ) @ ( G @ X ) )
                @ ( at_infinity @ A )
                @ F3 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_6827_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_6828_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
            & ( filterlim @ A @ real
              @ ^ [Y: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X2 ) ) @ ( F6 @ ( minus_minus @ A @ Y @ X2 ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_6829_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X3: real] :
          ( ( ord_less_eq @ real @ B2 @ X3 )
         => ? [Y4: real] :
              ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_6830_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_6831_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F2: C > A,F3: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F2 @ ( at_infinity @ A ) @ F3 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X ) ) )
                    @ F3 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_6832_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X2 ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_6833_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L2: A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_infinity @ A ) )
          = ( filterlim @ A @ A @ ( comp @ A @ A @ A @ F2 @ ( inverse_inverse @ A ) ) @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% lim_at_infinity_0
thf(fact_6834_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F6: A > B,X2: A,F2: A > B,S2: set @ A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F6 )
         => ( ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X2 ) ) @ ( F6 @ ( minus_minus @ A @ Y @ X2 ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivativeI
thf(fact_6835_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X2 ) ) @ ( F6 @ ( minus_minus @ A @ Y @ X2 ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_at_within
thf(fact_6836_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L2: A] :
          ( ( filterlim @ A @ A
            @ ^ [X: A] : ( F2 @ ( divide_divide @ A @ ( one_one @ A ) @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_6837_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
            & ? [E3: A > B] :
                ( ! [H: A] :
                    ( ( F2 @ ( plus_plus @ A @ X2 @ H ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X2 ) @ ( F6 @ H ) ) @ ( E3 @ H ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_6838_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X2 ) ) ) @ ( minus_minus @ B @ ( F2 @ Y ) @ ( plus_plus @ B @ ( F2 @ X2 ) @ ( F6 @ ( minus_minus @ A @ Y @ X2 ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_within
thf(fact_6839_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,D6: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F2 @ D6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D6 )
            & ( filterlim @ A @ real
              @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ ( plus_plus @ A @ X2 @ H ) ) @ ( F2 @ X2 ) ) @ ( D6 @ H ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_6840_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( has_derivative @ A @ B )
        = ( ^ [F4: A > B,F8: A > B,F9: filter @ A] :
              ( ( real_V3181309239436604168linear @ A @ B @ F8 )
              & ( filterlim @ A @ B
                @ ^ [Y: A] :
                    ( real_V8093663219630862766scaleR @ B
                    @ ( inverse_inverse @ real
                      @ ( real_V7770717601297561774m_norm @ A
                        @ ( minus_minus @ A @ Y
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X: A] : X ) ) ) )
                    @ ( minus_minus @ B
                      @ ( minus_minus @ B @ ( F4 @ Y )
                        @ ( F4
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X: A] : X ) ) )
                      @ ( F8
                        @ ( minus_minus @ A @ Y
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X: A] : X ) ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ F9 ) ) ) ) ) ).

% has_derivative_def
thf(fact_6841_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X2: A,S: set @ A,F2: A > B,F6: A > B] :
          ( ( member @ A @ X2 @ S )
         => ( ( topolo1002775350975398744n_open @ A @ S )
           => ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
                & ? [E3: A > B] :
                    ( ! [H: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X2 @ H ) @ S )
                       => ( ( F2 @ ( plus_plus @ A @ X2 @ H ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X2 ) @ ( F6 @ H ) ) @ ( E3 @ H ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_6842_at__top__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_top @ real ) @ ( at_infinity @ real ) ).

% at_top_le_at_infinity
thf(fact_6843_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ord_less @ A @ X2 @ X3 ) )
           => ~ ( member @ A @ ( complete_Inf_Inf @ A @ A3 ) @ A3 ) ) ) ) ).

% Inf_notin_open
thf(fact_6844_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ord_less @ A @ X3 @ X2 ) )
           => ~ ( member @ A @ ( complete_Sup_Sup @ A @ A3 ) @ A3 ) ) ) ) ).

% Sup_notin_open
thf(fact_6845_has__derivative__transform__within__open,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A,T2: set @ A,S2: set @ A,G: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( member @ A @ X2 @ S2 )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( F2 @ X3 )
                      = ( G @ X3 ) ) )
               => ( has_derivative @ A @ B @ G @ F6 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ) ) ) ).

% has_derivative_transform_within_open
thf(fact_6846_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S: set @ A,X2: A,Y2: A] :
          ( ( topolo1002775350975398744n_open @ A @ S )
         => ( ( member @ A @ X2 @ S )
           => ( ( ord_less @ A @ X2 @ Y2 )
             => ? [B6: A] :
                  ( ( ord_less @ A @ X2 @ B6 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X2 @ B6 ) @ S ) ) ) ) ) ) ).

% open_right
thf(fact_6847_Lim__transform__within__open,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L2: B,A2: A,T5: set @ A,S2: set @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ T5 ) )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( member @ A @ A2 @ S2 )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( X3 != A2 )
                     => ( ( F2 @ X3 )
                        = ( G @ X3 ) ) ) )
               => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ T5 ) ) ) ) ) ) ) ).

% Lim_transform_within_open
thf(fact_6848_has__field__derivative__transform__within__open,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,A2: A,S: set @ A,G: A > A] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( topolo1002775350975398744n_open @ A @ S )
           => ( ( member @ A @ A2 @ S )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S )
                   => ( ( F2 @ X3 )
                      = ( G @ X3 ) ) )
               => ( has_field_derivative @ A @ G @ F6 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within_open
thf(fact_6849_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S: set @ A,X2: A,Y2: A] :
          ( ( topolo1002775350975398744n_open @ A @ S )
         => ( ( member @ A @ X2 @ S )
           => ( ( ord_less @ A @ Y2 @ X2 )
             => ? [B6: A] :
                  ( ( ord_less @ A @ B6 @ X2 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B6 @ X2 ) @ S ) ) ) ) ) ) ).

% open_left
thf(fact_6850_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu2: product_prod @ A @ A] :
            ? [X: A,Y: A] :
              ( ( Uu2
                = ( product_Pair @ A @ A @ X @ Y ) )
              & ( ord_less @ A @ X @ Y ) ) ) ) ) ).

% open_subdiagonal
thf(fact_6851_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu2: product_prod @ A @ A] :
            ? [X: A,Y: A] :
              ( ( Uu2
                = ( product_Pair @ A @ A @ X @ Y ) )
              & ( ord_less @ A @ Y @ X ) ) ) ) ) ).

% open_superdiagonal
thf(fact_6852_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S8 )
               => ( ( member @ A @ F0 @ S8 )
                 => ? [N6: nat] :
                    ! [N: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ N )
                     => ( member @ A @ ( F2 @ N ) @ S8 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_6853_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ G )
           => ( ( ( G
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X: A] : X ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F3
                @ ^ [X: A] : ( divide_divide @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_6854_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F3: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X: A] : X ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F3
              @ ^ [X: A] : ( inverse_inverse @ B @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_inverse
thf(fact_6855_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X: A] : X ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F3
              @ ^ [X: A] : ( sgn_sgn @ B @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_sgn
thf(fact_6856_at__within__nhd,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X2: A,S: set @ A,T5: set @ A,U4: set @ A] :
          ( ( member @ A @ X2 @ S )
         => ( ( topolo1002775350975398744n_open @ A @ S )
           => ( ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ T5 @ S ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ U4 @ S ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( topolo174197925503356063within @ A @ X2 @ T5 )
                = ( topolo174197925503356063within @ A @ X2 @ U4 ) ) ) ) ) ) ).

% at_within_nhd
thf(fact_6857_continuous__powr,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ G )
           => ( ( ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X: A] : X ) )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ A @ real @ F3
                @ ^ [X: A] : ( powr @ real @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% continuous_powr
thf(fact_6858_continuous__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X: A] : X ) )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F3
              @ ^ [X: A] : ( ln_ln @ real @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_ln
thf(fact_6859_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F3 @ F2 )
         => ( ( ( cos @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X: A] : X ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F3
              @ ^ [X: A] : ( tan @ A @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_tan
thf(fact_6860_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F3 @ F2 )
         => ( ( ( sin @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X: A] : X ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F3
              @ ^ [X: A] : ( cot @ A @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_cot
thf(fact_6861_continuous__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: filter @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F3 @ F2 )
         => ( ( ( cosh @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ C @ C @ F3
                    @ ^ [X: C] : X ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ F3
              @ ^ [X: C] : ( tanh @ A @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_tanh
thf(fact_6862_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X: A] : X ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F3
              @ ^ [X: A] : ( arcosh @ real @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_6863_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S: set @ A,F2: A > D,L6: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S )
           => ( ( topolo1002775350975398744n_open @ A @ S )
             => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ S ) )
                = ( filterlim @ A @ D
                  @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L6 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_6864_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X: A] : X ) ) )
             => ( ( ( F2
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                      @ ^ [X: A] : X ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                        @ ^ [X: A] : X ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F3
                    @ ^ [X: A] : ( log @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_6865_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E2: real,F6: A > B,S2: set @ A,X2: A,F2: A > B,H7: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ F6 )
           => ( ! [Y3: A] :
                  ( ( member @ A @ Y3 @ S2 )
                 => ( ( Y3 != X2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y3 @ X2 ) @ E2 )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y3 ) @ ( F2 @ X2 ) ) @ ( F6 @ ( minus_minus @ A @ Y3 @ X2 ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y3 @ X2 ) ) ) @ ( H7 @ Y3 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H7 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
               => ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_6866_filterlim__pow__at__bot__even,axiom,
    ! [N2: nat,F2: real > real,F3: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F3 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( filterlim @ real @ real
            @ ^ [X: real] : ( power_power @ real @ ( F2 @ X ) @ N2 )
            @ ( at_top @ real )
            @ F3 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_6867_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ B2 @ A2 ) @ ( plus_plus @ A @ C2 @ A2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel2
thf(fact_6868_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel
thf(fact_6869_dist__self,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A] :
          ( ( real_V557655796197034286t_dist @ A @ X2 @ X2 )
          = ( zero_zero @ real ) ) ) ).

% dist_self
thf(fact_6870_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( real_V557655796197034286t_dist @ A @ X2 @ Y2 )
            = ( zero_zero @ real ) )
          = ( X2 = Y2 ) ) ) ).

% dist_eq_0_iff
thf(fact_6871_dist__0__norm,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( zero_zero @ A ) @ X2 )
          = ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ).

% dist_0_norm
thf(fact_6872_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) )
          = ( ( X2 != Y2 ) ) ) ) ).

% zero_less_dist_iff
thf(fact_6873_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( zero_zero @ real ) )
          = ( X2 = Y2 ) ) ) ).

% dist_le_zero_iff
thf(fact_6874_dist__diff_I1_J,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V557655796197034286t_dist @ A @ A2 @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ).

% dist_diff(1)
thf(fact_6875_dist__diff_I2_J,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( minus_minus @ A @ A2 @ B2 ) @ A2 )
          = ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ).

% dist_diff(2)
thf(fact_6876_dist__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: real,A2: A,Y2: real] :
          ( ( real_V557655796197034286t_dist @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ A2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y2 ) ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% dist_scaleR
thf(fact_6877_at__bot__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_bot @ real ) @ ( at_infinity @ real ) ).

% at_bot_le_at_infinity
thf(fact_6878_open__ball,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,D3: real] :
          ( topolo1002775350975398744n_open @ A
          @ ( collect @ A
            @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y ) @ D3 ) ) ) ) ).

% open_ball
thf(fact_6879_dist__norm,axiom,
    ! [A: $tType] :
      ( ( real_V6936659425649961206t_norm @ A )
     => ( ( real_V557655796197034286t_dist @ A )
        = ( ^ [X: A,Y: A] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) ) ) ) ).

% dist_norm
thf(fact_6880_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Z: A,Y2: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z ) ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ E2 ) ) ) ).

% dist_triangle_lt
thf(fact_6881_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y2: A,E1: real,X22: A,E22: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y2 ) @ E1 )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y2 ) @ E22 )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% dist_triangle_less_add
thf(fact_6882_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y2: A,X2: A,E2: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X2 ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ E2 ) ) ) ).

% dist_commute_lessI
thf(fact_6883_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A )
        = ( ^ [X: A] : ( real_V557655796197034286t_dist @ A @ X @ ( zero_zero @ A ) ) ) ) ) ).

% norm_conv_dist
thf(fact_6884_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ~ ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( zero_zero @ real ) ) ) ).

% dist_not_less_zero
thf(fact_6885_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) ) ) ) ).

% dist_pos_lt
thf(fact_6886_dist__real__def,axiom,
    ( ( real_V557655796197034286t_dist @ real )
    = ( ^ [X: real,Y: real] : ( abs_abs @ real @ ( minus_minus @ real @ X @ Y ) ) ) ) ).

% dist_real_def
thf(fact_6887_dist__complex__def,axiom,
    ( ( real_V557655796197034286t_dist @ complex )
    = ( ^ [X: complex,Y: complex] : ( real_V7770717601297561774m_norm @ complex @ ( minus_minus @ complex @ X @ Y ) ) ) ) ).

% dist_complex_def
thf(fact_6888_continuous__dist,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F3: filter @ D,F2: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F3 @ G )
           => ( topolo3448309680560233919inuous @ D @ real @ F3
              @ ^ [X: D] : ( real_V557655796197034286t_dist @ A @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_dist
thf(fact_6889_dist__triangle,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Z: A,Y2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Z ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z ) ) ) ) ).

% dist_triangle
thf(fact_6890_dist__triangle2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A,Z: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z ) ) ) ) ).

% dist_triangle2
thf(fact_6891_dist__triangle3,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A,A2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ X2 ) @ ( real_V557655796197034286t_dist @ A @ A2 @ Y2 ) ) ) ) ).

% dist_triangle3
thf(fact_6892_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Z: A,Y2: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ E2 ) ) ) ).

% dist_triangle_le
thf(fact_6893_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) ) ) ).

% zero_le_dist
thf(fact_6894_open__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S8: set @ A] :
            ! [X: A] :
              ( ( member @ A @ X @ S8 )
             => ? [E3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                  & ! [Y: A] :
                      ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X ) @ E3 )
                     => ( member @ A @ Y @ S8 ) ) ) ) ) ) ) ).

% open_dist
thf(fact_6895_continuous__at__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [B2: A,A2: A] : ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ B2 @ ( top_top @ ( set @ A ) ) ) @ ( real_V557655796197034286t_dist @ A @ A2 ) ) ) ).

% continuous_at_dist
thf(fact_6896_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [A2: A,B2: A,C2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ B2 ) @ ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) @ ( real_V557655796197034286t_dist @ A @ A2 @ C2 ) ) ) ).

% abs_dist_diff_le
thf(fact_6897_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N: A] :
                ( ( ord_less_eq @ A @ N @ N6 )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_6898_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N: A] :
                ( ( ord_less @ A @ N @ N6 )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_6899_eventually__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S ) )
          = ( ? [D2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
                & ! [X: A] :
                    ( ( member @ A @ X @ S )
                   => ( ( ( X != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ A2 ) @ D2 ) )
                     => ( P @ X ) ) ) ) ) ) ) ).

% eventually_at
thf(fact_6900_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( ? [D2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
                & ! [X: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ A2 ) @ D2 )
                   => ( P @ X ) ) ) ) ) ) ).

% eventually_nhds_metric
thf(fact_6901_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,A2: A,S: set @ A,D3: real,G: A > A] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ A2 @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
           => ( ( member @ A @ A2 @ S )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D3 )
                     => ( ( F2 @ X3 )
                        = ( G @ X3 ) ) ) )
               => ( has_field_derivative @ A @ G @ F6 @ ( topolo174197925503356063within @ A @ A2 @ S ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within
thf(fact_6902_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X2: A,S2: set @ A,D3: real,G: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
           => ( ( member @ A @ X2 @ S2 )
             => ( ! [X10: A] :
                    ( ( member @ A @ X10 @ S2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X10 @ X2 ) @ D3 )
                     => ( ( F2 @ X10 )
                        = ( G @ X10 ) ) ) )
               => ( has_derivative @ A @ B @ G @ F6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ) ).

% has_derivative_transform_within
thf(fact_6903_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X: A] : ( ord_less_eq @ A @ X @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_6904_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X: A] : ( ord_less @ A @ X @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_6905_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_6906_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S6: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S6 @ N ) @ ( S6 @ N6 ) ) @ E3 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_6907_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X6 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M9: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M9 @ M2 )
               => ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ M9 @ N7 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X6 @ M2 ) @ ( X6 @ N7 ) ) @ E2 ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_6908_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X6 @ M4 ) @ ( X6 @ N3 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X6 ) ) ) ).

% metric_CauchyI
thf(fact_6909_filterlim__uminus__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
      = ( filterlim @ A @ real
        @ ^ [X: A] : ( uminus_uminus @ real @ ( F2 @ X ) )
        @ ( at_bot @ real )
        @ F3 ) ) ).

% filterlim_uminus_at_top
thf(fact_6910_filterlim__uminus__at__bot,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_bot @ real ) @ F3 )
      = ( filterlim @ A @ real
        @ ^ [X: A] : ( uminus_uminus @ real @ ( F2 @ X ) )
        @ ( at_top @ real )
        @ F3 ) ) ).

% filterlim_uminus_at_bot
thf(fact_6911_filterlim__at__top__mirror,axiom,
    ! [A: $tType,F2: real > A,F3: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F3 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X: real] : ( F2 @ ( uminus_uminus @ real @ X ) )
        @ F3
        @ ( at_bot @ real ) ) ) ).

% filterlim_at_top_mirror
thf(fact_6912_filterlim__at__bot__mirror,axiom,
    ! [A: $tType,F2: real > A,F3: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F3 @ ( at_bot @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X: real] : ( F2 @ ( uminus_uminus @ real @ X ) )
        @ F3
        @ ( at_top @ real ) ) ) ).

% filterlim_at_bot_mirror
thf(fact_6913_dist__of__int,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [M: int,N2: int] :
          ( ( real_V557655796197034286t_dist @ A @ ( ring_1_of_int @ A @ M ) @ ( ring_1_of_int @ A @ N2 ) )
          = ( ring_1_of_int @ real @ ( abs_abs @ int @ ( minus_minus @ int @ M @ N2 ) ) ) ) ) ).

% dist_of_int
thf(fact_6914_filterlim__uminus__at__top__at__bot,axiom,
    filterlim @ real @ real @ ( uminus_uminus @ real ) @ ( at_top @ real ) @ ( at_bot @ real ) ).

% filterlim_uminus_at_top_at_bot
thf(fact_6915_filterlim__uminus__at__bot__at__top,axiom,
    filterlim @ real @ real @ ( uminus_uminus @ real ) @ ( at_bot @ real ) @ ( at_top @ real ) ).

% filterlim_uminus_at_bot_at_top
thf(fact_6916_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,A2: A,F3: filter @ C,G: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( eventually @ C
              @ ^ [X: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X ) @ A2 ) )
              @ F3 )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F3 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_6917_tendsto__dist,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L2: A,F3: filter @ B,G: B > A,M: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ M ) @ F3 )
           => ( filterlim @ B @ real
              @ ^ [X: B] : ( real_V557655796197034286t_dist @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( real_V557655796197034286t_dist @ A @ L2 @ M ) )
              @ F3 ) ) ) ) ).

% tendsto_dist
thf(fact_6918_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu2: set @ A] :
                  ? [F4: ( set @ A ) > A] :
                    ( ( Uu2
                      = ( image @ ( set @ A ) @ A @ F4 @ A3 ) )
                    & ! [X: set @ A] :
                        ( ( member @ ( set @ A ) @ X @ A3 )
                       => ( member @ A @ ( F4 @ X ) @ X ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_6919_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu2: set @ A] :
                  ? [F4: ( set @ A ) > A] :
                    ( ( Uu2
                      = ( image @ ( set @ A ) @ A @ F4 @ A3 ) )
                    & ! [X: set @ A] :
                        ( ( member @ ( set @ A ) @ X @ A3 )
                       => ( member @ A @ ( F4 @ X ) @ X ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) ) ) ) ).

% Sup_Inf_le
thf(fact_6920_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,L2: A,A2: C,G: C > B,M: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) )
         => ( ! [X3: C] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X3 ) @ M ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X3 ) @ L2 ) ) )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) ) ) ) ) ).

% metric_LIM_imp_LIM
thf(fact_6921_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y2: A,E2: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y2 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y2 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ E2 ) ) ) ) ).

% dist_triangle_half_l
thf(fact_6922_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y2: A,X15: A,E2: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X15 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X22 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ E2 ) ) ) ) ).

% dist_triangle_half_r
thf(fact_6923_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L2: B,X2: A,S: set @ A,D3: real,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
           => ( ! [X10: A] :
                  ( ( member @ A @ X10 @ S )
                 => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X10 @ X2 ) )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X10 @ X2 ) @ D3 )
                     => ( ( F2 @ X10 )
                        = ( G @ X10 ) ) ) ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ).

% Lim_transform_within
thf(fact_6924_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S ) )
          = ( ? [D2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
                & ! [X: A] :
                    ( ( member @ A @ X @ S )
                   => ( ( ( X != A2 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ A2 ) @ D2 ) )
                     => ( P @ X ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_6925_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,X22: A,E2: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ X32 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X42 ) @ E2 ) ) ) ) ) ).

% dist_triangle_third
thf(fact_6926_exp__at__bot,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_bot @ real ) ).

% exp_at_bot
thf(fact_6927_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G: A > B,G6: filter @ B,X2: A,S: set @ A,F3: filter @ B,D3: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G6 @ F3 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
             => ( ! [X10: A] :
                    ( ( member @ A @ X10 @ S )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X10 @ X2 ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X10 @ X2 ) @ D3 )
                       => ( ( F2 @ X10 )
                          = ( G @ X10 ) ) ) ) )
               => ( filterlim @ A @ B @ F2 @ F3 @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_6928_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F4: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N: nat] :
                      ( ( ord_less @ nat @ M3 @ N )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F4 @ M3 ) @ ( F4 @ N ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_6929_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M4 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X6 @ M4 ) @ ( X6 @ N3 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X6 ) ) ) ).

% CauchyI'
thf(fact_6930_dist__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( real_V557655796197034286t_dist @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ring_1_of_int @ real @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ) ).

% dist_of_nat
thf(fact_6931_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ( eventually @ B
                  @ ^ [X: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X ) @ L2 ) @ E3 )
                  @ F3 ) ) ) ) ) ).

% tendsto_iff
thf(fact_6932_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L2: A,F3: filter @ B] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ( eventually @ B
                @ ^ [X: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X ) @ L2 ) @ E )
                @ F3 ) )
         => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 ) ) ) ).

% tendstoI
thf(fact_6933_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L2: A,F3: filter @ B,E2: real] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ( eventually @ B
              @ ^ [X: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X ) @ L2 ) @ E2 )
              @ F3 ) ) ) ) ).

% tendstoD
thf(fact_6934_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [F2: A > B,L2: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F3 )
          = ( filterlim @ A @ real
            @ ^ [X: A] : ( real_V557655796197034286t_dist @ B @ ( F2 @ X ) @ L2 )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F3 ) ) ) ).

% tendsto_dist_iff
thf(fact_6935_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F3: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F3 )
          = ( ! [Z7: B] :
                ( ( ord_less_eq @ B @ Z7 @ C2 )
               => ( eventually @ A
                  @ ^ [X: A] : ( ord_less_eq @ B @ ( F2 @ X ) @ Z7 )
                  @ F3 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_6936_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F3 )
          = ( ! [Z7: B] :
                ( eventually @ A
                @ ^ [X: A] : ( ord_less_eq @ B @ ( F2 @ X ) @ Z7 )
                @ F3 ) ) ) ) ).

% filterlim_at_bot
thf(fact_6937_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F3 )
          = ( ! [Z7: B] :
                ( eventually @ A
                @ ^ [X: A] : ( ord_less @ B @ ( F2 @ X ) @ Z7 )
                @ F3 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_6938_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G: A > B,L2: B,A2: A,R3: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ R3 )
                   => ( ( F2 @ X3 )
                      = ( G @ X3 ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_equal2
thf(fact_6939_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [A2: A,F2: A > B,L6: B] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [S7: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ S7 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X3 ) @ L6 ) @ R2 ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% metric_LIM_I
thf(fact_6940_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L6: B,A2: A,R: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X4: A] :
                    ( ( ( X4 != A2 )
                      & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A2 ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X4 ) @ L6 ) @ R ) ) ) ) ) ) ).

% metric_LIM_D
thf(fact_6941_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L6: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X: A] :
                        ( ( ( X != A2 )
                          & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ A2 ) @ S6 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X ) @ L6 ) @ R5 ) ) ) ) ) ) ) ).

% LIM_def
thf(fact_6942_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A,L6: A,R: real] :
          ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No3: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N7 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X6 @ N7 ) @ L6 ) @ R ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_6943_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A,L6: A] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X6 @ N3 ) @ L6 ) @ R2 ) ) )
         => ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_6944_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A,L6: A] :
          ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N: nat] :
                    ( ( ord_less_eq @ nat @ No @ N )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X6 @ N ) @ L6 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_6945_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [J2: nat] :
            ? [M8: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ M8 @ M3 )
             => ! [N: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ N )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J2 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_6946_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D4: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D4 ) )
                     => ( ( F2 @ X3 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X: A] : ( G @ ( F2 @ X ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_compose2
thf(fact_6947_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_bot @ real ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( times_times @ real @ ( F2 @ X ) @ ( G @ X ) )
            @ ( at_bot @ real )
            @ F3 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_6948_tendsto__at__botI__sequentially,axiom,
    ! [B: $tType] :
      ( ( topolo3112930676232923870pology @ B )
     => ! [F2: real > B,Y2: B] :
          ( ! [X16: nat > real] :
              ( ( filterlim @ nat @ real @ X16 @ ( at_bot @ real ) @ ( at_top @ nat ) )
             => ( filterlim @ nat @ B
                @ ^ [N: nat] : ( F2 @ ( X16 @ N ) )
                @ ( topolo7230453075368039082e_nhds @ B @ Y2 )
                @ ( at_top @ nat ) ) )
         => ( filterlim @ real @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ Y2 ) @ ( at_bot @ real ) ) ) ) ).

% tendsto_at_botI_sequentially
thf(fact_6949_filterlim__inverse__at__bot__neg,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_lessThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_bot_neg
thf(fact_6950_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F3 )
     => ( ( eventually @ A
          @ ^ [X: A] : ( ord_less @ real @ ( F2 @ X ) @ ( zero_zero @ real ) )
          @ F3 )
       => ( filterlim @ A @ real @ F2 @ ( at_bot @ real ) @ F3 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
thf(fact_6951_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F3: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F3 )
          = ( ! [Z7: B] :
                ( ( ord_less @ B @ Z7 @ C2 )
               => ( eventually @ A
                  @ ^ [X: A] : ( ord_less_eq @ B @ ( F2 @ X ) @ Z7 )
                  @ F3 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_6952_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ D ) )
     => ! [A2: A,F2: A > C,G: C > D,L2: D] :
          ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ C @ D @ G @ ( topolo7230453075368039082e_nhds @ D @ L2 ) @ ( topolo174197925503356063within @ C @ ( F2 @ A2 ) @ ( top_top @ ( set @ C ) ) ) )
           => ( ? [D4: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D4 ) )
                     => ( ( F2 @ X3 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ D
                @ ^ [X: A] : ( G @ ( F2 @ X ) )
                @ ( topolo7230453075368039082e_nhds @ D @ L2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_isCont_LIM_compose2
thf(fact_6953_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
     => ( ( eventually @ A
          @ ^ [X: A] : ( ord_less @ real @ ( F2 @ X ) @ ( zero_zero @ real ) )
          @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X: A] : ( inverse_inverse @ real @ ( F2 @ X ) )
          @ ( at_bot @ real )
          @ F3 ) ) ) ).

% filterlim_inverse_at_bot
thf(fact_6954_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X: A] : ( times_times @ real @ ( F2 @ X ) @ ( G @ X ) )
            @ ( at_bot @ real )
            @ F3 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_6955_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A,L6: A] :
          ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No )
                    & ! [N: nat] :
                        ( ( ord_less_eq @ nat @ No @ N )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X6 @ N ) @ L6 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_6956_lhopital__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F6: real > real,G5: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_bot
thf(fact_6957_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X3: real] :
          ( ( ord_less_eq @ real @ X3 @ B2 )
         => ? [Y4: real] :
              ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_6958_filterlim__pow__at__bot__odd,axiom,
    ! [N2: nat,F2: real > real,F3: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F3 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( filterlim @ real @ real
            @ ^ [X: real] : ( power_power @ real @ ( F2 @ X ) @ N2 )
            @ ( at_bot @ real )
            @ F3 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_6959_lhopital__left__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F6: real > real,G5: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_bot
thf(fact_6960_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_6961_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu2: set @ A] :
                  ? [F4: ( set @ A ) > A] :
                    ( ( Uu2
                      = ( image @ ( set @ A ) @ A @ F4 @ A3 ) )
                    & ! [X: set @ A] :
                        ( ( member @ ( set @ A ) @ X @ A3 )
                       => ( member @ A @ ( F4 @ X ) @ X ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_6962_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S8: set @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [K3: set @ A] :
                  ( ( finite_finite @ A @ K3 )
                  & ( ord_less_eq @ ( set @ A ) @ S8
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X: A] :
                            ( collect @ A
                            @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E3 ) )
                        @ K3 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_6963_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F4: A > B,F9: filter @ A] :
            ? [Y: B,K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F4 @ X ) @ Y ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_6964_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( bfun @ A @ B @ F2 @ F3 )
         => ~ ! [B9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B9 )
               => ~ ( eventually @ A
                    @ ^ [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) @ B9 )
                    @ F3 ) ) ) ) ).

% BfunE
thf(fact_6965_Bseq__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ A @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A
              @ ^ [X: nat] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_mult
thf(fact_6966_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A
            @ ^ [X: nat] : ( plus_plus @ A @ ( F2 @ X ) @ C2 )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_add_iff
thf(fact_6967_Bseq__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X: nat] : ( plus_plus @ A @ ( F2 @ X ) @ C2 )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_add
thf(fact_6968_Bseq__minus__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A
            @ ^ [N: nat] : ( uminus_uminus @ A @ ( X6 @ N ) )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) ) ) ) ).

% Bseq_minus_iff
thf(fact_6969_Bseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( bfun @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_Suc_iff
thf(fact_6970_Bseq__subseq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > nat] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X: nat] : ( F2 @ ( G @ X ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_subseq
thf(fact_6971_Cauchy__Bseq,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A] :
          ( ( topolo3814608138187158403Cauchy @ A @ X6 )
         => ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) ) ) ) ).

% Cauchy_Bseq
thf(fact_6972_Bseq__conv__Bfun,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) ) ) ) ).

% Bseq_conv_Bfun
thf(fact_6973_Bseq__offset,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A,K: nat] :
          ( ( bfun @ nat @ A
            @ ^ [N: nat] : ( X6 @ ( plus_plus @ nat @ N @ K ) )
            @ ( at_top @ nat ) )
         => ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) ) ) ) ).

% Bseq_offset
thf(fact_6974_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X6: nat > A,K: nat] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [N: nat] : ( X6 @ ( plus_plus @ nat @ N @ K ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_ignore_initial_segment
thf(fact_6975_Bfun__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [C2: B,F3: filter @ A] :
          ( bfun @ A @ B
          @ ^ [Uu2: A] : C2
          @ F3 ) ) ).

% Bfun_const
thf(fact_6976_BseqI_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A,K5: real] :
          ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X6 @ N3 ) ) @ K5 )
         => ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) ) ) ) ).

% BseqI'
thf(fact_6977_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X: nat] : ( times_times @ A @ C2 @ ( F2 @ X ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_6978_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: nat > A,G: nat > B] :
          ( ( eventually @ nat
            @ ^ [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ N ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_6979_Bseq__eq__bounded,axiom,
    ! [F2: nat > real,A2: real,B2: real] :
      ( ( ord_less_eq @ ( set @ real ) @ ( image @ nat @ real @ F2 @ ( top_top @ ( set @ nat ) ) ) @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
     => ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ).

% Bseq_eq_bounded
thf(fact_6980_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
         => ? [K10: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
              & ! [N7: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X6 @ N7 ) ) @ K10 ) ) ) ) ).

% BseqD
thf(fact_6981_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
         => ~ ! [K10: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
               => ~ ! [N7: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X6 @ N7 ) ) @ K10 ) ) ) ) ).

% BseqE
thf(fact_6982_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K5: real,X6: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
         => ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X6 @ N3 ) ) @ K5 )
           => ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_6983_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
          = ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X6 @ N ) ) @ K6 ) ) ) ) ) ).

% Bseq_def
thf(fact_6984_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( X6 @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff1a
thf(fact_6985_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X6 @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_6986_Bseq__realpow,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X2 ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_6987_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,K5: real,F3: filter @ A] :
          ( ( eventually @ A
            @ ^ [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) @ K5 )
            @ F3 )
         => ( bfun @ A @ B @ F2 @ F3 ) ) ) ).

% BfunI
thf(fact_6988_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [X: A] :
                  ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X6 @ N ) @ ( uminus_uminus @ A @ X ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_6989_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [N6: nat] :
                  ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X6 @ N ) @ ( uminus_uminus @ A @ ( X6 @ N6 ) ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_6990_Bfun__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( bfun @ B @ A
              @ ^ [X: B] : ( inverse_inverse @ A @ ( F2 @ X ) )
              @ F3 ) ) ) ) ).

% Bfun_inverse
thf(fact_6991_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F4: A > B,F9: filter @ A] :
            ? [K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F4 @ X ) ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_def
thf(fact_6992_tendsto__exp__limit__at__right,axiom,
    ! [X2: real] :
      ( filterlim @ real @ real
      @ ^ [Y: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X2 @ Y ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X2 ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_6993_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_6994_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I ) ) ) ).

% greaterThan_iff
thf(fact_6995_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X2 ) @ ( set_ord_greaterThan @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% greaterThan_subset_iff
thf(fact_6996_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X2 ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_6997_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L: A] : ( collect @ A @ ( ord_less @ A @ L ) ) ) ) ) ).

% greaterThan_def
thf(fact_6998_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ X2 @ B3 )
                & ! [Y: A] :
                    ( ( ord_less @ A @ X2 @ Y )
                   => ( ( ord_less @ A @ Y @ B3 )
                     => ( P @ Y ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_6999_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X2: A,Y2: A,P: A > $o] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ X2 @ B3 )
                  & ! [Y: A] :
                      ( ( ord_less @ A @ X2 @ Y )
                     => ( ( ord_less @ A @ Y @ B3 )
                       => ( P @ Y ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_7000_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_7001_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X2: A] : ( eventually @ A @ ( ord_less @ A @ X2 ) @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) ) ) ) ).

% eventually_at_right_less
thf(fact_7002_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ? [A6: A,B6: A] :
              ( ( member @ A @ X2 @ ( set_ord_lessThan @ A @ A6 ) )
              & ( member @ A @ Y2 @ ( set_ord_greaterThan @ A @ B6 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A6 ) @ ( set_ord_greaterThan @ A @ B6 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_7003_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_7004_filterlim__split__at__real,axiom,
    ! [B: $tType,F2: real > B,F3: filter @ B,X2: real] :
      ( ( filterlim @ real @ B @ F2 @ F3 @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
     => ( ( filterlim @ real @ B @ F2 @ F3 @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
       => ( filterlim @ real @ B @ F2 @ F3 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% filterlim_split_at_real
thf(fact_7005_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: real > A,F3: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F2 @ F3 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X: real] : ( F2 @ ( plus_plus @ real @ X @ A2 ) )
        @ F3
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_7006_eventually__at__right__to__0,axiom,
    ! [P: real > $o,A2: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X: real] : ( P @ ( plus_plus @ real @ X @ A2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_7007_filterlim__at__left__to__right,axiom,
    ! [A: $tType,F2: real > A,F3: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F2 @ F3 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X: real] : ( F2 @ ( uminus_uminus @ real @ X ) )
        @ F3
        @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ A2 ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ A2 ) ) ) ) ) ).

% filterlim_at_left_to_right
thf(fact_7008_eventually__at__left__to__right,axiom,
    ! [P: real > $o,A2: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X: real] : ( P @ ( uminus_uminus @ real @ X ) )
        @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ A2 ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ A2 ) ) ) ) ) ).

% eventually_at_left_to_right
thf(fact_7009_eventually__at__right__real,axiom,
    ! [A2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( eventually @ real
        @ ^ [X: real] : ( member @ real @ X @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ).

% eventually_at_right_real
thf(fact_7010_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: B > A,P2: A,F13: filter @ B,C2: A,L2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ P2 @ ( set_ord_greaterThan @ A @ P2 ) ) @ F13 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L2
                = ( times_times @ A @ C2 @ P2 ) )
             => ( filterlim @ B @ A
                @ ^ [X: B] : ( times_times @ A @ C2 @ ( F2 @ X ) )
                @ ( topolo174197925503356063within @ A @ L2 @ ( set_ord_greaterThan @ A @ L2 ) )
                @ F13 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_7011_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F2: real > A,F3: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F3 @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( filterlim @ real @ A
        @ ^ [X: real] : ( F2 @ ( inverse_inverse @ real @ X ) )
        @ F3
        @ ( at_top @ real ) ) ) ).

% filterlim_at_right_to_top
thf(fact_7012_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F2: real > A,F3: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F3 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X: real] : ( F2 @ ( inverse_inverse @ real @ X ) )
        @ F3
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_top_to_right
thf(fact_7013_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L6: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ F3 )
         => ( ( eventually @ A
              @ ^ [X: A] : ( ord_less @ B @ L6 @ ( F2 @ X ) )
              @ F3 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L6 @ ( set_ord_greaterThan @ B @ L6 ) ) @ F3 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_7014_filterlim__inverse__at__right__top,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) @ ( at_top @ real ) ).

% filterlim_inverse_at_right_top
thf(fact_7015_filterlim__inverse__at__top__right,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_top_right
thf(fact_7016_eventually__at__top__to__right,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( at_top @ real ) )
      = ( eventually @ real
        @ ^ [X: real] : ( P @ ( inverse_inverse @ real @ X ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_top_to_right
thf(fact_7017_eventually__at__right__to__top,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( eventually @ real
        @ ^ [X: real] : ( P @ ( inverse_inverse @ real @ X ) )
        @ ( at_top @ real ) ) ) ).

% eventually_at_right_to_top
thf(fact_7018_ln__at__0,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% ln_at_0
thf(fact_7019_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X3: A,Y3: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y3 )
               => ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B6: A] :
                      ( ( Q @ B6 )
                     => ( ord_less @ A @ A2 @ B6 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_7020_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_7021_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G: A > B,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( G @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X: A] : ( if @ B @ ( ord_less_eq @ A @ X @ A2 ) @ ( G @ X ) @ ( F2 @ X ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_7022_lhopital__right__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F6: real > real,G5: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_top
thf(fact_7023_lhopital__right,axiom,
    ! [F2: real > real,X2: real,G: real > real,G5: real > real,F6: real > real,F3: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] :
                ( ( G @ X )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] :
                  ( ( G5 @ X )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
           => ( ( eventually @ real
                @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
             => ( ( eventually @ real
                  @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_7024_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G5: real > real,F6: real > real,F3: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] :
                ( ( G0 @ X )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] :
                  ( ( G5 @ X )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X: real] : ( has_field_derivative @ real @ F0 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X: real] : ( has_field_derivative @ real @ G0 @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X: real] : ( divide_divide @ real @ ( F0 @ X ) @ ( G0 @ X ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_7025_lhopital__right__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F6: real > real,G5: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_bot
thf(fact_7026_lhopital__right__at__top,axiom,
    ! [G: real > real,X2: real,G5: real > real,F2: real > real,F6: real > real,Y2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
     => ( ( eventually @ real
          @ ^ [X: real] :
              ( ( G5 @ X )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_7027_lhopital__right__0__at__top,axiom,
    ! [G: real > real,G5: real > real,F2: real > real,F6: real > real,X2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X: real] :
              ( ( G5 @ X )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X: real] : ( has_field_derivative @ real @ G @ ( G5 @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F6 @ X ) @ ( G5 @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X: real] : ( divide_divide @ real @ ( F2 @ X ) @ ( G @ X ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_7028_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S: set @ A] :
          ( ! [A6: A,B6: A,X3: A] :
              ( ( member @ A @ A6 @ S )
             => ( ( member @ A @ B6 @ S )
               => ( ( ord_less_eq @ A @ A6 @ X3 )
                 => ( ( ord_less_eq @ A @ X3 @ B6 )
                   => ( member @ A @ X3 @ S ) ) ) ) )
         => ? [A6: A,B6: A] :
              ( ( S
                = ( bot_bot @ ( set @ A ) ) )
              | ( S
                = ( top_top @ ( set @ A ) ) )
              | ( S
                = ( set_ord_lessThan @ A @ B6 ) )
              | ( S
                = ( set_ord_atMost @ A @ B6 ) )
              | ( S
                = ( set_ord_greaterThan @ A @ A6 ) )
              | ( S
                = ( set_ord_atLeast @ A @ A6 ) )
              | ( S
                = ( set_or5935395276787703475ssThan @ A @ A6 @ B6 ) )
              | ( S
                = ( set_or3652927894154168847AtMost @ A @ A6 @ B6 ) )
              | ( S
                = ( set_or7035219750837199246ssThan @ A @ A6 @ B6 ) )
              | ( S
                = ( set_or1337092689740270186AtMost @ A @ A6 @ B6 ) ) ) ) ) ).

% interval_cases
thf(fact_7029_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ! [F5: nat > A] :
                ( ! [N7: nat] : ( ord_less @ A @ A2 @ ( F5 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ A @ ( F5 @ N7 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F5 )
                   => ( ( filterlim @ nat @ A @ F5 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N: nat] : ( P @ ( F5 @ N ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_7030_atLeast__0,axiom,
    ( ( set_ord_atLeast @ nat @ ( zero_zero @ nat ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% atLeast_0
thf(fact_7031_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I ) ) ) ).

% atLeast_iff
thf(fact_7032_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X2 ) @ ( set_ord_atLeast @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% atLeast_subset_iff
thf(fact_7033_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_ord_atLeast @ A @ I ) )
          = ( set_ord_atLeast @ A @ ( plus_plus @ A @ K @ I ) ) ) ) ).

% image_add_atLeast
thf(fact_7034_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L2: A,H2: A,L4: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ H2 ) @ ( set_ord_atLeast @ A @ L4 ) )
          = ( ~ ( ord_less_eq @ A @ L2 @ H2 )
            | ( ord_less_eq @ A @ L4 @ L2 ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_7035_image__minus__const__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_ord_atLeast @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( minus_minus @ A @ C2 @ A2 ) ) ) ) ).

% image_minus_const_atLeast
thf(fact_7036_image__minus__const__AtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_ord_atMost @ A @ B2 ) )
          = ( set_ord_atLeast @ A @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% image_minus_const_AtMost
thf(fact_7037_atLeast__Suc__greaterThan,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( set_ord_greaterThan @ nat @ K ) ) ).

% atLeast_Suc_greaterThan
thf(fact_7038_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L: A] : ( collect @ A @ ( ord_less_eq @ A @ L ) ) ) ) ) ).

% atLeast_def
thf(fact_7039_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X2 ) ) ) ) ) ).

% antimonoD
thf(fact_7040_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X2 ) ) ) ) ) ).

% antimonoE
thf(fact_7041_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y3: A] :
              ( ( ord_less_eq @ A @ X3 @ Y3 )
             => ( ord_less_eq @ B @ ( F2 @ Y3 ) @ ( F2 @ X3 ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_7042_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F4: A > B] :
            ! [X: A,Y: A] :
              ( ( ord_less_eq @ A @ X @ Y )
             => ( ord_less_eq @ B @ ( F4 @ Y ) @ ( F4 @ X ) ) ) ) ) ) ).

% antimono_def
thf(fact_7043_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F4: nat > A] :
            ! [N: nat] : ( ord_less_eq @ A @ ( F4 @ ( suc @ N ) ) @ ( F4 @ N ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_7044_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X6: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X6 @ ( suc @ N3 ) ) @ ( X6 @ N3 ) )
         => ( order_antimono @ nat @ A @ X6 ) ) ) ).

% decseq_SucI
thf(fact_7045_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I: nat] :
          ( ( order_antimono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ ( suc @ I ) ) @ ( A3 @ I ) ) ) ) ).

% decseq_SucD
thf(fact_7046_decseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I: nat,J: nat] :
          ( ( order_antimono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ord_less_eq @ A @ ( F2 @ J ) @ ( F2 @ I ) ) ) ) ) ).

% decseqD
thf(fact_7047_decseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X8: nat > A] :
            ! [M3: nat,N: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N )
             => ( ord_less_eq @ A @ ( X8 @ N ) @ ( X8 @ M3 ) ) ) ) ) ) ).

% decseq_def
thf(fact_7048_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_7049_decseq__bounded,axiom,
    ! [X6: nat > real,B4: real] :
      ( ( order_antimono @ nat @ real @ X6 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ B4 @ ( X6 @ I4 ) )
       => ( bfun @ nat @ real @ X6 @ ( at_top @ nat ) ) ) ) ).

% decseq_bounded
thf(fact_7050_greaterThan__0,axiom,
    ( ( set_ord_greaterThan @ nat @ ( zero_zero @ nat ) )
    = ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ).

% greaterThan_0
thf(fact_7051_decseq__ge,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X6: nat > A,L6: A,N2: nat] :
          ( ( order_antimono @ nat @ A @ X6 )
         => ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ L6 @ ( X6 @ N2 ) ) ) ) ) ).

% decseq_ge
thf(fact_7052_greaterThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_greaterThan @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_greaterThan @ nat @ K ) @ ( insert @ nat @ ( suc @ K ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% greaterThan_Suc
thf(fact_7053_decseq__convergent,axiom,
    ! [X6: nat > real,B4: real] :
      ( ( order_antimono @ nat @ real @ X6 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ B4 @ ( X6 @ I4 ) )
       => ~ ! [L7: real] :
              ( ( filterlim @ nat @ real @ X6 @ ( topolo7230453075368039082e_nhds @ real @ L7 ) @ ( at_top @ nat ) )
             => ~ ! [I2: nat] : ( ord_less_eq @ real @ L7 @ ( X6 @ I2 ) ) ) ) ) ).

% decseq_convergent
thf(fact_7054_atLeast__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atLeast @ nat @ K ) @ ( insert @ nat @ K @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast_Suc
thf(fact_7055_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: B,B2: B,X6: B > C,L6: C] :
          ( ( ord_less @ B @ A2 @ B2 )
         => ( ! [S5: nat > B] :
                ( ! [N7: nat] : ( ord_less @ B @ A2 @ ( S5 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ B @ ( S5 @ N7 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S5 )
                   => ( ( filterlim @ nat @ B @ S5 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N: nat] : ( X6 @ ( S5 @ N ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L6 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X6 @ ( topolo7230453075368039082e_nhds @ C @ L6 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_greaterThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_7056_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F4: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X: A,Y: A] :
                  ( ( ord_less @ nat @ ( F4 @ X ) @ ( F4 @ Y ) )
                  | ( ( ord_less_eq @ nat @ ( F4 @ X ) @ ( F4 @ Y ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_7057_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( ( real_V768167426530841204y_dist @ A )
        & ( topolo7287701948861334536_space @ A ) )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F9: filter @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [P6: A > $o] :
                  ( ( eventually @ A @ P6 @ F9 )
                  & ! [X: A,Y: A] :
                      ( ( ( P6 @ X )
                        & ( P6 @ Y ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric
thf(fact_7058_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P4: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A4: int,C3: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D2: int] : ( ord_less @ int @ ( times_times @ int @ A4 @ D2 ) @ ( times_times @ int @ C3 @ B3 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P4 ) ) ) ) ).

% rat_less_code
thf(fact_7059_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P4: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A4: int,C3: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D2: int] : ( ord_less_eq @ int @ ( times_times @ int @ A4 @ D2 ) @ ( times_times @ int @ C3 @ B3 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P4 ) ) ) ) ).

% rat_less_eq_code
thf(fact_7060_mlex__leq,axiom,
    ! [A: $tType,F2: A > nat,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( mlex_prod @ A @ F2 @ R3 ) ) ) ) ).

% mlex_leq
thf(fact_7061_mlex__less,axiom,
    ! [A: $tType,F2: A > nat,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( mlex_prod @ A @ F2 @ R3 ) ) ) ).

% mlex_less
thf(fact_7062_mlex__iff,axiom,
    ! [A: $tType,X2: A,Y2: A,F2: A > nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( mlex_prod @ A @ F2 @ R3 ) )
      = ( ( ord_less @ nat @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
        | ( ( ( F2 @ X2 )
            = ( F2 @ Y2 ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ).

% mlex_iff
thf(fact_7063_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D2: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z8: int,Z5: int] :
                ( ( ord_less_eq @ int @ D2 @ Z5 )
                & ( ord_less @ int @ Z8 @ Z5 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_7064_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D2: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z8: int,Z5: int] :
                ( ( ord_less_eq @ int @ D2 @ Z8 )
                & ( ord_less @ int @ Z8 @ Z5 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_7065_in__measure,axiom,
    ! [A: $tType,X2: A,Y2: A,F2: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( measure @ A @ F2 ) )
      = ( ord_less @ nat @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ).

% in_measure
thf(fact_7066_GMVT,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X3 )
              & ( ord_less_eq @ real @ X3 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ( ! [X3: real] :
              ( ( ( ord_less @ real @ A2 @ X3 )
                & ( ord_less @ real @ X3 @ B2 ) )
             => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ G ) )
           => ( ! [X3: real] :
                  ( ( ( ord_less @ real @ A2 @ X3 )
                    & ( ord_less @ real @ X3 @ B2 ) )
                 => ( differentiable @ real @ real @ G @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C4: real] :
                  ( ( has_field_derivative @ real @ G @ G_c @ ( topolo174197925503356063within @ real @ C4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F2 @ F_c @ ( topolo174197925503356063within @ real @ C4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C4 )
                  & ( ord_less @ real @ C4 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_7067_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q2: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ C2 @ ( Q2 @ T3 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_7068_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q2: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ ( Q2 @ T3 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_7069_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,T2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
           => ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ) ).

% differentiable_within_subset
thf(fact_7070_differentiable__in__compose,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: C > A,X2: C,S2: set @ C] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( image @ C @ A @ G @ S2 ) ) )
         => ( ( differentiable @ C @ A @ G @ ( topolo174197925503356063within @ C @ X2 @ S2 ) )
           => ( differentiable @ C @ B
              @ ^ [X: C] : ( F2 @ ( G @ X ) )
              @ ( topolo174197925503356063within @ C @ X2 @ S2 ) ) ) ) ) ).

% differentiable_in_compose
thf(fact_7071_differentiable__compose,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: C > A,X2: C,S2: set @ C] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( differentiable @ C @ A @ G @ ( topolo174197925503356063within @ C @ X2 @ S2 ) )
           => ( differentiable @ C @ B
              @ ^ [X: C] : ( F2 @ ( G @ X ) )
              @ ( topolo174197925503356063within @ C @ X2 @ S2 ) ) ) ) ) ).

% differentiable_compose
thf(fact_7072_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,N2: nat] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( differentiable @ A @ B
            @ ^ [X: A] : ( power_power @ B @ ( F2 @ X ) @ N2 )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% differentiable_power
thf(fact_7073_differentiable__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [S2: set @ A,F2: A > B > C,Net: filter @ B] :
          ( ( finite_finite @ A @ S2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( differentiable @ B @ C @ ( F2 @ X3 ) @ Net ) )
           => ( differentiable @ B @ C
              @ ^ [X: B] :
                  ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [A4: A] : ( F2 @ A4 @ X )
                  @ S2 )
              @ Net ) ) ) ) ).

% differentiable_sum
thf(fact_7074_differentiable__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( differentiable @ A @ B )
        = ( ^ [F4: A > B,F9: filter @ A] :
            ? [D7: A > B] : ( has_derivative @ A @ B @ F4 @ D7 @ F9 ) ) ) ) ).

% differentiable_def
thf(fact_7075_differentiable__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F3: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ F3 )
         => ( ( differentiable @ A @ B @ G @ F3 )
           => ( differentiable @ A @ B
              @ ^ [X: A] : ( minus_minus @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ F3 ) ) ) ) ).

% differentiable_diff
thf(fact_7076_differentiable__ident,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: filter @ A] :
          ( differentiable @ A @ A
          @ ^ [X: A] : X
          @ F3 ) ) ).

% differentiable_ident
thf(fact_7077_differentiable__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: B,F3: filter @ A] :
          ( differentiable @ A @ B
          @ ^ [Z5: A] : A2
          @ F3 ) ) ).

% differentiable_const
thf(fact_7078_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F3: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ F3 )
         => ( ( differentiable @ A @ B @ G @ F3 )
           => ( differentiable @ A @ B
              @ ^ [X: A] : ( plus_plus @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ F3 ) ) ) ) ).

% differentiable_add
thf(fact_7079_differentiable__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( differentiable @ A @ B @ F2 @ F3 )
         => ( differentiable @ A @ B
            @ ^ [X: A] : ( uminus_uminus @ B @ ( F2 @ X ) )
            @ F3 ) ) ) ).

% differentiable_minus
thf(fact_7080_real__differentiable__def,axiom,
    ! [F2: real > real,X2: real,S2: set @ real] :
      ( ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X2 @ S2 ) )
      = ( ? [D7: real] : ( has_field_derivative @ real @ F2 @ D7 @ ( topolo174197925503356063within @ real @ X2 @ S2 ) ) ) ) ).

% real_differentiable_def
thf(fact_7081_real__differentiableE,axiom,
    ! [F2: real > real,X2: real,S2: set @ real] :
      ( ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X2 @ S2 ) )
     => ~ ! [Df2: real] :
            ~ ( has_field_derivative @ real @ F2 @ Df2 @ ( topolo174197925503356063within @ real @ X2 @ S2 ) ) ) ).

% real_differentiableE
thf(fact_7082_differentiable__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > real,X2: A,S2: set @ A,G: A > B] :
          ( ( differentiable @ A @ real @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( differentiable @ A @ B
              @ ^ [X: A] : ( real_V8093663219630862766scaleR @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% differentiable_scaleR
thf(fact_7083_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( differentiable @ A @ B
              @ ^ [X: A] : ( times_times @ B @ ( F2 @ X ) @ ( G @ X ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% differentiable_mult
thf(fact_7084_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X: A] : ( divide_divide @ B @ ( F2 @ X ) @ ( G @ X ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_7085_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X: A] : ( inverse_inverse @ B @ ( F2 @ X ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% differentiable_inverse
thf(fact_7086_at__within__order,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X2: A,S2: set @ A] :
          ( ( ( top_top @ ( set @ A ) )
           != ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ( topolo174197925503356063within @ A @ X2 @ S2 )
            = ( inf_inf @ ( filter @ A )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A4: A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A4 ) @ S2 ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  @ ( set_ord_greaterThan @ A @ X2 ) ) )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A4: A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A4 ) @ S2 ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  @ ( set_ord_lessThan @ A @ X2 ) ) ) ) ) ) ) ).

% at_within_order
thf(fact_7087_MVT,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L3: real,Z3: real] :
              ( ( ord_less @ real @ A2 @ Z3 )
              & ( ord_less @ real @ Z3 @ B2 )
              & ( has_field_derivative @ real @ F2 @ L3 @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L3 ) ) ) ) ) ) ).

% MVT
thf(fact_7088_DERIV__continuous__on,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S2: set @ A,F2: A > A,D6: A > A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ S2 )
             => ( has_field_derivative @ A @ F2 @ ( D6 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ S2 @ F2 ) ) ) ).

% DERIV_continuous_on
thf(fact_7089_continuous__on__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo5987344860129210374id_add @ C ) )
     => ! [I5: set @ A,S: set @ B,F2: A > B > C] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I5 )
             => ( topolo81223032696312382ous_on @ B @ C @ S @ ( F2 @ I4 ) ) )
         => ( topolo81223032696312382ous_on @ B @ C @ S
            @ ^ [X: B] :
                ( groups7311177749621191930dd_sum @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ I5 ) ) ) ) ).

% continuous_on_sum
thf(fact_7090_continuous__on__powr,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S2: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ G )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ S2 )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ real ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S2
                @ ^ [X: C] : ( powr @ real @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% continuous_on_powr
thf(fact_7091_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A3: set @ C,F2: C > B,G: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A3 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A3 @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ A3
              @ ^ [X: C] : ( power_power @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_7092_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S2: set @ C,F2: C > B,N2: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S2
            @ ^ [X: C] : ( power_power @ B @ ( F2 @ X ) @ N2 ) ) ) ) ).

% continuous_on_power
thf(fact_7093_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S2
              @ ^ [X: A] : ( sgn_sgn @ B @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_on_sgn
thf(fact_7094_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S2
              @ ^ [X: A] : ( inverse_inverse @ B @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_on_inverse
thf(fact_7095_continuous__on__minus,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [S2: set @ C,F2: C > B] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S2
            @ ^ [X: C] : ( uminus_uminus @ B @ ( F2 @ X ) ) ) ) ) ).

% continuous_on_minus
thf(fact_7096_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [S2: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S2 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S2
              @ ^ [X: D] : ( plus_plus @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_on_add
thf(fact_7097_continuous__on__rabs,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S2
            @ ^ [X: A] : ( abs_abs @ real @ ( F2 @ X ) ) ) ) ) ).

% continuous_on_rabs
thf(fact_7098_continuous__on__prod,axiom,
    ! [A: $tType,C: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ C )
        & ( comm_ring_1 @ C ) )
     => ! [S: set @ A,S2: set @ D,F2: A > D > C] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ S )
             => ( topolo81223032696312382ous_on @ D @ C @ S2 @ ( F2 @ I4 ) ) )
         => ( topolo81223032696312382ous_on @ D @ C @ S2
            @ ^ [X: D] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ S ) ) ) ) ).

% continuous_on_prod
thf(fact_7099_continuous__on__prod_H,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4987421752381908075d_mult @ C ) )
     => ! [I5: set @ A,S: set @ B,F2: A > B > C] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I5 )
             => ( topolo81223032696312382ous_on @ B @ C @ S @ ( F2 @ I4 ) ) )
         => ( topolo81223032696312382ous_on @ B @ C @ S
            @ ^ [X: B] :
                ( groups7121269368397514597t_prod @ A @ C
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ I5 ) ) ) ) ).

% continuous_on_prod'
thf(fact_7100_continuous__on__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S2
            @ ^ [X: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) ) ) ) ).

% continuous_on_norm
thf(fact_7101_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S2
            @ ^ [X: A] : ( sqrt @ ( F2 @ X ) ) ) ) ) ).

% continuous_on_real_sqrt
thf(fact_7102_continuous__on__of__real,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [S2: set @ C,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ G )
         => ( topolo81223032696312382ous_on @ C @ A @ S2
            @ ^ [X: C] : ( real_Vector_of_real @ A @ ( G @ X ) ) ) ) ) ).

% continuous_on_of_real
thf(fact_7103_continuous__on__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [S2: set @ D,F2: D > real,G: D > C] :
          ( ( topolo81223032696312382ous_on @ D @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ C @ S2 @ G )
           => ( topolo81223032696312382ous_on @ D @ C @ S2
              @ ^ [X: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_on_scaleR
thf(fact_7104_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real,N2: nat] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S2
            @ ^ [X: A] : ( root @ N2 @ ( F2 @ X ) ) ) ) ) ).

% continuous_on_real_root
thf(fact_7105_continuous__on__norm__id,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S: set @ A] : ( topolo81223032696312382ous_on @ A @ real @ S @ ( real_V7770717601297561774m_norm @ A ) ) ) ).

% continuous_on_norm_id
thf(fact_7106_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [S2: set @ A,C2: A] : ( topolo81223032696312382ous_on @ A @ A @ S2 @ ( times_times @ A @ C2 ) ) ) ).

% continuous_on_mult_const
thf(fact_7107_continuous__on__op__minus,axiom,
    ! [A: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [S2: set @ A,X2: A] : ( topolo81223032696312382ous_on @ A @ A @ S2 @ ( minus_minus @ A @ X2 ) ) ) ).

% continuous_on_op_minus
thf(fact_7108_continuous__on__diff,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [S2: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S2 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S2
              @ ^ [X: D] : ( minus_minus @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_on_diff
thf(fact_7109_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S2: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S2
            @ ^ [X: B] : ( times_times @ A @ ( F2 @ X ) @ C2 ) ) ) ) ).

% continuous_on_mult_right
thf(fact_7110_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S2: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S2
            @ ^ [X: B] : ( times_times @ A @ C2 @ ( F2 @ X ) ) ) ) ) ).

% continuous_on_mult_left
thf(fact_7111_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [A3: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ A3
              @ ^ [X: D] : ( times_times @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_on_mult'
thf(fact_7112_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S2: set @ D,F2: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S2 @ G )
           => ( topolo81223032696312382ous_on @ D @ A @ S2
              @ ^ [X: D] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_on_mult
thf(fact_7113_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S2: set @ A,F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ G )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                 => ( ( G @ X3 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S2
                @ ^ [X: A] : ( divide_divide @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_7114_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ real ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S2
              @ ^ [X: A] : ( ln_ln @ real @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_on_ln
thf(fact_7115_bounded__linear_Ocontinuous__on,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > B,S2: set @ C,G: C > A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S2 @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ S2
              @ ^ [X: C] : ( F2 @ ( G @ X ) ) ) ) ) ) ).

% bounded_linear.continuous_on
thf(fact_7116_continuous__on__dist,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [S2: set @ D,F2: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S2 @ G )
           => ( topolo81223032696312382ous_on @ D @ real @ S2
              @ ^ [X: D] : ( real_V557655796197034286t_dist @ A @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ).

% continuous_on_dist
thf(fact_7117_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y2: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT'
thf(fact_7118_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y2: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_7119_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F2 @ A3 ) )
         => ( ! [X3: A,Y3: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ( member @ A @ Y3 @ A3 )
                 => ( ( ord_less_eq @ A @ X3 @ Y3 )
                   => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A3 @ F2 ) ) ) ) ).

% continuous_onI_mono
thf(fact_7120_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X: A] : ( ord_less @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_7121_tendsto__at__iff__tendsto__nhds__within,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: B > A,X2: B,Y2: A,S2: set @ B] :
          ( ( ( F2 @ X2 )
            = Y2 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ ( topolo174197925503356063within @ B @ X2 @ S2 ) )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ ( inf_inf @ ( filter @ B ) @ ( topolo7230453075368039082e_nhds @ B @ X2 ) @ ( principal @ B @ S2 ) ) ) ) ) ) ).

% tendsto_at_iff_tendsto_nhds_within
thf(fact_7122_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( cos @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S2
              @ ^ [X: A] : ( tan @ A @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_on_tan
thf(fact_7123_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ G )
           => ? [A8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ A8 )
                & ( ( inf_inf @ ( set @ A ) @ A8 @ S2 )
                  = ( collect @ A
                    @ ^ [X: A] :
                        ( ( member @ A @ X @ S2 )
                        & ( ord_less @ real @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ) ) ).

% open_Collect_less_Int
thf(fact_7124_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( sin @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S2
              @ ^ [X: A] : ( cot @ A @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_on_cot
thf(fact_7125_continuous__on__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A3 @ F2 )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ A3 )
               => ( ( cosh @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ C @ A @ A3
              @ ^ [X: C] : ( tanh @ A @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_on_tanh
thf(fact_7126_continuous__on__arcosh_H,axiom,
    ! [A3: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F2 )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ A3 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X3 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X: real] : ( arcosh @ real @ ( F2 @ X ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_7127_continuous__image__closed__interval,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ? [C4: real,D5: real] :
            ( ( ( image @ real @ real @ F2 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
              = ( set_or1337092689740270186AtMost @ real @ C4 @ D5 ) )
            & ( ord_less_eq @ real @ C4 @ D5 ) ) ) ) ).

% continuous_image_closed_interval
thf(fact_7128_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ? [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
              & ( ( inf_inf @ ( set @ A ) @ A8 @ S2 )
                = ( collect @ A
                  @ ^ [X: A] :
                      ( ( member @ A @ X @ S2 )
                      & ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% open_Collect_positive
thf(fact_7129_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S2: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ G )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ S2 )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
                    & ( ( ( F2 @ X3 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S2
                @ ^ [X: C] : ( powr @ real @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_7130_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ G )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( F2 @ X3 )
                     != ( one_one @ real ) ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ S2 )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S2
                    @ ^ [X: A] : ( log @ ( F2 @ X ) @ ( G @ X ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_7131_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S2
              @ ^ [X: A] : ( arccos @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_7132_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S2
              @ ^ [X: A] : ( arcsin @ ( F2 @ X ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_7133_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,B2: A,F2: A > A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ A2 @ X3 )
             => ( ( ord_less_eq @ A @ X3 @ B2 )
               => ? [Y4: A] : ( has_field_derivative @ A @ F2 @ Y4 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_7134_at__left__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( topolo174197925503356063within @ A @ X2 @ ( set_ord_lessThan @ A @ X2 ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A4: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ A4 @ X2 ) )
                @ ( set_ord_lessThan @ A @ X2 ) ) ) ) ) ) ).

% at_left_eq
thf(fact_7135_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A4: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X2 @ A4 ) )
                @ ( set_ord_greaterThan @ A @ X2 ) ) ) ) ) ) ).

% at_right_eq
thf(fact_7136_at__infinity__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( at_infinity @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ real @ ( filter @ A )
            @ ^ [R5: real] :
                ( principal @ A
                @ ( collect @ A
                  @ ^ [X: A] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) )
            @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% at_infinity_def
thf(fact_7137_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F2: real > real,F6: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X3: real] :
                ( ( ord_less @ real @ A2 @ X3 )
               => ( ( ord_less @ real @ X3 @ B2 )
                 => ( has_derivative @ real @ real @ F2 @ ( F6 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
                & ( ord_less @ real @ Z3 @ B2 )
                & ( ( F6 @ Z3 )
                  = ( ^ [V5: real] : ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% Rolle_deriv
thf(fact_7138_mvt,axiom,
    ! [A2: real,B2: real,F2: real > real,F6: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_derivative @ real @ real @ F2 @ ( F6 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A2 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                   != ( F6 @ Xi @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_7139_continuous__on__of__int__floor,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A )
        & ( ring_1 @ B )
        & ( topolo4958980785337419405_space @ B ) )
     => ( topolo81223032696312382ous_on @ A @ B @ ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( ring_1_Ints @ A ) )
        @ ^ [X: A] : ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ A @ X ) ) ) ) ).

% continuous_on_of_int_floor
thf(fact_7140_continuous__on__of__int__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A )
        & ( ring_1 @ B )
        & ( topolo4958980785337419405_space @ B ) )
     => ( topolo81223032696312382ous_on @ A @ B @ ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( ring_1_Ints @ A ) )
        @ ^ [X: A] : ( ring_1_of_int @ B @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% continuous_on_of_int_ceiling
thf(fact_7141_at__within__def,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo174197925503356063within @ A )
        = ( ^ [A4: A,S6: set @ A] : ( inf_inf @ ( filter @ A ) @ ( topolo7230453075368039082e_nhds @ A @ A4 ) @ ( principal @ A @ ( minus_minus @ ( set @ A ) @ S6 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% at_within_def
thf(fact_7142_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_7143_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_7144_nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [X: A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ real @ ( filter @ A )
                @ ^ [E3: real] :
                    ( principal @ A
                    @ ( collect @ A
                      @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X ) @ E3 ) ) )
                @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% nhds_metric
thf(fact_7145_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less @ real @ A2 @ X3 )
           => ( ( ord_less @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ) ).

% DERIV_pos_imp_increasing_open
thf(fact_7146_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less @ real @ A2 @ X3 )
           => ( ( ord_less @ real @ X3 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ) ).

% DERIV_neg_imp_decreasing_open
thf(fact_7147_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( F2 @ B2 )
            = ( F2 @ A2 ) ) ) ) ) ).

% DERIV_isconst_end
thf(fact_7148_at__within__eq,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo174197925503356063within @ A )
        = ( ^ [X: A,S6: set @ A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ ( set @ A ) @ ( filter @ A )
                @ ^ [S8: set @ A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S8 @ S6 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
                @ ( collect @ ( set @ A )
                  @ ^ [S8: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S8 )
                      & ( member @ A @ X @ S8 ) ) ) ) ) ) ) ) ).

% at_within_eq
thf(fact_7149_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F2: real > real,X2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ( ( F2 @ X2 )
                = ( F2 @ A2 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_7150_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,B2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X3: A] :
                  ( ( ord_less @ A @ A2 @ X3 )
                 => ( ( ord_less @ A @ X3 @ B2 )
                   => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X3 ) ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A2 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_7151_Rolle,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X3: real] :
                ( ( ord_less @ real @ A2 @ X3 )
               => ( ( ord_less @ real @ X3 @ B2 )
                 => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
                & ( ord_less @ real @ Z3 @ B2 )
                & ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% Rolle
thf(fact_7152_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs2: list @ A,Ys2: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs2 @ Ys2 ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_7153_eventually__filtercomap__at__topological,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ B )
     => ! [P: A > $o,F2: A > B,A3: B,B4: set @ B] :
          ( ( eventually @ A @ P @ ( filtercomap @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ A3 @ B4 ) ) )
          = ( ? [S8: set @ B] :
                ( ( topolo1002775350975398744n_open @ B @ S8 )
                & ( member @ B @ A3 @ S8 )
                & ! [X: A] :
                    ( ( member @ B @ ( F2 @ X ) @ ( minus_minus @ ( set @ B ) @ ( inf_inf @ ( set @ B ) @ S8 @ B4 ) @ ( insert @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
                   => ( P @ X ) ) ) ) ) ) ).

% eventually_filtercomap_at_topological
thf(fact_7154_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs2: list @ A,Ys2: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys2 ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ) ).

% length_shuffles
thf(fact_7155_eventually__filtercomap__at__top__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_top @ A ) ) )
          = ( ? [N6: A] :
              ! [X: B] :
                ( ( ord_less_eq @ A @ N6 @ ( F2 @ X ) )
               => ( P @ X ) ) ) ) ) ).

% eventually_filtercomap_at_top_linorder
thf(fact_7156_eventually__filtercomap__at__top__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_top @ A ) ) )
          = ( ? [N6: A] :
              ! [X: B] :
                ( ( ord_less @ A @ N6 @ ( F2 @ X ) )
               => ( P @ X ) ) ) ) ) ).

% eventually_filtercomap_at_top_dense
thf(fact_7157_eventually__filtercomap__at__bot__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_bot @ A ) ) )
          = ( ? [N6: A] :
              ! [X: B] :
                ( ( ord_less_eq @ A @ ( F2 @ X ) @ N6 )
               => ( P @ X ) ) ) ) ) ).

% eventually_filtercomap_at_bot_linorder
thf(fact_7158_eventually__filtercomap__at__bot__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_bot @ A ) ) )
          = ( ? [N6: A] :
              ! [X: B] :
                ( ( ord_less @ A @ ( F2 @ X ) @ N6 )
               => ( P @ X ) ) ) ) ) ).

% eventually_filtercomap_at_bot_dense
thf(fact_7159_uniformity__dist,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ A ) )
          @ ( image @ real @ ( filter @ ( product_prod @ A @ A ) )
            @ ^ [E3: real] :
                ( principal @ ( product_prod @ A @ A )
                @ ( collect @ ( product_prod @ A @ A )
                  @ ( product_case_prod @ A @ A @ $o
                    @ ^ [X: A,Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E3 ) ) ) )
            @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ).

% uniformity_dist
thf(fact_7160_LIMSEQ__decseq__INF,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X6: nat > A] :
          ( ( condit1013018076250108175_below @ A @ ( image @ nat @ A @ X6 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_antimono @ nat @ A @ X6 )
           => ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ ( complete_Inf_Inf @ A @ ( image @ nat @ A @ X6 @ ( top_top @ ( set @ nat ) ) ) ) ) @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_decseq_INF
thf(fact_7161_bdd__below_OI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A,M7: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( ord_less_eq @ A @ M7 @ X3 ) )
         => ( condit1013018076250108175_below @ A @ A3 ) ) ) ).

% bdd_below.I
thf(fact_7162_bdd__belowI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( ord_less_eq @ A @ M @ X3 ) )
         => ( condit1013018076250108175_below @ A @ A3 ) ) ) ).

% bdd_belowI
thf(fact_7163_bdd__belowI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ B,M: A,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ M @ ( F2 @ X3 ) ) )
         => ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ).

% bdd_belowI2
thf(fact_7164_bdd__below_OI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ B,M7: A,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ M7 @ ( F2 @ X3 ) ) )
         => ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ).

% bdd_below.I2
thf(fact_7165_bdd__below_OE,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A3 )
         => ~ ! [M9: A] :
                ~ ! [X4: A] :
                    ( ( member @ A @ X4 @ A3 )
                   => ( ord_less_eq @ A @ M9 @ X4 ) ) ) ) ).

% bdd_below.E
thf(fact_7166_bdd__below_Ounfold,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit1013018076250108175_below @ A )
        = ( ^ [A7: set @ A] :
            ? [M8: A] :
            ! [X: A] :
              ( ( member @ A @ X @ A7 )
             => ( ord_less_eq @ A @ M8 @ X ) ) ) ) ) ).

% bdd_below.unfold
thf(fact_7167_cInf__lower2,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X2: A,X6: set @ A,Y2: A] :
          ( ( member @ A @ X2 @ X6 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( condit1013018076250108175_below @ A @ X6 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X6 ) @ Y2 ) ) ) ) ) ).

% cInf_lower2
thf(fact_7168_cInf__lower,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X2: A,X6: set @ A] :
          ( ( member @ A @ X2 @ X6 )
         => ( ( condit1013018076250108175_below @ A @ X6 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X6 ) @ X2 ) ) ) ) ).

% cInf_lower
thf(fact_7169_cINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A3: set @ B,X2: B,U: A] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A3 ) )
         => ( ( member @ B @ X2 @ A3 )
           => ( ( ord_less_eq @ A @ ( F2 @ X2 ) @ U )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U ) ) ) ) ) ).

% cINF_lower2
thf(fact_7170_cINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A3: set @ B,X2: B] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A3 ) )
         => ( ( member @ B @ X2 @ A3 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( F2 @ X2 ) ) ) ) ) ).

% cINF_lower
thf(fact_7171_le__cInf__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S: set @ A,A2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S )
           => ( ( ord_less_eq @ A @ A2 @ ( complete_Inf_Inf @ A @ S ) )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ S )
                   => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ) ) ) ).

% le_cInf_iff
thf(fact_7172_cInf__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( B4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A3 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ B4 )
                 => ? [X4: A] :
                      ( ( member @ A @ X4 @ A3 )
                      & ( ord_less_eq @ A @ X4 @ B6 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ) ) ).

% cInf_mono
thf(fact_7173_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X6: set @ A,Y2: A] :
          ( ( X6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X6 )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X6 ) @ Y2 )
              = ( ? [X: A] :
                    ( ( member @ A @ X @ X6 )
                    & ( ord_less @ A @ X @ Y2 ) ) ) ) ) ) ) ).

% cInf_less_iff
thf(fact_7174_less__cINF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A3: set @ B,Y2: A,I: B] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A3 ) )
         => ( ( ord_less @ A @ Y2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
           => ( ( member @ B @ I @ A3 )
             => ( ord_less @ A @ Y2 @ ( F2 @ I ) ) ) ) ) ) ).

% less_cINF_D
thf(fact_7175_cINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B4: set @ B,F2: C > A,A3: set @ C,G: B > A] :
          ( ( B4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ C @ A @ F2 @ A3 ) )
           => ( ! [M4: B] :
                  ( ( member @ B @ M4 @ B4 )
                 => ? [X4: C] :
                      ( ( member @ C @ X4 @ A3 )
                      & ( ord_less_eq @ A @ ( F2 @ X4 ) @ ( G @ M4 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% cINF_mono
thf(fact_7176_le__cINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,U: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A3 ) )
           => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
              = ( ! [X: B] :
                    ( ( member @ B @ X @ A3 )
                   => ( ord_less_eq @ A @ U @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% le_cINF_iff
thf(fact_7177_cInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ B4 )
           => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ B4 ) @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ) ) ).

% cInf_superset_mono
thf(fact_7178_cINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A3: set @ B,F2: B > A,A2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A3 ) )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ A2 )
              = ( ? [X: B] :
                    ( ( member @ B @ X @ A3 )
                    & ( ord_less @ A @ ( F2 @ X ) @ A2 ) ) ) ) ) ) ) ).

% cINF_less_iff
thf(fact_7179_Cauchy__uniform__iff,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [P6: ( product_prod @ A @ A ) > $o] :
              ( ( eventually @ ( product_prod @ A @ A ) @ P6 @ ( topolo7806501430040627800ormity @ A ) )
             => ? [N6: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N )
                 => ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ M3 )
                     => ( P6 @ ( product_Pair @ A @ A @ ( X8 @ N ) @ ( X8 @ M3 ) ) ) ) ) ) ) ) ) ).

% Cauchy_uniform_iff
thf(fact_7180_cINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ G @ B4 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ B4 )
                   => ( ord_less_eq @ A @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
               => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ) ).

% cINF_superset_mono
thf(fact_7181_less__eq__cInf__inter,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A3 )
         => ( ( condit1013018076250108175_below @ A @ B4 )
           => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% less_eq_cInf_inter
thf(fact_7182_Bseq__bdd__below,axiom,
    ! [X6: nat > real] :
      ( ( bfun @ nat @ real @ X6 @ ( at_top @ nat ) )
     => ( condit1013018076250108175_below @ real @ ( image @ nat @ real @ X6 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Bseq_bdd_below
thf(fact_7183_cInf__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S: set @ A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S )
           => ( ( complete_Inf_Inf @ A @ S )
              = ( complete_Sup_Sup @ A
                @ ( collect @ A
                  @ ^ [X: A] :
                    ! [Y: A] :
                      ( ( member @ A @ Y @ S )
                     => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) ).

% cInf_cSup
thf(fact_7184_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ! [P: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ P @ ( topolo7806501430040627800ormity @ A ) )
          = ( ? [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                & ! [X: A,Y: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E3 )
                   => ( P @ ( product_Pair @ A @ A @ X @ Y ) ) ) ) ) ) ) ).

% eventually_uniformity_metric
thf(fact_7185_uniformity__real__def,axiom,
    ( ( topolo7806501430040627800ormity @ real )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ real @ real ) )
      @ ( image @ real @ ( filter @ ( product_prod @ real @ real ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ real @ real )
            @ ( collect @ ( product_prod @ real @ real )
              @ ( product_case_prod @ real @ real @ $o
                @ ^ [X: real,Y: real] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ real @ X @ Y ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_real_def
thf(fact_7186_uniformity__complex__def,axiom,
    ( ( topolo7806501430040627800ormity @ complex )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ complex @ complex ) )
      @ ( image @ real @ ( filter @ ( product_prod @ complex @ complex ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ complex @ complex )
            @ ( collect @ ( product_prod @ complex @ complex )
              @ ( product_case_prod @ complex @ complex @ $o
                @ ^ [X: complex,Y: complex] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ complex @ X @ Y ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_complex_def
thf(fact_7187_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ! [F5: nat > A] :
                ( ! [N7: nat] : ( ord_less @ A @ B2 @ ( F5 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ A @ ( F5 @ N7 ) @ A2 )
                 => ( ( order_mono @ nat @ A @ F5 )
                   => ( ( filterlim @ nat @ A @ F5 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N: nat] : ( P @ ( F5 @ N ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_7188_range__abs__Nats,axiom,
    ( ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) )
    = ( semiring_1_Nats @ int ) ) ).

% range_abs_Nats
thf(fact_7189_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F2: A > B,M: A,N2: A,M6: B,N4: B] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ( image @ A @ B @ F2 @ ( set_or7035219750837199246ssThan @ A @ M @ N2 ) )
              = ( set_or7035219750837199246ssThan @ B @ M6 @ N4 ) )
           => ( ( ord_less @ A @ M @ N2 )
             => ( ( F2 @ M )
                = M6 ) ) ) ) ) ).

% mono_image_least
thf(fact_7190_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A3: A,B4: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A3 @ B4 ) ) @ ( inf_inf @ B @ ( F2 @ A3 ) @ ( F2 @ B4 ) ) ) ) ) ).

% mono_inf
thf(fact_7191_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,I: nat,J: nat,X2: A,Y2: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ( ord_less_eq @ A @ X2 @ ( F2 @ X2 ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I @ F2 @ X2 ) @ ( compow @ ( A > A ) @ J @ F2 @ Y2 ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_7192_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I: nat,J: nat] :
          ( ( order_mono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ord_less_eq @ A @ ( F2 @ I ) @ ( F2 @ J ) ) ) ) ) ).

% incseqD
thf(fact_7193_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X8: nat > A] :
            ! [M3: nat,N: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N )
             => ( ord_less_eq @ A @ ( X8 @ M3 ) @ ( X8 @ N ) ) ) ) ) ) ).

% incseq_def
thf(fact_7194_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F4: A > B] :
            ! [X: A,Y: A] :
              ( ( ord_less_eq @ A @ X @ Y )
             => ( ord_less_eq @ B @ ( F4 @ X ) @ ( F4 @ Y ) ) ) ) ) ) ).

% mono_def
thf(fact_7195_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y3: A] :
              ( ( ord_less_eq @ A @ X3 @ Y3 )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_7196_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) ) ).

% monoE
thf(fact_7197_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) ) ).

% monoD
thf(fact_7198_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F4: nat > A] :
            ! [N: nat] : ( ord_less_eq @ A @ ( F4 @ N ) @ ( F4 @ ( suc @ N ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_7199_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X6: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X6 @ N3 ) @ ( X6 @ ( suc @ N3 ) ) )
         => ( order_mono @ nat @ A @ X6 ) ) ) ).

% incseq_SucI
thf(fact_7200_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I: nat] :
          ( ( order_mono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ I ) @ ( A3 @ ( suc @ I ) ) ) ) ) ).

% incseq_SucD
thf(fact_7201_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
           => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% mono_invE
thf(fact_7202_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,A3: A,B4: A,N2: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ A3 @ B4 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N2 @ F2 @ A3 ) @ ( compow @ ( A > A ) @ N2 @ F2 @ B4 ) ) ) ) ) ).

% funpow_mono
thf(fact_7203_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_7204_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N2: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ) ).

% mono_pow
thf(fact_7205_Nats__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_numeral
thf(fact_7206_Nats__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_mult
thf(fact_7207_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
           => ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% mono_strict_invE
thf(fact_7208_fact__in__Nats,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] : ( member @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_1_Nats @ A ) ) ) ).

% fact_in_Nats
thf(fact_7209_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_7210_Nats__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_0
thf(fact_7211_Nats__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_1
thf(fact_7212_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_7213_Nats__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_add
thf(fact_7214_Nats__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X2: A] :
          ( ( member @ A @ X2 @ ( semiring_1_Nats @ A ) )
         => ~ ! [N3: nat] :
                ( X2
               != ( semiring_1_of_nat @ A @ N3 ) ) ) ) ).

% Nats_cases
thf(fact_7215_Nats__induct,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X2: A,P: A > $o] :
          ( ( member @ A @ X2 @ ( semiring_1_Nats @ A ) )
         => ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ A @ N3 ) )
           => ( P @ X2 ) ) ) ) ).

% Nats_induct
thf(fact_7216_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_Nats @ A ) ) ) ).

% of_nat_in_Nats
thf(fact_7217_mono__times__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N2 ) ) ) ).

% mono_times_nat
thf(fact_7218_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I3: nat] : ( compow @ ( A > A ) @ I3 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_7219_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P2: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P2 ) @ P2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P2 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_7220_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P2: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P2 @ ( F2 @ P2 ) )
           => ( ord_less_eq @ A @ P2 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_7221_incseq__bounded,axiom,
    ! [X6: nat > real,B4: real] :
      ( ( order_mono @ nat @ real @ X6 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( X6 @ I4 ) @ B4 )
       => ( bfun @ nat @ real @ X6 @ ( at_top @ nat ) ) ) ) ).

% incseq_bounded
thf(fact_7222_Nats__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( ( ord_less_eq @ A @ B2 @ A2 )
             => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ) ).

% Nats_diff
thf(fact_7223_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X: C] : ( F2 @ ( A3 @ X ) )
                @ I5 ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I5 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_7224_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A3 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% mono_Sup
thf(fact_7225_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ) ).

% mono_Inf
thf(fact_7226_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I5 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X: C] : ( F2 @ ( A3 @ X ) )
                @ I5 ) ) ) ) ) ).

% mono_INF
thf(fact_7227_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Nats_subset_Ints
thf(fact_7228_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I3: nat] : ( compow @ ( A > A ) @ I3 @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_7229_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X6: nat > A,L6: A,N2: nat] :
          ( ( order_mono @ nat @ A @ X6 )
         => ( ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X6 @ N2 ) @ L6 ) ) ) ) ).

% incseq_le
thf(fact_7230_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N2: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N2 @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_7231_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N2: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N2 @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_7232_incseq__convergent,axiom,
    ! [X6: nat > real,B4: real] :
      ( ( order_mono @ nat @ real @ X6 )
     => ( ! [I4: nat] : ( ord_less_eq @ real @ ( X6 @ I4 ) @ B4 )
       => ~ ! [L7: real] :
              ( ( filterlim @ nat @ real @ X6 @ ( topolo7230453075368039082e_nhds @ real @ L7 ) @ ( at_top @ nat ) )
             => ~ ! [I2: nat] : ( ord_less_eq @ real @ ( X6 @ I2 ) @ L7 ) ) ) ) ).

% incseq_convergent
thf(fact_7233_mono__Max__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798349783984er_Max @ A @ A3 ) )
                = ( lattic643756798349783984er_Max @ B @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ) ) ) ).

% mono_Max_commute
thf(fact_7234_mono__Min__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798350308766er_Min @ A @ A3 ) )
                = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ) ) ) ).

% mono_Min_commute
thf(fact_7235_Nats__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Nats_def
thf(fact_7236_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ) ) ) ).

% mono_cInf
thf(fact_7237_mono__cINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ ( image @ C @ A @ A3 @ I5 ) )
           => ( ( I5
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I5 ) ) )
                @ ( complete_Inf_Inf @ B
                  @ ( image @ C @ B
                    @ ^ [X: C] : ( F2 @ ( A3 @ X ) )
                    @ I5 ) ) ) ) ) ) ) ).

% mono_cINF
thf(fact_7238_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [N: A] :
              ( ( member @ A @ N @ ( ring_1_Ints @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ N ) ) ) ) ) ).

% Nats_altdef2
thf(fact_7239_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [Uu2: A] :
            ? [N: int] :
              ( ( Uu2
                = ( ring_1_of_int @ A @ N ) )
              & ( ord_less_eq @ int @ ( zero_zero @ int ) @ N ) ) ) ) ) ).

% Nats_altdef1
thf(fact_7240_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M3 ) @ M3 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_7241_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F2 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F2 )
           => ( ! [N3: nat] :
                  ( ( ( F2 @ N3 )
                    = ( F2 @ ( suc @ N3 ) ) )
                 => ( ( F2 @ ( suc @ N3 ) )
                    = ( F2 @ ( suc @ ( suc @ N3 ) ) ) ) )
             => ? [N9: nat] :
                  ( ! [N7: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ N9 )
                     => ! [M2: nat] :
                          ( ( ord_less_eq @ nat @ M2 @ N9 )
                         => ( ( ord_less @ nat @ M2 @ N7 )
                           => ( ord_less @ A @ ( F2 @ M2 ) @ ( F2 @ N7 ) ) ) ) )
                  & ! [N7: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N7 )
                     => ( ( F2 @ N9 )
                        = ( F2 @ N7 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_7242_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A2: B,X6: B > A,L6: A] :
          ( ( ord_less @ B @ B2 @ A2 )
         => ( ! [S5: nat > B] :
                ( ! [N7: nat] : ( ord_less @ B @ ( S5 @ N7 ) @ A2 )
               => ( ! [N7: nat] : ( ord_less @ B @ B2 @ ( S5 @ N7 ) )
                 => ( ( order_mono @ nat @ B @ S5 )
                   => ( ( filterlim @ nat @ B @ S5 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N: nat] : ( X6 @ ( S5 @ N ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L6 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_lessThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_7243_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs2: list @ A,Ys2: list @ A] :
      ( ( ( remdups_adj @ A @ Xs2 )
        = Ys2 )
      = ( ? [F4: nat > nat] :
            ( ( order_mono @ nat @ nat @ F4 )
            & ( ( image @ nat @ nat @ F4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( nth @ A @ Xs2 @ I3 )
                  = ( nth @ A @ Ys2 @ ( F4 @ I3 ) ) ) )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( ( nth @ A @ Xs2 @ I3 )
                    = ( nth @ A @ Xs2 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) )
                  = ( ( F4 @ I3 )
                    = ( F4 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_7244_LIMSEQ__incseq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X6: nat > A] :
          ( ( condit941137186595557371_above @ A @ ( image @ nat @ A @ X6 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ X6 )
           => ( filterlim @ nat @ A @ X6 @ ( topolo7230453075368039082e_nhds @ A @ ( complete_Sup_Sup @ A @ ( image @ nat @ A @ X6 @ ( top_top @ ( set @ nat ) ) ) ) ) @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_incseq_SUP
thf(fact_7245_bdd__above_OI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A,M7: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( ord_less_eq @ A @ X3 @ M7 ) )
         => ( condit941137186595557371_above @ A @ A3 ) ) ) ).

% bdd_above.I
thf(fact_7246_bdd__above_OI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ B,F2: B > A,M7: A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M7 ) )
         => ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ).

% bdd_above.I2
thf(fact_7247_remdups__adj__length,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% remdups_adj_length
thf(fact_7248_bdd__above_OE,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A] :
          ( ( condit941137186595557371_above @ A @ A3 )
         => ~ ! [M9: A] :
                ~ ! [X4: A] :
                    ( ( member @ A @ X4 @ A3 )
                   => ( ord_less_eq @ A @ X4 @ M9 ) ) ) ) ).

% bdd_above.E
thf(fact_7249_bdd__above_Ounfold,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit941137186595557371_above @ A )
        = ( ^ [A7: set @ A] :
            ? [M8: A] :
            ! [X: A] :
              ( ( member @ A @ X @ A7 )
             => ( ord_less_eq @ A @ X @ M8 ) ) ) ) ) ).

% bdd_above.unfold
thf(fact_7250_cSup__upper2,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X2: A,X6: set @ A,Y2: A] :
          ( ( member @ A @ X2 @ X6 )
         => ( ( ord_less_eq @ A @ Y2 @ X2 )
           => ( ( condit941137186595557371_above @ A @ X6 )
             => ( ord_less_eq @ A @ Y2 @ ( complete_Sup_Sup @ A @ X6 ) ) ) ) ) ) ).

% cSup_upper2
thf(fact_7251_cSup__upper,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X2: A,X6: set @ A] :
          ( ( member @ A @ X2 @ X6 )
         => ( ( condit941137186595557371_above @ A @ X6 )
           => ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ X6 ) ) ) ) ) ).

% cSup_upper
thf(fact_7252_cSUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X2: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ X2 @ A3 )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A3 ) )
           => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% cSUP_upper
thf(fact_7253_cSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A3: set @ B,X2: B,U: A] :
          ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A3 ) )
         => ( ( member @ B @ X2 @ A3 )
           => ( ( ord_less_eq @ A @ U @ ( F2 @ X2 ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ).

% cSUP_upper2
thf(fact_7254_cSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S: set @ A,A2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ S ) @ A2 )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ S )
                   => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ) ) ) ).

% cSup_le_iff
thf(fact_7255_cSup__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( B4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ B4 )
                 => ? [X4: A] :
                      ( ( member @ A @ X4 @ A3 )
                      & ( ord_less_eq @ A @ B6 @ X4 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ B4 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ).

% cSup_mono
thf(fact_7256_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X6: set @ A,Y2: A] :
          ( ( X6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X6 )
           => ( ( ord_less @ A @ Y2 @ ( complete_Sup_Sup @ A @ X6 ) )
              = ( ? [X: A] :
                    ( ( member @ A @ X @ X6 )
                    & ( ord_less @ A @ Y2 @ X ) ) ) ) ) ) ) ).

% less_cSup_iff
thf(fact_7257_cSUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A3: set @ B,Y2: A,I: B] :
          ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A3 ) )
         => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ Y2 )
           => ( ( member @ B @ I @ A3 )
             => ( ord_less @ A @ ( F2 @ I ) @ Y2 ) ) ) ) ) ).

% cSUP_lessD
thf(fact_7258_cSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,U: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A3 ) )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U )
              = ( ! [X: B] :
                    ( ( member @ B @ X @ A3 )
                   => ( ord_less_eq @ A @ ( F2 @ X ) @ U ) ) ) ) ) ) ) ).

% cSUP_le_iff
thf(fact_7259_cSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,G: C > A,B4: set @ C,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ C @ A @ G @ B4 ) )
           => ( ! [N3: B] :
                  ( ( member @ B @ N3 @ A3 )
                 => ? [X4: C] :
                      ( ( member @ C @ X4 @ B4 )
                      & ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ X4 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ) ).

% cSUP_mono
thf(fact_7260_cSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ B4 )
           => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ) ) ).

% cSup_subset_mono
thf(fact_7261_remdups__adj__adjacent,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs2 ) @ I )
       != ( nth @ A @ ( remdups_adj @ A @ Xs2 ) @ ( suc @ I ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_7262_less__cSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A3: set @ B,F2: B > A,A2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A3 ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
              = ( ? [X: B] :
                    ( ( member @ B @ X @ A3 )
                    & ( ord_less @ A @ A2 @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% less_cSUP_iff
thf(fact_7263_cSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ G @ B4 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                   => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
               => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ) ) ).

% cSUP_subset_mono
thf(fact_7264_Bseq__bdd__above,axiom,
    ! [X6: nat > real] :
      ( ( bfun @ nat @ real @ X6 @ ( at_top @ nat ) )
     => ( condit941137186595557371_above @ real @ ( image @ nat @ real @ X6 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Bseq_bdd_above
thf(fact_7265_cInf__le__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ( condit1013018076250108175_below @ A @ A3 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ).

% cInf_le_cSup
thf(fact_7266_cSup__cInf,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S: set @ A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S )
           => ( ( complete_Sup_Sup @ A @ S )
              = ( complete_Inf_Inf @ A
                @ ( collect @ A
                  @ ^ [X: A] :
                    ! [Y: A] :
                      ( ( member @ A @ Y @ S )
                     => ( ord_less_eq @ A @ Y @ X ) ) ) ) ) ) ) ) ).

% cSup_cInf
thf(fact_7267_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ ( image @ C @ A @ A3 @ I5 ) )
           => ( ( I5
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B
                @ ( complete_Sup_Sup @ B
                  @ ( image @ C @ B
                    @ ^ [X: C] : ( F2 @ ( A3 @ X ) )
                    @ I5 ) )
                @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I5 ) ) ) ) ) ) ) ) ).

% mono_cSUP
thf(fact_7268_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A3 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ) ).

% mono_cSup
thf(fact_7269_complex__is__Nat__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( semiring_1_Nats @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I3: nat] :
            ( ( re @ Z )
            = ( semiring_1_of_nat @ real @ I3 ) ) ) ) ).

% complex_is_Nat_iff
thf(fact_7270_Bseq__bdd__above_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X6: nat > A] :
          ( ( bfun @ nat @ A @ X6 @ ( at_top @ nat ) )
         => ( condit941137186595557371_above @ real
            @ ( image @ nat @ real
              @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( X6 @ N ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% Bseq_bdd_above'
thf(fact_7271_Rats__eq__int__div__nat,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu2: real] :
        ? [I3: int,N: nat] :
          ( ( Uu2
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I3 ) @ ( semiring_1_of_nat @ real @ N ) ) )
          & ( N
           != ( zero_zero @ nat ) ) ) ) ) ).

% Rats_eq_int_div_nat
thf(fact_7272_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
     => ( ( order_mono @ nat @ real @ F2 )
       => ( ( order_strict_mono @ nat @ nat @ G )
         => ( ( bfun @ nat @ real
              @ ^ [X: nat] : ( F2 @ ( G @ X ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
thf(fact_7273_Rats__abs__iff,axiom,
    ! [X2: real] :
      ( ( member @ real @ ( abs_abs @ real @ X2 ) @ ( field_char_0_Rats @ real ) )
      = ( member @ real @ X2 @ ( field_char_0_Rats @ real ) ) ) ).

% Rats_abs_iff
thf(fact_7274_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
            = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% strict_mono_less_eq
thf(fact_7275_strict__mono__imp__increasing,axiom,
    ! [F2: nat > nat,N2: nat] :
      ( ( order_strict_mono @ nat @ nat @ F2 )
     => ( ord_less_eq @ nat @ N2 @ ( F2 @ N2 ) ) ) ).

% strict_mono_imp_increasing
thf(fact_7276_Rats__no__top__le,axiom,
    ! [X2: real] :
    ? [X3: real] :
      ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
      & ( ord_less_eq @ real @ X2 @ X3 ) ) ).

% Rats_no_top_le
thf(fact_7277_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R: A > B,M: A,N2: A] :
          ( ( order_strict_mono @ A @ B @ R )
         => ( ( ord_less_eq @ A @ M @ N2 )
           => ( ord_less_eq @ B @ ( R @ M ) @ ( R @ N2 ) ) ) ) ) ).

% strict_mono_leD
thf(fact_7278_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F4: nat > A] :
            ! [N: nat] : ( ord_less @ A @ ( F4 @ N ) @ ( F4 @ ( suc @ N ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_7279_strict__mono__add,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A] :
          ( order_strict_mono @ A @ A
          @ ^ [N: A] : ( plus_plus @ A @ N @ K ) ) ) ).

% strict_mono_add
thf(fact_7280_Rats__number__of,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_number_of
thf(fact_7281_Rats__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_mult
thf(fact_7282_Rats__diff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_diff
thf(fact_7283_Rats__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_divide
thf(fact_7284_Rats__no__bot__less,axiom,
    ! [X2: real] :
    ? [X3: real] :
      ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
      & ( ord_less @ real @ X3 @ X2 ) ) ).

% Rats_no_bot_less
thf(fact_7285_Rats__dense__in__real,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ? [X3: real] :
          ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
          & ( ord_less @ real @ X2 @ X3 )
          & ( ord_less @ real @ X3 @ Y2 ) ) ) ).

% Rats_dense_in_real
thf(fact_7286_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ A @ X2 @ Y2 )
           => ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) ) ).

% strict_monoD
thf(fact_7287_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y3: A] :
              ( ( ord_less @ A @ X3 @ Y3 )
             => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
         => ( order_strict_mono @ A @ B @ F2 ) ) ) ).

% strict_monoI
thf(fact_7288_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_strict_mono @ A @ B )
        = ( ^ [F4: A > B] :
            ! [X: A,Y: A] :
              ( ( ord_less @ A @ X @ Y )
             => ( ord_less @ B @ ( F4 @ X ) @ ( F4 @ Y ) ) ) ) ) ) ).

% strict_mono_def
thf(fact_7289_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
            = ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% strict_mono_less
thf(fact_7290_Rats__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_add
thf(fact_7291_Rats__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_0
thf(fact_7292_Rats__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( field_char_0_Rats @ A ) ) ) ) ).

% Rats_power
thf(fact_7293_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( summable @ A
                @ ^ [N: nat] : ( F2 @ ( G @ N ) ) )
              = ( summable @ A @ F2 ) ) ) ) ) ).

% summable_mono_reindex
thf(fact_7294_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A,C2: A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( sums @ A
                @ ^ [N: nat] : ( F2 @ ( G @ N ) )
                @ C2 )
              = ( sums @ A @ F2 @ C2 ) ) ) ) ) ).

% sums_mono_reindex
thf(fact_7295_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A
                @ ^ [N: nat] : ( F2 @ ( G @ N ) ) )
              = ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mono_reindex
thf(fact_7296_Rats__eq__int__div__int,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu2: real] :
        ? [I3: int,J2: int] :
          ( ( Uu2
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I3 ) @ ( ring_1_of_int @ real @ J2 ) ) )
          & ( J2
           != ( zero_zero @ int ) ) ) ) ) ).

% Rats_eq_int_div_int
thf(fact_7297_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > nat] :
          ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ Y3 ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G )
           => ( ( bfun @ nat @ A
                @ ^ [X: nat] : ( F2 @ ( G @ X ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_7298_inj__sgn__power,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( inj_on @ real @ real
        @ ^ [Y: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N2 ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_7299_surj__int__decode,axiom,
    ( ( image @ nat @ int @ nat_int_decode @ ( top_top @ ( set @ nat ) ) )
    = ( top_top @ ( set @ int ) ) ) ).

% surj_int_decode
thf(fact_7300_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_7301_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B3: A] : ( divide_divide @ A @ B3 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_7302_inj__on__insert,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ A2 @ A3 ) )
      = ( ( inj_on @ A @ B @ F2 @ A3 )
        & ~ ( member @ B @ ( F2 @ A2 ) @ ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% inj_on_insert
thf(fact_7303_image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
        = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B4 ) ) ) ) ).

% image_set_diff
thf(fact_7304_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
            = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B4 ) ) ) ) ) ) ).

% inj_on_image_set_diff
thf(fact_7305_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( finite_card @ B @ A3 ) )
     => ~ ( inj_on @ B @ A @ F2 @ A3 ) ) ).

% pigeonhole
thf(fact_7306_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A2: A,X2: A,B2: A,F2: A > B] :
          ( ( ord_less @ A @ A2 @ X2 )
         => ( ( ord_less @ A @ X2 @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
             => ( ( inj_on @ A @ B @ F2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F2 @ A2 ) @ ( F2 @ X2 ) )
                    & ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F2 @ B2 ) @ ( F2 @ X2 ) )
                    & ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ A2 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_7307_inj__on__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( inj_on @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% inj_on_diff
thf(fact_7308_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B3: A] : ( plus_plus @ A @ B3 @ A2 )
          @ A3 ) ) ).

% inj_on_add'
thf(fact_7309_inj__on__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 ) ) ).

% inj_on_add
thf(fact_7310_int__decode__eq,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( ( nat_int_decode @ X2 )
        = ( nat_int_decode @ Y2 ) )
      = ( X2 = Y2 ) ) ).

% int_decode_eq
thf(fact_7311_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A3 ) ) ) ).

% inj_on_mult
thf(fact_7312_inj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( inj_on @ A @ A
          @ ^ [B3: A] : ( minus_minus @ A @ B3 @ A2 )
          @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_diff_right
thf(fact_7313_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F2: A > B] :
          ( ! [X3: A,Y3: A] :
              ( ( ord_less @ A @ X3 @ Y3 )
             => ( ( F2 @ X3 )
               != ( F2 @ Y3 ) ) )
         => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_7314_inj__add__left,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_add_left
thf(fact_7315_inj__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( inj_on @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_7316_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [X3: A,Y3: A] :
              ( ( ord_less @ A @ X3 @ Y3 )
             => ( ( member @ A @ X3 @ A3 )
               => ( ( member @ A @ Y3 @ A3 )
                 => ( ( F2 @ X3 )
                   != ( F2 @ Y3 ) ) ) ) )
         => ( ! [X3: A,Y3: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ( member @ A @ Y3 @ A3 )
                 => ( ( ord_less_eq @ A @ X3 @ Y3 )
                    | ( ord_less_eq @ A @ Y3 @ X3 ) ) ) )
           => ( inj_on @ A @ B @ F2 @ A3 ) ) ) ) ).

% linorder_inj_onI
thf(fact_7317_injective__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C2: real] :
          ( ( C2
           != ( zero_zero @ real ) )
         => ( inj_on @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% injective_scaleR
thf(fact_7318_bij__int__decode,axiom,
    bij_betw @ nat @ int @ nat_int_decode @ ( top_top @ ( set @ nat ) ) @ ( top_top @ ( set @ int ) ) ).

% bij_int_decode
thf(fact_7319_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B4: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B4 )
       => ( ( ? [F4: A > B] :
                ( ( inj_on @ A @ B @ F4 @ A3 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F4 @ A3 ) @ B4 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_7320_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B4: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B4 )
       => ( ( finite_finite @ B @ B4 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_7321_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B4 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) )
         => ? [F5: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A3 ) @ B4 )
              & ( inj_on @ A @ B @ F5 @ A3 ) ) ) ) ) ).

% card_le_inj
thf(fact_7322_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_7323_funpow__inj__finite,axiom,
    ! [A: $tType,P2: A > A,X2: A] :
      ( ( inj_on @ A @ A @ P2 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y: A] :
              ? [N: nat] :
                ( Y
                = ( compow @ ( A > A ) @ N @ P2 @ X2 ) ) ) )
       => ~ ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( compow @ ( A > A ) @ N3 @ P2 @ X2 )
               != X2 ) ) ) ) ).

% funpow_inj_finite
thf(fact_7324_pos__deriv__imp__strict__mono,axiom,
    ! [F2: real > real,F6: real > real] :
      ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X3: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F6 @ X3 ) )
       => ( order_strict_mono @ real @ real @ F2 ) ) ) ).

% pos_deriv_imp_strict_mono
thf(fact_7325_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X2: A,N2: int,S: set @ A] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A
            @ ^ [X: A] : ( power_int @ A @ X @ N2 )
            @ ^ [Y: A] : ( times_times @ A @ Y @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ X2 @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S ) ) ) ) ).

% has_derivative_power_int'
thf(fact_7326_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,X2: C,F6: C > A,S: set @ C,N2: int] :
          ( ( ( F2 @ X2 )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X2 @ S ) )
           => ( has_derivative @ C @ A
              @ ^ [X: C] : ( power_int @ A @ ( F2 @ X ) @ N2 )
              @ ^ [H: C] : ( times_times @ A @ ( F6 @ H ) @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ ( F2 @ X2 ) @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) )
              @ ( topolo174197925503356063within @ C @ X2 @ S ) ) ) ) ) ).

% has_derivative_power_int
thf(fact_7327_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N2 )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_7328_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y2: A] :
          ( ( power_int @ A @ Y2 @ ( one_one @ int ) )
          = Y2 ) ) ).

% power_int_1_right
thf(fact_7329_power__int__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N2: int] :
          ( ( sgn_sgn @ A @ ( power_int @ A @ A2 @ N2 ) )
          = ( power_int @ A @ ( sgn_sgn @ A @ A2 ) @ N2 ) ) ) ).

% power_int_sgn
thf(fact_7330_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W: num,Y2: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) @ M )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) @ ( power_int @ A @ Y2 @ M ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_7331_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,W: num,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X2 @ ( numeral_numeral @ A @ W ) ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_7332_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( ( power_int @ A @ X2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( N2
             != ( zero_zero @ int ) ) ) ) ) ).

% power_int_eq_0_iff
thf(fact_7333_power__int__0__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( M
           != ( zero_zero @ int ) )
         => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
            = ( zero_zero @ A ) ) ) ) ).

% power_int_0_left
thf(fact_7334_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X2: B] :
          ( ( power_int @ B @ X2 @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_7335_abs__power__int__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N2: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) )
          = ( abs_abs @ A @ ( power_int @ A @ A2 @ N2 ) ) ) ) ).

% abs_power_int_minus
thf(fact_7336_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( power_int @ A @ X2 @ ( semiring_1_of_nat @ int @ N2 ) )
          = ( power_power @ A @ X2 @ N2 ) ) ) ).

% power_int_of_nat
thf(fact_7337_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: num,N2: num] :
          ( ( power_int @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( power_int @ A @ X2 @ ( numeral_numeral @ int @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% power_int_mult_numeral
thf(fact_7338_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_7339_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ B2 ) )
          = B2 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_7340_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X2: A,N2: num] :
          ( ( power_int @ A @ X2 @ ( numeral_numeral @ int @ N2 ) )
          = ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ N2 ) ) ) ) ).

% power_int_numeral
thf(fact_7341_of__real__eq__numeral__power__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [Y2: real,X2: num,N2: int] :
          ( ( ( real_Vector_of_real @ A @ Y2 )
            = ( power_int @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( Y2
            = ( power_int @ real @ ( numeral_numeral @ real @ X2 ) @ N2 ) ) ) ) ).

% of_real_eq_numeral_power_int_cancel_iff
thf(fact_7342_numeral__power__int__eq__of__real__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X2: num,N2: int,Y2: real] :
          ( ( ( power_int @ A @ ( numeral_numeral @ A @ X2 ) @ N2 )
            = ( real_Vector_of_real @ A @ Y2 ) )
          = ( ( power_int @ real @ ( numeral_numeral @ real @ X2 ) @ N2 )
            = Y2 ) ) ) ).

% numeral_power_int_eq_of_real_cancel_iff
thf(fact_7343_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y2: A] :
          ( ( power_int @ A @ Y2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
          = ( inverse_inverse @ A @ Y2 ) ) ) ).

% power_int_minus1_right
thf(fact_7344_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: num,N2: num] :
          ( ( times_times @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ M ) ) @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ N2 ) ) )
          = ( power_int @ A @ X2 @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N2 ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_7345_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: num,N2: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ M ) ) @ ( times_times @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ N2 ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N2 ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_7346_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
             => ( ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ B2 @ N2 ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_int_mono_iff
thf(fact_7347_power__int__minus__left__even,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( power_int @ A @ A2 @ N2 ) ) ) ) ).

% power_int_minus_left_even
thf(fact_7348_power__int__minus__left__odd,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% power_int_minus_left_odd
thf(fact_7349_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [M: num,N2: num] :
          ( ( power_int @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( inverse_inverse @ A @ ( numeral_numeral @ A @ ( pow @ M @ N2 ) ) ) ) ) ).

% power_int_numeral_neg_numeral
thf(fact_7350_inj__on__set__encode,axiom,
    inj_on @ ( set @ nat ) @ nat @ nat_set_encode @ ( collect @ ( set @ nat ) @ ( finite_finite @ nat ) ) ).

% inj_on_set_encode
thf(fact_7351_inj__prod__encode,axiom,
    ! [A3: set @ ( product_prod @ nat @ nat )] : ( inj_on @ ( product_prod @ nat @ nat ) @ nat @ nat_prod_encode @ A3 ) ).

% inj_prod_encode
thf(fact_7352_inj__Suc,axiom,
    ! [N5: set @ nat] : ( inj_on @ nat @ nat @ suc @ N5 ) ).

% inj_Suc
thf(fact_7353_inj__int__decode,axiom,
    ! [A3: set @ nat] : ( inj_on @ nat @ int @ nat_int_decode @ A3 ) ).

% inj_int_decode
thf(fact_7354_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_7355_inj__on__diff__nat,axiom,
    ! [N5: set @ nat,K: nat] :
      ( ! [N3: nat] :
          ( ( member @ nat @ N3 @ N5 )
         => ( ord_less_eq @ nat @ K @ N3 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N: nat] : ( minus_minus @ nat @ N @ K )
        @ N5 ) ) ).

% inj_on_diff_nat
thf(fact_7356_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: int,B2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ A2 @ B2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ B2 @ A2 ) ) ) ) ).

% power_int_minus_one_diff_commute
thf(fact_7357_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N5: int,A2: A] :
          ( ( ord_less_eq @ int @ N2 @ N5 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ A2 @ N5 ) ) ) ) ) ).

% power_int_increasing
thf(fact_7358_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% zero_le_power_int
thf(fact_7359_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( ( M
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( one_one @ A ) ) )
          & ( ( M
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_7360_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N5: int,A2: A] :
          ( ( ord_less @ int @ N2 @ N5 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ A2 @ N5 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_7361_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X2 ) @ N2 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% power_int_one_over
thf(fact_7362_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,M: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ M )
          = ( divide_divide @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ Y2 @ M ) ) ) ) ).

% power_int_divide_distrib
thf(fact_7363_power__int__mult,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( power_int @ A @ X2 @ ( times_times @ int @ M @ N2 ) )
          = ( power_int @ A @ ( power_int @ A @ X2 @ M ) @ N2 ) ) ) ).

% power_int_mult
thf(fact_7364_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X2 @ Y2 ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ Y2 @ M ) ) ) ) ).

% power_int_mult_distrib
thf(fact_7365_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( times_times @ A @ ( power_int @ A @ X2 @ N2 ) @ X2 )
          = ( times_times @ A @ X2 @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% power_int_commutes
thf(fact_7366_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( N2
              = ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X2 @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% power_int_not_zero
thf(fact_7367_power__int__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( power_int @ A @ ( inverse_inverse @ A @ X2 ) @ N2 )
          = ( inverse_inverse @ A @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% power_int_inverse
thf(fact_7368_power__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N2: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ A2 @ N2 ) )
          = ( power_int @ A @ ( abs_abs @ A @ A2 ) @ N2 ) ) ) ).

% power_int_abs
thf(fact_7369_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% zero_less_power_int
thf(fact_7370_power__int__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( power_int @ A @ X2 @ ( uminus_uminus @ int @ N2 ) )
          = ( inverse_inverse @ A @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% power_int_minus
thf(fact_7371_power__int__diff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( M != N2 ) )
         => ( ( power_int @ A @ X2 @ ( minus_minus @ int @ M @ N2 ) )
            = ( divide_divide @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ) ).

% power_int_diff
thf(fact_7372_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ int @ N2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) ) ) ).

% power_int_minus_one_minus
thf(fact_7373_continuous__on__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S2: set @ A,F2: A > B,N2: int] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S2
              @ ^ [X: A] : ( power_int @ B @ ( F2 @ X ) @ N2 ) ) ) ) ) ).

% continuous_on_power_int
thf(fact_7374_tendsto__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,N2: int] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X: B] : ( power_int @ A @ ( F2 @ X ) @ N2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( power_int @ A @ A2 @ N2 ) )
              @ F3 ) ) ) ) ).

% tendsto_power_int
thf(fact_7375_continuous__at__within__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B,N2: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
              @ ^ [X: A] : ( power_int @ B @ ( F2 @ X ) @ N2 ) ) ) ) ) ).

% continuous_at_within_power_int
thf(fact_7376_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [N3: nat,F5: nat > A] :
          ( ( A3
            = ( image @ nat @ A @ F5
              @ ( collect @ nat
                @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N3 ) ) ) )
          & ( inj_on @ nat @ A @ F5
            @ ( collect @ nat
              @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N3 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_7377_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,N2: int] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X: A] : ( power_int @ B @ ( F2 @ X ) @ N2 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% differentiable_power_int
thf(fact_7378_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [F5: A > nat,N3: nat] :
          ( ( ( image @ A @ nat @ F5 @ A3 )
            = ( collect @ nat
              @ ^ [I3: nat] : ( ord_less @ nat @ I3 @ N3 ) ) )
          & ( inj_on @ A @ nat @ F5 @ A3 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_7379_continuous__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F3: filter @ A,F2: A > B,N2: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X: A] : X ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F3
              @ ^ [X: A] : ( power_int @ B @ ( F2 @ X ) @ N2 ) ) ) ) ) ).

% continuous_power_int
thf(fact_7380_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N5: int,A2: A] :
          ( ( ord_less @ int @ N2 @ N5 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N5 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_7381_power__int__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,N2: int] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
             => ( ord_less_eq @ A @ ( power_int @ A @ X2 @ N2 ) @ ( power_int @ A @ Y2 @ N2 ) ) ) ) ) ) ).

% power_int_mono
thf(fact_7382_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N2 @ ( zero_zero @ int ) )
             => ( ord_less @ A @ ( power_int @ A @ B2 @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_antimono
thf(fact_7383_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ) ).

% one_le_power_int
thf(fact_7384_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% one_less_power_int
thf(fact_7385_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M @ N2 )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X2 @ ( plus_plus @ int @ M @ N2 ) )
            = ( times_times @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ) ).

% power_int_add
thf(fact_7386_inj__on__nth,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ I5 )
           => ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs2 ) @ I5 ) ) ) ).

% inj_on_nth
thf(fact_7387_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X2: C,A2: A,N2: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_7388_summable__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) ) ) ) ).

% summable_reindex
thf(fact_7389_inj__on__funpow__least,axiom,
    ! [A: $tType,N2: nat,F2: A > A,S2: A] :
      ( ( ( compow @ ( A > A ) @ N2 @ F2 @ S2 )
        = S2 )
     => ( ! [M4: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
           => ( ( ord_less @ nat @ M4 @ N2 )
             => ( ( compow @ ( A > A ) @ M4 @ F2 @ S2 )
               != S2 ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K3: nat] : ( compow @ ( A > A ) @ K3 @ F2 @ S2 )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% inj_on_funpow_least
thf(fact_7390_power__int__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N2 @ ( zero_zero @ int ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ B2 @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_antimono
thf(fact_7391_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ B2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_mono
thf(fact_7392_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N5: int,A2: A] :
          ( ( ord_less_eq @ int @ N2 @ N5 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ( ( A2
                   != ( zero_zero @ A ) )
                  | ( N5
                   != ( zero_zero @ int ) )
                  | ( N2
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N5 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_7393_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ( ord_less_eq @ A @ X2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X2 @ N2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_7394_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ X2 @ N2 ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less_eq @ int @ M @ N2 ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_7395_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X2 )
         => ( ( ord_less @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ X2 @ N2 ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less @ int @ M @ N2 ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_7396_power__int__minus__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( power_int @ A @ A2 @ N2 ) ) )
          & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_minus_left
thf(fact_7397_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,N2: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( N2
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X2 @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) @ X2 )
            = ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% power_int_minus_mult
thf(fact_7398_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X2 @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ X2 @ ( power_int @ A @ X2 @ M ) ) ) ) ) ).

% power_int_add_1'
thf(fact_7399_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X2 @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X2 @ M ) @ X2 ) ) ) ) ).

% power_int_add_1
thf(fact_7400_suminf__reindex__mono,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) @ ( suminf @ real @ F2 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_7401_power__int__def,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ( ( power_int @ A )
        = ( ^ [X: A,N: int] : ( if @ A @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N ) @ ( power_power @ A @ X @ ( nat2 @ N ) ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ).

% power_int_def
thf(fact_7402_powr__real__of__int_H,axiom,
    ! [X2: real,N2: int] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( X2
           != ( zero_zero @ real ) )
          | ( ord_less @ int @ ( zero_zero @ int ) @ N2 ) )
       => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ N2 ) )
          = ( power_int @ real @ X2 @ N2 ) ) ) ) ).

% powr_real_of_int'
thf(fact_7403_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_7404_suminf__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( ! [X3: nat] :
                ( ~ ( member @ nat @ X3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) )
              = ( suminf @ real @ F2 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_7405_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D3: A,X2: A,S2: set @ A,N2: int] :
          ( ( has_field_derivative @ A @ F2 @ D3 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X: A] : ( power_int @ A @ ( F2 @ X ) @ N2 )
              @ ( times_times @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ ( F2 @ X2 ) @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) @ D3 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_power_int
thf(fact_7406_pred__nat__def,axiom,
    ( pred_nat
    = ( collect @ ( product_prod @ nat @ nat )
      @ ( product_case_prod @ nat @ nat @ $o
        @ ^ [M3: nat,N: nat] :
            ( N
            = ( suc @ M3 ) ) ) ) ) ).

% pred_nat_def
thf(fact_7407_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs: list @ A,Ys3: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs )
                      = ( size_size @ ( list @ A ) @ Ys3 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys3 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_7408_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_7409_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_ord_atMost @ nat @ N2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) @ ( M7 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_7410_dual__max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( max @ A
          @ ^ [X: A,Y: A] : ( ord_less_eq @ A @ Y @ X ) )
        = ( ord_min @ A ) ) ) ).

% dual_max
thf(fact_7411_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X2 @ Y2 ) @ Z )
          = ( ( ord_less_eq @ A @ X2 @ Z )
            & ( ord_less_eq @ A @ Y2 @ Z ) ) ) ) ).

% le_sup_iff
thf(fact_7412_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.bounded_iff
thf(fact_7413_Un__Diff__cancel,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ).

% Un_Diff_cancel
thf(fact_7414_Un__Diff__cancel2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) @ A3 )
      = ( sup_sup @ ( set @ A ) @ B4 @ A3 ) ) ).

% Un_Diff_cancel2
thf(fact_7415_sup__Inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ A2 )
              = A2 ) ) ) ) ).

% sup_Inf_absorb
thf(fact_7416_Compl__Diff__eq,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( sup_sup @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ B4 ) ) ).

% Compl_Diff_eq
thf(fact_7417_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A3: A,B4: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A3 ) @ ( F2 @ B4 ) ) @ ( F2 @ ( sup_sup @ A @ A3 @ B4 ) ) ) ) ) ).

% mono_sup
thf(fact_7418_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_7419_Diff__Un,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C6: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B4 @ C6 ) )
      = ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% Diff_Un
thf(fact_7420_Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C6: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B4 @ C6 ) )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% Diff_Int
thf(fact_7421_Int__Diff__Un,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = A3 ) ).

% Int_Diff_Un
thf(fact_7422_Un__Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
      = A3 ) ).

% Un_Diff_Int
thf(fact_7423_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ ( inf_inf @ A @ X2 @ Z ) ) @ ( inf_inf @ A @ X2 @ ( sup_sup @ A @ Y2 @ Z ) ) ) ) ).

% distrib_inf_le
thf(fact_7424_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X2 @ ( inf_inf @ A @ Y2 @ Z ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X2 @ Y2 ) @ ( sup_sup @ A @ X2 @ Z ) ) ) ) ).

% distrib_sup_le
thf(fact_7425_Diff__subset__conv,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ C6 )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B4 @ C6 ) ) ) ).

% Diff_subset_conv
thf(fact_7426_Diff__partition,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
        = B4 ) ) ).

% Diff_partition
thf(fact_7427_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_7428_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_7429_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_7430_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( sup_sup @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_7431_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( sup_sup @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_7432_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_7433_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_7434_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( A4
              = ( sup_sup @ A @ A4 @ B3 ) ) ) ) ) ).

% sup.order_iff
thf(fact_7435_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% sup.boundedI
thf(fact_7436_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.boundedE
thf(fact_7437_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( sup_sup @ A @ X2 @ Y2 )
            = Y2 ) ) ) ).

% sup_absorb2
thf(fact_7438_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( sup_sup @ A @ X2 @ Y2 )
            = X2 ) ) ) ).

% sup_absorb1
thf(fact_7439_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_7440_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb1
thf(fact_7441_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X2: A,Y2: A] :
          ( ! [X3: A,Y3: A] : ( ord_less_eq @ A @ X3 @ ( F2 @ X3 @ Y3 ) )
         => ( ! [X3: A,Y3: A] : ( ord_less_eq @ A @ Y3 @ ( F2 @ X3 @ Y3 ) )
           => ( ! [X3: A,Y3: A,Z3: A] :
                  ( ( ord_less_eq @ A @ Y3 @ X3 )
                 => ( ( ord_less_eq @ A @ Z3 @ X3 )
                   => ( ord_less_eq @ A @ ( F2 @ Y3 @ Z3 ) @ X3 ) ) )
             => ( ( sup_sup @ A @ X2 @ Y2 )
                = ( F2 @ X2 @ Y2 ) ) ) ) ) ) ).

% sup_unique
thf(fact_7442_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% sup.orderI
thf(fact_7443_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_7444_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X: A,Y: A] :
              ( ( sup_sup @ A @ X @ Y )
              = Y ) ) ) ) ).

% le_iff_sup
thf(fact_7445_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( ord_less_eq @ A @ Z @ X2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y2 @ Z ) @ X2 ) ) ) ) ).

% sup_least
thf(fact_7446_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ ( sup_sup @ A @ C2 @ D3 ) ) ) ) ) ).

% sup_mono
thf(fact_7447_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,D3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D3 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D3 ) @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_7448_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ X2 @ B2 )
         => ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_7449_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X2 @ A2 )
         => ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_7450_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y2: A,X2: A] : ( ord_less_eq @ A @ Y2 @ ( sup_sup @ A @ X2 @ Y2 ) ) ) ).

% sup_ge2
thf(fact_7451_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ X2 @ Y2 ) ) ) ).

% sup_ge1
thf(fact_7452_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X2 )
         => ( ( ord_less_eq @ A @ B2 @ X2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X2 ) ) ) ) ).

% le_supI
thf(fact_7453_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,X2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X2 )
         => ~ ( ( ord_less_eq @ A @ A2 @ X2 )
             => ~ ( ord_less_eq @ A @ B2 @ X2 ) ) ) ) ).

% le_supE
thf(fact_7454_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ X2 @ Y2 ) ) ) ).

% inf_sup_ord(3)
thf(fact_7455_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y2: A,X2: A] : ( ord_less_eq @ A @ Y2 @ ( sup_sup @ A @ X2 @ Y2 ) ) ) ).

% inf_sup_ord(4)
thf(fact_7456_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_7457_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_7458_Un__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C6: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) @ C6 )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ C6 ) @ ( minus_minus @ ( set @ A ) @ B4 @ C6 ) ) ) ).

% Un_Diff
thf(fact_7459_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_7460_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_7461_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( A4
                = ( sup_sup @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_7462_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_7463_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_7464_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb3
thf(fact_7465_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ X2 @ B2 )
         => ( ord_less @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_7466_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ X2 @ A2 )
         => ( ord_less @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_7467_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ Z )
          = ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y2 ) @ Z ) ) ) ) ).

% shunt1
thf(fact_7468_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) @ Z )
          = ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ Y2 @ Z ) ) ) ) ).

% shunt2
thf(fact_7469_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P2: A,Q2: A,R: A] :
          ( ( ord_less_eq @ A @ P2 @ ( sup_sup @ A @ Q2 @ R ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P2 @ ( uminus_uminus @ A @ Q2 ) ) @ R ) ) ) ).

% sup_neg_inf
thf(fact_7470_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( sup_sup @ A @ X2 @ Y2 )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) ) ) ).

% sup_shunt
thf(fact_7471_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_7472_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L2 ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_7473_card__Un__le,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ).

% card_Un_le
thf(fact_7474_atLeastLessThan__add__Un,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( set_or7035219750837199246ssThan @ nat @ I @ ( plus_plus @ nat @ J @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I @ J ) @ ( set_or7035219750837199246ssThan @ nat @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_7475_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_7476_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_atLeast @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_7477_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L2 ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_7478_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_7479_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_7480_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_7481_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_7482_card__Un__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_7483_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_7484_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_7485_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L2 ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_7486_Inf__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ( B4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
                  = ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ ( lattic7752659483105999362nf_fin @ A @ B4 ) ) ) ) ) ) ) ) ).

% Inf_fin.union
thf(fact_7487_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_7488_Max_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ( B4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
                  = ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ ( lattic643756798349783984er_Max @ A @ B4 ) ) ) ) ) ) ) ) ).

% Max.union
thf(fact_7489_Min_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ( B4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
                  = ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ ( lattic643756798350308766er_Min @ A @ B4 ) ) ) ) ) ) ) ) ).

% Min.union
thf(fact_7490_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L2 ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_7491_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_atLeast @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_7492_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_7493_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B4: A] :
          ( ( sup_sup @ A @ A3
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X: nat] : B4
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A3 @ B4 ) ) ) ).

% SUP_nat_binary
thf(fact_7494_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(6)
thf(fact_7495_sup__Inf1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( sup_sup @ A @ X2 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
              = ( lattic7752659483105999362nf_fin @ A
                @ ( collect @ A
                  @ ^ [Uu2: A] :
                    ? [A4: A] :
                      ( ( Uu2
                        = ( sup_sup @ A @ X2 @ A4 ) )
                      & ( member @ A @ A4 @ A3 ) ) ) ) ) ) ) ) ).

% sup_Inf1_distrib
thf(fact_7496_sup__Inf2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ( B4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ ( lattic7752659483105999362nf_fin @ A @ B4 ) )
                  = ( lattic7752659483105999362nf_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu2: A] :
                        ? [A4: A,B3: A] :
                          ( ( Uu2
                            = ( sup_sup @ A @ A4 @ B3 ) )
                          & ( member @ A @ A4 @ A3 )
                          & ( member @ A @ B3 @ B4 ) ) ) ) ) ) ) ) ) ) ).

% sup_Inf2_distrib
thf(fact_7497_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X: A,Y: A] : ( ord_less_eq @ A @ Y @ X )
        @ ^ [X: A,Y: A] : ( ord_less @ A @ Y @ X ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_7498_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( condit941137186595557371_above @ A @ A3 )
         => ( ( condit941137186595557371_above @ A @ B4 )
           => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) @ ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ) ) ) ).

% cSup_inter_less_eq
thf(fact_7499_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_7500_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_7501_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B4 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_7502_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_7503_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B4 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_7504_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_7505_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A3: set @ A,B4: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_7506_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B4 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_7507_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B4 @ A3 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_7508_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_7509_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( inj_on @ A @ B @ F2 @ A3 )
        & ( inj_on @ A @ B @ F2 @ B4 )
        & ( ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) )
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% inj_on_Un
thf(fact_7510_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L2 @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L2 @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_7511_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_7512_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L2 @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L2 @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_7513_sum__Un__nat,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_7514_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L2 @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_7515_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U: A] :
          ( ( ord_less @ A @ L2 @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L2 @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_7516_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A3: set @ B,B4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_7517_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X: A,Y: option @ A] : ( some @ A @ ( case_option @ A @ A @ X @ ( sup_sup @ A @ X ) @ Y ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Sup_fin.eq_fold'
thf(fact_7518_UNION__fun__upd,axiom,
    ! [B: $tType,A: $tType,A3: B > ( set @ A ),I: B,B4: set @ A,J4: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ ( fun_upd @ B @ ( set @ A ) @ A3 @ I @ B4 ) @ J4 ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ B ) @ J4 @ ( insert @ B @ I @ ( bot_bot @ ( set @ B ) ) ) ) ) ) @ ( if @ ( set @ A ) @ ( member @ B @ I @ J4 ) @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% UNION_fun_upd
thf(fact_7519_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ( inf_inf @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A3 ) )
              = A2 ) ) ) ) ).

% inf_Sup_absorb
thf(fact_7520_Sup__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
          = X2 ) ) ).

% Sup_fin.singleton
thf(fact_7521_Sup__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X2 @ A3 ) )
              = ( sup_sup @ A @ X2 @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ) ).

% Sup_fin.insert
thf(fact_7522_Sup__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( sup_sup @ A @ X2 @ ( lattic5882676163264333800up_fin @ A @ A3 ) )
              = ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ).

% Sup_fin.in_idem
thf(fact_7523_sup__int__def,axiom,
    ( ( sup_sup @ int )
    = ( ord_max @ int ) ) ).

% sup_int_def
thf(fact_7524_sup__enat__def,axiom,
    ( ( sup_sup @ extended_enat )
    = ( ord_max @ extended_enat ) ) ).

% sup_enat_def
thf(fact_7525_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_7526_Sup__fin__Max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% Sup_fin_Max
thf(fact_7527_Sup__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ).

% Sup_fin.coboundedI
thf(fact_7528_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X2 )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ord_less_eq @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Sup_fin.bounded_iff
thf(fact_7529_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A6: A] :
                  ( ( member @ A @ A6 @ A3 )
                 => ( ord_less_eq @ A @ A6 @ X2 ) )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X2 ) ) ) ) ) ).

% Sup_fin.boundedI
thf(fact_7530_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X2 )
             => ! [A9: A] :
                  ( ( member @ A @ A9 @ A3 )
                 => ( ord_less_eq @ A @ A9 @ X2 ) ) ) ) ) ) ).

% Sup_fin.boundedE
thf(fact_7531_Sup__fin__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ A3 )
              = ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% Sup_fin_Sup
thf(fact_7532_at__infinity__eq__at__top__bot,axiom,
    ( ( at_infinity @ real )
    = ( sup_sup @ ( filter @ real ) @ ( at_top @ real ) @ ( at_bot @ real ) ) ) ).

% at_infinity_eq_at_top_bot
thf(fact_7533_Sup__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite @ A @ A3 )
         => ( ( lattic5882676163264333800up_fin @ A @ A3 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Sup_fin.infinite
thf(fact_7534_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ B4 ) ) ) ) ) ) ).

% Sup_fin.subset_imp
thf(fact_7535_Sup__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [H2: A > A,N5: set @ A] :
          ( ! [X3: A,Y3: A] :
              ( ( H2 @ ( sup_sup @ A @ X3 @ Y3 ) )
              = ( sup_sup @ A @ ( H2 @ X3 ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite @ A @ N5 )
           => ( ( N5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic5882676163264333800up_fin @ A @ N5 ) )
                = ( lattic5882676163264333800up_fin @ A @ ( image @ A @ A @ H2 @ N5 ) ) ) ) ) ) ) ).

% Sup_fin.hom_commute
thf(fact_7536_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
             => ( ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ B4 ) @ ( lattic5882676163264333800up_fin @ A @ A3 ) )
                = ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ) ).

% Sup_fin.subset
thf(fact_7537_Sup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X2 @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X2 @ A3 ) )
                = ( sup_sup @ A @ X2 @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
thf(fact_7538_Sup__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y3: A] : ( member @ A @ ( sup_sup @ A @ X3 @ Y3 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ A3 ) ) ) ) ) ).

% Sup_fin.closed
thf(fact_7539_Sup__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ( B4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
                  = ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ B4 ) ) ) ) ) ) ) ) ).

% Sup_fin.union
thf(fact_7540_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ).

% Inf_fin_le_Sup_fin
thf(fact_7541_Sup__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( finite_fold @ A @ A @ ( sup_sup @ A ) @ X2 @ A3 ) ) ) ) ).

% Sup_fin.eq_fold
thf(fact_7542_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ( B4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( inf_inf @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ B4 ) )
                  = ( lattic5882676163264333800up_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu2: A] :
                        ? [A4: A,B3: A] :
                          ( ( Uu2
                            = ( inf_inf @ A @ A4 @ B3 ) )
                          & ( member @ A @ A4 @ A3 )
                          & ( member @ A @ B3 @ B4 ) ) ) ) ) ) ) ) ) ) ).

% inf_Sup2_distrib
thf(fact_7543_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( inf_inf @ A @ X2 @ ( lattic5882676163264333800up_fin @ A @ A3 ) )
              = ( lattic5882676163264333800up_fin @ A
                @ ( collect @ A
                  @ ^ [Uu2: A] :
                    ? [A4: A] :
                      ( ( Uu2
                        = ( inf_inf @ A @ X2 @ A4 ) )
                      & ( member @ A @ A4 @ A3 ) ) ) ) ) ) ) ) ).

% inf_Sup1_distrib
thf(fact_7544_fun__upd__image,axiom,
    ! [A: $tType,B: $tType,X2: B,A3: set @ B,F2: B > A,Y2: A] :
      ( ( ( member @ B @ X2 @ A3 )
       => ( ( image @ B @ A @ ( fun_upd @ B @ A @ F2 @ X2 @ Y2 ) @ A3 )
          = ( insert @ A @ Y2 @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
      & ( ~ ( member @ B @ X2 @ A3 )
       => ( ( image @ B @ A @ ( fun_upd @ B @ A @ F2 @ X2 @ Y2 ) @ A3 )
          = ( image @ B @ A @ F2 @ A3 ) ) ) ) ).

% fun_upd_image
thf(fact_7545_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A3 )
                  = X2 ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A3 )
                  = ( sup_sup @ A @ X2 @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.remove
thf(fact_7546_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X2 @ A3 ) )
                = X2 ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X2 @ A3 ) )
                = ( sup_sup @ A @ X2 @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.insert_remove
thf(fact_7547_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( cons @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set_nonempty
thf(fact_7548_nth__rotate,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,M: nat] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rotate @ A @ M @ Xs2 ) @ N2 )
        = ( nth @ A @ Xs2 @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% nth_rotate
thf(fact_7549_rotate0,axiom,
    ! [A: $tType] :
      ( ( rotate @ A @ ( zero_zero @ nat ) )
      = ( id @ ( list @ A ) ) ) ).

% rotate0
thf(fact_7550_nth__Cons__Suc,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A,N2: nat] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs2 ) @ ( suc @ N2 ) )
      = ( nth @ A @ Xs2 @ N2 ) ) ).

% nth_Cons_Suc
thf(fact_7551_nth__Cons__0,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs2 ) @ ( zero_zero @ nat ) )
      = X2 ) ).

% nth_Cons_0
thf(fact_7552_take__Suc__Cons,axiom,
    ! [A: $tType,N2: nat,X2: A,Xs2: list @ A] :
      ( ( take @ A @ ( suc @ N2 ) @ ( cons @ A @ X2 @ Xs2 ) )
      = ( cons @ A @ X2 @ ( take @ A @ N2 @ Xs2 ) ) ) ).

% take_Suc_Cons
thf(fact_7553_rotate__Suc,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( rotate @ A @ ( suc @ N2 ) @ Xs2 )
      = ( rotate1 @ A @ ( rotate @ A @ N2 @ Xs2 ) ) ) ).

% rotate_Suc
thf(fact_7554_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A,X2: B,Xs2: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( cons @ B @ X2 @ Xs2 ) )
          = ( plus_plus @ A @ ( F2 @ X2 ) @ ( times_times @ A @ A2 @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs2 ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_7555_rotate__length01,axiom,
    ! [A: $tType,Xs2: list @ A,N2: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( ( rotate @ A @ N2 @ Xs2 )
        = Xs2 ) ) ).

% rotate_length01
thf(fact_7556_rotate__id,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
        = ( zero_zero @ nat ) )
     => ( ( rotate @ A @ N2 @ Xs2 )
        = Xs2 ) ) ).

% rotate_id
thf(fact_7557_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N2: nat,X2: B,Xs2: list @ B] :
      ( ( enumerate @ B @ N2 @ ( cons @ B @ X2 @ Xs2 ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N2 @ X2 ) @ ( enumerate @ B @ ( suc @ N2 ) @ Xs2 ) ) ) ).

% enumerate_simps(2)
thf(fact_7558_nth__Cons__numeral,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A,V: num] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs2 ) @ ( numeral_numeral @ nat @ V ) )
      = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_7559_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,X2: A,Xs2: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X2 @ Xs2 ) )
      = ( cons @ A @ X2 @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs2 ) ) ) ).

% take_Cons_numeral
thf(fact_7560_nth__Cons__pos,axiom,
    ! [A: $tType,N2: nat,X2: A,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( nth @ A @ ( cons @ A @ X2 @ Xs2 ) @ N2 )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_7561_Suc__le__length__iff,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ? [X: A,Ys3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ X @ Ys3 ) )
            & ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Ys3 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_7562_rotate__add,axiom,
    ! [A: $tType,M: nat,N2: nat] :
      ( ( rotate @ A @ ( plus_plus @ nat @ M @ N2 ) )
      = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( rotate @ A @ M ) @ ( rotate @ A @ N2 ) ) ) ).

% rotate_add
thf(fact_7563_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Y2: B,Ys2: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X2 @ ( cons @ B @ Y2 @ Ys2 ) )
              = ( cons @ B @ X2 @ ( cons @ B @ Y2 @ Ys2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X2 @ ( cons @ B @ Y2 @ Ys2 ) )
              = ( cons @ B @ Y2 @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Ys2 ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_7564_impossible__Cons,axiom,
    ! [A: $tType,Xs2: list @ A,Ys2: list @ A,X2: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys2 ) )
     => ( Xs2
       != ( cons @ A @ X2 @ Ys2 ) ) ) ).

% impossible_Cons
thf(fact_7565_list__update__code_I3_J,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A,I: nat,Y2: A] :
      ( ( list_update @ A @ ( cons @ A @ X2 @ Xs2 ) @ ( suc @ I ) @ Y2 )
      = ( cons @ A @ X2 @ ( list_update @ A @ Xs2 @ I @ Y2 ) ) ) ).

% list_update_code(3)
thf(fact_7566_rotate__rotate,axiom,
    ! [A: $tType,M: nat,N2: nat,Xs2: list @ A] :
      ( ( rotate @ A @ M @ ( rotate @ A @ N2 @ Xs2 ) )
      = ( rotate @ A @ ( plus_plus @ nat @ M @ N2 ) @ Xs2 ) ) ).

% rotate_rotate
thf(fact_7567_replicate__Suc,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( replicate @ A @ ( suc @ N2 ) @ X2 )
      = ( cons @ A @ X2 @ ( replicate @ A @ N2 @ X2 ) ) ) ).

% replicate_Suc
thf(fact_7568_list__update__code_I2_J,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A,Y2: A] :
      ( ( list_update @ A @ ( cons @ A @ X2 @ Xs2 ) @ ( zero_zero @ nat ) @ Y2 )
      = ( cons @ A @ Y2 @ Xs2 ) ) ).

% list_update_code(2)
thf(fact_7569_length__Cons,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_Cons
thf(fact_7570_Suc__length__conv,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ( suc @ N2 )
        = ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ Y @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% Suc_length_conv
thf(fact_7571_length__Suc__conv,axiom,
    ! [A: $tType,Xs2: list @ A,N2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( suc @ N2 ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ Y @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% length_Suc_conv
thf(fact_7572_rotate__conv__mod,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N: nat,Xs: list @ A] : ( rotate @ A @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Xs ) ) ) ).

% rotate_conv_mod
thf(fact_7573_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ B,F2: B > A,A2: B] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs2 ) )
             => ( ord_less_eq @ A @ ( F2 @ A2 ) @ ( F2 @ X3 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs2 )
            = ( cons @ B @ A2 @ Xs2 ) ) ) ) ).

% insort_is_Cons
thf(fact_7574_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X222 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_7575_nth__Cons_H,axiom,
    ! [A: $tType,N2: nat,X2: A,Xs2: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X2 @ Xs2 ) @ N2 )
          = X2 ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X2 @ Xs2 ) @ N2 )
          = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_7576_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X2: A > nat,X21: A,X222: list @ A] :
      ( ( size_list @ A @ X2 @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X2 @ X21 ) @ ( size_list @ A @ X2 @ X222 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_7577_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_7578_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_7579_nth__equal__first__eq,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A,N2: nat] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( ( nth @ A @ ( cons @ A @ X2 @ Xs2 ) @ N2 )
            = X2 )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_7580_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs2: list @ A,N2: nat] :
      ( ( X2 != Y2 )
     => ( ( ( nth @ A @ ( cons @ A @ X2 @ Xs2 ) @ N2 )
          = Y2 )
        = ( ( ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
            = Y2 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_7581_Cons__replicate__eq,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A,N2: nat,Y2: A] :
      ( ( ( cons @ A @ X2 @ Xs2 )
        = ( replicate @ A @ N2 @ Y2 ) )
      = ( ( X2 = Y2 )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
        & ( Xs2
          = ( replicate @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ X2 ) ) ) ) ).

% Cons_replicate_eq
thf(fact_7582_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list @ A,N2: A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M @ Ms ) @ ( cons @ A @ N2 @ Ns ) ) @ ( lenlex @ A @ R ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M @ N2 ) @ R ) )
        | ( ( M = N2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_7583_of__char__Char,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
          ( ( comm_s6883823935334413003f_char @ A @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cons @ $o @ B0 @ ( cons @ $o @ B1 @ ( cons @ $o @ B22 @ ( cons @ $o @ B32 @ ( cons @ $o @ B42 @ ( cons @ $o @ B52 @ ( cons @ $o @ B62 @ ( cons @ $o @ B72 @ ( nil @ $o ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_Char
thf(fact_7584_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I3: int,J2: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J2 @ I3 ) @ Js @ ( upto_aux @ I3 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) @ ( cons @ int @ J2 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_7585_length__0__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( zero_zero @ nat ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_7586_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_7587_take__eq__Nil,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ( take @ A @ N2 @ Xs2 )
        = ( nil @ A ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( Xs2
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_7588_take__eq__Nil2,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N2 @ Xs2 ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( Xs2
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_7589_empty__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N2 @ X2 ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_7590_replicate__empty,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( ( replicate @ A @ N2 @ X2 )
        = ( nil @ A ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_7591_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_7592_n__lists__Nil,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N2 @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N2 @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_7593_length__greater__0__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ( Xs2
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_7594_nths__singleton,axiom,
    ! [A: $tType,A3: set @ nat,X2: A] :
      ( ( ( member @ nat @ ( zero_zero @ nat ) @ A3 )
       => ( ( nths @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ A3 )
          = ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      & ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 )
       => ( ( nths @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ A3 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_7595_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs2 )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_7596_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X2: A > nat] :
      ( ( size_list @ A @ X2 @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_7597_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_7598_replicate__0,axiom,
    ! [A: $tType,X2: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X2 )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_7599_take__0,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs2 )
      = ( nil @ A ) ) ).

% take_0
thf(fact_7600_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P4: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X24: list @ A] :
            ( ? [Y: A,Ys3: list @ A] :
                ( ( X17
                  = ( nil @ A ) )
                & ( X24
                  = ( cons @ A @ Y @ Ys3 ) ) )
            | ? [X: A,Y: A,Xs: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X @ Xs ) )
                & ( X24
                  = ( cons @ A @ Y @ Ys3 ) )
                & ( ord_less @ A @ X @ Y ) )
            | ? [X: A,Y: A,Xs: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X @ Xs ) )
                & ( X24
                  = ( cons @ A @ Y @ Ys3 ) )
                & ~ ( ord_less @ A @ X @ Y )
                & ~ ( ord_less @ A @ Y @ X )
                & ( P4 @ Xs @ Ys3 ) ) ) ) ) ).

% lexordp.mono
thf(fact_7601_remdups__adj__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N2 @ X2 ) )
          = ( nil @ A ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N2 @ X2 ) )
          = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_7602_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_7603_take__Cons_H,axiom,
    ! [A: $tType,N2: nat,X2: A,Xs2: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N2 @ ( cons @ A @ X2 @ Xs2 ) )
          = ( nil @ A ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N2 @ ( cons @ A @ X2 @ Xs2 ) )
          = ( cons @ A @ X2 @ ( take @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs2 ) ) ) ) ) ).

% take_Cons'
thf(fact_7604_concat__inth,axiom,
    ! [A: $tType,Xs2: list @ A,X2: A,Ys2: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = X2 ) ).

% concat_inth
thf(fact_7605_list__encode_Osimps_I2_J,axiom,
    ! [X2: nat,Xs2: list @ nat] :
      ( ( nat_list_encode @ ( cons @ nat @ X2 @ Xs2 ) )
      = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X2 @ ( nat_list_encode @ Xs2 ) ) ) ) ) ).

% list_encode.simps(2)
thf(fact_7606_length__append,axiom,
    ! [A: $tType,Xs2: list @ A,Ys2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs2 @ Ys2 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ).

% length_append
thf(fact_7607_size__list__append,axiom,
    ! [A: $tType,F2: A > nat,Xs2: list @ A,Ys2: list @ A] :
      ( ( size_list @ A @ F2 @ ( append @ A @ Xs2 @ Ys2 ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F2 @ Xs2 ) @ ( size_list @ A @ F2 @ Ys2 ) ) ) ).

% size_list_append
thf(fact_7608_nth__append__length__plus,axiom,
    ! [A: $tType,Xs2: list @ A,Ys2: list @ A,N2: nat] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ Ys2 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) )
      = ( nth @ A @ Ys2 @ N2 ) ) ).

% nth_append_length_plus
thf(fact_7609_take__append,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,Ys2: list @ A] :
      ( ( take @ A @ N2 @ ( append @ A @ Xs2 @ Ys2 ) )
      = ( append @ A @ ( take @ A @ N2 @ Xs2 ) @ ( take @ A @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys2 ) ) ) ).

% take_append
thf(fact_7610_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_7611_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_7612_list__encode_Ocases,axiom,
    ! [X2: list @ nat] :
      ( ( X2
       != ( nil @ nat ) )
     => ~ ! [X3: nat,Xs3: list @ nat] :
            ( X2
           != ( cons @ nat @ X3 @ Xs3 ) ) ) ).

% list_encode.cases
thf(fact_7613_list__encode_Osimps_I1_J,axiom,
    ( ( nat_list_encode @ ( nil @ nat ) )
    = ( zero_zero @ nat ) ) ).

% list_encode.simps(1)
thf(fact_7614_list__update__append1,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A,Ys2: list @ A,X2: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys2 ) @ I @ X2 )
        = ( append @ A @ ( list_update @ A @ Xs2 @ I @ X2 ) @ Ys2 ) ) ) ).

% list_update_append1
thf(fact_7615_inj__list__encode,axiom,
    ! [A3: set @ ( list @ nat )] : ( inj_on @ ( list @ nat ) @ nat @ nat_list_encode @ A3 ) ).

% inj_list_encode
thf(fact_7616_list__encode__eq,axiom,
    ! [X2: list @ nat,Y2: list @ nat] :
      ( ( ( nat_list_encode @ X2 )
        = ( nat_list_encode @ Y2 ) )
      = ( X2 = Y2 ) ) ).

% list_encode_eq
thf(fact_7617_replicate__add,axiom,
    ! [A: $tType,N2: nat,M: nat,X2: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N2 @ M ) @ X2 )
      = ( append @ A @ ( replicate @ A @ N2 @ X2 ) @ ( replicate @ A @ M @ X2 ) ) ) ).

% replicate_add
thf(fact_7618_enumerate__append__eq,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,Ys2: list @ A] :
      ( ( enumerate @ A @ N2 @ ( append @ A @ Xs2 @ Ys2 ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs2 ) @ ( enumerate @ A @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys2 ) ) ) ).

% enumerate_append_eq
thf(fact_7619_surj__list__encode,axiom,
    ( ( image @ ( list @ nat ) @ nat @ nat_list_encode @ ( top_top @ ( set @ ( list @ nat ) ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% surj_list_encode
thf(fact_7620_bij__list__encode,axiom,
    bij_betw @ ( list @ nat ) @ nat @ nat_list_encode @ ( top_top @ ( set @ ( list @ nat ) ) ) @ ( top_top @ ( set @ nat ) ) ).

% bij_list_encode
thf(fact_7621_list__encode_Oelims,axiom,
    ! [X2: list @ nat,Y2: nat] :
      ( ( ( nat_list_encode @ X2 )
        = Y2 )
     => ( ( ( X2
            = ( nil @ nat ) )
         => ( Y2
           != ( zero_zero @ nat ) ) )
       => ~ ! [X3: nat,Xs3: list @ nat] :
              ( ( X2
                = ( cons @ nat @ X3 @ Xs3 ) )
             => ( Y2
               != ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X3 @ ( nat_list_encode @ Xs3 ) ) ) ) ) ) ) ) ).

% list_encode.elims
thf(fact_7622_nths__append,axiom,
    ! [A: $tType,L2: list @ A,L4: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L2 @ L4 ) @ A3 )
      = ( append @ A @ ( nths @ A @ L2 @ A3 )
        @ ( nths @ A @ L4
          @ ( collect @ nat
            @ ^ [J2: nat] : ( member @ nat @ ( plus_plus @ nat @ J2 @ ( size_size @ ( list @ A ) @ L2 ) ) @ A3 ) ) ) ) ) ).

% nths_append
thf(fact_7623_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs2: list @ A,N2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( suc @ N2 ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( ( Xs2
              = ( append @ A @ Ys3 @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_7624_length__append__singleton,axiom,
    ! [A: $tType,Xs2: list @ A,X2: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs2 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_append_singleton
thf(fact_7625_nth__append,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,Ys2: list @ A] :
      ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( nth @ A @ ( append @ A @ Xs2 @ Ys2 ) @ N2 )
          = ( nth @ A @ Xs2 @ N2 ) ) )
      & ( ~ ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( nth @ A @ ( append @ A @ Xs2 @ Ys2 ) @ N2 )
          = ( nth @ A @ Ys2 @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% nth_append
thf(fact_7626_list__update__append,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,Ys2: list @ A,X2: A] :
      ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys2 ) @ N2 @ X2 )
          = ( append @ A @ ( list_update @ A @ Xs2 @ N2 @ X2 ) @ Ys2 ) ) )
      & ( ~ ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys2 ) @ N2 @ X2 )
          = ( append @ A @ Xs2 @ ( list_update @ A @ Ys2 @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ X2 ) ) ) ) ) ).

% list_update_append
thf(fact_7627_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs2: list @ A,Ys2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( Ys2
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs2 @ Ys2 )
            = ( append @ A @ Ys2 @ Xs2 ) )
         => ? [N3: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N3 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
                = ( append @ A @ Xs2 @ Ys2 ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_7628_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W: list @ A,R: set @ ( product_prod @ A @ A ),V: list @ A,Z: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W ) @ ( lexord @ A @ R ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V ) @ ( append @ A @ W @ Z ) ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_sufI
thf(fact_7629_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A2: A,Xs2: list @ B,Ys2: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( append @ B @ Xs2 @ Ys2 ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs2 ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs2 ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Ys2 ) ) ) ) ) ).

% horner_sum_append
thf(fact_7630_nths__Cons,axiom,
    ! [A: $tType,X2: A,L2: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X2 @ L2 ) @ A3 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) @ ( cons @ A @ X2 @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L2
          @ ( collect @ nat
            @ ^ [J2: nat] : ( member @ nat @ ( suc @ J2 ) @ A3 ) ) ) ) ) ).

% nths_Cons
thf(fact_7631_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( take @ A @ ( suc @ I ) @ Xs2 )
        = ( append @ A @ ( take @ A @ I @ Xs2 ) @ ( cons @ A @ ( nth @ A @ Xs2 @ I ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_7632_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs2: list @ A,N2: nat,X2: A] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( M != N2 )
         => ( ( nth @ A @ ( append @ A @ ( take @ A @ N2 @ Xs2 ) @ ( append @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ ( drop @ A @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs2 ) ) ) @ M )
            = ( nth @ A @ Xs2 @ M ) ) ) ) ) ).

% nth_repl
thf(fact_7633_pos__n__replace,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,Y2: A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ A ) @ ( append @ A @ ( take @ A @ N2 @ Xs2 ) @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ ( drop @ A @ ( suc @ N2 ) @ Xs2 ) ) ) ) ) ) ).

% pos_n_replace
thf(fact_7634_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X: list @ A] : X ) ) ).

% drop0
thf(fact_7635_drop__drop,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs2: list @ A] :
      ( ( drop @ A @ N2 @ ( drop @ A @ M @ Xs2 ) )
      = ( drop @ A @ ( plus_plus @ nat @ N2 @ M ) @ Xs2 ) ) ).

% drop_drop
thf(fact_7636_drop__Suc__Cons,axiom,
    ! [A: $tType,N2: nat,X2: A,Xs2: list @ A] :
      ( ( drop @ A @ ( suc @ N2 ) @ ( cons @ A @ X2 @ Xs2 ) )
      = ( drop @ A @ N2 @ Xs2 ) ) ).

% drop_Suc_Cons
thf(fact_7637_length__drop,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( drop @ A @ N2 @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) ) ).

% length_drop
thf(fact_7638_drop__update__cancel,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs2: list @ A,X2: A] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs2 @ N2 @ X2 ) )
        = ( drop @ A @ M @ Xs2 ) ) ) ).

% drop_update_cancel
thf(fact_7639_drop__replicate,axiom,
    ! [A: $tType,I: nat,K: nat,X2: A] :
      ( ( drop @ A @ I @ ( replicate @ A @ K @ X2 ) )
      = ( replicate @ A @ ( minus_minus @ nat @ K @ I ) @ X2 ) ) ).

% drop_replicate
thf(fact_7640_drop__eq__Nil2,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N2 @ Xs2 ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) ) ).

% drop_eq_Nil2
thf(fact_7641_drop__eq__Nil,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ( drop @ A @ N2 @ Xs2 )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) ) ).

% drop_eq_Nil
thf(fact_7642_drop__all,axiom,
    ! [A: $tType,Xs2: list @ A,N2: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 )
     => ( ( drop @ A @ N2 @ Xs2 )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_7643_drop__append,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,Ys2: list @ A] :
      ( ( drop @ A @ N2 @ ( append @ A @ Xs2 @ Ys2 ) )
      = ( append @ A @ ( drop @ A @ N2 @ Xs2 ) @ ( drop @ A @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys2 ) ) ) ).

% drop_append
thf(fact_7644_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,X2: A,Xs2: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X2 @ Xs2 ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs2 ) ) ).

% drop_Cons_numeral
thf(fact_7645_nth__drop,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,I: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( drop @ A @ N2 @ Xs2 ) @ I )
        = ( nth @ A @ Xs2 @ ( plus_plus @ nat @ N2 @ I ) ) ) ) ).

% nth_drop
thf(fact_7646_take__add,axiom,
    ! [A: $tType,I: nat,J: nat,Xs2: list @ A] :
      ( ( take @ A @ ( plus_plus @ nat @ I @ J ) @ Xs2 )
      = ( append @ A @ ( take @ A @ I @ Xs2 ) @ ( take @ A @ J @ ( drop @ A @ I @ Xs2 ) ) ) ) ).

% take_add
thf(fact_7647_take__drop,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs2: list @ A] :
      ( ( take @ A @ N2 @ ( drop @ A @ M @ Xs2 ) )
      = ( drop @ A @ M @ ( take @ A @ ( plus_plus @ nat @ N2 @ M ) @ Xs2 ) ) ) ).

% take_drop
thf(fact_7648_drop__take,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs2: list @ A] :
      ( ( drop @ A @ N2 @ ( take @ A @ M @ Xs2 ) )
      = ( take @ A @ ( minus_minus @ nat @ M @ N2 ) @ ( drop @ A @ N2 @ Xs2 ) ) ) ).

% drop_take
thf(fact_7649_drop__0,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs2 )
      = Xs2 ) ).

% drop_0
thf(fact_7650_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N: nat,Xs: list @ A] : ( nths @ A @ Xs @ ( collect @ nat @ ( ord_less_eq @ nat @ N ) ) ) ) ) ).

% drop_eq_nths
thf(fact_7651_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N2: nat,M: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M @ Xs2 ) ) @ ( set2 @ A @ ( drop @ A @ N2 @ Xs2 ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_7652_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N2: nat,Xs2: list @ A,X2: A] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs2 @ N2 @ X2 ) )
        = ( list_update @ A @ ( drop @ A @ M @ Xs2 ) @ ( minus_minus @ nat @ N2 @ M ) @ X2 ) ) ) ).

% drop_update_swap
thf(fact_7653_nths__drop,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,I5: set @ nat] :
      ( ( nths @ A @ ( drop @ A @ N2 @ Xs2 ) @ I5 )
      = ( nths @ A @ Xs2 @ ( image @ nat @ nat @ ( plus_plus @ nat @ N2 ) @ I5 ) ) ) ).

% nths_drop
thf(fact_7654_drop__Cons_H,axiom,
    ! [A: $tType,N2: nat,X2: A,Xs2: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N2 @ ( cons @ A @ X2 @ Xs2 ) )
          = ( cons @ A @ X2 @ Xs2 ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N2 @ ( cons @ A @ X2 @ Xs2 ) )
          = ( drop @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs2 ) ) ) ) ).

% drop_Cons'
thf(fact_7655_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_7656_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( cons @ A @ ( nth @ A @ Xs2 @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs2 ) )
        = ( drop @ A @ I @ Xs2 ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_7657_rotate__drop__take,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N: nat,Xs: list @ A] : ( append @ A @ ( drop @ A @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Xs ) @ ( take @ A @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Xs ) ) ) ) ).

% rotate_drop_take
thf(fact_7658_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I: nat,J: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I @ J )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_7659_id__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( Xs2
        = ( append @ A @ ( take @ A @ I @ Xs2 ) @ ( cons @ A @ ( nth @ A @ Xs2 @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs2 ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_7660_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A,A2: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( list_update @ A @ Xs2 @ I @ A2 )
        = ( append @ A @ ( take @ A @ I @ Xs2 ) @ ( cons @ A @ A2 @ ( drop @ A @ ( suc @ I ) @ Xs2 ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_7661_upto_Opelims,axiom,
    ! [X2: int,Xa: int,Y2: list @ int] :
      ( ( ( upto @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X2 @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X2 @ Xa )
               => ( Y2
                  = ( cons @ int @ X2 @ ( upto @ ( plus_plus @ int @ X2 @ ( one_one @ int ) ) @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X2 @ Xa )
               => ( Y2
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X2 @ Xa ) ) ) ) ) ).

% upto.pelims
thf(fact_7662_upto_Opsimps,axiom,
    ! [I: int,J: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I @ J ) )
     => ( ( ( ord_less_eq @ int @ I @ J )
         => ( ( upto @ I @ J )
            = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I @ J )
         => ( ( upto @ I @ J )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_7663_upto__empty,axiom,
    ! [J: int,I: int] :
      ( ( ord_less @ int @ J @ I )
     => ( ( upto @ I @ J )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_7664_upto__Nil2,axiom,
    ! [I: int,J: int] :
      ( ( ( nil @ int )
        = ( upto @ I @ J ) )
      = ( ord_less @ int @ J @ I ) ) ).

% upto_Nil2
thf(fact_7665_upto__Nil,axiom,
    ! [I: int,J: int] :
      ( ( ( upto @ I @ J )
        = ( nil @ int ) )
      = ( ord_less @ int @ J @ I ) ) ).

% upto_Nil
thf(fact_7666_nth__upto,axiom,
    ! [I: int,K: nat,J: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) @ J )
     => ( ( nth @ int @ ( upto @ I @ J ) @ K )
        = ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_7667_length__upto,axiom,
    ! [I: int,J: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I @ J ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J @ I ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_7668_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_7669_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_7670_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_7671_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_7672_upto__split2,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ J ) @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_7673_upto__split1,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( upto @ J @ K ) ) ) ) ) ).

% upto_split1
thf(fact_7674_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I3: int,J2: int] : ( set2 @ int @ ( upto @ I3 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_7675_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I3: int,J2: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J2 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_7676_upto_Osimps,axiom,
    ( upto
    = ( ^ [I3: int,J2: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I3 @ J2 ) @ ( cons @ int @ I3 @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J2 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_7677_upto_Oelims,axiom,
    ! [X2: int,Xa: int,Y2: list @ int] :
      ( ( ( upto @ X2 @ Xa )
        = Y2 )
     => ( ( ( ord_less_eq @ int @ X2 @ Xa )
         => ( Y2
            = ( cons @ int @ X2 @ ( upto @ ( plus_plus @ int @ X2 @ ( one_one @ int ) ) @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X2 @ Xa )
         => ( Y2
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_7678_upto__rec1,axiom,
    ! [I: int,J: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( upto @ I @ J )
        = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) ) ).

% upto_rec1
thf(fact_7679_upto__rec2,axiom,
    ! [I: int,J: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( upto @ I @ J )
        = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_7680_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I3: int,J2: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_7681_upto__split3,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_7682_take__hd__drop,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( append @ A @ ( take @ A @ N2 @ Xs2 ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N2 @ Xs2 ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N2 ) @ Xs2 ) ) ) ).

% take_hd_drop
thf(fact_7683_map__upds__append1,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys2: list @ B,M: A > ( option @ B ),X2: A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs2 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) @ Ys2 )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ Xs2 @ Ys2 ) @ X2 @ ( some @ B @ ( nth @ B @ Ys2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% map_upds_append1
thf(fact_7684_hd__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N2 @ X2 ) )
        = X2 ) ) ).

% hd_replicate
thf(fact_7685_hd__take,axiom,
    ! [A: $tType,J: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J )
     => ( ( hd @ A @ ( take @ A @ J @ Xs2 ) )
        = ( hd @ A @ Xs2 ) ) ) ).

% hd_take
thf(fact_7686_map__upds__list__update2__drop,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,I: nat,M: A > ( option @ B ),Ys2: list @ B,Y2: B] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I )
     => ( ( map_upds @ A @ B @ M @ Xs2 @ ( list_update @ B @ Ys2 @ I @ Y2 ) )
        = ( map_upds @ A @ B @ M @ Xs2 @ Ys2 ) ) ) ).

% map_upds_list_update2_drop
thf(fact_7687_hd__conv__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs2 )
        = ( nth @ A @ Xs2 @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_7688_hd__drop__conv__nth,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( hd @ A @ ( drop @ A @ N2 @ Xs2 ) )
        = ( nth @ A @ Xs2 @ N2 ) ) ) ).

% hd_drop_conv_nth
thf(fact_7689_hd__rotate__conv__nth,axiom,
    ! [A: $tType,Xs2: list @ A,N2: nat] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rotate @ A @ N2 @ Xs2 ) )
        = ( nth @ A @ Xs2 @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% hd_rotate_conv_nth
thf(fact_7690_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs2
         != ( nil @ A ) )
        & ( Xs2
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( hd @ A @ Xs2 ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_7691_restrict__map__upds,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys2: list @ B,D6: set @ A,M: A > ( option @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ D6 )
       => ( ( restrict_map @ A @ B @ ( map_upds @ A @ B @ M @ Xs2 @ Ys2 ) @ D6 )
          = ( map_upds @ A @ B @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D6 @ ( set2 @ A @ Xs2 ) ) ) @ Xs2 @ Ys2 ) ) ) ) ).

% restrict_map_upds
thf(fact_7692_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,X2: A,D6: set @ A,M: A > ( option @ B )] :
      ( ( ( member @ A @ X2 @ D6 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D6 ) @ X2 @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D6 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )
      & ( ~ ( member @ A @ X2 @ D6 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D6 ) @ X2 @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M @ D6 ) ) ) ) ).

% fun_upd_None_restrict
thf(fact_7693_fun__upd__restrict__conv,axiom,
    ! [A: $tType,B: $tType,X2: A,D6: set @ A,M: A > ( option @ B ),Y2: option @ B] :
      ( ( member @ A @ X2 @ D6 )
     => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D6 ) @ X2 @ Y2 )
        = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D6 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X2 @ Y2 ) ) ) ).

% fun_upd_restrict_conv
thf(fact_7694_restrict__fun__upd,axiom,
    ! [B: $tType,A: $tType,X2: A,D6: set @ A,M: A > ( option @ B ),Y2: option @ B] :
      ( ( ( member @ A @ X2 @ D6 )
       => ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ X2 @ Y2 ) @ D6 )
          = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D6 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X2 @ Y2 ) ) )
      & ( ~ ( member @ A @ X2 @ D6 )
       => ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ X2 @ Y2 ) @ D6 )
          = ( restrict_map @ A @ B @ M @ D6 ) ) ) ) ).

% restrict_fun_upd
thf(fact_7695_fun__upd__restrict,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),D6: set @ A,X2: A,Y2: option @ B] :
      ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D6 ) @ X2 @ Y2 )
      = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D6 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X2 @ Y2 ) ) ).

% fun_upd_restrict
thf(fact_7696_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F4: A > nat,Xs: list @ A] :
            ( if @ nat
            @ ( Xs
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F4 @ ( hd @ A @ Xs ) ) @ ( size_list @ A @ F4 @ ( tl @ A @ Xs ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_7697_map__of__zip__nth,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys2: list @ B,I: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( distinct @ A @ Xs2 )
       => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ B ) @ Ys2 ) )
         => ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Ys2 ) @ ( nth @ A @ Xs2 @ I ) )
            = ( some @ B @ ( nth @ B @ Ys2 @ I ) ) ) ) ) ) ).

% map_of_zip_nth
thf(fact_7698_length__tl,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_7699_tl__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( tl @ A @ ( replicate @ A @ N2 @ X2 ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ X2 ) ) ).

% tl_replicate
thf(fact_7700_take__tl,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( take @ A @ N2 @ ( tl @ A @ Xs2 ) )
      = ( tl @ A @ ( take @ A @ ( suc @ N2 ) @ Xs2 ) ) ) ).

% take_tl
thf(fact_7701_drop__Suc,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( drop @ A @ ( suc @ N2 ) @ Xs2 )
      = ( drop @ A @ N2 @ ( tl @ A @ Xs2 ) ) ) ).

% drop_Suc
thf(fact_7702_tl__take,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( tl @ A @ ( take @ A @ N2 @ Xs2 ) )
      = ( take @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( tl @ A @ Xs2 ) ) ) ).

% tl_take
thf(fact_7703_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs: list @ A] :
            ( if @ nat
            @ ( Xs
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_7704_nth__tl,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs2 ) @ N2 )
        = ( nth @ A @ Xs2 @ ( suc @ N2 ) ) ) ) ).

% nth_tl
thf(fact_7705_take__Suc,axiom,
    ! [A: $tType,Xs2: list @ A,N2: nat] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N2 ) @ Xs2 )
        = ( cons @ A @ ( hd @ A @ Xs2 ) @ ( take @ A @ N2 @ ( tl @ A @ Xs2 ) ) ) ) ) ).

% take_Suc
thf(fact_7706_list__encode_Opelims,axiom,
    ! [X2: list @ nat,Y2: nat] :
      ( ( ( nat_list_encode @ X2 )
        = Y2 )
     => ( ( accp @ ( list @ nat ) @ nat_list_encode_rel @ X2 )
       => ( ( ( X2
              = ( nil @ nat ) )
           => ( ( Y2
                = ( zero_zero @ nat ) )
             => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( nil @ nat ) ) ) )
         => ~ ! [X3: nat,Xs3: list @ nat] :
                ( ( X2
                  = ( cons @ nat @ X3 @ Xs3 ) )
               => ( ( Y2
                    = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X3 @ ( nat_list_encode @ Xs3 ) ) ) ) )
                 => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( cons @ nat @ X3 @ Xs3 ) ) ) ) ) ) ) ).

% list_encode.pelims
thf(fact_7707_upt__rec__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_7708_tl__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( tl @ nat @ ( upt @ M @ N2 ) )
      = ( upt @ ( suc @ M ) @ N2 ) ) ).

% tl_upt
thf(fact_7709_hd__upt,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( hd @ nat @ ( upt @ I @ J ) )
        = I ) ) ).

% hd_upt
thf(fact_7710_drop__upt,axiom,
    ! [M: nat,I: nat,J: nat] :
      ( ( drop @ nat @ M @ ( upt @ I @ J ) )
      = ( upt @ ( plus_plus @ nat @ I @ M ) @ J ) ) ).

% drop_upt
thf(fact_7711_length__upt,axiom,
    ! [I: nat,J: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I @ J ) )
      = ( minus_minus @ nat @ J @ I ) ) ).

% length_upt
thf(fact_7712_take__upt,axiom,
    ! [I: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ M ) @ N2 )
     => ( ( take @ nat @ M @ ( upt @ I @ N2 ) )
        = ( upt @ I @ ( plus_plus @ nat @ I @ M ) ) ) ) ).

% take_upt
thf(fact_7713_upt__conv__Nil,axiom,
    ! [J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( upt @ I @ J )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_7714_upt__eq__Nil__conv,axiom,
    ! [I: nat,J: nat] :
      ( ( ( upt @ I @ J )
        = ( nil @ nat ) )
      = ( ( J
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J @ I ) ) ) ).

% upt_eq_Nil_conv
thf(fact_7715_nth__upt,axiom,
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J )
     => ( ( nth @ nat @ ( upt @ I @ J ) @ K )
        = ( plus_plus @ nat @ I @ K ) ) ) ).

% nth_upt
thf(fact_7716_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N ) @ M3 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_7717_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N: nat,M3: nat] : ( set2 @ nat @ ( upt @ N @ ( suc @ M3 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_7718_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N ) @ ( suc @ M3 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_7719_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast_upt
thf(fact_7720_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) ) ) ) ).

% atMost_upto
thf(fact_7721_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N2: nat,Ns: list @ nat,Q2: nat] :
      ( ( ( cons @ nat @ M @ ( cons @ nat @ N2 @ Ns ) )
        = ( upt @ M @ Q2 ) )
      = ( ( cons @ nat @ N2 @ Ns )
        = ( upt @ ( suc @ M ) @ Q2 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_7722_upt__conv__Cons,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( upt @ I @ J )
        = ( cons @ nat @ I @ ( upt @ ( suc @ I ) @ J ) ) ) ) ).

% upt_conv_Cons
thf(fact_7723_upt__0,axiom,
    ! [I: nat] :
      ( ( upt @ I @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_7724_enumerate__eq__zip,axiom,
    ! [A: $tType] :
      ( ( enumerate @ A )
      = ( ^ [N: nat,Xs: list @ A] : ( zip @ nat @ A @ ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) @ Xs ) ) ) ).

% enumerate_eq_zip
thf(fact_7725_upt__add__eq__append,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( upt @ I @ ( plus_plus @ nat @ J @ K ) )
        = ( append @ nat @ ( upt @ I @ J ) @ ( upt @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_7726_upt__eq__Cons__conv,axiom,
    ! [I: nat,J: nat,X2: nat,Xs2: list @ nat] :
      ( ( ( upt @ I @ J )
        = ( cons @ nat @ X2 @ Xs2 ) )
      = ( ( ord_less @ nat @ I @ J )
        & ( I = X2 )
        & ( ( upt @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) @ J )
          = Xs2 ) ) ) ).

% upt_eq_Cons_conv
thf(fact_7727_upt__rec,axiom,
    ( upt
    = ( ^ [I3: nat,J2: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I3 @ J2 ) @ ( cons @ nat @ I3 @ ( upt @ ( suc @ I3 ) @ J2 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_7728_upt__Suc__append,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( upt @ I @ ( suc @ J ) )
        = ( append @ nat @ ( upt @ I @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_7729_upt__Suc,axiom,
    ! [I: nat,J: nat] :
      ( ( ( ord_less_eq @ nat @ I @ J )
       => ( ( upt @ I @ ( suc @ J ) )
          = ( append @ nat @ ( upt @ I @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I @ J )
       => ( ( upt @ I @ ( suc @ J ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_7730_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_7731_map__fst__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs2 ) )
      = ( upt @ N2 @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% map_fst_enumerate
thf(fact_7732_nth__map,axiom,
    ! [B: $tType,A: $tType,N2: nat,Xs2: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs2 ) @ N2 )
        = ( F2 @ ( nth @ A @ Xs2 @ N2 ) ) ) ) ).

% nth_map
thf(fact_7733_map__replicate__trivial,axiom,
    ! [A: $tType,X2: A,I: nat] :
      ( ( map @ nat @ A
        @ ^ [I3: nat] : X2
        @ ( upt @ ( zero_zero @ nat ) @ I ) )
      = ( replicate @ A @ I @ X2 ) ) ).

% map_replicate_trivial
thf(fact_7734_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N2: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I3: nat] : ( F2 @ ( suc @ I3 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% map_upt_Suc
thf(fact_7735_map__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs2 ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
      = Xs2 ) ).

% map_nth
thf(fact_7736_nth__map__upt,axiom,
    ! [A: $tType,I: nat,N2: nat,M: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ N2 @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M @ N2 ) ) @ I )
        = ( F2 @ ( plus_plus @ nat @ M @ I ) ) ) ) ).

% nth_map_upt
thf(fact_7737_map__upt__eqI,axiom,
    ! [A: $tType,Xs2: list @ A,N2: nat,M: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( minus_minus @ nat @ N2 @ M ) )
     => ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( ( nth @ A @ Xs2 @ I4 )
              = ( F2 @ ( plus_plus @ nat @ M @ I4 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M @ N2 ) )
          = Xs2 ) ) ) ).

% map_upt_eqI
thf(fact_7738_transpose__rectangle,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),N2: nat] :
      ( ( ( Xs2
          = ( nil @ ( list @ A ) ) )
       => ( N2
          = ( zero_zero @ nat ) ) )
     => ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ I4 ) )
              = N2 ) )
       => ( ( transpose @ A @ Xs2 )
          = ( map @ nat @ ( list @ A )
            @ ^ [I3: nat] :
                ( map @ nat @ A
                @ ^ [J2: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs2 @ J2 ) @ I3 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% transpose_rectangle
thf(fact_7739_find__Some__iff2,axiom,
    ! [A: $tType,X2: A,P: A > $o,Xs2: list @ A] :
      ( ( ( some @ A @ X2 )
        = ( find @ A @ P @ Xs2 ) )
      = ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( P @ ( nth @ A @ Xs2 @ I3 ) )
            & ( X2
              = ( nth @ A @ Xs2 @ I3 ) )
            & ! [J2: nat] :
                ( ( ord_less @ nat @ J2 @ I3 )
               => ~ ( P @ ( nth @ A @ Xs2 @ J2 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_7740_map__Suc__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M @ N2 ) )
      = ( upt @ ( suc @ M ) @ ( suc @ N2 ) ) ) ).

% map_Suc_upt
thf(fact_7741_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( n_lists @ A @ ( suc @ N2 ) @ Xs2 )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys3: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y: A] : ( cons @ A @ Y @ Ys3 )
              @ Xs2 )
          @ ( n_lists @ A @ N2 @ Xs2 ) ) ) ) ).

% n_lists.simps(2)
thf(fact_7742_map__add__upt,axiom,
    ! [N2: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I3: nat] : ( plus_plus @ nat @ I3 @ N2 )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N2 @ ( plus_plus @ nat @ M @ N2 ) ) ) ).

% map_add_upt
thf(fact_7743_map__decr__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( map @ nat @ nat
        @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N2 ) ) )
      = ( upt @ M @ N2 ) ) ).

% map_decr_upt
thf(fact_7744_enumerate__replicate__eq,axiom,
    ! [A: $tType,N2: nat,M: nat,A2: A] :
      ( ( enumerate @ A @ N2 @ ( replicate @ A @ M @ A2 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q4: nat] : ( product_Pair @ nat @ A @ Q4 @ A2 )
        @ ( upt @ N2 @ ( plus_plus @ nat @ N2 @ M ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_7745_find__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,X2: A] :
      ( ( ( find @ A @ P @ Xs2 )
        = ( some @ A @ X2 ) )
      = ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( P @ ( nth @ A @ Xs2 @ I3 ) )
            & ( X2
              = ( nth @ A @ Xs2 @ I3 ) )
            & ! [J2: nat] :
                ( ( ord_less @ nat @ J2 @ I3 )
               => ~ ( P @ ( nth @ A @ Xs2 @ J2 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_7746_length__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs ) )
        @ Xs2
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_7747_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs: list @ A,A7: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P4: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P4 ) @ A7 )
              @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ) ).

% nths_def
thf(fact_7748_length__filter__less,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A,P: A > $o] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
     => ( ~ ( P @ X2 )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% length_filter_less
thf(fact_7749_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X: A] :
                ~ ( P @ X )
            @ Xs2 ) ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% sum_length_filter_compl
thf(fact_7750_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_filter_le
thf(fact_7751_set__minus__filter__out,axiom,
    ! [A: $tType,Xs2: list @ A,Y2: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X: A] : ( X != Y2 )
          @ Xs2 ) ) ) ).

% set_minus_filter_out
thf(fact_7752_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: nat > $o,Xs2: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P4: product_prod @ A @ nat] : ( P @ ( suc @ ( product_snd @ A @ nat @ P4 ) ) )
          @ ( zip @ A @ nat @ Xs2 @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P4: product_prod @ A @ nat] : ( P @ ( product_snd @ A @ nat @ P4 ) )
          @ ( zip @ A @ nat @ Xs2 @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_7753_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P6: A > $o,Xs: list @ A] :
            ( nths @ A @ Xs
            @ ( collect @ nat
              @ ^ [I3: nat] :
                  ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( P6 @ ( nth @ A @ Xs @ I3 ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_7754_length__filter__conv__card,axiom,
    ! [A: $tType,P2: A > $o,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P2 @ Xs2 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I3: nat] :
              ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
              & ( P2 @ ( nth @ A @ Xs2 @ I3 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_7755_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F4: B > A,A4: A,Xs: list @ B] :
              ( foldr @ B @ A
              @ ^ [X: B,B3: A] : ( plus_plus @ A @ ( F4 @ X ) @ ( times_times @ A @ A4 @ B3 ) )
              @ Xs
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_7756_nths__shift__lemma,axiom,
    ! [A: $tType,A3: set @ nat,Xs2: list @ A,I: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P4: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P4 ) @ A3 )
          @ ( zip @ A @ nat @ Xs2 @ ( upt @ I @ ( plus_plus @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P4: product_prod @ A @ nat] : ( member @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P4 ) @ I ) @ A3 )
          @ ( zip @ A @ nat @ Xs2 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_7757_transpose__max__length,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( transpose @ A @ Xs2 )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X: list @ A] :
              ( X
             != ( nil @ A ) )
          @ Xs2 ) ) ) ).

% transpose_max_length
thf(fact_7758_nth__transpose,axiom,
    ! [A: $tType,I: nat,Xs2: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs2 ) @ I )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs: list @ A] : ( nth @ A @ Xs @ I )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
            @ Xs2 ) ) ) ) ).

% nth_transpose
thf(fact_7759_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys3: list @ B] :
                  ( Ys3
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_7760_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_7761_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs2: list @ B,F2: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs2 ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X: B] :
                        ( ( F2 @ A2 )
                        = ( F2 @ X ) )
                    @ Xs2 ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ ( remove1 @ B @ A2 @ Xs2 ) )
                = Xs2 ) ) ) ) ) ).

% insort_key_remove1
thf(fact_7762_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Xs2: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs2 ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ).

% sorted_insort_key
thf(fact_7763_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,X2: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X2 @ Xs2 ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_7764_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G: ( list @ B ) > A,Xs2: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X: B] :
                  ( ( F2 @ X )
                  = ( G @ Xs2 ) )
              @ Xs2 ) ) ) ) ).

% sorted_map_same
thf(fact_7765_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
          = ( sorted_wrt @ B
            @ ^ [X: B,Y: B] : ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
            @ Xs2 ) ) ) ).

% sorted_map
thf(fact_7766_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) ) ) ) ) ).

% sorted_filter
thf(fact_7767_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs2: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X: A] :
                ( X
                = ( G @ Xs2 ) )
            @ Xs2 ) ) ) ).

% sorted_same
thf(fact_7768_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P6: A > A > $o,Xs: list @ A] :
          ! [I3: nat,J2: nat] :
            ( ( ord_less @ nat @ I3 @ J2 )
           => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( P6 @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Xs @ J2 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_7769_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: A > A > $o,Xs2: list @ A,I: nat,J: nat] :
      ( ( sorted_wrt @ A @ P @ Xs2 )
     => ( ( ord_less @ nat @ I @ J )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( P @ ( nth @ A @ Xs2 @ I ) @ ( nth @ A @ Xs2 @ J ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_7770_sorted__upt,axiom,
    ! [M: nat,N2: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N2 ) ) ).

% sorted_upt
thf(fact_7771_sorted__wrt__upt,axiom,
    ! [M: nat,N2: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M @ N2 ) ) ).

% sorted_wrt_upt
thf(fact_7772_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_7773_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_7774_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_7775_sorted__upto,axiom,
    ! [M: int,N2: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N2 ) ) ).

% sorted_upto
thf(fact_7776_sorted__wrt__upto,axiom,
    ! [I: int,J: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I @ J ) ) ).

% sorted_wrt_upto
thf(fact_7777_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X2 @ Y2 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y2 @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_7778_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_7779_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L2 )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L2 )
            & ( distinct @ A @ L2 ) ) ) ) ).

% strict_sorted_iff
thf(fact_7780_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X: A] : X
              @ X2
              @ Xs2 ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% sorted_insort
thf(fact_7781_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I5: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs2 @ I5 ) ) ) ) ).

% sorted_nths
thf(fact_7782_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs2 ) ) ) ) ).

% sorted_remove1
thf(fact_7783_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_7784_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_7785_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs2 ) ) ) ) ).

% sorted_remdups_adj
thf(fact_7786_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N2: nat,X2: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N2 @ X2 ) ) ) ).

% sorted_replicate
thf(fact_7787_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs2 ) ) ) ) ).

% sorted_tl
thf(fact_7788_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X2 @ Ys2 ) )
          = ( ! [X: A] :
                ( ( member @ A @ X @ ( set2 @ A @ Ys2 ) )
               => ( ord_less_eq @ A @ X2 @ X ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys2 ) ) ) ) ).

% sorted_simps(2)
thf(fact_7789_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X2 @ Ys2 ) )
          = ( ! [X: A] :
                ( ( member @ A @ X @ ( set2 @ A @ Ys2 ) )
               => ( ord_less @ A @ X2 @ X ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys2 ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_7790_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs2 )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys2 )
           => ( ( ( set2 @ A @ Ys2 )
                = ( set2 @ A @ Xs2 ) )
             => ( Ys2 = Xs2 ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_7791_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( distinct @ A @ Xs2 )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys2 )
             => ( ( distinct @ A @ Ys2 )
               => ( ( ( set2 @ A @ Xs2 )
                    = ( set2 @ A @ Ys2 ) )
                 => ( Xs2 = Ys2 ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_7792_sorted__wrt01,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs2 ) ) ).

% sorted_wrt01
thf(fact_7793_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs2 @ Ys2 ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys2 )
            & ! [X: A] :
                ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
               => ! [Y: A] :
                    ( ( member @ A @ Y @ ( set2 @ A @ Ys2 ) )
                   => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ).

% sorted_append
thf(fact_7794_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,N2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N2 @ Xs2 ) ) ) ) ).

% sorted_drop
thf(fact_7795_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,N2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N2 @ Xs2 ) ) ) ) ).

% sorted_take
thf(fact_7796_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I3: nat,J2: nat] :
                ( ( ord_less @ nat @ I3 @ J2 )
               => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I3 ) @ ( nth @ A @ Xs2 @ J2 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_7797_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% sorted01
thf(fact_7798_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ? [X3: list @ A] :
              ( ( ( set2 @ A @ X3 )
                = A3 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X3 )
              & ( distinct @ A @ X3 )
              & ! [Y4: list @ A] :
                  ( ( ( ( set2 @ A @ Y4 )
                      = A3 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y4 )
                    & ( distinct @ A @ Y4 ) )
                 => ( Y4 = X3 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_7799_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( distinct @ A @ Xs2 )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs2 ) )
              = Xs2 ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_7800_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,P: B > $o,X2: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( ( P @ X2 )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs2 ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X2 @ ( filter2 @ B @ P @ Xs2 ) ) ) ) ) ) ).

% filter_insort
thf(fact_7801_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs2: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs2 ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X: A] : X
                @ A2
                @ ( remove1 @ A @ A2 @ Xs2 ) )
              = Xs2 ) ) ) ) ).

% insort_remove1
thf(fact_7802_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I3: nat] :
                ( ( ord_less @ nat @ ( suc @ I3 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I3 ) @ ( nth @ A @ Xs2 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_7803_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I ) @ ( nth @ A @ Xs2 @ J ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_7804_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I3: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J2 )
               => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I3 ) @ ( nth @ A @ Xs2 @ J2 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_7805_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ~ ! [L3: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L3 )
               => ( ( ( set2 @ A @ L3 )
                    = A3 )
                 => ( ( size_size @ ( list @ A ) @ L3 )
                   != ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_7806_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I @ ( nth @ nat @ Ns @ I ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_7807_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ? [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
                & ( P @ X4 ) )
           => ( ( find @ A @ P @ Xs2 )
              = ( some @ A
                @ ( lattic643756798350308766er_Min @ A
                  @ ( collect @ A
                    @ ^ [X: A] :
                        ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
                        & ( P @ X ) ) ) ) ) ) ) ) ) ).

% sorted_find_Min
thf(fact_7808_sorted__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs2 ) ) ) ).

% sorted_enumerate
thf(fact_7809_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,Ys2: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs2 ) @ ( set2 @ B @ Ys2 ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys2 ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys2 ) )
                 => ( ( ( set2 @ B @ Xs2 )
                      = ( set2 @ B @ Ys2 ) )
                   => ( Xs2 = Ys2 ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_7810_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,L2: list @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L2 )
              & ( ( set2 @ A @ L2 )
                = A3 )
              & ( ( size_size @ ( list @ A ) @ L2 )
                = ( finite_card @ A @ A3 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A3 )
              = L2 ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_7811_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X: A] : X
                @ A2
                @ Xs2 )
              = ( append @ A @ Xs2 @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_7812_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I: nat,J: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) )
       => ( ( ord_less @ nat @ J
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
                @ Xs2 ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs2 ) @ I ) @ J )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs2 @ J ) @ I ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_7813_transpose__column,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys3: list @ A] : ( nth @ A @ Ys3 @ I )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs2 ) ) )
          = ( nth @ ( list @ A ) @ Xs2 @ I ) ) ) ) ).

% transpose_column
thf(fact_7814_drop__rev,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( drop @ A @ N2 @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) @ Xs2 ) ) ) ).

% drop_rev
thf(fact_7815_rev__drop,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( rev @ A @ ( drop @ A @ I @ Xs2 ) )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I ) @ ( rev @ A @ Xs2 ) ) ) ).

% rev_drop
thf(fact_7816_rev__take,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( rev @ A @ ( take @ A @ I @ Xs2 ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I ) @ ( rev @ A @ Xs2 ) ) ) ).

% rev_take
thf(fact_7817_take__rev,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( take @ A @ N2 @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) @ Xs2 ) ) ) ).

% take_rev
thf(fact_7818_rotate__rev,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( rotate @ A @ N2 @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( rotate @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) @ Xs2 ) ) ) ).

% rotate_rev
thf(fact_7819_sorted__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) ) ) ).

% sorted_transpose
thf(fact_7820_rev__nth,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rev @ A @ Xs2 ) @ N2 )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( suc @ N2 ) ) ) ) ) ).

% rev_nth
thf(fact_7821_rev__update,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,Y2: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs2 @ K @ Y2 ) )
        = ( list_update @ A @ ( rev @ A @ Xs2 ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ K ) @ ( one_one @ nat ) ) @ Y2 ) ) ) ).

% rev_update
thf(fact_7822_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
          = ( ! [I3: nat] :
                ( ( ord_less @ nat @ ( suc @ I3 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ ( suc @ I3 ) ) @ ( nth @ A @ Xs2 @ I3 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_7823_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ J ) @ ( nth @ A @ Xs2 @ I ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_7824_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
          = ( ! [I3: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J2 )
               => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ J2 ) @ ( nth @ A @ Xs2 @ I3 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_7825_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Y2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
         => ( ( ( Xs2
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs2 @ Y2 )
                = Y2 ) )
            & ( ( Xs2
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs2 @ Y2 )
                = ( ord_max @ A @ ( nth @ A @ Xs2 @ ( zero_zero @ nat ) ) @ Y2 ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_7826_length__transpose__sorted,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ( Xs2
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs2
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_7827_transpose__column__length,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs2 ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ I ) ) ) ) ) ).

% transpose_column_length
thf(fact_7828_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X3: nat,Y3: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y3 )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_7829_transpose__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs2 ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X: list @ A] :
              ( X
             != ( nil @ A ) )
          @ Xs2 ) ) ) ).

% transpose_transpose
thf(fact_7830_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_7831_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X: A] :
                ( ( member @ A @ X @ ( set2 @ A @ Ns ) )
               => ( X
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_7832_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X2: A,Xs2: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X2 @ Xs2 ) )
          = ( plus_plus @ A @ X2 @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% sum_list.Cons
thf(fact_7833_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ A,Ys2: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs2 @ Ys2 ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ ( groups8242544230860333062m_list @ A @ Ys2 ) ) ) ) ).

% sum_list_append
thf(fact_7834_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X: B] : ( zero_zero @ A )
              @ Xs2 ) )
          = ( zero_zero @ A ) ) ) ).

% sum_list_0
thf(fact_7835_sum__list__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N2 ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X: nat] : X
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum_list_upt
thf(fact_7836_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ).

% sorted_takeWhile
thf(fact_7837_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_7838_nth__length__takeWhile,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ~ ( P @ ( nth @ A @ Xs2 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_7839_takeWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs2: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P @ Xs2 ) @ J )
        = ( nth @ A @ Xs2 @ J ) ) ) ).

% takeWhile_nth
thf(fact_7840_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_takeWhile_le
thf(fact_7841_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A,Xs2: list @ A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
         => ( ord_less_eq @ A @ X2 @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% member_le_sum_list
thf(fact_7842_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_7843_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs2 )
              = ( zero_zero @ A ) )
            = ( ! [X: A] :
                  ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
                 => ( X
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_7844_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_7845_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N2 @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_7846_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs2: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs2 ) ) ) ) ).

% sum_list_abs
thf(fact_7847_sum__list__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: B > A,G: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X: B] : ( minus_minus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ Xs2 ) )
          = ( minus_minus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs2 ) ) ) ) ) ).

% sum_list_subtractf
thf(fact_7848_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,C2: A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X: B] : ( times_times @ A @ ( F2 @ X ) @ C2 )
              @ Xs2 ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_7849_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X: B] : ( times_times @ A @ C2 @ ( F2 @ X ) )
              @ Xs2 ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_7850_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: B > A,G: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X: B] : ( plus_plus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ Xs2 ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs2 ) ) ) ) ) ).

% sum_list_addf
thf(fact_7851_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs2 ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) ) ) ).

% sum_list_filter_le_nat
thf(fact_7852_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs2: list @ A,F2: A > B,G: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs2 ) ) ) ) ) ).

% sum_list_mono
thf(fact_7853_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [F2: B > A,P: B > $o,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) ) )
          = ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X: B] : ( if @ A @ ( P @ X ) @ ( F2 @ X ) @ ( zero_zero @ A ) )
              @ Xs2 ) ) ) ) ).

% sum_list_map_filter'
thf(fact_7854_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_7855_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs2: list @ A,F2: A > B,G: A > B] :
          ( ( Xs2
           != ( nil @ A ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
               => ( ord_less @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs2 ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_7856_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs2: list @ A] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ J )
         => ( P @ ( nth @ A @ Xs2 @ I4 ) ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_7857_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ B,P: B > $o,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs2 ) )
             => ( ~ ( P @ X3 )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_7858_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A,P: A > $o] :
      ( ! [I4: nat] :
          ( ( ord_less @ nat @ I4 @ N2 )
         => ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( P @ ( nth @ A @ Xs2 @ I4 ) ) ) )
     => ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ~ ( P @ ( nth @ A @ Xs2 @ N2 ) ) )
       => ( ( takeWhile @ A @ P @ Xs2 )
          = ( take @ A @ N2 @ Xs2 ) ) ) ) ).

% takeWhile_eq_take_P_nth
thf(fact_7859_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X2: B,Xs2: list @ B,F2: B > A] :
          ( ( member @ B @ X2 @ ( set2 @ B @ Xs2 ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
            = ( plus_plus @ A @ ( F2 @ X2 ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X2 @ Xs2 ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_7860_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F4: B > nat,Xs: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F4 @ Xs ) ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_7861_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R: B,Xs2: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X: C] : R
              @ Xs2 ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs2 ) ) @ R ) ) ) ).

% sum_list_triv
thf(fact_7862_sum__list__Suc,axiom,
    ! [A: $tType,F2: A > nat,Xs2: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X: A] : ( suc @ ( F2 @ X ) )
          @ Xs2 ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% sum_list_Suc
thf(fact_7863_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_7864_card__length__sum__list__rec,axiom,
    ! [M: nat,N5: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L )
                  = N5 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L )
                    = N5 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L ) @ ( one_one @ nat ) )
                    = N5 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_7865_card__length__sum__list,axiom,
    ! [M: nat,N5: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L )
                = M )
              & ( ( groups8242544230860333062m_list @ nat @ L )
                = N5 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N5 @ M ) @ ( one_one @ nat ) ) @ N5 ) ) ).

% card_length_sum_list
thf(fact_7866_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs2: list @ A,X2: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs2 @ K @ X2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ X2 ) @ ( nth @ A @ Xs2 @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_7867_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) )
         => ( ( filter2 @ B
              @ ^ [X: B] : ( ord_less @ A @ T2 @ ( F2 @ X ) )
              @ Xs2 )
            = ( takeWhile @ B
              @ ^ [X: B] : ( ord_less @ A @ T2 @ ( F2 @ X ) )
              @ Xs2 ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_7868_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs2: list @ A,X6: set @ A,F2: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ X6 )
     => ( ( finite_finite @ A @ X6 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X: A] : ( times_times @ nat @ ( count_list @ A @ Xs2 @ X ) @ ( F2 @ X ) )
            @ X6 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_7869_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: A > nat,Xs2: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X: A] : ( times_times @ nat @ ( count_list @ A @ Xs2 @ X ) @ ( F2 @ X ) )
        @ ( set2 @ A @ Xs2 ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_7870_count__notin,axiom,
    ! [A: $tType,X2: A,Xs2: list @ A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
     => ( ( count_list @ A @ Xs2 @ X2 )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_7871_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y2: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y2 )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_7872_count__le__length,axiom,
    ! [A: $tType,Xs2: list @ A,X2: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs2 @ X2 ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% count_le_length
thf(fact_7873_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs2: list @ A] :
      ( ( ( X2 = Y2 )
       => ( ( count_list @ A @ ( cons @ A @ X2 @ Xs2 ) @ Y2 )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs2 @ Y2 ) @ ( one_one @ nat ) ) ) )
      & ( ( X2 != Y2 )
       => ( ( count_list @ A @ ( cons @ A @ X2 @ Xs2 ) @ Y2 )
          = ( count_list @ A @ Xs2 @ Y2 ) ) ) ) ).

% count_list.simps(2)
thf(fact_7874_quotient__of__def,axiom,
    ( quotient_of
    = ( ^ [X: rat] :
          ( the @ ( product_prod @ int @ int )
          @ ^ [Pair: product_prod @ int @ int] :
              ( ( X
                = ( fract @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) )
              & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Pair ) )
              & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) ) ) ) ) ).

% quotient_of_def
thf(fact_7875_Rat_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o @ ratrel
    @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
    @ ^ [X: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ X ) ) )
    @ ^ [X: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ X ) ) ) ) ).

% Rat.positive.rsp
thf(fact_7876_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( algebr8660921524188924756oprime @ A @ C2 @ A2 )
            & ( algebr8660921524188924756oprime @ A @ C2 @ B2 ) ) ) ) ).

% coprime_mult_right_iff
thf(fact_7877_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
            & ( algebr8660921524188924756oprime @ A @ B2 @ C2 ) ) ) ) ).

% coprime_mult_left_iff
thf(fact_7878_coprime__abs__left__iff,axiom,
    ! [K: int,L2: int] :
      ( ( algebr8660921524188924756oprime @ int @ ( abs_abs @ int @ K ) @ L2 )
      = ( algebr8660921524188924756oprime @ int @ K @ L2 ) ) ).

% coprime_abs_left_iff
thf(fact_7879_coprime__abs__right__iff,axiom,
    ! [K: int,L2: int] :
      ( ( algebr8660921524188924756oprime @ int @ K @ ( abs_abs @ int @ L2 ) )
      = ( algebr8660921524188924756oprime @ int @ K @ L2 ) ) ).

% coprime_abs_right_iff
thf(fact_7880_coprime__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ A2 )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_self
thf(fact_7881_coprime__mod__left__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_left_iff
thf(fact_7882_coprime__mod__right__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ A2 @ ( modulo_modulo @ A @ B2 @ A2 ) )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_right_iff
thf(fact_7883_coprime__power__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( power_power @ A @ B2 @ N2 ) )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_right_iff
thf(fact_7884_coprime__power__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( power_power @ A @ A2 @ N2 ) @ B2 )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_left_iff
thf(fact_7885_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_right_iff
thf(fact_7886_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( zero_zero @ A ) @ A2 )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_left_iff
thf(fact_7887_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mult_self_left_iff
thf(fact_7888_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mult_self_right_iff
thf(fact_7889_coprime__left__2__iff__odd,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% coprime_left_2_iff_odd
thf(fact_7890_coprime__right__2__iff__odd,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% coprime_right_2_iff_odd
thf(fact_7891_normalize__stable,axiom,
    ! [Q2: int,P2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Q2 )
     => ( ( algebr8660921524188924756oprime @ int @ P2 @ Q2 )
       => ( ( normalize @ ( product_Pair @ int @ int @ P2 @ Q2 ) )
          = ( product_Pair @ int @ int @ P2 @ Q2 ) ) ) ) ).

% normalize_stable
thf(fact_7892_coprime__common__divisor__int,axiom,
    ! [A2: int,B2: int,X2: int] :
      ( ( algebr8660921524188924756oprime @ int @ A2 @ B2 )
     => ( ( dvd_dvd @ int @ X2 @ A2 )
       => ( ( dvd_dvd @ int @ X2 @ B2 )
         => ( ( abs_abs @ int @ X2 )
            = ( one_one @ int ) ) ) ) ) ).

% coprime_common_divisor_int
thf(fact_7893_div__gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( A2
             != ( zero_zero @ A ) )
            | ( B2
             != ( zero_zero @ A ) ) )
         => ( algebr8660921524188924756oprime @ A @ ( divide_divide @ A @ A2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) @ ( divide_divide @ A @ B2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ) ).

% div_gcd_coprime
thf(fact_7894_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( power @ B )
        & ( power @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R3 @ ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ A @ B @ ( nat > A ) @ ( nat > B ) @ R3
              @ ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
                @ R3 )
              @ ( power_power @ A )
              @ ( power_power @ B ) ) ) ) ) ).

% power_transfer
thf(fact_7895_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( gcd_gcd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_right_right_cancel
thf(fact_7896_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( gcd_gcd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_right_left_cancel
thf(fact_7897_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_left_right_cancel
thf(fact_7898_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_left_left_cancel
thf(fact_7899_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ring_1 @ B )
        & ( ring_1 @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R3 @ ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 @ ( uminus_uminus @ A ) @ ( uminus_uminus @ B ) )
               => ( bNF_rel_fun @ int @ int @ A @ B
                  @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
                  @ R3
                  @ ( ring_1_of_int @ A )
                  @ ( ring_1_of_int @ B ) ) ) ) ) ) ) ).

% transfer_rule_of_int
thf(fact_7900_coprime__1__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ ( one_one @ A ) @ A2 ) ) ).

% coprime_1_left
thf(fact_7901_coprime__1__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ A2 @ ( one_one @ A ) ) ) ).

% coprime_1_right
thf(fact_7902_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ A2 ) ) ).

% coprime_add_one_left
thf(fact_7903_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_add_one_right
thf(fact_7904_coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ! [C4: A] :
              ( ( dvd_dvd @ A @ C4 @ A2 )
             => ( ( dvd_dvd @ A @ C4 @ B2 )
               => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% coprimeI
thf(fact_7905_coprime__def,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A4: A,B3: A] :
            ! [C3: A] :
              ( ( dvd_dvd @ A @ C3 @ A4 )
             => ( ( dvd_dvd @ A @ C3 @ B3 )
               => ( dvd_dvd @ A @ C3 @ ( one_one @ A ) ) ) ) ) ) ) ).

% coprime_def
thf(fact_7906_not__coprimeE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
         => ~ ! [C4: A] :
                ( ( dvd_dvd @ A @ C4 @ A2 )
               => ( ( dvd_dvd @ A @ C4 @ B2 )
                 => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) ) ) ) ).

% not_coprimeE
thf(fact_7907_not__coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ~ ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
             => ~ ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ) ).

% not_coprimeI
thf(fact_7908_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( ( algebr8660921524188924756oprime @ A @ X2 @ Y2 )
            = ( dvd_dvd @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_left
thf(fact_7909_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,D3: A,A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ D3 )
         => ( ! [E: A] :
                ( ~ ( dvd_dvd @ A @ E @ ( one_one @ A ) )
               => ( ( dvd_dvd @ A @ E @ A2 )
                 => ( ( dvd_dvd @ A @ E @ B2 )
                   => ( dvd_dvd @ A @ E @ C2 ) ) ) )
           => ( ! [E: A] :
                  ( ~ ( dvd_dvd @ A @ E @ ( one_one @ A ) )
                 => ( ( dvd_dvd @ A @ E @ A2 )
                   => ( ( dvd_dvd @ A @ E @ B2 )
                     => ( dvd_dvd @ A @ E @ D3 ) ) ) )
             => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ) ).

% coprime_imp_coprime
thf(fact_7910_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [Y2: A,X2: A] :
          ( ( dvd_dvd @ A @ Y2 @ X2 )
         => ( ( algebr8660921524188924756oprime @ A @ X2 @ Y2 )
            = ( dvd_dvd @ A @ Y2 @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_right
thf(fact_7911_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( dvd_dvd @ A @ C2 @ ( one_one @ A ) ) ) ) ) ) ).

% coprime_common_divisor
thf(fact_7912_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% is_unit_left_imp_coprime
thf(fact_7913_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% is_unit_right_imp_coprime
thf(fact_7914_coprime__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [B3: A,A4: A] : ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ) ).

% coprime_commute
thf(fact_7915_coprime__divisors,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D3: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ B2 @ D3 )
           => ( ( algebr8660921524188924756oprime @ A @ C2 @ D3 )
             => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ) ).

% coprime_divisors
thf(fact_7916_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% coprime_dvd_mult_right_iff
thf(fact_7917_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% coprime_dvd_mult_left_iff
thf(fact_7918_divides__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
             => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% divides_mult
thf(fact_7919_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( semiring_numeral @ B )
        & ( monoid_add @ A )
        & ( semiring_numeral @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R3 @ ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ num @ num @ A @ B
                @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
                @ R3
                @ ( numeral_numeral @ A )
                @ ( numeral_numeral @ B ) ) ) ) ) ) ).

% transfer_rule_numeral
thf(fact_7920_coprime__diff__one__left,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ A2 ) ) ).

% coprime_diff_one_left
thf(fact_7921_coprime__doff__one__right,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ A2 @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_doff_one_right
thf(fact_7922_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [N2: A,A2: A,M: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ N2 @ A2 ) @ M )
            = ( modulo_modulo @ A @ ( times_times @ A @ N2 @ B2 ) @ M ) )
         => ( ( algebr8660921524188924756oprime @ A @ M @ N2 )
           => ( ( modulo_modulo @ A @ A2 @ M )
              = ( modulo_modulo @ A @ B2 @ M ) ) ) ) ) ).

% mult_mod_cancel_left
thf(fact_7923_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [A2: A,N2: A,M: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ N2 ) @ M )
            = ( modulo_modulo @ A @ ( times_times @ A @ B2 @ N2 ) @ M ) )
         => ( ( algebr8660921524188924756oprime @ A @ M @ N2 )
           => ( ( modulo_modulo @ A @ A2 @ M )
              = ( modulo_modulo @ A @ B2 @ M ) ) ) ) ) ).

% mult_mod_cancel_right
thf(fact_7924_coprime__crossproduct__int,axiom,
    ! [A2: int,D3: int,B2: int,C2: int] :
      ( ( algebr8660921524188924756oprime @ int @ A2 @ D3 )
     => ( ( algebr8660921524188924756oprime @ int @ B2 @ C2 )
       => ( ( ( times_times @ int @ ( abs_abs @ int @ A2 ) @ ( abs_abs @ int @ C2 ) )
            = ( times_times @ int @ ( abs_abs @ int @ B2 ) @ ( abs_abs @ int @ D3 ) ) )
          = ( ( ( abs_abs @ int @ A2 )
              = ( abs_abs @ int @ B2 ) )
            & ( ( abs_abs @ int @ C2 )
              = ( abs_abs @ int @ D3 ) ) ) ) ) ) ).

% coprime_crossproduct_int
thf(fact_7925_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ? [A11: A,B7: A] :
              ( ( A2
                = ( times_times @ A @ A11 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( B2
                = ( times_times @ A @ B7 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( algebr8660921524188924756oprime @ A @ A11 @ B7 ) ) ) ) ).

% gcd_coprime_exists
thf(fact_7926_gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,A5: A,B5: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( times_times @ A @ A5 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
           => ( ( B2
                = ( times_times @ A @ B5 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
             => ( algebr8660921524188924756oprime @ A @ A5 @ B5 ) ) ) ) ) ).

% gcd_coprime
thf(fact_7927_invertible__coprime,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ C2 ) ) ) ).

% invertible_coprime
thf(fact_7928_Rat__induct,axiom,
    ! [P: rat > $o,Q2: rat] :
      ( ! [A6: int,B6: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
         => ( ( algebr8660921524188924756oprime @ int @ A6 @ B6 )
           => ( P @ ( fract @ A6 @ B6 ) ) ) )
     => ( P @ Q2 ) ) ).

% Rat_induct
thf(fact_7929_Rat__cases,axiom,
    ! [Q2: rat] :
      ~ ! [A6: int,B6: int] :
          ( ( Q2
            = ( fract @ A6 @ B6 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
           => ~ ( algebr8660921524188924756oprime @ int @ A6 @ B6 ) ) ) ).

% Rat_cases
thf(fact_7930_Rat__cases__nonzero,axiom,
    ! [Q2: rat] :
      ( ! [A6: int,B6: int] :
          ( ( Q2
            = ( fract @ A6 @ B6 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
           => ( ( A6
               != ( zero_zero @ int ) )
             => ~ ( algebr8660921524188924756oprime @ int @ A6 @ B6 ) ) ) )
     => ( Q2
        = ( zero_zero @ rat ) ) ) ).

% Rat_cases_nonzero
thf(fact_7931_Rats__cases_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [X2: A] :
          ( ( member @ A @ X2 @ ( field_char_0_Rats @ A ) )
         => ~ ! [A6: int,B6: int] :
                ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
               => ( ( algebr8660921524188924756oprime @ int @ A6 @ B6 )
                 => ( X2
                   != ( divide_divide @ A @ ( ring_1_of_int @ A @ A6 ) @ ( ring_1_of_int @ A @ B6 ) ) ) ) ) ) ) ).

% Rats_cases'
thf(fact_7932_quotient__of__unique,axiom,
    ! [R: rat] :
    ? [X3: product_prod @ int @ int] :
      ( ( R
        = ( fract @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) )
      & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ X3 ) )
      & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) )
      & ! [Y4: product_prod @ int @ int] :
          ( ( ( R
              = ( fract @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
            & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Y4 ) )
            & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
         => ( Y4 = X3 ) ) ) ).

% quotient_of_unique
thf(fact_7933_of__rat_Orsp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ A @ A @ ratrel
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ ^ [X: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X ) ) )
        @ ^ [X: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X ) ) ) ) ) ).

% of_rat.rsp
thf(fact_7934_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( semiring_1 @ B )
        & ( semiring_1 @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R3 @ ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
                @ R3
                @ ( semiring_1_of_nat @ A )
                @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% transfer_rule_of_nat
thf(fact_7935_vanishes__mult__bounded,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ? [A9: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ A9 )
          & ! [N3: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X6 @ N3 ) ) @ A9 ) )
     => ( ( vanishes @ Y6 )
       => ( vanishes
          @ ^ [N: nat] : ( times_times @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% vanishes_mult_bounded
thf(fact_7936_coprime__int__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N2 ) )
      = ( algebr8660921524188924756oprime @ nat @ M @ N2 ) ) ).

% coprime_int_iff
thf(fact_7937_vanishes__const,axiom,
    ! [C2: rat] :
      ( ( vanishes
        @ ^ [N: nat] : C2 )
      = ( C2
        = ( zero_zero @ rat ) ) ) ).

% vanishes_const
thf(fact_7938_coprime__nat__abs__right__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( algebr8660921524188924756oprime @ nat @ N2 @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ N2 ) @ K ) ) ).

% coprime_nat_abs_right_iff
thf(fact_7939_coprime__nat__abs__left__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N2 )
      = ( algebr8660921524188924756oprime @ int @ K @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% coprime_nat_abs_left_iff
thf(fact_7940_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( zero_neq_one @ B )
        & ( zero_neq_one @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( bNF_rel_fun @ $o @ $o @ A @ B
              @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
              @ R3
              @ ( zero_neq_one_of_bool @ A )
              @ ( zero_neq_one_of_bool @ B ) ) ) ) ) ).

% transfer_rule_of_bool
thf(fact_7941_Fract_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > ( product_prod @ int @ int ) )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ratrel )
    @ ^ [A4: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A4 @ B3 ) )
    @ ^ [A4: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A4 @ B3 ) ) ) ).

% Fract.rsp
thf(fact_7942_plus__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    @ ( plus_plus @ nat )
    @ ( plus_plus @ nat ) ) ).

% plus_natural.rsp
thf(fact_7943_plus__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( plus_plus @ int )
    @ ( plus_plus @ int ) ) ).

% plus_integer.rsp
thf(fact_7944_coprime__Suc__0__right,axiom,
    ! [N2: nat] : ( algebr8660921524188924756oprime @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ).

% coprime_Suc_0_right
thf(fact_7945_coprime__Suc__0__left,axiom,
    ! [N2: nat] : ( algebr8660921524188924756oprime @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) ).

% coprime_Suc_0_left
thf(fact_7946_dup_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ int @ int
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ^ [K3: int] : ( plus_plus @ int @ K3 @ K3 )
    @ ^ [K3: int] : ( plus_plus @ int @ K3 @ K3 ) ) ).

% dup.rsp
thf(fact_7947_modulo__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( modulo_modulo @ int )
    @ ( modulo_modulo @ int ) ) ).

% modulo_integer.rsp
thf(fact_7948_modulo__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    @ ( modulo_modulo @ nat )
    @ ( modulo_modulo @ nat ) ) ).

% modulo_natural.rsp
thf(fact_7949_coprime__Suc__right__nat,axiom,
    ! [N2: nat] : ( algebr8660921524188924756oprime @ nat @ N2 @ ( suc @ N2 ) ) ).

% coprime_Suc_right_nat
thf(fact_7950_coprime__Suc__left__nat,axiom,
    ! [N2: nat] : ( algebr8660921524188924756oprime @ nat @ ( suc @ N2 ) @ N2 ) ).

% coprime_Suc_left_nat
thf(fact_7951_Suc_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ nat @ nat
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ suc
    @ suc ) ).

% Suc.rsp
thf(fact_7952_unset__bit__integer_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( int > int ) @ ( int > int )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( bit_se2638667681897837118et_bit @ int )
    @ ( bit_se2638667681897837118et_bit @ int ) ) ).

% unset_bit_integer.rsp
thf(fact_7953_unset__bit__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    @ ( bit_se2638667681897837118et_bit @ nat )
    @ ( bit_se2638667681897837118et_bit @ nat ) ) ).

% unset_bit_natural.rsp
thf(fact_7954_less__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( ord_less @ nat )
    @ ( ord_less @ nat ) ) ).

% less_natural.rsp
thf(fact_7955_less__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > $o ) @ ( int > $o )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ $o @ $o
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( ord_less @ int )
    @ ( ord_less @ int ) ) ).

% less_integer.rsp
thf(fact_7956_times__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    @ ( times_times @ nat )
    @ ( times_times @ nat ) ) ).

% times_natural.rsp
thf(fact_7957_times__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( times_times @ int )
    @ ( times_times @ int ) ) ).

% times_integer.rsp
thf(fact_7958_coprime__crossproduct__nat,axiom,
    ! [A2: nat,D3: nat,B2: nat,C2: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ A2 @ D3 )
     => ( ( algebr8660921524188924756oprime @ nat @ B2 @ C2 )
       => ( ( ( times_times @ nat @ A2 @ C2 )
            = ( times_times @ nat @ B2 @ D3 ) )
          = ( ( A2 = B2 )
            & ( C2 = D3 ) ) ) ) ) ).

% coprime_crossproduct_nat
thf(fact_7959_minus__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( minus_minus @ int )
    @ ( minus_minus @ int ) ) ).

% minus_integer.rsp
thf(fact_7960_minus__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    @ ( minus_minus @ nat )
    @ ( minus_minus @ nat ) ) ).

% minus_natural.rsp
thf(fact_7961_divide__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( divide_divide @ int )
    @ ( divide_divide @ int ) ) ).

% divide_integer.rsp
thf(fact_7962_divide__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    @ ( divide_divide @ nat )
    @ ( divide_divide @ nat ) ) ).

% divide_natural.rsp
thf(fact_7963_sub_Orsp,axiom,
    ( bNF_rel_fun @ num @ num @ ( num > int ) @ ( num > int )
    @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ num @ num @ int @ int
      @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ^ [M3: num,N: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N ) )
    @ ^ [M3: num,N: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N ) ) ) ).

% sub.rsp
thf(fact_7964_coprime__common__divisor__nat,axiom,
    ! [A2: nat,B2: nat,X2: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ A2 @ B2 )
     => ( ( dvd_dvd @ nat @ X2 @ A2 )
       => ( ( dvd_dvd @ nat @ X2 @ B2 )
         => ( X2
            = ( one_one @ nat ) ) ) ) ) ).

% coprime_common_divisor_nat
thf(fact_7965_num_Ocase__transfer,axiom,
    ! [A: $tType,B: $tType,S: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( num > A ) > ( num > A ) > num > A ) @ ( ( num > B ) > ( num > B ) > num > B ) @ S
      @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( ( num > A ) > num > A ) @ ( ( num > B ) > num > B )
        @ ( bNF_rel_fun @ num @ num @ A @ B
          @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
          @ S )
        @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( num > A ) @ ( num > B )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
            @ S )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
            @ S ) ) )
      @ ( case_num @ A )
      @ ( case_num @ B ) ) ).

% num.case_transfer
thf(fact_7966_less__eq__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > $o ) @ ( int > $o )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ $o @ $o
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( ord_less_eq @ int )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_integer.rsp
thf(fact_7967_less__eq__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( ord_less_eq @ nat )
    @ ( ord_less_eq @ nat ) ) ).

% less_eq_natural.rsp
thf(fact_7968_plus__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y ) @ ( product_snd @ int @ int @ X ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) )
    @ ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y ) @ ( product_snd @ int @ int @ X ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) ) ) ).

% plus_rat.rsp
thf(fact_7969_times__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_fst @ int @ int @ Y ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) )
    @ ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_fst @ int @ int @ Y ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) ) ) ).

% times_rat.rsp
thf(fact_7970_vanishes__diff,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( vanishes @ X6 )
     => ( ( vanishes @ Y6 )
       => ( vanishes
          @ ^ [N: nat] : ( minus_minus @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% vanishes_diff
thf(fact_7971_vanishes__minus,axiom,
    ! [X6: nat > rat] :
      ( ( vanishes @ X6 )
     => ( vanishes
        @ ^ [N: nat] : ( uminus_uminus @ rat @ ( X6 @ N ) ) ) ) ).

% vanishes_minus
thf(fact_7972_vanishes__add,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( vanishes @ X6 )
     => ( ( vanishes @ Y6 )
       => ( vanishes
          @ ^ [N: nat] : ( plus_plus @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% vanishes_add
thf(fact_7973_coprime__diff__one__left__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( algebr8660921524188924756oprime @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ N2 ) ) ).

% coprime_diff_one_left_nat
thf(fact_7974_coprime__diff__one__right__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( algebr8660921524188924756oprime @ nat @ N2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% coprime_diff_one_right_nat
thf(fact_7975_Rats__abs__nat__div__natE,axiom,
    ! [X2: real] :
      ( ( member @ real @ X2 @ ( field_char_0_Rats @ real ) )
     => ~ ! [M4: nat,N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( ( ( abs_abs @ real @ X2 )
                = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ M4 ) @ ( semiring_1_of_nat @ real @ N3 ) ) )
             => ~ ( algebr8660921524188924756oprime @ nat @ M4 @ N3 ) ) ) ) ).

% Rats_abs_nat_div_natE
thf(fact_7976_vanishes__def,axiom,
    ( vanishes
    = ( ^ [X8: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K3: nat] :
            ! [N: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N ) ) @ R5 ) ) ) ) ) ).

% vanishes_def
thf(fact_7977_vanishesI,axiom,
    ! [X6: nat > rat] :
      ( ! [R2: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
         => ? [K4: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K4 @ N3 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X6 @ N3 ) ) @ R2 ) ) )
     => ( vanishes @ X6 ) ) ).

% vanishesI
thf(fact_7978_vanishesD,axiom,
    ! [X6: nat > rat,R: rat] :
      ( ( vanishes @ X6 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
       => ? [K2: nat] :
          ! [N7: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N7 )
           => ( ord_less @ rat @ ( abs_abs @ rat @ ( X6 @ N7 ) ) @ R ) ) ) ) ).

% vanishesD
thf(fact_7979_inverse__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) )
    @ ^ [X: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) ) ) ).

% inverse_rat.rsp
thf(fact_7980_plus__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y ) @ ( product_snd @ int @ int @ X ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) )
    @ ( plus_plus @ rat ) ) ).

% plus_rat.transfer
thf(fact_7981_inverse__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) )
    @ ( inverse_inverse @ rat ) ) ).

% inverse_rat.transfer
thf(fact_7982_zero__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( zero_zero @ rat ) ).

% zero_rat.transfer
thf(fact_7983_Fract_Otransfer,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ rat
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ pcr_rat )
    @ ^ [A4: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A4 @ B3 ) )
    @ fract ) ).

% Fract.transfer
thf(fact_7984_of__rat_Otransfer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ A @ A @ pcr_rat
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ ^ [X: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X ) ) )
        @ ( field_char_0_of_rat @ A ) ) ) ).

% of_rat.transfer
thf(fact_7985_times__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X: product_prod @ int @ int,Y: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_fst @ int @ int @ Y ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X ) @ ( product_snd @ int @ int @ Y ) ) )
    @ ( times_times @ rat ) ) ).

% times_rat.transfer
thf(fact_7986_Rat_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ $o @ $o @ pcr_rat
    @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
    @ ^ [X: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ X ) ) )
    @ positive ) ).

% Rat.positive.transfer
thf(fact_7987_times__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X @ U2 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X @ V5 ) @ ( times_times @ nat @ Y @ U2 ) ) ) ) )
    @ ( times_times @ int ) ) ).

% times_int.transfer
thf(fact_7988_num_Orec__transfer,axiom,
    ! [A: $tType,B: $tType,S: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( num > A > A ) > ( num > A > A ) > num > A ) @ ( ( num > B > B ) > ( num > B > B ) > num > B ) @ S
      @ ( bNF_rel_fun @ ( num > A > A ) @ ( num > B > B ) @ ( ( num > A > A ) > num > A ) @ ( ( num > B > B ) > num > B )
        @ ( bNF_rel_fun @ num @ num @ ( A > A ) @ ( B > B )
          @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
          @ ( bNF_rel_fun @ A @ B @ A @ B @ S @ S ) )
        @ ( bNF_rel_fun @ ( num > A > A ) @ ( num > B > B ) @ ( num > A ) @ ( num > B )
          @ ( bNF_rel_fun @ num @ num @ ( A > A ) @ ( B > B )
            @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
            @ ( bNF_rel_fun @ A @ B @ A @ B @ S @ S ) )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
            @ S ) ) )
      @ ( rec_num @ A )
      @ ( rec_num @ B ) ) ).

% num.rec_transfer
thf(fact_7989_verit__eq__simplify_I20_J,axiom,
    ! [A: $tType,F1: A,F22: num > A > A,F32: num > A > A,X22: num] :
      ( ( rec_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X22 ) )
      = ( F22 @ X22 @ ( rec_num @ A @ F1 @ F22 @ F32 @ X22 ) ) ) ).

% verit_eq_simplify(20)
thf(fact_7990_verit__eq__simplify_I19_J,axiom,
    ! [A: $tType,F1: A,F22: num > A > A,F32: num > A > A] :
      ( ( rec_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(19)
thf(fact_7991_zero__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( zero_zero @ int ) ).

% zero_int.transfer
thf(fact_7992_int__transfer,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( product_prod @ nat @ nat ) @ int
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ pcr_int
    @ ^ [N: nat] : ( product_Pair @ nat @ nat @ N @ ( zero_zero @ nat ) )
    @ ( semiring_1_of_nat @ int ) ) ).

% int_transfer
thf(fact_7993_uminus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X ) )
    @ ( uminus_uminus @ int ) ) ).

% uminus_int.transfer
thf(fact_7994_nat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ nat @ nat @ pcr_int
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ nat2 ) ).

% nat.transfer
thf(fact_7995_one__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( one_one @ int ) ).

% one_int.transfer
thf(fact_7996_of__int_Otransfer,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ A @ A @ pcr_int
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I3: nat,J2: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J2 ) ) )
        @ ( ring_1_of_int @ A ) ) ) ).

% of_int.transfer
thf(fact_7997_less__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) )
    @ ( ord_less @ int ) ) ).

% less_int.transfer
thf(fact_7998_less__eq__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_int.transfer
thf(fact_7999_plus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ U2 ) @ ( plus_plus @ nat @ Y @ V5 ) ) ) )
    @ ( plus_plus @ int ) ) ).

% plus_int.transfer
thf(fact_8000_minus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ Y @ U2 ) ) ) )
    @ ( minus_minus @ int ) ) ).

% minus_int.transfer
thf(fact_8001_mult__inj__if__coprime__nat,axiom,
    ! [B: $tType,A: $tType,F2: A > nat,A3: set @ A,G: B > nat,B4: set @ B] :
      ( ( inj_on @ A @ nat @ F2 @ A3 )
     => ( ( inj_on @ B @ nat @ G @ B4 )
       => ( ! [A6: A,B6: B] :
              ( ( member @ A @ A6 @ A3 )
             => ( ( member @ B @ B6 @ B4 )
               => ( algebr8660921524188924756oprime @ nat @ ( F2 @ A6 ) @ ( G @ B6 ) ) ) )
         => ( inj_on @ ( product_prod @ A @ B ) @ nat
            @ ( product_case_prod @ A @ B @ nat
              @ ^ [A4: A,B3: B] : ( times_times @ nat @ ( F2 @ A4 ) @ ( G @ B3 ) ) )
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu2: A] : B4 ) ) ) ) ) ).

% mult_inj_if_coprime_nat
thf(fact_8002_inverse__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X8: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X8 )
        @ ^ [N: nat] : ( zero_zero @ rat )
        @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X8 @ N ) ) )
    @ ( inverse_inverse @ real ) ) ).

% inverse_real.transfer
thf(fact_8003_one__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N: nat] : ( one_one @ rat )
    @ ( one_one @ real ) ) ).

% one_real.transfer
thf(fact_8004_card__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B4: set @ B] :
      ( ( finite_card @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu2: A] : B4 ) )
      = ( times_times @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) ) ) ).

% card_cartesian_product
thf(fact_8005_zero__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N: nat] : ( zero_zero @ rat )
    @ ( zero_zero @ real ) ) ).

% zero_real.transfer
thf(fact_8006_product__atMost__eq__Un,axiom,
    ! [A3: set @ nat,M: nat] :
      ( ( product_Sigma @ nat @ nat @ A3
        @ ^ [Uu2: nat] : ( set_ord_atMost @ nat @ M ) )
      = ( sup_sup @ ( set @ ( product_prod @ nat @ nat ) )
        @ ( product_Sigma @ nat @ nat @ A3
          @ ^ [I3: nat] : ( set_ord_atMost @ nat @ ( minus_minus @ nat @ M @ I3 ) ) )
        @ ( product_Sigma @ nat @ nat @ A3
          @ ^ [I3: nat] : ( set_or3652927894154168847AtMost @ nat @ ( minus_minus @ nat @ M @ I3 ) @ M ) ) ) ) ).

% product_atMost_eq_Un
thf(fact_8007_uminus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X8: nat > rat,N: nat] : ( uminus_uminus @ rat @ ( X8 @ N ) )
    @ ( uminus_uminus @ real ) ) ).

% uminus_real.transfer
thf(fact_8008_plus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X8: nat > rat,Y7: nat > rat,N: nat] : ( plus_plus @ rat @ ( X8 @ N ) @ ( Y7 @ N ) )
    @ ( plus_plus @ real ) ) ).

% plus_real.transfer
thf(fact_8009_times__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X8: nat > rat,Y7: nat > rat,N: nat] : ( times_times @ rat @ ( X8 @ N ) @ ( Y7 @ N ) )
    @ ( times_times @ real ) ) ).

% times_real.transfer
thf(fact_8010_pairs__le__eq__Sigma,axiom,
    ! [M: nat] :
      ( ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [I3: nat,J2: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ J2 ) @ M ) ) )
      = ( product_Sigma @ nat @ nat @ ( set_ord_atMost @ nat @ M )
        @ ^ [R5: nat] : ( set_ord_atMost @ nat @ ( minus_minus @ nat @ M @ R5 ) ) ) ) ).

% pairs_le_eq_Sigma
thf(fact_8011_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,G: C > B,A3: set @ A,B4: set @ C] :
          ( ( inj_on @ ( product_prod @ A @ C ) @ B
            @ ( product_case_prod @ A @ C @ B
              @ ^ [A4: A,B3: C] : ( times_times @ B @ ( F2 @ A4 ) @ ( G @ B3 ) ) )
            @ ( product_Sigma @ A @ C @ A3
              @ ^ [Uu2: A] : B4 ) )
         => ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B4 ) )
            = ( groups7311177749621191930dd_sum @ B @ B @ ( id @ B )
              @ ( collect @ B
                @ ^ [Uu2: B] :
                  ? [A4: A,B3: C] :
                    ( ( Uu2
                      = ( times_times @ B @ ( F2 @ A4 ) @ ( G @ B3 ) ) )
                    & ( member @ A @ A4 @ A3 )
                    & ( member @ C @ B3 @ B4 ) ) ) ) ) ) ) ).

% sum_mult_sum_if_inj
thf(fact_8012_Real_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
    @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
    @ ^ [X8: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
           => ( ord_less @ rat @ R5 @ ( X8 @ N ) ) ) )
    @ positive2 ) ).

% Real.positive.transfer
thf(fact_8013_Sigma__Diff__distrib2,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,A3: A > ( set @ B ),B4: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ I5
        @ ^ [I3: A] : ( minus_minus @ ( set @ B ) @ ( A3 @ I3 ) @ ( B4 @ I3 ) ) )
      = ( minus_minus @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I5 @ A3 ) @ ( product_Sigma @ A @ B @ I5 @ B4 ) ) ) ).

% Sigma_Diff_distrib2
thf(fact_8014_Real_Opositive__mult,axiom,
    ! [X2: real,Y2: real] :
      ( ( positive2 @ X2 )
     => ( ( positive2 @ Y2 )
       => ( positive2 @ ( times_times @ real @ X2 @ Y2 ) ) ) ) ).

% Real.positive_mult
thf(fact_8015_Real_Opositive__zero,axiom,
    ~ ( positive2 @ ( zero_zero @ real ) ) ).

% Real.positive_zero
thf(fact_8016_Real_Opositive__add,axiom,
    ! [X2: real,Y2: real] :
      ( ( positive2 @ X2 )
     => ( ( positive2 @ Y2 )
       => ( positive2 @ ( plus_plus @ real @ X2 @ Y2 ) ) ) ) ).

% Real.positive_add
thf(fact_8017_Real_Opositive__minus,axiom,
    ! [X2: real] :
      ( ~ ( positive2 @ X2 )
     => ( ( X2
         != ( zero_zero @ real ) )
       => ( positive2 @ ( uminus_uminus @ real @ X2 ) ) ) ) ).

% Real.positive_minus
thf(fact_8018_less__real__def,axiom,
    ( ( ord_less @ real )
    = ( ^ [X: real,Y: real] : ( positive2 @ ( minus_minus @ real @ Y @ X ) ) ) ) ).

% less_real_def
thf(fact_8019_rat__floor__code,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [P4: rat] : ( product_case_prod @ int @ int @ int @ ( divide_divide @ int ) @ ( quotient_of @ P4 ) ) ) ) ).

% rat_floor_code
thf(fact_8020_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q4: int,R5: int] :
          ( plus_plus @ int @ Q4
          @ ( zero_neq_one_of_bool @ int
            @ ( R5
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_8021_lists__length__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( collect @ ( list @ A )
        @ ^ [Xs: list @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
            & ( ( size_size @ ( list @ A ) @ Xs )
              = ( suc @ N2 ) ) ) )
      = ( image @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
        @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
          @ ^ [Xs: list @ A,N: A] : ( cons @ A @ N @ Xs ) )
        @ ( product_Sigma @ ( list @ A ) @ A
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs )
                  = N2 ) ) )
          @ ^ [Uu2: list @ A] : A3 ) ) ) ).

% lists_length_Suc_eq
thf(fact_8022_Sigma__Diff__distrib1,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,J4: set @ A,C6: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( minus_minus @ ( set @ A ) @ I5 @ J4 ) @ C6 )
      = ( minus_minus @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I5 @ C6 ) @ ( product_Sigma @ A @ B @ J4 @ C6 ) ) ) ).

% Sigma_Diff_distrib1
thf(fact_8023_Times__Diff__distrib1,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ A,C6: set @ B] :
      ( ( product_Sigma @ A @ B @ ( minus_minus @ ( set @ A ) @ A3 @ B4 )
        @ ^ [Uu2: A] : C6 )
      = ( minus_minus @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu2: A] : C6 )
        @ ( product_Sigma @ A @ B @ B4
          @ ^ [Uu2: A] : C6 ) ) ) ).

% Times_Diff_distrib1
thf(fact_8024_Real_Opositive_Orep__eq,axiom,
    ( positive2
    = ( ^ [X: real] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K3: nat] :
            ! [N: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N )
             => ( ord_less @ rat @ R5 @ ( rep_real @ X @ N ) ) ) ) ) ) ).

% Real.positive.rep_eq
thf(fact_8025_Real_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ $o @ $o @ realrel
    @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
    @ ^ [X8: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
           => ( ord_less @ rat @ R5 @ ( X8 @ N ) ) ) )
    @ ^ [X8: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
           => ( ord_less @ rat @ R5 @ ( X8 @ N ) ) ) ) ) ).

% Real.positive.rsp
thf(fact_8026_uminus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X8: nat > rat,N: nat] : ( uminus_uminus @ rat @ ( X8 @ N ) )
    @ ^ [X8: nat > rat,N: nat] : ( uminus_uminus @ rat @ ( X8 @ N ) ) ) ).

% uminus_real.rsp
thf(fact_8027_plus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X8: nat > rat,Y7: nat > rat,N: nat] : ( plus_plus @ rat @ ( X8 @ N ) @ ( Y7 @ N ) )
    @ ^ [X8: nat > rat,Y7: nat > rat,N: nat] : ( plus_plus @ rat @ ( X8 @ N ) @ ( Y7 @ N ) ) ) ).

% plus_real.rsp
thf(fact_8028_times__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X8: nat > rat,Y7: nat > rat,N: nat] : ( times_times @ rat @ ( X8 @ N ) @ ( Y7 @ N ) )
    @ ^ [X8: nat > rat,Y7: nat > rat,N: nat] : ( times_times @ rat @ ( X8 @ N ) @ ( Y7 @ N ) ) ) ).

% times_real.rsp
thf(fact_8029_zero__real_Orsp,axiom,
    ( realrel
    @ ^ [N: nat] : ( zero_zero @ rat )
    @ ^ [N: nat] : ( zero_zero @ rat ) ) ).

% zero_real.rsp
thf(fact_8030_one__real_Orsp,axiom,
    ( realrel
    @ ^ [N: nat] : ( one_one @ rat )
    @ ^ [N: nat] : ( one_one @ rat ) ) ).

% one_real.rsp
thf(fact_8031_real_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > $o ) @ ( real > $o ) @ pcr_real
    @ ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ realrel
    @ ^ [Y5: real,Z4: real] : ( Y5 = Z4 ) ) ).

% real.rel_eq_transfer
thf(fact_8032_inverse__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X8: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X8 )
        @ ^ [N: nat] : ( zero_zero @ rat )
        @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X8 @ N ) ) )
    @ ^ [X8: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X8 )
        @ ^ [N: nat] : ( zero_zero @ rat )
        @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X8 @ N ) ) ) ) ).

% inverse_real.rsp
thf(fact_8033_Real_Opositive__def,axiom,
    ( positive2
    = ( map_fun @ real @ ( nat > rat ) @ $o @ $o @ rep_real @ ( id @ $o )
      @ ^ [X8: nat > rat] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K3: nat] :
            ! [N: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N )
             => ( ord_less @ rat @ R5 @ ( X8 @ N ) ) ) ) ) ) ).

% Real.positive_def
thf(fact_8034_times__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X @ U2 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X @ V5 ) @ ( times_times @ nat @ Y @ U2 ) ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X @ U2 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X @ V5 ) @ ( times_times @ nat @ Y @ U2 ) ) ) ) ) ) ).

% times_int.rsp
thf(fact_8035_intrel__iff,axiom,
    ! [X2: nat,Y2: nat,U: nat,V: nat] :
      ( ( intrel @ ( product_Pair @ nat @ nat @ X2 @ Y2 ) @ ( product_Pair @ nat @ nat @ U @ V ) )
      = ( ( plus_plus @ nat @ X2 @ V )
        = ( plus_plus @ nat @ U @ Y2 ) ) ) ).

% intrel_iff
thf(fact_8036_uminus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X ) )
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X ) ) ) ).

% uminus_int.rsp
thf(fact_8037_nat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ nat @ nat @ intrel
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ).

% nat.rsp
thf(fact_8038_int_Oabs__eq__iff,axiom,
    ! [X2: product_prod @ nat @ nat,Y2: product_prod @ nat @ nat] :
      ( ( ( abs_Integ @ X2 )
        = ( abs_Integ @ Y2 ) )
      = ( intrel @ X2 @ Y2 ) ) ).

% int.abs_eq_iff
thf(fact_8039_zero__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ).

% zero_int.rsp
thf(fact_8040_one__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ).

% one_int.rsp
thf(fact_8041_of__int_Orsp,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ A @ A @ intrel
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I3: nat,J2: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J2 ) ) )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I3: nat,J2: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J2 ) ) ) ) ) ).

% of_int.rsp
thf(fact_8042_intrel__def,axiom,
    ( intrel
    = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] :
              ( ( plus_plus @ nat @ X @ V5 )
              = ( plus_plus @ nat @ U2 @ Y ) ) ) ) ) ).

% intrel_def
thf(fact_8043_less__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) ) ) ).

% less_int.rsp
thf(fact_8044_less__eq__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) ) ) ).

% less_eq_int.rsp
thf(fact_8045_int_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ intrel
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) ) ).

% int.rel_eq_transfer
thf(fact_8046_plus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ U2 ) @ ( plus_plus @ nat @ Y @ V5 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ U2 ) @ ( plus_plus @ nat @ Y @ V5 ) ) ) ) ) ).

% plus_int.rsp
thf(fact_8047_minus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ Y @ U2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X: nat,Y: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X @ V5 ) @ ( plus_plus @ nat @ Y @ U2 ) ) ) ) ) ).

% minus_int.rsp
thf(fact_8048_inverse__real_Oabs__eq,axiom,
    ! [X2: nat > rat] :
      ( ( realrel @ X2 @ X2 )
     => ( ( inverse_inverse @ real @ ( real2 @ X2 ) )
        = ( real2
          @ ( if @ ( nat > rat ) @ ( vanishes @ X2 )
            @ ^ [N: nat] : ( zero_zero @ rat )
            @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X2 @ N ) ) ) ) ) ) ).

% inverse_real.abs_eq
thf(fact_8049_mono__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ D )
        & ( order @ C )
        & ( order @ A ) )
     => ! [A3: A > B > $o,B4: C > D > $o] :
          ( ( bi_total @ A @ B @ A3 )
         => ( ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A3
              @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3
                @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
              @ ( ord_less_eq @ A )
              @ ( ord_less_eq @ B ) )
           => ( ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B4
                @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B4
                  @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
                @ ( ord_less_eq @ C )
                @ ( ord_less_eq @ D ) )
             => ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B4 )
                @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
                @ ( order_mono @ A @ C )
                @ ( order_mono @ B @ D ) ) ) ) ) ) ).

% mono_transfer
thf(fact_8050_int_Obi__total,axiom,
    bi_total @ ( product_prod @ nat @ nat ) @ int @ pcr_int ).

% int.bi_total
thf(fact_8051_of__rat__Real,axiom,
    ( ( field_char_0_of_rat @ real )
    = ( ^ [X: rat] :
          ( real2
          @ ^ [N: nat] : X ) ) ) ).

% of_rat_Real
thf(fact_8052_of__nat__Real,axiom,
    ( ( semiring_1_of_nat @ real )
    = ( ^ [X: nat] :
          ( real2
          @ ^ [N: nat] : ( semiring_1_of_nat @ rat @ X ) ) ) ) ).

% of_nat_Real
thf(fact_8053_zero__real__def,axiom,
    ( ( zero_zero @ real )
    = ( real2
      @ ^ [N: nat] : ( zero_zero @ rat ) ) ) ).

% zero_real_def
thf(fact_8054_one__real__def,axiom,
    ( ( one_one @ real )
    = ( real2
      @ ^ [N: nat] : ( one_one @ rat ) ) ) ).

% one_real_def
thf(fact_8055_of__int__Real,axiom,
    ( ( ring_1_of_int @ real )
    = ( ^ [X: int] :
          ( real2
          @ ^ [N: nat] : ( ring_1_of_int @ rat @ X ) ) ) ) ).

% of_int_Real
thf(fact_8056_real_Oabs__induct,axiom,
    ! [P: real > $o,X2: real] :
      ( ! [Y3: nat > rat] :
          ( ( realrel @ Y3 @ Y3 )
         => ( P @ ( real2 @ Y3 ) ) )
     => ( P @ X2 ) ) ).

% real.abs_induct
thf(fact_8057_uminus__real_Oabs__eq,axiom,
    ! [X2: nat > rat] :
      ( ( realrel @ X2 @ X2 )
     => ( ( uminus_uminus @ real @ ( real2 @ X2 ) )
        = ( real2
          @ ^ [N: nat] : ( uminus_uminus @ rat @ ( X2 @ N ) ) ) ) ) ).

% uminus_real.abs_eq
thf(fact_8058_plus__real_Oabs__eq,axiom,
    ! [Xa: nat > rat,X2: nat > rat] :
      ( ( realrel @ Xa @ Xa )
     => ( ( realrel @ X2 @ X2 )
       => ( ( plus_plus @ real @ ( real2 @ Xa ) @ ( real2 @ X2 ) )
          = ( real2
            @ ^ [N: nat] : ( plus_plus @ rat @ ( Xa @ N ) @ ( X2 @ N ) ) ) ) ) ) ).

% plus_real.abs_eq
thf(fact_8059_times__real_Oabs__eq,axiom,
    ! [Xa: nat > rat,X2: nat > rat] :
      ( ( realrel @ Xa @ Xa )
     => ( ( realrel @ X2 @ X2 )
       => ( ( times_times @ real @ ( real2 @ Xa ) @ ( real2 @ X2 ) )
          = ( real2
            @ ^ [N: nat] : ( times_times @ rat @ ( Xa @ N ) @ ( X2 @ N ) ) ) ) ) ) ).

% times_real.abs_eq
thf(fact_8060_Real_Opositive_Oabs__eq,axiom,
    ! [X2: nat > rat] :
      ( ( realrel @ X2 @ X2 )
     => ( ( positive2 @ ( real2 @ X2 ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K3: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N )
                 => ( ord_less @ rat @ R5 @ ( X2 @ N ) ) ) ) ) ) ) ).

% Real.positive.abs_eq
thf(fact_8061_inverse__real__def,axiom,
    ( ( inverse_inverse @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X8: nat > rat] :
          ( if @ ( nat > rat ) @ ( vanishes @ X8 )
          @ ^ [N: nat] : ( zero_zero @ rat )
          @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X8 @ N ) ) ) ) ) ).

% inverse_real_def
thf(fact_8062_le__Real,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( cauchy @ Y6 )
       => ( ( ord_less_eq @ real @ ( real2 @ X6 ) @ ( real2 @ Y6 ) )
          = ( ! [R5: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
               => ? [K3: nat] :
                  ! [N: nat] :
                    ( ( ord_less_eq @ nat @ K3 @ N )
                   => ( ord_less_eq @ rat @ ( X6 @ N ) @ ( plus_plus @ rat @ ( Y6 @ N ) @ R5 ) ) ) ) ) ) ) ) ).

% le_Real
thf(fact_8063_Real__induct,axiom,
    ! [P: real > $o,X2: real] :
      ( ! [X16: nat > rat] :
          ( ( cauchy @ X16 )
         => ( P @ ( real2 @ X16 ) ) )
     => ( P @ X2 ) ) ).

% Real_induct
thf(fact_8064_cr__real__eq,axiom,
    ( pcr_real
    = ( ^ [X: nat > rat,Y: real] :
          ( ( cauchy @ X )
          & ( ( real2 @ X )
            = Y ) ) ) ) ).

% cr_real_eq
thf(fact_8065_realrel__refl,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( realrel @ X6 @ X6 ) ) ).

% realrel_refl
thf(fact_8066_cauchy__mult,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( cauchy @ Y6 )
       => ( cauchy
          @ ^ [N: nat] : ( times_times @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% cauchy_mult
thf(fact_8067_cauchy__const,axiom,
    ! [X2: rat] :
      ( cauchy
      @ ^ [N: nat] : X2 ) ).

% cauchy_const
thf(fact_8068_cauchy__add,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( cauchy @ Y6 )
       => ( cauchy
          @ ^ [N: nat] : ( plus_plus @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% cauchy_add
thf(fact_8069_cauchy__minus,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( cauchy
        @ ^ [N: nat] : ( uminus_uminus @ rat @ ( X6 @ N ) ) ) ) ).

% cauchy_minus
thf(fact_8070_cauchy__inverse,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ~ ( vanishes @ X6 )
       => ( cauchy
          @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X6 @ N ) ) ) ) ) ).

% cauchy_inverse
thf(fact_8071_cauchy__diff,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( cauchy @ Y6 )
       => ( cauchy
          @ ^ [N: nat] : ( minus_minus @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% cauchy_diff
thf(fact_8072_cauchy__imp__bounded,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ? [B6: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B6 )
          & ! [N7: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X6 @ N7 ) ) @ B6 ) ) ) ).

% cauchy_imp_bounded
thf(fact_8073_less__RealD,axiom,
    ! [Y6: nat > rat,X2: real] :
      ( ( cauchy @ Y6 )
     => ( ( ord_less @ real @ X2 @ ( real2 @ Y6 ) )
       => ? [N3: nat] : ( ord_less @ real @ X2 @ ( field_char_0_of_rat @ real @ ( Y6 @ N3 ) ) ) ) ) ).

% less_RealD
thf(fact_8074_le__RealI,axiom,
    ! [Y6: nat > rat,X2: real] :
      ( ( cauchy @ Y6 )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ X2 @ ( field_char_0_of_rat @ real @ ( Y6 @ N3 ) ) )
       => ( ord_less_eq @ real @ X2 @ ( real2 @ Y6 ) ) ) ) ).

% le_RealI
thf(fact_8075_Real__leI,axiom,
    ! [X6: nat > rat,Y2: real] :
      ( ( cauchy @ X6 )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( field_char_0_of_rat @ real @ ( X6 @ N3 ) ) @ Y2 )
       => ( ord_less_eq @ real @ ( real2 @ X6 ) @ Y2 ) ) ) ).

% Real_leI
thf(fact_8076_minus__Real,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( uminus_uminus @ real @ ( real2 @ X6 ) )
        = ( real2
          @ ^ [N: nat] : ( uminus_uminus @ rat @ ( X6 @ N ) ) ) ) ) ).

% minus_Real
thf(fact_8077_add__Real,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( cauchy @ Y6 )
       => ( ( plus_plus @ real @ ( real2 @ X6 ) @ ( real2 @ Y6 ) )
          = ( real2
            @ ^ [N: nat] : ( plus_plus @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ) ).

% add_Real
thf(fact_8078_mult__Real,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( cauchy @ Y6 )
       => ( ( times_times @ real @ ( real2 @ X6 ) @ ( real2 @ Y6 ) )
          = ( real2
            @ ^ [N: nat] : ( times_times @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ) ).

% mult_Real
thf(fact_8079_diff__Real,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( cauchy @ Y6 )
       => ( ( minus_minus @ real @ ( real2 @ X6 ) @ ( real2 @ Y6 ) )
          = ( real2
            @ ^ [N: nat] : ( minus_minus @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ) ).

% diff_Real
thf(fact_8080_realrelI,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( cauchy @ Y6 )
       => ( ( vanishes
            @ ^ [N: nat] : ( minus_minus @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) )
         => ( realrel @ X6 @ Y6 ) ) ) ) ).

% realrelI
thf(fact_8081_eq__Real,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( cauchy @ Y6 )
       => ( ( ( real2 @ X6 )
            = ( real2 @ Y6 ) )
          = ( vanishes
            @ ^ [N: nat] : ( minus_minus @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) ) ) ) ) ).

% eq_Real
thf(fact_8082_vanishes__diff__inverse,axiom,
    ! [X6: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ~ ( vanishes @ X6 )
       => ( ( cauchy @ Y6 )
         => ( ~ ( vanishes @ Y6 )
           => ( ( vanishes
                @ ^ [N: nat] : ( minus_minus @ rat @ ( X6 @ N ) @ ( Y6 @ N ) ) )
             => ( vanishes
                @ ^ [N: nat] : ( minus_minus @ rat @ ( inverse_inverse @ rat @ ( X6 @ N ) ) @ ( inverse_inverse @ rat @ ( Y6 @ N ) ) ) ) ) ) ) ) ) ).

% vanishes_diff_inverse
thf(fact_8083_realrel__def,axiom,
    ( realrel
    = ( ^ [X8: nat > rat,Y7: nat > rat] :
          ( ( cauchy @ X8 )
          & ( cauchy @ Y7 )
          & ( vanishes
            @ ^ [N: nat] : ( minus_minus @ rat @ ( X8 @ N ) @ ( Y7 @ N ) ) ) ) ) ) ).

% realrel_def
thf(fact_8084_cauchy__not__vanishes__cases,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ~ ( vanishes @ X6 )
       => ? [B6: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B6 )
            & ? [K2: nat] :
                ( ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N7 )
                   => ( ord_less @ rat @ B6 @ ( uminus_uminus @ rat @ ( X6 @ N7 ) ) ) )
                | ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N7 )
                   => ( ord_less @ rat @ B6 @ ( X6 @ N7 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes_cases
thf(fact_8085_positive__Real,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( positive2 @ ( real2 @ X6 ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K3: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N )
                 => ( ord_less @ rat @ R5 @ ( X6 @ N ) ) ) ) ) ) ) ).

% positive_Real
thf(fact_8086_uminus__real__def,axiom,
    ( ( uminus_uminus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X8: nat > rat,N: nat] : ( uminus_uminus @ rat @ ( X8 @ N ) ) ) ) ).

% uminus_real_def
thf(fact_8087_cauchy__not__vanishes,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ~ ( vanishes @ X6 )
       => ? [B6: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B6 )
            & ? [K2: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N7 )
               => ( ord_less @ rat @ B6 @ ( abs_abs @ rat @ ( X6 @ N7 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes
thf(fact_8088_cauchyD,axiom,
    ! [X6: nat > rat,R: rat] :
      ( ( cauchy @ X6 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
       => ? [K2: nat] :
          ! [M2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ M2 )
           => ! [N7: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N7 )
               => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X6 @ M2 ) @ ( X6 @ N7 ) ) ) @ R ) ) ) ) ) ).

% cauchyD
thf(fact_8089_cauchyI,axiom,
    ! [X6: nat > rat] :
      ( ! [R2: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
         => ? [K4: nat] :
            ! [M4: nat] :
              ( ( ord_less_eq @ nat @ K4 @ M4 )
             => ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K4 @ N3 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X6 @ M4 ) @ ( X6 @ N3 ) ) ) @ R2 ) ) ) )
     => ( cauchy @ X6 ) ) ).

% cauchyI
thf(fact_8090_cauchy__def,axiom,
    ( cauchy
    = ( ^ [X8: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K3: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ K3 @ M3 )
             => ! [N: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X8 @ M3 ) @ ( X8 @ N ) ) ) @ R5 ) ) ) ) ) ) ).

% cauchy_def
thf(fact_8091_inverse__Real,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( ( vanishes @ X6 )
         => ( ( inverse_inverse @ real @ ( real2 @ X6 ) )
            = ( zero_zero @ real ) ) )
        & ( ~ ( vanishes @ X6 )
         => ( ( inverse_inverse @ real @ ( real2 @ X6 ) )
            = ( real2
              @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X6 @ N ) ) ) ) ) ) ) ).

% inverse_Real
thf(fact_8092_not__positive__Real,axiom,
    ! [X6: nat > rat] :
      ( ( cauchy @ X6 )
     => ( ( ~ ( positive2 @ ( real2 @ X6 ) ) )
        = ( ! [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
             => ? [K3: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N )
                 => ( ord_less_eq @ rat @ ( X6 @ N ) @ R5 ) ) ) ) ) ) ).

% not_positive_Real
thf(fact_8093_times__real__def,axiom,
    ( ( times_times @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X8: nat > rat,Y7: nat > rat,N: nat] : ( times_times @ rat @ ( X8 @ N ) @ ( Y7 @ N ) ) ) ) ).

% times_real_def
thf(fact_8094_plus__real__def,axiom,
    ( ( plus_plus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X8: nat > rat,Y7: nat > rat,N: nat] : ( plus_plus @ rat @ ( X8 @ N ) @ ( Y7 @ N ) ) ) ) ).

% plus_real_def
thf(fact_8095_cr__real__def,axiom,
    ( cr_real
    = ( ^ [X: nat > rat,Y: real] :
          ( ( realrel @ X @ X )
          & ( ( real2 @ X )
            = Y ) ) ) ) ).

% cr_real_def
thf(fact_8096_and__not__num_Opelims,axiom,
    ! [X2: num,Xa: num,Y2: option @ num] :
      ( ( ( bit_and_not_num @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ X2 @ Xa ) )
       => ( ( ( X2 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y2
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y2
                      = ( some @ num @ one2 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y2
                        = ( none @ num ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X2
                      = ( bit0 @ M4 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y2
                          = ( some @ num @ ( bit0 @ M4 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X2
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y2
                              = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X2
                          = ( bit0 @ M4 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y2
                                = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X2
                            = ( bit1 @ M4 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y2
                                = ( some @ num @ ( bit0 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X2
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y2
                                    = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                      @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                      @ ( bit_and_not_num @ M4 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X2
                                = ( bit1 @ M4 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y2
                                      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
thf(fact_8097_real_Opcr__cr__eq,axiom,
    pcr_real = cr_real ).

% real.pcr_cr_eq
thf(fact_8098_and__num_Opelims,axiom,
    ! [X2: num,Xa: num,Y2: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ X2 @ Xa ) )
       => ( ( ( X2 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y2
                  = ( some @ num @ one2 ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y2
                      = ( none @ num ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y2
                        = ( some @ num @ one2 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X2
                      = ( bit0 @ M4 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y2
                          = ( none @ num ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X2
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y2
                              = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X2
                          = ( bit0 @ M4 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y2
                                = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X2
                            = ( bit1 @ M4 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y2
                                = ( some @ num @ one2 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X2
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y2
                                    = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X2
                                = ( bit1 @ M4 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y2
                                      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                        @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
thf(fact_8099_xor__num_Opelims,axiom,
    ! [X2: num,Xa: num,Y2: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ X2 @ Xa ) )
       => ( ( ( X2 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y2
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y2
                      = ( some @ num @ ( bit1 @ N3 ) ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y2
                        = ( some @ num @ ( bit0 @ N3 ) ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X2
                      = ( bit0 @ M4 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y2
                          = ( some @ num @ ( bit1 @ M4 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X2
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y2
                              = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X2
                          = ( bit0 @ M4 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y2
                                = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X2
                            = ( bit1 @ M4 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y2
                                = ( some @ num @ ( bit0 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X2
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y2
                                    = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X2
                                = ( bit1 @ M4 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y2
                                      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
thf(fact_8100_or__not__num__neg_Opelims,axiom,
    ! [X2: num,Xa: num,Y2: num] :
      ( ( ( bit_or_not_num_neg @ X2 @ Xa )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ X2 @ Xa ) )
       => ( ( ( X2 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y2 = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [M4: num] :
                  ( ( Xa
                    = ( bit0 @ M4 ) )
                 => ( ( Y2
                      = ( bit1 @ M4 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ M4 ) ) ) ) ) )
           => ( ( ( X2 = one2 )
               => ! [M4: num] :
                    ( ( Xa
                      = ( bit1 @ M4 ) )
                   => ( ( Y2
                        = ( bit1 @ M4 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ M4 ) ) ) ) ) )
             => ( ! [N3: num] :
                    ( ( X2
                      = ( bit0 @ N3 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y2
                          = ( bit0 @ one2 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ one2 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X2
                        = ( bit0 @ N3 ) )
                     => ! [M4: num] :
                          ( ( Xa
                            = ( bit0 @ M4 ) )
                         => ( ( Y2
                              = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit0 @ M4 ) ) ) ) ) )
                 => ( ! [N3: num] :
                        ( ( X2
                          = ( bit0 @ N3 ) )
                       => ! [M4: num] :
                            ( ( Xa
                              = ( bit1 @ M4 ) )
                           => ( ( Y2
                                = ( bit0 @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit1 @ M4 ) ) ) ) ) )
                   => ( ! [N3: num] :
                          ( ( X2
                            = ( bit1 @ N3 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y2 = one2 )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ one2 ) ) ) ) )
                     => ( ! [N3: num] :
                            ( ( X2
                              = ( bit1 @ N3 ) )
                           => ! [M4: num] :
                                ( ( Xa
                                  = ( bit0 @ M4 ) )
                               => ( ( Y2
                                    = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit0 @ M4 ) ) ) ) ) )
                       => ~ ! [N3: num] :
                              ( ( X2
                                = ( bit1 @ N3 ) )
                             => ! [M4: num] :
                                  ( ( Xa
                                    = ( bit1 @ M4 ) )
                                 => ( ( Y2
                                      = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit1 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
thf(fact_8101_and__num__rel__dict,axiom,
    bit_un4731106466462545111um_rel = bit_un5425074673868309765um_rel ).

% and_num_rel_dict
thf(fact_8102_xor__num__rel__dict,axiom,
    bit_un2901131394128224187um_rel = bit_un3595099601533988841um_rel ).

% xor_num_rel_dict
thf(fact_8103_rcis__inverse,axiom,
    ! [R: real,A2: real] :
      ( ( inverse_inverse @ complex @ ( rcis @ R @ A2 ) )
      = ( rcis @ ( divide_divide @ real @ ( one_one @ real ) @ R ) @ ( uminus_uminus @ real @ A2 ) ) ) ).

% rcis_inverse
thf(fact_8104_rcis__zero__arg,axiom,
    ! [R: real] :
      ( ( rcis @ R @ ( zero_zero @ real ) )
      = ( real_Vector_of_real @ complex @ R ) ) ).

% rcis_zero_arg
thf(fact_8105_rcis__eq__zero__iff,axiom,
    ! [R: real,A2: real] :
      ( ( ( rcis @ R @ A2 )
        = ( zero_zero @ complex ) )
      = ( R
        = ( zero_zero @ real ) ) ) ).

% rcis_eq_zero_iff
thf(fact_8106_rcis__zero__mod,axiom,
    ! [A2: real] :
      ( ( rcis @ ( zero_zero @ real ) @ A2 )
      = ( zero_zero @ complex ) ) ).

% rcis_zero_mod
thf(fact_8107_Re__rcis,axiom,
    ! [R: real,A2: real] :
      ( ( re @ ( rcis @ R @ A2 ) )
      = ( times_times @ real @ R @ ( cos @ real @ A2 ) ) ) ).

% Re_rcis
thf(fact_8108_Im__rcis,axiom,
    ! [R: real,A2: real] :
      ( ( im @ ( rcis @ R @ A2 ) )
      = ( times_times @ real @ R @ ( sin @ real @ A2 ) ) ) ).

% Im_rcis
thf(fact_8109_rcis__mult,axiom,
    ! [R1: real,A2: real,R22: real,B2: real] :
      ( ( times_times @ complex @ ( rcis @ R1 @ A2 ) @ ( rcis @ R22 @ B2 ) )
      = ( rcis @ ( times_times @ real @ R1 @ R22 ) @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% rcis_mult
thf(fact_8110_rcis__divide,axiom,
    ! [R1: real,A2: real,R22: real,B2: real] :
      ( ( divide_divide @ complex @ ( rcis @ R1 @ A2 ) @ ( rcis @ R22 @ B2 ) )
      = ( rcis @ ( divide_divide @ real @ R1 @ R22 ) @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% rcis_divide
thf(fact_8111_rcis__def,axiom,
    ( rcis
    = ( ^ [R5: real,A4: real] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ R5 ) @ ( cis @ A4 ) ) ) ) ).

% rcis_def
thf(fact_8112_DeMoivre2,axiom,
    ! [R: real,A2: real,N2: nat] :
      ( ( power_power @ complex @ ( rcis @ R @ A2 ) @ N2 )
      = ( rcis @ ( power_power @ real @ R @ N2 ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) ) ) ).

% DeMoivre2
thf(fact_8113_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [A: $tType,B: $tType,S: set @ A,F2: A > B > B,A3: set @ A,Z: B,Y2: B,A2: A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S )
       => ( ( finite_fold_graph @ A @ B @ F2 @ Z @ A3 @ Y2 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [Y8: B] :
                ( ( Y2
                  = ( F2 @ A2 @ Y8 ) )
                & ( finite_fold_graph @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) @ Y8 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
thf(fact_8114_power_Opower__eq__if,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( ^ [One: A,Times: A > A > A,P4: A,M3: nat] :
            ( if @ A
            @ ( M3
              = ( zero_zero @ nat ) )
            @ One
            @ ( Times @ P4 @ ( power2 @ A @ One @ Times @ P4 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% power.power_eq_if
thf(fact_8115_power_Opower_Opower__0,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( zero_zero @ nat ) )
      = One2 ) ).

% power.power.power_0
thf(fact_8116_power_Opower_Ocong,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( power2 @ A ) ) ).

% power.power.cong
thf(fact_8117_power_Opower_Opower__Suc,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A,N2: nat] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( suc @ N2 ) )
      = ( Times2 @ A2 @ ( power2 @ A @ One2 @ Times2 @ A2 @ N2 ) ) ) ).

% power.power.power_Suc
thf(fact_8118_butlast__take,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( butlast @ A @ ( take @ A @ N2 @ Xs2 ) )
        = ( take @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs2 ) ) ) ).

% butlast_take
thf(fact_8119_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N2: nat,S2: A] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ S @ ( set_ord_lessThan @ A @ S2 ) ) ) )
           => ( ( infini527867602293511546merate @ A @ ( inf_inf @ ( set @ A ) @ S @ ( set_ord_lessThan @ A @ S2 ) ) @ N2 )
              = ( infini527867602293511546merate @ A @ S @ N2 ) ) ) ) ) ).

% finite_enumerate_initial_segment
thf(fact_8120_enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,M: nat,N2: nat] :
          ( ~ ( finite_finite @ A @ S )
         => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ M ) @ ( infini527867602293511546merate @ A @ S @ N2 ) )
            = ( ord_less @ nat @ M @ N2 ) ) ) ) ).

% enumerate_mono_iff
thf(fact_8121_length__butlast,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) ).

% length_butlast
thf(fact_8122_finite__enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,M: nat,N2: nat] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ M @ ( finite_card @ A @ S ) )
           => ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ S ) )
             => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ M ) @ ( infini527867602293511546merate @ A @ S @ N2 ) )
                = ( ord_less @ nat @ M @ N2 ) ) ) ) ) ) ).

% finite_enumerate_mono_iff
thf(fact_8123_le__enumerate,axiom,
    ! [S: set @ nat,N2: nat] :
      ( ~ ( finite_finite @ nat @ S )
     => ( ord_less_eq @ nat @ N2 @ ( infini527867602293511546merate @ nat @ S @ N2 ) ) ) ).

% le_enumerate
thf(fact_8124_enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N2: nat] :
          ( ~ ( finite_finite @ A @ S )
         => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ N2 ) @ ( infini527867602293511546merate @ A @ S @ ( suc @ N2 ) ) ) ) ) ).

% enumerate_step
thf(fact_8125_enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M: nat,N2: nat,S: set @ A] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ~ ( finite_finite @ A @ S )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ M ) @ ( infini527867602293511546merate @ A @ S @ N2 ) ) ) ) ) ).

% enumerate_mono
thf(fact_8126_sorted__butlast,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( Xs2
           != ( nil @ A ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
           => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( butlast @ A @ Xs2 ) ) ) ) ) ).

% sorted_butlast
thf(fact_8127_nth__butlast,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( butlast @ A @ Xs2 ) @ N2 )
        = ( nth @ A @ Xs2 @ N2 ) ) ) ).

% nth_butlast
thf(fact_8128_finite__enum__ext,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X6: set @ A,Y6: set @ A] :
          ( ! [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( finite_card @ A @ X6 ) )
             => ( ( infini527867602293511546merate @ A @ X6 @ I4 )
                = ( infini527867602293511546merate @ A @ Y6 @ I4 ) ) )
         => ( ( finite_finite @ A @ X6 )
           => ( ( finite_finite @ A @ Y6 )
             => ( ( ( finite_card @ A @ X6 )
                  = ( finite_card @ A @ Y6 ) )
               => ( X6 = Y6 ) ) ) ) ) ) ).

% finite_enum_ext
thf(fact_8129_finite__enumerate__Ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,S2: A] :
          ( ( finite_finite @ A @ S )
         => ( ( member @ A @ S2 @ S )
           => ? [N3: nat] :
                ( ( ord_less @ nat @ N3 @ ( finite_card @ A @ S ) )
                & ( ( infini527867602293511546merate @ A @ S @ N3 )
                  = S2 ) ) ) ) ) ).

% finite_enumerate_Ex
thf(fact_8130_finite__enumerate__in__set,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N2: nat] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ S ) )
           => ( member @ A @ ( infini527867602293511546merate @ A @ S @ N2 ) @ S ) ) ) ) ).

% finite_enumerate_in_set
thf(fact_8131_take__butlast,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( take @ A @ N2 @ ( butlast @ A @ Xs2 ) )
        = ( take @ A @ N2 @ Xs2 ) ) ) ).

% take_butlast
thf(fact_8132_butlast__power,axiom,
    ! [A: $tType,N2: nat,Xs2: list @ A] :
      ( ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N2 @ ( butlast @ A ) @ Xs2 )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N2 ) @ Xs2 ) ) ).

% butlast_power
thf(fact_8133_finite__enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M: nat,N2: nat,S: set @ A] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ( finite_finite @ A @ S )
           => ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ S ) )
             => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ M ) @ ( infini527867602293511546merate @ A @ S @ N2 ) ) ) ) ) ) ).

% finite_enumerate_mono
thf(fact_8134_butlast__conv__take,axiom,
    ! [A: $tType] :
      ( ( butlast @ A )
      = ( ^ [Xs: list @ A] : ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% butlast_conv_take
thf(fact_8135_butlast__list__update,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,X2: A] :
      ( ( ( K
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs2 @ K @ X2 ) )
          = ( butlast @ A @ Xs2 ) ) )
      & ( ( K
         != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs2 @ K @ X2 ) )
          = ( list_update @ A @ ( butlast @ A @ Xs2 ) @ K @ X2 ) ) ) ) ).

% butlast_list_update
thf(fact_8136_finite__le__enumerate,axiom,
    ! [S: set @ nat,N2: nat] :
      ( ( finite_finite @ nat @ S )
     => ( ( ord_less @ nat @ N2 @ ( finite_card @ nat @ S ) )
       => ( ord_less_eq @ nat @ N2 @ ( infini527867602293511546merate @ nat @ S @ N2 ) ) ) ) ).

% finite_le_enumerate
thf(fact_8137_finite__enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N2: nat] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ ( suc @ N2 ) @ ( finite_card @ A @ S ) )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ N2 ) @ ( infini527867602293511546merate @ A @ S @ ( suc @ N2 ) ) ) ) ) ) ).

% finite_enumerate_step
thf(fact_8138_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N2: nat] :
          ( ( infini527867602293511546merate @ A @ S @ ( suc @ N2 ) )
          = ( infini527867602293511546merate @ A @ ( minus_minus @ ( set @ A ) @ S @ ( insert @ A @ ( infini527867602293511546merate @ A @ S @ ( zero_zero @ nat ) ) @ ( bot_bot @ ( set @ A ) ) ) ) @ N2 ) ) ) ).

% enumerate_Suc'
thf(fact_8139_finite__enum__subset,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X6: set @ A,Y6: set @ A] :
          ( ! [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( finite_card @ A @ X6 ) )
             => ( ( infini527867602293511546merate @ A @ X6 @ I4 )
                = ( infini527867602293511546merate @ A @ Y6 @ I4 ) ) )
         => ( ( finite_finite @ A @ X6 )
           => ( ( finite_finite @ A @ Y6 )
             => ( ( ord_less_eq @ nat @ ( finite_card @ A @ X6 ) @ ( finite_card @ A @ Y6 ) )
               => ( ord_less_eq @ ( set @ A ) @ X6 @ Y6 ) ) ) ) ) ) ).

% finite_enum_subset
thf(fact_8140_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N2: nat] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ ( suc @ N2 ) @ ( finite_card @ A @ S ) )
           => ( ( infini527867602293511546merate @ A @ S @ ( suc @ N2 ) )
              = ( ord_Least @ A
                @ ^ [S6: A] :
                    ( ( member @ A @ S6 @ S )
                    & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ N2 ) @ S6 ) ) ) ) ) ) ) ).

% finite_enumerate_Suc''
thf(fact_8141_enumerate__Suc,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N2: nat] :
          ( ( infini527867602293511546merate @ A @ S @ ( suc @ N2 ) )
          = ( infini527867602293511546merate @ A
            @ ( minus_minus @ ( set @ A ) @ S
              @ ( insert @ A
                @ ( ord_Least @ A
                  @ ^ [N: A] : ( member @ A @ N @ S ) )
                @ ( bot_bot @ ( set @ A ) ) ) )
            @ N2 ) ) ) ).

% enumerate_Suc
thf(fact_8142_Least__eq__0,axiom,
    ! [P: nat > $o] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( ord_Least @ nat @ P )
        = ( zero_zero @ nat ) ) ) ).

% Least_eq_0
thf(fact_8143_enumerate__0,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A] :
          ( ( infini527867602293511546merate @ A @ S @ ( zero_zero @ nat ) )
          = ( ord_Least @ A
            @ ^ [N: A] : ( member @ A @ N @ S ) ) ) ) ).

% enumerate_0
thf(fact_8144_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [A6: A] :
                ( ( P @ A6 )
               => ( ! [B10: A] :
                      ( ( P @ B10 )
                     => ( ord_less_eq @ A @ A6 @ B10 ) )
                 => ( Q @ A6 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder_ex
thf(fact_8145_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [A6: A] :
                ( ( P @ A6 )
               => ( ! [B10: A] :
                      ( ( P @ B10 )
                     => ( ord_less_eq @ A @ A6 @ B10 ) )
                 => ( Q @ A6 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder
thf(fact_8146_Least__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X2: A] :
          ( ( P @ X2 )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ X2 @ Y3 ) )
           => ( ( ord_Least @ A @ P )
              = X2 ) ) ) ) ).

% Least_equality
thf(fact_8147_LeastI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X2: A,Q: A > $o] :
          ( ( P @ X2 )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ X2 @ Y3 ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y4: A] :
                        ( ( P @ Y4 )
                       => ( ord_less_eq @ A @ X3 @ Y4 ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ) ).

% LeastI2_order
thf(fact_8148_Least1__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,Z: A] :
          ( ? [X4: A] :
              ( ( P @ X4 )
              & ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ A @ X4 @ Y3 ) )
              & ! [Y3: A] :
                  ( ( ( P @ Y3 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y3 @ Ya2 ) ) )
                 => ( Y3 = X4 ) ) )
         => ( ( P @ Z )
           => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ Z ) ) ) ) ).

% Least1_le
thf(fact_8149_Least1I,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o] :
          ( ? [X4: A] :
              ( ( P @ X4 )
              & ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ A @ X4 @ Y3 ) )
              & ! [Y3: A] :
                  ( ( ( P @ Y3 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y3 @ Ya2 ) ) )
                 => ( Y3 = X4 ) ) )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% Least1I
thf(fact_8150_Least__le,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ K ) ) ) ).

% Least_le
thf(fact_8151_not__less__Least,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [K: A,P: A > $o] :
          ( ( ord_less @ A @ K @ ( ord_Least @ A @ P ) )
         => ~ ( P @ K ) ) ) ).

% not_less_Least
thf(fact_8152_Least__Suc2,axiom,
    ! [P: nat > $o,N2: nat,Q: nat > $o,M: nat] :
      ( ( P @ N2 )
     => ( ( Q @ M )
       => ( ~ ( P @ ( zero_zero @ nat ) )
         => ( ! [K2: nat] :
                ( ( P @ ( suc @ K2 ) )
                = ( Q @ K2 ) )
           => ( ( ord_Least @ nat @ P )
              = ( suc @ ( ord_Least @ nat @ Q ) ) ) ) ) ) ) ).

% Least_Suc2
thf(fact_8153_Least__Suc,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ( ( ord_Least @ nat @ P )
          = ( suc
            @ ( ord_Least @ nat
              @ ^ [M3: nat] : ( P @ ( suc @ M3 ) ) ) ) ) ) ) ).

% Least_Suc
thf(fact_8154_Least__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( finite_finite @ A @ ( collect @ A @ P ) )
         => ( ? [X_12: A] : ( P @ X_12 )
           => ( ( ord_Least @ A @ P )
              = ( lattic643756798350308766er_Min @ A @ ( collect @ A @ P ) ) ) ) ) ) ).

% Least_Min
thf(fact_8155_Sup__real__def,axiom,
    ( ( complete_Sup_Sup @ real )
    = ( ^ [X8: set @ real] :
          ( ord_Least @ real
          @ ^ [Z5: real] :
            ! [X: real] :
              ( ( member @ real @ X @ X8 )
             => ( ord_less_eq @ real @ X @ Z5 ) ) ) ) ) ).

% Sup_real_def
thf(fact_8156_Least__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,S: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ? [X4: A] :
                ( ( member @ A @ X4 @ S )
                & ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ S )
                   => ( ord_less_eq @ A @ X4 @ Xa3 ) ) )
           => ( ( ord_Least @ B
                @ ^ [Y: B] : ( member @ B @ Y @ ( image @ A @ B @ F2 @ S ) ) )
              = ( F2
                @ ( ord_Least @ A
                  @ ^ [X: A] : ( member @ A @ X @ S ) ) ) ) ) ) ) ).

% Least_mono
thf(fact_8157_Least__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_Least @ A )
        = ( ^ [P6: A > $o] :
              ( the @ A
              @ ^ [X: A] :
                  ( ( P6 @ X )
                  & ! [Y: A] :
                      ( ( P6 @ Y )
                     => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ).

% Least_def
thf(fact_8158_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N2: nat] :
          ( ~ ( finite_finite @ A @ S )
         => ( ( infini527867602293511546merate @ A @ S @ ( suc @ N2 ) )
            = ( ord_Least @ A
              @ ^ [S6: A] :
                  ( ( member @ A @ S6 @ S )
                  & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ N2 ) @ S6 ) ) ) ) ) ) ).

% enumerate_Suc''
thf(fact_8159_remove__def,axiom,
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X: A,A7: set @ A] : ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% remove_def
thf(fact_8160_has__vector__derivative__real__field,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,A2: real,S2: set @ real] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ ( real_Vector_of_real @ A @ A2 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( has_ve8173657378732805170vative @ A
            @ ^ [X: real] : ( F2 @ ( real_Vector_of_real @ A @ X ) )
            @ F6
            @ ( topolo174197925503356063within @ real @ A2 @ S2 ) ) ) ) ).

% has_vector_derivative_real_field
thf(fact_8161_has__vector__derivative__diff__const,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: real > A,Z: A,F6: A,Net: filter @ real] :
          ( ( has_ve8173657378732805170vative @ A
            @ ^ [T3: real] : ( minus_minus @ A @ ( G @ T3 ) @ Z )
            @ F6
            @ Net )
          = ( has_ve8173657378732805170vative @ A @ G @ F6 @ Net ) ) ) ).

% has_vector_derivative_diff_const
thf(fact_8162_has__vector__derivative__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > A,F6: A,Net: filter @ real,G: real > A,G5: A] :
          ( ( has_ve8173657378732805170vative @ A @ F2 @ F6 @ Net )
         => ( ( has_ve8173657378732805170vative @ A @ G @ G5 @ Net )
           => ( has_ve8173657378732805170vative @ A
              @ ^ [X: real] : ( minus_minus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( minus_minus @ A @ F6 @ G5 )
              @ Net ) ) ) ) ).

% has_vector_derivative_diff
thf(fact_8163_continuous__on__vector__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S: set @ real,F2: real > A,F6: real > A] :
          ( ! [X3: real] :
              ( ( member @ real @ X3 @ S )
             => ( has_ve8173657378732805170vative @ A @ F2 @ ( F6 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ S ) ) )
         => ( topolo81223032696312382ous_on @ real @ A @ S @ F2 ) ) ) ).

% continuous_on_vector_derivative
thf(fact_8164_has__vector__derivative__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_V2191834092415804123ebra_1 @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: real > real,D6: real,F3: filter @ real] :
          ( ( has_field_derivative @ real @ F2 @ D6 @ F3 )
         => ( has_ve8173657378732805170vative @ A
            @ ^ [X: real] : ( real_Vector_of_real @ A @ ( F2 @ X ) )
            @ ( real_Vector_of_real @ A @ D6 )
            @ F3 ) ) ) ).

% has_vector_derivative_of_real
thf(fact_8165_has__field__derivative__iff__has__vector__derivative,axiom,
    ( ( has_field_derivative @ real )
    = ( has_ve8173657378732805170vative @ real ) ) ).

% has_field_derivative_iff_has_vector_derivative
thf(fact_8166_has__vector__derivative__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [I5: set @ A,F2: A > real > B,F6: A > B,Net: filter @ real] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I5 )
             => ( has_ve8173657378732805170vative @ B @ ( F2 @ I4 ) @ ( F6 @ I4 ) @ Net ) )
         => ( has_ve8173657378732805170vative @ B
            @ ^ [X: real] :
                ( groups7311177749621191930dd_sum @ A @ B
                @ ^ [I3: A] : ( F2 @ I3 @ X )
                @ I5 )
            @ ( groups7311177749621191930dd_sum @ A @ B @ F6 @ I5 )
            @ Net ) ) ) ).

% has_vector_derivative_sum
thf(fact_8167_has__vector__derivative__const,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: A,Net: filter @ real] :
          ( has_ve8173657378732805170vative @ A
          @ ^ [X: real] : C2
          @ ( zero_zero @ A )
          @ Net ) ) ).

% has_vector_derivative_const
thf(fact_8168_has__vector__derivative__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > A,F6: A,Net: filter @ real] :
          ( ( has_ve8173657378732805170vative @ A @ F2 @ F6 @ Net )
         => ( has_ve8173657378732805170vative @ A
            @ ^ [X: real] : ( uminus_uminus @ A @ ( F2 @ X ) )
            @ ( uminus_uminus @ A @ F6 )
            @ Net ) ) ) ).

% has_vector_derivative_minus
thf(fact_8169_has__vector__derivative__id,axiom,
    ! [Net: filter @ real] :
      ( has_ve8173657378732805170vative @ real
      @ ^ [X: real] : X
      @ ( one_one @ real )
      @ Net ) ).

% has_vector_derivative_id
thf(fact_8170_has__vector__derivative__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > A,F6: A,Net: filter @ real,G: real > A,G5: A] :
          ( ( has_ve8173657378732805170vative @ A @ F2 @ F6 @ Net )
         => ( ( has_ve8173657378732805170vative @ A @ G @ G5 @ Net )
           => ( has_ve8173657378732805170vative @ A
              @ ^ [X: real] : ( plus_plus @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( plus_plus @ A @ F6 @ G5 )
              @ Net ) ) ) ) ).

% has_vector_derivative_add
thf(fact_8171_has__vector__derivative__add__const,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: real > A,Z: A,F6: A,Net: filter @ real] :
          ( ( has_ve8173657378732805170vative @ A
            @ ^ [T3: real] : ( plus_plus @ A @ ( G @ T3 ) @ Z )
            @ F6
            @ Net )
          = ( has_ve8173657378732805170vative @ A @ G @ F6 @ Net ) ) ) ).

% has_vector_derivative_add_const
thf(fact_8172_has__vector__derivative__eq__rhs,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > A,X6: A,F3: filter @ real,Y6: A] :
          ( ( has_ve8173657378732805170vative @ A @ F2 @ X6 @ F3 )
         => ( ( X6 = Y6 )
           => ( has_ve8173657378732805170vative @ A @ F2 @ Y6 @ F3 ) ) ) ) ).

% has_vector_derivative_eq_rhs
thf(fact_8173_has__vector__derivative__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: real > A,X2: A,F3: filter @ real,A2: A] :
          ( ( has_ve8173657378732805170vative @ A @ F2 @ X2 @ F3 )
         => ( has_ve8173657378732805170vative @ A
            @ ^ [X: real] : ( divide_divide @ A @ ( F2 @ X ) @ A2 )
            @ ( divide_divide @ A @ X2 @ A2 )
            @ F3 ) ) ) ).

% has_vector_derivative_divide
thf(fact_8174_has__vector__derivative__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: real > A,X2: A,F3: filter @ real,A2: A] :
          ( ( has_ve8173657378732805170vative @ A @ F2 @ X2 @ F3 )
         => ( has_ve8173657378732805170vative @ A
            @ ^ [X: real] : ( times_times @ A @ ( F2 @ X ) @ A2 )
            @ ( times_times @ A @ X2 @ A2 )
            @ F3 ) ) ) ).

% has_vector_derivative_mult_left
thf(fact_8175_has__vector__derivative__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: real > A,X2: A,F3: filter @ real,A2: A] :
          ( ( has_ve8173657378732805170vative @ A @ F2 @ X2 @ F3 )
         => ( has_ve8173657378732805170vative @ A
            @ ^ [X: real] : ( times_times @ A @ A2 @ ( F2 @ X ) )
            @ ( times_times @ A @ A2 @ X2 )
            @ F3 ) ) ) ).

% has_vector_derivative_mult_right
thf(fact_8176_has__vector__derivative__continuous,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > A,D6: A,X2: real,S2: set @ real] :
          ( ( has_ve8173657378732805170vative @ A @ F2 @ D6 @ ( topolo174197925503356063within @ real @ X2 @ S2 ) )
         => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ S2 ) @ F2 ) ) ) ).

% has_vector_derivative_continuous
thf(fact_8177_bounded__linear_Ohas__vector__derivative,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > B,G: real > A,G5: A,F3: filter @ real] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( has_ve8173657378732805170vative @ A @ G @ G5 @ F3 )
           => ( has_ve8173657378732805170vative @ B
              @ ^ [X: real] : ( F2 @ ( G @ X ) )
              @ ( F2 @ G5 )
              @ F3 ) ) ) ) ).

% bounded_linear.has_vector_derivative
thf(fact_8178_has__vector__derivative__def,axiom,
    ! [B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( has_ve8173657378732805170vative @ B )
        = ( ^ [F4: real > B,F8: B] :
              ( has_derivative @ real @ B @ F4
              @ ^ [X: real] : ( real_V8093663219630862766scaleR @ B @ X @ F8 ) ) ) ) ) ).

% has_vector_derivative_def
thf(fact_8179_has__vector__derivative__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: real > A,F6: A,X2: real,S2: set @ real,G: real > A,G5: A] :
          ( ( has_ve8173657378732805170vative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ real @ X2 @ S2 ) )
         => ( ( has_ve8173657378732805170vative @ A @ G @ G5 @ ( topolo174197925503356063within @ real @ X2 @ S2 ) )
           => ( has_ve8173657378732805170vative @ A
              @ ^ [X: real] : ( times_times @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X2 ) @ G5 ) @ ( times_times @ A @ F6 @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ S2 ) ) ) ) ) ).

% has_vector_derivative_mult
thf(fact_8180_minus__fold__remove,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ B4 @ A3 )
        = ( finite_fold @ A @ ( set @ A ) @ ( remove @ A ) @ B4 @ A3 ) ) ) ).

% minus_fold_remove
thf(fact_8181_has__vector__derivative__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > real,F6: real,X2: real,S2: set @ real,G: real > A,G5: A] :
          ( ( has_field_derivative @ real @ F2 @ F6 @ ( topolo174197925503356063within @ real @ X2 @ S2 ) )
         => ( ( has_ve8173657378732805170vative @ A @ G @ G5 @ ( topolo174197925503356063within @ real @ X2 @ S2 ) )
           => ( has_ve8173657378732805170vative @ A
              @ ^ [X: real] : ( real_V8093663219630862766scaleR @ A @ ( F2 @ X ) @ ( G @ X ) )
              @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( F2 @ X2 ) @ G5 ) @ ( real_V8093663219630862766scaleR @ A @ F6 @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ S2 ) ) ) ) ) ).

% has_vector_derivative_scaleR

% Type constructors (778)
thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_1,axiom,
    ! [A10: $tType] : ( bounded_lattice @ ( filter @ A10 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_2,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_3,axiom,
    ! [A10: $tType] : ( bounded_lattice @ ( set @ A10 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_4,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( bounded_lattice @ A15 )
     => ( bounded_lattice @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( comple6319245703460814977attice @ A15 )
     => ( condit1219197933456340205attice @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( counta3822494911875563373attice @ A15 )
     => ( counta3822494911875563373attice @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( comple592849572758109894attice @ A15 )
     => ( comple592849572758109894attice @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( bounded_lattice @ A15 )
     => ( bounde4967611905675639751up_bot @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( bounded_lattice @ A15 )
     => ( bounde4346867609351753570nf_top @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( comple6319245703460814977attice @ A15 )
     => ( comple6319245703460814977attice @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( boolea8198339166811842893lgebra @ A15 )
     => ( boolea8198339166811842893lgebra @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( semilattice_sup @ A15 )
     => ( semilattice_sup @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( semilattice_inf @ A15 )
     => ( semilattice_inf @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( distrib_lattice @ A15 )
     => ( distrib_lattice @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( order_top @ A15 )
     => ( order_top @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( order_bot @ A15 )
     => ( order_bot @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( preorder @ A15 )
     => ( preorder @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( lattice @ A15 )
     => ( lattice @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( order @ A15 )
     => ( order @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( ord @ A15 )
     => ( ord @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( uminus @ A15 )
     => ( uminus @ ( A10 > A15 ) ) ) ).

thf(tcon_fun___Groups_Ominus,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( minus @ A15 )
     => ( minus @ ( A10 > A15 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_5,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot1__space,axiom,
    topological_t1_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_6,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_7,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Lattices_Odistrib__lattice_8,axiom,
    distrib_lattice @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom @ int ).

thf(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___Groups_Ominus_14,axiom,
    minus @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_15,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_16,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_17,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_18,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_19,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_20,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_21,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_22,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_23,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_24,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_25,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_26,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_27,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_28,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_29,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_30,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_31,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_32,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_33,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_34,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_35,axiom,
    topolo4987421752381908075d_mult @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_36,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_37,axiom,
    linord4140545234300271783up_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_38,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_39,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_40,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_41,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_42,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_43,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_44,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_45,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_46,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_47,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_48,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_49,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_50,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_51,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_52,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_53,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot1__space_54,axiom,
    topological_t1_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_55,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_56,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_57,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_58,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_59,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_60,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_61,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Lattices_Odistrib__lattice_62,axiom,
    distrib_lattice @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_63,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_64,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_65,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_66,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_67,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_68,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_69,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_70,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_71,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_72,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_73,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_74,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_75,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_76,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_77,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_78,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_79,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_80,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_81,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_82,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_83,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_84,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_85,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_86,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_87,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_88,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_89,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_90,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_91,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_92,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_93,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_94,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_95,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_96,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom_97,axiom,
    semidom @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_98,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Groups_Ominus_99,axiom,
    minus @ nat ).

thf(tcon_Nat_Onat___Power_Opower_100,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_101,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_102,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_103,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_104,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_105,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_106,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_107,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_108,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_109,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_110,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_111,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_112,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_113,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_114,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_115,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_116,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_117,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_118,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_119,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_120,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_121,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_122,axiom,
    linord4140545234300271783up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_123,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_124,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_125,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_126,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_127,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_128,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_129,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_130,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_131,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_132,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_133,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_134,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_135,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_136,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_137,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_138,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_139,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_140,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_141,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_142,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_143,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_144,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Lattices_Odistrib__lattice_145,axiom,
    distrib_lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_146,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_147,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_148,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_149,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_150,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_151,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_152,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_153,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_154,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_155,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_156,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_157,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_158,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_159,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_160,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_161,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_162,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_163,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_164,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_165,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_166,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_167,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_168,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_169,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_170,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_171,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_172,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_173,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_174,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_175,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_176,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_177,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_178,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_179,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_180,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_181,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_182,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_183,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_184,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_185,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom_186,axiom,
    semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_187,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_188,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_189,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_190,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Groups_Ominus_191,axiom,
    minus @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_192,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_193,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_194,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_195,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_196,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_197,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_198,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_199,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_200,axiom,
    ! [A10: $tType] : ( condit1219197933456340205attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_201,axiom,
    ! [A10: $tType] : ( counta3822494911875563373attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_202,axiom,
    ! [A10: $tType] : ( comple592849572758109894attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_203,axiom,
    ! [A10: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_204,axiom,
    ! [A10: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_205,axiom,
    ! [A10: $tType] : ( comple6319245703460814977attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_206,axiom,
    ! [A10: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_207,axiom,
    ! [A10: $tType] : ( semilattice_sup @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_208,axiom,
    ! [A10: $tType] : ( semilattice_inf @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_209,axiom,
    ! [A10: $tType] : ( distrib_lattice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_210,axiom,
    ! [A10: $tType] : ( order_top @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_211,axiom,
    ! [A10: $tType] : ( order_bot @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_212,axiom,
    ! [A10: $tType] : ( preorder @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_213,axiom,
    ! [A10: $tType] : ( lattice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_214,axiom,
    ! [A10: $tType] : ( order @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_215,axiom,
    ! [A10: $tType] : ( ord @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_216,axiom,
    ! [A10: $tType] : ( uminus @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Groups_Ominus_217,axiom,
    ! [A10: $tType] : ( minus @ ( set @ A10 ) ) ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_218,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_219,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_220,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_221,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_222,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_223,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_224,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_225,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_226,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_227,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_228,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot1__space_229,axiom,
    topological_t1_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_230,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_231,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_232,axiom,
    distrib_lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_233,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_234,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_235,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_236,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_237,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_238,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_239,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_240,axiom,
    uminus @ $o ).

thf(tcon_HOL_Obool___Groups_Ominus_241,axiom,
    minus @ $o ).

thf(tcon_List_Olist___Nat_Osize_242,axiom,
    ! [A10: $tType] : ( size @ ( list @ A10 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_243,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_244,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_245,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_246,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_247,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_248,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_249,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_250,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_251,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_252,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_253,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_254,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_255,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_256,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_257,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_258,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_259,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_260,axiom,
    linord4140545234300271783up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_261,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_262,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_263,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_264,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_265,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_266,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_267,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_268,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_269,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_270,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_271,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_272,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_273,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_274,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_275,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_276,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_277,axiom,
    comm_s4317794764714335236cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Odist__norm,axiom,
    real_V6936659425649961206t_norm @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_278,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot1__space_279,axiom,
    topological_t1_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_280,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_281,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_282,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_283,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_284,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_285,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_286,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_287,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_288,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_289,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Lattices_Odistrib__lattice_290,axiom,
    distrib_lattice @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_291,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_292,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_293,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_294,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_295,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_296,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_297,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_298,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_299,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_300,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_301,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_302,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_303,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_304,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_305,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_306,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_307,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__abs__sgn_308,axiom,
    field_abs_sgn @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_309,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_310,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_311,axiom,
    comm_semiring @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_312,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_313,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_314,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_315,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_316,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_317,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_318,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_319,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_320,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_321,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_322,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_323,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_324,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_325,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_326,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_327,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_328,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_329,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_330,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_331,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_332,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_333,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_334,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_335,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_336,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom_337,axiom,
    semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_338,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_339,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_340,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_341,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Groups_Ominus_342,axiom,
    minus @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_343,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_344,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_345,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_346,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_347,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_348,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_349,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_350,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_351,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Nat_Osize_352,axiom,
    size @ char ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_353,axiom,
    ! [A10: $tType] : ( condit1219197933456340205attice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_354,axiom,
    ! [A10: $tType] : ( counta3822494911875563373attice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_355,axiom,
    ! [A10: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_356,axiom,
    ! [A10: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_357,axiom,
    ! [A10: $tType] : ( comple6319245703460814977attice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_358,axiom,
    ! [A10: $tType] : ( semilattice_sup @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_359,axiom,
    ! [A10: $tType] : ( semilattice_inf @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_360,axiom,
    ! [A10: $tType] : ( distrib_lattice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_361,axiom,
    ! [A10: $tType] : ( order_top @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_362,axiom,
    ! [A10: $tType] : ( order_bot @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_363,axiom,
    ! [A10: $tType] : ( preorder @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_364,axiom,
    ! [A10: $tType] : ( lattice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_365,axiom,
    ! [A10: $tType] : ( order @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_366,axiom,
    ! [A10: $tType] : ( ord @ ( filter @ A10 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_367,axiom,
    ! [A10: $tType] : ( size @ ( option @ A10 ) ) ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_368,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_369,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_370,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_371,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_372,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_373,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_374,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_375,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_376,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_377,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_378,axiom,
    real_V768167426530841204y_dist @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_379,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_380,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_381,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_382,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_383,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_384,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_385,axiom,
    topolo8386298272705272623_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_386,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_387,axiom,
    real_V6157519004096292374lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_388,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_389,axiom,
    topolo1287966508704411220up_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_390,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_391,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_392,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_393,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_394,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_395,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_396,axiom,
    comm_s4317794764714335236cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Odist__norm_397,axiom,
    real_V6936659425649961206t_norm @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__group__add_398,axiom,
    topolo1633459387980952147up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_399,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot1__space_400,axiom,
    topological_t1_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_401,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_402,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_403,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_404,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_405,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_406,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_407,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_408,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_409,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_410,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_411,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_412,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_413,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_414,axiom,
    field_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_415,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_416,axiom,
    comm_semiring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_417,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_418,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_419,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_420,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_421,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_422,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_423,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_424,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_425,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_426,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_427,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_428,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_429,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_430,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_431,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_432,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_433,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_434,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom_435,axiom,
    semidom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_436,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_437,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ominus_438,axiom,
    minus @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_439,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_440,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_441,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_442,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_443,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_444,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_445,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_446,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_447,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_448,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_449,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_450,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_451,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_452,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_453,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_454,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_455,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_456,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_457,axiom,
    linord4140545234300271783up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_458,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_459,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_460,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_461,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_462,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_463,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_464,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_465,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Odistrib__lattice_466,axiom,
    distrib_lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_467,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_468,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_469,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_470,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_471,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_472,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_473,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_474,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_475,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_476,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_477,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_478,axiom,
    comm_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_479,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_480,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_481,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_482,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_483,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_484,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_485,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_486,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_487,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_488,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_489,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_490,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_491,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_492,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_493,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_494,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ominus_495,axiom,
    minus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_496,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_497,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_498,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_499,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_500,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_501,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_502,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( ( topolo4958980785337419405_space @ A10 )
        & ( topolo4958980785337419405_space @ A15 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A10 @ A15 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_503,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( ( topological_t2_space @ A10 )
        & ( topological_t2_space @ A15 ) )
     => ( topological_t2_space @ ( product_prod @ A10 @ A15 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot1__space_504,axiom,
    ! [A10: $tType,A15: $tType] :
      ( ( ( topological_t1_space @ A10 )
        & ( topological_t1_space @ A15 ) )
     => ( topological_t1_space @ ( product_prod @ A10 @ A15 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_505,axiom,
    ! [A10: $tType,A15: $tType] : ( size @ ( product_prod @ A10 @ A15 ) ) ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_506,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_507,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_508,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_509,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_510,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_511,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_512,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_513,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_514,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_515,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_516,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_517,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_518,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_519,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_520,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_521,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_522,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_523,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_524,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_525,axiom,
    linord4140545234300271783up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_526,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_527,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_528,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_529,axiom,
    euclid5891614535332579305n_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_530,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_531,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_532,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_533,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_534,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_535,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_536,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_537,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_538,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_539,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_540,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_541,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_542,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_543,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_544,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_545,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_546,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_547,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_548,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_549,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_550,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_551,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_552,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_553,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_554,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_555,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_556,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_557,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_558,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_559,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_560,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_561,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_562,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_563,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_564,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_565,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_566,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_567,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_568,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_569,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_570,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_571,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_572,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_573,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_574,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_575,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_576,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_577,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_578,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_579,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_580,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_581,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_582,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_583,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_584,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_585,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_586,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_587,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_588,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_589,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_590,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_591,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom_592,axiom,
    semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_593,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_594,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_595,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_596,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ominus_597,axiom,
    minus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_598,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_599,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_600,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_601,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_602,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_603,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_604,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_605,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_606,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $false @ X2 @ Y2 )
      = Y2 ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $true @ X2 @ Y2 )
      = X2 ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X8: A] : ( P @ X8 ) ) ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ succy ) @ z ).

%------------------------------------------------------------------------------
